/******************************************************************************

                        D S _ L I N U X . H

******************************************************************************/

/******************************************************************************

  @file    ds_linux.h
  @brief   Feature definitions for Linux Data Services

  DESCRIPTION
  Header file containing feature definitions for Linux Data Services.

  ---------------------------------------------------------------------------
  Copyright (c) 2007 QUALCOMM Incorporated.
  All Rights Reserved. QUALCOMM Proprietary and Confidential.
  ---------------------------------------------------------------------------

******************************************************************************/

/******************************************************************************

                      EDIT HISTORY FOR FILE

  $Id: //release/linux-enablement/02.00.08.010.041/pkgs/proprietary/data/main/source/dss/inc/ds_linux.h#1 $

when       who        what, where, why
--------   ---        -------------------------------------------------------
10/05/07   ar         Add UMTS Circuit Switched Data macros.
09/28/07   vk         Initial version

******************************************************************************/

#ifndef __DS_LINUX_H__
#define __DS_LINUX_H__

#define FEATURE_DATA
#define FEATURE_DATA_LINUX

#define FEATURE_DS_SOCKETS
#define FEATURE_DATA_PS

#if 0
#undef FEATURE_DS_LINUX_NO_RPC
#undef FEATURE_DS_LINUX_NO_TARGET

#undef FEATURE_DS_NO_DCM
#undef FEATURE_DS_DEBUG_MTRACE
#undef FEATURE_DS_DEBUG_INTERACTIVE
#endif

/* UMTS Circuit Switched Data (UCSD) */
#ifdef FEATURE_GSM
  #define FEATURE_DATA_GCSD
#endif

#ifdef FEATURE_WCDMA
  #define FEATURE_DATA_WCDMA_CS
#endif

#if defined(FEATURE_DATA_GCSD) || defined(FEATURE_DATA_WCDMA_CS)
  #define FEATURE_DATA_UCSD_SCUDIF_API
  #define FEATURE_DATA_UCSD_UNIFIED_API
#endif

#endif /* __DS_LINUX_H__ */

