/******************************************************************************
 ----------------------------------------------------------------------------
 Copyright (c) 2007 QUALCOMM Incorporated.
 All Rights Reserved. QUALCOMM Proprietary and Confidential.
 ----------------------------------------------------------------------------
*******************************************************************************/

#ifndef MSG_H
#define MSG_H

/*----------------------------------------------------------------------------
 Copyright (c) 2007 QUALCOMM Incorporated.  All Rights Reserved.  
 QUALCOMM Proprietary and Confidential. 
----------------------------------------------------------------------------*/

extern int printf (__const char *__restrict __format, ...);

static inline void __msg(const char * fmt, char * file, int line, int x1, int x2, int x3) 
  { 
  printf(fmt,x1,x2,x3); 
  printf("  :FILE %s:LINE %d:ARG1 %d:ARG2 %d:ARG3 %d:\n",file,line,x1,x2,x3); 
  }

#define MSG(lvl, fmt, file, line, a,b,c) \
do { \
  printf("%s :MSG ", lvl); \
  __msg(fmt, file, line, a, b, c); \
  } while(0)

#define MSG_ERROR(fmt, a,b,c) MSG("      ERROR",     fmt,__FILE__,__LINE__,(int)a,(int)b,(int)c)
#define MSG_HIGH(fmt, a,b,c)  MSG("        HIGH",    fmt,__FILE__,__LINE__,(int)a,(int)b,(int)c)
#define MSG_MED(fmt, a,b,c)   MSG("          MED",   fmt,__FILE__,__LINE__,(int)a,(int)b,(int)c)
#define MSG_LOW(fmt, a,b,c)   MSG("            LOW", fmt,__FILE__,__LINE__,(int)a,(int)b,(int)c)

#endif /* MSG_H */
