#ifndef MVS_RPC_H
#define MVS_RPC_H

/* MVS TOOL VERSION: 3.20 */
/*=============================================================================
                               M V S _ R P C . H

GENERAL DESCRIPTION
  This is an AUTO GENERATED file that provides declarations pertaining to the
  exporting of the mvs api using ONCRPC.

  ---------------------------------------------------------------------------
  Copyright (c) 2008 QUALCOMM Incorporated.
  All Rights Reserved. QUALCOMM Proprietary and Confidential.
  ---------------------------------------------------------------------------
=============================================================================*/

/*=============================================================================

                              Edit History

                             AUTO GENERATED                                  */
/* Generated by following versions of Htorpc modules:
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/htorpc.pl#4 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Start.pm#3 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Htoxdr.pm#1 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/XDR.pm#3 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Output.pm#8 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Parser.pm#2 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Metacomments.pm#2 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/SymbolTable.pm#3  */
/* $Id: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/mvs/inc/mvs_rpc.h#1 $
=============================================================================*/

/* Include ONCRPC headers */
#include "oncrpc.h"
#include "comdef.h"

#define MVSPROG		0x30000014
#define MVSVERS		0x987d0a7a /* 0x987d0a7a */

#define MVSCBPROG		0x31000014
#define MVSCBVERS		0xaed32da4 /* 0xaed32da4 */

/* prototypes for the app_init routines for the api and the api's callback
 * services
 */
extern void mvs_app_init( void );
extern void mvscb_app_init( void );

/* prototypes for the app_lock routines for the api and the api's callback
 * services
 */
#define mvs_app_enable()  mvs_app_lock( FALSE )
#define mvs_app_disable() mvs_app_lock( TRUE )
extern void mvs_app_lock( boolean lock );

#define mvscb_app_enable()  mvscb_app_lock( FALSE )
#define mvscb_app_disable() mvscb_app_lock( TRUE )
extern void mvscb_app_lock( boolean lock );

/* prototypes for glue code info querty functions:
 *
 * toolvers   : Tool version
 * features   : Features turned on in the code.
 *              0x00000001    ONCRPC Server Cleanup Support
 * proghash   : Unique hash value that represents the API XDR definition
 * cbproghash : Unique hash value that represents the Callbacks' XDR definition
 */
extern boolean mvs_rpc_glue_code_info_remote    /* REMOTE INFO */
(
  uint32 *toolvers,
  uint32 *features,
  uint32 *proghash,
  uint32 *cbproghash
);
extern boolean mvs_rpc_glue_code_info_local     /* LOCAL INFO */
(
  uint32 *toolvers,
  uint32 *features,
  uint32 *proghash,
  uint32 *cbproghash
);

/* prototype for API null routine */
extern boolean mvs_null(void);

#define ONCRPC_MVS_NULL_PROC 0
#define ONCRPC_MVS_RPC_GLUE_CODE_INFO_REMOTE_PROC 1

#define ONCRPC_MVS_MODE_SUPPORTED_PROC 2
#define ONCRPC_MVS_SET_LOOPBACK_PROC 3
#define ONCRPC_MVS_ACQUIRE_PROC 4
#define ONCRPC_MVS_ENABLE_PROC 5
#define ONCRPC_MVS_RELEASE_PROC 6
#define ONCRPC_MVS_AMR_SET_AMR_MODE_PROC 7
#define ONCRPC_MVS_AMR_SET_AWB_MODE_PROC 8
#define ONCRPC_MVS_AMR_SET_SCR_MODE_PROC 9
#define ONCRPC_MVS_VOC_SET_FRAME_RATE_PROC 10
#define ONCRPC_MVS_GSM_SET_DTX_MODE_PROC 11
#define ONCRPC_MVS_GET_G711_MODE_PROC 12
#define ONCRPC_MVS_SET_G711_MODE_PROC 13
#define ONCRPC_MVS_VOC_TX_RATE_LIMIT_PROC 14
#define ONCRPC_MVS_CLIENT_SEND_FRAMES_PROC 15
#define ONCRPC_MVS_API_VERSIONS_PROC 4294967295
#define ONCRPC_MVS_EVENT_CB_TYPE_PROC 1
#define ONCRPC_MVS_PACKET_UL_FN_TYPE_PROC 2
#define ONCRPC_MVS_PACKET_DL_FN_TYPE_PROC 3


/* XDR Routine Prototypes go here */

/*
 * mvs_frame_info_hdr_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_frame_info_hdr_type (xdr_s_type *xdrs, mvs_frame_info_hdr_type const *sptr);

/*
 * mvs_frame_info_hdr_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_frame_info_hdr_type (xdr_s_type *xdrs, mvs_frame_info_hdr_type *sptr);

/*
 * mvs_voc_tx_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_voc_tx_frame_info_type (xdr_s_type *xdrs, mvs_voc_tx_frame_info_type const *sptr);

/*
 * mvs_voc_tx_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_voc_tx_frame_info_type (xdr_s_type *xdrs, mvs_voc_tx_frame_info_type *sptr);

/*
 * mvs_voc_rx_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_voc_rx_frame_info_type (xdr_s_type *xdrs, mvs_voc_rx_frame_info_type const *sptr);

/*
 * mvs_voc_rx_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_voc_rx_frame_info_type (xdr_s_type *xdrs, mvs_voc_rx_frame_info_type *sptr);

/*
 * mvs_voc_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_voc_frame_info_type (xdr_s_type *xdrs, mvs_voc_frame_info_type const *uptr);

/*
 * mvs_voc_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_voc_frame_info_type (xdr_s_type *xdrs, mvs_voc_frame_info_type *uptr);

/*
 * mvs_amr_ul_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_amr_ul_frame_info_type (xdr_s_type *xdrs, mvs_amr_ul_frame_info_type const *sptr);

/*
 * mvs_amr_ul_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_amr_ul_frame_info_type (xdr_s_type *xdrs, mvs_amr_ul_frame_info_type *sptr);

/*
 * mvs_amr_dl_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_amr_dl_frame_info_type (xdr_s_type *xdrs, mvs_amr_dl_frame_info_type const *sptr);

/*
 * mvs_amr_dl_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_amr_dl_frame_info_type (xdr_s_type *xdrs, mvs_amr_dl_frame_info_type *sptr);

/*
 * mvs_amr_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_amr_frame_info_type (xdr_s_type *xdrs, mvs_amr_frame_info_type const *uptr);

/*
 * mvs_amr_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_amr_frame_info_type (xdr_s_type *xdrs, mvs_amr_frame_info_type *uptr);

/*
 * mvs_gsm_ul_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_gsm_ul_frame_info_type (xdr_s_type *xdrs, mvs_gsm_ul_frame_info_type const *sptr);

/*
 * mvs_gsm_ul_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_gsm_ul_frame_info_type (xdr_s_type *xdrs, mvs_gsm_ul_frame_info_type *sptr);

/*
 * mvs_gsm_dl_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_gsm_dl_frame_info_type (xdr_s_type *xdrs, mvs_gsm_dl_frame_info_type const *sptr);

/*
 * mvs_gsm_dl_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_gsm_dl_frame_info_type (xdr_s_type *xdrs, mvs_gsm_dl_frame_info_type *sptr);

/*
 * mvs_gsm_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_gsm_frame_info_type (xdr_s_type *xdrs, mvs_gsm_frame_info_type const *uptr);

/*
 * mvs_gsm_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_gsm_frame_info_type (xdr_s_type *xdrs, mvs_gsm_frame_info_type *uptr);

/*
 * mvs_hr_ul_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_hr_ul_frame_info_type (xdr_s_type *xdrs, mvs_hr_ul_frame_info_type const *sptr);

/*
 * mvs_hr_ul_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_hr_ul_frame_info_type (xdr_s_type *xdrs, mvs_hr_ul_frame_info_type *sptr);

/*
 * mvs_hr_dl_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_hr_dl_frame_info_type (xdr_s_type *xdrs, mvs_hr_dl_frame_info_type const *sptr);

/*
 * mvs_hr_dl_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_hr_dl_frame_info_type (xdr_s_type *xdrs, mvs_hr_dl_frame_info_type *sptr);

/*
 * mvs_hr_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_hr_frame_info_type (xdr_s_type *xdrs, mvs_hr_frame_info_type const *uptr);

/*
 * mvs_hr_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_hr_frame_info_type (xdr_s_type *xdrs, mvs_hr_frame_info_type *uptr);

/*
 * mvs_g711_ul_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_g711_ul_frame_info_type (xdr_s_type *xdrs, mvs_g711_ul_frame_info_type const *sptr);

/*
 * mvs_g711_ul_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_g711_ul_frame_info_type (xdr_s_type *xdrs, mvs_g711_ul_frame_info_type *sptr);

/*
 * mvs_g711_dl_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_g711_dl_frame_info_type (xdr_s_type *xdrs, mvs_g711_dl_frame_info_type const *sptr);

/*
 * mvs_g711_dl_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_g711_dl_frame_info_type (xdr_s_type *xdrs, mvs_g711_dl_frame_info_type *sptr);

/*
 * mvs_g711_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_g711_frame_info_type (xdr_s_type *xdrs, mvs_g711_frame_info_type const *uptr);

/*
 * mvs_g711_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_g711_frame_info_type (xdr_s_type *xdrs, mvs_g711_frame_info_type *uptr);

/*
 * mvs_g723_ul_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_g723_ul_frame_info_type (xdr_s_type *xdrs, mvs_g723_ul_frame_info_type const *sptr);

/*
 * mvs_g723_ul_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_g723_ul_frame_info_type (xdr_s_type *xdrs, mvs_g723_ul_frame_info_type *sptr);

/*
 * mvs_g723_dl_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_g723_dl_frame_info_type (xdr_s_type *xdrs, mvs_g723_dl_frame_info_type const *sptr);

/*
 * mvs_g723_dl_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_g723_dl_frame_info_type (xdr_s_type *xdrs, mvs_g723_dl_frame_info_type *sptr);

/*
 * mvs_g723_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_g723_frame_info_type (xdr_s_type *xdrs, mvs_g723_frame_info_type const *uptr);

/*
 * mvs_g723_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_g723_frame_info_type (xdr_s_type *xdrs, mvs_g723_frame_info_type *uptr);

/*
 * mvs_pcm_ul_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_pcm_ul_frame_info_type (xdr_s_type *xdrs, mvs_pcm_ul_frame_info_type const *sptr);

/*
 * mvs_pcm_ul_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_pcm_ul_frame_info_type (xdr_s_type *xdrs, mvs_pcm_ul_frame_info_type *sptr);

/*
 * mvs_pcm_dl_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_pcm_dl_frame_info_type (xdr_s_type *xdrs, mvs_pcm_dl_frame_info_type const *sptr);

/*
 * mvs_pcm_dl_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_pcm_dl_frame_info_type (xdr_s_type *xdrs, mvs_pcm_dl_frame_info_type *sptr);

/*
 * mvs_pcm_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_pcm_frame_info_type (xdr_s_type *xdrs, mvs_pcm_frame_info_type const *uptr);

/*
 * mvs_pcm_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_pcm_frame_info_type (xdr_s_type *xdrs, mvs_pcm_frame_info_type *uptr);

/*
 * mvs_amr_if1_ul_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_amr_if1_ul_frame_info_type (xdr_s_type *xdrs, mvs_amr_if1_ul_frame_info_type const *sptr);

/*
 * mvs_amr_if1_ul_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_amr_if1_ul_frame_info_type (xdr_s_type *xdrs, mvs_amr_if1_ul_frame_info_type *sptr);

/*
 * mvs_amr_if1_dl_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_amr_if1_dl_frame_info_type (xdr_s_type *xdrs, mvs_amr_if1_dl_frame_info_type const *sptr);

/*
 * mvs_amr_if1_dl_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_amr_if1_dl_frame_info_type (xdr_s_type *xdrs, mvs_amr_if1_dl_frame_info_type *sptr);

/*
 * mvs_amr_if1_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_amr_if1_frame_info_type (xdr_s_type *xdrs, mvs_amr_if1_frame_info_type const *uptr);

/*
 * mvs_amr_if1_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_amr_if1_frame_info_type (xdr_s_type *xdrs, mvs_amr_if1_frame_info_type *uptr);

/*
 * mvs_frame_info_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_frame_info_type (xdr_s_type *xdrs, mvs_frame_info_type const *uptr);

/*
 * mvs_frame_info_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_frame_info_type (xdr_s_type *xdrs, mvs_frame_info_type *uptr);

/*
 * mvs_frame_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_frame_type (xdr_s_type *xdrs, mvs_frame_type const *sptr);

/*
 * mvs_frame_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_frame_type (xdr_s_type *xdrs, mvs_frame_type *sptr);

/*
 * mvs_ev_header_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_ev_header_type (xdr_s_type *xdrs, mvs_ev_header_type const *sptr);

/*
 * mvs_ev_header_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_ev_header_type (xdr_s_type *xdrs, mvs_ev_header_type *sptr);

/*
 * mvs_ev_command_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_ev_command_type (xdr_s_type *xdrs, mvs_ev_command_type const *sptr);

/*
 * mvs_ev_command_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_ev_command_type (xdr_s_type *xdrs, mvs_ev_command_type *sptr);

/*
 * mvs_ev_mode_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_ev_mode_type (xdr_s_type *xdrs, mvs_ev_mode_type const *sptr);

/*
 * mvs_ev_mode_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_ev_mode_type (xdr_s_type *xdrs, mvs_ev_mode_type *sptr);

/*
 * mvs_ev_notify_hdr_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_ev_notify_hdr_type (xdr_s_type *xdrs, mvs_ev_notify_hdr_type const *sptr);

/*
 * mvs_ev_notify_hdr_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_ev_notify_hdr_type (xdr_s_type *xdrs, mvs_ev_notify_hdr_type *sptr);

/*
 * mvs_ev_notify_buffer_cfg_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_ev_notify_buffer_cfg_type (xdr_s_type *xdrs, mvs_ev_notify_buffer_cfg_type const *sptr);

/*
 * mvs_ev_notify_buffer_cfg_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_ev_notify_buffer_cfg_type (xdr_s_type *xdrs, mvs_ev_notify_buffer_cfg_type *sptr);

/*
 * mvs_ev_notify_buffer_status_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_ev_notify_buffer_status_type (xdr_s_type *xdrs, mvs_ev_notify_buffer_status_type const *sptr);

/*
 * mvs_ev_notify_buffer_status_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_ev_notify_buffer_status_type (xdr_s_type *xdrs, mvs_ev_notify_buffer_status_type *sptr);

/*
 * mvs_ev_notify_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_ev_notify_type (xdr_s_type *xdrs, mvs_ev_notify_type const *uptr);

/*
 * mvs_ev_notify_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_ev_notify_type (xdr_s_type *xdrs, mvs_ev_notify_type *uptr);

/*
 * mvs_event_type XDR_MVS_SEND
 */
boolean xdr_mvs_send_mvs_event_type (xdr_s_type *xdrs, mvs_event_type const *uptr);

/*
 * mvs_event_type XDR_MVS_RECV
 */
boolean xdr_mvs_recv_mvs_event_type (xdr_s_type *xdrs, mvs_event_type *uptr);

#endif /* ! MVS_RPC_H */
