#ifndef PDSM_ATL_RPC_H
#define PDSM_ATL_RPC_H

/* PDSM_ATL TOOL VERSION: 3.20 */
/*=============================================================================
                          P D S M _ A T L _ R P C . H

GENERAL DESCRIPTION
  This is an AUTO GENERATED file that provides declarations pertaining to the
  exporting of the pdsm_atl api using ONCRPC.

  ---------------------------------------------------------------------------
  Copyright (c) 2008 QUALCOMM Incorporated.
  All Rights Reserved. QUALCOMM Proprietary and Confidential.
  ---------------------------------------------------------------------------
=============================================================================*/

/*=============================================================================

                              Edit History

                             AUTO GENERATED                                  */
/* Generated by following versions of Htorpc modules:
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/htorpc.pl#4 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Start.pm#3 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Htoxdr.pm#1 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/XDR.pm#3 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Output.pm#8 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Parser.pm#2 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/Metacomments.pm#2 
Id: //source/qcom/qct/core/mproc/tools/rel/03.01/htorpc/lib/Htorpc/SymbolTable.pm#3  */
/* $Id: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/pdsm_atl/inc/pdsm_atl_rpc.h#1 $
=============================================================================*/

/* Include ONCRPC headers */
#include "oncrpc.h"
#include "comdef.h"

#define PDSM_ATLPROG		0x3000001d
#define PDSM_ATLVERS		0x97744e06 /* 0x97744e06 */

#define PDSM_ATLCBPROG		0x3100001d
#define PDSM_ATLCBVERS		0xc8db0cb5 /* 0xc8db0cb5 */

/* prototypes for the app_init routines for the api and the api's callback
 * services
 */
extern void pdsm_atl_app_init( void );
extern void pdsm_atlcb_app_init( void );

/* prototypes for the app_lock routines for the api and the api's callback
 * services
 */
#define pdsm_atl_app_enable()  pdsm_atl_app_lock( FALSE )
#define pdsm_atl_app_disable() pdsm_atl_app_lock( TRUE )
extern void pdsm_atl_app_lock( boolean lock );

#define pdsm_atlcb_app_enable()  pdsm_atlcb_app_lock( FALSE )
#define pdsm_atlcb_app_disable() pdsm_atlcb_app_lock( TRUE )
extern void pdsm_atlcb_app_lock( boolean lock );

/* prototypes for glue code info querty functions:
 *
 * toolvers   : Tool version
 * features   : Features turned on in the code.
 *              0x00000001    ONCRPC Server Cleanup Support
 * proghash   : Unique hash value that represents the API XDR definition
 * cbproghash : Unique hash value that represents the Callbacks' XDR definition
 */
extern boolean pdsm_atl_rpc_glue_code_info_remote    /* REMOTE INFO */
(
  uint32 *toolvers,
  uint32 *features,
  uint32 *proghash,
  uint32 *cbproghash
);
extern boolean pdsm_atl_rpc_glue_code_info_local     /* LOCAL INFO */
(
  uint32 *toolvers,
  uint32 *features,
  uint32 *proghash,
  uint32 *cbproghash
);

/* prototype for API null routine */
extern boolean pdsm_atl_null(void);

#define ONCRPC_PDSM_ATL_NULL_PROC 0
#define ONCRPC_PDSM_ATL_RPC_GLUE_CODE_INFO_REMOTE_PROC 1

#define ONCRPC_PDSM_ATL_REG_PROC 2
#define ONCRPC_PDSM_ATL_L2_PROXY_REG_PROC 3
#define ONCRPC_PDSM_ATL_L2_PROXY_DEREG_PROC 4
#define ONCRPC_PDSM_ATL_POST_EVENT_PROC 5
#define ONCRPC_PDSM_ATL_DNS_PROXY_REG_PROC 6
#define ONCRPC_PDSM_ATL_DNS_PROXY_DEREG_PROC 7
#define ONCRPC_PDSM_ATL_DNS_PROXY_RESPONSE_PROC 8
#define ONCRPC_PDSM_ATL_API_VERSIONS_PROC 4294967295
#define ONCRPC_PDSM_ATL_SESSION_HANDLE_OPERATION_F_TYPE_PROC 1
#define ONCRPC_PDSM_ATL_OPEN_F_TYPE_PROC 2
#define ONCRPC_PDSM_ATL_CLOSE_F_TYPE_PROC 3
#define ONCRPC_PDSM_ATL_CONNECT_F_TYPE_PROC 4
#define ONCRPC_PDSM_ATL_DNS_LOOKUP_F_TYPE_PROC 5
#define ONCRPC_PDSM_ATL_DISCONNECT_F_TYPE_PROC 6
#define ONCRPC_PDSM_ATL_SEND_F_TYPE_PROC 7
#define ONCRPC_PDSM_ATL_RECV_F_TYPE_PROC 8
#define ONCRPC_PDSM_ATL_DORMANCY_OPERATION_F_TYPE_PROC 9


/* XDR Routine Prototypes go here */

/*
 * pdsm_atl_ip_addr_type XDR_PDSM_ATL_SEND
 */
boolean xdr_pdsm_atl_send_pdsm_atl_ip_addr_type (xdr_s_type *xdrs, pdsm_atl_ip_addr_type const *sptr);

/*
 * pdsm_atl_ip_addr_type XDR_PDSM_ATL_RECV
 */
boolean xdr_pdsm_atl_recv_pdsm_atl_ip_addr_type (xdr_s_type *xdrs, pdsm_atl_ip_addr_type *sptr);

/*
 * pdsm_atl_open_params_type XDR_PDSM_ATL_SEND
 */
boolean xdr_pdsm_atl_send_pdsm_atl_open_params_type (xdr_s_type *xdrs, pdsm_atl_open_params_type const *sptr);

/*
 * pdsm_atl_open_params_type XDR_PDSM_ATL_RECV
 */
boolean xdr_pdsm_atl_recv_pdsm_atl_open_params_type (xdr_s_type *xdrs, pdsm_atl_open_params_type *sptr);

/*
 * pdsm_atl_connect_params_type XDR_PDSM_ATL_SEND
 */
boolean xdr_pdsm_atl_send_pdsm_atl_connect_params_type (xdr_s_type *xdrs, pdsm_atl_connect_params_type const *sptr);

/*
 * pdsm_atl_connect_params_type XDR_PDSM_ATL_RECV
 */
boolean xdr_pdsm_atl_recv_pdsm_atl_connect_params_type (xdr_s_type *xdrs, pdsm_atl_connect_params_type *sptr);

/*
 * pdsm_atl_dns_params_type XDR_PDSM_ATL_SEND
 */
boolean xdr_pdsm_atl_send_pdsm_atl_dns_params_type (xdr_s_type *xdrs, pdsm_atl_dns_params_type const *sptr);

/*
 * pdsm_atl_dns_params_type XDR_PDSM_ATL_RECV
 */
boolean xdr_pdsm_atl_recv_pdsm_atl_dns_params_type (xdr_s_type *xdrs, pdsm_atl_dns_params_type *sptr);

/*
 * pdsm_atl_dns_response_type XDR_PDSM_ATL_SEND
 */
boolean xdr_pdsm_atl_send_pdsm_atl_dns_response_type (xdr_s_type *xdrs, pdsm_atl_dns_response_type const *sptr);

/*
 * pdsm_atl_dns_response_type XDR_PDSM_ATL_RECV
 */
boolean xdr_pdsm_atl_recv_pdsm_atl_dns_response_type (xdr_s_type *xdrs, pdsm_atl_dns_response_type *sptr);

#endif /* ! PDSM_ATL_RPC_H */
