# -*-makefile-*-
# $Id: atp.make 8646 2008-07-11 12:47:29Z mkl $
#
# Copyright (C) 2003 by Robert Schwebel <r.schwebel@pengutronix.de>
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_ATP) += atp

#
# Paths and names
#
ATP_VERSION	:= 1.0
ATP		:= atp
ATP_SUFFIX	:= tgz.gz
ATP_SOURCE	:= $(SRCDIR)/$(ATP).$(ATP_SUFFIX)
ATP_SRCDIR  := $(PTXDIST_WORKSPACE)/../source/atp
ATP_DIR	:= $(BUILDDIR)/$(ATP)
# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

atp_get: $(STATEDIR)/atp.get

$(STATEDIR)/atp.get:$(atp_get_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

$(ATP_SOURCE):
	@$(call targetinfo, $@)
	@$(call get, ATP)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

atp_extract: $(STATEDIR)/atp.extract

$(STATEDIR)/atp.extract: $(atp_extract_deps_default)
	@$(call targetinfo, $@)
	@$(call clean, $(ATP_DIR))
	#@$(call extract, ATP)
	rm -rf $(ATP_DIR)
	cp -rf $(ATP_SRCDIR) $(ATP_DIR)
	@$(call patchin, ATP)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

atp_prepare: $(STATEDIR)/atp.prepare

ATP_PATH	=  PATH=$(CROSS_PATH)
ATP_ENV 	=  $(CROSS_ENV)

#
# autoconf
#
ATP_AUTOCONF =  $(CROSS_AUTOCONF_USR)

$(STATEDIR)/atp.prepare: $(atp_prepare_deps_default)
	@$(call targetinfo, $@)
	@$(call clean, $(ATP_DIR)/config.cache)
	cd $(ATP_DIR) && \
		$(ATP_PATH) $(ATP_ENV) \
		./configure $(ATP_AUTOCONF)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

atp_compile: $(STATEDIR)/atp.compile

$(STATEDIR)/atp.compile: $(atp_compile_deps_default)
	@$(call targetinfo, $@)
	cd $(ATP_DIR) && make
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

atp_install: $(STATEDIR)/atp.install

$(STATEDIR)/atp.install: $(atp_install_deps_default)
	@$(call targetinfo, $@)
	@$(call install, ATP)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

atp_targetinstall: $(STATEDIR)/atp.targetinstall

$(STATEDIR)/atp.targetinstall: $(atp_targetinstall_deps_default)
	@$(call targetinfo, $@)
	@$(call install_init, atp)
	@$(call install_fixup, atp,PACKAGE,atp)
	@$(call install_fixup, atp,PRIORITY,optional)
	@$(call install_fixup, atp,VERSION,1.0)
	@$(call install_fixup, atp,SECTION,base)
	@$(call install_fixup, atp,AUTHOR,"ATP")
	@$(call install_fixup, atp,DEPENDS,)
	@$(call install_fixup, atp,DESCRIPTION,missing)
	@$(call install_copy, atp, 0, 0, 0755, \
		$(ATP_DIR)/atp/bin/iptables, \
		/bin/iptables,n)
	@$(call install_copy, atp, 0, 0, 0755, \
		$(ATP_DIR)/atp/bin/dnsmasq, \
		/bin/dnsmasq,n)
	@$(call install_copy, atp, 0, 0, 0755, \
		$(ATP_DIR)/atp/bin/siproxd, \
		/bin/siproxd,n)	
	@$(call install_copy, atp, 0, 0, 0755, \
		$(ATP_DIR)/atp/lib/libosip2.a, \
		/lib/libosip2.a,n)
	@$(call install_copy, atp, 0, 0, 0755, \
		$(ATP_DIR)/atp/lib/libosipparser2.a, \
		/lib/libosipparser2.a,n)
	@$(call install_finish, atp)
#	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

atp_clean:
	rm -rf $(STATEDIR)/atp.compile
	#rm -rf $(ATP)

# vim: syntax=make
