################################################################################
# Copyright (C) 2008 by Qualcomm
################################################################################

# debug to print make internal variables
# $(call dump_ptx_vars)
define dump_ptx_vars
    $(foreach V, $(sort $(.VARIABLES)), $(if $(filter PTX%, $V), \
                 $(warning $V=$($V) ($(value $V)))))
endef


# We provide this package
PACKAGES-$(PTXCONF_BOOTWEDGE) += bootwedge

# Paths and names
BOOTWEDGE_VERSION := 0.01
BOOTWEDGE         := bootwedge-$(BOOTWEDGE_VERSION)
BOOTWEDGE_SRCDIR  := $(PTXDIST_WORKSPACE)/../source/bootwedge
BOOTWEDGE_URL	  := file://$(BOOTWEDGE_SRCDIR)
BOOTWEDGE_DIR     := $(BUILDDIR)/$(BOOTWEDGE)

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

$(STATEDIR)/bootwedge.get: $(bootwedge_get_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

bootwedge_extract: $(STATEDIR)/bootwedge.extract

$(STATEDIR)/bootwedge.extract: $(bootwedge_extract_deps_default)
	@$(call targetinfo, $@)
# create a platform specific package directory for intermediate files.
# the default behavior is to create a symlink to the source directory.
	mkdir -p $(BOOTWEDGE_DIR)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

BOOTWEDGE_PATH      = PATH=$(CROSS_PATH)
BOOTWEDGE_ENV       = $(CROSS_ENV)

# Build in the platform-XXXX/build-<host|target> directory
BOOTWEDGE_MAKEVARS += -C $(BOOTWEDGE_DIR)
# Invoke the Makefile which resides with the source
BOOTWEDGE_MAKEVARS += -f $(BOOTWEDGE_SRCDIR)/bootwedge.mk
# Location of source directory used by vpath
BOOTWEDGE_MAKEVARS += OBJDIR=$(BOOTWEDGE_DIR)
BOOTWEDGE_MAKEVARS += SRCDIR=$(BOOTWEDGE_SRCDIR)
BOOTWEDGE_MAKEVARS += $(PARALLELMFLAGS)
BOOTWEDGE_MAKEVARS += CROSS_COMPILE=arm-none-linux-gnueabi-

ifeq "$(findstring msm7201a,$(PTXCONF_PLATFORM))" "msm7201a"
BOOTWEDGE_MAKEVARS += TARGET=msm7600
else ifeq "$(findstring msm7601,$(PTXCONF_PLATFORM))" "msm7601"
BOOTWEDGE_MAKEVARS += TARGET=msm7600
else ifeq "$(findstring qsd8650,$(PTXCONF_PLATFORM))" "qsd8650"
BOOTWEDGE_MAKEVARS += TARGET=msm8650
else ifeq "$(findstring msm7625,$(PTXCONF_PLATFORM))" "msm7625"
BOOTWEDGE_MAKEVARS += TARGET=msm7625
else ifeq "$(findstring qst1500,$(PTXCONF_PLATFORM))" "qst1500"
BOOTWEDGE_MAKEVARS += TARGET=msm7625
else ifeq "$(findstring qst1600,$(PTXCONF_PLATFORM))" "qst1600"
BOOTWEDGE_MAKEVARS += TARGET=msm7625
else ifeq "$(findstring qst1105,$(PTXCONF_PLATFORM))" "qst1105"
BOOTWEDGE_MAKEVARS += TARGET=qst1105
else
BOOTWEDGE_MAKEVARS += TARGET=$(PTXCONF_PLATFORM)
endif


BOOTWEDGE_MAKEVARS += TARGET_TYPE=$(TARGET_TYPE)
BOOTWEDGE_MAKEVARS += BOOTWEDGE_PADDR=$(PTXCONF_BOOTWEDGE_PADDR)
BOOTWEDGE_MAKEVARS += KERNEL_DIR=$(KERNEL_DIR)
BOOTWEDGE_MAKEVARS += KERNEL_OBJDIR=$(KERNEL_OBJDIR)

bootwedge_prepare: $(STATEDIR)/bootwedge.prepare

$(STATEDIR)/bootwedge.prepare: $(bootwedge_prepare_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

bootwedge_compile: $(STATEDIR)/bootwedge.compile

# defer compile until initrd.gz is built during post-processing

$(STATEDIR)/bootwedge.compile: $(bootwedge_compile_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

bootwedge_install: $(STATEDIR)/bootwedge.install

$(STATEDIR)/bootwedge.install: $(bootwedge_install_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

bootwedge_targetinstall: $(STATEDIR)/bootwedge.targetinstall

$(STATEDIR)/bootwedge.targetinstall: $(bootwedge_targetinstall_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

bootwedge_clean:
	rm -rf $(STATEDIR)/bootwedge.*
	rm -rf $(BOOTWEDGE_DIR)

