################################################################################
# Copyright (C) 2008 by Qualcomm
################################################################################

#
# We provide this package
#
HOST_PACKAGES-$(PTXCONF_HOST_MKNANDIMAGE) += host-mknandimage

#
# Paths and names
#
HOST_MKNANDIMAGE_VERSION := 1.0.0
HOST_MKNANDIMAGE	 := mknandimage-$(HOST_MKNANDIMAGE_VERSION)
HOST_MKNANDIMAGE_SRCDIR  := $(PTXDIST_WORKSPACE)/../source/mknandimage
HOST_MKNANDIMAGE_URL     := file://$(HOST_MKNANDIMAGE_SRCDIR)
HOST_MKNANDIMAGE_DIR	 := $(HOST_BUILDDIR)/$(HOST_MKNANDIMAGE)

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

host-mknandimage_get: $(STATEDIR)/host-mknandimage.get

$(STATEDIR)/host-mknandimage.get: $(host-mknandimage_get_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

host-mknandimage_extract: $(STATEDIR)/host-mknandimage.extract

$(STATEDIR)/host-mknandimage.extract: $(host-mknandimage_extract_deps_default)
	@$(call targetinfo, $@)
# create a platform specific package directory for intermediate files.
# the default behavior is to create a symlink to the source directory.
	mkdir -p $(HOST_MKNANDIMAGE_DIR)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

# Build in the platform-XXXX/build-<host|target> directory
HOST_MKNANDIMAGE_MAKEVARS += -C $(HOST_MKNANDIMAGE_DIR)
# Invoke the Makefile which resides with the source
HOST_MKNANDIMAGE_MAKEVARS += -f $(HOST_MKNANDIMAGE_SRCDIR)/mknandimage.mk
# Location of source directory used by vpath
HOST_MKNANDIMAGE_MAKEVARS += SRCDIR=$(HOST_MKNANDIMAGE_SRCDIR)
HOST_MKNANDIMAGE_MAKEVARS += $(PARALLELMFLAGS)

host-mknandimage_prepare: $(STATEDIR)/host-mknandimage.prepare

$(STATEDIR)/host-mknandimage.prepare: $(host-mknandimage_prepare_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

host-mknandimage_compile: $(STATEDIR)/host-mknandimage.compile

$(STATEDIR)/host-mknandimage.compile: $(host-mknandimage_compile_deps_default)
	@$(call targetinfo, $@)
	$(HOST_MKNANDIMAGE_PATH) $(MAKE) $(HOST_MKNANDIMAGE_MAKEVARS)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

host-mknandimage_install: $(STATEDIR)/host-mknandimage.install

$(STATEDIR)/host-mknandimage.install: $(host-mknandimage_install_deps_default)
	@$(call targetinfo, $@)
	@-cp -f $(HOST_MKNANDIMAGE_DIR)/mknandimage $(PTXCONF_SYSROOT_HOST)/bin/mknandimage
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

host-mknandimage_clean:
	rm -rf $(STATEDIR)/host-mknandimage.*
	rm -rf $(HOST_MKNANDIMAGE_DIR)

# vim: syntax=make
