# -*-makefile-*-
# $Id: template-make 8008 2008-04-15 07:39:46Z mkl $
#
# Copyright (C) 2008 by QUALCOMM Incorporated.
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_STRINGL) += stringl

#
# Paths and names
#
STRINGL_VERSION	:= 1.0.0
STRINGL			:= stringl-$(STRINGL_VERSION)
STRINGL_SRCDIR  := $(PTXDIST_WORKSPACE)/../source/stringl
STRINGL_URL		:= file://$(STRINGL_SRCDIR)
STRINGL_DIR		:= $(BUILDDIR)/$(STRINGL)

STRINGL_LIBVER   := $(STRINGL_VERSION)
STRINGL_LIBMAJOR := $(basename $(basename $(STRINGL_LIBVER)))
# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

$(STATEDIR)/stringl.get:
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

$(STATEDIR)/stringl.extract:
	@$(call targetinfo, $@)
# create a platform specific package directory for intermediate files.
# the default behavior is to create a symlink to the source directory.
	mkdir -p $(STRINGL_DIR)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

STRINGL_PATH = PATH=$(CROSS_PATH)
STRINGL_ENV  = $(CROSS_ENV)

# Build in the platform-XXXX/build-<host|target> directory
STRINGL_MAKEVARS += -C $(STRINGL_DIR)
# Invoke the Makefile which resides with the source
STRINGL_MAKEVARS += -f $(STRINGL_SRCDIR)/stringl.mk
# Location of source directory used by vpath
STRINGL_MAKEVARS += OBJDIR=$(STRINGL_DIR)
STRINGL_MAKEVARS += SRCDIR=$(STRINGL_SRCDIR)

STRINGL_MAKEVARS += LIBVER=$(STRINGL_LIBVER)
STRINGL_MAKEVARS += LIBMAJOR=$(STRINGL_LIBMAJOR)
STRINGL_MAKEVARS += $(PARALLELMFLAGS)

ifeq "$(PTXCONF_STRINGL_TEST)" "y"
STRINGL_MAKEVARS += BUILD_TEST=y
endif	# PTXCONF_STRINGL_TEST

$(STATEDIR)/stringl.prepare:
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

$(STATEDIR)/stringl.compile:
	@$(call targetinfo, $@)
	$(STRINGL_ENV) $(STRINGL_PATH) $(MAKE) $(STRINGL_MAKEVARS)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

$(STATEDIR)/stringl.install:
	@$(call targetinfo, $@)
# install to common include and link paths
	@cp -f $(STRINGL_SRCDIR)/stringl.h $(PTXCONF_SYSROOT_TARGET)/include
	@cp -f $(STRINGL_DIR)/libstringl.so.$(STRINGL_LIBVER) $(PTXCONF_SYSROOT_TARGET)/lib/libstringl.so.$(STRINGL_LIBVER)
	@ln -sf $(PTXCONF_SYSROOT_TARGET)/lib/libstringl.so.$(STRINGL_LIBVER) $(PTXCONF_SYSROOT_TARGET)/lib/libstringl.so.$(STRINGL_LIBMAJOR)
	@ln -sf $(PTXCONF_SYSROOT_TARGET)/lib/libstringl.so.$(STRINGL_LIBMAJOR) $(PTXCONF_SYSROOT_TARGET)/lib/libstringl.so
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/stringl.targetinstall:
	@$(call targetinfo, $@)

	@$(call install_init, stringl)
	@$(call install_fixup, stringl,PACKAGE,stringl)
	@$(call install_fixup, stringl,PRIORITY,optional)
	@$(call install_fixup, stringl,VERSION,$(STRINGL_VERSION))
	@$(call install_fixup, stringl,SECTION,base)
	@$(call install_fixup, stringl,AUTHOR,"QUALCOMM")
	@$(call install_fixup, stringl,DEPENDS,)
	@$(call install_fixup, stringl,DESCRIPTION,missing)

	@$(call install_copy, stringl, 0, 0, 0644, $(STRINGL_DIR)/libstringl.so.$(STRINGL_LIBVER), $(PTXCONF_QCOM_LIB_INSTALL_PATH)/libstringl.so.$(STRINGL_LIBVER))
	@$(call install_link, stringl, libstringl.so.$(STRINGL_LIBVER), $(PTXCONF_QCOM_LIB_INSTALL_PATH)/libstringl.so.$(STRINGL_LIBMAJOR))
	@$(call install_link, stringl, libstringl.so.$(STRINGL_LIBMAJOR), $(PTXCONF_QCOM_LIB_INSTALL_PATH)/libstringl.so)

ifeq "$(PTXCONF_STRINGL_TEST)" "y"
	@$(call install_copy, stringl, 0, 0, 0755, $(STRINGL_DIR)/test_stringl, $(PTXCONF_QCOM_TEST_INSTALL_PATH)/test_stringl)
endif	# PTXCONF_STRINGL_TEST

	@$(call install_finish, stringl)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

stringl_clean:
	rm -rf $(STATEDIR)/stringl.*
	rm -rf $(PKGDIR)/stringl_*
	rm -rf $(STRINGL_DIR)

# vim: syntax=make
