/******************************************************************************
  Ȩ  : 2007-2020Ϊ޹˾
      : dnsserverapi.c
        : l67187
        : v1.0
    : 2007-8-23
        : DNS ServerĹ
  
  б  :
                ATP_DNS_ServerRestart
                ATP_DNS_ServerStart
                ATP_DNS_ServerStop
                ATP_DNS_GetFuncInfo

  ʷ¼      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
//#include <sys/types.h>
//#include <sys/wait.h>
#include <errno.h>

#include "dnsserverapi.h"

char** environ;

/* ǰ DNS Server Ƿ״̬ */
static int g_lDnsStatus = ATP_DNS_SERVER_STOP;

/* ǰDNS ServerʹõĹܽṹ */
static ATP_DNS_FUNC_INFO_ST g_stDnsFuncInfo;

/* ǰò */
static ATP_DNS_FUNC_PARA_ST g_stDnsFuncPara;

/* ǰLanӦϵ */
static ATP_DNS_LANINFO_NODE_ST* g_pstDnsLanInfo = NULL;

/******************************************************************************
    : DnsCmdExec
    : shell
    : 
              pszCmd  ָ
  ú  : 
    : 
    : 
    ֵ  : ɹ  0
              ʧܷ  -1

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int DnsCmdExec(char* pszCmd)
{
    int lPid = 0;
    int lStatus = 0;
    char *pacArgv[4];

    if (NULL == pszCmd)
    {
        return -1;
    }
      

    lPid = fork();
    if (-1 == lPid)
    {
        return -1;
    }
    if (0 == lPid)
    {
        pacArgv[0] = "sh";
        pacArgv[1] = "-c";
        pacArgv[2] = pszCmd;
        pacArgv[3] = 0;
        execve("/bin/sh", pacArgv, environ);
        exit(127);
    }

    /* wait for child process return */
    do
    {
        if (-1 == waitpid(lPid, &lStatus, 0))
        {
            if ( errno != EINTR )
            {
                return -1;
            }                
        } 
        else
        {
            return lStatus;
        }
    } while (1);
    return lStatus;
}

/******************************************************************************
    : DnsValidateUrl
    : УǷΪURLַ
    : 
              pcUrl  - Url
  ú  : 
    : 
    : 
    ֵ  : ɹ             1
              ʧܷ             0

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int DnsValidateUrl(char* pcUrl)
{
    int lLen = 0;
    char* tmp;
    if (NULL == pcUrl)
    {
        return 0;
    }
    lLen = strlen(pcUrl);
    if (lLen < 3)
    {
        return 0;
    }
    tmp = strchr(pcUrl, '.');
    if ((NULL == tmp) || (tmp == pcUrl))
    {
        return 0;
    }
    tmp = pcUrl;
    while(*tmp != '\0')
    {
        if (*tmp == ' ' || *tmp == '\\')
        {
            return 0;
        }
        tmp++;
    }
    if (*(tmp-1) == '.')
    {
        return 0;
    }
    return 1;
}

/******************************************************************************
    : DnsValidateThreeNumber
    : УÿIpǷΪ
    : 
              pcBuf  - Ipַ
  ú  : 
    : 
    : 
    ֵ  : ɹ             1
              ʧܷ             0

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int DnsValidateThreeNumber(char* pcBuf)
{
    int   bRet = 0;
    int   i = 0; 
    int   ulSize = 0;

    if (pcBuf == NULL) 
    {
        return bRet;
    }

    ulSize = strlen(pcBuf);
    for ( i = 0; i < ulSize; i++ )
    {        
        if ((pcBuf[i] < '0') || (pcBuf[i] > '9'))
        {
            break;
        }
    }

    if ((ulSize > 0) && (ulSize <= 3) && (i == ulSize))
    {
        bRet = 1;
    }
    return bRet;
}
/******************************************************************************
    : DnsValidateHostIpAddress
    : УIp
    : 
              pcIpAddr  - Ip ַ
  ú  : 
    : 
    : 
    ֵ  : ɹ             1
              ʧܷ             0

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int DnsValidateHostIpAddress(char *pcIpAddr)
{
    char   *pcToken = NULL;
    char   *pcLast = NULL;
    char   acbuf[DNS_HGW_DEFAULT_IP_LEN];
    int i = 0;
    char   *pcTemp;

    if ((pcIpAddr == NULL) || (strlen(pcIpAddr) >= DNS_HGW_DEFAULT_IP_LEN))
    {
        return 0;
    }

    memset(acbuf, 0, sizeof(acbuf));
    strcpy(acbuf, pcIpAddr);

    pcTemp = acbuf;
    while(*pcTemp != '\0')
    {
        if (*pcTemp == '.')
        {
            i++;
        }
        pcTemp++;
    }
    if (i != 3)
    {
        return 0;
    }

    if ((strcmp("0.0.0.0", acbuf) == 0) || 
        (strcmp("255.255.255.255", acbuf) == 0))
    {
        return 0;
    }

    pcToken = strtok_r(acbuf, ".", &pcLast);
    if ((DnsValidateThreeNumber(pcToken) == 0) || 
        (atoi(pcToken) < 1) || 
        (atoi(pcToken) >= 224) || 
        (atoi(pcToken) == 127))
    {
        return 0;
    }

    for (i = 2; i <= 3; i++)
    {
        pcToken = strtok_r(NULL, ".", &pcLast);
        if ((DnsValidateThreeNumber(pcToken) == 0) || 
            (atoi(pcToken) < 0) || 
            (atoi(pcToken) > 255))
        {
            return 0;
        }
    }

    /*0255ҲǺϷ*/
    pcToken = strtok_r(NULL, ".", &pcLast);
    if ((DnsValidateThreeNumber(pcToken) == 0) || 
        (atoi(pcToken) < 1) || 
        (atoi(pcToken) > 254))
    {
        return 0;
    }

    return 1;
}

/******************************************************************************
    : DnsRestart
    : LAN  ʣļ
    : 
              
  ú  : 
    : 
    : 
    ֵ  : ɹ  0
              ʧܷ  -1

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int DnsRestart(void)
{
    FILE* fd;
    unsigned int  lPid;
    char acCmd[DNS_SERVER_CMD_LEN];
	ATP_DNS_LANINFO_NODE_ST* pstLanUrl = g_pstDnsLanInfo;
	
    lPid = 0;
    acCmd[0] = '\0';

    fd = fopen(DNS_PID_FILE, "r");
    if (NULL == fd)
    {
        perror("the error no");
        printf("DNS Server: Could't Open The PidFile-%s\n", DNS_PID_FILE);
        return ATP_DNS_STS_ERR_PID;
    }

    fscanf(fd, "%d", &lPid);
    fclose(fd);  
    remove(DNS_PID_FILE);
    
    if (lPid > 0)
    {
        sprintf(acCmd, "kill -9 %d", lPid);
        DnsCmdExec(acCmd);
    } 
    else
    {
        printf("DNS Server: The Pid is Error-%d\n", lPid);
        return ATP_DNS_STS_ERR_PID;
    }

    remove("/var/dnsmasq.conf");

    g_lDnsStatus = ATP_DNS_SERVER_STOP;

	fd = fopen("/var/dnsmasq.conf", "w");
    if(NULL == fd)
    {
        perror("the error no");
        printf("DNS Server: Could't Open The ConfFile-/var/dnsmasq.conf.\r\n");
        return ATP_DNS_STS_ERR_HOSTS;
    }
    while(pstLanUrl != NULL)
    {
    	fprintf(fd, "address=/%s/%s\n", pstLanUrl->stLanInfo.acUrl, pstLanUrl->stLanInfo.acLanIpAddr);
    	pstLanUrl = pstLanUrl->next;
    }
    /* ж */
	if (1 == g_stDnsFuncInfo.HgwUrl)
    {
	    fprintf(fd, "address=/%s/%s\n", g_stDnsFuncPara.acHgwUrl, g_stDnsFuncPara.acHgwLanIpAddr);
	}
	fprintf(fd, "addn-hosts=%s\n", DNS_SERVER_CACHE_FILE);
	fprintf(fd, "strict-order\n");  /* C47036: dns query in the order */
    fclose(fd);
    
    sprintf(acCmd, "/bin/dnsmasq -i br0 --conf-file=/var/dnsmasq.conf & > /dev/null &");  /* BB5D02120.DNSMASQ: yangjianping 2009-8-8 DEL END> */
    DnsCmdExec(acCmd);

    g_lDnsStatus = ATP_DNS_SERVER_START;
    sleep(1);
    return ATP_DNS_STS_OK;
}

/******************************************************************************
    : ATP_DNS_ServerRestart
    : DNS Server  -HUP Ϣ
    : 
              
  ú  : 
    : 
    : 
    ֵ  : ɹ ATP_DNS_STS_OK - 0
              ʧܷش ATP_DNS_STS_ERR_PID

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int ATP_DNS_ServerRestart(void)
{
    FILE* fd;
    unsigned int lPid = 0;
    char acCmd[DNS_SERVER_CMD_LEN];
    acCmd[0] = '\0';

    fd = fopen(DNS_PID_FILE, "r");

    /* ǰļڣûУֱӷ */
    if (fd == NULL)
    {
        perror("the error no");
        printf("DNS Server: Could't Open The PidFile-%s \r\n", DNS_PID_FILE);
        return ATP_DNS_STS_ERR_PID;
    }
    fscanf(fd, "%d", &lPid);
    fclose(fd);  

    if (lPid > 0)
    {
        sprintf(acCmd, "kill -HUP %d", lPid);
        DnsCmdExec(acCmd);
    } 
    else
    {
        printf("DNS Server: The Pid is Error-%d \r\n", lPid);
        return ATP_DNS_STS_ERR_PID;
    }
    return ATP_DNS_STS_OK;
}

/******************************************************************************
    : ATP_DNS_ServerStop
    : ֹͣDNS Server
    : 
              
  ú  : 
    : 
    : 
    ֵ  : ɹ ATP_DNS_STS_OK - 0
              ʧܷش

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int ATP_DNS_ServerStop(void)
{
    FILE* fd;
    unsigned int  lPid;
    char acCmd[DNS_SERVER_CMD_LEN];

    lPid = 0;
    acCmd[0] = '\0';

    g_lDnsStatus = ATP_DNS_SERVER_STOP;

    fd = fopen(DNS_PID_FILE, "r");
    if (NULL == fd)
    {
        perror("the error no");
        printf("DNS Server: Could't Open The PidFile-%s\n", DNS_PID_FILE);
        return ATP_DNS_STS_ERR_PID;
    }
    fscanf(fd, "%d", &lPid);
    fclose(fd);  
    remove(DNS_PID_FILE);
    
    if (lPid > 0)
    {
        sprintf(acCmd, "kill -9 %d", lPid);
        DnsCmdExec(acCmd);
    } 
    else
    {
        printf("DNS Server: The Pid is Error-%d\n", lPid);
        return ATP_DNS_STS_ERR_PID;
    }
//    sprintf(acCmd, "iptables -t nat -D PREROUTING -p udp --dport 53 -j REDIRECT --to-ports 53 2>/dev/null");
//    DnsCmdExec(acCmd);

    remove(DNS_SERVER_CACHE_FILE);
    remove("/var/dnsmasq.conf");
    
    memset(&g_stDnsFuncInfo, 0, sizeof(ATP_DNS_FUNC_INFO_ST));
    memset(&g_stDnsFuncPara, 0, sizeof(ATP_DNS_FUNC_PARA_ST));
    return ATP_DNS_STS_OK;
}

/******************************************************************************
    : ATP_DNS_ServerStart
    : DNS Server
    : 
              stDnsInfo  - DNS Serverܽṹ
              pstDnsPara - DNS Serverܲ
  ú  : 
    : 
    : 
    ֵ  : ɹ ATP_DNS_STS_OK - 0
              ʧܷش

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int ATP_DNS_ServerStart(ATP_DNS_FUNC_INFO_ST stDnsInfo, ATP_DNS_FUNC_PARA_ST* pstDnsPara)
{
    char acCmd[DNS_SERVER_CMD_LEN];
    char acLanIpAddr[DNS_HGW_DEFAULT_IP_LEN];
    char acDefaultUrl[DNS_HGW_DEFAULT_URL_LEN];
    FILE* fp;
    
    char acUrlFltPath[] = DNS_URLFLT_PATH;          /*   /var/url_filter   */
    char acHostsPath[] = DNS_SERVER_CACHE_FILE;     /*   /var/hosts        */
    ATP_DNS_LANINFO_NODE_ST* pstLanUrl = g_pstDnsLanInfo;

    memset(acLanIpAddr, 0, sizeof(acLanIpAddr));
    memset(acDefaultUrl, 0, sizeof(acDefaultUrl));
    memset(acCmd, 0, sizeof(acCmd));

    if (ATP_DNS_SERVER_START == g_lDnsStatus)
    {
        return ATP_DNS_STS_ERR_START;
    }

    if (NULL == pstDnsPara)
    {
        printf("DNS Server: Input Para is NULL.\n");
        return ATP_DNS_STS_ERR_INPUT;
    }

    fp = fopen(acHostsPath, "w");
    if(NULL == fp) 
    {
        perror("the error no");
        printf("DNS Server: Could't Open The HostsFile-%s", acHostsPath);
        return ATP_DNS_STS_ERR_HOSTS;
    }    
    fprintf(fp, "127.0.0.1 localhost.localdomain localhost\n");
    fclose(fp);

    fp = fopen("/var/dnsmasq.conf", "w");
    if(NULL == fp)
    {
        perror("the error no");
        printf("DNS Server: Could't Open The ConfFile-/var/dnsmasq.conf.\r\n");
        remove(DNS_SERVER_CACHE_FILE);
        return ATP_DNS_STS_ERR_HOSTS;
    }
    while(pstLanUrl != NULL)
    {
    	fprintf(fp, "address=/%s/%s\n", pstLanUrl->stLanInfo.acUrl, pstLanUrl->stLanInfo.acLanIpAddr);
    	pstLanUrl = pstLanUrl->next;
    }
    /* ж */
    if (1 == stDnsInfo.HgwUrl)
    {
        if (0 == DnsValidateHostIpAddress(pstDnsPara->acHgwLanIpAddr) || '\0' == pstDnsPara->acHgwUrl[0])
        {
            printf("DNS Server: Ip Addr is Error.\n");
            fclose(fp);
            remove(DNS_SERVER_CACHE_FILE);
            remove("/var/dnsmasq.conf");
            return ATP_DNS_STS_ERR_INPUT;
        }
        strcpy(acDefaultUrl, pstDnsPara->acHgwUrl);
        strcpy(acLanIpAddr, pstDnsPara->acHgwLanIpAddr);
        fprintf(fp, "address=/%s/%s\n", acDefaultUrl, acLanIpAddr);    
    }
    
    fprintf(fp, "addn-hosts=%s\n", acHostsPath);
    fprintf(fp, "strict-order\n");  /* C47036: dns query in the order */
    fclose(fp);
    if (1 != stDnsInfo.UrlFlt)
    {
        fp = fopen(acUrlFltPath, "w");
        if (NULL == fp) 
        {
            perror("the error no");
            printf("DNS Server: Could't Open The UrlFilter File-%s", acUrlFltPath);
            return ATP_DNS_STS_ERR_URLFLT;           
        }
        fprintf(fp, "0\n");
        fclose(fp);
    }
    else
    {
        fp = fopen(acUrlFltPath, "r");
        if (NULL == fp)
        {
            perror("the error no");
            printf("DNS Server: Could't Open The UrlFilter File-%s", acUrlFltPath);
            return ATP_DNS_STS_ERR_URLFLT;
        }
        fclose(fp);
    }
    /***************************չܴ***************************/
    //
    //
    //
    //
    //
    //
    //
    //
    /***************************չܴ***************************/

//    sprintf(acCmd, "iptables -t nat -I PREROUTING 1 -p udp --dport 53 -j REDIRECT --to-ports 53 2>/dev/null");
//    DnsCmdExec(acCmd);    

    sprintf(acCmd, "/bin/dnsmasq -i br0 --conf-file=/var/dnsmasq.conf & > /dev/null &");
    DnsCmdExec(acCmd);
  
    /* 浱ǰõȫ */
    memcpy(&g_stDnsFuncInfo, &stDnsInfo, sizeof(ATP_DNS_FUNC_INFO_ST));
    memcpy(&g_stDnsFuncPara, pstDnsPara, sizeof(ATP_DNS_FUNC_PARA_ST));
    g_lDnsStatus = ATP_DNS_SERVER_START;
    sleep(1);
    return ATP_DNS_STS_OK;
}


/******************************************************************************
    : ATP_DNS_GetFuncInfo
    : ȡDNS Serverò
    : 
              
  ú  : 
    : 
    : 
              pstDnsInfo - DNS Serverܽṹ
              pstDnsPara - DNS Serverܲ
              
    ֵ  : DNS Serverȡɹ  1
              DNS Serverδ        0

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int ATP_DNS_GetFuncInfo(ATP_DNS_FUNC_INFO_ST* pstDnsInfo, ATP_DNS_FUNC_PARA_ST* pstDnsPara)
{
    if (NULL == pstDnsInfo || NULL == pstDnsPara)
    {
        printf("DNS Server: Input Para is NULL.\n");
        return -1;
    }
    
    if (ATP_DNS_SERVER_START == g_lDnsStatus)
    {
        memcpy(pstDnsInfo, &g_stDnsFuncInfo, sizeof(ATP_DNS_FUNC_INFO_ST));
        memcpy(pstDnsPara, &g_stDnsFuncPara, sizeof(ATP_DNS_FUNC_PARA_ST));
    }
    return g_lDnsStatus;
}

/******************************************************************************
    : ATP_DNS_LanUrlSet
    : LanIpӦϵϵΨһ
              Ѿʱ  ATP_DNS_STS_ERR_URL_EXIST
    : 
              pszUrl - Lan
              pszIp  - LanIp
  ú  : 
    : 
    : 
              
              
    ֵ  : óɹ         0
              ʧܷش       ATP_DNS_STS_ERR_INPUT       Ϊ
                                   ATP_DNS_STS_ERR_URL         
                                   ATP_DNS_STS_ERR_IP          Ip
                                   ATP_DNS_STS_ERR_URL_EXIST   Ѵ
                                   ATP_DNS_STS_ERR_MEM         ڴ治

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int ATP_DNS_LanUrlSet(char* pszUrl, char* pszIp)
{
    ATP_DNS_LANINFO_NODE_ST* pstCurNode = g_pstDnsLanInfo;
    ATP_DNS_LANINFO_NODE_ST* pstPreNode = pstCurNode;
    ATP_DNS_LANINFO_NODE_ST* tmp = NULL;
    if (pszUrl == NULL || pszIp == NULL)
    {
        return  ATP_DNS_STS_ERR_INPUT;
    }
    if (0 == DnsValidateUrl(pszUrl))
    {
        return ATP_DNS_STS_ERR_URL;
    }
    if (0 == DnsValidateHostIpAddress(pszIp))
    {
        return ATP_DNS_STS_ERR_IP;
    }

    /* УǷظ */
    while ((pstCurNode != NULL) && (strcmp(pstCurNode->stLanInfo.acUrl, pszUrl) != 0))
    {
        pstPreNode = pstCurNode;
        pstCurNode = pstCurNode->next;
    }
    if (pstCurNode != NULL)
    {
        return ATP_DNS_STS_ERR_URL_EXIST;
    }

    /* ·㣬ӽβ */
    tmp = (ATP_DNS_LANINFO_NODE_ST*)malloc(sizeof(ATP_DNS_LANINFO_NODE_ST));
    if (NULL == tmp)
    {
        printf("More Mem Needed.\r\n");
        return ATP_DNS_STS_ERR_MEM;
    }
    strcpy(tmp->stLanInfo.acUrl, pszUrl);
    strcpy(tmp->stLanInfo.acLanIpAddr, pszIp);
    tmp->next = NULL;

    if (NULL == g_pstDnsLanInfo)
    {
        g_pstDnsLanInfo = tmp;
    }
    else
    {
        pstPreNode->next = tmp;
    }
    DnsRestart();
    return ATP_DNS_STS_OK;
}

/******************************************************************************
    : ATP_DNS_LanUrlDel
    : ɾӦϵ
    : 
              pszUrl - Lan

  ú  : 
    : 
    : 
              
              
    ֵ  : ɾɹ         0
              ʧܷش       ATP_DNS_STS_ERR_INPUT       Ϊ
                                   ATP_DNS_STS_ERR_URL_EXIST   

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
int ATP_DNS_LanUrlDel(char* pszUrl)
{
    ATP_DNS_LANINFO_NODE_ST* pstCurNode = g_pstDnsLanInfo;
    ATP_DNS_LANINFO_NODE_ST* pstPreNode = pstCurNode;
    if (NULL == pszUrl)
    {
        return ATP_DNS_STS_ERR_INPUT;
    }
    /*  */
    while ((pstCurNode != NULL) && (strcmp(pstCurNode->stLanInfo.acUrl, pszUrl) != 0))
    {
        pstPreNode = pstCurNode;
        pstCurNode = pstCurNode->next;
    }
    if (NULL == pstCurNode)
    {
        return ATP_DNS_STS_ERR_URL_EXIST;
    }
    /* ɾͷ㣬ƶȫָ */
    if (pstCurNode == g_pstDnsLanInfo)
    {
        g_pstDnsLanInfo = g_pstDnsLanInfo->next;
    }
    else
    {   /* ɾǰ */
        pstPreNode->next = pstCurNode->next;
    }
    /* ͷԴ */
    pstCurNode->next = NULL;
    free(pstCurNode);
    DnsRestart();
    return ATP_DNS_STS_OK;
}

/******************************************************************************
    : ATP_DNS_LanUrlGet
    : ָ룬ѯǰϢһָ
              ʵֶùϵĲѯ
              ɵΪڴռ
              
    : 
              pVoid - ATP_DNS_LANINFO_NODE_ST* ṹָ
              

  ú  : 
    : 
    : 
              pstLanInfo  ATP_DNS_LAN_INFO_ST* 
              
    ֵ  : 
              pVoidΪʱͷָ
              򷵻ظýһָ     ATP_DNS_LANINFO_NODE_ST

  ޸ʷ      :
   1.       : 2007-8-23
            : l67187
     ޸   : ɳ

******************************************************************************/
ATP_DNS_LANINFO_NODE_ST* ATP_DNS_LanUrlGet(void *pVoid, ATP_DNS_LAN_INFO_ST* pstLanInfo)
{
    ATP_DNS_LANINFO_NODE_ST* pstNode = NULL;

    if (NULL == pstLanInfo)
    {
        return pstNode;
    }

    if (NULL == pVoid)
    {
        pstNode = g_pstDnsLanInfo;
    }
    else
    {
        pstNode = ((ATP_DNS_LANINFO_NODE_ST *)pVoid)->next;
    }

    if ( NULL != pstNode )
    {
        memcpy(pstLanInfo, &(pstNode->stLanInfo), sizeof(ATP_DNS_LAN_INFO_ST));
    }

    return pstNode;
}


/******************************************************************************
    : ATP_DNS_CacheClear
    : DNS򣬷򻺴
    : 
              
  ú  : 
    : 
    : 
    ֵ  : ɹ ATP_DNS_STS_OK - 0
              ʧܷش

  ޸ʷ      :
   1.       : 2008-02-18
            : d00107688
     ޸   : ɳ

******************************************************************************/
int ATP_DNS_CacheClear(void)
{
    FILE* fd;
    unsigned int  lPid;
    char acCmd[DNS_SERVER_CMD_LEN];

    lPid = 0;
    acCmd[0] = '\0';

    fd = fopen(DNS_PID_FILE, "r");
    if (NULL == fd)
    {
        perror("the error no");
        printf("DNS Server: Could't Open The PidFile-%s\n", DNS_PID_FILE);
        return ATP_DNS_STS_ERR_PID;
    }
    fscanf(fd, "%d", &lPid);
    fclose(fd);  
    
    if (lPid > 0)
    {
        sprintf(acCmd, "kill -SIGUSR2 %u", lPid);
        DnsCmdExec(acCmd);
    } 
    else
    {
        printf("DNS Server: The Pid is Error-%d\n", lPid);
        return ATP_DNS_STS_ERR_PID;
    }

    return ATP_DNS_STS_OK;
}


