#ifndef __DNS_SERVER_API_H__
#define __DNS_SERVER_API_H__

#define ATP_DNS_SERVER_STOP               0
#define ATP_DNS_SERVER_START              1
#define DNS_HGW_DEFAULT_IP_LEN        16
#define DNS_HGW_DEFAULT_URL_LEN       64
#define DNS_SERVER_CMD_LEN            240

/* ˺겻ɸģdnsmasq\src\config.hеĺͬ */
#define DNS_PID_FILE               "/var/run/dnsmasq.pid"

/* ļ·޸ */
#define DNS_SERVER_CACHE_FILE      "/var/hosts"

/* ˺겻ɸģdnsmasq.cеĺͬ */
#define DNS_URLFLT_PATH            "/var/url_filter"
/*<BB5D02150 Z00129678 20090818 BEGIN>*/
#ifdef WEB_SOURCE_UK_H3G
/*<BB5D06059 jialaibin  begin  2010-05-25 >*/
#ifdef WEB_SOURCE_AUS_H3G_VODAFONE
#define DNS_HGW_DEFAULT_URL                  "pocket.wifi"
#else
#define DNS_HGW_DEFAULT_URL                  "3.home"
#endif
/*<BB5D06059 jialaibin  end  2010-05-25 >*/
#else
/*BB5D02373 liukeke,Orange  2009-08-25*/
#ifdef WEB_SOURCE_ORANGE
/*BB5D02572 liukeke,Orange  2009-09-12*/
#define DNS_HGW_DEFAULT_URL                  "wifimodem.orange"
/*BB5D02572 liukeke,Orange  2009-09-12*/
#else
#define DNS_HGW_DEFAULT_URL                  "e5.home"
#endif
/*BB5D02373 liukeke,Orange  2009-08-25*/
#endif
/*<BB5D02150 Z00129678 20090818 END>*/
typedef enum tagATP_DNS_STS_EN
{
    ATP_DNS_STS_OK = 0,        
    ATP_DNS_STS_ERR_PID = 1,
    ATP_DNS_STS_ERR_START = 2,
    ATP_DNS_STS_ERR_URLFLT = 3,
    ATP_DNS_STS_ERR_HOSTS = 4,
    ATP_DNS_STS_ERR_INPUT = 5,
    ATP_DNS_STS_ERR_URL = 6,
    ATP_DNS_STS_ERR_IP = 7,
    ATP_DNS_STS_ERR_URL_EXIST = 8,
    ATP_DNS_STS_ERR_MEM = 9
} ATP_DNS_STS_EN;

typedef struct tagATP_DNS_FUNC_INFO_ST 
{
    unsigned int
    HgwUrl:1,
    UrlFlt:1,

    reserved:30;
} ATP_DNS_FUNC_INFO_ST;

typedef struct tagATP_DNS_FUNC_PARA_ST 
{
    char acHgwUrl[DNS_HGW_DEFAULT_URL_LEN];
    char acHgwLanIpAddr[DNS_HGW_DEFAULT_IP_LEN];
    /* ṹдչ */    
} ATP_DNS_FUNC_PARA_ST;

typedef struct tagATP_DNS_LAN_INFO_ST
{
    char acUrl[DNS_HGW_DEFAULT_URL_LEN];
    char acLanIpAddr[DNS_HGW_DEFAULT_IP_LEN];
}ATP_DNS_LAN_INFO_ST;

typedef struct tagATP_DNS_LANINFO_NODE_ST
{
    ATP_DNS_LAN_INFO_ST   stLanInfo;
    struct tagATP_DNS_LANINFO_NODE_ST* next;
} ATP_DNS_LANINFO_NODE_ST;

/********************** Global APIs Definitions *****************************/

#if defined(__cplusplus)
extern "C"
{
#endif

int ATP_DNS_ServerRestart(void);
int ATP_DNS_ServerStop(void);
int ATP_DNS_ServerStart(ATP_DNS_FUNC_INFO_ST stDnsInfo, ATP_DNS_FUNC_PARA_ST* pstDnsPara);
int ATP_DNS_GetFuncInfo(ATP_DNS_FUNC_INFO_ST* pstDnsInfo, ATP_DNS_FUNC_PARA_ST* pstDnsPara);
int ATP_DNS_LanUrlSet(char* pszUrl, char* pszIp);
int ATP_DNS_LanUrlDel(char* pszUrl);
ATP_DNS_LANINFO_NODE_ST* ATP_DNS_LanUrlGet(void *pVoid, ATP_DNS_LAN_INFO_ST* pstLanInfo);
int ATP_DNS_CacheClear(void);

#if defined(__cplusplus)
}
#endif

#endif
