
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include "dnsmasq.h"

#define NAME_SIZE  64
#define LIST_STEP  4

typedef struct {
	char szName[NAME_SIZE];
} NAME_S;

/* 1 -white, 0 -black. */
static unsigned int s_uMode = 0;
static NAME_S* s_pstNameList = 0;
static unsigned int s_uNameSize = 0;
#ifdef SUPPORT_CNC_URLFILTER
/*start ͨɫ by l38280   2008-4-8*/
static unsigned int s_cnc_uMode[3] = {0,0,0};
static NAME_S* s_cnc_pstNameList[3] = {0,0,0};
static unsigned int s_cnc_uNameSize[3] = {0,0,0};
/*end ͨɫ by l38280   2008-4-8*/
#endif


unsigned int filterInitialize(const char* lpszFile)
{
	FILE* pFile = 0;
	char* pszTemp = 0;
	NAME_S* pstName = 0;
	unsigned int uInd = 0;
	char szName[NAME_SIZE] = {0};

	if (s_pstNameList != 0) {
		printf("URL Filer: Has been initialized!\n");
		return 0;
	}
	
	pFile = fopen(lpszFile, "r");
	if (pFile == 0) {
		printf("URL Filer: open rule file failed!\n");
		return 1;
	}

    /* get white/black mode */
	if (!fgets(szName, sizeof(szName), pFile)) {
		printf("URL Filer: Not sepcial white/black mode in file!\n");
		fclose(pFile);
		return 1;
	}
	s_uMode = (unsigned int)atoi(szName);

	/* get name list */
	while (fgets(szName, sizeof(szName), pFile)) {
		if (s_uNameSize <= uInd) {
			pstName = realloc(s_pstNameList, 
				(sizeof(NAME_S) * (s_uNameSize + LIST_STEP)));
			if (pstName == 0) {
				if (s_pstNameList != 0) {
					free(s_pstNameList);
					s_pstNameList = 0;
				}
				uInd = 0;
				break;
			}
			memset(&(pstName[uInd]), 0, (sizeof(NAME_S) * LIST_STEP));
			s_pstNameList = pstName;
			s_uNameSize += LIST_STEP;
		}
		if (szName[0] == '\n'
			|| szName[0] == '\r'
			|| szName[0] == ' '
			|| szName[0] == '\t')
		{
			continue;
		}
		
		pszTemp = strpbrk(szName, " \r\n");
		if (pszTemp != 0) {
			*pszTemp = '\0';
		}
		strncpy(s_pstNameList[uInd].szName, szName, NAME_SIZE);
		s_pstNameList[uInd].szName[NAME_SIZE - sizeof(char)] = '\0';
		
		uInd++;
	}

	fclose(pFile);
	s_uNameSize = uInd;
	return 1;
}

void filterClean()
{
	s_uMode = 0;
	if (s_pstNameList != 0) {
		free(s_pstNameList);
		s_pstNameList = 0;
		s_uNameSize = 0;
	}
}

unsigned int filterCheck(const char* lpszName)
{
	
	if (s_pstNameList != 0) {
		unsigned int uInd = 0;
		for (uInd = 0; uInd < s_uNameSize; uInd++) {
			if (strcasestr(lpszName, s_pstNameList[uInd].szName) != 0) {
				return s_uMode;
			}
		}
	}
	return (!s_uMode);
}

#ifdef SUPPORT_CNC_URLFILTER
/*start ͨɫ by l38280   2008-4-8*/
/*parenttypeֵΪ0 1 2ֱChild Guest Other*/
unsigned int CNC_filterInitialize(const char* lpszFile, int parenttype)
{
	FILE* pFile = 0;
	char* pszTemp = 0;
	NAME_S* pstName = 0;
	unsigned int uInd = 0;
	char szName[NAME_SIZE] = {0};

       if((0 != parenttype) && (1 != parenttype) && (2 != parenttype))
       {
            printf("parent type is not right, shoud be 0 1 or 2!!!\n");
            return 1;
       }
        
	if (s_cnc_pstNameList[parenttype] != 0) {
		printf("URL Filer: Has been initialized!\n");
		return 0;
	}
	
	pFile = fopen(lpszFile, "r");
	if (pFile == 0) {
		printf("CNC URL Filer: open rule file failed!\n");
		return 1;
	}

    /* get parent control type mode */
	if (!fgets(szName, sizeof(szName), pFile)) {
		printf("URL Filer: Not sepcial parent control type in file!\n");
		fclose(pFile);
		return 1;
	}
       if(parenttype == 0)
       {
            if(strstr(szName, "Child") == NULL)
            {
                printf("The parentcontrol type is not correct!!!!\n");
                fclose(pFile);
                return 1;
            }
       }
       else if(parenttype == 1)
       {
            if(strstr(szName, "Guest") == NULL)
            {
                printf("The parentcontrol type is not correct!!!!\n");
                fclose(pFile);
                return 1;
            }
       }
       else if(parenttype == 2)
       {
            if(strstr(szName, "Other") == NULL)
            {
                printf("The parentcontrol type is not correct!!!!\n");
                fclose(pFile);
                return 1;
            }
       }
       else
       {
            printf("The input parentcontrol type is not correct!!!\n");
            fclose(pFile);
            return 1;
       }

    /* get white/black mode */
	if (!fgets(szName, sizeof(szName), pFile)) {
		printf("URL Filer: Not sepcial white/black mode in file!\n");
		fclose(pFile);
		return 1;
	}
       if(strstr(szName, "black") != NULL)
       {
            s_cnc_uMode[parenttype] = 0;
       }
       else if(strstr(szName, "white") != NULL)
       {
            s_cnc_uMode[parenttype] = 1;
       }
       else
       {
            return 0;
       }
	//s_cnc_uMode[parenttype] = (unsigned int)atoi(szName);

	/* get name list */
	while (fgets(szName, sizeof(szName), pFile)) {
		if (s_cnc_uNameSize[parenttype] <= uInd) {
			pstName = realloc(s_cnc_pstNameList[parenttype], 
				(sizeof(NAME_S) * (s_cnc_uNameSize[parenttype] + LIST_STEP)));
			if (pstName == 0) {
				if (s_cnc_pstNameList[parenttype] != 0) {
					free(s_cnc_pstNameList[parenttype]);
					s_cnc_pstNameList[parenttype] = 0;
				}
				uInd = 0;
				break;
			}
			memset(&(pstName[uInd]), 0, (sizeof(NAME_S) * LIST_STEP));
			s_cnc_pstNameList[parenttype] = pstName;
			s_cnc_uNameSize[parenttype] += LIST_STEP;
		}
		if (szName[0] == '\n'
			|| szName[0] == '\r'
			|| szName[0] == ' '
			|| szName[0] == '\t')
		{
			continue;
		}
		
		pszTemp = strpbrk(szName, " \r\n");
		if (pszTemp != 0) {
			*pszTemp = '\0';
		}
		strncpy(s_cnc_pstNameList[parenttype][uInd].szName, szName, NAME_SIZE);
		s_cnc_pstNameList[parenttype][uInd].szName[NAME_SIZE - sizeof(char)] = '\0';
		
		uInd++;
	}

	fclose(pFile);
	s_cnc_uNameSize[parenttype] = uInd;

	return 1;
}

void CNC_filterClean(int parenttype)
{
	s_cnc_uMode[parenttype] = 0;
	if (s_cnc_pstNameList[parenttype] != 0) {
		free(s_cnc_pstNameList[parenttype]);
		s_cnc_pstNameList[parenttype] = 0;
		s_cnc_uNameSize[parenttype] = 0;
	}
}

unsigned int CNC_filterCheck(const char* lpszName, int parenttype)
{
	if (s_cnc_pstNameList[parenttype] != 0) {
		unsigned int uInd = 0;
		for (uInd = 0; uInd < s_cnc_uNameSize[parenttype]; uInd++)
		{
			if (strcasestr(lpszName, s_cnc_pstNameList[parenttype][uInd].szName) != NULL) 
			{
				return s_cnc_uMode[parenttype];
			}
		}
	}
	return (!s_cnc_uMode[parenttype]);
}

/*end ͨɫ by l38280   2008-4-8*/
#endif

