
/*****************************************************************************/
/*                Copyright 2004 - 2004, Huawei Tech. Co., Ltd.              */
/*                           ALL RIGHTS RESERVED                             */
/* FileName: vtoptypes.h                                                     */
/* Version: 01a                                                              */
/* Description:  										                     */
/*                                                                           */
/* History:                                                                  */
/* 1. 01a,2004-08-31,y19511 Create this file.                                */
/*****************************************************************************/
/*===========================================================================
Edit History of Huawei: 
time          author      Problem form No.     desc
===========================================================================*/
#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#ifndef __ATP_TYPES_H__
#define __ATP_TYPES_H__

#include "atpconfig.h"

/*ƽ̨*/
#define VTOP_OS_WIN32 1
#define VTOP_OS_LINUX  2
#define VTOP_OS_TYPE VTOP_OS_LINUX

#define VTOP_LIBC_GLIBC 1
#define VTOP_LIBC_UCLIBC 2
/*define VTOP_LIBC_TYPE VTOP_LIBC_GLIBC*/

typedef const char				VOS_CONST_CHAR;
#define VOS_NOK                 1L
#define VTOP_OK                 0L
#define VTOP_NOK                1L


/* if vos.h is not included */
#ifndef  _V_TYPDEF_H

/************************* MACRO & TYPE DEFINITION ***************************/
#define VOS_NULL              (0)
#define VOS_NULL_PTR           (0L)

#define VOS_OK                 (0)
#define VOS_ERROR           (-1)
#define VOS_TRUE               1L 
#define VOS_FALSE              0L

#ifndef  VOS_TYPE
#define  VOS_TYPE          1
typedef void                    VOS_VOID;

typedef unsigned char           VOS_UINT8;
typedef char             VOS_INT8;
typedef char                    VOS_CHAR;

typedef unsigned short          VOS_UINT16;
typedef signed short            VOS_INT16;

typedef unsigned int           VOS_UINT32;
typedef signed int             VOS_INT32;

typedef unsigned int            VOS_UINT;
typedef int                     VOS_INT;
#endif

typedef unsigned int           VOS_BOOL;

typedef float                   VOS_FLOAT;
typedef double                  VOS_DOUBLE;

typedef unsigned int           VOS_SOCKET;

#if VTOP_OS_TYPE == VTOP_OS_LINUX
typedef unsigned long long           VOS_UINT64;
typedef long long             VOS_INT64;
#endif
#endif /* _V_TYPDEF_H */

#define    VTOP_LITTLE_ENDIAN        1234 /* least-significant byte first (vax) */
#define    VTOP_BIG_ENDIAN           4321 /* most-significant byte first (IBM, net) */

#define VTOP_LITTLE_BYTE_ORDER

#ifdef VTOP_LITTLE_BYTE_ORDER
#define    VTOP_BYTE_ORDER          VTOP_LITTLE_ENDIAN  
#endif

#ifdef VTOP_BIG_BYTE_ORDER
#define    VTOP_BYTE_ORDER          VTOP_BIG_ENDIAN  
#endif

/* start of ATP y42304 2008-1-11 ޸: ΪCPUֽͬ */
#if 0  
#ifdef VTOP_BYTE_ORDER
#if	VTOP_BYTE_ORDER==VTOP_BIG_ENDIAN
#define	VTOP_NTOHL(x)	(x)
#define	VTOP_HTONL(x)	(x)
#define	VTOP_NTOHS(x)	(x)
#define	VTOP_HTONS(x)	(x)
#else
#define VTOP_NTOHL(x)	((((x) & 0x000000ff) << 24) | \
			 (((x) & 0x0000ff00) <<  8) | \
			 (((x) & 0x00ff0000) >>  8) | \
			 (((x) & 0xff000000) >> 24))

#define VTOP_HTONL(x)	((((x) & 0x000000ff) << 24) | \
			 (((x) & 0x0000ff00) <<  8) | \
			 (((x) & 0x00ff0000) >>  8) | \
			 (((x) & 0xff000000) >> 24))

#define VTOP_NTOHS(x)	((((x) & 0x00ff) << 8) | \
			 (((x) & 0xff00) >> 8))

#define VTOP_HTONS(x)	((((x) & 0x00ff) << 8) | \
			 (((x) & 0xff00) >> 8))

#endif	/* VTOP_BYTE_ORDER==VTOP_BIG_ENDIAN */

#else
#error "Byte order macro (VTOP_BYTE_ORDER) not defined!"
#endif  /* VTOP_BYTE_ORDER */
#else
#define	VTOP_NTOHL(x)	ntohl((x))
#define	VTOP_HTONL(x)	htonl((x))
#define	VTOP_NTOHS(x)	ntohs((x))
#define	VTOP_HTONS(x)	htons((x))
#endif
/* end of ATP y42304 2008-1-11 ޸:*/

typedef enum tagATP_TEAM_EN
{
    ATP_TEAM_MNT        = 1,
    ATP_TEAM_SYS,
    ATP_TEAM_NTWK,
    ATP_TEAM_VOICE,
    ATP_TEAM_CMS,
} ATP_TEAM_EN;

/* Massege Categories */
typedef enum tagATP_MODULE_CATEGORY_EN
{
    ATP_MODULE_CFM    = 1,
    ATP_MODULE_SYSTEM,

    ATP_MODULE_MSG,
    ATP_MODULE_MIC,
    ATP_MODULE_HTTP,
    ATP_MODULE_CMS,
    ATP_MODULE_CWMP,
    ATP_MODULE_WEB,
    ATP_MODULE_UPNP,
    ATP_MODULE_SNMP,
    ATP_MODULE_OMCI,
} ATP_MODULE_CATEGORY_EN;

#define ATP_MNT_ERR_CODE_DEF(team, module)    (((team) << 30) | (module) << 16)

#ifndef ATP_MSG_LOCAL_HOST
#define ATP_MSG_LOCAL_HOST        ("127.0.0.1")
#endif
#ifndef ATP_MSG_LOCAL_PORT
#define ATP_MSG_LOCAL_PORT        (9267)
#endif

#define ATP_MIC_CBB_NAME        		 "mic"
#define ATP_CWMP_CBB_NAME       		 "cwmp"
#define ATP_WEB_CBB_NAME        		 "web"
#define ATP_TELNETD_CBB_NAME    		 "telnetd"
#define ATP_CLI_CBB_NAME        		 "cli_demo"
#define ATP_CONSOLE_CBB_NAME    		 "mnt_con"
#define ATP_SSHD_CBB_NAME       		 "sshd"
#define ATP_CMS_CBB_NAME        		 "mnt_cms"
#define ATP_HTTP_CBB_NAME       		 "http"
#define ATP_CBBID_WAN_NAME      		 "wan"
#define ATP_CBBID_SEC_NAME	  		 "sec"
#define ATP_CBBID_LAN_NAME      		 "lan"
#define ATP_CBBID_WLAN_NAME      		 "wlan"
#define ATP_CBBID_CALL_NAME     		 "call"
#define ATP_CBBID_UPNP_NAME     		 "upnp"
#define ATP_CBBID_ATS_NAME             "atsrv"
/* <BB5D01787.QMI_PROXY: yangjianping 2009-7-2 ADD BEGIN */
#define ATP_CBBID_QMI_NAME             "qmiserver"
/* BB5D01787.QMI_PROXY: yangjianping 2009-7-2 ADD END> */

#define ATP_CBBID_UPNP_NAME         "upnp"
/*HTTPD*/
#define ATP_CBBID_HTTPD_NAME         "httpd"

#define ATP_CBBID_DHCPC_NAME         "dhcpc"
#define ATP_CBBID_WIFICONNECT_NAME "wificonnect"
#define SELF_REFERENCE(x) ((x)=(x))
#define  CPUFREQ_GOVERNOR  "echo userspace > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor"
#define  LOW_FREQ          "echo 122880 > /sys/devices/system/cpu/cpu0/cpufreq/scaling_setspeed"
#define  MEDIUM_FREQ       "echo 384000 > /sys/devices/system/cpu/cpu0/cpufreq/scaling_setspeed"
#define  HIGH_FREQ         "echo 528000 > /sys/devices/system/cpu/cpu0/cpufreq/scaling_setspeed"
#define CHANGE_ETH_MTU_CMD    "ifconfig eth0 mtu " 
#define CHANGE_USB_MTU_CMD    "ifconfig usb0 mtu "
#define CHANGE_RMENT_MTU_CMD  "ifconfig rmnet0 mtu "
#define ETHERNET_MTU_SIZE      1500
/*usb up/downźŶ壬źʱȴֵСź*/
/* û²żCMS·Ľ/Ͽӵź */
#define SIGDIAL            36
/* û²żCMS·ĶϿӵź */
#define SIGDISCONT         37        //E5832δʹ
/* CMS·DHCPЭIPַɹź */
#define SIGIPUP            38
/* CMS·DHCPЭIPַʧܵź */
#define SIGIPFAIL          39
#define SIGPCDIAL          40 

#define SIG_USB_UP         SIGUSR2    /*USB UP signal*/
#define SIG_USB_DOWN       SIGUSR1    /*USB DOWN signal*/
#define SIG_WAN_DOWN       45
#define SIG_WAN_UP         44
#define SIG_DATA_IN        46
#define SIG_LAN_USB_UP     47      /*USB UP signal*/
#define SIG_LAN_USB_DOWN   48   /*USB DOWN signal*/

#define SIGMODECHANGE      49
#define SIGDEMAND          50
#define SIG_CONN_DISCONNECTIONG SIGMODECHANGE
#define SIGIPRELEASE       51   /* ԭͷIPϿӵź */
#ifdef FEATURE_USB_MANUAL
#define SIGUSBCHANGE       52
#endif
#define POWER_OFF_SIGNAL  53
#define SIG_IS_DIAL_ESTABLISH 54

#define CALL_SMS_PIN_OK SIG_IS_DIAL_ESTABLISH

#define WIFI_RESET        55
#define PAMODECHNGE       56
#define WAN_STATUS_CHANGE 58
#ifdef FEATURE_HUAWEI_OLED
#define SIG_WLAN_AUTH_WEP 57 
#define SIG_WPS_SUC       61
#endif        
#define SIG_DEL_USER      59
#define DIAL_NUM_RESET    60
#define SIG_ROAMING       61 /* ״̬л */
#ifdef FEATURE_FLUX_COLLECT
#define POWER_OFF_FLUX_SIGNAL  62 //ػź
#define FIRST_TIME_FLUX_SIGNAL 63 //ȡʱź
#define REBOOT_FLUX_SIGNAL     64 //ź
#define CLEAR_FLUX_SIGNAL      SIG_DATA_IN //ȫͳƵ,źѴﵽ󣬽SIG_DATA_INźŸ
#endif
#define SIG_PIN_READY          SIGUSR1 
#ifdef SUPPORT_UNIT_TEST
#define ATP_STATIC
#else
#define ATP_STATIC              static
#endif

#define ATP_SOCK_INVALID_FD     (-1)
#define ATP_PID_INVALID_NUM     (-1)

#endif /* __VTOP_TYPES_H__ */

#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cpluscplus */
#endif /* __cpluscplus */

