################################################################################
# Copyright (c) 2008 QUALCOMM Incorporated.
# All Rights Reserved. QUALCOMM Proprietary and Confidential.
################################################################################
vpath %.S $(SRCDIR)

CPPFLAGS += -D__packed__=
CPPFLAGS += -DIMAGE_APPS_PROC
CPPFLAGS += -DFEATURE_Q_SINGLE_LINK
CPPFLAGS += -DFEATURE_Q_NO_SELF_QPTR
CPPFLAGS += -DFEATURE_NATIVELINUX
CPPFLAGS += -DFEATURE_DSM_DUP_ITEMS
CPPFLAGS += -D$(TARGET_TYPE)
CPPFLAGS += -Werror
CPPFLAGS += -I$(KERNEL_DIR)/include
CPPFLAGS += -I$(KERNEL_OBJDIR)/include
CPPFLAGS += -I$(KERNEL_OBJDIR)/include2
CPPFLAGS += -D__ASSEMBLY__
CPPFLAGS += -c
CPPFLAGS += -DPHYS_OFFSET=$(BOOTWEDGE_PADDR)
CPPFLAGS += -c

CPPFLAGS += -I$(SRCDIR)
CPPFLAGS += -I$(OBJDIR) -DFEATURE_E5832

all: wedge

wedge: wedge-$(BOOTWEDGE_PADDR).o wedge-$(BOOTWEDGE_PADDR).lds
	$(LD) --no-undefined -X -T wedge-$(BOOTWEDGE_PADDR).lds -o wedge $<

wedge-$(BOOTWEDGE_PADDR).o: wedge.o
	cp $< $@

wedge-$(BOOTWEDGE_PADDR).lds: $(SRCDIR)/bootwedge.mk
	@echo "OUTPUT_ARCH(arm)" > $@
	@echo "ENTRY(_start)" >> $@
	@echo "SECTIONS" >> $@
	@echo "{" >> $@
	@echo "  . = $(BOOTWEDGE_PADDR);" >> $@
	@echo "  .text : {" >> $@
	@echo "   _stext = .;" >> $@
	@echo "   *(.start)" >> $@
	@echo "   *(.text)" >> $@
	@echo "   _etext = .;" >> $@
	@echo "  }" >> $@
	@echo "}" >> $@

wedge.o: wedge.S wedge.h
	$(CC) $(CPPFLAGS) -o wedge.o $<

wedge.h: wedge-$(TARGET).h
	cp $< $@

# INITRD_SIZE changes per build
.PHONY: wedge-$(TARGET).h
wedge-$(TARGET).h: $(SRCDIR)/wedge-$(TARGET)-$(subst FFA,ffa,$(subst SURF,surf,$(subst T_,,$(TARGET_TYPE)))).h
	rm -f $@
	cp $< $@
	chmod 644 $@
	echo "#define RD_SIZE $(INITRD_SIZE)" >> $@

.PHONY: clean
clean:
	rm -f wedge wedge*.o wedge*.lds wedge.h

