/* boot/wedge/wedge.S
 *
 * Copyright (c) 2008 QUALCOMM Incorporated.
 * All Rights Reserved.  QUALCOMM Proprietary and Confidential.
 */

#define ATAG_CORE		0x54410001
#define ATAG_MEM		0x54410002
#define ATAG_INITRD2		0x54420005
#define ATAG_CMDLINE		0x54410009

#include <asm/mach-types.h>
#include "wedge.h"
#include "cmdline.h"

		.section .start, #alloc, #execinstr
		.type	_start, #function
		.globl	_start

_start:		mov 	r0, #0
		ldr	r1, =MSM_MACHTYPE
#ifdef PLATFORM_HAS_TAGS
		adr	r2, data
#endif
		ldr	pc, =(PHYS_OFFSET + 0x8000)

		.size	_start, . - _start

#ifdef PLATFORM_HAS_TAGS
		.type	data, #object
data:

		.word	0x00000005	@ ATAG_CORE size
		.word	ATAG_CORE
		.word	ATAG_CORE_FLAGS	@ flags
		.word	PAGE_SIZE	@ page size
		.word	ATAG_CORE_RDEV 	@ root dev
		.word	0x00000004	@ ATAG_MEM size
		.word	ATAG_MEM
		.word	EBI1_SIZE
		.word	EBI1_START
		.word	0x00000004	@ ATAG_INITRD2 size
		.word	ATAG_INITRD2
		.word	RD_START
		.word	RD_SIZE
		.word	0x00000102	@ ATAG_CMDLINE size (max 1K bytes -- i.e. 256 words)
		.word	ATAG_CMDLINE
		.asciz	CMDLINE
		.word	0		@ ATAG_NONE
		.rept	256
		.word	0		@ padding so we will see the required zeros
					@ for ATAG_NONE no matter what command line is supplied.
		.endr
		.size	data, . - data
#endif
