/* arch/arm/mach-msm/rpc_server_handset.c
 *
 * Copyright (c) 2008 QUALCOMM USA, INC.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can find it at http://www.fsf.org.
 */
/***********************************************************************
    ޸ʷ¼б:
    <  >    <޸ʱ>  <汾>  <޸>
    ע:
 ************************************************************************/
/*===========================================================================
Edit History of Huawei: 
time          author      Problem form No.     desc
===========================================================================*/

#include <linux/module.h>
#include <linux/kernel.h>

#include <asm/arch/msm_handset.h>
#include <asm/arch/msm_rpcrouter.h>
#include <asm/arch/board.h>

#ifdef FEATURE_E5832
#include <linux/netlink.h>
#include <asm/arch/mpp.h>
#include <linux/delay.h>

#define  HS_FORCE_SLEEP_K  0xC4
extern int sleep_app_knl_set(void *data, u64 val);
extern int vote_for_sleep(int, int);
#endif

#define HS_SERVER_PROG 0x30000062
#define HS_SERVER_VERS 0x00010001

#define RPC_KEYPAD_NULL_PROC 0
#define RPC_KEYPAD_PASS_KEY_CODE_PROC 2
#define RPC_KEYPAD_SET_PWR_KEY_STATE_PROC 3
#ifdef FEATURE_HUAWEI_OLED
#define RPC_UI_DISPLAY_INDICATION_PROC   (4)
#endif
#define HS_PWR_K		0x6F	/* Power key */
#define HS_END_K		0x51	/* End key or Power key */
#define HS_STEREO_HEADSET_K	0x82
#define HS_REL_K		0xFF	/* key release */
#ifdef FEATURE_E5832
#define  HS_WIFI_K 0xC0
#define  HS_WPS_K  0xC1
#define  HS_DIAL_K 0xC2
#define  HS_WAKE_K 0xC3
#ifdef FEATURE_HUAWEI_D25HW
#define  HS_DIALMODE_K  0xC5
#endif
#define  HS_RESTORE_FTM_K  0xC6
#ifdef FEATURE_FLUX_COLLECT
#define  HS_POWOFF_K  0xC7
#endif
#endif
#ifdef HUAWEI_FEATURE_SDUPDATE
#define HS_SDUPDATE_K 0xC8
#endif /*#ifdef HUAWEI_FEATURE_SDUPDATE*/
#ifdef FEATURE_WIFI_INTERRUPT
#define WLAN_WAKE     0xC9
typedef int (*wlan_callback)(void);
extern unsigned int get_ip_packet_total(void);
extern wlan_callback wlan_resume_func;
unsigned int g_packet_total = 0;
/*start a timer, enable msm to sleep
  in the timerout function*/
struct timer_list g_wlan_wow_timer;
#define WLAN_HOLD_TIME 30
static void wlan_wow_timer_out_func(unsigned long data)
{
  if(g_packet_total != get_ip_packet_total())
  {
     g_packet_total = get_ip_packet_total();
     mod_timer(&g_wlan_wow_timer, jiffies + WLAN_HOLD_TIME*HZ);
  }
  else
  {
     /*no data,enable to sleep*/
    vote_for_sleep(USER_WLAN_SIG_BIT_17, 0);
    del_timer(&g_wlan_wow_timer);
  }
}
static void wlan_wow_resume_timer_start(void)
{
    memset(&g_wlan_wow_timer, 0, sizeof(struct timer_list));//lint !e522
    init_timer(&g_wlan_wow_timer);
    g_wlan_wow_timer.data = (unsigned long)0;
    g_wlan_wow_timer.function = wlan_wow_timer_out_func;
    g_wlan_wow_timer.expires = jiffies + WLAN_HOLD_TIME*HZ;
    add_timer(&g_wlan_wow_timer);
    g_packet_total = get_ip_packet_total();
}
#endif

#define KEY(hs_key, input_key) ((hs_key << 24) | input_key)
static const uint32_t hs_key_map[] = {
	KEY(HS_PWR_K, KEY_POWER),
	KEY(HS_END_K, KEY_END),
	KEY(HS_STEREO_HEADSET_K, SW_HEADPHONE_INSERT),
	0
};

static struct input_dev *kpdev;
static struct input_dev *hsdev;
#ifndef FEATURE_E5832
static int hs_find_key(uint32_t hscode)
{
	int i, key;

	key = KEY(hscode, 0);

	for (i = 0; hs_key_map[i] != 0; i++) {
		if ((hs_key_map[i] & 0xff000000) == key)
			return hs_key_map[i] & 0x00ffffff;
	}
	return -1;
}
static void report_hs_key(uint32_t key_code, uint32_t key_parm)
{
	int key;

	if (key_code == HS_REL_K)
		key = hs_find_key(key_parm);
	else
		key = hs_find_key(key_code);

	switch (key) {
	case KEY_POWER:
	case KEY_END:
		if (!kpdev) {
			printk(KERN_ERR "%s: No input device for reporting "
					"pwr/end key press\n", __func__);
			return;
		}
		input_report_key(kpdev, key, (key_code != HS_REL_K));
		break;
	case SW_HEADPHONE_INSERT:
		if (!hsdev) {
			printk(KERN_ERR "%s: No input device for reporting "
					"handset events\n", __func__);
			return;
		}
		input_report_switch(hsdev, key, (key_code != HS_REL_K));
		break;
	case -1:
		printk(KERN_ERR "%s: No mapping for remote handset event %d\n",
				 __func__, key_code);
		break;
	default:
		printk(KERN_ERR "%s: Unhandled handset key %d\n", __func__,
				key);
	}
}
#endif
#ifdef FEATURE_HUAWEI_OLED
struct ui_display_info_t
{
    int cmd;
    char info[12];
};
#endif
static int handle_hs_rpc_call(struct msm_rpc_server *server,
			   struct rpc_request_hdr *req, unsigned len)
{
#ifdef FEATURE_E5832
    char WPS_str[] = "WPS_GPIO";
	char WIFI_str[] = "WLAN_GPIO";
	char DIAL_str[] = "DIAL_GPIO";
	char WAKE_str[] = "HS_WAKE";
#ifdef FEATURE_HUAWEI_D25HW
    char DIALMODE_str[] = "DIALMODE_GPIO";
#endif
    char RESTORE_str[] = "RESTORE_GPIO";

	char FORCE_SLEEP_str[] = "SLEEP_GPIO";
    unsigned config = 0;
    struct mpp *p_mpp = NULL;
#ifdef FEATURE_FLUX_COLLECT
   	char POWER_OFF_str[] = "POWOFF_GPIO";
#endif
#endif

#ifdef HUAWEI_FEATURE_SDUPDATE
   	char SD_UPDATE_str[] = "SDUPDATE_GPIO";
#endif /*#ifdef HUAWEI_FEATURE_SDUPDATE*/
	struct rpc_keypad_pass_key_code_args {
		uint32_t key_code;
		uint32_t key_parm;
	};

	kpdev = msm_keypad_get_input_dev();
	hsdev = msm_get_handset_input_dev();

	switch (req->procedure) {
	case RPC_KEYPAD_NULL_PROC:
		return 0;

	case RPC_KEYPAD_PASS_KEY_CODE_PROC: {
		struct rpc_keypad_pass_key_code_args *args;

		args = (struct rpc_keypad_pass_key_code_args *)(req + 1);
		args->key_code = be32_to_cpu(args->key_code);
		args->key_parm = be32_to_cpu(args->key_parm);
#ifdef FEATURE_E5832
		switch(args->key_code)
		{
                case  HS_WIFI_K:
         		syswatch_nl_send_nodelay(WIFI_str, GPIO_TRIGGER);
            vote_for_sleep(USER_WLAN_SIG_BIT_17, 1);
         		break;
                case  HS_WPS_K:
         		syswatch_nl_send_nodelay(WPS_str, GPIO_TRIGGER);
            vote_for_sleep(USER_WLAN_SIG_BIT_17, 1);
         		break;
                case  HS_DIAL_K:
         		syswatch_nl_send_nodelay(DIAL_str, GPIO_TRIGGER);
         	vote_for_sleep(USER_CALL_SIG_BIT_19, 1);
         		break;
#ifdef FEATURE_HUAWEI_D25HW
        case  HS_DIALMODE_K:              
        	 syswatch_nl_send_nodelay(DIALMODE_str, GPIO_TRIGGER);
        	 break;
#endif
        case HS_FORCE_SLEEP_K:
            syswatch_nl_send_nodelay(FORCE_SLEEP_str, GPIO_TRIGGER);
            schedule_timeout(2000);
            p_mpp = mpp_get(NULL, "mpp5");
            if (!p_mpp)
            {
                printk(KERN_ALERT "wifi_reset_write, mpp_get failed.\n");
                return -1;
            }

             // for config, the low 16 bits stands for the output logic, such as low, high
             // the corresponding datatype in ARM9 is pm_mpp_dlogic_out_ctrl_type
             // the higher 16 bits stands for pm_mpp_dlogic_lvl_type in ARM9
             config = 1 << 16; // 1 stands for PM_MPP_DLOGIC_LVL_MSMP
             mpp_config_digital_out(p_mpp, config);
             schedule_timeout(1000);
             sleep_app_knl_set(NULL, 0);
             break;
	      case HS_WAKE_K:
			 syswatch_nl_send_nodelay(WAKE_str, GPIO_TRIGGER);
			 break;
#ifdef FEATURE_FLUX_COLLECT
          case HS_POWOFF_K:
             syswatch_nl_send_nodelay(POWER_OFF_str, GPIO_TRIGGER);
             break;
#endif
#ifdef HUAWEI_FEATURE_SDUPDATE
          case HS_SDUPDATE_K:
             syswatch_nl_send_nodelay(SD_UPDATE_str, GPIO_TRIGGER);
             break;
#endif 
	      case HS_RESTORE_FTM_K:
	         syswatch_nl_send(RESTORE_str, GPIO_TRIGGER);
             vote_for_sleep(USER_RESTORE_SIG_BIT_20, 1);
	         break;
#ifdef FEATURE_WIFI_INTERRUPT
        case WLAN_WAKE:
            vote_for_sleep(USER_WLAN_SIG_BIT_17, 1);
            syswatch_nl_send_nodelay(WAKE_str, GPIO_TRIGGER);
            if(NULL != wlan_resume_func)
            {
              wlan_resume_func();
            }
            wlan_wow_resume_timer_start();
            break;
#endif
          default:
             break;
		}
#else
		    report_hs_key(args->key_code, args->key_parm);
#endif

		return 0;
	}

	case RPC_KEYPAD_SET_PWR_KEY_STATE_PROC:
		/* This RPC function must be available for the ARM9
		 * to function properly.  This function is redundant
		 * when RPC_KEYPAD_PASS_KEY_CODE_PROC is handled. So
		 * input_report_key is not needed.
		 */
		return 0;
#ifdef FEATURE_HUAWEI_OLED
  case RPC_UI_DISPLAY_INDICATION_PROC:
  {
      static struct ui_display_info_t ui_cmd ;
      struct ui_display_info_t *p = (struct ui_display_info_t *)(req + 1);
      ui_cmd.cmd = be32_to_cpu(p->cmd);
      syswatch_nl_send_nodelay((char *)&ui_cmd, UI_DISPLAY_INDICATION);
      return 0;
   }
#endif
	default:
		return -ENODEV;
	}
}

static struct msm_rpc_server hs_rpc_server = {
	.prog		= HS_SERVER_PROG,
	.vers		= HS_SERVER_VERS,
	.rpc_call	= handle_hs_rpc_call,
};

static int __init hs_rpc_server_init(void)
{
	return msm_rpc_create_server(&hs_rpc_server);
}
module_init(hs_rpc_server_init);
