/******************************************************************************
  Ȩ  : 2007-2020Ϊ޹˾
      : monitor.c
        : yuyouqing42304
        : 1.0
    : 2009-1-6
        : ں̬û̬ӿڹ
  б  :

  ʷ¼      :
   1.       : 2009-1-6
            : 42304
     ޸   : ɳ

*****************************************************************************/
#include <linux/version.h>
#include <linux/init.h>
#include <linux/fs.h>
#include <linux/interrupt.h>
#include <linux/errno.h>
#include <linux/module.h>
#include <linux/wait.h>
#include <linux/poll.h>
#include <linux/sched.h>
#include <linux/list.h>
#include <linux/timer.h>
#include <linux/file.h>
#include <linux/miscdevice.h>
#include "commondrv.h"


unsigned long g_ulMonitorlMajor = 0; /* 豸*/

static int g_lBhalWakeupMonitor = 0;
static struct file *g_pstBhalMonitorFile = NULL;
static struct task_struct *g_pstBhalMonitorTask = NULL;
static unsigned int (*g_pfbhal_orig_fop_poll)
    (struct file *, struct poll_table_struct *) = NULL;

/*ĿǰǷmonitorFd 0:δ 1:*/
static int g_siSetMonitorFd =0;


/* Prototypes. */
static int monitorOpen( struct inode *inode, struct file *filp );
static int monitorIoctl( struct inode *inode, struct file *flip, unsigned int command, unsigned long arg );
static int monitorRelease(struct inode *inode, struct file *filp);                     
static unsigned int bhalMonitorPollHook(struct file * f, struct poll_table_struct * t);

void __exit bhalCleanup( void );


static struct file_operations monitor_fops =
{
  open:       monitorOpen,
  ioctl:      monitorIoctl,
  release:    monitorRelease,
};

/* MODULE */ 
#if defined(MODULE)
int init_module(void)
{
    return (monitorInit());              
}

void cleanup_module(void)
{
    if (MOD_IN_USE)
        printk("bhal: cleanup_module failed because module is in use\n");
    else
        monitorCleanup();
}
#endif 

static struct miscdevice mic_miscdev =
{
    .minor = MISC_DYNAMIC_MINOR,
    .name = "commondrv",
    .fops = &monitor_fops,
};

static int __init monitorInit( void )
{
    int iRet;
              
 //   iRet = register_chrdev(MONITOR_DRV_MAJOR, "commondrv", &monitor_fops );
    iRet = misc_register(&mic_miscdev);
    if (iRet < 0)
    {
        printk( "MoniterInit(major %d): fail to register device.\n",MONITOR_DRV_MAJOR);
    }
    else 
    {
        printk("MoniterInit entry\n");
        g_ulMonitorlMajor = MONITOR_DRV_MAJOR;
       
    }
    return iRet;
} 


void __exit monitorCleanup( void )
{
	
    if (g_ulMonitorlMajor != -1) 
    {
        unregister_chrdev(g_ulMonitorlMajor, "MonitorIoctl");
    }
} 


static BHAL_IOC_ST* bhalIocalloc(void)
{
    BHAL_IOC_ST *stBhalioc = NULL;
    stBhalioc = (BHAL_IOC_ST*) kmalloc( sizeof(BHAL_IOC_ST) , GFP_KERNEL );
    if (stBhalioc)
    {
        memset(stBhalioc, 0, sizeof(BHAL_IOC_ST));
    }
    return stBhalioc;
}


static void bhalIocfree(BHAL_IOC_ST* bhal_ioc)
{
    if (bhal_ioc)
    {
        kfree(bhal_ioc);
    }	
}


static int monitorOpen( struct inode *inode, struct file *filp )
{
    filp->private_data = bhalIocalloc();

    if (filp->private_data == NULL)
        return -ENOMEM;
            
    return( 0 );
} 


static int monitorRelease(struct inode *inode, struct file *filp)
{
    BHAL_IOC_ST *stBhalioc = filp->private_data;
    
    bhalIocfree(stBhalioc);

    return( 0 );
} 

static int monitorIoctl( struct inode *inode, struct file *flip,
                        unsigned int command, unsigned long arg )
{
    int iRet = -1;
    MONITOR_IOCTL_PARMS_ST stCtrlParms;
    memset(&stCtrlParms, 0, sizeof(MONITOR_IOCTL_PARMS_ST));    
   
    switch(command) 
    {  
        case BHAL_IOCTL_SET_MONITOR_FD:
        {
            g_siSetMonitorFd = 1;
            if (copy_from_user((void*)&stCtrlParms, (void*)arg, sizeof(stCtrlParms)) == 0)
            {
                int fput_needed = 0;

                g_pstBhalMonitorFile = fget_light(stCtrlParms.ulType, &fput_needed);
                if (g_pstBhalMonitorFile) 
                {
                   g_pstBhalMonitorTask = current;
                    g_pfbhal_orig_fop_poll = g_pstBhalMonitorFile->f_op->poll;
                    g_pstBhalMonitorFile->f_op->poll = bhalMonitorPollHook;
                }
                iRet = VOS_OK;
            }
            else
            {
                iRet = VOS_ERROR;
            }
            break;
        }

        case BHAL_IOCTL_WAKEUP_MONITOR_TASK:
        {
            bhalWakeupMonitorTask();
            break;
        }  
     
        default:
        {
            iRet = VOS_ERROR;
            printk("board_ioctl: invalid command %x, cmd %d .\n",command,_IOC_NR(command));
            break;
        }
        
    }/* switch */
    
    stCtrlParms.lResult = iRet;
    __copy_to_user((MONITOR_IOCTL_PARMS_ST*)arg, &stCtrlParms, sizeof(MONITOR_IOCTL_PARMS_ST));

    return iRet;
}

static unsigned int bhalMonitorPollHook( struct file *f, struct poll_table_struct *t)
{

    int iMask = (*g_pfbhal_orig_fop_poll) (f, t);
    if (g_lBhalWakeupMonitor == 1 && g_pstBhalMonitorFile == f )
    {
        /* If g_wakeup_monitor is non-0, the user mode application needs to
         * return from a blocking select function.  Return POLLPRI which will
         * cause the select to return with the exception descriptor set.
         */
        
        iMask |= POLLPRI;
        g_lBhalWakeupMonitor = 0;
    }

    return( iMask );
}


void bhalWakeupMonitorTask( void )
{
    g_lBhalWakeupMonitor = 1;
    if (g_pstBhalMonitorTask && (g_siSetMonitorFd == 1))
    {
        wake_up_process(g_pstBhalMonitorTask);
    }
}

module_init( monitorInit );
module_exit( monitorRelease );

EXPORT_SYMBOL(bhalWakeupMonitorTask);
