#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/init.h>
#include <linux/device.h>
#include <linux/miscdevice.h>
#include <linux/taskstats_kern.h>

extern int printk_switch_off;

static int switcher_open(struct inode *inode, struct file *file)
{
    return 0;
}

static ssize_t
switcher_write(struct file *file, const char __user *data, size_t len,
                     loff_t *ppos)
{
/*
    char buf[10];
    int ret = 0;


    ret = copy_from_user(buf, data, 10);
    if (ret)
    {
	printk(KERN_ALERT "switcher_write error.\n");
	return ret;
    }
*/
    static int times = 0;

    if (times%2 == 0)
    {
        printk_switch_off = 1;
    }else
    {
	printk_switch_off = 0;
    }

    ++times;
    return len;
}


// forced to read all in one time
static ssize_t
switcher_read(struct file *file, char __user *buf, size_t count,
                         loff_t *ppos)
{
    printk(KERN_ALERT "JUST USED FOR TEST.\n");
    return 0;
}

static const struct file_operations sw_fops =
{
    .owner = THIS_MODULE,
    .open = switcher_open,
    .write = switcher_write,
    .read = switcher_read,
};

static struct miscdevice sw_kern_miscdev =
{
    .minor = MISC_DYNAMIC_MINOR,
    .name = "printk_switcher",
    .fops = &sw_fops,
};

static int __init sw_kern_init(void)
{
    int ret;
    ret = misc_register(&sw_kern_miscdev);
    if (ret)
    {
        printk(KERN_ALERT "syswatch misc_register failed.\n");
        return -1;
    }
    return 0;
}

static void __exit sw_kern_exit(void)
{
    misc_deregister(&sw_kern_miscdev);
}

module_init(sw_kern_init);
module_exit(sw_kern_exit);
