#ifndef AUDIOHW_H
#define AUDIOHW_H

#include "clockinit.h"

/*--------------------------------------------------------------------
* audio (new for Raptor)
*--------------------------------------------------------------------*/
extern void *audioBaseAddress;
#define AUDIO_BASE                     audioBaseAddress
#define AUDIO_BASE_HW                  0xa0700000

#define HWIO_AUDIO_IRQ_ENa_ADDR(a)	(AUDIO_BASE + 0x0000000c + 0x14 * (a))
#define HWIO_AUDIO_IRQ_ENa_ADDR(a)	(AUDIO_BASE + 0x0000000c + 0x14 * (a))
#define HWIO_AUDIO_IRQ_CLEARa_ADDR(a)	(AUDIO_BASE + 0x00000018 + 0x14 * (a))
#define HWIO_AUDIO_DMA_CTLa_ADDR(a)	(AUDIO_BASE + 0x00000034 + 0x30 * (a))
#define HWIO_AUDIO_DMA_BASEa_ADDR(a)	(AUDIO_BASE + 0x00000038 + 0x30 * (a))
#define HWIO_AUDIO_DMA_BUFF_LENa_ADDR(a) (AUDIO_BASE + 0x0000003c + 0x30 * (a))
#define HWIO_AUDIO_DMA_PER_LENa_ADDR(a)  (AUDIO_BASE + 0x00000044 + 0x30 * (a))
#define HWIO_AUDIO_DMA_DEFa_ADDR(a)	(AUDIO_BASE + 0x00000054 + 0x30 * (a))
#define HWIO_AUDIO_WB_CTL_ADDR		(AUDIO_BASE + 00000000)
#define HWIO_AUDIO_I2S_CTL_ADDR	(AUDIO_BASE + 0x00000008)
#define HWIO_AUDIO_PCM_CTL_ADDR	(AUDIO_BASE + 0x00000004)

extern void *audioClockCtlBase;
#define CLK_CTL_BASE                  audioClockCtlBase
#define CLK_CTL_BASE_HW               0xa8600000

#define HWIO_SBI_NS_REG_ADDR          (CLK_CTL_BASE      + 0x00000094)

#define HWIO_SBI_NS_REG_CODEC_SSBI_ROOT_ENA_BMSK                    0x100
#define HWIO_SBI_NS_REG_CODEC_SSBI_CLK_BRANCH_ENA_BMSK              0x40
#define HWIO_ICODEC_RX_NS_REG_ICODEC_RX_CLK_DIV_SHFT                0xe
#define HWIO_ICODEC_RX_NS_REG_ICODEC_2X_RX_CLK_BRANCH_ENA_BMSK      0x1000
#define HWIO_ICODEC_RX_NS_REG_ICODEC_RX_ROOT_ENA_BMSK               0x800
#define HWIO_ICODEC_RX_NS_REG_ICODEC_RX_ROOT_ENA_BMSK               0x800
#define HWIO_ICODEC_RX_NS_REG_ICODEC_RX_CLK_BRANCH_ENA_BMSK         0x200
#define HWIO_ICODEC_RX_NS_REG_MNCNTR_EN_BMSK                        0x100
#define HWIO_ICODEC_RX_NS_REG_MNCNTR_MODE_SHFT                      0x5
#define HWIO_ROW_RESET_ADDR             (CLK_CTL_BASE      + 0x00000218)
#define HWIO_ROW_RESET_ICODEC_RX_BMSK   0x8000
#define HWIO_ICODEC_RX_MD_REG_ADDR      (CLK_CTL_BASE      + 0x00000068)
#define HWIO_ICODEC_RX_NS_REG_ADDR      (CLK_CTL_BASE      + 0x0000006c)


#define SSBI_BASE                           audioSSBIBase
#define SSBI_BASE_HW                        0xa8100000

#define HWIO_CODEC_SSBI_CTL_ADDR            (SSBI_BASE      + 00000000)
#define HWIO_CODEC_SSBI_STATUS_ADDR         (SSBI_BASE      + 0x00000014)
#define HWIO_CODEC_SSBI_CMD_ADDR            (SSBI_BASE      + 0x00000008)

#define HWIO_GPIOSH_INT_STATUS_0_ADDR     HWIO_GPIO1SH1_INT_STATUS_0_ADDR
#define HWIO_GPIOSH_INT_STATUS_1_ADDR     HWIO_GPIO2SH1_INT_STATUS_1_ADDR
#define HWIO_GPIOSH_INT_STATUS_2_ADDR     HWIO_GPIO1SH1_INT_STATUS_2_ADDR
#define HWIO_GPIOSH_INT_STATUS_3_ADDR     HWIO_GPIO1SH1_INT_STATUS_3_ADDR
#define HWIO_GPIOSH_INT_STATUS_4_ADDR     HWIO_GPIO1SH1_INT_STATUS_4_ADDR
#define HWIO_GPIOSH_INT_STATUS_5_ADDR     HWIO_GPIO1SH1_INT_STATUS_5_ADDR
#define HWIO_GPIOSH_INT_STATUS_6_ADDR     HWIO_GPIO1SH1_INT_STATUS_6_ADDR
#define HWIO_GPIOSH_INT_STATUS_7_ADDR     HWIO_GPIO1SH1_INT_STATUS_7_ADDR
#define HWIO_GPIOSH_INT_EN_0_ADDR         HWIO_GPIO1SH1_INT_EN_0_ADDR
#define HWIO_GPIOSH_INT_EN_1_ADDR         HWIO_GPIO2SH1_INT_EN_1_ADDR
#define HWIO_GPIOSH_INT_EN_2_ADDR         HWIO_GPIO1SH1_INT_EN_2_ADDR
#define HWIO_GPIOSH_INT_EN_3_ADDR         HWIO_GPIO1SH1_INT_EN_3_ADDR
#define HWIO_GPIOSH_INT_EN_4_ADDR         HWIO_GPIO1SH1_INT_EN_4_ADDR
#define HWIO_GPIOSH_INT_EN_5_ADDR         HWIO_GPIO1SH1_INT_EN_5_ADDR
#define HWIO_GPIOSH_INT_EN_6_ADDR         HWIO_GPIO1SH1_INT_EN_6_ADDR
#define HWIO_GPIOSH_INT_EN_7_ADDR         HWIO_GPIO1SH1_INT_EN_7_ADDR

#define HWIO_GPIOSH_INT_CLEAR_0_ADDR      HWIO_GPIO1SH1_INT_CLEAR_0_ADDR
#define HWIO_GPIOSH_INT_CLEAR_1_ADDR   	  HWIO_GPIO_INT_CLEAR_1_ADDR
#define HWIO_GPIOSH_INT_CLEAR_2_ADDR      HWIO_GPIO1SH1_INT_CLEAR_2_ADDR
#define HWIO_GPIOSH_INT_CLEAR_3_ADDR      HWIO_GPIO1SH1_INT_CLEAR_3_ADDR
#define HWIO_GPIOSH_INT_CLEAR_4_ADDR      HWIO_GPIO1SH1_INT_CLEAR_4_ADDR
#define HWIO_GPIOSH_INT_CLEAR_5_ADDR      HWIO_GPIO1SH1_INT_CLEAR_5_ADDR
#define HWIO_GPIOSH_INT_CLEAR_6_ADDR      HWIO_GPIO1SH1_INT_CLEAR_6_ADDR
#define HWIO_GPIOSH_INT_CLEAR_7_ADDR      HWIO_GPIO1SH1_INT_CLEAR_7_ADDR

#define HWIO_GPIOSH_INT_POLARITY_0_ADDR   HWIO_GPIO1SH1_INT_POLARITY_0_ADDR
#define HWIO_GPIOSH_INT_POLARITY_1_ADDR   HWIO_GPIO2SH1_INT_POLARITY_1_ADDR
#define HWIO_GPIOSH_INT_POLARITY_2_ADDR   HWIO_GPIO1SH1_INT_POLARITY_2_ADDR
#define HWIO_GPIOSH_INT_POLARITY_3_ADDR   HWIO_GPIO1SH1_INT_POLARITY_3_ADDR
#define HWIO_GPIOSH_INT_POLARITY_4_ADDR   HWIO_GPIO1SH1_INT_POLARITY_4_ADDR
#define HWIO_GPIOSH_INT_POLARITY_5_ADDR   HWIO_GPIO1SH1_INT_POLARITY_5_ADDR
#define HWIO_GPIOSH_INT_POLARITY_6_ADDR   HWIO_GPIO1SH1_INT_POLARITY_6_ADDR
#define HWIO_GPIOSH_INT_POLARITY_7_ADDR   HWIO_GPIO1SH1_INT_POLARITY_7_ADDR

#define HWIO_GPIOSH_INT_DETECT_CTL_0_ADDR HWIO_GPIO1SH1_INT_DETECT_CTL_0_ADDR
#define HWIO_GPIOSH_INT_DETECT_CTL_1_ADDR HWIO_GPIO2SH1_INT_DETECT_CTL_1_ADDR
#define HWIO_GPIOSH_INT_DETECT_CTL_2_ADDR HWIO_GPIO1SH1_INT_DETECT_CTL_2_ADDR
#define HWIO_GPIOSH_INT_DETECT_CTL_3_ADDR HWIO_GPIO1SH1_INT_DETECT_CTL_3_ADDR
#define HWIO_GPIOSH_INT_DETECT_CTL_4_ADDR HWIO_GPIO1SH1_INT_DETECT_CTL_4_ADDR
#define HWIO_GPIOSH_INT_DETECT_CTL_5_ADDR HWIO_GPIO1SH1_INT_DETECT_CTL_5_ADDR
#define HWIO_GPIOSH_INT_DETECT_CTL_6_ADDR HWIO_GPIO1SH1_INT_DETECT_CTL_6_ADDR
#define HWIO_GPIOSH_INT_DETECT_CTL_7_ADDR HWIO_GPIO1SH1_INT_DETECT_CTL_7_ADDR

/*
 * Fix up the VIC register definitions
 */
#define HWIO_VICFIQ_STATUS_0_UART_GROUP_IRQ_BMSK \
		HWIO_VICFIQ_STATUS_1_SPSS_SIRC_IRQ1_BMSK
#define HWIO_VICFIQ_STATUS_0_UART_GROUP_IRQ_SHFT \
		HWIO_VICFIQ_STATUS_1_SPSS_SIRC_IRQ1_SHFT
#define HWIO_VICFIQ_STATUS_1_GPIO_GROUP_BMSK 1
#define HWIO_VICFIQ_STATUS_1_GPIO_GROUP2_BMSK    2
#define HWIO_VICFIQ_STATUS_1_GPIO_GROUP_SHFT    0
#define HWIO_VICFIQ_STATUS_1_GPIO_GROUP2_SHFT    1

#define HWIO_VICVECTADDRn_ADDR(n)   (0xac000400+(4*(n)))

/*
 * MDP Changes
 */
#define HWIO_MDP_FULL_BYPASS_WORD0_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD1_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD2_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD3_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD4_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD5_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD6_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD7_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD8_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD9_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD10_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD11_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD12_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD13_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD14_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD15_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD16_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD17_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD18_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD19_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD20_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD21_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD22_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD23_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD24_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD25_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD26_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD27_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD28_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD29_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD30_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD31_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD32_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD33_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD34_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD35_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD36_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD37_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD38_ADDR 1
#define HWIO_MDP_FULL_BYPASS_WORD39_ADDR 1

/*
 * Virtual address offset from the standard Qualcomm physical address of the
 * data or peripheral.
 */
#define QC_VA_OFFSET 0x50000000
#define QC_VA_OFF    QC_VA_OFFSET

/*
 * Convert a qc physical address to Linux virt
 */
#define QC_VIRT(a)  (((char *)(a))+(QC_VA_OFFSET))

#ifdef TRUE
#undef TRUE
#endif

#ifdef FALSE
#undef FALSE
#endif

#define TRUE   1		/* Boolean true value. */
#define FALSE  0		/* Boolean false value. */

#define  ON   1			/* On value. */
#define  OFF  0			/* Off value. */

#ifndef NULL
#define NULL  0
#endif

/* -----------------------------------------------------------------------
** Standard Types
** ----------------------------------------------------------------------- */

/* The following definitions are the same accross platforms.  This first
** group are the sanctioned types.
*/
typedef unsigned char boolean;	/* Boolean value type. */

typedef unsigned long int uint32;	/* Unsigned 32 bit value */
typedef unsigned short uint16;	/* Unsigned 16 bit value */
typedef unsigned char uint8;	/* Unsigned 8  bit value */

typedef signed long int int32;	/* Signed 32 bit value */
typedef signed short int16;	/* Signed 16 bit value */
typedef signed char int8;	/* Signed 8  bit value */

/* This group are the deprecated types.  Their use should be
** discontinued and new code should use the types above
***** NOTE: the DSP firmware downloader still uses these typedef ******
*/
typedef unsigned char byte;	/* Unsigned 8  bit value type. */
typedef unsigned short word;	/* Unsinged 16 bit value type. */
typedef unsigned long dword;	/* Unsigned 32 bit value type. */

/*===========================================================================

DESCRIPTION
  IN/OUT port macros for byte and word ports, typically inlined by compilers
  which support these routines

PARAMETERS
  inp8(   xx_addr )
  inp16(  xx_addr )
  inp32( xx_addr )
  outp8(   xx_addr, xx_byte_val  )
  outp16(  xx_addr, xx_word_val  )
  outp32( xx_addr, xx_dword_val )
      xx_addr      - Address of port to read or write (may be memory mapped)
      xx_byte_val  - 8 bit value to write
      xx_word_val  - 16 bit value to write
      xx_dword_val - 32 bit value to write

DEPENDENCIES
  None

RETURN VALUE
  inp/inpw/inpdw: the byte, word or dword read from the given address
  outp/outpw/outpdw: the byte, word or dword written to the given address

SIDE EFFECTS
  None.

===========================================================================*/

  /* ARM based targets use memory mapped i/o, so the inp/outp calls are
   ** macroized to access memory directly
   *
   * KAS chaged these from QC to support the offset and use the standard
   * linux way...
   */

#define outp32(addr, val) writel(val, ((addr)+QC_VA_OFF))
#define outp16(addr, val) writew(val, ((addr)+QC_VA_OFF))
#define outp8(addr, val) writeb(val, ((addr)+QC_VA_OFF))
#define outp(addr, val) outp32(addr, val)

#define inp32(addr) readl((addr)+QC_VA_OFF)
#define inp16(addr) readw((addr)+QC_VA_OFF)
#define inp8(addr) readb((addr)+QC_VA_OFF)
#define inp(addr) inp32(addr)
/*===========================================================================

MACRO MEM_B
MACRO MEM_W

DESCRIPTION
  Take an address and dereference it as a uint8/uint16, allowing access to an
  arbitrary memory uint8/uint16.

PARAMETERS
  x     address to be dereferenced

DEPENDENCIES
  None

RETURN VALUE
  MEM_B uint8 at the given address
  MEM_W uint16 at the given address

SIDE EFFECTS
  None

===========================================================================*/

#define  MEM_B(x)  (*((uint8 *)(x)))
#define  MEM_W(x)  (*((uint16 *)(x)))
/*===========================================================================

MACRO MAX
MACRO MIN

DESCRIPTION
  Evaluate the maximum/minimum of 2 specified arguments.

PARAMETERS
  x     parameter to compare to 'y'
  y     parameter to compare to 'x'

DEPENDENCIES
  'x' and 'y' are referenced multiple times, and should remain the same
  value each time they are evaluated.

RETURN VALUE
  MAX   greater of 'x' and 'y'
  MIN   lesser of 'x' and 'y'

SIDE EFFECTS
  None

===========================================================================*/
#ifndef MAX
#define  MAX(x, y) (((x) > (y)) ? (x):(y))
#endif

#ifndef MIN
#define  MIN(x, y) (((x) < (y)) ? (x):(y))
#endif

/*===========================================================================

MACRO WORD_LO
MACRO WORD_HI

DESCRIPTION
  Take a 16-bit word and extract the least-significant or most-significant byte.

PARAMETERS
  xxx   word to extract the Low/High from

DEPENDENCIES
  None

RETURN VALUE
  WORD_LO       Least significant byte of xxx.
  WORD_HI       Most significant byte of xxx.

SIDE EFFECTS
  None

===========================================================================*/

#define  WORD_LO(xxx)  ((uint8) ((uint16)(xxx) & 255))
#define  WORD_HI(xxx) \
  /*lint -e572 */  ((uint8) ((uint16)(xxx) >> 8))	/*lint +e572 */
/*===========================================================================

MACRO RND8

DESCRIPTION
  RND8 rounds a number up to the nearest multiple of 8.

PARAMETERS
  x     Number to be rounded up

DEPENDENCIES
  None

RETURN VALUE
  x rounded up to the nearest multiple of 8.

SIDE EFFECTS
 None

===========================================================================*/

#define RND8(x)        ((((x) + 7) / 8) * 8)

/* -------------------------------------------------------------------------
**                       Debug Declarations
** ------------------------------------------------------------------------- */

/* Define 'SHOW_STAT' in order to view static's as globals
** (e.g. cl /DSHOW_STAT foo.c) If 'SHOW_STAT' is not defined,
** it gets defined as 'static'
*/
#ifdef LOCAL
#undef LOCAL
#endif

#ifdef SHOW_STAT
#define LOCAL
#else
#define LOCAL static
#endif

#endif

