
#ifndef __CLOCKINIT__H__
#define __CLOCKINIT__H__

/*
 * Some of the systems perform the clock initialzations before the OS is up so
 * The OS does not need to do them, so, setting do_clock_init to non 0 will make
 * the OS perform clock initialztions.
 */
#ifndef __ASSEMBLY__
extern int do_clock_init;
#define CLOCK_INIT(a) \
		do { \
		if (do_clock_init) \
			a; \
			} while (0)

#endif

#endif
