/***********************************************************************
  ȨϢ: Ȩ(C) 2009-2010, Ϊ޹˾.
  ļ: qmi.c
  : Mobile@huawei.com
  汾: 001
  : 2009-7-01
  : 2009-7-01
  :
  Ҫб:

  ޸ʷ¼б:
   <ⵥ> <  >    <޸ʱ>  <汾>  <޸>
  ע:
 ************************************************************************/

#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/init.h>
#include <linux/list.h>
#include <linux/proc_fs.h>
#include <linux/netdevice.h>

#include <asm/io.h>
#include <asm/byteorder.h>
#include <asm/system.h>
#include <asm/unaligned.h>


#undef	RNDIS_PM
#undef	RNDIS_WAKEUP
#undef	VERBOSE

#include "qmux.h"
#include "qmitty.h"
#include <linux/netlink.h>

#define rndis_debug		0

#define DBG(str,args...) do { \
	if (rndis_debug) \
		pr_debug(str , ## args); \
	} while (0)

#define RNDIS_MAX_CONFIGS	1

/*---------------------------------------------------------------------------
  QMI header constants
  - QMI control flags differ from standard qmux service since QMI CTL 
    doesn't support compound messages.
---------------------------------------------------------------------------*/
#define QMI_CTL_FLAG_MASK_MSGTYPE  (0x03) 

/*----------------------------------------------------------------------
        qmi function 
--------------------------------------------------------------------*/
 u16 qmi_pushdown_package(void * val, u16 len);
 static void *  qmi_dmsi_get_next_client_sp
(
  void *  svc_sp,
  void *  cl_sp
);
static void     qmi_dmsi_reset_client(void * cl_sp_in);
static void *  qmi_wdsi_get_next_client_sp
(
  void *  sp,
  void *  cl_sp
);
static void qmi_wdsi_reset_client(  void * cl_sp_in);
u16 qmi_pullup_package(u8 **pkt, u8 *value, u16 len);
static void * qmux_reg_service
(
  qmi_instance_e_type     qmi_instance,
  qmux_service_e_type     service,
  qmux_svc_config_type_t *  cfg
);
void qmux_init(void);
bool  qmi_svc_dealloc_clid
(
  qmi_common_svc_state_type *  svc_sp,
  u8   clid
);

/*note: this "a" must be a u8 type point;*/
#define qmi_pull8(a_u8) (*a_u8++)
#define qmi_pull16(a_u8) \
    ({u16 __b; __b =*a_u8++; __b += ((*a_u8++)<<8);__b;})

#define qmi_pullup(pkt,value,len) qmi_pullup_package(pkt,value,len)
#define qmi_pullup_length(pkt,len) (pkt+=len)
#define qmi_swap16(a_u16) (((a_u16&0xFF00)>>8) + ((a_u16&0x00FF)<<8))

#define QMI_PKT_MAX_SIZE 1024*4
static bool usb_configure_suspended = false; 

static u8 QMI_POOL[QMI_PKT_MAX_SIZE]={0};

static qmi_item_pool QMI_ITEM_POOL;

typedef struct {
    qmux_service_e_type srv_type;
    qmux_svc_config_type_t srv_cfg;
}qmi_services_cfg;

static rndis_params qmi_per_dev_params [RNDIS_MAX_CONFIGS];

/*---------------------------------------------------------------------------
  QMI_CTL instance state structure
---------------------------------------------------------------------------*/
static qmi_ctli_state_type  qmi_ctl_state[QMI_INSTANCE_MAX] = {{0},};
static qmux_state_type  qmux_state[QMI_INSTANCE_MAX] = {{{{0},},},};
static qmi_dmsi_state_type  qmi_dms_state[QMI_INSTANCE_MAX] = {{{0},},};
/*---------------------------------------------------------------------------
  Each QMI link (usb, BT etc) has its own WDS state
---------------------------------------------------------------------------*/
static qmi_wdsi_state_type_t qmi_wds_state[QMI_INSTANCE_MAX] = {{{0},},};


/* Max length of the manufacturer name string cannot exceed 65535 bytes    */
#define QMI_DEVICE_MFR_STR  "HUAWEI INCORPORATED"
#define QMI_DEVICE_MOB_STR "E5832"
#define QMI_DEVICE_MODEL_STR "HUAWEI FMC"
char * qmi_device_mfr_str = QMI_DEVICE_MFR_STR;
char * qmi_device_mob_str = QMI_DEVICE_MOB_STR;
char * qmi_device_model_str = QMI_DEVICE_MODEL_STR;

static qmux_svc_config_type_t  qmi_ctl_cfg[QMI_INSTANCE_MAX] =
{
  { { QMI_CTL_BASE_VER_MAJOR, QMI_CTL_BASE_VER_MINOR },
    { QMI_CTL_ADDENDUM_VER_MAJOR, QMI_CTL_ADDENDUM_VER_MINOR },
    { NULL,
      NULL,//qmi_ctli_is_valid_client_id,  
      NULL,
      NULL,//qmi_ctli_qmi_link_closed_cb,
      NULL,
      NULL,
      NULL },
    //NULL,
    0,
   &qmi_ctl_state[0]
  }  
 ,{ { QMI_CTL_BASE_VER_MAJOR, QMI_CTL_BASE_VER_MINOR },
    { QMI_CTL_ADDENDUM_VER_MAJOR, QMI_CTL_ADDENDUM_VER_MINOR },
    { NULL,
      NULL,//qmi_ctli_is_valid_client_id,  
      NULL,
      NULL,//qmi_ctli_qmi_link_closed_cb,
      NULL,
      NULL,
      NULL },
    //NULL,
    0,
    &qmi_ctl_state[1]
  }
  ,{ { QMI_CTL_BASE_VER_MAJOR, QMI_CTL_BASE_VER_MINOR },
     { QMI_CTL_ADDENDUM_VER_MAJOR, QMI_CTL_ADDENDUM_VER_MINOR },
    { NULL,
      NULL,//qmi_ctli_is_valid_client_id,  
      NULL,
      NULL,//qmi_ctli_qmi_link_closed_cb,
      NULL,
      NULL,
      NULL },
    //NULL,
    0,
    &qmi_ctl_state[2]
  }
};

static qmux_svc_config_type_t  qmi_dmsi_cfg[QMI_INSTANCE_MAX] =
{
  { { DMSI_BASE_VER_MAJOR, DMSI_BASE_VER_MINOR},
    { DMSI_ADDENDUM_VER_MAJOR, DMSI_ADDENDUM_VER_MINOR},
    { NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      qmi_dmsi_get_next_client_sp,
      qmi_dmsi_reset_client},//qmi_dmsi_reset_client 
      //qmi_dmsi_cmd_callbacks, 
      DMSI_CMD_MAX,
      &qmi_dms_state[0],   
  },
  { { DMSI_BASE_VER_MAJOR, DMSI_BASE_VER_MINOR },
     { DMSI_ADDENDUM_VER_MAJOR, DMSI_ADDENDUM_VER_MINOR },  
    { NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      qmi_dmsi_get_next_client_sp,
      qmi_dmsi_reset_client},//qmi_dmsi_reset_client 
      //qmi_dmsi_cmd_callbacks, 
      DMSI_CMD_MAX,
      &qmi_dms_state[1],   
  },
  { { DMSI_BASE_VER_MAJOR, DMSI_BASE_VER_MINOR },
     { DMSI_ADDENDUM_VER_MAJOR, DMSI_ADDENDUM_VER_MINOR },
    { NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      qmi_dmsi_get_next_client_sp,
      qmi_dmsi_reset_client},//qmi_dmsi_reset_client 
      //qmi_dmsi_cmd_callbacks, 
      DMSI_CMD_MAX,
      &qmi_dms_state[2],  
  }
};

static qmux_svc_config_type_t  qmi_wdsi_cfg[QMI_INSTANCE_MAX] =
{
  { { WDSI_BASE_VER_MAJOR, WDSI_BASE_VER_MINOR },
    { WDSI_ADDENDUM_VER_MAJOR, WDSI_ADDENDUM_VER_MINOR },
    { NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      qmi_wdsi_get_next_client_sp,
      qmi_wdsi_reset_client },
      //qmi_wdsi_cmd_callbacks,
      WDSI_CMD_MAX,
      &qmi_wds_state[0]
  }
  ,{ { WDSI_BASE_VER_MAJOR, WDSI_BASE_VER_MINOR },
     { WDSI_ADDENDUM_VER_MAJOR, WDSI_ADDENDUM_VER_MINOR },
    { NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      qmi_wdsi_get_next_client_sp,
      qmi_wdsi_reset_client },
      //qmi_wdsi_cmd_callbacks,
      WDSI_CMD_MAX,
      &qmi_wds_state[1]
  }
  ,{ { WDSI_BASE_VER_MAJOR, WDSI_BASE_VER_MINOR },
     { WDSI_ADDENDUM_VER_MAJOR, WDSI_ADDENDUM_VER_MINOR },
    { NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      qmi_wdsi_get_next_client_sp,
      qmi_wdsi_reset_client },
      //qmi_wdsi_cmd_callbacks,
      WDSI_CMD_MAX,
      &qmi_wds_state[2]
  }
};

#define QMI_MIN(a,b) (((a)<(b))? (a):(b))
#define QMI_SRV_MASK (0x03<<1)
#define QMI_SRV_REQUEST 0x00
#define QMI_SRV_RESPONSE (0x01<<1)
#define QMI_SRV_INDICAION (0x10<<1)
#define QMI_SRV_RESERVE (0x11<<1)

#define QMI_SVC_PKT_PUSH_T(val,len) (len == qmi_pushdown_package(val,len))
u8 qmi_vs_services_min;
u8 qmi_vs_services_max;

#define QMI_IF_GET_RMNET_INSTANCE(qmi_instance)           \
          (rmnet_instance_e_type) qmi_instance


int qmi_register (int (* qmi_control_ack) (struct net_device *))
{
	u8 i;

	for (i = 0; i < RNDIS_MAX_CONFIGS; i++) {
		if (!qmi_per_dev_params [i].used) {
			qmi_per_dev_params [i].used = 1;
			qmi_per_dev_params [i].ack = qmi_control_ack;
			DBG("%s: configNr = %d\n", __FUNCTION__, i);
			return i;
		}
	}
	DBG("failed\n");

	return -1;
}

void qmi_deregister (int configNr)
{
	DBG("%s: \n", __FUNCTION__ );

	if (configNr >= RNDIS_MAX_CONFIGS) return;
	qmi_per_dev_params [configNr].used = 0;

	return;
}

void qmi_exit (void)
{
#ifdef	CONFIG_USB_GADGET_DEBUG_FILES
	u8 i;
	char name [20];

	for (i = 0; i < RNDIS_MAX_CONFIGS; i++) {
		sprintf (name, NAME_TEMPLATE, i);
		remove_proc_entry (name, NULL);
	}
#endif
}

int qmi_rm_hdr(struct sk_buff *skb)
{
	/* tmp points to a struct rndis_packet_msg_type */
	__le32		*tmp = (void *) skb->data;

	/* MessageType, MessageLength */
	if (__constant_cpu_to_le32(REMOTE_NDIS_PACKET_MSG)
			!= get_unaligned(tmp++))
		return -EINVAL;
	tmp++;

	/* DataOffset, DataLength */
	if (!skb_pull(skb, le32_to_cpu(get_unaligned(tmp++))
			+ 8 /* offset of DataOffset */))
		return -EOVERFLOW;
	skb_trim(skb, le32_to_cpu(get_unaligned(tmp++)));

	return 0;
}

int qmi_set_param_medium (u8 configNr, u32 medium, u32 speed)
{
	DBG("%s: %u %u\n", __FUNCTION__, medium, speed);
	if (configNr >= RNDIS_MAX_CONFIGS) return -1;

	qmi_per_dev_params [configNr].medium = medium;
	qmi_per_dev_params [configNr].speed = speed;

	return 0;
}

void qmi_add_hdr (struct sk_buff *skb)
{
	struct rndis_packet_msg_type	*header;

	if (!skb)
		return;
	header = (void *) skb_push (skb, sizeof *header);
	memset (header, 0, sizeof *header);
	header->MessageType = __constant_cpu_to_le32(REMOTE_NDIS_PACKET_MSG);
	header->MessageLength = cpu_to_le32(skb->len);
	header->DataOffset = __constant_cpu_to_le32 (36);
	header->DataLength = cpu_to_le32(skb->len - sizeof *header);
}
void qmi_set_host_mac (int configNr, const u8 *addr)
{
	qmi_per_dev_params [configNr].host_mac = addr;
}

int qmi_set_param_dev (u8 configNr, struct net_device *dev,
			 struct net_device_stats *stats,
			 u16 *cdc_filter)
{
	DBG("%s:\n", __FUNCTION__ );
	if (!dev || !stats) return -1;
	if (configNr >= RNDIS_MAX_CONFIGS) return -1;

	qmi_per_dev_params [configNr].dev = dev;
	qmi_per_dev_params [configNr].stats = stats;
	qmi_per_dev_params [configNr].filter = cdc_filter;

	return 0;
}

int qmi_set_param_vendor (u8 configNr, u32 vendorID, const char *vendorDescr)
{
	DBG("%s:\n", __FUNCTION__ );
	if (!vendorDescr) return -1;
	if (configNr >= RNDIS_MAX_CONFIGS) return -1;

	qmi_per_dev_params [configNr].vendorID = vendorID;
	qmi_per_dev_params [configNr].vendorDescr = vendorDescr;

	return 0;
}


u8 *qmi_get_next_response (int configNr, u32 *length)
{
	rndis_resp_t		*r;
	struct list_head	*act, *tmp;

	if (!length) return NULL;

	list_for_each_safe (act, tmp,
			&(qmi_per_dev_params [configNr].resp_queue))
	{
		r = list_entry (act, rndis_resp_t, list);
		if (!r->send) {
			r->send = 1;
			*length = r->length;
			return r->buf;
		}
	}

	return NULL;
}

void qmi_free_response (int configNr, u8 *buf)
{
	rndis_resp_t		*r;
	struct list_head	*act, *tmp;

	list_for_each_safe (act, tmp,
			&(qmi_per_dev_params [configNr].resp_queue))
	{
		r = list_entry (act, rndis_resp_t, list);
		if (r && r->buf == buf) {
			list_del (&r->list);
			kfree (r);
		}
	}
}

static rndis_resp_t *qmi_add_response (int configNr, u32 length)
{
	rndis_resp_t	*r;

	/* NOTE:  this gets copied into ether.c USB_BUFSIZ bytes ... */
	r = kmalloc (sizeof (rndis_resp_t) + length, GFP_ATOMIC);
	if (!r) return NULL;

	r->buf = (u8 *) (r + 1);
	r->length = length;
	r->send = 0;

	list_add_tail (&r->list,
		&(qmi_per_dev_params [configNr].resp_queue));
	return r;
}

/*------------------------------------------------------------
       : static void qmi_drain_response_queue(int configNr)
       : empty the response list
       : int configNr ǰqmi
       : 
  ֵ   : 
-------------------------------------------------------------*/
static void qmi_drain_response_queue(int configNr)
{
	u8 *buf = NULL;
	u32 length = 0;
	
	printk(KERN_INFO "qmi_drain_response_queue\n");
	
	/* drain the response queue */
	while ((buf = qmi_get_next_response(configNr, &length)))
	{
        printk(KERN_INFO "drain the list cycle\n");
		qmi_free_response(configNr, buf);
	}
}

/*------------------------------------------------------------
       : void qmi_resume(int configNr)
       : when usb resume, clear the reponse list and release the used clientID.
       : int configNr ǰqmi
       : 
  ֵ   : 
-------------------------------------------------------------*/
void qmi_resume(int configNr)
{
   int i = 0;
   printk(KERN_INFO "qmi_resume\n");
   
   /* drain the response queue */
   qmi_drain_response_queue(configNr);
   
   printk(KERN_INFO "qmi resume:release qmi client data\n");
   qmi_dms_state[0].common.next_clid = QMI_SVC_CLID_UNUSED + 1;
   qmi_wds_state[0].common.next_clid = QMI_SVC_CLID_UNUSED + 1;

   /*release the client ID */
   for(i = 1; i <= DMSI_MAX_CLIDS; i++)
   {
       qmi_svc_dealloc_clid(&qmi_dms_state[0].common, i);
   }
   for(i = 1;i <= WDSI_MAX_CLIDS; i++)
   {
       qmi_svc_dealloc_clid(&qmi_wds_state[0].common, i);    
   }  
}

void qmi_usb_uninit (int configNr)
{
	u8 *buf;
	u32 length;
	u8 i;

	if (configNr >= RNDIS_MAX_CONFIGS)
		return;
	qmi_per_dev_params [configNr].used = 0;
	qmi_per_dev_params [configNr].state = RNDIS_UNINITIALIZED;

	/* drain the response queue */
	while ((buf = qmi_get_next_response(configNr, &length)))
		qmi_free_response(configNr, buf);
		
  printk(KERN_INFO "release qmi client data");
  qmi_dms_state[0].common.next_clid = QMI_SVC_CLID_UNUSED + 1;
  qmi_wds_state[0].common.next_clid = QMI_SVC_CLID_UNUSED + 1;
  /*release the client ID */
  for(i=1;i<=DMSI_MAX_CLIDS;i++)
  {
    qmi_svc_dealloc_clid(&qmi_dms_state[0].common, i);
  }
  for(i=1;i<=WDSI_MAX_CLIDS;i++)
  {
    qmi_svc_dealloc_clid(&qmi_wds_state[0].common, i);    
  }  

}

/*
 * Device to Host Comunication
 */
static int qmi_indicate_status_msg (int configNr, u32 status)
{
	rndis_indicate_status_msg_type	*resp;
	rndis_resp_t			*r;

	if (qmi_per_dev_params [configNr].state == RNDIS_UNINITIALIZED)
		return -ENOTSUPP;

	r = qmi_add_response (configNr,
				sizeof (rndis_indicate_status_msg_type));
	if (!r)
		return -ENOMEM;
	resp = (rndis_indicate_status_msg_type *) r->buf;

	resp->MessageType = __constant_cpu_to_le32 (
			REMOTE_NDIS_INDICATE_STATUS_MSG);
	resp->MessageLength = __constant_cpu_to_le32 (20);
	resp->Status = cpu_to_le32 (status);
	resp->StatusBufferLength = __constant_cpu_to_le32 (0);
	resp->StatusBufferOffset = __constant_cpu_to_le32 (0);

	if (qmi_per_dev_params [configNr].ack)
		qmi_per_dev_params [configNr].ack (
			qmi_per_dev_params [configNr].dev);
	return 0;
}


int qmi_signal_connect (int configNr)
{
	qmi_per_dev_params [configNr].media_state
			= NDIS_MEDIA_STATE_CONNECTED;
	return qmi_indicate_status_msg (configNr,
					  RNDIS_STATUS_MEDIA_CONNECT);
}

int qmi_signal_disconnect (int configNr)
{
	qmi_per_dev_params [configNr].media_state
			= NDIS_MEDIA_STATE_DISCONNECTED;
	return qmi_indicate_status_msg (configNr,
					  RNDIS_STATUS_MEDIA_DISCONNECT);
}

#ifdef	CONFIG_USB_GADGET_DEBUG_FILES
static int qmi_proc_read (char *page, char **start, off_t off, int count, int *eof,
		void *data)
{
	char *out = page;
	int len;
	rndis_params *param = (rndis_params *) data;

	out += snprintf (out, count,
			 "Config Nr. %d\n"
			 "used      : %s\n"
			 "state     : %s\n"
			 "medium    : 0x%08X\n"
			 "speed     : %d\n"
			 "cable     : %s\n"
			 "vendor ID : 0x%08X\n"
			 "vendor    : %s\n",
			 param->confignr, (param->used) ? "y" : "n",
			 ({ char *s = "?";
			 switch (param->state) {
			 case RNDIS_UNINITIALIZED:
				s = "RNDIS_UNINITIALIZED"; break;
			 case RNDIS_INITIALIZED:
				s = "RNDIS_INITIALIZED"; break;
			 case RNDIS_DATA_INITIALIZED:
				s = "RNDIS_DATA_INITIALIZED"; break;
			}; s; }),
			 param->medium,
			 (param->media_state) ? 0 : param->speed*100,
			 (param->media_state) ? "disconnected" : "connected",
			 param->vendorID, param->vendorDescr);

	len = out - page;
	len -= off;

	if (len < count) {
		*eof = 1;
		if (len <= 0)
			return 0;
	} else
		len = count;

	*start = page + off;
	return len;
}

static int qmi_proc_write (struct file *file, const char __user *buffer,
		unsigned long count, void *data)
{
	rndis_params *p = data;
	u32 speed = 0;
	int i, fl_speed = 0;

	for (i = 0; i < count; i++) {
		char c;
		if (get_user(c, buffer))
			return -EFAULT;
		switch (c) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			fl_speed = 1;
			speed = speed*10 + c - '0';
			break;
		case 'C':
		case 'c':
			qmi_signal_connect (p->confignr);
			break;
		case 'D':
		case 'd':
			qmi_signal_disconnect(p->confignr);
			break;
		default:
			if (fl_speed) p->speed = speed;
			else DBG("%c is not valid\n", c);
			break;
		}

		buffer++;
	}

	return count;
}
#define	NAME_TEMPLATE	"driver/rndis-%03d"

static struct proc_dir_entry *qmi_connect_state [RNDIS_MAX_CONFIGS];

#endif	/* CONFIG_USB_GADGET_DEBUG_FILES */

int qmi_usb_init (void)
{
	u8 i;

	for (i = 0; i < RNDIS_MAX_CONFIGS; i++) {
#ifdef	CONFIG_USB_GADGET_DEBUG_FILES
		char name [20];

		sprintf (name, NAME_TEMPLATE, i);
		if (!(qmi_connect_state [i]
				= create_proc_entry (name, 0660, NULL)))
		{
			DBG("%s :remove entries", __FUNCTION__);
			while (i) {
				sprintf (name, NAME_TEMPLATE, --i);
				remove_proc_entry (name, NULL);
			}
			DBG("\n");
			return -EIO;
		}

		qmi_connect_state [i]->write_proc = qmi_proc_write;
		qmi_connect_state [i]->read_proc = rndis_proc_read;
		qmi_connect_state [i]->data = (void *)
				(qmi_per_dev_params + i);
#endif
		qmi_per_dev_params [i].confignr = i;
		qmi_per_dev_params [i].used = 0;
		qmi_per_dev_params [i].state = RNDIS_UNINITIALIZED;
		qmi_per_dev_params [i].media_state
				= NDIS_MEDIA_STATE_DISCONNECTED;
		INIT_LIST_HEAD (&(qmi_per_dev_params [i].resp_queue));
	}

       /*------------------------------------------------------------
            qmi func init
       -------------------------------------------------------------*/
	return 0;
}

/*===========================================================================
  FUNCTION QMI_INSTANCE_BY_QMUX_HANDLE()

  DESCRIPTION
    To obtain QMI instance from QMUX handle. Qmux handle passed in must 
    ALWAYS be the service handle.

  PARAMETERS
    qmux_handle : QMUX service handle returned to service by qmux_reg_service

  RETURN VALUE
    QMI Instance if qmux_handle is valid
    QMI_INSTANCE_MAX if qmux_handle is invalid

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static qmi_instance_e_type  qmi_instance_by_qmux_handle
(
  qmux_svc_info_type * service_handle
)
{
  qmi_instance_e_type  retval;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if (service_handle->service_id >= qmi_vs_services_min && 
      service_handle->service_id < qmi_vs_services_max)
  {
    for(retval = QMI_INSTANCE_MIN; retval < QMI_INSTANCE_MAX; retval++)
    {
       if((service_handle >= qmux_state[retval].vs_svc_array) &&
          (service_handle < (qmux_state[retval].vs_svc_array + 
                    qmux_state[retval].num_vs_svc_reg)))  
       {
         break;
       }
    }
  }
  else
  {
    retval = (qmi_instance_e_type)
	    ((u32)((u8 *) service_handle - (u8 *) &(qmux_state[0].service)) 
                                 / sizeof(qmux_state_type));
  }
  
  if (retval >= QMI_INSTANCE_MAX)
  {
    printk(KERN_INFO "Invalid QMUX Service handle! (0x%x)", (unsigned int)service_handle);/* BB5D03002 z00104852, for lint, 2009/11/19 */
    return QMI_INSTANCE_MAX;
  }

  return retval;

} /* qmi_instance_by_qmux_handle() */


/*===========================================================================
  FUNCTION QMI_CTL_INIT()

  DESCRIPTION
    Initialize all instances (one for each physical link supporting QMUX)
    of the QMI_CTL service

  PARAMETERS
    None

  RETURN VALUE
    None

  DEPENDENCIES
    Must be called at startup

  SIDE EFFECTS
    None
===========================================================================*/
void qmi_ctl_init
(
  qmi_instance_e_type  qmi_inst
)
{
  qmi_ctli_state_type *  ctl_sp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  //ASSERT(qmi_inst < QMI_INSTANCE_MAX);

  ctl_sp = &qmi_ctl_state[qmi_inst];
  /*-----------------------------------------------------------------------
    Initialize each instance's state, then reg with QMUX
    - Set local link ID (byte 1) to the QMI link instance ID
  -----------------------------------------------------------------------*/
  memset( ctl_sp, 0, sizeof(qmi_ctli_state_type) );
  ctl_sp->qmi_link_id = (qmi_inst & 0xFF) << 8;
  ctl_sp->qmux_svc_handle = qmux_reg_service(qmi_inst,
                                             QMUX_SERVICE_CTL,
                                             &qmi_ctl_cfg[qmi_inst]);
  ctl_sp->constants.rmnet_instance = QMI_IF_GET_RMNET_INSTANCE(qmi_inst);
} /* qmi_ctl_init() */

/*===========================================================================
  FUNCTION QMI_DMS_INIT()

  DESCRIPTION
    Register the DMS service with QMUX for all applicable QMI links

  PARAMETERS
    None

  RETURN VALUE
    None

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
void qmi_dms_init_t
(
  qmi_instance_e_type  qmi_inst
)
{
  qmi_dmsi_state_type *         dms_sp;
//  qmi_dmsi_client_state_type *  cl_sp;
//  int                           client;
 // qmi_cmd_buf_type *            cmd_buf_p;
 // qmi_transaction_type *        x_p;
//  int                           i;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  //ASSERT(qmi_inst < QMI_INSTANCE_MAX);
  dms_sp = &qmi_dms_state[qmi_inst];

  /* TO DO: if supposed to be mapped to this QMI instance do below, 
            else continue */
  memset( dms_sp, 0, sizeof(qmi_dmsi_state_type) );

  /*-------------------------------------------------------------------------
    client ID's are always non-zero
  -------------------------------------------------------------------------*/
  dms_sp->common.next_clid = QMI_SVC_CLID_UNUSED + 1;
  dms_sp->common.qmux_svc_handle = qmux_reg_service( qmi_inst,
                                              QMUX_SERVICE_DMS,
                                              &qmi_dmsi_cfg[qmi_inst] );

  /*-------------------------------------------------------------------------
    set the boolean to TRUE to indicate that the global trans buffer is free
  -------------------------------------------------------------------------*/
  dms_sp->common.bcast_transaction_buf_free = true;
}
/*===========================================================================
  FUNCTION QMI_WDS_INIT()

  DESCRIPTION
    Register the Wireless Data Service with QMUX for all applicable QMI links

  PARAMETERS
    None

  RETURN VALUE
    None

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
void qmi_wds_init_t
(
  qmi_instance_e_type  qmi_inst
)
{
  qmi_wdsi_state_type_t *         wds_sp;
//  int                           client;
//  qmi_wdsi_client_state_type_t *  cl_sp;
//  qmi_cmd_buf_type *            cmd_buf_p;
//  qmi_transaction_type *        x_p;
 // ps_iface_type *               rm_iface_ptr;
//  int                           i;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if(qmi_inst >= QMI_INSTANCE_MAX)
  {  
    printk(KERN_INFO "wenp: func qmi_wds_init_t error qmi_inst\n");
  }
  wds_sp = &qmi_wds_state[qmi_inst];
  memset( wds_sp, 0, sizeof(qmi_wdsi_state_type_t) );

  /*-----------------------------------------------------------------------
    client ID's are always non-zero
  -----------------------------------------------------------------------*/
  wds_sp->common.next_clid = QMI_SVC_CLID_UNUSED + 1;
  wds_sp->pkt_svc_state = QMI_WDS_CONN_DISCONNECTED;

  /// future: WDS to QMI instance may not be 1-to-1
  wds_sp->common.qmux_svc_handle = qmux_reg_service(qmi_inst,
                                             QMUX_SERVICE_WDS,
                                             &qmi_wdsi_cfg[qmi_inst]);
  if(wds_sp->common.qmux_svc_handle == NULL)
    printk(KERN_INFO "wenp: func qmi_wds_init_t error qmux_reg_service\n");
  //other data_init just omit.
  // TODO:  if svc_handle 0 then return ?
}

void qmux_init(void)
{
  qmi_vs_services_min = QMUX_SERVICE_VENDOR_MIN;
  qmi_vs_services_max = QMUX_SERVICE_VENDOR_MAX;
  
   qmux_state[(qmi_instance_e_type)0].initialized = true;
   qmi_ctl_init((qmi_instance_e_type)0);
   qmi_dms_init_t((qmi_instance_e_type)0);
   qmi_wds_init_t((qmi_instance_e_type)0);
   
}

static void * qmux_reg_service
(
  qmi_instance_e_type     qmi_instance,
  qmux_service_e_type     service,
  qmux_svc_config_type_t *  cfg
)
{
  qmux_svc_info_type *  svc_s;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//  assert (qmi_instance < QMI_INSTANCE_MAX);
//  assert (service < QMUX_SERVICE_QC_MAX);
//  assert (cfg);
  if((qmi_instance >= QMI_INSTANCE_MAX) ||
    (service >= QMUX_SERVICE_QC_MAX)||(cfg==NULL))

  /* Check for out of VS range */
  if (((u8)service >= qmi_vs_services_min) &&
      ((u8)service < qmi_vs_services_max))
  {
    printk(KERN_INFO "Service ID %d falls in invalid (VS service) range!\n", service);
    return NULL;
  }

  if( !qmux_state[qmi_instance].initialized )
  {
    printk(KERN_INFO "QMI link %d not initialized!\n", qmi_instance);
    return NULL;
  }
  svc_s = &qmux_state[qmi_instance].service[service];

  if( svc_s->registered )
  {
    printk(KERN_INFO "Service %d already registered with QMUX#%d!", 
         service, qmi_instance);
    return NULL;
  }

  /*-------------------------------------------------------------------------
    validate passed config
    - service must have a non-null receive function.
    - Everything else is optional
    - if dealloc callback is not specified (using the service library),
      must specify a reset clid callback
  -------------------------------------------------------------------------*/

//TODO: wenp not finish yet
/*  if ( ((cfg->cbs.recv == NULL) && 
        ((cfg->cmd_hdlr_array == NULL) || (cfg->cmd_num_entries == 0))) ||
       ((cfg->cbs.recv != NULL) && 
        ((cfg->cmd_hdlr_array != NULL) || (cfg->cmd_num_entries != 0))) )
  {
    ERR ("Invalid QMI service config", 0, 0,0);
    return NULL;
  }
*/
  /*-------------------------------------------------------------------------
    if the service is not QCTL, then when it's using the common dealloc_clid,
    reset client must be registered, otherwise it would cause an error
  -------------------------------------------------------------------------*/
/*  if (service != QMUX_SERVICE_CTL)
  {
    if ((cfg->cbs.dealloc_clid == NULL) && (cfg->cbs.reset_client == NULL))
    {
      printk (KERN_INFO "Invalid QMI service config\n");
      return NULL;
    }
  }*/
  
  /*-------------------------------------------------------------------------
    state pointer will be passed back in callbacks to tie this to the 
    associated service instance
  -------------------------------------------------------------------------*/
  svc_s->registered = true;     /* indication that service is registered */
  svc_s->service_id = service;  /* QMUX service type */
  svc_s->cfg        = *cfg;     /* store the provided config */
 
  /*-------------------------------------------------------------------------
    Return service handle which service should use to deregister, etc.
  -------------------------------------------------------------------------*/
  return svc_s;

}

/*===========================================================================
  FUNCTION QMUX_GET_SERVICE_CFG()

  DESCRIPTION
    Get Service configuration

  PARAMETERS
    qmux_handle : handle assigned to each service by qmux
    svc_type    : type of qmux service    

  RETURN VALUE
    qmux_svc_config_type
    NULL if input service handle or service type is invalid

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
qmux_svc_config_type_t *  qmux_get_service_cfg
(
  void *               qmux_handle,
  qmux_service_e_type  svc_type
)
{
  qmi_instance_e_type  qmi_instance;
  u8                i;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

 // assert (qmux_handle);
  if(qmux_handle == NULL)
 {
    printk(KERN_INFO "wenp:empty pointer\n");
    return NULL;
  }
 /*---------------------------------------------------------------------
    Return NULL if:
     - svc_type is not Internal QC service range or not in VS range
  ---------------------------------------------------------------------*/
  if ((svc_type >= QMUX_SERVICE_QC_MAX && 
       svc_type < qmi_vs_services_min) || 
       svc_type >= qmi_vs_services_max)
  {
    printk(KERN_INFO "wenp:svc type\n");
    return NULL;
  }

  qmi_instance = qmi_instance_by_qmux_handle(qmux_handle);
  if (qmi_instance == QMI_INSTANCE_MAX)
  {
    printk(KERN_INFO "wenp:qmi instance\n"); 
    return NULL;
  }

    printk(KERN_INFO "wenp:instance(%d),type(%d),reg(%d),0x%x\n",qmi_instance,svc_type,
        qmux_state[qmi_instance].service[svc_type].registered, (unsigned int)&qmux_state[qmi_instance].service[svc_type].cfg); 

  /*---------------------------------------------------------------------
     First determine if svc_type is referring to QC internal services or 
     external services and then return appropriate cfg.
  ---------------------------------------------------------------------*/
  if ( svc_type < QMUX_SERVICE_QC_MAX )
  {  
    if (qmux_state[qmi_instance].service[svc_type].registered)
    {
      return &qmux_state[qmi_instance].service[svc_type].cfg;
    }
  }
  else 
  {
    for( i = 0; i < qmux_state[qmi_instance].num_vs_svc_reg; i++ )
    {
      if (qmux_state[qmi_instance].vs_svc_array[i].service_id == svc_type)
      {
        return &qmux_state[qmi_instance].vs_svc_array[i].cfg;
      }
    }
  }
  return NULL;

} /* qmux_get_service_cfg() */

/*===========================================================================
  FUNCTION QMI_DMSI_RESET_CLIENT()

  DESCRIPTION
    Resets the state for the given client
    
  PARAMETERS
    cl_sp :  client state pointer
    
  RETURN VALUE
    None
    
  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static void qmi_dmsi_reset_client
(
  void * cl_sp_in
)
{
  qmi_dmsi_client_state_type * cl_sp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if(cl_sp_in == NULL)
  {
    printk(KERN_INFO "wenp: func qmi_dmsi_reset_client empty pointer\n");
    return;
  }
  /*-------------------------------------------------------------------------
    Free resources for client

    FUTURE:  clear pending msg transactions and partially bundled responses
  -------------------------------------------------------------------------*/

  cl_sp = (qmi_dmsi_client_state_type *)cl_sp_in;
#if 0
  (void) q_init( &cl_sp->common.x_free_q );
  for( i = 0; i < MAX_PENDING_TRANSACTIONS; i++ )
  {
    x_p = &cl_sp->common.transactions[i];
    qmi_svc_free_transaction( &x_p );
  }

  /*-------------------------------------------------------------------------
    clear event reporting
  -------------------------------------------------------------------------*/
  cl_sp->report_status.bat_lvl_lower_limit = DMSI_BAT_LVL_MIN;
  cl_sp->report_status.bat_lvl_upper_limit = DMSI_BAT_LVL_MAX;
  cl_sp->report_status.last_bat_lvl_reported = DMSI_BAT_LVL_INACTIVE;
  cl_sp->report_status.last_power_state_reported = DMSI_PWR_STATE_INACTIVE;

  /*-------------------------------------------------------------------------
    If power state reporting is set for this client then
    - reset it
    - decrement the report power state count by 1
    - If this count becomes 0, turn off the timer for power state reporting
  -------------------------------------------------------------------------*/
  if(cl_sp->report_status.report_power_state == TRUE)
  {
    cl_sp->report_status.report_power_state  = FALSE;
    qmi_dmsi_global.pwr_rpt.report_power_state_client_count--;

    if(qmi_dmsi_global.pwr_rpt.report_power_state_client_count == 0)
    {
      qmi_charger_set_power_state_reporting(FALSE);
    }
  }
#endif
  
} /* qmi_dmsi_reset_client() */
/*===========================================================================
  FUNCTION QMI_DMSI_GET_NEXT_CLIENT_SP()

  DESCRIPTION
    To obtain DMS client specific state ptr from given client state ptr
    This function is registered with QMUX.
    
  PARAMETERS
    sp   : service provided state pointer (user data)
    cl_sp   : service provided client state pointer (if null goes to head)

  RETURN VALUE
    client state ptr: DMS client specific state pointer

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static void *  qmi_dmsi_get_next_client_sp
(
  void *  svc_sp,
  void *  cl_sp
)
{
  qmi_dmsi_state_type *         dms_sp;
  qmi_dmsi_client_state_type *  first_cl_sp;
  qmi_dmsi_client_state_type *  dms_client_sp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  if(svc_sp == NULL)
  {
    printk(KERN_INFO "wenp: func qmi_dmsi_get_next_client_sp empty pointer\n");
    return NULL;
  }
  
  dms_sp = (qmi_dmsi_state_type *) svc_sp;
  first_cl_sp = dms_sp->client;
  if ( cl_sp == NULL ) 
  {
    return first_cl_sp;
  }

  dms_client_sp = (qmi_dmsi_client_state_type *) cl_sp;

  dms_client_sp++;
  if (dms_client_sp < first_cl_sp + DMSI_MAX_CLIDS) 
  {
    return dms_client_sp;
  }
  else
  {
    return NULL;
  }
} /* qmi_dmsi_get_next_client_sp() */


/*===========================================================================
  FUNCTION QMI_WDSI_GET_NEXT_CLIENT_SP()

  DESCRIPTION
    To obtain WDS client specific state ptr from given client state ptr
    This function is registered with QMUX.
    
  PARAMETERS
    sp      : service provided state pointer (user data)
    cl_sp   : service provided client state pointer (if null goes to head)

  RETURN VALUE
    client state ptr: WDS client specific state pointer

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static void *  qmi_wdsi_get_next_client_sp
(
  void *  sp,
  void *  cl_sp
)
{
  qmi_wdsi_state_type_t *         wds_sp;
  qmi_wdsi_client_state_type_t*  first_cl_sp;
  qmi_wdsi_client_state_type_t*  wds_client_sp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  if(sp == NULL)
  {
    printk(KERN_INFO "wenp: func qmi_wdsi_get_next_client_sp empty pointer\n");
    return NULL;
  }
  
  wds_sp = (qmi_wdsi_state_type_t *) sp;
  first_cl_sp = wds_sp->client;
  if ( cl_sp == NULL ) 
  {
    return first_cl_sp;
  }

  wds_client_sp = (qmi_wdsi_client_state_type_t *) cl_sp;

  wds_client_sp++;
  if (wds_client_sp < first_cl_sp + WDSI_MAX_CLIDS) 
  {
    return wds_client_sp;
  }
  else
  {
    return NULL;
  }


} /* qmi_wdsi_get_next_client_sp() */


/*===========================================================================
  FUNCTION QMI_WDSI_RESET_CLIENT()

  DESCRIPTION
    Resets the state for the given client
    
  PARAMETERS
    cl_sp :  client state pointer
    
  RETURN VALUE
    ptr to response
    
  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static void qmi_wdsi_reset_client
(
  void * cl_sp_in
)
{
  qmi_wdsi_client_state_type_t *  cl_sp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  if(cl_sp_in == NULL)
  {
    printk(KERN_INFO "wenp: func qmi_dmsi_reset_client empty pointer\n");
    return;
  }
  cl_sp = (qmi_wdsi_client_state_type_t *)cl_sp_in;

#if 0
  wds_sp = qmi_wdsi_get_wds_sp_by_cl_sp(cl_sp);

  if (wds_sp == NULL) 
  {
    ASSERT(0);
    return;
  }
  /*-------------------------------------------------------------------------
    Free resources for client
    Remove any pending commmands for this client from the pending q's
    Clear pending msg transactions and partially bundled responses
  -------------------------------------------------------------------------*/
  TASKLOCK();
  (void)q_linear_extract(&wds_sp->sni_pend_q,
                         (q_compare_func_type) qmi_svc_cmd_buf_belongs_to_client,
                         cl_sp);
  TASKFREE();

  (void) q_init( &cl_sp->common.x_free_q );
  for( i = 0; i < MAX_PENDING_TRANSACTIONS; i++ )
  {
    x_p = &cl_sp->common.transactions[i];
    qmi_svc_free_transaction(&x_p );
  }

  /*-------------------------------------------------------------------------  
    stop network interface
  -------------------------------------------------------------------------*/
  qmi_wdsi_stop_net_iface_client(cl_sp);

  /*-------------------------------------------------------------------------
    clear call status reporting
  -------------------------------------------------------------------------*/
  qmi_wdsi_set_pkt_stats_reports( cl_sp, 0, 0 );
  cl_sp->report_status.report_ch_rate = FALSE;
  cl_sp->report_status.report_data_bearer = FALSE;
  cl_sp->report_status.report_dormancy_status = FALSE;
#endif  
} /* qmi_wdsi_reset_client() */



static void qmi_msg_poolInit(qmi_item_pool *pool)
{
    pool->buf = (u8 *)&QMI_POOL;
    pool->bytes_left = QMI_PKT_MAX_SIZE;
    pool->cur = NULL;
    
}

u16 qmi_pullup_package(u8 **pkt, u8 *value, u16 len)
{
 u16 i;
 if(*pkt==NULL || value==NULL)
    return -1;
 for (i = 0;i<len;i++)
{
     *value = **pkt;
     (*pkt)++;
     value++;
 }   
 return len;

}

 u16 qmi_pushdown_package(void * val, u16 len)
{
  qmi_item_pool *pool=&QMI_ITEM_POOL;
  
   if((pool->buf == NULL) || (pool->bytes_left <= 100)){
        printk(KERN_INFO "wenp:error put\n");
        return -1;
    }
   pool->bytes_left -= len;
   pool->cur = pool->buf + pool->bytes_left;
   memcpy(pool->cur, val,len);

   return len;
}

static bool   qmi_svc_put_param_tlv
(
  u8             type,
  u16            len,
  void *            value
)
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  qmi_item_pool *pkt;
  pkt = &QMI_ITEM_POOL;

  if( (QMI_SVC_PKT_PUSH_T(value, len)) &&
      (QMI_SVC_PKT_PUSH_T(&len, sizeof(len))) &&
      (QMI_SVC_PKT_PUSH_T(&type, sizeof(type))) )
  {
    return true;
  }
  // free here 
  printk(KERN_INFO "wenp:put params error(%d)\n",pkt->bytes_left);
  return false;

} /* qmi_svc_put_param_tlv() */

static bool  qmi_svc_put_result_tlv
(
  qmi_result_e_type  result,
  qmi_error_e_type   error
)
{
  struct
  {
    u16  rcode;
    u16  ecode;
  } v_result;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  printk(KERN_INFO "result tlv (%d),error(%d)\n",
            result, error);

  v_result.rcode =(u16)result;
  v_result.ecode = (u16)error;

  return qmi_svc_put_param_tlv(QMI_TYPE_RESULT_CODE,
                               sizeof (v_result),
                               &v_result);

} /* qmi_svc_put_result_tlv() */

/*===========================================================================
  FUNCTION QMI_SVC_GET_CLIENT_SP_BY_CLID()

  DESCRIPTION
    To obtain cl_sp from svc_sp and clientID
    
  PARAMETERS
    state ptr
    clientID

  RETURN VALUE
    client state ptr

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
void *  qmi_svc_get_client_sp_by_clid
(
  qmi_common_svc_state_type *  svc_sp,  
  u8   clid
)
{
  qmi_common_client_state_type *  cl_sp;
  qmux_svc_info_type *            svc_handle;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  svc_handle = (qmux_svc_info_type *)svc_sp->qmux_svc_handle;

  if (clid == QMI_SVC_CLID_UNUSED || clid == QMI_SVC_CLID_BROADCAST)
  {
    return NULL;
  }

  cl_sp = NULL;

  do 
  {
    cl_sp = svc_handle->cfg.cbs.get_next_client_sp(svc_sp,cl_sp);
    if (cl_sp!= NULL && cl_sp->clid == clid)
    {
      break;
    }
  } while (cl_sp != NULL);

  return cl_sp;

} /* qmi_svc_get_client_sp_by_clid() */

/*===========================================================================
  FUNCTION QMI_SVC_DEALLOC_CLIENT()

  DESCRIPTION
    Deallocate ClientID
                       
  PARAMETERS
    svc_sp : Cleint specific xxx service state ptr (user data)
    (xxx depends on service)
    cl_sp :  

  RETURN VALUE
    TRUE  : on Success
    FALSE : on Failure

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static void  qmi_svc_dealloc_client
(
  qmi_common_svc_state_type *     svc_sp,
  qmi_common_client_state_type *  cl_sp
)
{
  qmux_svc_info_type *            svc_handle;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  if((svc_sp == NULL) || (cl_sp == NULL))
  {
    printk(KERN_INFO "wenp: qmi_svc_dealloc_clid empty pointer\n");
    return;
  }
  svc_handle = (qmux_svc_info_type *)svc_sp->qmux_svc_handle;

  if(NULL == svc_handle->cfg.cbs.reset_client)
  {
    printk(KERN_INFO "wenp: qmi_svc_dealloc_clid empty reset_client\n");
    return;
  }
  
  printk(KERN_INFO "Dealloc service clid %d", cl_sp->clid);

  /* LATER:  clear pending transactions */
  // is this already done in reset client?  but it's common, so move it here

  /*-------------------------------------------------------------------------
    Free resources for client
  -------------------------------------------------------------------------*/
  svc_handle->cfg.cbs.reset_client(cl_sp);
  cl_sp->clid = QMI_SVC_CLID_UNUSED;
} /* qmi_svc_dealloc_client() */


/*===========================================================================
  FUNCTION QMI_SVC_DEALLOC_CLID()

  DESCRIPTION
    Deallocate ClientID
                       
  PARAMETERS
    state ptr: service provided state pointer (user data)
    clientID : ID of the client to be deallocated

  RETURN VALUE
    TRUE  :on Success
    FALSE :on Failure

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
bool  qmi_svc_dealloc_clid
(
  qmi_common_svc_state_type *  svc_sp,
  u8   clid
)
{
  qmi_common_client_state_type *  cl_sp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if(svc_sp == NULL)
  {
    printk(KERN_INFO "wenp: qmi_svc_dealloc_clid empty pointer\n");
    return false;
  }
  
  cl_sp = qmi_svc_get_client_sp_by_clid( svc_sp, clid );
  if (cl_sp)
  {
    qmi_svc_dealloc_client( svc_sp,cl_sp );
    return true;
  }
  return false;
} /* qmi_svc_dealloc_clid() */


/*===========================================================================
  FUNCTION QMI_SVC_IS_VALID_CLID()

  DESCRIPTION
    Checks validity of the client ID.
                       
  PARAMETERS
    svc_sp:    service provided state pointer (user data)
    clid:  ID allocated to the client, whose validity is to be checked

  RETURN VALUE
    TRUE  :  Client ID is allocated
    FALSE :  Client ID is not allocated
    
  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
bool  qmi_svc_is_valid_clid
(
  qmi_common_svc_state_type *   svc_sp,       
  u8    clid
)
{
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  if (qmi_svc_get_client_sp_by_clid(svc_sp,clid) != NULL)
  {
    return true;
  }
  else
  {
    return false;
  }
} /* qmi_svc_is_valid_clid() */


/*===========================================================================
  FUNCTION QMI_SVC_ALLOC_CLID()

  DESCRIPTION
    Allocate a client ID.  This function is called whenever a QMI_CTL alloc 
    client id message with service type xxx is received.
    (xxx depends on service type)

  PARAMETERS
    svc_sp:  service provided state pointer (user data)

  RETURN VALUE
    Client ID on Sucesss
    Zero      on Failure

  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
u8  qmi_svc_alloc_clid
(
  qmi_common_svc_state_type *  svc_sp
)
{
  qmi_common_client_state_type *  cl_sp;   
  u8                           assigned_clid;
  qmi_common_client_state_type *  loop_cl_sp;      /* looping client pointer */
  bool                         in_use;
  qmux_svc_info_type *            svc_handle;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  svc_handle = (qmux_svc_info_type *)svc_sp->qmux_svc_handle;

  cl_sp = NULL;

  do 
  {
    cl_sp = svc_handle->cfg.cbs.get_next_client_sp(svc_sp,cl_sp);
    if (cl_sp != NULL && cl_sp->clid == QMI_SVC_CLID_UNUSED)
    {
      break;
    }
  } while (cl_sp != NULL);

  if (cl_sp == NULL) /* if no unused client, fail */
  {
    printk(KERN_INFO "No available service clids!\n");
    return QMI_SVC_CLID_UNUSED;
  }

  /*-------------------------------------------------------------------------
      Attempt to assign Client ID one greater than last assigned, but check
      to make sure we haven't wrapped around and have selected a client id
      that was previously assigned.
  -------------------------------------------------------------------------*/
  do
  {
    assigned_clid = svc_sp->next_clid;
    in_use = false;

    loop_cl_sp = NULL;

    do  
    {
      loop_cl_sp = svc_handle->cfg.cbs.get_next_client_sp(svc_sp,loop_cl_sp);
      if (loop_cl_sp != NULL && loop_cl_sp->clid == assigned_clid)
      {
        /*-------------------------------------------------------------------
          If the client ID was already assigned, we'll increment the next
          client id value and loop.
        -------------------------------------------------------------------*/
        in_use = true;
        break;
      }
    } while (loop_cl_sp != NULL);
    
    /*-----------------------------------------------------------------------
      Increment the next client ID to be assigned.  Ensure client id rolls 
      over to one (skip UNUSED = 0).

      NOTE this logic is premised on specific values for broadcast (255),
      unused (0) and clid field width (8 bits)
    -----------------------------------------------------------------------*/
    svc_sp->next_clid++;
    if (svc_sp->next_clid == QMI_SVC_CLID_BROADCAST) /* go from 254 -> 1 */
    {
      svc_sp->next_clid = QMI_SVC_CLID_UNUSED + 1; /* roll over */
    }
  } while (in_use);

  /*-------------------------------------------------------------------------
    Allocate Client ID (increment counter for next client id)
  -------------------------------------------------------------------------*/
  cl_sp->clid = assigned_clid;
  printk(KERN_INFO "Alloc clid %d for service %x\n", cl_sp->clid,(unsigned int)svc_sp);  /* BB5D03002 z00104852, for lint, 2009/11/19 */

  return (cl_sp->clid);
} /* qmi_svc_alloc_clid() */

/*===========================================================================
  FUNCTION QMI_DMSI_GET_DEVICE_MFR()

  DESCRIPTION
    Gives the name of the device manufacturer.
    
  PARAMETERS
    sp            : service provided state pointer (user data)
    clid          : clientID
    sdu_in        : incoming request

  RETURN VALUE
    ptr to response
    
  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static bool qmi_dmsi_get_device_mfr(void)
{
  // VS - externalize and allow unicode
  u8 *             mfr_info;
  u16             len;
  qmi_error_e_type   errval;
  qmi_result_e_type  result;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  
  errval = QMI_ERR_NONE;

  mfr_info = qmi_device_mfr_str;
  len = QMI_MIN(QMI_PKT_MAX_SIZE-sizeof(struct qmi_ctl_pdu_header), strlen(mfr_info));

  //TO DO in future - read it from NV to make it customizable
  /*-------------------------------------------------------------------------
    Build the response from back to front
  -------------------------------------------------------------------------*/
  if(false == qmi_svc_put_param_tlv(QMI_TYPE_REQUIRED_PARAMETERS,
                                    (u16) len,
                                    mfr_info))
  {
    errval = QMI_ERR_NO_MEMORY;
  }

  result = (errval == QMI_ERR_NONE ? QMI_RESULT_SUCCESS 
                                   : QMI_RESULT_FAILURE);
  if(false == qmi_svc_put_result_tlv(result, errval))
    return false;
      
  return true;
  
} /* qmi_dmsi_get_device_mfr() */

/*===========================================================================
  FUNCTION QMI_DMSI_GET_MSISDN()

  DESCRIPTION
    Gives the msisdn information(MDN) of the device
    
  PARAMETERS
    sp            : service provided state pointer (user data)
    clid          : clientID
    sdu_in        : incoming request

  RETURN VALUE
    ptr to response
    
  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static bool  qmi_dmsi_get_msisdn(void)
{
  qmi_error_e_type        errval;
  qmi_result_e_type       result;
  u16 len;
  u8 *mob_num;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  errval = QMI_ERR_NONE;

  /*-------------------------------------------------------------------------
    build response from the back to the front
  -------------------------------------------------------------------------*/   
  mob_num=qmi_device_mob_str;
  len = QMI_MIN(QMI_PKT_MAX_SIZE-sizeof(struct qmi_ctl_pdu_header), strlen(mob_num));

  /*-------------------------------------------------------------------------
    Get the current NAM from NV
  -------------------------------------------------------------------------*/                                        
  //TO DO use ds eq for all of these
  // add check for sys mode and do if else depending on that
  if(false == qmi_svc_put_param_tlv( 
                                      QMI_TYPE_REQUIRED_PARAMETERS,
                                      (u16) len,
                                      mob_num))
  {
      errval = QMI_ERR_NO_MEMORY;
  }
  result = (errval == QMI_ERR_NONE ? QMI_RESULT_SUCCESS 
                                   : QMI_RESULT_FAILURE);

  if(false == qmi_svc_put_result_tlv(result, errval))
    return false;
      
  return true;  

} /* qmi_dmsi_get_msisdn() */
/*===========================================================================
  FUNCTION QMI_DMSI_GET_DEVICE_MODEL_ID()

  DESCRIPTION
    Gives the model ID of the device in use
    
  PARAMETERS
    sp            : service provided state pointer (user data)
    clid          : clientID
    sdu_in        : incoming request

  RETURN VALUE
    ptr to response
    
  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
static bool qmi_dmsi_get_device_model_id(  void )
{
  u8 *model_id_info;
  qmi_error_e_type   errval;
  qmi_result_e_type  result;
  u16 len;

  errval = QMI_ERR_NONE;

  /*-------------------------------------------------------------------------
    Query NV for Model Identification
  -------------------------------------------------------------------------*/

  /*-----------------------------------------------------------------------
    A total length of 256 is not required so null terminate at position 20 
    because a 32 bit number has at most 10 digits plus 1 for sign.
    Additional spaces are provided for specific formatting that 
    may be used.
  -----------------------------------------------------------------------*/  
  /*-------------------------------------------------------------------------
    build response from the back to the front
  -------------------------------------------------------------------------*/   
  model_id_info=qmi_device_model_str;
  len = QMI_MIN(QMI_PKT_MAX_SIZE-sizeof(struct qmi_ctl_pdu_header), strlen(model_id_info));

  /*-------------------------------------------------------------------------
    Get the current NAM from NV
  -------------------------------------------------------------------------*/                                        
  //TO DO use ds eq for all of these
  // add check for sys mode and do if else depending on that
  if(false == qmi_svc_put_param_tlv( 
                                      QMI_TYPE_REQUIRED_PARAMETERS,
                                       (u16) len,
                                      model_id_info))
  {
      errval = QMI_ERR_NO_MEMORY;
  }
  result = (errval == QMI_ERR_NONE ? QMI_RESULT_SUCCESS 
                                   : QMI_RESULT_FAILURE);

  if(false == qmi_svc_put_result_tlv(result, errval))
    return false;
      
  return true;  
 
} /* qmi_dmsi_get_device_model_id() */
/*===========================================================================
  FUNCTION QMI_WDSI_GET_PKT_SRVC_STATUS()

  DESCRIPTION
    Give the current packet data connection status
    
  PARAMETERS
    sp      : service provided state pointer (user data)
    clid    : client ID
    sdu_in  : incoming request

  RETURN VALUE
    ptr to response
    
  DEPENDENCIES
    None

  SIDE EFFECTS
    None
===========================================================================*/
#ifndef FEATURE_E5832
static int qmi_wdsi_get_pkt_srvc_status_debug_use(u8 configNr)
//(
//  void *            sp,
//  void *            cmd_buf_p,
//  void *            cl_sp,
//  dsm_item_type **  sdu_in
//)
{
//  qmi_wdsi_state_type *  wds_sp;
  struct
  {
    qmi_wds_conn_status_e_type  conn_status;
  } v_out_reqd;
  qmi_error_e_type   errval;
  qmi_result_e_type  result;
  bool           retval;
  rndis_resp_t            *r;      
      u16 resp_len,msg_len;
    qmi_item_pool *resp_buf;
    struct 
    {
       u16 msg_id;
       u16 msg_len;
    }qmi_srv_msg_header={0};
  struct qmi_srv_pdu_header *resp;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  /*-------------------------------------------------------------------------
    Build the response from back to front
  -------------------------------------------------------------------------*/
  errval = QMI_ERR_NONE;

  v_out_reqd.conn_status = QMI_WDS_CONN_CONNECTED;

  if( false == qmi_svc_put_param_tlv(
                                     QMI_TYPE_REQUIRED_PARAMETERS,
                                     sizeof (v_out_reqd),
                                     &v_out_reqd))
  {
    errval = QMI_ERR_NO_MEMORY; 
  }

  result = (errval == QMI_ERR_NONE ? QMI_RESULT_SUCCESS 
                                   : QMI_RESULT_FAILURE);
    
  retval = qmi_svc_put_result_tlv(result, errval);
  
  resp_buf = &QMI_ITEM_POOL;

  qmi_srv_msg_header.msg_id = 0xF0F0;
  qmi_srv_msg_header.msg_len = QMI_PKT_MAX_SIZE - resp_buf->bytes_left;
  qmi_pushdown_package(&qmi_srv_msg_header, sizeof(qmi_srv_msg_header));
    /*-----------------------------------------------------------
       fill response buffer
       -----------------------------------------------------------*/
    msg_len = QMI_PKT_MAX_SIZE - resp_buf->bytes_left;
    resp_len = sizeof(struct qmi_srv_pdu_header)+msg_len;

    if (!qmi_per_dev_params [configNr].dev) return -ENOTSUPP;

    r = qmi_add_response (configNr, resp_len);
    if (!r)
        return -ENOMEM;
    resp = (struct qmi_srv_pdu_header *) r->buf;    
    
    resp->iflags=0x01;
    resp->length=resp_len-1;         //reduce the resp->iflags   
    resp->ctl_info=QMUXI_CFLAG_SENDER_SERVICE;
    resp->srv_type=QMUX_SERVICE_WDS;
    resp->client_id=0x01;

    resp->ctl_flag=QMI_SRV_INDICAION;
    resp->trans_id=0x0001;

    memcpy(((u8 *)resp+ sizeof(struct qmi_srv_pdu_header)),
        resp_buf->buf + resp_buf->bytes_left, msg_len);
    
    /*-----------------------------------------------------------
       send response data
       -----------------------------------------------------------*/
    if (qmi_per_dev_params [configNr].ack)
    qmi_per_dev_params [configNr].ack (
    	qmi_per_dev_params [configNr].dev);

    return 0;
} /* qmi_wdsi_get_pkt_srvc_status() */
#endif
/*===========================================================================
  FUNCTION QMI_CTLI_SET_INSTANCE_ID()

  DESCRIPTION
    Handle the QMI CTL set instance ID message.  Prepends the host instance
    ID contained in the input message with the local QMI link instance, and
    saves the 16-bit result in the QMI CTL instance state.  Generates a
    reply containing this 16-bit value to be sent back to the host.

  PARAMETERS
    sp:      QMI_CTL's service instance state pointer for this qmi link
             returned by qmux_reg_service()
    clid:    coresponding client id
    sdu_in:  input command data

  RETURN VALUE
    dsm * pointing to the response to be sent to host
    NULL if no response was generated or command was discarded

  DEPENDENCIES
    qmi_ctl_init() must have been called

  SIDE EFFECTS
    None
===========================================================================*/
static int  qmi_ctli_set_instance_id_p
(
  void *            sp,
  u8 *sdu_msg_in,
  s32 sdu_len
)
{
  qmi_ctli_state_type *  ctl_sp;
  u8                  type;
  u16                 len;
  u16                 expected_len;
  void *                 value;
  
  struct {
    u8  instance;
  } v_in_required = { 0, };
  bool                got_v_in_required;
  
  struct {
    u16  qmi_link_id;
  } v_out_required;
  
  qmi_error_e_type   errval;
  qmi_result_e_type  result;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

  if(sp == NULL || sdu_msg_in == NULL)
  {
    printk(KERN_INFO "qmi_ctli_set_instance_id_p NULL pointer!\n");
     errval = QMI_ERR_MISSING_ARG;
    goto send_result;     
  }
  memset(&v_in_required, 0, sizeof(v_in_required));

  ctl_sp = (qmi_ctli_state_type *) sp;

  /*-------------------------------------------------------------------------
    Parse out expected TLVs, toss unexpected.  If duplicates, last wins.
  -------------------------------------------------------------------------*/
  errval = QMI_ERR_NONE;
  got_v_in_required = false;

  while(*sdu_msg_in && (sdu_len>0))
  {
    type= qmi_pull8( sdu_msg_in);
    len = qmi_pull16(sdu_msg_in);
    sdu_len -= 3;
    printk(KERN_INFO "qmi_ctli_set_instance_id_p:0x%x!\n", (unsigned int)sdu_msg_in);/* BB5D03002 z00104852, for lint, 2009/11/19 */

    // special value 0 = variable length or don't care (unrecognzied TLV)
    expected_len = 0;
    value = NULL;
    switch (type)
    {
      case QMI_TYPE_REQUIRED_PARAMETERS:
      {
        expected_len = sizeof(v_in_required);
        value = &v_in_required;
        got_v_in_required = true;
        break;
      }
      default:
      {
        printk(KERN_INFO "Unrecognized TLV type (%d)",type);
        break;
      }
    }

    if ((expected_len != 0) && (expected_len != len))
    {
      printk(KERN_INFO "Invalid TLV len (%d) for type (%d)", len, type);
      errval = QMI_ERR_MALFORMED_MSG;
      goto send_result;
    }

    if( len != qmi_pullup(&sdu_msg_in, value, len ))
    {
      printk(KERN_INFO "malformed (short) TLV!");
      errval = QMI_ERR_MALFORMED_MSG;
      goto send_result;
    }
    sdu_len -= len;

  }

  printk(KERN_INFO "Got QMI_CTL set instance command (instance = %d)",
           v_in_required.instance);/* BB5D03002 z00104852, for lint,  2009/11/19 */

  /*-------------------------------------------------------------------------
    Ensure required TLV parameters are present
  -------------------------------------------------------------------------*/
  if (!got_v_in_required)
  {
    printk(KERN_INFO "Missing required parameters TLV!");
    errval = QMI_ERR_MISSING_ARG;
  }
  else
  {
    /*-----------------------------------------------------------------------
      Perform action associated with message -
      Concatenate the provided host link ID with the local link ID to form
      the unique QMI link identifier.
    -----------------------------------------------------------------------*/
    ctl_sp->qmi_link_id &= ~(0xFF);
    ctl_sp->qmi_link_id |= v_in_required.instance;
    // TO DO - event that link ID has changed - reset Rm MAC
    v_out_required.qmi_link_id = ctl_sp->qmi_link_id;

    if( false == qmi_svc_put_param_tlv(
                                       QMI_TYPE_REQUIRED_PARAMETERS,
                                       sizeof (v_out_required),
                                       &v_out_required))
    {
      errval = QMI_ERR_NO_MEMORY;
    }
  }

send_result:
  result = (errval == QMI_ERR_NONE) ? QMI_RESULT_SUCCESS : QMI_RESULT_FAILURE;
  if(false == qmi_svc_put_result_tlv(result, errval))
  {
    return -1;
  }
  return 0;
} /* qmi_ctli_set_instance_id() */


/*===========================================================================
  FUNCTION QMI_CTLI_RELEASE_CLIENT_ID()

  DESCRIPTION
    Handle the QMI CTL release client ID message.

    Dispatches a request to the specified service to deallocate a client ID.
    Returns the result of the operation to the issuer.

  PARAMETERS
    sp:      QMI_CTL's service instance state pointer for this qmi link
             returned by qmux_reg_service()
    clid:    coresponding client id
    sdu_in:  input command data

  RETURN VALUE
    dsm * pointing to the response to be sent to host
    NULL if no response was generated or command was discarded

  DEPENDENCIES
    qmi_ctl_init() must have been called

  SIDE EFFECTS
    None
===========================================================================*/
static int  qmi_ctli_release_client_id_p(void * sp,u8 *sdu_msg_in,s32 sdu_len)
{
  qmi_ctli_state_type *  ctl_sp;
  u8                  type;
  u16                 len;
  u16                 expected_len;
  void *                 value;
  struct {
    u8  qmux_type;
    u8  clid;
  } v_io_required;
  bool                got_v_io_required;
  qmi_error_e_type       errval;
  qmi_result_e_type      result;
  qmux_svc_config_type_t * svc_cfg;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  if(sp == NULL || sdu_msg_in == NULL)
  {
    printk(KERN_INFO "qmi_ctli_release_client_id_p NULL pointer!\n");
     errval = QMI_ERR_MISSING_ARG;
    goto send_result;     
  }
  memset(&v_io_required, 0, sizeof(v_io_required));

  ctl_sp = (qmi_ctli_state_type *) sp;

  errval = QMI_ERR_NONE;
 // response = NULL;

  /*-------------------------------------------------------------------------
    Parse incoming command (none)
    - identify and save expected TLVs,
      if duplicate TLV found, last present is used.
    - discard unexpected TLVs
  -------------------------------------------------------------------------*/
  got_v_io_required = false;

  while (*sdu_msg_in && (sdu_len>0))
  {
    type= qmi_pull8( sdu_msg_in );
    len = qmi_pull16(sdu_msg_in);
    sdu_len -= 3;

    // special value 0 = variable length or don't care (unrecognzied TLV)
    expected_len = 0;
    value = NULL;
    switch (type)
    {
      case QMI_TYPE_REQUIRED_PARAMETERS:
        expected_len = sizeof(v_io_required);
        got_v_io_required = true;
        value = &v_io_required;
        break;

      default:
        printk(KERN_INFO "Unrecognized TLV type (%d)\n",type);
        break;
    }

    if ((expected_len != 0) && (expected_len != len))
    {
      printk(KERN_INFO "Invalid TLV len (%d) for type (%d)\n", len, type);
      errval = QMI_ERR_MALFORMED_MSG;
      goto send_result;
    }

    if( len != qmi_pullup(&sdu_msg_in, (u8 *)value, len ) )
    {
      printk(KERN_INFO "Short TLV ");
      errval = QMI_ERR_MALFORMED_MSG;
      goto send_result;
    }
    sdu_len -= len;

  }

  /*-------------------------------------------------------------------------
    Perform validity checks (none)
  -------------------------------------------------------------------------*/
  if (!got_v_io_required)
  {
    printk(KERN_INFO "Mandatory TLV not present!");
    errval = QMI_ERR_MISSING_ARG;
    goto send_result;
  }

  /*-------------------------------------------------------------------------
    Perform action/gather required information for response
    - get the service configuration block of the specified QMI service
    - deallocate the client ID from the specified QMI service
  -------------------------------------------------------------------------*/
  printk(KERN_INFO "Got QMI_CTL release CLID command (svc = %d, clid = %d)",
           v_io_required.qmux_type, v_io_required.clid);

  svc_cfg = qmux_get_service_cfg( ctl_sp->qmux_svc_handle,
                                    (qmux_service_e_type)v_io_required.qmux_type );
  if (!svc_cfg)
  {
    errval = QMI_ERR_INVALID_SERVICE_TYPE;
    goto send_result;
  }

  // if is_valid_clid function is registered, check validity using that function
  // otherwise, check with the qmi_svc_is_valid_clid function
  if ( ((svc_cfg->cbs.is_valid_clid) &&
       !(svc_cfg->cbs.is_valid_clid(svc_cfg->sp, v_io_required.clid))) ||
       (!(svc_cfg->cbs.is_valid_clid) &&
       !(qmi_svc_is_valid_clid(svc_cfg->sp, v_io_required.clid))) )
  {
    errval = QMI_ERR_INVALID_CLIENT_ID;
    goto send_result;
  }

  // qctl itself doesn't allow dealloc client
  if ((qmux_service_e_type)v_io_required.qmux_type == QMUX_SERVICE_CTL)
  {
    errval = QMI_ERR_INTERNAL;
    goto send_result;
  }

  //specific function provided
  if (svc_cfg->cbs.dealloc_clid &&
      !(svc_cfg->cbs.dealloc_clid(svc_cfg->sp, v_io_required.clid))) 
  {
    errval = QMI_ERR_INTERNAL;
    goto send_result;
  }

  //specific funtion not provided
  if (!(qmi_svc_dealloc_clid(svc_cfg->sp, v_io_required.clid)))
  {
    errval = QMI_ERR_INTERNAL;
    goto send_result;
  }

  /*-------------------------------------------------------------------------
    If no error so far, build response payload from the back to the front
  -------------------------------------------------------------------------*/
  if (errval == QMI_ERR_NONE)
  {
    if(false == qmi_svc_put_param_tlv(QMI_TYPE_REQUIRED_PARAMETERS,
                                      sizeof (v_io_required),
                                      &v_io_required))
    {
      errval = QMI_ERR_NO_MEMORY;
    }
  }

  /*-------------------------------------------------------------------------
    Prepend response result and return to input function which will
    finalize the response command header and send it back via QMUX
  -------------------------------------------------------------------------*/
send_result:
  result = (errval == QMI_ERR_NONE ? QMI_RESULT_SUCCESS
                                   : QMI_RESULT_FAILURE);

  if(false == qmi_svc_put_result_tlv(result, errval))
  {
    return -1;
  }
  return 0;
} /* qmi_ctli_release_client_id() */

/*===========================================================================
  FUNCTION QMI_CTLI_GET_CLIENT_ID()

  DESCRIPTION
    Handle the QMI CTL get client ID message.

    Dispatches a request to the specified service to allocate a client ID.
    Returns the allocated client ID in the response to the issuer.

  PARAMETERS
    sp:      QMI_CTL's service instance state pointer for this qmi link
             returned by qmux_reg_service()
    clid:    coresponding client id
    sdu_in:  input command data

  RETURN VALUE
    dsm * pointing to the response to be sent to host
    NULL if no response was generated or command was discarded

  DEPENDENCIES
    qmi_ctl_init() must have been called

  SIDE EFFECTS
    None
===========================================================================*/
static int qmi_ctli_get_client_id_p(void * sp,u8 *sdu_msg_in,s32 sdu_len)
{
  qmi_ctli_state_type *   ctl_sp;
  u8                   type;
  u16                  len;
  u16                  expected_len;
  void *                  value;
  u8 * tmp;
  struct
  {
    u8  qmux_type;
  } v_in_required = { 0, };
  bool                 got_v_in_reqd = true;
  qmux_svc_config_type_t *  svc_cfg;
//  dsm_item_type *         response;
  qmi_result_e_type       result;
  qmi_error_e_type        errval;
  struct
  {
    u8  qmux_type;
    u8  clid;
  } v_out_required;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
//  ASSERT(sp);
//  ASSERT(sdu_in);
//  ASSERT (clid == QMI_CTL_CLIENT_ID);
  if(sp == NULL || sdu_msg_in == NULL)
  {
    printk(KERN_INFO "qmi_ctli_get_client_id_p NULL pointer!\n");
     errval = QMI_ERR_MISSING_ARG;
    goto send_result;     
  }

  ctl_sp = (qmi_ctli_state_type *)sp;
  memset(&v_in_required, 0, sizeof(v_in_required));
  errval = QMI_ERR_NONE;
//  response = NULL;


  /*-------------------------------------------------------------------------
    Parse incoming command
    - identify and save expected TLVs,
      if duplicate TLV found, last present is used.
    - discard unexpected TLVs
  -------------------------------------------------------------------------*/
  got_v_in_reqd = false;
  tmp = sdu_msg_in;   
  while (*sdu_msg_in && (sdu_len>0))
  {
    type= qmi_pull8( sdu_msg_in );
    len = qmi_pull16(sdu_msg_in);
    sdu_len -= 3;
    // special value 0 = variable length or don't care (unrecognzied TLV)
    expected_len = 0;
    value = NULL;
    switch (type)
    {
      case QMI_TYPE_REQUIRED_PARAMETERS:
        expected_len = sizeof(v_in_required);
        got_v_in_reqd = true;
        value = &v_in_required;
        break;

      default:
        printk(KERN_INFO "Unexpected TLV type (%d)\n",type);
        break;
    }

    if ((expected_len != 0) && (expected_len != len))
    {
      printk(KERN_INFO "Invalid TLV len (%d) for type (%d)", len, type);
      errval = QMI_ERR_MALFORMED_MSG;
      goto send_result;
    }
    
    if( len != qmi_pullup(&sdu_msg_in, (u8 *)value, len ) )
    {
      printk(KERN_INFO "Short TLV ");
      errval = QMI_ERR_MALFORMED_MSG;
      goto send_result;
    }
    sdu_len -= len;
  }

  /*-------------------------------------------------------------------------
    Perform validity checks (none)
  -------------------------------------------------------------------------*/
  if (!got_v_in_reqd)
  {
    printk(KERN_INFO "Mandatory TLV not present!");
    errval = QMI_ERR_MISSING_ARG;
    goto send_result;
  }

  /*-------------------------------------------------------------------------
    Perform action/gather required information for response
    - get the service configuration block of the specified QMI service
    - allocate a client ID from the specified QMI service
  -------------------------------------------------------------------------*/
  printk(KERN_INFO "Got QMI_CTL get CLID command (svc = %d)",
            v_in_required.qmux_type);


  svc_cfg = qmux_get_service_cfg( ctl_sp->qmux_svc_handle,
                                  (qmux_service_e_type)v_in_required.qmux_type );

  if(!svc_cfg)
  {
    /* invalid QMI service type (unassigned) */
    errval = QMI_ERR_INVALID_SERVICE_TYPE;
    goto send_result;
  }

  if( (qmux_service_e_type)v_in_required.qmux_type == QMUX_SERVICE_CTL)
  {
    errval = QMI_ERR_INVALID_SERVICE_TYPE;
    goto send_result;
  }

  if (svc_cfg->cbs.alloc_clid) //specific function provided
  {
    v_out_required.clid = svc_cfg->cbs.alloc_clid(svc_cfg->sp);
  }
  else //specific funtion not provided
  {
      v_out_required.clid = qmi_svc_alloc_clid(svc_cfg->sp);
    }
  
  // VS design - do we want VS service to be able to not specify a alloc
  // client id callback?

  if (!(v_out_required.clid))
  {
    errval = QMI_ERR_CLIENT_IDS_EXHAUSTED;
    goto send_result;
  }

  printk (KERN_INFO "Assigned client ID %d\n", v_out_required.clid);

  /*-------------------------------------------------------------------------
    Since no error so far, build response payload from the back to the front
  -------------------------------------------------------------------------*/
  v_out_required.qmux_type = v_in_required.qmux_type;
  if(false == qmi_svc_put_param_tlv(QMI_TYPE_REQUIRED_PARAMETERS,
                                     sizeof (v_out_required),
                                     &v_out_required ) )
  {
    errval = QMI_ERR_NO_MEMORY;
    goto send_result;
  }
  
  /*-------------------------------------------------------------------------
    Prepend response result and return to input function which will
    finalize the response command header and send it back via QMUX
  -------------------------------------------------------------------------*/
send_result:
  result = (errval == QMI_ERR_NONE ? QMI_RESULT_SUCCESS
                                   : QMI_RESULT_FAILURE);

  if( false == qmi_svc_put_result_tlv(result, errval) )
  {
    return -1;
  }
  return 0;

}

/*===========================================================================
  FUNCTION QMI_CTLI_GET_VERSION()

  DESCRIPTION
    Handle the QMI CTL get version message.

    Generates a reply containing the QMI CTL service's major and minor
    version numbers.

  PARAMETERS
    sp:      QMI_CTL's service instance state pointer for this qmi link
             returned by qmux_reg_service()
    clid:    coresponding client id
    sdu_in:  input command data

  RETURN VALUE
    dsm * pointing to the response to be sent to host
    NULL if no response was generated or command was discarded

  DEPENDENCIES
    qmi_ctl_init() must have been called

  SIDE EFFECTS
    None
===========================================================================*/
static int qmi_ctli_get_version_p(void * sp,u8 *sdu_msg_in)
{
  qmi_ctli_state_type *   ctl_sp;
  qmux_svc_config_type_t *  svc_cfg;
  qmi_error_e_type        errval;
  qmi_result_e_type       result;
  struct  /* note this is not accessed directly - just sized to hold max size tlv */
  {
    u8  n_services;
    struct
    {
      qmux_service_e_type  svc_type;
      qmux_version_type    base_version;
    } tuple[QMUX_SERVICE_QC_MAX + QMI_CTL_MAX_VS_SERVICES];
  } v_out_reqd;
  u8 * pout;
  qmux_service_e_type  svc;
 
  struct  /* note this is not accessed directly - just sized to hold max size tlv */
  {
    u8  n_services;
    struct
    {
      qmux_service_e_type  svc_type;
      qmux_version_type    base_version;
    } tuple[QMUX_SERVICE_QC_MAX + QMI_CTL_MAX_VS_SERVICES];
  } v_out_addendum_opt;
  
  u8 * addendum_opt_out;
  u8 * addendum_label;
  u8  label_len;
  u16 addendum_svc_ver_info_len;
  u16 total_bytes_pushed;
  u8   addendum_tlv_type;
  qmi_item_pool *resp_buf;
    resp_buf = &QMI_ITEM_POOL;

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
  errval = QMI_ERR_NONE;
  ctl_sp = (qmi_ctli_state_type *)sp;

  /*-------------------------------------------------------------------------
    Perform validity checks (none)
  -------------------------------------------------------------------------*/
  /*-------------------------------------------------------------------------
    Perform action/gather required information for response
    - retrieve the version numbers from the service configuration block
    If no error so far, build response payload from the back to the front
  -------------------------------------------------------------------------*/
  pout = (u8 *) &v_out_reqd;
  v_out_reqd.n_services = 0;
  pout++; //leave 1st location for num_services

  addendum_opt_out = (u8 *) &v_out_addendum_opt;
  memset(&v_out_addendum_opt, 0, sizeof(v_out_addendum_opt));
  addendum_opt_out++; //leave 1st location for num_services

  // process QC services
  for (svc = QMUX_SERVICE_MIN; svc < QMUX_SERVICE_QC_MAX; svc++)
  {
    //svc_cfg = qmi_get_service_cfg(QMI_SRV_TBL[svc]);
    svc_cfg = qmux_get_service_cfg( ctl_sp->qmux_svc_handle, svc );
    if (svc_cfg == NULL)
    {
      // skip this service - not registered on this qmux link e.g. RRDM
      continue;
    }
    printk(KERN_INFO "QMUX svc %d Version is %d.%d\n", 
             svc,
             svc_cfg->base_version.major,
             svc_cfg->base_version.minor);
    v_out_reqd.n_services++;
    *pout++ = svc;
    memcpy( pout, &svc_cfg->base_version, sizeof(qmux_version_type) );
    pout += sizeof(qmux_version_type);

    /* addendum ver info */
    if(svc_cfg->addendum_version.major == 0)
    {
      /* NO addendum ver to report for this service */
      continue;
    }

    v_out_addendum_opt.n_services++;
    *addendum_opt_out++ = svc;
    memcpy( addendum_opt_out, &svc_cfg->addendum_version, sizeof(qmux_version_type) );
    addendum_opt_out += sizeof(qmux_version_type);
  }

  
  /*------------------------------------------------------------------------- 
    send addendum ver TLV only if there is any addendum ver 
    to report for any service
  -------------------------------------------------------------------------*/
  if(v_out_addendum_opt.n_services > 0)
  {
    printk(KERN_INFO "QMUX addition version num find\n");
    
    addendum_label = QMI_ADDENDUM_LABEL;
	label_len = strlen(addendum_label);

    addendum_svc_ver_info_len = (u16) (addendum_opt_out - (u8*) &v_out_addendum_opt);

    total_bytes_pushed = addendum_svc_ver_info_len + label_len + sizeof(u8);
    addendum_tlv_type = QMI_PRM_TYPE_ADDENDUM_VER_LIST;

    if(! (QMI_SVC_PKT_PUSH_T(&v_out_addendum_opt, addendum_svc_ver_info_len) &&
          QMI_SVC_PKT_PUSH_T(addendum_label, label_len) &&
          QMI_SVC_PKT_PUSH_T(&label_len, sizeof(u8)) &&
          QMI_SVC_PKT_PUSH_T(&total_bytes_pushed, sizeof(u16)) &&
          QMI_SVC_PKT_PUSH_T(&addendum_tlv_type, sizeof(u8))))
    {
      errval = QMI_ERR_NO_MEMORY;
     // dsm_free_packet(&response);
    }
  }

  qmi_svc_put_param_tlv(QMI_TYPE_REQUIRED_PARAMETERS,
                                      (u16) (pout - (u8*) &v_out_reqd),
                                       &v_out_reqd);

  /*-------------------------------------------------------------------------
    Prepend response result and return to input function which will
    finalize the response command header and send it back via QMUX
  -------------------------------------------------------------------------*/
    result = (errval == QMI_ERR_NONE ? QMI_RESULT_SUCCESS
                                   : QMI_RESULT_FAILURE);

    qmi_svc_put_result_tlv(result, errval);

    return 0;
}

static int qmi_ctl_response_p(u8 configNr,struct qmi_pdu_header recv_pdu, u8 *sdu_in)
{
    rndis_resp_t            *r;       
    struct qmi_ctl_sdu_header	recv;
    struct qmi_ctl_pdu_header *resp;
    __u8  *temp,*ctl_sdu_msg;
    u16 resp_len,msg_len;
    qmi_item_pool *resp_buf;
    qmi_instance_e_type qmi_inst;
    qmi_ctli_state_type *ctl_sp;
    
    /*-------------------------------------------------------------------------
    QMI_CTL header:

    field                          length
    +----------------------------+
    | QMI CTL control flags      |    1
    +----------------------------+
    | QMI CTL transaction ID     |    1
    +----------------------------+
    | QMI CTL command number     |    2
    +----------------------------+
    | QMI CTL message length     |    2
    +----------------------------+
    ...
    +----------------------------+
    | QMI CTL message body       |    length bytes
    +----------------------------+
    -------------------------------------------------------------------------*/

    temp = sdu_in;  
    recv.ctl_flag  = qmi_pull8(temp);
    recv.trans_id = qmi_pull8(temp);      
    recv.cmd_val = qmi_pull16(temp);
    recv.msg_len= qmi_pull16(temp);
    ctl_sdu_msg = temp;

    switch (recv.ctl_flag & QMI_CTL_FLAG_MASK_MSGTYPE)
    {
        case QMI_CTL_FLAG_MSGTYPE_CMD:
          break;

        default:
          printk(KERN_INFO "Invalid msg type! (%d) ignoring",
                   recv.ctl_flag & QMI_CTL_FLAG_MASK_MSGTYPE);
          return -EPERM;
    }

    /*-----------------------------------------------------------
       init pool data
    --------------------------------------------------------------*/
    qmi_inst = 0;
    ctl_sp = &qmi_ctl_state[qmi_inst];
    qmi_msg_poolInit(&QMI_ITEM_POOL);
    resp_buf = &QMI_ITEM_POOL;

    switch(recv.cmd_val)
    {
        case  QMI_CTLI_CMD_VAL_GET_VERSION:         //        = 0x0021,
            printk(KERN_INFO "get version\n");
	   usb_configure_suspended = true;
            qmi_ctli_get_version_p(ctl_sp,ctl_sdu_msg);
            break;
        case  QMI_CTLI_CMD_VAL_GET_CLIENT_ID:       //      = 0x0022,
            printk(KERN_INFO "get client,0x%x\n", (unsigned int)ctl_sdu_msg);
            qmi_ctli_get_client_id_p(ctl_sp,ctl_sdu_msg,(s32)recv.msg_len);
            break;
        case  QMI_CTLI_CMD_VAL_RELEASE_CLIENT_ID:       //  = 0x0023,
            printk(KERN_INFO "release client ID,0x%x\n", (unsigned int)ctl_sdu_msg);
            qmi_ctli_release_client_id_p(ctl_sp,ctl_sdu_msg,(s32)recv.msg_len);
            break;
        case  QMI_CTLI_CMD_VAL_SET_INSTANCE_ID:   //    = 0x0020,  
            printk(KERN_INFO "set instance ID,0x%x\n", (unsigned int)ctl_sdu_msg);
            qmi_ctli_set_instance_id_p(ctl_sp,ctl_sdu_msg,(s32)recv.msg_len);    		
            syswatch_nl_send(NULL, QMI_SRV_START);            
	   usb_configure_suspended = false;
            break;            
        case  QMI_CTLI_CMD_VAL_REVOKE_CLIENT_ID:    //   = 0x0024,
        case  QMI_CTLI_CMD_VAL_INVALID_CLIENT_ID:       //  = 0x0025,
        case  QMI_CTLI_CMD_VAL_SET_DATA_FORMAT:   // = 0x0026,
        case  QMI_CTLI_CMD_VAL_WIDTH:       //                 = 0xFFFF
        default:
            break;
    }
 
    /*-----------------------------------------------------------
       fill response buffer
       -----------------------------------------------------------*/
    msg_len = QMI_PKT_MAX_SIZE - resp_buf->bytes_left;
    resp_len = sizeof(struct qmi_pdu_header)+sizeof(struct qmi_ctl_sdu_header)+msg_len;

    if (!qmi_per_dev_params [configNr].dev) return -ENOTSUPP;

    r = qmi_add_response (configNr, resp_len);
    if (!r)
        return -ENOMEM;
    resp = (struct qmi_ctl_pdu_header *) r->buf;    
    
    resp->iflags=recv_pdu.iflags;
    resp->length=resp_len-1;         //reduce the resp->iflags   
    resp->ctl_info=QMUXI_CFLAG_SENDER_SERVICE;
    resp->srv_type=QMUX_SERVICE_CTL;
    resp->client_id=recv_pdu.client_id;

    resp->ctl_flag=QMI_CTL_FLAG_MSGTYPE_RESP;
    resp->trans_id=recv.trans_id;

    resp->cmd_val=recv.cmd_val;
    resp->msg_len=msg_len;     

    memcpy(((u8 *)resp+ sizeof(struct qmi_ctl_pdu_header)),resp_buf->buf + resp_buf->bytes_left, msg_len);

    /*-----------------------------------------------------------
       fill response buffer
       -----------------------------------------------------------*/
    if (qmi_per_dev_params [configNr].ack)
    qmi_per_dev_params [configNr].ack (
    	qmi_per_dev_params [configNr].dev);

    return 0;

}

static int qmi_dms_response_p(u8 configNr,struct qmi_pdu_header recv_pdu, u8 *sdu_in)
{
    rndis_resp_t            *r;       
    struct qmi_ctl_sdu_header	recv;
    struct qmi_srv_pdu_header *resp;
    u16 resp_len,msg_len;
    qmi_item_pool *resp_buf;
    u16 msg_index,msg_index_len;
    qmi_dmsi_cmd_val_e_type msg_id;
    s32 sdu_index;
    struct 
    {
       u16 msg_id;
       u16 msg_len;
    }qmi_srv_msg_header={0};

    /*-------------------------------------------------------------------------
    QMI_SRV header:
    field                          length
    +----------------------------+
    | QMI SRV control flags      |    1
    +----------------------------+
    | QMI SRV transaction ID     |    1
    +----------------------------+
    | QMI SRV message ID     |    2
    +----------------------------+
    | QMI CTL message length     |    2
    +----------------------------+
    ...
    +----------------------------+
    | QMI CTL message body       |    length bytes
    +----------------------------+
    -------------------------------------------------------------------------*/

    recv.ctl_flag  = qmi_pull8(sdu_in);
    recv.trans_id = qmi_pull16(sdu_in);    

    switch(recv.ctl_flag & QMI_SRV_MASK)
    {
        case QMI_SRV_REQUEST:
           printk(KERN_INFO "dms request receive!");          
           break;
        case QMI_SRV_RESPONSE:
           printk(KERN_INFO "Invalid msg type! (%d) ignoring",
                   recv.ctl_flag & QMI_SRV_MASK);            
            return -EPERM;
        case QMI_SRV_INDICAION:
        case QMI_SRV_RESERVE:
        default:
           printk(KERN_INFO "Invalid msg type! (%d) ignoring",
                   recv.ctl_flag & QMI_SRV_MASK);                  
            return -EPERM;
    }

    /*-----------------------------------------------------------
       init pool data
    --------------------------------------------------------------*/
    //qmi_inst = 0;
   // ctl_sp = &qmi_ctl_state[qmi_inst];
    qmi_msg_poolInit(&QMI_ITEM_POOL);
    resp_buf = &QMI_ITEM_POOL;
    sdu_index = recv_pdu.length - sizeof(struct qmi_srv_pdu_header) -1;
    msg_index = 0;

    while (*sdu_in && (sdu_index > 0))
    {  
        msg_id = qmi_pull16(sdu_in);
        msg_index_len= qmi_pull16(sdu_in);
        sdu_index-= sizeof(qmi_srv_msg_header);
        msg_index ++;
        printk(KERN_INFO "DMS No.%d, with msg_id(%d)\n",msg_index,msg_id);

        switch(msg_id)
        {
           case DMSI_CMD_VAL_GET_DEVICE_MFR:
                qmi_dmsi_get_device_mfr();
                qmi_srv_msg_header.msg_id = DMSI_CMD_VAL_GET_DEVICE_MFR;
                qmi_srv_msg_header.msg_len = QMI_PKT_MAX_SIZE - resp_buf->bytes_left;
                qmi_pushdown_package(&qmi_srv_msg_header, sizeof(qmi_srv_msg_header));
                break;
           case DMSI_CMD_VAL_GET_MSISDN: 
                qmi_dmsi_get_msisdn();
                qmi_srv_msg_header.msg_id = DMSI_CMD_VAL_GET_MSISDN;
                qmi_srv_msg_header.msg_len = QMI_PKT_MAX_SIZE - resp_buf->bytes_left;
                qmi_pushdown_package(&qmi_srv_msg_header, sizeof(qmi_srv_msg_header));                
                break;
           case DMSI_CMD_VAL_GET_DEVICE_MODEL_ID:
                qmi_dmsi_get_device_model_id();
                qmi_srv_msg_header.msg_id = DMSI_CMD_VAL_GET_DEVICE_MODEL_ID;
                qmi_srv_msg_header.msg_len = QMI_PKT_MAX_SIZE - resp_buf->bytes_left;
                qmi_pushdown_package(&qmi_srv_msg_header, sizeof(qmi_srv_msg_header));    
                break;
           default:
                break;
        }
        
       qmi_pullup_length(sdu_in, msg_index_len);
       sdu_index-=msg_index_len;        
    };    


    /*-----------------------------------------------------------
       fill response buffer
       -----------------------------------------------------------*/
    msg_len = QMI_PKT_MAX_SIZE - resp_buf->bytes_left;
    resp_len = sizeof(struct qmi_srv_pdu_header)+msg_len;

    if (!qmi_per_dev_params [configNr].dev) return -ENOTSUPP;

    r = qmi_add_response (configNr, resp_len);
    if (!r)
        return -ENOMEM;
    resp = (struct qmi_srv_pdu_header *) r->buf;    
    
    resp->iflags=recv_pdu.iflags;
    resp->length=resp_len-1;         //reduce the resp->iflags   
    resp->ctl_info=QMUXI_CFLAG_SENDER_SERVICE;
    resp->srv_type=QMUX_SERVICE_DMS;
    resp->client_id=recv_pdu.client_id;

    resp->ctl_flag=QMI_SRV_RESPONSE;
    resp->trans_id=recv.trans_id;

    memcpy(((u8 *)resp+ sizeof(struct qmi_srv_pdu_header)),
        resp_buf->buf + resp_buf->bytes_left, msg_len);
    
    /*-----------------------------------------------------------
       send response data
       -----------------------------------------------------------*/
    if (qmi_per_dev_params [configNr].ack)
    qmi_per_dev_params [configNr].ack (
    	qmi_per_dev_params [configNr].dev);

    return 0;
}

int qmi_wds_response_p(u8 configNr,u8 *pdu_in)
{
  rndis_resp_t            *r;       
  u8  *tmp;
  u8  type;
  u16 resp_len;

  printk(KERN_INFO "qmi_wds_response_p: start.\n");

  /*-----------------------------------------------------------
    send pdu request buffer to tty
  -----------------------------------------------------------*/   
  tmp = pdu_in;
  type = qmi_pull8(tmp);
  switch (type)
  {
      case QMUXI_IFTYPE_QMUX:
        break;

      default:
        printk(KERN_INFO "qmi_wds_response_p:Invalid control frame type: %d.\n", type);
        return -EFAULT;
  }

  /*-----------------------------------------------------------
     fill response buffer
  -----------------------------------------------------------*/
  resp_len = qmi_pull16(tmp);
  if(resp_len == 0)
  {
      printk(KERN_INFO "qmi_wds_response_p:error length wds package\n");
      return -EFAULT;
   }
      
  if (!qmi_per_dev_params[configNr].dev) 
  {
    printk(KERN_INFO "qmi_wds_response_p: dev is zero.\n");
    return -ENOTSUPP;
  }

  /* add IF len.*/
  resp_len++;
  r = qmi_add_response (configNr, resp_len);
  if (!r)
  {
    printk(KERN_INFO "qmi_wds_response_p:qmi_add_response error\n");
    return -ENOMEM;
  }

  memcpy(r->buf,pdu_in, resp_len);

  /*send response data*/
  if (qmi_per_dev_params [configNr].ack)
  {
    qmi_per_dev_params [configNr].ack(qmi_per_dev_params [configNr].dev);
  }

  printk(KERN_INFO "qmi_wds_response_p: ok.\n");

  return 0;
}
EXPORT_SYMBOL(qmi_wds_response_p);

struct qmi_function *qmi_tty_func=NULL;

int qmi_tty_register(struct qmi_function* qmi_tty)
{
    int ret = 0;
    
    qmi_tty_func = kzalloc(sizeof(*qmi_tty_func), GFP_KERNEL);
    if (!qmi_tty_func) {
            ret = -ENOMEM;
            goto fail;
    }

    qmi_tty_func=qmi_tty;

fail:
    return ret;
}
EXPORT_SYMBOL(qmi_tty_register);

/*
 * Message Parser
 */
 int qmi_msg_parser_p (u8 configNr, u8 *buf)
{
    u8 *tmp,*sdu_buf;
    struct qmi_pdu_header recv_pdu;    

    if (!buf)
        return -ENOMEM;

    /*=== parse QMI PDU header=================================

        "B1" + "B2B3" + "B4"+"B5"+"B6" 
        B1:  		byte1 "01", Interface
        B2B3:       pdu length
        B4:  		Ctl_flags: 00 for contol as interrupt, 80 for service
        B5: 		Service_type: 00 (CTL), 01(WDS), 02(DMS),03(NAS)
        B6: 		client ID
    ====================================================*/
    tmp = buf;
    recv_pdu.iflags = qmi_pull8(tmp);
    recv_pdu.length = qmi_pull16(tmp); 
    recv_pdu.ctl_info = qmi_pull8(tmp);
    recv_pdu.srv_type = qmi_pull8(tmp);
    recv_pdu.client_id = qmi_pull8(tmp);
    sdu_buf = tmp;    
    
    switch (recv_pdu.iflags)
    {
        case QMUXI_IFTYPE_QMUX:
          break;
        default:
          printk(KERN_INFO "Invalid control frame type ");
          return -EFAULT;
    }
      
    /*handle msg instance */ 
    switch(recv_pdu.srv_type)
    {
        case QMUX_SERVICE_CTL :          /* QMI service control           */
            return qmi_ctl_response_p(configNr,recv_pdu,sdu_buf);
        case QMUX_SERVICE_WDS:             /* Wireless Data service         */
            if(!usb_configure_suspended)
	   {
		if(qmi_tty_func->send == NULL){

		    printk("qmi_tty_func not registered");
			return -EFAULT;
		}
		printk("qmi send REQ buffer to TTY\n");           
		qmi_tty_func->send(configNr,buf);
	    } else
            {
    	        printk("usb_configure_suspended!!!\n");
            }   
            return 0;
        case QMUX_SERVICE_DMS:            /* Device Management service     */
            return qmi_dms_response_p(configNr,recv_pdu,sdu_buf);
        case QMUX_SERVICE_NAS:            /* Network Access service        */
            return 0;
        default:
            break;
    }

    return -ENOTSUPP;
}

