/* ehci-msm.h - HSUSB Host Controller Driver Header
 *
 * Copyright (c) 2008 QUALCOMM USA, INC.
 *
 * All source code in this file is licensed under the following license except
 * where indicated.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can find it at http://www.fsf.org
 */

#ifndef _EHCI_MSM_H
#define _EHCI_MSM_H

#define USB_SBUSCFG	(MSM_USB_BASE + 0x0090)
#define USB_AHB_MODE	(MSM_USB_BASE + 0x0098)

#define USB_CAPLENGTH	(MSM_USB_BASE + 0x0100) /* 8 bit */
#define USB_USBCMD	(MSM_USB_BASE + 0x0140)
#define USB_PORTSC	(MSM_USB_BASE + 0x0184)
#define USB_USBMODE	(MSM_USB_BASE + 0x01A8)

#define USB_ULPI_VIEWPORT    (MSM_USB_BASE + 0x0170)

/* usb mode bit settings */
#define USBMODE_VBUS	(1 << 5)	/* vbus power select */
#ifdef USBMODE_SDIS
#undef USBMODE_SDIS
#define USBMODE_SDIS	(1<<4)	/* Stream disable */
#endif

/* portsc bit settings */
#define PORT_ULPI		(2 << 30) /* port ulpi enable */
#define PORTSC_PHCD		(1 << 23) /* phy suspend mode */
#define ASYNC_INTR_CTRL		(1 << 29)

#define ULPI_WAKEUP		(1 << 31)
#define ULPI_RUN		(1 << 30)
#define ULPI_WRITE		(1 << 29)
#define ULPI_READ		(0 << 29)
#define ULPI_STP_CTRL		(1 << 30)
#define ULPI_STATE_NORMAL	(1 << 27)
#define ULPI_C_VBUS_VALID_RISE	(1 << 1)
#define ULPI_C_SESS_END_RISE	(1 << 3)
#define ULPI_C_VBUS_VALID_FALL	(1 << 1)
#define ULPI_C_SESS_END_FALL	(1 << 3)
#define ULPI_ADDR(n)		(((n) & 255) << 16)
#define ULPI_DATA(n)		((n) & 255)
#define ULPI_DATA_READ(n)	(((n) >> 8) & 255)

#define SBUSCFG_AHBBRST_INCR4	0x01
#endif
