/*
 *
 * Copyright (C) 2008 QUALCOMM USA, INC.
 * 
 * All source code in this file is licensed under the following license
 * except where indicated.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can find it at http://www.fsf.org
 *
 */

#ifndef ARDI_H
#define ARDI_H

#include "msm8k_cad_module.h"
#include "msm8k_ard.h"
#include "msm8k_cad_itypes.h"

#define ARD_AUDIO_MAX_CLIENT  5


enum ard_state_enum_type {
	ARD_STATE_RESET,
	ARD_STATE_CLK_ACTIVE,
	ARD_STATE_AFE_ACTIVE,
	ARD_STATE_ACTIVE
};

enum codec_enum_type {
	CODEC_INT,
	CODEC_AUX_PCM,
	CODEC_I2S,
	CODEC_ERROR
};

enum ard_state_ret_enum_type {
	ARD_STATE_RC_SUCCESS,
	ARD_STATE_RC_CONTINUE
};

enum ard_ret_enum_type {
	ARD_FALSE = 0,
	ARD_TRUE
};

enum ard_session_enum_type {
	DEVICE_CTRL_TYPE,
	STREAM_TYPE,
};

struct ard_global_data_struct_type {
	u32		audio_device;
	u32		voice_device;
};

struct ard_session_info_struct_type {
	enum ard_session_enum_type	session_type;
	struct cadi_open_struct_type	*sess_open_info;
	struct cadi_evt_struct_type	*ev_buf;
	void				*cmd_buf;
	enum sample_rate_type		rx;
	enum sample_rate_type		tx;
	u8				enabled;
	void				*p_local_format_block;
};

struct ard_state_struct_type {
	u32				state;
	u8				device_configured;
	enum snd_device_enum_type	device_inuse;
	struct mutex			device_mutex;
	enum ard_ret_enum_type		afe_enabled;
};


enum ard_ret_enum_type valid_session_present(void);

enum codec_enum_type get_codec_type(void);

s32 qdsp6_enable(s32 ses_id);
s32 qdsp6_disable(s32 ses_id);

s32 adie_enable(s32 ses_id);
s32 adie_disable(s32 ses_id);

void ard_callback_func(struct cadi_evt_struct_type *ev_data,
		       void *client_data);

enum ard_state_ret_enum_type ard_state_control(s32 ses_id);
enum ard_state_ret_enum_type ard_state_reset(s32 ses_id);
enum ard_state_ret_enum_type ard_state_clk_active(s32 ses_id);
enum ard_state_ret_enum_type ard_state_afe_active(s32 ses_id);
enum ard_state_ret_enum_type ard_state_active(s32 ses_id);

#endif
