/*
 *
 * Copyright (C) 2008 QUALCOMM USA, INC.
 * 
 * All source code in this file is licensed under the following license
 * except where indicated.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can find it at http://www.fsf.org
 *
 */

#ifndef CADIOCTL_H
#define CADIOCTL_H

#include <linux/types.h>


enum cad_stream_app_enum_type {
	CAD_STREAM_APP_UNKNOWN                  = 0x00,
	CAD_STREAM_APP_VOICE                    = 0x01,
	CAD_STREAM_APP_PLAYBACK                 = 0x02,
	CAD_STREAM_APP_KEY_BEEP                 = 0x04,
	CAD_STREAM_APP_RINGER                   = 0x08,
	CAD_STREAM_APP_SYSTEM_SOUND             = 0x10,
	CAD_STREAM_APP_RECORD                   = 0x20
};


enum cad_stream_buf_mem_type {
	CAD_STREAM_BUF_MEM_UNKNOWN                 = 0x00,
	CAD_STREAM_BUF_MEM_HEAP                    = 0x01,
	CAD_STREAM_BUF_MEM_TYPE_CONTIGUOUS_HEAP    = 0x02
};


#define CAD_IOCTL_CMD_SET_STREAM_EVENT_LSTR                 0x01075ee6

#define CAD_IOCTL_CMD_STREAM_START                          0x01075ee7

#define CAD_IOCTL_CMD_STREAM_PAUSE                          0x01075ee8

#define CAD_IOCTL_CMD_STREAM_RESUME                         0x01075ee9

#define CAD_IOCTL_CMD_STREAM_FLUSH                          0x01075eea

#define CAD_IOCTL_CMD_SET_STREAM_DEVICE                     0x01075eec

#define CAD_IOCTL_CMD_SET_STREAM_CONFIG                     0x01075eed

#define CAD_IOCTL_CMD_SET_STREAM_INFO                       0x01075eee

#define CAD_IOCTL_CMD_SET_STREAM_FILTER_CONFIG              0x01075eef

#define CAD_IOCTL_CMD_SET_STREAM_AV_SYNC                    0x0107605c

#define CAD_IOCTL_CMD_DEVICE_SET_FILTER_CONFIG              0x01075ef0

#define CAD_IOCTL_CMD_DEVICE_SET_CAL                        0x01075ef1

#define CAD_IOCTL_CMD_DEVICE_SET_GLOBAL_DEFAULT             0x01075ef2



struct cad_device_struct_type {
	u32  ul_device;
	u32  ul_reserved;
};

typedef void (*cad_evt_cb_func_type)(u32 ul_event, void *p_evt_packet,
		u32 ul_evt_packet_len, void *client_data);

struct cad_event_struct_type {
	cad_evt_cb_func_type    pfn_callback;
	void                    *p_client_data;
};


struct cad_stream_config_struct_type {
	void    *p_format_block;
	u32             ul_format_block_len;
};

struct cad_stream_info_struct_type {
	enum cad_stream_app_enum_type   app_type;
	u32  ul_ses_buf_max_size;
	enum cad_stream_buf_mem_type    buf_mem_type;
	u32 ul_priority;
};

struct cad_stream_filter_struct_type {
	void    *p_format_block;
	u32  ul_format_block_len;
};

struct cad_stream_device_struct_type {
	u32 *p_device;
	u32 ul_device_len;
};

struct cad_stream_av_sync_struct_type {
	u32 ul_av_sync_interval;
};

#endif
