/*
 *
 * Copyright (C) 2008 QUALCOMM USA, INC.
 * 
 * All source code in this file is licensed under the following license
 * except where indicated.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can find it at http://www.fsf.org
 *
 */

#ifndef _MSM8K_CAD_Q6DEC_DRVI_H_
#define _MSM8K_CAD_Q6DEC_DRVI_H_
/*======================================================
FILE:      msm8k_cad_q6dec_drvi.h

SERVICES:

   This is the internal header file for the CAD QDSP6 audio decoder

GENERAL DESCRIPTION:

  This file contains the external interface funciton for the QDSP6 audio decodor

FUNCTIONS

   NONE

============================================================================*/
#include <asm/arch/msm8k_cad_module.h>
#include <linux/mutex.h>
#include <asm/semaphore.h>


#define CAD_DEC_DRVI_MAX_STREAM_COUNT                   4
#define CAD_DEC_DRVI_BUFFER_NUM_PER_STREAM              4
#define CAD_DEC_DRVI_BUFFER_SIZE                        1024*4

enum cad_dec_drvi_session_state {
	CAD_DEC_DRVI_RESET = 0, /* not avialable */
	CAD_DEC_DRVI_READY,
	CAD_DEC_DRVI_PROCESSING,
	CAD_DEC_DRVI_CLOSING
};

struct cad_dec_drvi_sesson_buffer_node;
struct cad_dec_drvi_sesson_buffer_node {
	u8                                              *buf;
	u32						phys_addr;
	struct cad_dec_drvi_sesson_buffer_node          *next;
};

struct cad_dec_drvi_session_data;
struct cad_dec_drvi_session_data {
	struct mutex                                    session_mutex;
	u32                                             session_id;
	/* This is the shared buffer pointer for data */
	s32                                             pmem_fd;
	u8                                              *shared_buf;
	/* init to CAD_DEC_DRVI_BUFFER_NUM_PER_STREAM */
	struct semaphore                                all_buf_done_mutex;
	struct semaphore                                free_buff_count_mutex;
	struct cad_dec_drvi_sesson_buffer_node          *free_buf_list;
	struct cad_dec_drvi_sesson_buffer_node          *used_buf_list;
	enum cad_dec_drvi_session_state                 session_state;
	struct cad_dec_drvi_session_data                *next;
};

struct cad_dec_drvi_data {
	struct cad_dec_drvi_session_data         *free_session_list;
	struct cad_dec_drvi_session_data         *used_session_list;
};

#endif /* _MSM8K_CAD_Q6DEC_DRVI_H_ */
