/*
 *
 * Copyright (C) 2008 QUALCOMM USA, INC.
 * 
 * All source code in this file is licensed under the following license
 * except where indicated.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can find it at http://www.fsf.org
 *
 */

#ifndef _QDSP6_CADDECSESSION_H_
#define _QDSP6_CADDECSESSION_H_
/*======================================================
FILE:      qdsp6_caddecsession.h

SERVICES:

   This is the header file for cad q6decoder session functions

GENERAL DESCRIPTION:

  This file contains the internal functions for the QDSP6 audio decodor

EXTERNALIZED FUNCTIONS

   QDSP6AudioDecSession_SessionInit
   Init function for the decoder sessoin

   QDSP6AudioDecSession_SessionDeInit
   DeInit function for the decoder sessioin

   QDSP6AudioDecSession_SessionOpen
   Initialize all the decoder resource needed for the specified session


   QDSP6AudioDecSession_SessionWrite
   Used the push session data to the QDSP6

   QDSP6AudioDecSession_SessionClose
   Release all the decoder related resource for the current session

   QDSP6AudioDecSession_SessionPause
   Pause the current pushing of the session data

   QDSP6AudioDecSession_SessionResume
   Resume the paused action

============================================================================*/
#include <asm/arch/msm8k_cad_q6dec_drvi.h>

/* These functions are only called during the driver init and deinit */
s32 cad_q6dec_session_init(struct cad_dec_drvi_session_data *self);
s32 cad_q6dec_session_deinit(struct cad_dec_drvi_session_data *self);
s32 cad_q6dec_session_open(struct cad_dec_drvi_session_data *self,
				u32 session_id,
				struct cad_open_struct_type *open_param);
s32 cad_q6dec_session_write(struct cad_dec_drvi_session_data *self,
				struct cad_buf_struct_type *buffer);
s32 cad_q6dec_session_close(struct cad_dec_drvi_session_data *self);



#endif /* _QDSP6_CADDECSESSION_H_ */
