/* include/asm-arm/arch-msm/qdsp5/qdsp5audplaymsg.h
 *
 * Copyright (c) 2008 QUALCOMM USA, INC.
 * 
 * All source code in this file is licensed under the following license
 * except where indicated.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can find it at http://www.fsf.org
 *
 */

#ifndef QDSP5AUDPLAYMSG_H
#define QDSP5AUDPLAYMSG_H

#define AUDPLAY_MSG_DEC_NEEDS_DATA		0x0001
#define AUDPLAY_MSG_DEC_NEEDS_DATA_MSG_LEN	\
	sizeof(audplay_msg_dec_needs_data)

typedef struct{
   /* reserved*/
  unsigned int dec_id;

  /*The read pointer offset of external memory till which bitstream
    has been dmed in*/
  unsigned int adecDataReadPtrOffset;

  /*	The buffer size of external memory. */
  unsigned int adecDataBufSize;

  unsigned int 	bitstream_free_len;
  unsigned int	bitstream_write_ptr;
  unsigned int	bitstarem_buf_start;
  unsigned int	bitstream_buf_len;
} __attribute__((packed)) audplay_msg_dec_needs_data;

#define AUDPLAY_MSG_BUFFER_UPDATE 0x0004
#define AUDPLAY_MSG_BUFFER_UPDATE_LEN \
  sizeof(audplay_msg_buffer_update)

typedef struct {
  unsigned int buffer_write_count;
  unsigned int num_of_buffer;
  unsigned int buf0_address;
  unsigned int buf0_length;
  unsigned int buf1_address;
  unsigned int buf1_length;
} __attribute__((packed)) audplay_msg_buffer_update;

#endif /* QDSP5AUDPLAYMSG_H */
