################################################################################
# -----------------------------------------------------------------------------
# Copyright (c) 2008 QUALCOMM Incorporated.  All Rights Reserved.  
# QUALCOMM Proprietary and Confidential.
# -----------------------------------------------------------------------------
################################################################################

# sources and intermediate files are separated
vpath %.c $(SRCDIR)

CPPFLAGS += $(QCT_CPPFLAGS)
CPPFLAGS += -I$(SRCDIR)

CFLAGS += $(QCT_CFLAGS) -D__packed__= -DIMAGE_APPS_PROC -DFEATURE_Q_SINGLE_LINK -DFEATURE_Q_NO_SELF_QPTR -DFEATURE_LINUX -DFEATURE_NATIVELINUX -DFEATURE_DSM_DUP_ITEMS -DTARGET_msm7625 -Wundef -Wstrict-prototypes -Wno-trigraphs -Werror -fpic -shared

all: libstringl.so.$(LIBVER)

libstringl.so.$(LIBVER): strlcat.c strlcpy.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(QCT_CFLAGS_SO) $(QCT_LDFLAGS_SO) -Wl,-soname,libstringl.so.$(LIBMAJOR) -o $@ $^


###############################################################################
# Test Target
###############################################################################
ifdef BUILD_TEST

test_stringl: libstringl.so.$(LIBVER)

all: test_stringl

# build invoked elsewhere to keep sources and intermediate files separate
vpath %.c $(SRCDIR)/test

TEST_STRINGL_LDLIBS += $(OBJDIR)/libstringl.so.$(LIBVER)

test_stringl: test_stringl.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(TEST_STRINGL_LDLIBS)

endif	# BUILD_TEST

