#!/bin/sh

# Environment Parameters
IMAGEPATH=/bin
NETIF=${NETIF:-eth0}
EEPROM="pa.bin"
if [ -e /mnt/flash/eeprom ]
then
   EEPROM=/mnt/flash/`cat /mnt/flash/eeprom`
fi

echo "~~~~~~~~~~EEPROM file =" $EEPROM
# configure mac address
if [ -e /mnt/flash/mac ]
then
   mac=`cat /mnt/flash/mac`
else
   mac="00:18:00:00:aa:dd"
fi
echo "macaddress!!!!! = " $mac

/bin/ar6k_load_un.sh
echo reset >/dev/wifi_reset

/sbin/insmod msm_sdcc

# Insert ar6k module and let it stay in BMI state
/sbin/insmod $IMAGEPATH/ar6000.ko bmienable=1 fwmode=2

# Disable System Sleep on AR6002
old_options=`$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x180c0 --or=8`
old_sleep=`$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x40c4 --or=1`
echo "old_options=" $old_options
echo "old_sleep=" $old_sleep

# Clock set
$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x4020 --param=0
ext_clk_detected=`$IMAGEPATH/bmiloader -i $NETIF --quiet --get --address=0x50047c`
if [ $ext_clk_detected = 0x0 ]
then
    $IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x40e0 --param=0x100000
fi

$IMAGEPATH/eeprom.AR6002 --transfer --file=$EEPROM --setmac=$mac --interface=$NETIF
$IMAGEPATH/bmiloader -i $NETIF --write --address=0x502400 --file=athwlan.bin.z77 --uncompress
$IMAGEPATH/bmiloader -i $NETIF --write --address=0x52d8bc --file=data.patch.hw2_0.bin
$IMAGEPATH/bmiloader -i $NETIF --write --address=0x500418 --param=0x52d8bc

# Restore System Sleep on AR6002
$IMAGEPATH/bmiloader -i $NETIF --set --address=0x40c4 --param=$old_sleep > /dev/null
$IMAGEPATH/bmiloader -i $NETIF --set --address=0x180c0 --param=$old_options > /dev/null

# Enable HI_OPTION_TIMER_WAR (timerwar)
$IMAGEPATH/bmiloader -i $NETIF --set --address=0x500410 --or=1

# Leave BMI now and start the WLAN driver.
$IMAGEPATH/bmiloader -i $NETIF --done

sleep 2


if [ -e /mnt/flash/ssid ]
then
   ssid=`cat /mnt/flash/ssid`
else
   ssid=E5832
fi
echo "ssid = " $ssid

#ifconfig $NETIF hw ether $mac

# Others
brctl addif br0 $NETIF
ifconfig $NETIF up
iwconfig $NETIF channel 1
iwconfig $NETIF essid $ssid
iwconfig $NETIF commit
exit 0
