#!/bin/sh

# Environment Parameters
IMAGEPATH=/bin
NETIF=${NETIF:-eth0}

EEPROM="pa.bin"

mac="00:18:00:00:aa:ef"



/sbin/insmod msm_sdcc

# Insert ar6k module and let it stay in BMI state
/sbin/insmod $IMAGEPATH/ar6000.ko bmienable=1 fwmode=2

# Disable System Sleep on AR6002
old_options=`$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x180c0 --or=8`
old_sleep=`$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x40c4 --or=1`

# Clock set
$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x4020 --param=0
ext_clk_detected=`$IMAGEPATH/bmiloader -i $NETIF --quiet --get --address=0x50047c`
if [ $ext_clk_detected = 0x0 ]
then
    $IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x40e0 --param=0x100000
fi

$IMAGEPATH/eeprom.AR6002 --transfer --file=$EEPROM --setmac=$mac --interface=$NETIF
$IMAGEPATH/bmiloader -i $NETIF --write --address=0x502400 --file=athwlan.bin.z77 --uncompress
$IMAGEPATH/bmiloader -i $NETIF --write --address=0x52d8bc --file=data.patch.hw2_0.bin
$IMAGEPATH/bmiloader -i $NETIF --write --address=0x500418 --param=0x52d8bc

# Restore System Sleep on AR6002
$IMAGEPATH/bmiloader -i $NETIF --set --address=0x40c4 --param=$old_sleep > /dev/null
$IMAGEPATH/bmiloader -i $NETIF --set --address=0x180c0 --param=$old_options > /dev/null

# Enable HI_OPTION_TIMER_WAR (timerwar)
$IMAGEPATH/bmiloader -i $NETIF --set --address=0x500410 --or=1

# Leave BMI now and start the WLAN driver.
$IMAGEPATH/bmiloader -i $NETIF --done

sleep 1

echo "interface=eth0">/tmp/hostapd.conf
echo "bridge=br0">>/tmp/hostapd.conf
echo "driver=ar6000">>/tmp/hostapd.conf
echo "debug=0">>/tmp/hostapd.conf
echo "ssid=e5832test">>/tmp/hostapd.conf


iwconfig eth0 essid e5832test
wmiconfig -i eth0 --wmode g
wmiconfig -i eth0 --hiddenssid 0
wmiconfig -i eth0 --setcountry CN
iwconfig eth0 channel 13
wmiconfig -i eth0 --setfixrates 11

echo "max_num_sta=4">>/tmp/hostapd.conf

iwconfig eth0 commit
/bin/hostapd_wps /tmp/hostapd.conf &

exit 0
