#!/bin/sh

# Environment Parameters
IMAGEPATH=/bin
NETIF=${NETIF:-eth0}
EEPROM="pa.bin"
PATCH_FILE=data.patch.pa.bin
PATCH_ADDR=0x52d8b0
logfile="/mnt/flash/dbglog.txt"
logsize=10000

if [ -e /tmp/imagepath ]
then
   IMAGEPATH=`cat /tmp/imagepath`
fi

if [ -e /tmp/wlanifc ]
then
   NETIF=`cat /tmp/wlanifc`
fi

if [ -e /tmp/eeprom ]
then
   EEPROM=`cat /tmp/eeprom`
fi

######/* BB5D05622 z00125912, begin 2010/4/29 */
if [ ${EEPROM} == "pa.bin" ]
then
    EEPROM="/bin/pa.bin"
    PATCH_FILE=data.patch.pa.bin
    PATCH_ADDR=0x52d8b0
    if [ -f /mnt/pa_res/pa.bin ]
    then
        EEPROM="/mnt/pa_res/pa.bin"
    fi
    if [ -f /mnt/flash/pa.bin ]
    then
        EEPROM="/mnt/flash/pa.bin"
    fi	
fi

if [ ${EEPROM} == "nopa.bin" ]
then
    EEPROM="/bin/nopa.bin"
    PATCH_FILE=data.patch.nopa.bin
    PATCH_ADDR=0x52d8bc
    if [ -f /mnt/pa_res/nopa.bin ]
    then
        EEPROM="/mnt/pa_res/nopa.bin"
    fi
    
    if [ -f /mnt/flash/nopa.bin ]
    then
        EEPROM="/mnt/flash/nopa.bin"
    fi
fi
##########/* BB5D05622 z00125912, end 2010/4/29 */

# configure mac address
if [ -e /tmp/mac ]
then
   mac=`cat /tmp/mac`
else
   mac="00:18:00:00:aa:dd"
fi


killall recEvent

/sbin/insmod msm_sdcc

# Run rcvEvent, to receive target event
$IMAGEPATH/recEvent $logfile $logsize > /dev/null 2>&1 &

# Insert ar6k module and let it stay in BMI state
/sbin/insmod $IMAGEPATH/ar6000.ko bmienable=1 fwmode=2

# Disable System Sleep on AR6002
$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x180c0 --or=8
$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x40c4 --or=1

# Clock set
$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x4020 --param=0
$IMAGEPATH/bmiloader -i $NETIF --quiet --set --address=0x40e0 --param=0x100000

$IMAGEPATH/eeprom.AR6002 --transfer --file=$EEPROM --setmac=$mac --interface=$NETIF

$IMAGEPATH/bmiloader -i $NETIF --write --address=0x502400 --file=$IMAGEPATH/athwlan.bin.z77 --uncompress

$IMAGEPATH/bmiloader -i $NETIF --write --address=$PATCH_ADDR --file=$IMAGEPATH/$PATCH_FILE
$IMAGEPATH/bmiloader -i $NETIF --write --address=0x500418 --param=$PATCH_ADDR

# Enable HI_OPTION_TIMER_WAR (timerwar)
$IMAGEPATH/bmiloader -i $NETIF --set --address=0x500410 --or=1

# Leave BMI now and start the WLAN driver.
$IMAGEPATH/bmiloader -i $NETIF --done

sleep 1

echo "IMAGE PATH:  " $IMAGEPATH
echo "MAC ADDR:    " $mac
echo "EEPROM FILE: " $EEPROM
echo "PATCH FILE:  " $PATCH_FILE
echo "PATCH ADDR:  " $PATCH_ADDR
echo "logfile:     " $logfile
echo "logsize:     " $logsize


exit 0
