# Script to test the mpp driver.

cd /debug/mpp/ 2>/dev/null
if [ $? -ne 0 ]; then
	echo "Unable to find /debug/mpp/"
	echo "Debug fs support required to proceed with tests."
	exit 1;
fi

mfailed=0
mpp="mpp1"
echo "Testing MPP"
echo "============"
status=`cat $mpp`
level=0
control=0
x=65535
y=1048575
config=$(( (($level & $x)<<16)|($control & $y) ))
status=`cat $mpp`
echo  "$config" > $mpp
status=`cat $mpp`
if [ $status -ne 0 ]; then
   echo "FAILED: mpp_config_digital_out"
   mfailed=$(($mfailed + 1))
fi
if [ $mfailed -eq 0 ]; then
   echo "ALL MPP TESTS PASSED"
fi

failed=$(($mfailed))
if [ $failed -ne 0 ]; then
  exit 1;
else
  exit 0;
fi

