# Script to test the vreg driver.

cd /debug/vreg/ 2>/dev/null
if [ $? -ne 0 ]; then
	echo "Unable to find /debug/vreg/"
	echo "Debug fs support required to proceed with tests."
	exit 1;
fi

vfailed=0
vreg="usb"
echo "Testing VREG"
echo "============"
status=`cat $vreg`
echo  "2850" > $vreg
status=`cat $vreg`
if [ $status -ne 0 ]; then
   echo "FAILED: vreg_set_level"
   vfailed=$(($vfailed + 1))
fi
echo  "0" > $vreg
status=`cat $vreg`
if [ $status -ne 0 ]; then
   echo "FAILED: vreg_disable"
   vfailed=$(($vfailed + 1))
fi
echo  "1" > $vreg
status=`cat $vreg`
if [ $status -ne 0 ]; then
   echo "FAILED: vreg_enable"
   vfailed=$(($vfailed + 1))
fi
if [ $vfailed -eq 0 ]; then
   echo "ALL VREG TESTS PASSED"
fi

failed=$(($vfailed))
if [ $failed -ne 0 ]; then
  exit 1;
else
  exit 0;
fi

