#ifndef CM_H_trimmed
#define CM_H_trimmed
/*=============================================================================
  @file  cm.h

  ---------------------------------------------------------------------------
  Copyright (c) 2009 QUALCOMM Incorporated. 
  All Rights Reserved. QUALCOMM Proprietary and Confidential.
  ---------------------------------------------------------------------------

  $Id: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $

  Notes: 
     ==== Auto-Generated File, do not edit manually ====
     Generated from build type: ASNCABLBH 
     #defines containing SNCABLBH replaced with ________
=============================================================================*/

#ifndef CM_H
#define CM_H

/**==========================================================================
@FILE_DOC

              C A L L   M A N A G E R   H E A D E R   F I L E

DESCRIPTION
  This header file contains all the definitions necessary for
  clients to interface with the Call Manager module.

Copyright (c) 2002 - 2008 by QUALCOMM INCORPORATED. All Rights Reserved.

Export of this technology or software is regulated by the U.S. Government.
Diversion contrary to U.S. law prohibited.

===========================================================================*/

/** A new error type for WMS-CM-NAS interaction.
** Again CM acts like a pipe only.
*/
#define CM_API_NAS_NO_ERROR_CP_ACK

/** Add new activation code */
#define CM_API_OTASP_ACTIVATE_CODE

/** Support for FEATURE_HDR_EMPA
*/
#define CM_API_FEATURE_HDR_EMPA

/** Client type GSDI. */
#define CM_API_CLIENT_TYPE_GSDI

/** Client type BREW_APPS. */
#define CM_API_CLIENT_TYPE_BREW_APPS

/** Cleint type PBM
*/
#define CM_API_CLIENT_TYPE_PBM

/** Added several new enums
*/
#define CM_API_CM_DBM_CMD_ERR_PAYLOAD_NULL_PTR_P
#define CM_API_CM_DBM_CMD_ERR_PAYLOAD_SIZE_P
#define CM_API_CM_PD_CMD_ERR_PAYLOAD_SIZE_P
#define CM_API_CM_PD_CMD_ERR_PAYLOAD_NULL_PTR_P
#define CM_API_CM_PH_CMD_ERR_DDTM_SRV_OPTIONS_LIST_P

/** Client type CM_CLIENT_TYPE_OEMTELEPHONE
*/
#define CM_API_CLIENT_TYPE_OEMTELEPHONE

/** Client type CM_CLIENT_TYPE_MFLO
*/
#define CM_API_CLIENT_TYPE_MFLO

/** Client type DS_BCMCS
*/
#define CM_API_CLIENT_TYPE_DS_BCMCS

/** API change for the new PD session functionality
*/

#define CM_API_PD_SESSION

/** Integration of the BCMCS DS to CM to HDRMC path
*/
#define CM_API_BCMCS_DS_CM_HDRMC_PATH_INTEGRATION

/** New USSD pack/unpack functions.
*/
#define CM_API_UTIL_USSD_FUNCTIONS

/** To differentiate between the old call throttle API without packet_zone
** support and the new call throttle API with packet_zone support
*/
#define CM_API_ORIG_THR_PKT_ZONE

/** Report highest layer call origination failure as part of call events
*/
#define CM_API_HIGHEST_LAYER_CALL_ORIG_FAIL

/** Externalized misc utility functions from cmutil.c
*/
#define CM_API_MISC_UTIL_FUNCTIONS

/** Origination throttle support
*/
#define CM_API_ORIG_THR

/**
** Indicates that client needs to call on cm_ph_net_list_copy()
** to get more detailed CMPH information
** If this flag is not defined, client needs to call on net_list_copy_func
** provided as part of CMPH event info structure
*/
#define CM_API_STATIC_FUNC_FOR_EXTRA_EVENT_INFO

/** Secondary PDP support in CM can be detected by checking for this define
*/
#define CM_API_SEC_PDP

/** Support for User to user data signaling can be detected by
** checking for this define
*/
#define CM_API_USER_USER_DATA

/** Support for PRL preferences in CM can be detected by checking for this
** define.
*/
#define CM_API_SYS_SEL_PRL_PREF

/** Support for WLAN in CM can be detected by checking for this
** define.
*/
#define CM_API_WLAN

/** Support for Remote WMS.  This would require CM to handle certain NAS events
** and commands for WMS.
*/
#define CM_API_REMOTE_WMS

/** Support for VideoTelephony Call support.
*/
#define CM_API_VT

/** Support for USSD data coding scheme enums and macros
*/
#define CM_API_USSD_DCS

/** Support for 64 Bit Band Preferences.
*/
#define CM_API_BAND_PREF_64_BIT

/** Support for IP call api in CM can be detected by checking for this
** define.
*/
#define CM_API_IP_CALL

/** Support for GW ciphering indication
*/
#define CM_CIPHERING_IND_SUPP

/** Support for Call Completion to busy subscriber
*/
#define CM_API_CCBS

/** Support for IP call cause values
*/
#define CM_API_IP_CAUSE

/** Support for HPLMN search request
*/
#define CM_API_INITIATE_HPLMN_SRCH

/** Changes to PDP modify API request
*/
#define CM_API_CHG_PDP_MOD

/** Support for reporting emergency number list
*/
#define CM_API_EMERGENCY_NUM_LIST

/** Supporting additional incoming substates
*/
#define CM_API_ADD_INCOM_SUBST

/** Support for Video Share
*/
#define CM_API_VIDEOSHARE

/** Support for WCDMA900 band class (BC3,4,8,9)
*/
#define CM_API_WCDMA900

/** Support for change CM_BAND_PREF_NO_CHANGE to 0x40000000
**                    CM_BAND_PREF_ANY to 0xFFFFFFFFBFFFFFFFULL
**                    CM_BAND_PREF_MAX tp CM_BAND_PREF_ANY + 1
*/
#define CM_API_BAND_PREF_NO_CHANGE_ANY_MAX_UPDATE

/** Support for Advice of Charge info
*/
#define CM_API_AOC_INFO

/** Support for sending unparsed L3 data from MN to clients
*/
#define CM_SUPS_UNPARSED_L3_DATA

/** Api's and enums for VT fallback to Voice
** feature
*/
#define CM_API_VT_FALLBACK_TO_VOICE

/** Support for emergency service category in
** call orig and call control
*/
#define CM_API_ECATEG_IN_NUM_STRUCT

/** Support to inform client on the success/failure
** of PLMN list request
*/
#define CM_API_AVAIL_NET_LIST_CNF

/** Supports SS events for cell supported services
*/
#define CM_API_CELL_SUPP_SERVICES

/** Defines support for GW PS call control
*/
#define CM_API_GW_PS_CC

/** Support for ip call ss success/failure.
*/
#define CM_API_IPCALL_SS_INFO

/** Support for WLAN ADHOC networks
*/
#ifdef FEATURE_WLAN_ADHOC
#define CM_API_WLAN_ADHOC
#endif

/** Support for new incoming call substate when
** call is waiting on timer before
** sending setup response
*/

/** Support for WLAN WPS procedure.
*/
#define CM_API_WLAN_WPS

#define CM_API_DELAY_SETUPRES

/** Support for enumeration on PDP header
** and data compression
*/
#define CM_API_PDP_COMPR

/** Support for BC 12, 14,15 and 16
*/
#define CM_API_BAND_CLASS_12_14_15_16

/** Support for the new SUPS default values for ss_code, ss_reference, etc
*/
#define CM_API_SUPS_DEFAULT_VALUES

/** Check for this compile flag before trying to use CM_CLIENT_TYPE_OEMNET
*/
#define CM_API_CM_CLIENT_TYPE_OEMNET

/** Support for the HDR active protocol revision
*/
#define CM_API_HDR_ACTIVE_PROT

/** Check for this compile flag before trying to use
** CM_CALL_EVENT_CONNECT_ORDER_ACK
*/
#define CM_API_CM_CALL_EVENT_CONNECT_ORDER_ACK

/** Support for rab_id for
** circuit switched calls
*/
#define CM_API_CS_RABID

/** Addition of enumeration for UCS2
*/
#define CM_API_USSD_UCS2_DCS

/** Supporting Persistent implementations for
** acq_order, band_pref, roam_pref, hybrid_pref and srv_domain_pref
*/
#define CM_API_PERSISTENT_PREF

/** Support for gw_ecio
*/
#define CM_API_GW_ECIO

/** Check for this flag before using cm_result_from_cc_s_type
*/
#define CM_API_RESULT_FROM_CC

/** Adding new enum for NAS-WMS interaction
*/
#define CM_API_NAS_CELL_CHANGE_TYPE

/** Adding support for FEATURE_SMS_OVER_IP
*/
#define CM_API_SMS_OVER_IP

/** Adding new CM API function cm_get_user_data that exposes
** cmwcall_get_user_data
*/
#define CM_API_GET_USER_DATA_FUNCTION

/** Adding enw field to report HS call status
*/
#define CM_API_CELL_SUPP_SERVICES_HS_CALL

/* Support for handset based plus dial
*/
#define CM_API_PLUS_DIALING

/* Adding new field rssi2, rscp, and ecio_for_display
** to report signal strength indication
*/
#define CM_API_SIGNAL_STRENGTH_INDICATION

/* Support for MBMS
*/
#define CM_API_MBMS

/* Adding a new field to report OTASP SPC Error
*/
#define CM_API_OTASP_SPC_ERR

/*---------------------------------------------------------------------------
** Includes
**---------------------------------------------------------------------------
*/
#ifndef CUSTOMER_H
#define CUSTOMER_H
/*===========================================================================

                   C U S T O M E R    H E A D E R    F I L E

DESCRIPTION
  This header file provides customer specific information for the current
  build.  It expects the compile time switch /DCUST_H=CUSTxxxx.H.  CUST_H
  indicates which customer file is to be used during the current build.
  Note that cust_all.h contains a list of ALL the option currently available.
  The individual CUSTxxxx.H files define which options a particular customer
  has requested.


Copyright (c) 1996, 1997       by QUALCOMM Incorporated.  All Rights Reserved.
Copyright (c) 1998, 1999, 2000 by QUALCOMM Incorporated.  All Rights Reserved.
Copyright (c) 2001, 2002       by QUALCOMM Incorporated.  All Rights Reserved.
===========================================================================*/


/* Make sure that CUST_H is defined and then include whatever file it
** specifies.
*/
#ifdef CUST_H
#ifndef CUST_________H
#define CUST_________H
/* ========================================================================
FILE: CUST________

Copyright (c) 2001-2009 by QUALCOMM Incorporated.  All Rights Reserved.        
=========================================================================== */

#ifndef TARG_________H
#ifndef TARG_________H
#define TARG_________H
/* ========================================================================
FILE: TARG________

Copyright (c) 2001-2009 by QUALCOMM Incorporated.  All Rights Reserved.        
=========================================================================== */


#define T_SURF 
#define FEATURE_KEYPAD_MULTI_KEY 
#define T_MSM6800 
#define T_MSM7500 
#define T_MSM6500 
#define FEATURE_BUILD_CDMA_CELL_PCS 
#define FEATURE_BUILD_CDMA_CELL_PCS 
#define FEATURE_BUILD_CDMA_CELL_PCS 


#endif /* TARG_________H */
#endif

#define FEATURE_GSM 
#define FEATURE_WCDMA 
#define FEATURE_GWSMS 
#define FEATURE_CDMA 
#define FEATURE_HDR 
#define FEATURE_FACTORY_TESTMODE 
#define FEATURE_FACTORY_TESTMODE 
#define FEATURE_HSDPA_ACCESS_STRATUM 
#define FEATURE_WCDMA 
#define FEATURE_CGPS_USES_UMTS 
#define FEATURE_CGPS 
#define FEATURE_DS 
#define FEATURE_SMD 
#define FEATURE_SECOND_UART_ON_ANY_PROC 
#define FEATURE_THIRD_UART_ON_ANY_PROC 
#define FEATURE_AUDIO_CONFIGURATION_VALUE_ADD 
#define FEATURE_SD20 
#define FEATURE_SSPR_ENHANCEMENTS 
#define FEATURE_MULTIPROCESSOR 
#define FEATURE_NV_RPC_SUPPORT 
#define FEATURE_VOC_4GV 
#define FEATURE_MMGSDI_NO_TCB_PTR_OR_CRIT_SEC 
#define FEATURE_HS_USB 
#define FEATURE_USB_CDC_ACM 
#define FEATURE_USB_DIAG 
#define FEATURE_USB_DIAG_NMEA 
#define FEATURE_L4 
#define FEATURE_HTORPC_METACOMMENTS 

#ifndef CUSTCDMA2000_H
#define CUSTCDMA2000_H
/*===========================================================================

            " C D M A 2 0 0 0 "   H E A D E R   F I L E

DESCRIPTION
  Configuration for IS-856 support on MSM6800 targets.

  Copyright (c) 2001, 2002, 2003
                2004, 2005, 2006 by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/

#define FEATURE_BUILD_CDMA_TRIMODE 

/* FEATURE_CDMA feature should be defined only in C2k 
 * and multimode (UMTS + CDMA) builds. 
 * support for IS-95/IS2000/1X Data Services   */
#define FEATURE_CDMA

#endif /* CUSTCDMA2000_H */
#ifndef CUSTCDMA_H
#define CUSTCDMA_H
/*===========================================================================

DESCRIPTION
  Configuration for CDMA and AMPS Operation

  Copyright (c) 2002,2003  by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/* -----------------------------------------------------------------------
** Top Level CDMA Call Processing Mode Feature Selection
** ----------------------------------------------------------------------- */
#if (defined (FEATURE_BUILD_CDMA_CELL) && !defined (FEATURE_BUILD_JCDMA))
#elif defined FEATURE_BUILD_CDMA_CELL_AMPS
#elif (defined (FEATURE_BUILD_JCDMA) && !defined (FEATURE_BUILD_CDMA_PCS))
#elif (defined (FEATURE_BUILD_CDMA_PCS) && !defined (FEATURE_BUILD_JCDMA))
#elif (defined (FEATURE_BUILD_CDMA_PCS) && defined (FEATURE_BUILD_JCDMA))
#elif defined FEATURE_BUILD_CDMA_TRIMODE

   /* Supports CDMA at 800  MHz
   **          CDMA at 1900 Mhz
   **          AMPS
   */
   #define FEATURE_CDMA_800
   #define FEATURE_CDMA_1900
   /* Enable Analog Call Processing.
   */
#ifndef T_MSM6500
   #define FEATURE_ACP
#endif
   
#elif defined FEATURE_BUILD_CDMA_CELL_PCS
#else
#endif


/* Enables code to process a roaming list with the format specified in 
** IS 683A. Otherwise, the code will process a roaming list with the format 
** specified in IS 683.
*/
#define  FEATURE_IS683A_PRL
/* Allows a mode that restricts the phone to home systems only.
*/

/* -----------------------------------------------------------------------
** IS-95B
** ----------------------------------------------------------------------- */
#define FEATURE_IS95B

#ifdef FEATURE_IS95B
  /*---------------------------------------*/
  /* Enable the individual IS-95B features */
  /*---------------------------------------*/

  /* IS95B compliant version of Calling NAme Presentation (CNAP)
  ** This is included only if FEATURE_IS95B is included
  */
  #define FEATURE_IS95B_EXT_DISP

  /* IS95B compliant version of Network Directed System Selection (NDSS)
  ** This is included only if FEATURE_IS95B is included
  */
  #define FEATURE_IS95B_NDSS

  /* IS95B compliant version of the Alert Answer Bypass Feature
  ** This is included only if FEATURE_IS95B is included
  */
  #define FEATURE_IS95B_ALERT_ANS_BYPASS

  /*-----------------------------------------------------------*/
  /* Enable the individual IS-95B Protocol Revision 5 features */
  /* These are optional for Revsion 4                          */
  /*-----------------------------------------------------------*/

  /*-----------------------------------------------------------*/
  /* End of IS-95B Feature Definitions                         */
  /*-----------------------------------------------------------*/

#endif /* FEATURE_IS95B */

/* -----------------------------------------------------------------------
** IS-2000
** ----------------------------------------------------------------------- */
#define FEATURE_IS2000

#ifdef FEATURE_IS2000

  /* Data related features
  */
  #ifdef FEATURE_DS
   /*
    * Featurizes data code for IS-2000. 
    * Data Services support for IS-2000 data, such as RLP3.
   */
    #define FEATURE_DS_IS2000
    /* This is the new RLP for IS-2000
    */

    #ifdef FEATURE_DS_IS2000

      //Supplemental Channel
      #define FEATURE_IS2000_SCH

      #ifdef FEATURE_IS2000_SCH

        // Reverse supplemental channel
        #define FEATURE_IS2000_R_SCH

      #endif
    #endif

  #endif


#endif /* FEATURE_IS2000 */

/* -----------------------------------------------------------------------
** CDMA at 800MHz Specific
** ----------------------------------------------------------------------- */
#ifdef FEATURE_CDMA_800
   /* This feature allows the use of a roaming list as defined in IS-683A.
   ** SSPR_800 can operate without a roaming list, in which case it behaves similar
   ** to the old algorithm, but not exactly the same.
   */
   
   /* Needs to be turned on to enable all the functionality needed for FEATURE_SSPR_800.
   */
   #define  FEATURE_SSPR_ENHANCEMENTS

#endif

/* Phone will do OTASP Protocol
** This feature includes full compliance with IS-683A except for OTAPA.
*/
#define  FEATURE_OTASP

/* Unselect non-standard OTASP implementation.
*/
#undef FEATURE_NSOTASP

/* OTASP_OTAPA
*/
#if defined(FEATURE_OTASP) && !defined(FEATURE_NSOTASP)
   /* Support for Over the Air Authentication
    * OTAPA is the network-initiated portion of IS-683A OTASP.
   */
   #define FEATURE_OTASP_OTAPA

#endif


#endif /* CUSTCDMA_H */
#ifndef CUSTHDR_H
#define CUSTHDR_H
/*===========================================================================

            " M S M 6 8 0 0 -  S U R F "   H E A D E R   F I L E

DESCRIPTION
  Configuration for IS-856 support on MSM6800 targets.

  Copyright (c) 2001, 2002, 2003
                2004, 2005, 2006
                2007, 2008 by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/* HDR Air Interface support.
*/
#define FEATURE_HDR

/* HDR-1X handoff */
#define FEATURE_HDR_HANDOFF 

/* Hybrid operation
*/
#define FEATURE_HDR_HYBRID

/* Data Dedicated Transmission mode 
   to minimize the hyrbid HDR data call interruption 
*/ 
#define FEATURE_DDTM_CNTL

/* HDR Broadcast related features */
#define FEATURE_BCMCS

#if defined(T_MSM6800) && !defined(T_MSM7500)
/* Feature for Enhanced Multi-flow Packet Application. Turn on only for 6800 */
#define FEATURE_HDR_EMPA
#endif


#endif /* CUSTHDR_H */
#ifndef CUSTWCDMA_H
#define CUSTWCDMA_H
/*=========================================================================== 

                           C U S T    W C D M A 

DESCRIPTION
  Customer file for WCDMA

  Copyright (c) 2002-2008 by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


#ifdef FEATURE_HSDPA_ACCESS_STRATUM
  #define FEATURE_REL5
  /* Make CQI estimation less pessimistic */
#endif


#define FEATURE_MODEM_MBMS

#endif /* CUSTWCDMA_H */
#ifndef CUSTUSURF_H
#define CUSTUSURF_H
/*===========================================================================

                           C U S T U S U R F

DESCRIPTION
  Customer file for the MSM6280 UMTS (GSM + WCDMA) SURF build.

  Copyright (c) 1996-2008 by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/* Enable MVS
*/
#define FEATURE_MVS

// ---  GSM  ---
/* Enable GSM code
*/
#define FEATURE_GSM

// --- WCDMA ---
/* Enable WCDMA code
*/
#define FEATURE_WCDMA

/* Must be defined for SIO services.
*/
#define FEATURE_NEW_SIO

/* Must be defined to use the baud change abilities for Diag and DS.
*/
#define FEATURE_SERIAL_DEVICE_MAPPER

/* Must be defined to use the Runtime Device Mapper.
*/
#define FEATURE_RUNTIME_DEVMAP

/* Must be defined for SIO services.
*/
#define FEATURE_NEW_SIO

/* Must be defined to use the baud change abilities for Diag and DS.
*/
#define FEATURE_SERIAL_DEVICE_MAPPER

/* Must be defined to use the Runtime Device Mapper.
*/
#define FEATURE_RUNTIME_DEVMAP
#define FEATURE_MMGSDI_GSM
#define FEATURE_MMGSDI_UMTS

#define FEATURE_ALS

/* Enable Data Services
*/
#define FEATURE_DATA

/* Enable ETSI specific functionality in PS
*/
#define FEATURE_DATA_WCDMA_PS

/* Enable feature to read DS baud info from NV
*/
#define FEATURE_DS_DEFAULT_BITRATE_NV

/* Enable Factory Test Mode support
*/
#define FEATURE_FACTORY_TESTMODE
#define FEATURE_IS683A_PRL

/* Support for Multiple PDP contexts */
#define FEATURE_MULTIPLE_PRIMARY_PDP

#define FEATURE_UUS

#define FEATURE_CCBS

//David - added to make FTM audio compile
#define FEATURE_VOC_PCM_INTERFACE

/*#define FEATURE_LSM_PCH_REPORTING*/

#endif /* CUSTUSURF_H */


/*****************************************************************************/
#ifndef CUSTGSM_H
#define CUSTGSM_H
/*=========================================================================== 

                           C U S T G S M

DESCRIPTION
  Customer file for GSM.

  Copyright (c) 2002 by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/*===========================================================================

                      EDIT HISTORY FOR FILE

  This section contains comments describing changes made to the module.
  Notice that changes are listed in reverse chronological order.

$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $

when       who     what, where, why
--------   ---     ----------------------------------------------------------
08/12/08    rc     Added 3G Rove in feature def within FEATURE_GAN
06/10/08    rc     Added FEATURE_BPLMN_SEARCH_PRIORITY for GOBI-2000 - Fix for CR:152804
02/10/08    ps	   Enable AMR-WB for LCU	 	
18/09/08    rc     Removed FEATURE_USB_WITH_ARM_HALT, Enabled FEATURE_GAN dependent features & FEATURE_LAPDM_REESTABLISHMENT
04/09/08    rc     Enabled FEATURE_GSM_RGS_MULTIPASS
01/09/08    rc     Enable R-SACCH for LCU
04/08/08    rc     Disable AMR-WB and R-SACCH feature in LCU for now.
08/07/08    ws     Changes for raptor2 Target, Disable AMR-WB and define FEATURE_GSM_8K_QDSP6_AUDIO
13/06/08    rc     Added 2H07 GERAN Feature AMR-WB
07/05/08    rc     Added 2H07 GERAN Features R-SACCH & PS HO
07/05/08    rc     Added FEATURE_GPRS_FAST_RACH 
30/04/08    ws     Moved ESAIC feature to cutgsmdrv.h
30/04/08    ws     Enable ESAIC for LCU
06/02/08    ws     Added FEATURE_GSM_MDSP_ESAIC
05/02/08    ws     Added FEATURE_GSM_L1_IMPLEMENT_LPM
22/01/08    ws     Added T_QSC6270 specific featurisation
22/10/07    ws     Addede Enable ACQ database feature
14/09/07    rc     Added FEATURE_GPRS_COMP_ENUM_TYPES to re-use SNDCP VU that support IPHC with other layers that does not support IPHC
14/08/07    rc     Replaced FEATURE_GSM_SNDCP_IPHC_ROHC with FEATURE_GSM_SNDCP_IPHC
                   Added FEATURE_GSM_L1_OOS_SEARCH_TIME_ENH
09/07/07    rc     Removed FEATURE_CSN_REFACTORED
31/05/07    ws     Enabled FEATURE_GSM_L1_CONTROL_SET_BAND
16/04/07    npr    Enabled 2H06 features: EDTM, RFACCH, IPA, CSN
19/01/07    rc     Enabled FEATURE_GSM_GPRS_LLC_GEA_NV_SUPPORT
21/11/06    rc     Enabled FEATURE_GSM_L1_HFREQ_ERR_NCELL_SCH_DECODE
10/02/06    ws     Enabled DTM,EDA and PFC
09/06/05    ws     Removed FEATURE_GSM_DTM  since new build Id's use them
08/26/05    ws     Merged from Raven Branch features DISABLE_XFER_SNR_RESELECTION
                   and FEATURE_GPRS_GRR_GMM_PCCCH_PAGING_COORD
08/25/05    ws     Enabled FEATURE_GSM_DTM
06/23/05   src     Enabled FEATURE_GSM_GPRS_PEMR
05/24/05    gw     Enable WCDMA ID searches in transfer mode via
                   FEATURE_GTOW_RESELECTION_XFER_CELL_ID
04/24/05    bk     Temp disabled SNR based reselection in transfer via DISABLE_XFER_SNR_RESELECTION
11/19/04   gfr     Moved DEBUG_HW_SELECT_STAGE2_OUTPUT_CHANNEL_FILTER to
                   custgsmdrv.h
13/05/04   npr     Initial revision.
===========================================================================*/

#ifdef FEATURE_GSM

/***************************************************************************
                                 GSM
****************************************************************************/
#define FEATURE_GSM_EXT_SPEECH_PREF_LIST


/* Enable GPRS as Standard */
#define FEATURE_GSM_GPRS

#if ( !defined(T_MSM8650B) )
/* Don't enable W-AMR on Raptor2 for now */
#define FEATURE_GSM_AMR_WB
#endif


/*-------------------------------------------------------------------------*/
#endif /* FEATURE_GSM */
#endif /* CUSTGSM_H */

#ifndef CUSTUIM_H
#define CUSTUIM_H
/*===========================================================================

            " C u s t -  U I M "   H E A D E R   F I L E

DESCRIPTION
  Configuration for UIM Feature.

  Copyright (c) 2000-2008 by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/

/* #define FEATURE_UIM2 */

#if defined (FEATURE_WCDMA) || defined (FEATURE_GSM)
/* Enable MMGSDI */
#define FEATURE_MMGSDI_UMTS
#endif /* FEATURE_WCDMA || FEATURE_GSM */

#ifdef FEATURE_GSM
/* GSM part of MMGSDI */
#define FEATURE_MMGSDI_GSM
#endif /* FEATURE_GSM */


#if defined(FEATURE_RUIM) && !(defined(FEATURE_MMGSDI_UMTS) || defined (FEATURE_MMGSDI_GSM))
  #define FEATURE_PERSO_RUIM
#endif /* FEATURE_RUIM !(FEATURE_MMGSDI_UMTS || FEATURE_MMGSDI_GSM)*/


/* Support for Pre-Addendum Op codes that clash with ISO-7816 commands
*/
#undef FEATURE_UIM_RUIM_PRE_A1_OP_CODES

/*---------------------------------------------------------------------------
                           NV access in RUIM
---------------------------------------------------------------------------*/
#define FEATURE_CAT_REL6


/* Feature for 1000 Phonebook */
#define FEATURE_USIM_1000_PBM

/* Feature for dual processor build to prevent these members from being accessed */
#define FEATURE_MMGSDI_NO_TCB_PTR_OR_CRIT_SEC

/* Feature to allow detail card error info to be sent */
#define FEATURE_MMGSDI_CARD_ERROR_INFO

#if defined (FEATURE_MMGSDI_UMTS) || defined (FEATURE_MMGSDI_GSM)

/*SIM Lock for GSM/UMTS only*/
#define FEATURE_PERSO_SIM
#endif /* FEATURE_MMGSDI_UMTS OR FEATURE_GSM */

#endif /* CUSTUIM_H */
#ifndef CUSTCGPS_H
#define CUSTCGPS_H
/*===========================================================================

            " C u s t - C G P S "   H E A D E R   F I L E

DESCRIPTION
  Configuration for GPS Feature.

  Copyright (c) 2006 - 2007
                by QUALCOMM Incorporated. All Rights Reserved.

===========================================================================*/


/*---------------------------------------------------------------------------
                            gpsOne Features
---------------------------------------------------------------------------*/

#define FEATURE_CGPS

#ifdef FEATURE_CGPS

  #define FEATURE_GPSONE 

  #ifdef FEATURE_CGPS_USES_UMTS

    #define FEATURE_CM_LCS

  #endif  /* FEATURE_CGPS_USES_UMTS */

#endif /* FEATURE_CGPS */
#endif /* CUSTCGPS_H */
#ifndef CUSTUMTSDATA_H
#define CUSTUMTSDATA_H
/*===========================================================================

DESCRIPTION
  Configuration for UMTS DATA.

  Copyright (c) 2006,2007  by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/* Enable ETSI specific functionality in PS
*/
#define FEATURE_DATA_WCDMA_PS

#define FEATURE_SECONDARY_PDP

#define FEATURE_PS_DORMANT_PWR_SAVE

#endif /* CUSTUMTSDATA_H */
#ifndef CUSTDATA_H
#define CUSTDATA_H
/*===========================================================================

DESCRIPTION
  Configuration for NVM.

  Copyright (c) 2002 - 2008  by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/*===========================================================================

                      EDIT HISTORY FOR FILE

  This section contains comments describing changes made to the module.
  Notice that changes are listed in reverse chronological order.

$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $ $DateTime: 2009/01/08 04:43:34 $ $Author: cbothsa $
 Came from //depot/asic/msmshared/plfs/cdma2000/1H07_TIP/build/cust/custdata.h#1

when       who     what, where, why
--------   ---     ------------------------------------------------------------
05/06/08   ms      ENABLED FEATURE_IS707B_ADDENDUM
04/29/08   sn      Putting FEATURE_DS_LN_UPDATE under FEATURE_HDR check
03/06/08   mga     Enabled FEATURE_DS_LN_UPDATE
09/28/07   as      Switched on FEATURE_DATA_MOBILE_IP_DMU_MODIFIES_AN_AUTH
08/21/07   wsh     Retired EATURE_C2K_INTERNAL_USE_ONLY flag in 1H07 branch
08/09/07   wli     added support for FEATURE_DADA_ON_APPS
08/03/07   pm      updated to use FEATURE_INTERNAL_USE_FFABUILDS_ONLY
05/23/07   dnn     Mainlined FEATURE_HDR_QOS_DQOS_SUPPORTED_ALWAYS
05/23/07   ssr     Adding GSM custdata.h under FEATURE_GSM_GPRS
05/17/07   ssr     Adding GSM / GPRS fearure sets to enable combined 1x/GSM PLF
04/17/07   ac      Turn off certain features when VoIP is off
11/14/06   vrk/gr  turning off RDUD, CAM, DCTM for JCDMA builds
11/15/06   vas     Added FEATURE_C2K_INTERNAL_USE_ONLY related features
05/23/06   vrk     enable FEATURE_DATA_SERIALIZER for 6800 5.0
12/13/05   vrk     enable FEATURE_CALL_THROTTLE (DCTM) and move RSVP Featurization
10/17/05   vrk     disable FEATURE_DS_QNC in JCDMA builds and modified comments
04/05/05   gr      Integrated EPZID functionality onto the main line
02/28/05   ks      Enabled FEATURE_DATA_PS_DATA_LOGGING for Data Protocol
                   Logging.
02/25/05   kvd     Removed FEATURE_DS_MOBILE_IP_MULTIPLE_NAI as the feature is
                   now appicable to SIP calls also and is covered by
                   FEATURE_DS_MULTIPLE_NAI.
02/15/05   kvd     Added FEATURE_DS_MULTIPLE_NAI.
02/03/05   kvd     Added FEATURE_DS_MOBILE_IP_MULTIPLE_NAI.
11/11/02   cah     Added GSM features.
05/01/02   jct     Created
===========================================================================*/
/* -----------------------------------------------------------------------
** Data Services
** ----------------------------------------------------------------------- */
#define FEATURE_DS

#ifdef FEATURE_DS

   /* New Multi-Mode Data Features */
   /* Support for generic Data Services*/
   #define FEATURE_DATA
#ifdef FEATURE_CDMA //DNN
   /* Support for IS-95/IS2000/1X Data Services.   */
   #define FEATURE_CDMA
#endif // #ifdef FEATURE_CDMA //DNN

#endif /* FEATURE_DS */


/* Enabling GSM_GPRS features in case of a combined 1x-GSM build
 */
#if defined(FEATURE_GSM_GPRS)

/*===========================================================================

                      EDIT HISTORY FOR FILE

  This section contains comments describing changes made to the module.
  Notice that changes are listed in reverse chronological order.

$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $
$DateTime: 2009/01/08 04:43:34 $
$Author: cbothsa $

when       who     what, where, why
--------   ---     ------------------------------------------------------------
08/30/07   sjw     Added FEATURE_ENUM_COMPRESSION_TYPES
06/30/07   dnn     Commented out #define FEATURE_DATA_V80
06/22/07   dnn     Removed extra endif
05/23/07   ssr     Created
===========================================================================*/

#ifdef FEATURE_GSM_GPRS
#define FEATURE_SECONDARY_PDP
#define FEATURE_PS_DORMANT_PWR_SAVE
#define FEATURE_UUS

#endif /* FEATURE_GSM_GPRS */
#endif /* FEATURE_GSM_GPRS */
#endif /* CUSTDATA_H */
#ifndef CUSTREMOTEAPIS_H
#define CUSTREMOTEAPIS_H
/*===========================================================================

                      C U S T R E M O T E A P I S . H

DESCRIPTION
  This file defines which APIs are remoted via ONCRPC.

  Copyright (c) 2006 by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/

#ifndef CUSTDRIVERS_H
#define CUSTDRIVERS_H
/*=========================================================================== 

                           C U S T D R I V E R S

DESCRIPTION
  Customer definition file for drivers.

  Copyright (c) 2006 by QUALCOMM Incorporated. All Rights Reserved.

===========================================================================*/


/* Define the target for clock regime */
#define T_CLKREGIM   7625

/* Set up the other PLLs based on turbo mode or not.  */

#ifdef FEATURE_TURBOMODE
  #define T_CLKREGIM_PLL1_960_MHZ
  #define FEATURE_CLKREGIM_TURBO_MODE
#endif

/* Set modem frequency plan. */
#if defined(FEATURE_WCDMA) && defined(FEATURE_CDMA)
#elif defined(FEATURE_WCDMA)
  #define T_CLKREGIM_PLL0_245_76_MHZ 
#else
  #define T_CLKREGIM_PLL0_196_608_MHZ
#endif


/* Enable the resource manager */
#define FEATURE_CLKREGIM_RM

/* Enable F3 trace feature */
#if !defined(BOOT_LOADER) && !defined(BUILD_HOSTDL) && !defined(FEATURE_WINCE)
  #define FEATURE_SAVE_DEBUG_TRACE
  #define FEATURE_ERR_EXTENDED_STORE
#endif


/*---------------------------------------------------------------------------
                              KEYPAD
---------------------------------------------------------------------------*/

#ifndef FEATURE_THIN_UI

  /* Enable the keypad unless this is ThinUI */
  #define FEATURE_KEYPAD

#endif

#ifdef FEATURE_KEYPAD

  #define FEATURE_KEYPAD_MULTI_KEY

#endif

#define FEATURE_CLKREGIM_TURBO_MODE

#endif /* CUSTDRIVERS_H */
#endif /* CUSTREMOTEAPIS_H */
#ifndef CUSTSIO_H
#define CUSTSIO_H
/*===========================================================================

DESCRIPTION
  Configuration for SIO

  Copyright (c) 2002  by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/
                                        

/*Enable to open MMC port*/
#ifdef FEATURE_BUILD_MMC
   #define FEATURE_MMC
#endif


/* Enable new SIO code - required for MSM3100 s/w release
*/
#define FEATURE_NEW_SIO

#ifdef FEATURE_NEW_SIO

/* Enables Serial Device Mapper.  Must define
** FEATURE_NEW_SIO for this to be effective.
*/
  #define FEATURE_SERIAL_DEVICE_MAPPER

#ifdef FEATURE_SERIAL_DEVICE_MAPPER
  /* Runtime Device Mapper services.  These are mutually exclusive
  ** with FEATURE_SDEVMAP_UI_MENU & FEATURE_SDEVMAP_MENU_ITEM_NV.
  */
  #define FEATURE_RUNTIME_DEVMAP

  /* Enables UI selection of port mapping. The port map is stored in
  ** NV and retrieved - requires power cycle for changes to take effect.
  ** These should be defined or undefined together.
  */
  #ifndef FEATURE_RUNTIME_DEVMAP
    #define FEATURE_SDEVMAP_MENU_ITEM_NV
  #endif

  #ifdef FEATURE_DS
    /* Enables UI selection of DS baud rate and the DS baud to be stored in
    ** and retrieved from NV.  These should be defined or undefined together.
    */
    #define  FEATURE_DS_DEFAULT_BITRATE_NV
  #endif /* FEATURE_DS */

   #define FEATURE_DIAG_DEFAULT_BITRATE_NV

#endif  /* FEATURE_SERIAL_DEVICE_MAPPER */

#endif  /* FEATURE_NEW_SIO */

#endif /* CUSTSIO_H */
#ifndef CUSTMMODE_H
#define CUSTMMODE_H
/*========================================================================

DESCRIPTION

  Configuration CUST file for all of Multi Mode code

  Copyright (c) 2007  by QUALCOMM Incorporated. All Rights Reserved.
========================================================================*/


  /* Enable FEATURE_MM_SUPERSET for targets that use RPCs and thus
  ** need remote API files.
  ** This flag being on results in uniform remote API files for MMODE
  ** as even 1X-only targets will then pull in NAS files that CM uses in
  ** its API
  */
  #ifdef FEATURE_MULTIPROCESSOR
  #define FEATURE_MM_SUPERSET
  #endif


  /*
  ** Multi Mode features that are WCDMA or GSM specific
  */
  #if (defined FEATURE_WCDMA) || (defined FEATURE_GSM)

    /* Feature to deactivate secondary PDP before sending
    ** setup response for incoming call.
    */
    #define FEATURE_CM_DELAY_SETUPRES

  #endif /* (defined FEATURE_WCDMA) || (defined FEATURE_GSM) */

#endif /* CUSTMMODE_H */
#ifndef CUSTAVS_H
#define CUSTAVS_H
/*===========================================================================

DESCRIPTION
  Configuration for AVS

  Copyright(c) 2002 - 2008 by QUALCOMM, Incorporated.
  All Rights Reserved. Qualcomm Proprietary and Confidential.
===========================================================================*/


/*===========================================================================

                      EDIT HISTORY FOR FILE

  This section contains comments describing changes made to the module.
  Notice that changes are listed in reverse chronological order.

$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $ $DateTime: 2009/01/08 04:43:34 $ $Author: cbothsa $

when       who     what, where, why
--------   ---     ----------------------------------------------------------
04/01/08   sud     Added support for DTMF Detection.
02/08/08   sud     Added feature FEATURE_VOC_AMR_WB for AMR-WB Vocoder.
                   Added feature FEATURE_IIR_FILTER_5S for 5-stage IIR filter.
                   Updated Copyright.
12/17/07   sud     Re-enabled FEATURE_AVS_CRYSTAL_SPEECH.
12/14/07   sud     Enabled FEATURE_PCM_VOCODER for 7600 and 7200A 5.X
                   Removed FEATURE_AVS_CRYSTAL_SPEECH feature enable.
08/21/07    ac     Added FEATURE_AVS_CRYSTAL_SPEECH
06/20/07    np     Added FEATURE_AUDFMT_EVB for 4GV playback.
05/01/07    aw     Added support for GSM TTY and PCM Package log.
03/23/07    aw     Enable QDSP_PACKET_SNIFFER only for vocoder 1x which have
                   FEATURE_DIAG_PACKET_COUPLING enabled in custdiag.h
01/22/07    aw     Enabled FEATURE_AUDIO_NEW_AUX_CODEC_HW for 7600, 7200A 
17/01/07   kan     Enabled  QDSP_PACKET_SNIFFER for 1X vocoder packet log.
01/16/06    ac     Enabled FEATURE_AVS_I2SSBC
                           FEATURE_EXTERNAL_SDAC 
                           FEATURE_EXTERNAL_SADC
11/16/06    aw     Enable FEATURE_IIR_FILTER
10/23/06    aw     Added FEATURE_AVS_NEXTGEN_EC
07/19/06    aw     Added FEATURE_VOC_PCM_INTERFACE
04/07/06    aw     Added FEATURE_INTERNAL_SADC
02/04/06   bam     Added FEATURE_AUDFMT_AMR
12/28/05   bam     Added FEATURE_VOICE_RECORD.
12/28/05    aw     Enabled FEATURE_VOICE_PLAYBACK
12/20/05    aw     Added FEATURE_VOC_PACKET_INTERFACE
12/12/04    aw     Added FEATURE_MVS
11/10/04    ro     Added FEATURE_QDSP_RTOS.
02/19/03    st     Added FEATURE_GRAPH_ADPCM.
02/03/03   cah     Added FEATURE_MVS for GSM.
11/11/02   cah     Added GSM features.
09/06/02    st     Enabled FEATURE_TTY.
08/23/02    st     Updated defines for SDAC.
05/01/02   jct     Created
===========================================================================*/
#if defined(FEATURE_AUDIO_CONFIGURATION_VALUE_ADD) || \
    defined(FEATURE_AUDIO_CONFIGURATION_STANDARD)

  /**************************************************************************
  [FEATURE NAME]:      FEATURE_VOICE_PLAYBACK
  [SCOPE]:             AUDDRV, AUDSVC
  [DESCRIPTION]:       Enable Voice playback function for QCP file playback
  [OEM CAN ENABLE/DISABLE]: YES.
  **************************************************************************/
  #define FEATURE_VOICE_PLAYBACK

  /**************************************************************************
  [FEATURE NAME]:      FEATURE_VOICE_RECORD
  [SCOPE]:             AUDDRV, AUDSVC
  [DESCRIPTION]:       Enable Voice recording function for QCP file recording
  [OEM CAN ENABLE/DISABLE]: YES.
  **************************************************************************/
  #define FEATURE_VOICE_RECORD

  #ifndef FEATURE_AUDIO_CONFIGURATION_MINIMAL
    #define FEATURE_AUDIO_CONFIGURATION_MINIMAL
  #endif

#endif /* FEATURE_AUDIO_CONFIGURATION_VALUE_ADD || 
          FEATURE_AUDIO_CONFIGURATION_STANDARD */

#ifdef FEATURE_AUDIO_CONFIGURATION_MINIMAL

  /**************************************************************************
  [FEATURE NAME]:      FEATURE_AUDIO_AGC
  [SCOPE]:             AVS, AUDDRV, AUDSVC
  [DESCRIPTION]:       Enable AUDIO AGC
  [OEM CAN ENABLE/DISABLE]: YES.
  **************************************************************************/
  #define FEATURE_AUDIO_AGC

  /**************************************************************************
  [FEATURE NAME]:      FEATURE_TTY
  [SCOPE]:             AVS
  [DESCRIPTION]:       Enable TTY Support
  [OEM CAN ENABLE/DISABLE]: YES.
  **************************************************************************/
  #define FEATURE_TTY

  /**************************************************************************
  [FEATURE NAME]:      FEATURE_ANALOG_HFK
  [SCOPE]:             AVS
  [DESCRIPTION]:       Enable Multi mode voice services 
  [OEM CAN ENABLE/DISABLE]: NO.
  **************************************************************************/
  #define FEATURE_MVS
 
  /**************************************************************************
  [FEATURE NAME]:      FEATURE_EXTERNAL_SDAC
  [SCOPE]:             AVS
  [DESCRIPTION]:       Allows use of the internal codec's Stereo DAC 
  [OEM CAN ENABLE/DISABLE]: YES.
  **************************************************************************/
  #define FEATURE_EXTERNAL_SDAC

  #if defined(FEATURE_INTERNAL_SDAC) || defined(FEATURE_EXTERNAL_SDAC)
    /* Adds calibration values and provides common code between 
    ** FEATURE_INTERNAL_SDAC and FEATURE_EXTERNAL_SDAC.
    */
    #define FEATURE_STEREO_DAC
  #endif


  #ifdef FEATURE_GSM
  
    /* Enable Multimode Voice Services
    */
    #ifndef FEATURE_MVS
      #define FEATURE_MVS
    #endif

  #endif /* FEATURE_GSM */

  /**************************************************************************
  [FEATURE NAME]:      FEATURE_VOC_PCM_INTERFACE
  [SCOPE]:             AVS
  [DESCRIPTION]:       Enable voice PCM interface for capture and playback 8K
                       PCM sample on ARM9
  [OEM CAN ENABLE/DISABLE]: YES.
  **************************************************************************/
  #define FEATURE_VOC_PCM_INTERFACE

  /**************************************************************************
  [FEATURE NAME]:      FEATURE_TTY_UMTS
  [SCOPE]:             VOCDRV, VOCSVC
  [DESCRIPTION]:       Enable new aux codec hardware interface on 7600, 7200A
                       Target.
  [OEM CAN ENABLE/DISABLE]: NO.
  **************************************************************************/
  #define FEATURE_TTY_UMTS
  
#endif /* FEATURE_AUDIO_CONFIGURATION_MINIMAL */

/*--------------- DO NOT CHANGE CODE BELOW THIS LINE ----------------------*/
/****************************************************************************
*****************************************************************************
*****************************************************************************
*****************************************************************************
*****************************************************************************
*****************************************************************************
****************************************************************************/

/*---------------------------------------------------------------------------
                            Feature Dependencies
---------------------------------------------------------------------------*/

#ifdef FEATURE_TTY_UMTS
  #ifndef FEATURE_TTY
    #define FEATURE_TTY
  #endif
  #ifndef FEATURE_VOC_PCM_INTERFACE
    #define FEATURE_VOC_PCM_INTERFACE
  #endif
#endif /* FEATURE_TTY_UMTS */


#endif /* CUSTAVS_H */
#ifndef CUSTNVM_H
#define CUSTNVM_H
/*===========================================================================

DESCRIPTION
  Configuration for NVM.

  Copyright (c) 2002  by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/* Phone's NV memory will support one NAM of 625 bytes, and the one-time
   subsidy lock item
*/
#define  FEATURE_NV_ONE_NAM_RL_LARGE

/* This feature configures NV to have two small roaming lists for a two NAM phone,
** as opposed to having one large roaming list for a one NAM phone.
*/
#undef  FEATURE_NV_TWO_NAMS_RL_SMALL

/* Define to enable the use of a trimode rf calibration file to derive
** NV items.  Also triggers the NV section to support this feature.
*/
#define FEATURE_TRIMODE_ITEMS

/* Enable reading of BTF value from NV
*/
#define FEATURE_ENC_BTF_IN_NV

#if defined FEATURE_BUILD_CDMA_TRIMODE || \
    defined FEATURE_BUILD_CDMA_PCS
      /* Define to enable the use of a trimode rf calibration file to derive
      ** NV items.  Also triggers the NV section to support this feature.
      */
      #define FEATURE_TRIMODE_ITEMS
#endif

#endif /* CUSTNVM_H */
#ifndef CUSTRF_H
#define CUSTRF_H
/*===========================================================================

DESCRIPTION
  Configuration for RF

  Copyright (c) 2002  by QUALCOMM Incorporated. All Rights Reserved.
  Copyright (c) 2008  by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/* Enable NV item to calculate the PA warmup delay used for puncturing during
** transmit.
*/
#define FEATURE_SUBPCG_PA_WARMUP_DELAY

/* CRF3100-PA and QRF3300-1 uses RFR3100
** Enables reading of Forward Mode Rx CAGC RF Cal items.
*/
#define FEATURE_RFR3100

/* Features to use the improved TX AGC supported by CRF3100-PA
** Features enable reading of Forward Mode Tx CAGC RF Cal items.
*/

#define FEATURE_PA_RANGE_TEMP_FREQ_COMP
#define FEATURE_4PAGE_TX_LINEARIZER


#endif /* CUSTRF_H */
#ifndef CUSTWMS_H
#define CUSTWMS_H
/*===========================================================================

DESCRIPTION
  Configuration for WMS

  Copyright (c) 2002,2003,2004, 2005, 2006 by QUALCOMM Incorporated. 
  All Rights Reserved.
===========================================================================*/


/*---------------------------------------------------------------------------
                         Wireless Messaging Services
---------------------------------------------------------------------------*/
#ifdef FEATURE_CDMA
  #define FEATURE_CDSMS
#endif

#ifdef FEATURE_WCDMA
  #define FEATURE_GWSMS
#endif

/* Common Features across CDMA and GW Modes */
#if defined(FEATURE_CDSMS) || defined(FEATURE_GWSMS)
  
  /* Enables user data headers to support voice and email address.
  */
  #define FEATURE_SMS_UDH

  /* Features specific to CDMA Mode */
  #ifdef FEATURE_CDSMS

    /* Broadcast SMS support
    */
    #define FEATURE_BROADCAST_SMS

    /* New Implementation of CDMA Broadcast API
    */
    #define FEATURE_CDSMS_BROADCAST

  #endif /* FEATURE_CDSMS */

#endif /*defined(FEATURE_CDSMS) || defined(FEATURE_GWSMS)*/

#endif /* CUSTWMS_H */
#ifndef CUSTL4_H
#define CUSTL4_H
/*===========================================================================

            " C u s t - L 4 "   H E A D E R   F I L E

DESCRIPTION
  Configuration for L4 Feature.

  Copyright (c) 2005       by QUALCOMM Incorporated. All Rights Reserved.
===========================================================================*/


/*===========================================================================

                      EDIT HISTORY FOR FILE

  This section contains comments describing changes made to the module.
  Notice that changes are listed in reverse chronological order.

$Header:
$DateTime: 2009/01/08 04:43:34 $ $Author:

when       who     what, where, why
--------   ---     ----------------------------------------------------------
03/10/06   hn      Disabled FEATURE_L4_CPUSLEEP for 7200
12/07/05   ddh     Enabled FEATURE_L4_CPUSLEEP
11/17/05   dlb'    Enabling Rex Profiling for modem processor..
10/27/05   AMW     Added BUILD_JFLASH exception
09/21/05   AMW     Added test for building boot and tools

===========================================================================*/


#if !defined(BUILD_BOOT_CHAIN) && \
    !defined(BUILD_JNAND) && \
    !defined(BUILD_JFLASH) && \
    !defined(BUILD_HOSTDL) && \
    defined(FEATURE_L4)
  #define FEATURE_QUARTZ_135

#else
#endif /* !BUILD_BOOT_CHAIN & !BUILD_JNAND & FEATURE_L4 */

#endif /* CUSTL4_H */

#endif /* CUST_________H */
#else
#endif

/* Now perform certain Sanity Checks on the various options and combinations
** of option.  Note that this list is probably NOT exhaustive, but just
** catches the obvious stuff.
*/


#endif /* CUSTOMER_H */
#ifndef COMDEF_H
#define COMDEF_H
/*===========================================================================

                   S T A N D A R D    D E C L A R A T I O N S

DESCRIPTION
  This header file contains general types and macros that are of use
  to all modules.  The values or definitions are dependent on the specified
  target.  T_WINNT specifies Windows NT based targets, otherwise the
  default is for ARM targets.

       T_WINNT  Software is hosted on an NT platforn, triggers macro and
                type definitions, unlike definition above which triggers
                actual OS calls

DEFINED TYPES

       Name      Definition
       -------   --------------------------------------------------------
       byte      8  bit unsigned value
       word      16 bit unsigned value
       dword     32 bit unsigned value

       uint1     byte
       uint2     word
       uint4     dword

       uint8     8  bit unsigned value
       uint16    16 bit unsigned value
       uint32    32 bit unsigned value
       uint64    64 bit unsigned value

       int8      8  bit signed value
       int16     16 bit signed value
       int32     32 bit signed value
       int 64    64 bit signed value

       sint31    32 bit signed value
       sint15    16 bit signed value
       sint7     8  bit signed value

       int1      8  bit signed value
       int2      16 bit signed value
       int4      32 bit signed value

       boolean   8 bit boolean value

DEFINED CONSTANTS

       Name      Definition
       -------   --------------------------------------------------------
       TRUE      Asserted boolean condition (Logical 1)
       FALSE     Deasserted boolean condition (Logical 0)

       ON        Asserted condition
       OFF       Deasserted condition

       NULL      Pointer to nothing

       PACK()    Used to declare a C type packed for either GCC or ARM
                 compilers.

       *** DEPRECATED - WON'T WORK FOR newer versions (3.x) of GCC ***
       PACKED    Used to indicate structures which should use packed
                 alignment
       *** DEPRECATED - WON'T WORK FOR newer versions (3.x) of GCC ***

       INLINE    Used to inline functions for compilers which support this

Copyright (c) 1990,1992 by QUALCOMM, Incorporated.  All Rights Reserved.
Copyright (c) 1993,1994 by QUALCOMM, Incorporated.  All Rights Reserved.
Copyright (c) 1997,1998 by QUALCOMM, Incorporated.  All Rights Reserved.
Copyright (c) 1999,2000 by QUALCOMM, Incorporated.  All Rights Reserved.
Copyright (c) 2001,2002 by QUALCOMM, Incorporated.  All Rights Reserved.
Copyright (c) 2003,2004 by QUALCOMM, Incorporated.  All Rights Reserved.
Copyright (c) 2005,2006 by QUALCOMM, Incorporated.  All Rights Reserved.
Copyright (c) 2007      by QUALCOMM, Incorporated.  All Rights Reserved.
===========================================================================*/

#ifndef TARGET_H
#define TARGET_H
/*===========================================================================

      T A R G E T   C O N F I G U R A T I O N   H E A D E R   F I L E

DESCRIPTION
  All the declarations and definitions necessary for general configuration
  of the DMSS software for a given target environment.

Copyright (c) 1998,1999,2000,2001,2002  by QUALCOMM, Inc.  All Rights Reserved.
===========================================================================*/


/* All featurization starts from customer.h which includes the appropriate
**    cust*.h and targ*.h
*/
#ifdef CUST_H
#endif

#endif /* TARGET_H */

#if defined FEATURE_L4  && !defined FEATURE_L4_KERNEL && !defined BUILD_BOOT_CHAIN && !defined BUILD_BOOT_CHAIN_OEMSBL
  #ifndef _ARM_ASM_
    	#ifdef FEATURE_QUARTZ_135 
/*===========================================================================
     Copyright (c) 2004-2008 QUALCOMM Incorporated. All Rights Reserved.

     QUALCOMM Confidential and Proprietary
===========================================================================*/

#ifndef __MSM_SYSCALL_H__
#define __MSM_SYSCALL_H__
/*===========================================================================

              M S M    S Y S C A L L    H E A D E R    F I L E

DESCRIPTION
   This file contains the functions in assembly, which are equivelent
   to those inline assembly functions defined in msm_syscall.h

===========================================================================*/


/*********************************************************************
 *
 * Copyright (C) 2001-2004,  Karlsruhe University
 *
 * File path:     l4/types.h
 * Description:   Commonly used L4 types
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $
 *
 ********************************************************************/
/*
 * Australian Public Licence B (OZPLB)
 *
 * Version 1-0
 *
 * Copyright (c) 2006, National ICT Australia
 *
 * All rights reserved. 
 *
 * Developed by: Embedded, Real-time and Operating Systems Program (ERTOS)
 *               National ICT Australia
 *               http://www.ertos.nicta.com.au
 *
 * Permission is granted by National ICT Australia, free of charge, to
 * any person obtaining a copy of this software and any associated
 * documentation files (the "Software") to deal with the Software without
 * restriction, including (without limitation) the rights to use, copy,
 * modify, adapt, merge, publish, distribute, communicate to the public,
 * sublicense, and/or sell, lend or rent out copies of the Software, and
 * to permit persons to whom the Software is furnished to do so, subject
 * to the following conditions:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimers.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimers in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of National ICT Australia, nor the names of its
 *       contributors, may be used to endorse or promote products derived
 *       from this Software without specific prior written permission.
 *
 * EXCEPT AS EXPRESSLY STATED IN THIS LICENCE AND TO THE FULL EXTENT
 * PERMITTED BY APPLICABLE LAW, THE SOFTWARE IS PROVIDED "AS-IS", AND
 * NATIONAL ICT AUSTRALIA AND ITS CONTRIBUTORS MAKE NO REPRESENTATIONS,
 * WARRANTIES OR CONDITIONS OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO ANY REPRESENTATIONS, WARRANTIES OR CONDITIONS
 * REGARDING THE CONTENTS OR ACCURACY OF THE SOFTWARE, OR OF TITLE,
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NONINFRINGEMENT,
 * THE ABSENCE OF LATENT OR OTHER DEFECTS, OR THE PRESENCE OR ABSENCE OF
 * ERRORS, WHETHER OR NOT DISCOVERABLE.
 *
 * TO THE FULL EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT SHALL
 * NATIONAL ICT AUSTRALIA OR ITS CONTRIBUTORS BE LIABLE ON ANY LEGAL
 * THEORY (INCLUDING, WITHOUT LIMITATION, IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHERWISE) FOR ANY CLAIM, LOSS, DAMAGES OR OTHER
 * LIABILITY, INCLUDING (WITHOUT LIMITATION) LOSS OF PRODUCTION OR
 * OPERATION TIME, LOSS, DAMAGE OR CORRUPTION OF DATA OR RECORDS; OR LOSS
 * OF ANTICIPATED SAVINGS, OPPORTUNITY, REVENUE, PROFIT OR GOODWILL, OR
 * OTHER ECONOMIC LOSS; OR ANY SPECIAL, INCIDENTAL, INDIRECT,
 * CONSEQUENTIAL, PUNITIVE OR EXEMPLARY DAMAGES, ARISING OUT OF OR IN
 * CONNECTION WITH THIS LICENCE, THE SOFTWARE OR THE USE OF OR OTHER
 * DEALINGS WITH THE SOFTWARE, EVEN IF NATIONAL ICT AUSTRALIA OR ITS
 * CONTRIBUTORS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH CLAIM, LOSS,
 * DAMAGES OR OTHER LIABILITY.
 *
 * If applicable legislation implies representations, warranties, or
 * conditions, or imposes obligations or liability on National ICT
 * Australia or one of its contributors in respect of the Software that
 * cannot be wholly or partly excluded, restricted or modified, the
 * liability of National ICT Australia or the contributor is limited, to
 * the full extent permitted by the applicable legislation, at its
 * option, to:
 * a.  in the case of goods, any one or more of the following:
 * i.  the replacement of the goods or the supply of equivalent goods;
 * ii.  the repair of the goods;
 * iii. the payment of the cost of replacing the goods or of acquiring
 *  equivalent goods;
 * iv.  the payment of the cost of having the goods repaired; or
 * b.  in the case of services:
 * i.  the supplying of the services again; or
 * ii.  the payment of the cost of having the services supplied again.
 *
 * The construction, validity and performance of this licence is governed
 * by the laws in force in New South Wales, Australia.
 */
#ifndef __L4__TYPES_H__
#define __L4__TYPES_H__


#if !defined(__ARMCC_VERSION) && !defined(__GNUC__)
#define __GNUC__
#endif


#endif /* !__L4__TYPES_H__ */
#ifndef KXCACHE_H
#define KXCACHE_H

/*====================================================================
  FILE:         KxCache.h

  SERVICES:     Quartz cache management

  DESCRIPTION:  This API gives access to the cache functionality
                allowing various operations such as flushing and
                invalidating the cache at various granularity levels.


  Copyright (c) 2006 QUALCOMM Incorporated.
  All Rights Reserved. QUALCOMM Proprietary and Confidential.

 =====================================================================
 *$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $ */

 
/*
 * stdlib.h declares four types, several general purpose functions,
 * and defines several macros.
 */

#ifndef __stdlib_h
#define __stdlib_h


  #ifndef __STDLIB_DECLS
  #define __STDLIB_DECLS


#undef NULL
#define NULL 0                   /* see <stddef.h> */


   /*
    * Defining __USE_ANSI_EXAMPLE_RAND at compile time switches to
    * the example implementation of rand() and srand() provided in
    * the ANSI C standard. This implementation is very poor, but is
    * provided for completeness.
    */
#ifdef __USE_ANSI_EXAMPLE_RAND
#define rand _ANSI_rand
#else
#endif
   /*
    * RAND_MAX: an integral constant expression, the value of which
    * is the maximum value returned by the rand function.
    */
  #endif /* __STDLIB_DECLS */


#endif
/* end of stdlib.h */

#endif /* #ifdef KXCACHE_H */

#endif  /* __MSM_SYSCALL_H__ */
		#else
		#endif
  #endif
#endif


/* ------------------------------------------------------------------------
** Constants
** ------------------------------------------------------------------------ */

#ifdef TRUE
#undef TRUE
#endif

#ifdef FALSE
#undef FALSE
#endif

#define TRUE   1   /* Boolean true value. */
#define FALSE  0   /* Boolean false value. */

#define  ON   1    /* On value. */
#define  OFF  0    /* Off value. */

#ifndef NULL
  #define NULL  0
#endif

/* -----------------------------------------------------------------------
** Standard Types
** ----------------------------------------------------------------------- */

/* The following definitions are the same accross platforms.  This first
** group are the sanctioned types.
*/
#ifndef _ARM_ASM_
typedef  unsigned char      boolean;     /* Boolean value type. */

typedef  unsigned long int  uint32;      /* Unsigned 32 bit value */
typedef  unsigned short     uint16;      /* Unsigned 16 bit value */
typedef  unsigned char      uint8;       /* Unsigned 8  bit value */

typedef  signed long int    int32;       /* Signed 32 bit value */

typedef  signed short       int16;       /* Signed 16 bit value */
typedef  signed char        int8;        /* Signed 8  bit value */

/* This group are the deprecated types.  Their use should be
** discontinued and new code should use the types above
*/
typedef  unsigned char     byte;         /* Unsigned 8  bit value type. */
typedef  unsigned short    word;         /* Unsinged 16 bit value type. */
typedef  unsigned long     dword;        /* Unsigned 32 bit value type. */

typedef  unsigned char     uint1;        /* Unsigned 8  bit value type. */
typedef  unsigned short    uint2;        /* Unsigned 16 bit value type. */
typedef  unsigned long     uint4;        /* Unsigned 32 bit value type. */

typedef  signed char       int1;         /* Signed 8  bit value type. */
typedef  signed short      int2;         /* Signed 16 bit value type. */
typedef  long int          int4;         /* Signed 32 bit value type. */

typedef  signed long       sint31;       /* Signed 32 bit value */
typedef  signed short      sint15;       /* Signed 16 bit value */
typedef  signed char       sint7;        /* Signed 8  bit value */

#if (! defined T_WINNT) && (! defined TARGET_OS_SOLARIS)
#ifndef SWIG  /* The SWIG preprocessor gets confused by these */
  /* Non WinNT Targets
  */

#ifndef _INT64_DEFINED
	typedef signed long long     int64;       /* Signed 64 bit value */
#define _INT64_DEFINED
#endif

#ifndef _UINT64_DEFINED
	typedef  unsigned long long  uint64;      /* Unsigned 64 bit value */
	#define _UINT64_DEFINED
#endif
#if defined(__ARMCC_VERSION) 
  #define PACKED __packed
#else  /* __GNUC__ */
#endif /* defined (__GNUC__) */

#endif /* SWIG */

#else /* T_WINNT || TARGET_OS_SOLARIS || __GNUC__ */
#endif /* T_WINNT */
#endif // #ifndef _ARM_ASM_


/* ----------------------------------------------------------------------
** Lint does not understand __packed, so we define it away here.  In the
** past we did this:
**   This helps us catch non-packed pointers accessing packed structures,
**   for example, (although lint thinks it is catching non-volatile pointers
**   accessing volatile structures).
**   This does assume that volatile is not being used with __packed anywhere
**   because that would make Lint see volatile volatile (grrr).
** but found it to be more trouble than it was worth as it would emit bogus
** errors
** ---------------------------------------------------------------------- */
#ifdef _lint
  #ifdef __packed
    #undef __packed
  #endif /* __packed */
  #define __packed
#endif

/* ----------------------------------------------------------------------
**                          STANDARD MACROS
** ---------------------------------------------------------------------- */

#ifndef SWIG /* these confuse the SWIG preprocessor and aren't needed for it */

/*===========================================================================

MACRO MAX
MACRO MIN

DESCRIPTION
  Evaluate the maximum/minimum of 2 specified arguments.

PARAMETERS
  x     parameter to compare to 'y'
  y     parameter to compare to 'x'

DEPENDENCIES
  'x' and 'y' are referenced multiple times, and should remain the same
  value each time they are evaluated.

RETURN VALUE
  MAX   greater of 'x' and 'y'
  MIN   lesser of 'x' and 'y'

SIDE EFFECTS
  None

===========================================================================*/
#ifndef MAX
   #define  MAX( x, y ) ( ((x) > (y)) ? (x) : (y) )
#endif

#ifndef MIN
   #define  MIN( x, y ) ( ((x) < (y)) ? (x) : (y) )
#endif


#endif /* SWIG */

#endif  /* COMDEF_H */
#ifndef QW_H
#define QW_H
/*===========================================================================

                  Q U A D W O R D   S E R V I C E S
                        H E A D E R    F I L E

DESCRIPTION
  This file contains delarations necessary to use the Quadword Services.

Copyright (c) 1991-2005 by QUALCOMM, Incorporated.  All Rights Reserved.
===========================================================================*/


/*
 * string.h declares one type and several functions, and defines one macro
 * useful for manipulating character arrays and other objects treated as
 * character arrays. Various methods are used for determining the lengths of
 * the arrays, but in all cases a char * or void * argument points to the
 * initial (lowest addresses) character of the array. If an array is written
 * beyond the end of an object, the behaviour is undefined.
 */

#ifndef __string_h
#define __string_h


  #ifndef __STRING_DECLS
  #define __STRING_DECLS


#undef NULL
#define NULL 0                   /* see <stddef.h> */

  #endif /* __STRING_DECLS */


#endif

/* end of string.h */

/* <EJECT> */
/*===========================================================================

                        DATA DECLARATIONS

===========================================================================*/

typedef unsigned long qword[ 2 ];

#endif /* QW_H */
#ifndef SYS_H
#define SYS_H

/**===========================================================================

              S Y S T E M   H E A D E R   F I L E

@DESCRIPTION
  This header file contains definitions that are shared between Call Manager,
  Call Manager clients and the protocol stacks.


  Organization of the file:

    The file is divided into multiple sections. Each section contains
    type definitions for a particular entity.  The following entities
    are defined in this file:

        Service Indicators
        System Identifiers
        Network Lists
        Mobility Management Information
        Menu Selection
        BCMCS

    Each section is further subdivided to represent different types of
    information.  The types of information include:

        #defines
        enumerated types
        data types
        functions

  NOTE:
    Please do not change the order of the enumerations.  If a new
    enumeration value is needed, add to the end of the enumerated
    type.  Other code may be dependent on the existing order.

Copyright (c) 2002 - 2008 by QUALCOMM INCORPORATED. All Rights Reserved.

Export of this technology or software is regulated by the U.S. Government.
Diversion contrary to U.S. law prohibited.

===========================================================================*/
#ifndef AEE_SIMULATOR
#endif


/*------------------------------------------------------------------------------
   General macros
------------------------------------------------------------------------------*/

#define SYS_WLAN_PROFILE_MAX_SIZE  120

/** Macro to convert bit number to bit mask
*/
#define SYS_BM( val ) (1<<(int)(val))

#define SYS_BM_64BIT( val )   ((uint64)1<<(int)(val))

/** @defgroup DRD DDTM related define
**  @{
*/

#define SYS_DDTM_MAX_SO_LIST_SIZE            10

typedef uint16                        sys_srv_opt_type;

/** Enumeration of DDTM actions to enhance to HDR data thru'put.
*/
typedef enum
{
  SYS_DDTM_ACT_SUPPRESS_L2ACK   = 0,
    /**< Do not send L2 ACK on 1x.
    */

  SYS_DDTM_ACT_SUPPRESS_REG     = 1,
    /**< Suppress 1x registrations.
    */

  SYS_DDTM_ACT_IGN_SO_PAGES     = 2,
    /**< Ignore 1x pages with specified service options.
    */

  SYS_DDTM_ACT_SUPPRESS_MO_DBM  = 3,
    /**< Block MO SMS and DBM
    */  

  SYS_DDTM_ACT_MAX
    /**< FOR INTERNAL USE OF CM ONLY!
    */

} sys_ddtm_act_e_type;

/**
** Enumeration of DDTM action mask.
** It converts bit position of sys_ddtm_act_e_type to a bit mask.
*/
typedef enum {

  SYS_DDTM_ACT_MASK_EMPTY           = 0,
    /**< Empty action mask.
    */

  SYS_DDTM_ACT_MASK_SUPPRESS_L2ACK  = SYS_BM(SYS_DDTM_ACT_SUPPRESS_L2ACK),
    /**< Mask for suppressing L2 acks in 1x.
    */

  SYS_DDTM_ACT_MASK_SUPPRESS_REG    = SYS_BM(SYS_DDTM_ACT_SUPPRESS_REG),
    /**< Mask for suppressing 1x registrations.
    */

  SYS_DDTM_ACT_MASK_IGN_SO_PAGES    = SYS_BM(SYS_DDTM_ACT_IGN_SO_PAGES),
    /**< Mask for ignoring pages with specified service options.
    */

  SYS_DDTM_ACT_MASK_SUPPRESS_MO_DBM = SYS_BM(SYS_DDTM_ACT_SUPPRESS_MO_DBM),
    /**< Mask for blocking MO sms and DBM
    */

  SYS_DDTM_ACT_MASK_ALL =  0x3fff,
    /**< Mask for enabling all DDTM actions.
    */

  SYS_DDTM_ACT_MASK_NO_CHANGE,
    /**< Reserved value for not changing current DDTM action settings.
    */

  SYS_DDTM_ACT_MASK_MAX
    /**< For internal use.
    */

} sys_ddtm_act_mask_e_type;

/** @}
*/

/** Maximum number of primary PDP contexts
*/
#if defined(FEATURE_MULTIPLE_PRIMARY_PDP)
#define SYS_MAX_PRIMARY_PDP_CONTEXTS          3
#else
#define SYS_MAX_PRIMARY_PDP_CONTEXTS          1
#endif

/** Maximum number of secondary PDP contexts per primary PDP context
*/
#if defined(FEATURE_SECONDARY_PDP)
#define SYS_MAX_SEC_PDP_CONTEXT_PER_PRIMARY   2
#else
#define SYS_MAX_SEC_PDP_CONTEXT_PER_PRIMARY   0
#endif

/** Maximum number of PDP contexts
*/
#define SYS_MAX_PDP_CONTEXTS                                                 \
  ( SYS_MAX_PRIMARY_PDP_CONTEXTS +                                           \
    ( SYS_MAX_PRIMARY_PDP_CONTEXTS * SYS_MAX_SEC_PDP_CONTEXT_PER_PRIMARY ) )

/* Maximum size of the SSID.
*/
#ifdef FEATURE_WLAN
#define SYS_WLAN_SSID_MAX_SIZE         (int)(32)
#else
#define SYS_WLAN_SSID_MAX_SIZE         (int)(1)
#endif


/** typedef for set window search size.
*/
typedef byte                      sys_srch_win_type;

/** Typedef for base station latitude.
*/
typedef int32                     sys_base_lat_type;

/** Typedef for base station longitude.
*/
typedef int32                     sys_base_long_type;

/** Typedef for base station ID.
*/
typedef word                     sys_base_id_type;

/* Type for WLAN BSS id.
*/
typedef uint64                   sys_wlan_bssid_type;

/*------------------------------------------------------------------------------
   Service Indicators Enums
------------------------------------------------------------------------------*/

/**
** Enumeration of phone operating modes.
*/
/** For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum
{
  SYS_OPRT_MODE_NONE = -1,
    /**< FOR INTERNAL USE OF CM ONLY!                     */

  SYS_OPRT_MODE_PWROFF = 0,
    /**< Phone is powering off                            */

  SYS_OPRT_MODE_FTM = 1,
    /**< Phone is in factory test mode                    */

  SYS_OPRT_MODE_OFFLINE = 2,
    /**< Phone is offline                                 */

  SYS_OPRT_MODE_OFFLINE_AMPS = 3,
    /**< Phone is offline analog                          */

  SYS_OPRT_MODE_OFFLINE_CDMA = 4,
    /**< Phone is offline cdma                            */

  SYS_OPRT_MODE_ONLINE = 5,
    /**< Phone is online                                  */

  SYS_OPRT_MODE_LPM = 6,
    /**< Phone is in LPM - Low Power Mode                 */

  SYS_OPRT_MODE_RESET = 7,
    /**< Phone is resetting - i.e. power-cycling          */

  SYS_OPRT_MODE_NET_TEST_GW = 8,
    /**< Phone is conducting network test for GSM/WCDMA.  */
    /**< This mode can NOT be set by the clients. It can  */
    /**< only be set by the lower layers of the stack.    */

  SYS_OPRT_MODE_OFFLINE_IF_NOT_FTM = 9,
    /**< This mode is only set when there is offline      */
    /**< request during powerup.                          */
    /**< This mode can not be set by the clients. It can  */
    /**< only be set by task mode controller.             */

  SYS_OPRT_MODE_PSEUDO_ONLINE = 10,
    /**< Phone is pseudo online, tx disabled              */

  SYS_OPRT_MODE_RESET_MODEM = 11,
    /**< Phone is resetting the modem processor.          */

  SYS_OPRT_MODE_MAX
    /**< FOR INTERNAL USE OF CM ONLY!                     */

  #ifdef FEATURE_RPC
  ,
  SYS_OPRT_MODE_BIG = 0x10000000
    /**< To force enum to 32 bit for windows NT           */
  #endif /* FEATURE_RPC */

} sys_oprt_mode_e_type;

/**
** Enumeration of system modes.
*/
/** For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum
{
  SYS_SYS_MODE_NONE = -1,
    /**< FOR INTERNAL USE ONLY!                             */

  SYS_SYS_MODE_NO_SRV=0,
    /**< No service = NV_MODE_INACTIVE                      */

  SYS_SYS_MODE_AMPS=1,
    /**< Analog Mobile Phone System (AMPS) mode             */

  SYS_SYS_MODE_CDMA=2,
    /**< Code Division Multiple Access (CDMA) mode          */

  SYS_SYS_MODE_GSM=3,
    /**< Global System for Mobile communications (GSM) mode */

  SYS_SYS_MODE_HDR=4,
    /**< High Data Rate (HDR) mode                          */

  SYS_SYS_MODE_WCDMA=5,
    /**< Wideband CDMA (WCDMA) mode                         */

  SYS_SYS_MODE_GPS=6,
    /**< Global Positioning System (GPS) mode               */

  SYS_SYS_MODE_GW=7,
    /**< GSM and WCDMA mode                                 */

  SYS_SYS_MODE_WLAN=8,
  /**< WLAN mode                                          */

  SYS_SYS_MODE_MAX
    /**< FOR INTERNAL USE ONLY!                             */

  #ifdef FEATURE_RPC
  ,
  SYS_SYS_MODE_BIG=0x10000000
    /**< To force enum to 32 bit for windows NT             */
  #endif /* FEATURE_RPC */
} sys_sys_mode_e_type;

/** Macro for creating a Bit Mask by shifting 1 left by a specified number -
** useful for defining a bit-mask enum values.
*/
#define BM( val ) ( 1<< ((int)(val)) )

/** Bit Masks of system modes 
** Combination of system modes can be created
** by using the macro ADD_SYSMODE
*/
typedef enum
{

  SYS_SYS_MODE_MASK_NONE        = 0,
                                /**< Acquire no system */

  SYS_SYS_MODE_MASK_NO_SRV      = BM( SYS_SYS_MODE_NO_SRV ),
                                /**< No service */

  SYS_SYS_MODE_MASK_CDMA        = BM( SYS_SYS_MODE_CDMA ),
                                /**< CDMA mode systems only */

  SYS_SYS_MODE_MASK_HDR         = BM( SYS_SYS_MODE_HDR ),
                                /**< Acquire HDR mode systems only */

  SYS_SYS_MODE_MASK_GSM         = BM( SYS_SYS_MODE_GSM ),
                                /**< Acquire GSM systems only */

  SYS_SYS_MODE_MASK_WCDMA       = BM( SYS_SYS_MODE_WCDMA ),
                                /**< Acquire WCDMA systems only */

  SYS_SYS_MODE_MASK_WLAN        = BM( SYS_SYS_MODE_WLAN ),
                                /**< Acquire WLAN systems only */

  SYS_SYS_MODE_MASK_MAX

} sys_sys_mode_mask_e_type;

/**
** Enumeration of system band classes.
*/
typedef enum
{
  SYS_BAND_CLASS_NONE        = -1,
    /**< FOR INTERNAL USE OF CM ONLY!                    */

  SYS_BAND_BC0               = 0,
    /**< Band Class 0 - US Cellular band (800 MHz)       */

  SYS_BAND_BC1               = 1,
    /**< Band Class 1 - US */

  SYS_BAND_BC3               = 3,
    /**< Band Class 3 - Japanese Cellular band (800 MHz) */

  SYS_BAND_BC4               = 4,
    /**< Band Class 4 - Korean PCS band (1800 MHz)       */

  SYS_BAND_BC5               = 5,
    /**< Band Class 5 (450 MHz)                          */

  SYS_BAND_BC6               = 6,
    /**< Band Class 6 (2 GHz)                            */

  SYS_BAND_BC7               = 7,
    /**< Band Class 7 (700 MHz)                          */

  SYS_BAND_BC8               = 8,
    /**< Band Class 8 (1800 MHz)                         */

  SYS_BAND_BC9               = 9,
    /**< Band Class 9 (900 MHz)                          */

  SYS_BAND_BC10              = 10,
    /**< Band Class 10 (Second 800 MHz)                  */

  SYS_BAND_BC11              = 11,
    /**< Band Class 11 - European PAMR Band (400 MHz)    */

  SYS_BAND_BC12              = 12,
  /**< Band Class 12 - PAMR Band (800 MHz)               */

  SYS_BAND_BC14              = 14,
  /**< Band Class 14 - Band Class 14 (US PCS 1.9GHz Band)*/

  SYS_BAND_BC15              = 15,
  /**< Band Class 15 - Band Class 15 (1700-2100 MHz -AWS)*/

  SYS_BAND_BC16              = 16,
  /**< Band Class 16 - Band Class 16 (US 2.5GHz)         */



    /**< Reserved 12-39 for CDMA band classes. */



  SYS_BAND_GSM_450           = 40,
    /**< GSM 450 band (450 MHz)                          */

  SYS_BAND_GSM_480           = 41,
    /**< GSM 480 band (480 MHz)                          */

  SYS_BAND_GSM_750           = 42,
    /**< GSM 750 band (750 MHz)                          */

  SYS_BAND_GSM_850           = 43,
    /**< GSM 850 band (850 MHz)                          */

  SYS_BAND_GSM_EGSM_900      = 44,
    /**< GSM Extended GSM (E-GSM) 900 band (900 MHz)     */

  SYS_BAND_GSM_PGSM_900      = 45,
    /**< GSM Primary GSM ( P-GSM) 900 band (900 MHz)     */

  SYS_BAND_GSM_RGSM_900      = 46,
    /**< GSM Railways GSM ( R-GSM) 900 band (900 MHz)    */

  SYS_BAND_GSM_DCS_1800      = 47,
    /**< GSM DCS band (1800 MHz)                         */

  SYS_BAND_GSM_PCS_1900      = 48,
    /**< GSM PCS band (1900 Mhz)                         */

    /**< Reserved 49-79 for GSM band classes. */

  SYS_BAND_WCDMA_I_IMT_2000  = 80,
    /**< WCDMA EUROPE JAPAN & CHINA IMT 2100 band        */

  SYS_BAND_WCDMA_II_PCS_1900 = 81,
    /**< WCDMA US PCS 1900 band                          */

  SYS_BAND_WCDMA_III_1700    = 82,
    /**< WCDMA EUROPE&CHINA DCS 1800 band                */

  SYS_BAND_WCDMA_IV_1700     = 83,
    /**< WCDMA US 1700 band                              */

  SYS_BAND_WCDMA_V_850       = 84,
    /**< WCDMA US 850 band                               */

  SYS_BAND_WCDMA_VI_800      = 85,
    /**< WCDMA JAPAN 800 band                            */

  SYS_BAND_WCDMA_VII_2600    = 86,
    /**< WCDMA EUROPE 2600 band                          */

  SYS_BAND_WCDMA_VIII_900    = 87,
    /**< WCDMA EUROPE & CHINA 900 band.                  */

  SYS_BAND_WCDMA_IX_1700     = 88,
    /**< WCDMA JAPAN 1700 band                           */

  /**< Reserved 85-109 for WCDMA band classes. 
  */

  SYS_BAND_WLAN_US_2400    = 110,
    /**< WLAN US 2400 Mhz band                           */

  SYS_BAND_WLAN_JAPAN_2400 = 111,
    /**< WLAN JAPAN 2400 Mhz band                        */

  SYS_BAND_WLAN_EUROPE_2400 = 112,
    /**< WLAN EUROPEAN 2400 Mhz band                     */

  SYS_BAND_WLAN_FRANCE_2400 = 113,
    /**< WLAN FRANCE 2400 Mhz band                       */

  SYS_BAND_WLAN_SPAIN_2400 = 114,
    /**< WLAN SPAIN 2400 Mhz band                        */


  SYS_BAND_WLAN_US_5000    = 115,
    /**< WLAN US 5000 Mhz band                           */

  SYS_BAND_WLAN_JAPAN_5000 = 116,
    /**< WLAN JAPAN 5000 Mhz band                        */

  SYS_BAND_WLAN_EUROPE_5000 = 117,
    /**< WLAN EUROPEAN 5000 Mhz band                     */

  SYS_BAND_WLAN_FRANCE_5000 = 118,
    /**< WLAN FRANCE 5000 Mhz band                       */

  SYS_BAND_WLAN_SPAIN_5000 = 119,
    /**< WLAN SPAIN 5000 Mhz band                        */

  SYS_BAND_CLASS_MAX
    /**< FOR INTERNAL USE ONLY!                          */

  #ifdef FEATURE_RPC
  ,
  SYS_BAND_CLASS_BIG=0x10000000
    /**< To force enum to 32 bit for windows NT          */
  #endif /* FEATURE_RPC */
} sys_band_class_e_type;

typedef uint16 sys_channel_num_type;   /**< CDMA Channel Number */

/**
** Enumeration of system band class mask.
** It converts bit position of sys_sband_e_type to a bit mask.
** To keep numbering scheme consistent,
** use sys_sband_e_type instead of numbers directly.
**
*/
/**
** Band class bit mask data type. It is a combination of enumeration of
** system band class mask.
*/
typedef uint64                sys_band_mask_type;
    /**< Acquire WCDMA JAPAN 1700 systems only */

#define SYS_BAND_MASK_WLAN_US_2400      ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_US_2400 ))
    /**< Acquire WLAN US 2400 systems only */

#define SYS_BAND_MASK_WLAN_EUROPE_2400  ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_EUROPE_2400 ))
    /**< Acquire WLAN EUROPE 2400 systems only */

#define SYS_BAND_MASK_WLAN_FRANCE_2400  ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_FRANCE_2400 ))
    /**< Acquire WLAN FRANCE 2400 systems only */

#define SYS_BAND_MASK_WLAN_SPAIN_2400   ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_SPAIN_2400 ))
    /**< Acquire WLAN SPAIN 2400 systems only */

#define SYS_BAND_MASK_WLAN_JAPAN_2400   ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_JAPAN_2400 ))
    /**< Acquire WLAN JAPAN 2400 systems only */

#define SYS_BAND_MASK_WLAN_US_5000      ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_US_5000 ))
    /**< Acquire WLAN US 5000 systems only */

#define SYS_BAND_MASK_WLAN_EUROPE_5000  ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_EUROPE_5000 ))
    /**< Acquire WLAN EUROPE 5000 systems only */

#define SYS_BAND_MASK_WLAN_FRANCE_5000  ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_FRANCE_5000 ))
    /**< Acquire WLAN FRANCE 5000 systems only */

#define SYS_BAND_MASK_WLAN_SPAIN_5000   ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_SPAIN_5000 ))
    /**< Acquire WLAN SPAIN 5000 systems only */

#define SYS_BAND_MASK_WLAN_JAPAN_5000   ((sys_band_mask_type) SYS_BM_64BIT( SYS_SBAND_WLAN_JAPAN_5000 ))
    /**< Acquire WLAN JAPAN 5000 systems only */


#define SYS_BAND_MASK_WLAN_2400         (SYS_BAND_MASK_WLAN_US_2400      | \
                                         SYS_BAND_MASK_WLAN_JAPAN_2400   | \
                                         SYS_BAND_MASK_WLAN_EUROPE_2400  | \
                                         SYS_BAND_MASK_WLAN_FRANCE_2400  | \
                                         SYS_BAND_MASK_WLAN_SPAIN_2400)

#define SYS_BAND_MASK_WLAN_5000         (SYS_BAND_MASK_WLAN_US_5000      | \
                                         SYS_BAND_MASK_WLAN_JAPAN_5000   | \
                                         SYS_BAND_MASK_WLAN_FRANCE_5000  | \
                                         SYS_BAND_MASK_WLAN_EUROPE_5000  | \
                                         SYS_BAND_MASK_WLAN_SPAIN_5000)

#define SYS_BAND_MASK_WLAN_ANY          (SYS_BAND_MASK_WLAN_2400 | \
                                         SYS_BAND_MASK_WLAN_5000)

/**
** Channel data type.
*/
typedef word  sys_chan_type;

/**
** Enumeration of PCS frequency blocks/Cellular systems.
*/
typedef enum
{
  SYS_BLKSYS_NONE = -1,
    /**< FOR INTERNAL USE OF CM ONLY!           */

  /* 0 */
  SYS_BLKSYS_PCS_A,
    /**< PCS block A                            */

  SYS_BLKSYS_PCS_B,
    /**< PCS block B                            */

  SYS_BLKSYS_PCS_C,
    /**< PCS block C                            */

  SYS_BLKSYS_PCS_D,
    /**< PCS block D                            */

  /* 4 */
  SYS_BLKSYS_PCS_E,
    /**< PCS block E                            */

  SYS_BLKSYS_PCS_F,
    /**< PCS block F                            */

  SYS_BLKSYS_PCS_CELL_A,
    /**< Cellular system A                      */

  SYS_BLKSYS_PCS_CELL_B,
    /**< Cellular system B                      */

  /* 8 */
  SYS_BLKSYS_PCS_G,
    /**< BC5/11 G-Block                         */

  SYS_BLKSYS_PCS_H,
    /**< BC5/11 H-Block                         */

  SYS_BLKSYS_PCS_I,
    /**< BC5/11 I-Block                         */

  SYS_BLKSYS_PCS_J,
    /**< BC5/11 J-Block                         */

  /* 12 */
  SYS_BLKSYS_PCS_K,
    /**< BC5/11 K-Block                         */

  SYS_BLKSYS_PCS_L,
    /**< BC5 L-BLOCK                            */

  SYS_BLKSYS_MAX
    /**< FOR INTERNAL USE OF CM ONLY!           */

  #ifdef FEATURE_RPC
  ,
  SYS_BLKSYS_BIG = 0x10000000
    /**< To force enum to 32 bit for windows NT */
  #endif /**< FEATURE_RPC */

} sys_blksys_e_type;

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/** Enumeration of prl system types.
*/
typedef enum {

  SYS_PRL_AVAIL_BC0_A = 0,         /**< available systems on Band Class 0,
                                   ** A-System only
                                   */

  SYS_PRL_AVAIL_BC0_B = 1,         /**< available systems on
                                   ** Band Class 0, B-System only
                                   */

  SYS_PRL_MAX

} sys_prl_e_type;

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/**
** Enumeration of service status.  Indicates whether service is
** available or not available.
*/
typedef enum
{
  SYS_SRV_STATUS_NONE = -1,
    /**< FOR INTERNAL USE ONLY!                 */

  /* 0 */
  SYS_SRV_STATUS_NO_SRV,
    /**< No service                             */

  SYS_SRV_STATUS_LIMITED,
    /**< Limited service                        */

  SYS_SRV_STATUS_SRV,
    /**< Service available                      */

  SYS_SRV_STATUS_LIMITED_REGIONAL,
    /**< Limited regional service               */

  /* 4 */
  SYS_SRV_STATUS_PWR_SAVE,
    /**< MS is in power save or deep sleep      */

  SYS_SRV_STATUS_MAX
    /**< FOR INTERNAL USE OF CM ONLY!           */

  #ifdef FEATURE_RPC
  ,
  SYS_SRV_STATUS_BIG = 0x10000000
    /**< To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} sys_srv_status_e_type;

/**
** The following enumerated type defines type of service.
*/
typedef enum
{
  SYS_SRV_DOMAIN_NONE = -1,
    /**< FOR INTERNAL USE ONLY!                 */

  /* 0 */
  SYS_SRV_DOMAIN_NO_SRV,
    /**< No service                             */

  SYS_SRV_DOMAIN_CS_ONLY,
    /**< Circuit Switched Only Capable          */

  SYS_SRV_DOMAIN_PS_ONLY,
    /**< Packet Switched Only Capable           */

  SYS_SRV_DOMAIN_CS_PS,
    /**< Circuit and Packet Switched Capable    */

  /* 4 */
  SYS_SRV_DOMAIN_CAMPED,
    /**< MS found the right system but not yet
    ** registered/attached.                  */

  SYS_SRV_DOMAIN_MAX
    /**< FOR INTERNAL USE ONLY!                 */

  #ifdef FEATURE_RPC
  ,
  SYS_SRV_DOMAIN_BIG=0x10000000
    /**< To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */
} sys_srv_domain_e_type;

/**
** The following enumerated type defines the service capabilities
** of a network.
*/
typedef enum
{
  SYS_SRV_CAPABILITY_NONE = -1,
    /**< FOR INTERNAL USE ONLY!                                            */

  SYS_SRV_CAPABILITY_NOT_AVAILABLE,
    /**< Network can not provide service                                   */

  SYS_SRV_CAPABILITY_CS_SERVICE_ONLY,
    /**< Network is capable of providing Circuit Switched service          */

  SYS_SRV_CAPABILITY_PS_SERVICE_ONLY,
    /**< Network is capable of providing Packet Switched service           */

  SYS_SRV_CAPABILITY_CS_PS_SERVICE,
    /**< Network is capable of providing Circuit & Packet Switched service */

  SYS_SRV_CAPABILITY_MAX
    /**< FOR INTERNAL USE ONLY!                                            */

  #ifdef FEATURE_RPC
  ,
  SYS_SRV_CAPABILITY_BIG=0x10000000
    /**< To force enum to 32 bit for windows NT                            */
  #endif /* FEATURE_RPC */
} sys_srv_capability_e_type;

/**
** Enumeration of roaming statuses.  The values for these enumerates
** were derived from the roaming display indicators described in
** 3GPP2 C.R1001-A.  Please note that the actual value of the enumerate
** is not consistent with the value listed in the standard (e.g. the
** value of SYS_ROAM_STATUS_OFF and SYS_ROAM_STATUS_ON are reversed from
** the standard.
*/
typedef enum
{

  SYS_ROAM_STATUS_NONE = -1,
    /**< FOR INTERNAL USE ONLY!                      */

  /* 0 */
  SYS_ROAM_STATUS_OFF,
    /**< Roaming Indicator off                       */

  SYS_ROAM_STATUS_ON,
    /**< Roaming Indicator on                        */

  SYS_ROAM_STATUS_BLINK,
    /**< Roaming Indicator flashing                  */

  SYS_ROAM_STATUS_OUT_OF_NEIGHBORHOOD,
    /**< Out of neighborhood                         */
  
  /* 4 */
  SYS_ROAM_STATUS_OUT_OF_BLDG,
    /**< Out of building                             */

  SYS_ROAM_STATUS_PREF_SYS,
    /**< Roaming - preferred system                  */

  SYS_ROAM_STATUS_AVAIL_SYS,
    /**< Roaming - available system                  */

  SYS_ROAM_STATUS_ALLIANCE_PARTNER,
    /**< Roaming - alliance partner                  */

  /* 8 */
  SYS_ROAM_STATUS_PREMIUM_PARTNER,
    /**< Roaming - premium partner                   */

  SYS_ROAM_STATUS_FULL_SVC,
    /**< Roaming - full service functionality        */

  SYS_ROAM_STATUS_PARTIAL_SVC,
    /**< Roaming - partial service functionality     */

  SYS_ROAM_STATUS_BANNER_ON,
    /**< Roaming banner on                           */

  /* 12 */
  SYS_ROAM_STATUS_BANNER_OFF,
    /**< Roaming banner off                          */

  SYS_ROAM_STATUS_MAX  = 0xFF+1
    /**< FOR INTERNAL USE ONLY!                      */
    /**< Values 0x00 - 0xFF are used in the standard */

} sys_roam_status_e_type;

/**
** The following enumerated type defines the radio access technologies.
*/
typedef enum
{
  SYS_RAT_NONE = -1,
    /**< FOR INTERNAL USE ONLY!                 */

  SYS_RAT_GSM_RADIO_ACCESS,
    /**< GSM radio access technology            */

  SYS_RAT_UMTS_RADIO_ACCESS,
    /**< UMTS radio access technology           */

  SYS_RAT_MAX
    /**< FOR INTERNAL USE ONLY!                 */

  #ifdef FEATURE_RPC
  ,
  SYS_RAT_BIG  = 0x10000000
    /**< To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} sys_radio_access_tech_e_type;

/**
** The following enumerated type defines the state of the
** Subscriber Identfication Module (SIM) card.
*/
typedef enum
{
  SYS_SIM_STATE_NONE = -1,
    /**< FOR INTERNAL USE ONLY!                 */

  /* 0 */
  SYS_SIM_STATE_NOT_AVAILABLE,
    /**< The SIM is not available               */

  SYS_SIM_STATE_AVAILABLE,
    /**< The SIM is available                   */

  SYS_SIM_STATE_CS_INVALID,
    /**< The SIM has been marked by the network */
    /**< as invalid for CS services             */

  SYS_SIM_STATE_PS_INVALID,
    /**< The SIM has been marked by the network */
    /**< as invalid for PS services             */

  /* 4 */
  SYS_SIM_STATE_CS_PS_INVALID,
    /**< The SIM has been marked by the network */
    /**< as invalid for CS and PS services      */

  SYS_SIM_STATE_MAX
    /**< FOR INTERNAL USE ONLY!                 */

  #ifdef FEATURE_RPC
  ,
  SYS_SIM_STATE_BIG = 0x10000000
    /**< To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} sys_sim_state_e_type;

#if (defined(FEATURE_UMTS_1X_HANDOVER_1XMSM) || \
    defined(FEATURE_UMTS_1X_HANDOVER_UMTSMSM) || \
    defined(FEATURE_MM_SUPERSET))

/** Enumeration to identify the MSM.
*/
typedef enum
{
  SYS_MSM_ID_NONE = -1,
    /**< used only for bounds checking.           */

  /* 0 */
  SYS_MSM_ID_6500,
    /**< MSM Id is 6500.                          */

  SYS_MSM_ID_6250,
    /**< MSM Id is 6250.                          */

  SYS_MSM_ID_MAIN,
    /**< MSM which has control of DPRAM.          */

  SYS_MSM_ID_SECONDARY,
    /**< MSM which does not has control of DPRAM. */

  /* 4 */
  SYS_MSM_ID_MAX
    /**< Used for arrays & bounds checking        */

} sys_msm_id_e_type;
#endif


/** Enumeration for simultaneous modes, needed to 7600 to differentiate
** between WX and non-WX modes of operation
*/

typedef enum {

  SYS_SIMULTANEOUS_MODE_NONE = -1,    /**< For Internal SD use              */

  SYS_SIMULTANEOUS_MODE_NON_WX,       /**< Not in WX mode                   */

  SYS_SIMULTANEOUS_MODE_WX ,          /**< Simultaneous CDMA and WCDMA (WX) */

  SYS_SIMULTANEOUS_MODE_MAX           /**< For Internal SD use              */

  #ifdef FEATURE_RPC
  ,
  SYS_SIMULTANEOUS_MODE_BIG = 0x10000000
    /**< To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} sys_simultaneous_mode_e_type;

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/** Enumeration for hsdpa, hsupa indication types
** High speed downlink packet access and high speed
** uplink packet access can be available within WCDMA
** service only
*/
typedef enum
{

  SYS_HS_IND_NONE = -1,
    /**< FOR INTERNAL USE OF CM ONLY!
    */

  SYS_HS_IND_HSDPA_HSUPA_UNSUPP_CELL,
    /**< Cell does not support either HSDPA or HSUPA
    */

  SYS_HS_IND_HSDPA_SUPP_CELL,
    /**< Cell supports HSDPA
    */

  SYS_HS_IND_HSUPA_SUPP_CELL,
    /**< Cell supports HSUPA
    */

  SYS_HS_IND_HSDPA_HSUPA_SUPP_CELL,
    /**< Cell supports HSDPA and HSUPA
    */  

  SYS_HS_IND_MAX
    /**< FOR INTERNAL USE OF CM ONLY!
    */

} sys_hs_ind_e_type;

/** Dual transfer mode allows simultaneous
** CS and ps calls during GSM only service
*/
typedef enum
{

  SYS_DTM_SUPPORT_NONE = -1,
    /**< FOR INTERNAL USE OF CM ONLY!
    */  

  SYS_DTM_SUPPORT_NOT_AVAIL,
    /**< DTM support is not available
    */

  SYS_DTM_SUPPORT_AVAIL,
    /**< DTM support is available
    */

  SYS_DTM_SUPPORT_MAX
    /**< FOR INTERNAL USE OF CM ONLY!
    */

} sys_dtm_support_e_type;

typedef enum

{

  SYS_EGPRS_SUPPORT_NONE = -1,
    /**< FOR INTERNAL USE OF CM ONLY!
    */  
  
  SYS_EGPRS_SUPPORT_NOT_AVAIL,
    /**< EGPRS support is not available
    */

  SYS_EGPRS_SUPPORT_AVAIL,
    /**< EGPRS support is available
    */

  SYS_EGPRS_SUPPORT_MAX
    /**< FOR INTERNAL USE OF CM ONLY!
    */

} sys_egprs_support_e_type;

/** Maximum user zone name length.
*/
#define  SYS_PUZL_MAX_UZ_NAME_LEN          32

typedef struct
{
  byte     uz_name_encoding;

  byte     uz_name_n_octets;

  byte     uz_name[SYS_PUZL_MAX_UZ_NAME_LEN];

} sys_puzl_uz_name_s_type;

/*------------------------------------------------------------------------------
   HDR related Defines^M
------------------------------------------------------------------------------*/

/** Enumeration of active protocol revision for various technolgies.
*/
typedef enum {

  
  SYS_ACTIVE_PROT_NONE,               /**< The protocol revision is unknown.
                                      ** When HDR sys ID is first acquired 
                                      ** and no protocol revision is 
                                      ** available at this point.
                                      */
  SYS_ACTIVE_PROT_HDR_START,          /**< The protocol revision is unknown.
                                      ** When HDR sys ID is first acquired 
                                      ** and no protocol revision is 
                                      ** available at this point.
                                      */
  SYS_ACTIVE_PROT_HDR_REL0,           /**< HDR release 0 
                                      */
  SYS_ACTIVE_PROT_HDR_RELA,           /**< HDR release A (physical layer 
                                      ** subtype 2 is active in current 
                                      ** personality) 
                                      */
  SYS_ACTIVE_PROT_HDR_END,            /**< Internal use for HDR range check  
                                      */

                                      /**< If adding other technologies, pls
                                      ** reserve some entries for HDR.
                                      */

  SYS_ACTIVE_PROT_MAX                 /**< Internal use for enum range check.
                                      */

} sys_active_prot_e_type;

/** PDP header compression types */
typedef enum
{
  SYS_PDP_HEADER_COMP_NONE = -1,
    /**< FOR INTERNAL USE OF CM ONLY!
    */

  SYS_PDP_HEADER_COMP_OFF = 0,
    /**< PDP header compression is OFF.
    ** Preserves earlier value of h_comp=FALSE 
    ** for no header compression.
    */

  SYS_PDP_HEADER_COMP_ON  = 1,
    /**< PDP header compression is ON.
    ** Preserves earlier value of h_comp=TRUE
    ** for default header compression.
    */


  SYS_PDP_HEADER_COMP_RFC1144,
    /**< PDP header compression based on rfc 1144.    
    ** 3GPP TS 44.065 (sect 6.5.1.1.4)
    */

  SYS_PDP_HEADER_COMP_RFC2507,
    /**< PDP header compression based on rfc 2507.    
    ** 3GPP TS 44.065 (sect 6.5.1.1.4)
    */


  SYS_PDP_HEADER_COMP_RFC3095,
    /**< PDP header compression based on rfc 3095.    
    ** 3GPP TS 44.065 release-6 version-6.5.0 
    ** (sect 6.5.4 and 6.5.5)
    */

  SYS_PDP_HEADER_COMP_MAX
    /**< FOR INTERNAL USE OF CM ONLY!
    */

} sys_pdp_header_comp_e_type;

/** PDP Data compression types */
typedef enum
{
  SYS_PDP_DATA_COMP_NONE = -1,
    /**< FOR INTERNAL USE OF CM ONLY!
    */

  SYS_PDP_DATA_COMP_OFF = 0,
    /**< PDP Data compression is OFF.
    ** Preserves earlier value of d_comp=FALSE 
    ** for no data compression.
    */

  SYS_PDP_DATA_COMP_ON  = 1,
    /**< Default PDP Data compression is enabled.
    ** Preserves earlier value of d_comp=TRUE 
    ** for default data compression.
    */


  SYS_PDP_DATA_COMP_V42_BIS,
    /**< Data compression standard specified in
    ** 3GPP TS 44.065 (sect 6.6.1.1.4).
    */


  SYS_PDP_DATA_COMP_V44,
    /**< Data compression standard specified in
    ** 3GPP TS 44.065 (sect 6.6.1.1.4).
    */

  SYS_PDP_DATA_COMP_MAX
    /**< FOR INTERNAL USE OF CM ONLY!
    */

} sys_pdp_data_comp_e_type;

/* Enumeration of WLAN BSS types.
*/
typedef enum {

  /* FOR INTERNAL USE ONLY!.
  */
  SYS_WLAN_BSS_TYPE_NONE = -1,

  /* Ad-Hoc Type BSS.
  */
  SYS_WLAN_BSS_TYPE_ADHOC,

  /* Infrastructure Mode BSS.
  */
  SYS_WLAN_BSS_TYPE_INFRA,

  /* Any BSS Mode Type.
  */
  SYS_WLAN_BSS_TYPE_ANY,

  /* Ad-Hoc Type BSS created by MS.
  */
  SYS_WLAN_BSS_TYPE_ADHOC_START,

  /* FOR INTERNAL USE ONLY!.
  */
  SYS_WLAN_BSS_TYPE_MAX

} sys_wlan_bss_e_type;

/* Type that defines the SSID of WLAN system.
*/
typedef struct sys_wlan_ssid_s
{
  /* Length of the SSID, if == 0, then SSID = broadcast SSID.
  */
  uint8                                len;

  /* SSID of the wlan system.
  */
  char                                 ssid[SYS_WLAN_SSID_MAX_SIZE];

} sys_wlan_ssid_s_type;

/* Enumeration of Technology type/version.
*/
typedef enum
{

  /* FOR INTERNAL USE OF CM ONLY!.
  */
  SYS_TECH_NONE                        = -1,

  /* WLAN 802.11a technology.
  */
  SYS_TECH_WLAN_80211A                 = 0,

  /* WLAN 802.11b technology.
  */
  SYS_TECH_WLAN_80211B                 = 1,

  /* WLAN 802.11g technology.
  */
  SYS_TECH_WLAN_80211G                 = 2,


  /* Reserved values for CM use.
  */
  SYS_TECH_RESERVED                    = 30,

  /* FOR INTERNAL USE OF CM ONLY!.
  */
  SYS_TECH_MAX

} sys_tech_e_type;

/*------------------------------------------------------------------------------
   Service Indicator Data Types
------------------------------------------------------------------------------*/

/**
** Define a enumerated type that indicates the type of system ID.
*/
typedef enum
{

  SYS_SYS_ID_TYPE_UNDEFINED,
    /**< System ID is undefined     */

  SYS_SYS_ID_TYPE_UMTS,
    /**< UMTS (WCDMA/GSM) system ID */

  SYS_SYS_ID_TYPE_IS95,
    /**< IS-95 system ID            */

  SYS_SYS_ID_TYPE_IS856,
    /**< IS-856 (HDR) system ID     */

  SYS_SYS_ID_TYPE_WLAN
    /**< WLAN System Id                 */

} sys_sys_id_type_e_type;

/*------------------------------------------------------------------------------
   System Identifier Data Types
------------------------------------------------------------------------------*/
/**
** Define a structure that identifies an IS-95 system.
**/
typedef struct sys_is95_sys_id_s
{
  uint16         sid;
       /**< The system ID */

  uint16         nid;
       /**< The network ID */

  word           mcc;       
       /**< MCC - Mobile County Code */

  byte           imsi_11_12;
       /**< IMSI_11_12 */

} sys_is95_sys_id_s_type;

/**
** Define a structure that identifies a Public Land Mobile Network (PLMN).
** A PLMN ID is defined within a GSM network to be the combination of a Mobile
** Country Code (MCC) and Mobile Network Code (MNC).  A PLMN ID is stored in 3
** octets as specified in 3G TS 24.008 Section 10.5.1.3 and shown below:
**                                        Bit
**                 |  8  |  7  |  6  |  5  |  4  |  3  |  2  |  1  |
**                 |===============================================|
**         octet 1 |      MCC Digit 2      |      MCC Digit 1      |
**                 |-----------------------------------------------|
**         octet 2 |      MNC Digit 3      |      MCC Digit 3      |
**                 |-----------------------------------------------|
**         octet 3 |      MNC Digit 2      |      MNC Digit 1      |
**                 |===============================================|
**
** The criteria for comparing one PLMN against another is specified in
** 3G TS 23.122 Annex A.
**/
typedef struct sys_plmn_id_s
{
  byte                                identity[3];
} sys_plmn_id_s_type;

/**
**        LAC      local area code.
**/
typedef word                          sys_lac_type;

/**
**        PLMN + LAC.
**/
typedef struct sys_plmn_lac_id_s
{
  sys_plmn_id_s_type   plmn;
  sys_lac_type         lac;
}sys_plmn_lac_id_s_type;

/**
** Type for system ID.
*/
typedef union sys_sys_id_u
{
  /** IS-95 system ID.
  */
  sys_is95_sys_id_s_type               is95;

  /** IS-856 system ID.
  */
  byte                                 is856[16];

  /** WLAN system Id.
  */
  sys_wlan_ssid_s_type                 ssid;

  sys_plmn_lac_id_s_type  plmn_lac;
    /**< UMTS (WCDMA/GSM) PLMN and LAC ID  */

} sys_sys_id_u_type;

typedef struct sys_sys_id_s
{
  /** Type of the system id.
  */
  sys_sys_id_type_e_type              id_type;

  /** The system identifier.
  */
  sys_sys_id_u_type                   id;

} sys_sys_id_s_type;

/**
**        CELL ID
**/
typedef uint32                        sys_cell_id_type;

/**
**   CELL ID 
**/
typedef struct sys_cell_info_s
{
  sys_cell_id_type         cell_id;
                           /* Cell_id */
}sys_cell_info_s_type;

/** Type for profile Id.
*/
typedef byte                          sys_profile_id_type;

#if (defined(FEATURE_GSM) || defined(FEATURE_WCDMA) || defined(FEATURE_WLAN))
#define SYS_NETWORK_LIST_INFO_MAX          (int)(25)
#else
#define SYS_NETWORK_LIST_INFO_MAX          (int)(1)
#endif

#if (defined(FEATURE_GSM) || defined(FEATURE_WCDMA))

#define SYS_USER_PPLMN_LIST_MAX_LENGTH      85
  /**< Maximum number of user preferred/controlled PLMNs */
#define SYS_PLMN_LIST_MAX_LENGTH            40

#else
#endif

/*------------------------------------------------------------------------------
   Network Lists Enums
------------------------------------------------------------------------------*/
/**
** The following enumerated types defines whether the PLMN in the PLMN list
** is a
**
**     Home PLMN
**     User Controlled PLMN (preferred) stored on the SIM
**     Operator Controlled PLMN stored on the SIM
**     Other PLMN
**     Forbidden PLMN
*/

typedef enum
{
  SYS_DETAILED_PLMN_LIST_CATEGORY_NONE = -1,     /* FOR INTERNAL USE ONLY! */
  SYS_DETAILED_PLMN_LIST_CATEGORY_HPLMN,
  SYS_DETAILED_PLMN_LIST_CATEGORY_PREFERRED,
  SYS_DETAILED_PLMN_LIST_CATEGORY_USER_PREFERRED,
  SYS_DETAILED_PLMN_LIST_CATEGORY_OPERATOR_PREFERRED,
  SYS_DETAILED_PLMN_LIST_CATEGORY_OTHER,
  SYS_DETAILED_PLMN_LIST_CATEGORY_MAX            /* FOR INTERNAL USE ONLY! */
} sys_detailed_plmn_list_category_e_type;

/**
** The following enumerated type defines the PLMN's signal quality.
*/
typedef enum
{
  SYS_SIGNAL_QUALITY_NONE = -1,                  /* FOR INTERNAL USE ONLY! */
  SYS_SIGNAL_QUALITY_HIGH,
  SYS_SIGNAL_QUALITY_LOW,
  SYS_SIGNAL_QUALITY_MAX                         /* FOR INTERNAL USE ONLY! */
} sys_signal_quality_e_type;

/**
** The following enumerated type defines the access technologies that are
** defined for the elementary file, EFPLMNwAcT (User controlled PLMN selector
** with Access Technology).  The #defines are to be used in a bit mask.
** Refer to TS 11.11.
*/
typedef uint16 sys_access_tech_e_type;

/**
** The following enumerated type used to specify the status of Manual PLMN 
** Search.
**
*/

typedef enum
{
  SYS_PLMN_LIST_NONE = -1,       /* FOR INTERNAL USE ONLY */
  SYS_PLMN_LIST_SUCCESS,
  SYS_PLMN_LIST_AS_ABORT,
  SYS_PLMN_LIST_MAX              /* FOR INTERNAL USE ONLY */
} sys_plmn_list_status_e_type;

/*------------------------------------------------------------------------------
   Network Lists Data Types
------------------------------------------------------------------------------*/
/**
** The following type defines the PLMN's the signal strength in
** units that allow direct comparison of the signal strength between
** GSM and WCDMA cells.
**
*/
typedef int32 sys_signal_strength_type;

typedef struct sys_detailed_plmn_list_info_s
{
  /** The ID of the PLMN.
  */
  sys_plmn_id_s_type                        plmn;

  /** The radio access technology of the PLMN.
  */
  sys_radio_access_tech_e_type              rat;

  /** Indicates the type of service domain the PLMN can provide.
  */
  sys_srv_capability_e_type                 plmn_service_capability;

  /** Indicates if the PLMN is forbidden.
  */
  boolean                                   plmn_forbidden;

  /** Indicates the type of PLMN.
  */
  sys_detailed_plmn_list_category_e_type    list_category;

  /** The signal quality of the PLMN.
  */
  sys_signal_quality_e_type                 signal_quality;

  /** The signal strength of the PLMN.
  */
  sys_signal_strength_type                  signal_strength;

} sys_detailed_plmn_list_info_s_type;

/**
** Define a structure for the detailed PLMN list.
*/
typedef struct sys_detailed_plmn_list_s
{
  /** The number of PLMNs in the list.
  */
  uint32                                    length;

  /** PLMN info.
  */
  sys_detailed_plmn_list_info_s_type        info[SYS_PLMN_LIST_MAX_LENGTH];

} sys_detailed_plmn_list_s_type;

/**
** Define a structure that contains information regarding the user
** preferred/controlled network.  The access_tech_mask is a bit mask
** indicated by the sys_access_tech_e_type enumerates.
*/
typedef struct sys_user_pref_plmn_list_info_s
{
  sys_plmn_id_s_type                        plmn;
  sys_access_tech_e_type                    access_tech;
} sys_user_pref_plmn_list_info_s_type;

/**
** Define a structure for the list of user preferred/controlled networks.
*/
typedef struct sys_user_pref_plmn_list_s
{
  /** The number of PLMNs in the list.
  */
  byte                                      length;

  sys_user_pref_plmn_list_info_s_type       info[SYS_USER_PPLMN_LIST_MAX_LENGTH];
} sys_user_pref_plmn_list_s_type;

#define WPA_RSN_MAX_PAIRWISE_CIPHER_SUITE  5
#define WPA_RSN_MAX_AKM_SUITE              2

/** Type of WLAN Security.
*/
typedef enum
{
  SYS_TECH_WLAN_SEC_NONE = 0,
  SYS_TECH_WLAN_SEC_WEP  = 1,
  SYS_TECH_WLAN_SEC_WPA  = 2,
  SYS_TECH_WLAN_SEC_WPA2 = 3
} sys_wlan_security_e_type;

/** Type of Cipher Suite.
*/
typedef enum
{
  SYS_WLAN_SEC_CIPHER_SUITE_WEP_40  = 1,
  SYS_WLAN_SEC_CIPHER_SUITE_TKIP    = 2,
  SYS_WLAN_SEC_CIPHER_SUITE_RSVD    = 3,
  SYS_WLAN_SEC_CIPHER_SUITE_CCMP    = 4,
  SYS_WLAN_SEC_CIPHER_SUITE_WEP_104 = 5,
  SYS_WLAN_SEC_CIPHER_SUITE_VENDOR_SPECIFIC = 6,
  SYS_WLAN_SEC_CIPHER_SUITE_INVALID = 7
} sys_wlan_cipher_suite_e_type;

/** Type of AKM Suite.
*/
typedef enum
{
  SYS_WLAN_SEC_AKM_SUITE_RSVD    = 0,
  SYS_WLAN_SEC_AKM_SUITE_8021X   = 1,
  SYS_WLAN_SEC_AKM_SUITE_PSK     = 2,
  SYS_WLAN_SEC_AKM_SUITE_VENDOR_SPECIFIC = 3,
  SYS_WLAN_SEC_AKM_SUITE_INVALID = 4     
} sys_wlan_akm_suite_e_type;

/** Type that holds the WLAN WPA security Info.
*/
typedef struct sys_wlan_security_wpa_rsn_info_type
{
  sys_wlan_cipher_suite_e_type  grp_cipher_suite;
 
  uint16                        pairwise_cipher_count;
  sys_wlan_cipher_suite_e_type  pairwise_cipher_suites[WPA_RSN_MAX_PAIRWISE_CIPHER_SUITE];
 
  uint16                        akm_count;
  sys_wlan_akm_suite_e_type     akm_suites[WPA_RSN_MAX_AKM_SUITE];

} sys_wlan_security_wpa_rsn_info_s_type;
 
/** Type that holds the WLAN security Info.
*/
typedef struct sys_wlan_security_info_s
{
 
  /** Type of WLAN security.
  */
  sys_wlan_security_e_type                 sec_type;

  /** WLAN WPA security Info.
  */
  sys_wlan_security_wpa_rsn_info_s_type    wpa_rsn_info;
  
} sys_wlan_security_info_s_type;

/** Type that holds the BSS information in WLAN.
*/
typedef struct sys_wlan_bss_info_s
{
  /** Channel on which this BSS provides service.
  */
  sys_chan_type                             chan;

  /** Band in which this BSS provides service.
  */
  sys_band_class_e_type                     band;

  /** Type of BSS - Infrastructure or independent.
  */
  sys_wlan_bss_e_type                       bss_type;

  /** BSS Id.
  */
  sys_wlan_bssid_type                       bssid;

  /** SS Id.
  */
  sys_wlan_ssid_s_type                      ssid;

  /** Measured RSSI of the BSS.
  */
  uint16                                    rssi;

  /** WLAN technology in use.
  */
  sys_tech_e_type                           tech;

  /** WLAN Security in use.
  */
  sys_wlan_security_info_s_type             security_info;

} sys_wlan_bss_info_s_type;

typedef struct sys_wlan_bss_info_list_s
{
    /** Number of BSS in this list.
    */
    int                            num_bss;

    /** BSS List
    */
    sys_wlan_bss_info_s_type       bss_info[SYS_NETWORK_LIST_INFO_MAX];
}sys_wlan_bss_info_list_s_type;

/*------------------------------------------------------------------------------
   Mobility Management Info Defines
------------------------------------------------------------------------------*/
/**
** Define constants used by for mobility management information.
** According to the standard, 3GPP TS 24.0008, the short name and
** full name can be from 3 to N characters in length.
*/
#if (defined(FEATURE_GSM) || defined(FEATURE_WCDMA))
#define SYS_MAX_SHORT_NAME_CHARS      255
#define SYS_MAX_FULL_NAME_CHARS       255
#else
#define SYS_MAX_SHORT_NAME_CHARS      1
#define SYS_MAX_FULL_NAME_CHARS       1
#endif


/**
** Define a type for the Network Name Coding Scheme.  The format is
** specified by 3GPP TS 24.008 and 03.38.
*/
typedef enum
{
  SYS_NW_NAME_CODING_SCHEME_NONE                             = -1,
    /**< FOR INTERNAL USE ONLY */

  SYS_NW_NAME_CODING_SCHEME_CELL_BROADCAST_DEFAULT_ALPHABET  =  0,
    /**< Cell Broadcast data coding, default alphabet, language unspecified */

  SYS_NW_NAME_CODING_SCHEME_UCS2                             =  1,
    /**< UCS2 coding scheme */

  SYS_NW_NAME_CODING_SCHEME_RESERVED                         =  2,
    /**< Reserved */

  SYS_NW_NAME_CODING_SCHEME_MAX
    /**< FOR INTERNAL USE ONLY */
} sys_network_name_coding_scheme_type_e_type;

/**
** Define a type for the Localized Service Area identity.  The format
** is specified by 3GPP TS 24.008 and 23.003.
*/
typedef enum
{

  SYS_LSA_ID_TYPE_NONE         = -1,             /**< FOR INTERNAL USE ONLY! */
  SYS_LSA_ID_TYPE_PLMN_SIG_NUM =  0,             /**< The LSA is a PLMN      */
                                                 /**< significant number     */
  SYS_LSA_ID_TYPE_UNIVERSAL    =  1,             /**< The LSA is a universal */
                                                 /**< LSA                    */
  SYS_LSA_ID_TYPE_MAX                            /**< FOR INTERNAL USE ONLY! */
} sys_lsa_identity_type_e_type;

/**
** Define a enumerated type for the daylight savings adjustment.
** The values for the enumerated constants are dictated by 3GPP
** TS 24.008.
**/
typedef enum
{
  SYS_DAY_SAV_ADJ_NONE          = -1,            /* FOR INTERNAL USE ONLY! */
  SYS_DAY_SAV_ADJ_NO_ADJUSTMENT =  0,
  SYS_DAY_SAV_ADJ_PLUS_ONE_HOUR =  1,
  SYS_DAY_SAV_ADJ_PLUS_TWO_HOUR =  2,
  SYS_DAY_SAV_ADJ_MAX                            /* FOR INTERNAL USE ONLY! */
} sys_daylight_saving_adj_e_type;

/*------------------------------------------------------------------------------
   Mobility Management Info Data Types
------------------------------------------------------------------------------*/
/**
** Define types for the network's short name and full name.
**/
typedef struct sys_network_short_name_s
{
  uint8                                       length;
    /**< Number of characters in the short name */

  sys_network_name_coding_scheme_type_e_type  coding_scheme;
    /**< The coding scheme used to encode the short name of the network */

  boolean                                     add_country_initials;
    /**< Flag that indicates whether MS should add the country initials to
       the short name of the network */

  uint8                                       name[SYS_MAX_SHORT_NAME_CHARS];
    /**< The short name of the network          */

} sys_network_short_name_s_type;

typedef struct sys_network_full_name_s
{
  uint8                                        length;
    /**< Number of characters in the full name */

  sys_network_name_coding_scheme_type_e_type   coding_scheme;
  /**< The coding scheme used to encode the full name of the network */

  boolean                                      add_country_initials;
    /**< Flag that indicates whether MS should add the country initials to
       the full name of the network */

  uint8                                        name[SYS_MAX_FULL_NAME_CHARS];
    /**< The full name of the network          */
} sys_network_full_name_s_type;

/**
** Define a type for time zone.  The time zone is an offset from
** Universal time (i.e. difference between local time and Universal
** time) in increments of 15 minutes.  The format for this type is
** specified in 3G TS 24.008 and 23.040.
*/
typedef int sys_time_zone_type;

/**
** Define a structure for the Time Zone and Universal Time mobility
** management information.  Each field is received as Binary Coded
** Digits as specified in 3GPP TS 24.008 and 23.040.
*/
typedef struct sys_time_and_time_zone_s
{
  uint8                                     year;
  uint8                                     month;
  uint8                                     day;
  uint8                                     hour;
  uint8                                     minute;
  uint8                                     second;
  sys_time_zone_type                        time_zone;
} sys_time_and_time_zone_s_type;

/**
** Define a type for the Localized Service Area identity.  The format
** is specified by 3GPP TS 24.008 and 23.003.
*/
typedef struct sys_lsa_identity_s
{
  sys_lsa_identity_type_e_type              type;
  uint8                                     identity[3];
} sys_lsa_identity_s_type;

/**
** Define a structure that contains the currently registered network's
** mobility management information (i.e. network's name, date, time and
** time zone).  All fields in this structure are optional.  If the
** "available" flag is true, then the corresponding data field contains
** valid information.  If the "available" flag is false, then the
** corresponding data field should be ignored.
*/
typedef struct sys_mm_information_s
{
  /**
  ** Flags that indicate whether the particular mm information is
  ** available.
  **/
  boolean                                   plmn_avail;
  boolean                                   full_name_avail;
  boolean                                   short_name_avail;
  boolean                                   univ_time_and_time_zone_avail;
  boolean                                   time_zone_avail;
  boolean                                   lsa_identity_avail;
  boolean                                   daylight_saving_adj_avail;

  sys_plmn_id_s_type                        plmn;
  sys_network_full_name_s_type              full_name;
  sys_network_short_name_s_type             short_name;
  sys_time_and_time_zone_s_type             univ_time_and_time_zone;
  sys_time_zone_type                        time_zone;
  sys_lsa_identity_s_type                   lsa_identity;
  sys_daylight_saving_adj_e_type            daylight_saving_adj;
} sys_mm_information_s_type;

/**---------------------------------------------------------------------------
  M511 Table values.
---------------------------------------------------------------------------*/
typedef enum
{
  SYS_JCDMA_M511_MIN = -1,        /**< used only for bounds checking       */
  SYS_JCDMA_M511_PKT,             /**< User picked packet from M511 menu   */
  SYS_JCDMA_M511_ASYNC_FAX,       /**< User picked async/fax from M511 menu*/
  SYS_JCDMA_M511_MAX              /**< Used for arrays & bounds checking   */
} sys_jcdma_m511_e_type;

/**---------------------------------------------------------------------------
  M512 Table values.
---------------------------------------------------------------------------*/
typedef enum
{
  SYS_JCDMA_M512_MIN = -1,        /**< used only for bounds checking       */
  SYS_JCDMA_M512_STD,             /**< User picked standard data rate      */
  SYS_JCDMA_M512_HIGH,            /**< User picked high data rate          */
  SYS_JCDMA_M512_MAX              /**< Used for arrays & bounds checking   */
} sys_jcdma_m512_e_type;

/**---------------------------------------------------------------------------
  M513 Table values.
---------------------------------------------------------------------------*/
typedef enum
{
  SYS_JCDMA_M513_MIN = -1,        /**< used only for bounds checking       */
  SYS_JCDMA_M513_AUTO,            /**< AUTO setting                        */
  SYS_JCDMA_M513_19200,           /**< 19200 bps                           */
  SYS_JCDMA_M513_115200,          /**< 115200 bps                          */
  SYS_JCDMA_M513_230400,          /**< 230400                              */
  SYS_JCDMA_M513_MAX              /**< Used for arrays & bounds checking   */
} sys_jcdma_m513_e_type;

/** Maximum size(bytes) of the IS2000 Message.
*/
#define    SYS_MAX_IS2000_MSG_SIZE     (256)

/** UMTS->CDMA Handover status causes.
*/
typedef enum
{
  SYS_UMTS_CDMA_HANDOVER_NONE,
  SYS_UMTS_CDMA_HANDOVER_SUCCESS,
  SYS_UMTS_CDMA_HANDOVER_ERR_NO_SRV,
  SYS_UMTS_CDMA_HANDOVER_ERR_ACC_IN_PROG,
  SYS_UMTS_CDMA_HANDOVER_ERR_IN_TC,
  SYS_UMTS_CDMA_HANDOVER_ERR_UHDM_PARSE,
  SYS_UMTS_CDMA_HANDOVER_ERR_CDMA_LOCK,
  SYS_UMTS_CDMA_HANDOVER_ERR_OTHERS,
  SYS_UMTS_CDMA_HANDOVER_ERR_BAD_MSG_TYPE,
  SYS_UMTS_CDMA_HANDOVER_MAX

}sys_umts_cdma_handover_e_type;

typedef enum
{
  SYS_HO_STATUS_NONE,
  SYS_HDR_CDMA_HO_SUCCESS,
  SYS_HDR_CDMA_HO_ERR_NO_SRV,
  SYS_HDR_CDMA_HO_ERR_ACC_IN_PROG,
  SYS_HDR_CDMA_HO_ERR_IN_TC,
  SYS_HDR_CDMA_HO_ERR_UHDM_PARSE,
  SYS_HDR_CDMA_HO_ERR_CDMA_LOCK,
  SYS_HDR_CDMA_HO_ERR_OTHERS,

  SYS_HO_STATUS_MAX
} sys_ho_status_e_type;

/** Typedef which holds a IS2000 Message.
*/
typedef struct {

  /** Message type.
  */
  uint8                                type;

  /** Message payload length in bits max is SYS_MAX_IS2000_MSG_SIZE * 8
  */
  uint32                               payload_len;

  /** Message payload.
  */
  byte                                 payload[SYS_MAX_IS2000_MSG_SIZE];

} sys_is2000_msg_s_type;

/*------------------------------------------------------------------------------
   BCMCS Defines
------------------------------------------------------------------------------*/
#ifdef FEATURE_BCMCS_20 
#elif defined( FEATURE_BCMCS )

#define SYS_BCMCS_MAX_FLOWS     10

#else
#define SYS_BCMCS_MAX_FLOWS     1
#endif
/**------------------------------------------------------------------------------
   BCMCS Enums
------------------------------------------------------------------------------*/

/** Enumeration for BCMCS data service availability
*/
typedef enum {

  SYS_BCMCS_SRV_STATUS_NONE = -1,
    /**< FOR INTERNAL USE ONLY!
    */

  SYS_BCMCS_SRV_STATUS_NO_SRV,
    /**< No BCMCS service is available
    */

  SYS_BCMCS_SRV_STATUS_SRV,
    /**< BCMCS service is available
    */

  SYS_BCMCS_SRV_STATUS_MAX
    /**< FOR INTERNAL USE OF CM ONLY!
    */

  #ifdef FEATURE_RPC
  ,
  SYS_BCMCS_SRV_STATUS_BIG = 0x10000000
    /**< To force enum to 32 bit for windows NT
    */
  #endif /* FEATURE_RPC */


} sys_bcmcs_srv_status_e_type;

/** Enumeration for BCMCS flow status values
*/
typedef enum
{

  SYS_BCMCS_FLOW_STATUS_MIN = -1,
    /**< For bounds checking only
    */

  SYS_BCMCS_FLOW_STATUS_NONE = 0,
    /**< Used for initialization or to indicate that
    ** there is no flow status info sent with the
    ** event / report
    */

  /*---------------------------------------------------------------
    No-op
  ---------------------------------------------------------------*/
  SYS_BCMCS_FLOW_STATUS_CANCELLED = 100,
    /**< A new Flow Request received before the previous one is done processing.
    ** Cancel the remaining lookup and start processing the new Request.
    */

  /*---------------------------------------------------------------
    Success - Flow is monitored  (DESIRED_MONITORED)
  ---------------------------------------------------------------*/
  SYS_BCMCS_FLOW_STATUS_MONITORED = 200,
    /**< Flow is active and included in broadcast overhead msg
    */

  /*---------------------------------------------------------------
    Successful request and db lookup, but the flow cannot be 
    monitored yet.

    Considered a temporary Failure - start a deregistration timer.
  ---------------------------------------------------------------*/
  /*-------------------------------------
    DESIRED_UNMONITORED
  -------------------------------------*/
  SYS_BCMCS_FLOW_STATUS_UNABLE_TO_MONITOR = 300,
    /**< Flow is available in overhead but can not be monitored 
     * because its channel assignment conflicts with other flows
     */

  /*-------------------------------------
    DESIRED_UNAVAILABLE
  -------------------------------------*/
  SYS_BCMCS_FLOW_STATUS_REQUESTED,
    /**< Registered but not included in broadcast overhead msg
    */

  SYS_BCMCS_FLOW_STATUS_TIMEOUT,
    /**< Broadcast Supervision Timeout.  The AT is on a system where
    ** broadcast is available. The AT waited for 3 x BroadcastOverheadPeriod, 
    ** and the flow did not appear in the bcovhd message.
    */

  SYS_BCMCS_FLOW_STATUS_LOST,
    /**< The AT lost acquisition and temporarily disabled its monitored flows.
    ** It is as if the flows weren't in the BC OVHD msg as with
    ** SYS_BCMCS_FLOW_STATUS_REQUESTED. Another flow status will be sent 
    ** when the AT reacquires. 
    */

  SYS_BCMCS_FLOW_STATUS_SYS_UNAVAILABLE,
    /**< The AT cannot process the flow request because BCMCS is in
    ** CLOSED state (HDR not acquired)
    */

  SYS_BCMCS_FLOW_STATUS_REACHED_MAX_MON_FLOWS,
    /**< 
    ** The flow is available in ovhd, but the AT cannot monitor it 
    ** because it has reached the maximum number of flows it can 
    ** concurrently monitor.  
    */

  /*---------------------------------------------------------------
    Failure (permanent) - flow should be deregistered.
  ---------------------------------------------------------------*/
  /*-------------------------------------
    AN is explicitely rejecting the flow
  -------------------------------------*/
  SYS_BCMCS_FLOW_STATUS_REJECTED_NOT_AVAILABLE = 400,
    /**< Flow was rejected explicitly by the network
    ** - BCMCS Flow ID / BCMCS Program ID not available
    */

  SYS_BCMCS_FLOW_STATUS_REJECTED_NOT_TRANSMITTED,
    /**< Flow was rejected explicitly by the network
    ** - BCMCS Flow ID / BCMCS Program ID not transmitted
    */

  SYS_BCMCS_FLOW_STATUS_REJECTED_INVALID_AUTH_SIG,
    /**< Flow was rejected explicitly by the network 
     * - Invalid authorization signature
    */

  /*-------------------------------------
    DB Lookup Failure
  -------------------------------------*/
  SYS_BCMCS_FLOW_STATUS_DB_UNAVAILABLE = 500,
    /**< A lookup in the XML file couldn't be completed because the database
    ** is in an invalid state 
    */  

  SYS_BCMCS_FLOW_STATUS_NO_MAPPING,
    /**< The XML file does not contain any mapping for the current subnet.
    */

  SYS_BCMCS_FLOW_STATUS_ID_NOT_FOUND_FOR_GIVEN_MULTICAST_IP,
    /**< A lookup in the XML file can't find a FlowID for
    ** the given Multicast IP in the current subnet
    */

  SYS_BCMCS_FLOW_STATUS_MAX
    /**< For bounds checking only
    */

} sys_bcmcs_flow_status_e_type;

/* 
** Enumeration for BCMCS flow status values  
*/
typedef enum
{
  SYS_BCMCS_REG_STATUS_MIN = -1,
    /**< For bounds checking only */
 
  SYS_BCMCS_REG_STATUS_NONE = 0,
    /**< Used for initialization or to indicate that there is no 
    ** registration status info sent with the event / report */
  
  SYS_BCMCS_REG_STATUS_SUCCESS,
    /**< FlowRegistration message was sent successfully for this flow */

  SYS_BCMCS_REG_STATUS_NOT_ALLOWED,
    /**< Could not send a FlowRegistration message - not allowed */

  SYS_BCMCS_REG_STATUS_GEN_FAILURE,
    /**< Could not send a FlowRegistration message  generic failure */
 
  SYS_BCMCS_REG_STATUS_MAX
    /**< For bounds checking only */
 
} sys_bcmcs_reg_status_e_type;

/* Identifies different flow service types 
*/
typedef enum 
{
  SYS_FLOW_SERVICE_NONE = -1,
    /* For bounds checking only
    */

  SYS_FLOW_SERVICE_BCMCS = 0,
    /* Flow serv type is BCMCS
    */

  SYS_FLOW_SERVICE_MBMS = 1,
    /* Flow serv type is MBMS
    */

  SYS_FLOW_SERVICE_MAX
    /* For bounds checking only
    */

} sys_flow_service_e_type;

/**
** An enum that defines all of the address types supported - used to
** discriminate the union below
** (same as ip_addr_type from ps_ip_addr.h)
*/
typedef enum
{
  SYS_IP_ANY_ADDR     = 0,
  SYS_IPV4_ADDR       = 4,
  SYS_IPV6_ADDR       = 6,
  SYS_IP_ADDR_INVALID = 255

} sys_ip_addr_enum_type;

/** IP address
*/
typedef struct sys_ip_address_s
{

  sys_ip_addr_enum_type type;

  union {

    uint32 v4;
    uint64 v6[2];
  } addr;

} sys_ip_address_s_type;

/* TMGI is a parameter used in 
** MBMS service act req. Gives
** the max length of TMGI.
** TMGI stands for ???
*/
#define SYS_MAX_MBMS_TMGI_LENGTH 15

/*---------------------------------------------------------------------------
** MBMS enum definitions
---------------------------------------------------------------------------*/
typedef enum
{

  SYS_MBMS_SRV_STATUS_NONE = -1,
    /* For internal use only */

  SYS_MBMS_SRV_STATUS_UNAVAILABLE_NETWORK_FAILURE,
    /* MBMS service in unavailable due to network failure */

  SYS_MBMS_SRV_STATUS_UNAVAILABLE_SETUP_FAILURE,
    /* MBMS service in unavailable due to setup failure on UE side */

  SYS_MBMS_SRV_STATUS_UNAVAILABLE_FAILURE_OTHER,
    /* MBMS service in unavailable due to some other failure */

  SYS_MBMS_SRV_STATUS_AVAILABLE,
    /*MBMS service in available */

  SYS_MBMS_SRV_STATUS_MONITORED,
    /* MBMS service monitored */

  SYS_MBMS_SRV_STATUS_OTHER,
    /* Reserved for future use */
    
  SYS_MBMS_SRV_STATUS_RESERVED1,
    /* Reserved for future use */
    
  SYS_MBMS_SRV_STATUS_MAX
    /* For internal use only */

} sys_mbms_srv_status_e_type;

/* To be discarded for phase 2a */
typedef struct
{ 

  uint32  service_id;
  boolean plmn_id_present;
  uint32  plmn_id;

} sys_mbms_tmgi_uint_old_s_type;

/* MBMS logical channel id 
*/
typedef struct
{
  /* TRUE  -  Log chan id is present
  ** FALSE -  Log chan id is not present
  */
  boolean present;

  /* Logical channel id. 
  ** Used between DS and RLC on traffic plane.
  */
  uint32  log_chan_id;

}sys_mbms_log_chan_id_s_type;

/* TMGI structure in array format */
typedef struct
{
  /* TRUE  -  TMGI is present
  ** FALSE -  TMGI is not present
  */
  boolean present;

  /* Length of TMGI */
  uint8   length;

  /* Actual TMGI value */
  uint8   value[SYS_MAX_MBMS_TMGI_LENGTH];

}sys_mbms_tmgi_s_type;

/* MBMS service priority */
typedef struct
{
  /* TRUE  -  Priority is present
  ** FALSE -  Priority is not present
  */
  boolean present;

  /* Priority of MBMS service request */
  uint32   priority;

}sys_mbms_srv_priority_s_type;

/* Structure to hold mbms information
*/
typedef struct
{
  /* TMGI required for MBMS service
  */
  sys_mbms_tmgi_s_type              tmgi;

  /* Converted TMGI used by MBMS mgr
  */
  sys_mbms_tmgi_uint_old_s_type     tmgi_conv;

  /* Priority reqd for MBMS 
  */
  sys_mbms_srv_priority_s_type      srv_priority;

  /* Gives conf on MBMS srv activ or deact
  ** request
  */
  sys_mbms_srv_status_e_type        srv_status;

  /* Logical channel id. Reported from MBMS mgr
  ** to CM
  */
  sys_mbms_log_chan_id_s_type       srv_log_chan_id;

}sys_mbms_srv_info_s_type;

/* Flow ID structure
**
** Overloading bcmcs flow id structure to hold MBMS
** specific information. Has been done to resue 
** cm_bcmcs_cmd_flow_request().
*/
typedef struct
{

  /* IP address for flow (MBMS and BCMCS) 
  */
  sys_ip_address_s_type ip_address;

  /* Port address for flow (MBMS and BCMCS)
  */
  uint16                port_number;

  /* Identifies the type of flow (MBMS, BCMCS...)
  */ 
  sys_flow_service_e_type  flow_service;

  /* Information specific to MBMS service request
  */
  sys_mbms_srv_info_s_type mbms_srv_info;

} sys_bcmcs_flow_addr_s_type;

/* Flow status element type
*/
typedef struct
{
  /* Address of flow depending on BCMCS or MBMS
  */
  sys_bcmcs_flow_addr_s_type   flow_address;


  sys_bcmcs_flow_status_e_type flow_status;

} sys_bcmcs_flow_status_element_s_type;

typedef struct {

  sys_bcmcs_flow_addr_s_type   flow_address;
  sys_bcmcs_reg_status_e_type  reg_status;

} sys_bcmcs_reg_status_element_s_type;

typedef enum{

  SYS_BCMCS_REG_SETUP_MIN = -1,
  /**< For bounds checking only */

  SYS_BCMCS_REG_SETUP_ALLOWED,
  /**< Allow Registration setup */

  SYS_BCMCS_REG_SETUP_NOT_ALLOWED,
  /**< Registration setup not allowed */

  SYS_BCMCS_REG_SETUP_MAX
  /**< For bounds checking only */

}sys_bcmcs_reg_setup_e_type;

typedef struct sys_manual_sys_profile_s{

  /** Manual System Profile is stored in packed format in profile_buf. This needs to be
  ** unpacked using net_unpack_profile() to "net_profile_s_type" before
  ** using.
  */
  word                                   profile_size;
  byte                                   profile_buf[SYS_WLAN_PROFILE_MAX_SIZE];

} sys_manual_sys_profile_s_type;

/** Enumeration for LN notification status
*/
typedef enum
{

  SYS_HDR_LOCATION_NOTIFICATION_STATUS_NONE = -1,      /** Internal CM use */
  SYS_HDR_LOCATION_NOTIFICATION_STATUS_SUCCESSFUL,     /** LN Successful */
  SYS_HDR_LOCATION_NOTIFICATION_STATUS_FAILED,         /** LN Failed     */
  SYS_HDR_LOCATION_NOTIFICATION_STATUS_MAX             /** Internal CM use */

} sys_hdr_location_notification_status_e_type;

#endif /* #ifndef SYS_H */

/* @}
** 
*/

#ifndef SYS_GW_H
#define SYS_GW_H

/*===========================================================================

              S Y S T E M   H E A D E R   F I L E

DESCRIPTION
  This header file contains definitions that are shared between Call Manager,
  Call Manager clients and the GSM/WCDMA protocol stacks.

Copyright (c) 2002 - 2008 by QUALCOMM INCORPORATED. All Rights Reserved.

Export of this technology or software is regulated by the U.S. Government.
Diversion contrary to U.S. law prohibited.

===========================================================================*/


/*===========================================================================

                      EDIT HISTORY FOR FILE

  This section contains comments describing changes made to the module.
  Notice that changes are listed in reverse chronological order.

  $Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $

when       who     what, where, why
--------   ---     ----------------------------------------------------------
10/17/08   rm      Fixing HTORPC warning
10/10/08   aj      fix typo in UMA-GAN Connection Status enumeration
09/18/08   aj      Support for UMA GAN 
07/01/08   rm      Mainlining of MBMS changes
02/19/08   sk      Moved cause.h out of FEATURE_MM_SUPERSET
10/15/07   rn      Added support for UE initiated dormancy
09/14/07   dm      Added support for FEATURE_MM_SUPERSET
03/16/05   ic      Include cmwmsg.h in cm.h directly instead of indirectly 
                   (through sys_gw.h) as cm.h uses MAXNO_FORWARD_TO_NUMBER 
                   that is defined in cmwmsg.h
02/06/04   ws      Initial jaguar/mainline merge.
01/21/03   ws      Updated copyright information for 2003
08/29/02   PRK     Featurized include files.
05/07/02   PRK     Initial version.
===========================================================================*/
#if (defined(FEATURE_WCDMA) || defined(FEATURE_GSM) || defined(FEATURE_MM_SUPERSET))
#ifndef SM_COMMON_H
#define SM_COMMON_H

/*===========================================================================
                        S M    C O M M O N   Header File

DESCRIPTION

   Definition of common data types used in the primitives between Session 
   Management Entity and other Entities. (SM-SNDCP, SM-RABM, SM-CM, SM-GMM)

INITIALIZATION AND SEQUENCING REQUIREMENTS
  None

Copyright (c) 2000, 2001 QUALCOMM, Incorporated.  All Rights Reserved.
QUALCOMM Proprietary.  Export of this technology or software is regulated
by the U.S. Government. Diversion contrary to U.S. law prohibited.

===========================================================================*/
 
#ifndef MS_H
#define MS_H
/*===========================================================================
                        COPYRIGHT INFORMATION

Copyright (c) 2001 QUALCOMM, Incorporated and its licensors.  All Rights 
Reserved.  QUALCOMM Proprietary.  Export of this technology or software 
is regulated by the U.S. Government. Diversion contrary to U.S. law prohibited.

                        EDIT HISTORY FOR MODULE

This section contains comments describing changes made to the module.
Notice that changes are listed in reverse chronological order.

$PVCSPath:  L:/src/asw/MSM5200/nas/vcs/ms.h_v   1.17   24 Jun 2002 19:39:12   kishores  $   
$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $    $DateTime: 2009/01/08 04:43:34 $ $Author: cbothsa $

when       who     what, where, why
--------   ---     ---------------------------------------------------------- 
05/02/07   kgj     Added stuff for FEATURE_CGPS
20/03/07   cs      Add new definition for TCXO_MGR_3->GL1 restriction request 
07/03/07   cs      Add new definition for CGPS->GL1 timetag request 
04/06/05   kvk     New feature message sets defined for UMTS BMC
08/12/04   cd      Replaced FEATURE_LCS by FEATURE_MMGPS
06/08/04   cd      LCS support.  Added MS_MM_LCS message set definition
02/12/04   vdr     Added new MS_WMS_CB message set definition under FEATURE_GSM_CB
02/02/04   vk      Added new MS_LSM_RRC message set definition under FEATURE_MMGPS
04/15/03   sbs     Added new MS_LSM_RR message set definition
04/14/03   lalit   Added new MS_LSM_L1 message set definition
02/14/03   ab      Added new MS_CC_MM_PS message set definition
02/12/02   vdr     Added new MS_CM_MM message set definition
02/12/02   vdr     Added new MS_WMS_MM message set definition
08/01/02   ATM     Added InterRAT support (RRC <-> RR)
06/18/02   ks      Added GPRS support
05/13/02   ATM     Split RRC enum into it's parts (internal/L1/MAC/RLC) 
                   NOTE: MM and TC were already defined
05/06/02   ATM     Added new MSGSETs for WCDMA
05/06/02   ATM     Removed redefinition of MS_SNDCP_SM
05/06/02   ATM     Added new MSGSETs for GPRS
04/22/02   ks      Added MS_CM_RABM messege set definition for CM/RABM
01/30/02   mks     Added new message set definitions for TC
05/30/01   ks      Added new message set definitions for SM/RABM.
05/03/01   jca     Added new message set definitions.

7/13/01    cd      Replaced MS_MN_CM by MS_MN_CM
                   Added MS_MN_UASMS

08/14/01   ab      Renamed connection manager reference to CNM from CM.

08/24/01   ab      Restored MS_CM_SM name.

===========================================================================*/

#if (defined(FEATURE_GSM) || defined(FEATURE_WCDMA))
#define  MS_TIMER          6   /* Messages indicating timeouts        */
#endif
#if (defined(FEATURE_GSM) || defined(FEATURE_WCDMA))
#define  MS_GSDI           13  /* messages from/to GSDI               */
#endif

#endif /* MS_H */

// Maximum size of IPV4 packet filter is 32 bytes. It is 60 bytes for IPV6.
#define MAX_FILTER_CONTENT_LENGTH 60

/* Maximum number of packet filters allowed in the TFT */
#define MAX_PACKET_FILTERS 8

/* Maximun number of protocol Ids in the protocol config. parameters */
#ifdef FEATURE_IMS
#define NUM_PROTOCOL_ID 17
#else
#define NUM_PROTOCOL_ID 4
#endif


/* Maximum lenght of the contexts for each protocol Id */                                                                       
#define MAX_PROTOCOL_ID_CONTENT 127

/* Maximum length of the PDP address */
#define MAX_PDP_ADR_LEN  20

/* Maximum length of APN address */
#define MAX_APN_ADR_LEN  102

/* --------------------------------------------------------------------
 SM cause enumeration type, defined in Table 10.5.157/TS 24.008 
 This is the cause sent to the SM-SM peer entity.
** ------------------------------------------------------------------*/
typedef enum
{
  SM_UNKNOWN_CAUSE = 0x01,    /* For SM internal use only, not to be used in OTA*/
  SM_OPERATOR_DETERMINED_BARRING = 0x08,
  #ifdef FEATURE_MODEM_MBMS
  SM_MBMS_BEARER_CAP_INSUFFICIENT = 0x18,
  #endif
  SM_LLC_SNDCP_FAILURE          = 0x19,
  SM_INSUFFICIENT_RESOURCES,
  SM_MISSING_OR_UNKNOWN_APN,
  SM_UNKNOWN_PDP_ADDRESS_OR_TYPE,
  SM_USER_AUTHENTICATION_FAILED,
  SM_ACTIVATION_REJECTED_BY_GGSN,
  SM_ACTIVATION_REJECTED_UNSPECIFIED,
  SM_SERVICE_OPTION_NOT_SUPPORTED,
  SM_SERVICE_NOT_SUBSCRIBED,
  SM_SERVICE_OUT_OR_ORDER,
  SM_NSAPI_ALREADY_USED,
  SM_REGULAR_DEACTIVATION,
  SM_QOS_NOT_ACCEPTED,
  SM_NETWORK_FAILURE,
  SM_REACTIVATION_REQUIRED,
  SM_FEATURE_NOT_SUPPORTED,
  SM_SEMANTIC_ERR_IN_TFT,
  SM_SYNTACTIC_ERR_IN_TFT,
  SM_UNKNOWN_PDP_CONTEXT,
  SM_SEMANTIC_ERR_IN_FILTER,
  SM_SYNTACTIC_ERR_IN_FILTER,
  SM_PDP_WITHOUT_TFT_ACTIVE,
  #ifdef FEATURE_MODEM_MBMS
  SM_MBMS_GROUP_MEMBERSHIP_TIMEOUT,
  #endif
  SM_INVALID_TRANS_ID = 0x51,
  SM_SEMANTIC_INCORRECT_MESG = 0x5F,
  SM_INVALID_MANDATORY_INFO = 0x60,
  SM_MESG_TYPE_NON_EXISTENT,
  SM_MESG_TYPE_NOT_COMPATIBLE,
  SM_IE_NON_EXISTENT,
  SM_CONDITIONAL_IE_ERR,
  SM_MESG_NOT_COMPATIBLE,
  SM_PROTOCOL_ERR = 0x6F,
  SM_APN_TYPE_CONFLICT
} sm_status_T;
 
/* --------------------------------------------------------------------------                       
** network service access point identifier information element is to identify
** the service access point that is used for the GPRS data transfer at
** layer 3. The IE is defined in 10.5.6.2
** ------------------------------------------------------------------------*/                       
typedef struct nsapi_s
{
  boolean valid;
  byte    nsapi;
} nsapi_T;

/* --------------------------------------------------------------------------                       
** the quality of service information element is to specify the QoS 
** parameters for a PDP context. The IE is defined in 10.5.6.5
** ------------------------------------------------------------------------*/                       
typedef struct qos
{
  boolean valid;
  byte    delay_class;
  byte    reliability_class;
  byte    peak_throughput;
  byte    precedence_class;
  byte    mean_throughput;
  byte    traffic_class;
  byte    deliver_order;
  byte    deliver_err_sdu;
  byte    max_sdu_size;
  byte    max_bit_rare_uplink;
  byte    max_bit_rare_downlink;
  byte    residual_ber;
  byte    sdu_err_ratio;
  byte    tranfer_delay;
  byte    traffic_priority;
  byte    guarantee_ber_uplink;
  byte    guarantee_ber_dwnlink;
#if defined (FEATURE_REL5) || defined(FEATURE_MM_SUPERSET)
  boolean sig_ind;
  byte    src_stat_desc;
  byte    ext_max_bit_rate_downlink;
  byte    ext_gtd_bit_rate_downlink;
#endif
} qos_T;

/* --------------------------------------------------------------------------                       
** the packet data protocol address information element is to identify an 
** address associated with a PDP. The IE is defined in 10.5.6.4.
** ------------------------------------------------------------------------*/                       
typedef struct pdp_address
{
  boolean valid;
  byte    pdp_type_org;
  byte    pdp_type_num;
  byte    pdp_addr_len;
  byte    address[MAX_PDP_ADR_LEN];
} pdp_address_T;

/* --------------------------------------------------------------------------                       
** The Access Point Name is a label or a full qualified domain name 
** according to DNS naming conventions . The IE is defined in 10.5.6.1.
** ------------------------------------------------------------------------*/                       
typedef struct apn
{
  boolean valid;
  word    apn_addr_len;
  byte    address[MAX_APN_ADR_LEN];
} apn_T;

/* Structure for individual procotol information */
typedef struct protocol_id_s
{
  byte protocol_id[2];
  byte protocol_len;
  byte protocol_contents[MAX_PROTOCOL_ID_CONTENT];
} protocol_id_T;

typedef struct protocol_cfg_options
{
  boolean         valid;
  byte            config_protocol;
  word            num_protocol_ids;
  protocol_id_T   procol_info[NUM_PROTOCOL_ID];
} protocol_cfg_options_T;

/* --------------------------------------------------------------------------                       
** The purpose of the traffic flow template information element is to specify 
** the TFT parameters and operations for a PDP context.. The IE is defined 
** in 10.5.6.12.
** ------------------------------------------------------------------------*/ 
/* Structure for individual packet filter information */ 
typedef struct packet_filter
{
  byte  identifier;
  byte  eval_precedence;
  byte  content_length;
  byte  filter_contents[MAX_FILTER_CONTENT_LENGTH];
} packet_filter_type_T;

/* Data structre for TFT which has a list of individual filters */
typedef struct tft
{
  boolean                 valid;
  word                    tft_total_length;
  byte                    operation_code;
#if defined (FEATURE_REL5) || defined(FEATURE_MM_SUPERSET)
  byte                    e_bit;
#endif
  byte                    num_filters;
  packet_filter_type_T    filter_list[MAX_PACKET_FILTERS];
} tft_type_T;
                          
/* --------------------------------------------------------------------------                       
** the tear down indicator information element is to indicate whether 
** only the PDP context associated with this specific TI or all active 
** PDP contexts sharing the same PDP address as the PDP context associated 
** with this specific TI shall be deactivated. defined in 10.5.6.10.
** ------------------------------------------------------------------------*/
typedef struct ti
{
  boolean valid;
  boolean ti_flag;
} ti_T;

#endif
#ifndef SM_CM_H
#define SM_CM_H

/*===========================================================================
                        S M - C M  Header File

DESCRIPTION

   Definition of Primitive message types between Session Management Entity
   and Call Manager layer (SM <-> CM)

INITIALIZATION AND SEQUENCING REQUIREMENTS
  None

Copyright (c) 2000, 2001 QUALCOMM, Incorporated.  All Rights Reserved.
QUALCOMM Proprietary.  Export of this technology or software is regulated
by the U.S. Government. Diversion contrary to U.S. law prohibited.

===========================================================================*/
 

/* --------------------------------------------------------------------------
 Enumeration for failures, caused due to internal failures (inside MS)
** ------------------------------------------------------------------------*/
typedef enum
{
  INVALID_CONNECTIN_ID,
  INVALID_NSAPI,
  INVALID_PRI_NSAPI,
  INVALID_FIELD,
  SNDCP_FAILURE,
  RAB_SETUP_FAILURE,
  NO_GPRS_CONTEXT,
  PDP_ESTABLISH_MAX_TIMEOUT,
  PDP_ACTIVATE_MAX_TIMEOUT,
  PDP_MODIFY_MAX_TIMEOUT,
  PDP_INACTIVE_MAX_TIMEOUT,
  PDP_LOWERLAYER_ERROR,
  PDP_DUPLICATE,
  UE_RAT_CHANGE,
  PPD_UNKNOWN_REASON,
  PDP_MODIFY_COLLISION
  #ifdef FEATURE_MODEM_MBMS
  ,PDP_MBMS_REQUEST_COLLISION,
  MBMS_DUPLICATE,
  INVALID_PDP_CONTEXT_STATE
  #endif
}sm_cm_status_T;

typedef union
{
    sm_cm_status_T    int_cause;     
    sm_status_T       ext_cause;
} pdp_cause_T;

/* --------------------------------------------------------------------------
 Enumeration that identifies if the cause is of Internal or due to Network.
** ------------------------------------------------------------------------*/
typedef enum
{
  SM_NETWORK_CAUSE,
  SM_INTERNAL_CAUSE
} cause_enum_type_T;

#endif
#ifndef RABM_CM_H
#define RABM_CM_H

/*===========================================================================
                        R A B M - C M  Header File

DESCRIPTION

   Definition of Primitive message types between Radio Access Bearer Manager 
   and Call Manager layer (RABM <-> CM)

INITIALIZATION AND SEQUENCING REQUIREMENTS
  None

Copyright (c) 2000, 2001 QUALCOMM, Incorporated.  All Rights Reserved.
QUALCOMM Proprietary.  Export of this technology or software is regulated
by the U.S. Government. Diversion contrary to U.S. law prohibited.

===========================================================================*/
 

// Rabid value
typedef byte rabm_rabid_T;

// Cause during RAB release/reject
typedef byte rabmcm_cause_T;  // Exact enum will be defined soon

#endif
                            /* Call Manager interface primitives           */
#endif /* FEATURE_WCDMA || FEATURE_GSM || FEATURE_MM_SUPERSET*/


/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

#define SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ 2

/* Maximum number of MBMS services
** that can simultaneously exist.
*/
#define SYS_GW_MBMS_MAX_SERVICES 16

/* Maximum length of USZ STR 
** used in GAN display mode.
*/
#define SYS_GW_GAN_USZ_STR_MAX_LENGTH 34

/*--------------------------------------------------------------------------
   MBMS (Multimedia broadcast multicast service) Enums.   
   MBMS is specific to WCDMA.
--------------------------------------------------------------------------*/

typedef enum
{

  SYS_GW_MBMS_SRV_STATUS_NONE = -1,
    /* For internal use only */

  SYS_GW_MBMS_SRV_STATUS_UNAVAILABLE_NETWORK_FAILURE,
    /* MBMS service in unavailable due to network failure */

  SYS_GW_MBMS_SRV_STATUS_UNAVAILABLE_SETUP_FAILURE,
    /* MBMS service in unavailable due to setup failure on UE side */

  SYS_GW_MBMS_SRV_STATUS_UNAVAILABLE_FAILURE_OTHER,
    /* MBMS service in unavailable due to some other failure */

  SYS_GW_MBMS_SRV_STATUS_AVAILABLE,
    /* MBMS service in available */

  SYS_GW_MBMS_SRV_STATUS_MONITORED,
    /* MBMS service monitored */

  SYS_GW_MBMS_SRV_STATUS_OTHER,
    /* Reserved for future use */
    
  SYS_GW_MBMS_SRV_STATUS_RESERVED1,
    /* Reserved for future use */
    
  SYS_GW_MBMS_SRV_STATUS_MAX
    /* For internal use only */

} sys_gw_mbms_srv_status_e_type;

/* MBMS mode of service */
typedef enum
{
  SYS_GW_MBMS_SRV_MODE_NONE = -1,
    /*For internal use only */

  SYS_GW_MBMS_SRV_MODE_UNKNOWN,
    /* Service mode unknown */

  SYS_GW_MBMS_SRV_MODE_BROADCAST,
    /* Service mode broadcast */

  SYS_GW_MBMS_SRV_MODE_MULTICAST,
    /* Service mode multicast */

  SYS_GW_MBMS_SRV_MODE_MAX
    /*For internal use only */

}sys_gw_mbms_srv_mode_e_type;

/* MBMS type of service */
typedef enum
{
  SYS_GW_MBMS_SRV_TYPE_NONE = -1,
    /* For internal use only */

  SYS_GW_MBMS_SRV_TYPE_UNKNOWN = 0,
    /* Service type unknown */

  SYS_GW_MBMS_SRV_TYPE_STREAMING,
    /* Service type streaming */

  SYS_GW_MBMS_SRV_TYPE_DOWNLOAD,
    /* Service type download */

  SYS_GW_MBMS_SRV_TYPE_OTHER,
    /* Service type other*/

  SYS_GW_MBMS_SRV_TYPE_MAX
    /* For internal use only */

}sys_gw_mbms_srv_type_e_type;

/* MBMS type of service */
typedef enum
{
  SYS_GW_MBMS_ABORT_NONE = -1,
    /* For internal use only */

  SYS_GW_MBMS_ABORT_ALL,
    /* Abort all */

  SYS_GW_MBMS_ABORT_CONTEXT_ACT,
    /* Abort context activation */

  SYS_GW_MBMS_ABORT_CONTEXT_DEACT,
    /* Abort context deactivation */

  SYS_GW_MBMS_ABORT_TRAFFIC_ACT,
    /* Abort traffic activation*/

  SYS_GW_MBMS_ABORT_TRAFFIC_DEACT,
    /* Abort traffic deactivation */

  SYS_GW_MBMS_ABORT_MAX
    /* For internal use only */
}sys_gw_mbms_abort_type_e_type;

/* Enum for MBMS context activation deactivation failure reason
*/
typedef enum
{
  SYS_GW_MBMS_CONTEXT_FAILURE_REASON_NONE = -1,
    /* For internal use only */

  SYS_GW_MBMS_CONTEXT_FAILURE_REASON_UNKNOWN,
    /* Unknown reason*/

  SYS_GW_MBMS_CONTEXT_FAILURE_NO_NETWORK_RESPONSE,
    /* No network response*/

  SYS_GW_MBMS_CONTEXT_FAILURE_INVALID_PDP_CONTEXT_STATE,
    /* Invalid PDP context state*/

  SYS_GW_MBMS_CONTEXT_FAILURE_PDP_CONTEXT_ERROR,
    /* PDP context error*/

  SYS_GW_MBMS_CONTEXT_FAILURE_APN_ERROR,
    /* APN error*/

  SYS_GW_MBMS_CONTEXT_FAILURE_INSUFFICIENT_RESOURCES,
    /* Insufficient resources*/

  SYS_GW_MBMS_CONTEXT_FAILURE_AUTHENTICATION_ERROR,
    /*  Authentication error*/

  SYS_GW_MBMS_CONTEXT_FAILURE_ACT_DEACT_REJECTED,
    /* Activate/Deactivate rejected */

  SYS_GW_MBMS_CONTEXT_FAILURE_DUPLICATE_MBMS,
    /* Duplicate MBMS*/

  SYS_GW_MBMS_CONTEXT_FAILURE_CONTEXT_SYNC_ERROR,
    /* Context sync error*/

  SYS_GW_MBMS_CONTEXT_FAILURE_REASON_OTHER,
    /* Other */

  SYS_GW_MBMS_CONTEXT_FAILURE_REASON_MAX
    /* For internal use only */
}sys_gw_mbms_context_failure_reason_e_type;

/* Type that identifies the specific MBMS request sent by
** the client. 
*/
typedef enum 
{
  /* FOR INTERNAL USE ONLY!
  */
  SYS_GW_MBMS_REQ_NONE = -1,

  /* MBMS Service Activate command  
  */
  SYS_GW_MBMS_REQ_ACTIVATE,

  /* MBMS Service Deactivate command 
  */
  SYS_GW_MBMS_REQ_DEACTIVATE,

  /* MBMS Session Complete Ind 
  */
  SYS_GW_MBMS_REQ_SESSION_COMPLETE_IND,

  /* MBMS Abort Req  (to abort MBMS contex activation procedure in NAS)
  */
  SYS_GW_MBMS_REQ_ABORT,

  /* MBMS Service Suspend command  
  */
  SYS_GW_MBMS_REQ_SUSPEND,

  /* MBMS Service Resume command  
  */
  SYS_GW_MBMS_REQ_RESUME,

  /* MBMS Available Services List Request 
  */
  SYS_GW_MBMS_REQ_AVAIL_SERVICES_LIST,

  /* MBMS Capability enquiry
  */
  SYS_GW_MBMS_REQ_GET_CAPABILITY ,

  /* MBMS Set Attribute 
  */
  SYS_GW_MBMS_REQ_SET_ATTR ,

  /* FOR INTERNAL USE ONLY!
  */
  SYS_GW_MBMS_REQ_MAX

} sys_gw_mbms_req_e_type;

/* MBMS report type */
typedef enum 
{
  /* FOR INTERNAL USE ONLY!
  */
  SYS_GW_MBMS_RESP_NONE = -1,

  /* MBMS Service Activate Cnf 
  */
  SYS_GW_MBMS_RESP_ACTIVATE_CNF ,

  /* MBMS Service Deactivate Cnf  
  */
  SYS_GW_MBMS_RESP_DEACTIVATE_CNF ,

  /* MBMS Service Ind (change in status)
  */
  SYS_GW_MBMS_RESP_SERVICE_IND ,

  /* MBMS Capability RPTication - from RRC, NAS 
  */
  SYS_GW_MBMS_RESP_CAPABILITY_IND ,

  /* MBMS Context Act Ind - from NAS after it received TMGI for a service 
  */
  SYS_GW_MBMS_RESP_CONTEXT_ACTIVATED_IND ,

  /* MBMS Context Deact Ind (MBMS context deactivation, PDP context 
  ** deactivation, etc)  - from NAS 
  */
  SYS_GW_MBMS_RESP_CONTEXT_DEACTIVATED_IND ,

  /* MBMS Abort cnf
  */
  SYS_GW_MBMS_RESP_ABORT_CNF,

  /* MBMS Service Suspend Cnf 
  */
  SYS_GW_MBMS_RESP_SUSPEND_CNF ,

  /* MBMS Service Resume Cnf 
  */
  SYS_GW_MBMS_RESP_RESUME_CNF ,

  /* MBMS Available Services List Cnf 
  */
  SYS_GW_MBMS_RESP_AVAIL_SERVICES_LIST_CNF ,

  /* MBMS Available Services List Cnf 
  */
  SYS_GW_MBMS_RESP_LL_READY_IND ,

  /* MBMS Rpt Set Attribute
  */
  SYS_GW_MBMS_RESP_SET_ATTR ,

  /* FOR INTERNAL USE ONLY!
  */
  SYS_GW_MBMS_RESP_MAX

} sys_gw_mbms_resp_e_type;

/**
*  Enumeration of UMA-GAN client states
*/

typedef enum sys_gw_gan_state_e {

  SYS_GW_GAN_STATE_NONE = -1,               
  /**< @internal */

  SYS_GW_GAN_STATE_INIT,                 
  /**< GAN client is initialized 
  */
                                  
  SYS_GW_GAN_STATE_SHUTDOWN,
  /**< GAN client shutdown 
  */

  SYS_GW_GAN_STATE_MAX 
   /**< @internal */
  
} sys_gw_gan_state_e_type;

/**
** Enumeration of UMA-GAN signal channel status
*/

typedef enum sys_gw_gan_sig_chan_status_e {

  SYS_GW_GAN_SIG_CHAN_STATUS_NONE = -1,               
  /**< @internal */

  SYS_GW_GAN_SIG_CHAN_STATUS_UP,                 
  /**< GAN service is possible pending a successful 
  ** GAN registration procedure. 
  */
                                  
  SYS_GW_GAN_SIG_CHAN_STATUS_DOWN,
  /**< MS can not attempt to register with GAN Client and 
  ** no GAN service is possible. 
  */

  SYS_GW_GAN_SIG_CHAN_STATUS_MAX 
   /**< @internal */
  
} sys_gw_gan_sig_chan_status_e_type;

/** 
** Type for UMA-GAN Connection Status 
*/

typedef enum sys_gw_gan_conn_status_e {

  SYS_GW_GAN_CONN_STATUS_NONE = -1,
  /**< @internal*/
 
  /* 0 */
  SYS_GW_GAN_CONN_STATUS_AP_MS_NOT_ASSOCIATED = 0 ,
    /**< AP MS NOT ASSOCIATED */

  SYS_GW_GAN_CONN_STATUS_AP_MS_ASSOCIATED    = SYS_BM(1),
    /**< AP MS ASSOCIATED */

  SYS_GW_GAN_CONN_STATUS_CS_ROVE_IN_STARTED  = SYS_BM(2),
    /**< CS ROVE IN STARTED */
  
  SYS_GW_GAN_CONN_STATUS_PS_ROVE_IN_STARTED  = SYS_BM(3),
    /**< PS ROVE IN STARTED */

  /* 4 */
  SYS_GW_GAN_CONN_STATUS_CS_HAND_IN_STARTED  = SYS_BM(4),
    /**< CS HAND IN STARTED */

  SYS_GW_GAN_CONN_STATUS_PS_HAND_IN_STARTED  = SYS_BM(5),
    /**< PS HAND IN STARTED*/

  SYS_GW_GAN_CONN_STATUS_CS_ROVE_OUT_STARTED = SYS_BM(6),
    /**< CS ROVE OUT STARTED*/

  SYS_GW_GAN_CONN_STATUS_PS_ROVE_OUT_STARTED = SYS_BM(7),
    /**< PS ROVE OUT STARTED */

   SYS_GW_GAN_CONN_STATUS_CS_HAND_OUT_STARTED =SYS_BM(8),
    /**< CS HAND OUT STARTED */

  SYS_GW_GAN_CONN_STATUS_PS_HAND_OUT_STARTED = SYS_BM(9),
    /**< PS HAND OUT STARTED*/

  SYS_GW_GAN_CONN_STATUS_CS_HAND_OUT_OVER   = SYS_BM(10),
    /**< CS HAND OUT OVER */

  SYS_GW_GAN_CONN_STATUS_PS_HAND_OUT_OVER   = SYS_BM(11),
    /**< PS HAND OUT OVER */

  SYS_GW_GAN_CONN_STATUS_MAX
  /** @internal */

} sys_gw_gan_conn_status_e_type;

/**
*  Type for UMA-GAN Mode Display
*  Describes if WLAN or GERAN is active RAT
*  and the parameters if WLAN is the active RAT
*/

typedef struct sys_gw_gan_mode_display_s{

  boolean                                         is_mode_display_on;
  /**< if is_mode_display_on is set to TRUE, WLAN is the active RAT
  ** if it is FALSE, GERAN is the active RAT
  */

  /**< The parameters below are valid only if 
  ** is_mode_display_on = TRUE
  */

  uint8                                           gan_usz_icon_indicator;
     /**< GAN USZ icon indicator */

  uint8                                           gan_ms_location_status;
     /**< GAN MS location status  */

  uint8                                           usz_str[SYS_GW_GAN_USZ_STR_MAX_LENGTH];
     /**< GAN USZ string */

}sys_gw_gan_mode_display_s_type;

/*
** Type for UMA-GAN Error prompt
*/

typedef struct sys_gw_gan_error_s{

  uint8                                           gan_error_category;
     /**< GAN error category*/

  uint8                                           gan_error_codepoint;
     /**< GAN specific error
     **  within the category  
     */

} sys_gw_gan_error_s_type;

#if (defined(FEATURE_MODEM_MBMS) || defined(FEATURE_MM_SUPERSET))

/* MBMS logical channel id 
*/
typedef struct
{
  /* TRUE  -  Log chan id is present
  ** FALSE -  Log chan id is not present
  */
  boolean present;

  /* Logical channel id. 
  ** Used between DS and RLC on traffic plane.
  */
  uint32  log_chan_id;

}sys_gw_mbms_log_chan_id_s_type;

/* MBMS session id */
typedef struct
{
  /* TRUE  -  Session id is present
  ** FALSE -  Session id is not present
  */
  boolean present;

  /* Session id_type */
  uint32  session_id;

}sys_gw_mbms_session_id_s_type;

/* TMGI structure in int format */
typedef struct
{ 

  /* TRUE  -  TMGI is present
  ** FALSE -  TMGI is not present
  */
  boolean present;

  /* TMGI in uint64 format */
  uint64  tmgi;

}sys_gw_mbms_tmgi_uint_s_type;

/* MBMS service priority */
typedef struct
{
  /* TRUE  -  Priority is present
  ** FALSE -  Priority is not present
  */
  boolean present;

  /* Priority of MBMS service request */
  uint32   priority;

}sys_gw_mbms_srv_priority_s_type;

/*
** Struct to hold parameters for MBMS activate request for each service
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Multicast IP*/
  sys_ip_address_s_type            mip;

  /* Port number */
  uint32                           port;

  /* Service Priority */  
  sys_gw_mbms_srv_priority_s_type     priority; 

  /* Service Mode */
  sys_gw_mbms_srv_mode_e_type         srv_mode;

  /* Service Type */
  sys_gw_mbms_srv_type_e_type         srv_type;

  /* Generic parameter */
  uint32                           mbms_parm;

}sys_gw_mbms_activate_req_entry_s_type;

/* Struct to hold MBMS activate request parameters for num_services elements
*/
typedef struct 
{
  /* Number of services in the array */
  uint8                                  num_services;

  /* Services that need to be activated */
  sys_gw_mbms_activate_req_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];

}sys_gw_mbms_activate_req_s_type;

/* Struct to hold MBMS deactivate req parameters
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Generic parameter */
  uint32                           mbms_parm;        

}sys_gw_mbms_deactivate_req_entry_s_type;

/* Struct to hold MBMS deactivate req parameters for "num_services" MBMS 
** services
*/
typedef struct 
{
  /* Number of services in the array. Setting this to 0xFF will deactivate 
  ** all active MBMS services 
  */
  uint8                                    num_services;

  /* Services that need to be de-activated */
  sys_gw_mbms_deactivate_req_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];      

}sys_gw_mbms_deactivate_req_s_type;

/* Struct to hold parameters for MBMS session complete ind
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Completed Session id */
  sys_gw_mbms_session_id_s_type       session_id;

  /* Generic parameter */
  uint32                           mbms_parm;
      
}sys_gw_mbms_session_complete_ind_s_type;

/* Struct to hold parameters for MBMS abort req
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Multicast IP */
  sys_ip_address_s_type            mip;

  /* Port number */
  uint32                           port;

  /* Abort type */
  sys_gw_mbms_abort_type_e_type       abort_type; 

  /* Generic parameter */
  uint32                           mbms_parm;
      
}sys_gw_mbms_abort_req_entry_s_type;

/* To hold Abort req parameters for "num_services" MBMS services.
*/
typedef struct 
{
  /* Number of services in the array. Setting this to 0xFF will abort 
  ** all active MBMS services 
  */
  uint8                               num_services;

  /* Services list */
  sys_gw_mbms_abort_req_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];
      
}sys_gw_mbms_abort_req_s_type;

/* MBMS suspend request
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Generic parameter */
  uint32                           mbms_parm;
      
}sys_gw_mbms_suspend_req_entry_s_type;

/* Struct to hold parameters for MBMS suspend req cmd.
*/
typedef struct 
{
  /* Number of services in the array. Setting this to 0xFF will suspend 
  ** all active MBMS services 
  */
  uint8                                 num_services;

  /* Services list */
  sys_gw_mbms_suspend_req_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];
      
}sys_gw_mbms_suspend_req_s_type;

/* MBMS resume request
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Generic parameter */
  uint32                           mbms_parm;

}sys_gw_mbms_resume_req_entry_s_type;

/* Struct to hold parameters for MBMS resume req cmd.
*/
typedef struct 
{
  /* Number of services in the array. Setting this to 0xFF will resume 
  ** all suspended MBMS services 
  */
  uint8                                num_services;

  /* Services list */
  sys_gw_mbms_resume_req_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];
      
}sys_gw_mbms_resume_req_s_type;

/* Struct to hold parameters for MBMS available services list request command
*/
typedef struct 
{
  /* Placeholder for future use */
  uint32 mbms_parm;

}sys_gw_mbms_avail_srv_list_req_s_type;

/* Struct for clients to query MBMS capability
*/
typedef struct 
{
  /* Placeholder for future use */
  uint32 mbms_parm;

} sys_gw_mbms_capability_req_s_type;

/* Generic MBMS command
*/
typedef struct 
{
  /* Generic parameters */
  uint32 mbms_parm1;
  uint32 mbms_parm2;
  uint32 mbms_parm3;
  uint32 mbms_parm4;
  uint32 mbms_parm5;
  uint32 mbms_parm6;

}sys_gw_mbms_set_attr_req_s_type;

/* MBMS activate cnf
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Multicast IP*/
  sys_ip_address_s_type            mip;

  /* Port number */
  uint32                           port;

  /* Status of req - TRUE indicates success, FALSE indicates failure */
  boolean                          cnf_status;

  /* Service status */
  sys_gw_mbms_srv_status_e_type       srv_status;

  /* Logical channel id that was added */
  sys_gw_mbms_log_chan_id_s_type      log_chan_id;

  /* Generic parameter */
  uint32                           mbms_parm;        

}sys_gw_mbms_resp_activate_cnf_entry_s_type;

/* Struct to hold parameters for MBMS activate conf report
*/
typedef struct 
{
  /* Number of services in the array */
  uint8                                  num_services;

  /* Services list */
  sys_gw_mbms_resp_activate_cnf_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];        

}sys_gw_mbms_resp_activate_cnf_s_type;

typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Multicast IP*/
  sys_ip_address_s_type            mip;

  /* Port number */
  uint32                           port;

  /* Status of req - TRUE indicates success, FALSE indicates failure */
  boolean                          cnf_status;

  /* Service status */
  sys_gw_mbms_srv_status_e_type       srv_status;

  /* Logical channel id that was removed */
  sys_gw_mbms_log_chan_id_s_type      log_chan_id;

  /* Generic parameter */
  uint32                           mbms_parm;        

}sys_gw_mbms_resp_deactivate_cnf_entry_s_type;

/* Struct to hold parameters for MBMS deactivate cnf
*/
typedef struct 
{
  /* Number of services in the array */
  uint8                                   num_services;

  /* Services list */
  sys_gw_mbms_resp_deactivate_cnf_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];      

}sys_gw_mbms_resp_deactivate_cnf_s_type;

/* MBMS Service Indication
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Multicast IP*/
  sys_ip_address_s_type            mip;

  /* Port number */
  uint32                           port;

  /* Logical channel id that was added/removed */
  sys_gw_mbms_log_chan_id_s_type      log_chan_id;

  /* Service status */
  sys_gw_mbms_srv_status_e_type       srv_status;

  /* Generic parameter */
  uint32                           mbms_parm;        

}sys_gw_mbms_resp_service_ind_entry_s_type;

/* Struct to hold parameters for service indication report
*/
typedef struct sys_gw_mbms_resp_service_ind_s
{
  /* Number of services in the array */
  uint8                                 num_services;

  /* Services list */
  sys_gw_mbms_resp_service_ind_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];      

}sys_gw_mbms_resp_service_ind_s_type;

/* Struct to hold parameters for capability indication
*/
typedef struct 
{
  /* Indication that core network is MBMS capable */
  boolean network_capability;

  /* Indication that cell is MBMS capable */
  boolean cell_capability;

  /* Generic parameter */
  uint32 mbms_parm;

}sys_gw_mbms_resp_capability_ind_s_type;

/* Struct to hold parameters for Context Activated Indication report
*/
typedef struct 
{
  /* TMGI reported by NAS for MIP specified below */
  sys_gw_mbms_tmgi_uint_s_type              tmgi;

  /* Multicast IP*/
  sys_ip_address_s_type                  mip;

  /* Port number */
  uint32                                 port;

  /* Context activation status. TRUE is successful, FALSE otherwise */
  boolean                                act_status;

  /* Failure reason of context activation req  if act_status is FALSE */
  sys_gw_mbms_context_failure_reason_e_type context_failure_reason;   

}sys_gw_mbms_resp_context_activated_ind_s_type;

/* Struct to hold parameters for context deactivation
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type               tmgi;

  /* Multicast IP*/
  sys_ip_address_s_type                   mip;

  /* Port number */
  uint32                                  port;

  /* Context de-activation status. TRUE is successful, FALSE otherwise */
  boolean                                 deact_status;

  /* Failure reason of context deactivation req. Valid if deact_status is
  ** is FALSE
  */
  sys_gw_mbms_context_failure_reason_e_type  context_failure_reason;   

}sys_gw_mbms_resp_context_deactivated_ind_s_type;

/* MBMS Abort cnf
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi_uint;

  /* Multicast IP*/
  sys_ip_address_s_type            mip;

  /* Port number */
  uint32                           port;

  /* Status of req - TRUE indicates success, FALSE indicates failure */
  boolean                          cnf_status;

}sys_gw_mbms_resp_abort_cnf_entry_s_type;

/* Struct to hold parameters for MBMS Abort conf
*/
typedef struct 
{
  /* Number of services in the array */
  uint8                               num_services;
 
  /* Services list */
  sys_gw_mbms_resp_abort_cnf_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];      

}sys_gw_mbms_resp_abort_cnf_s_type;

/* MBMS suspend cnf
*/
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Status of req - TRUE indicates success, FALSE indicates failure */
  boolean                          cnf_status;

  /* Generic parameter */
  uint32                           mbms_parm;

}sys_gw_mbms_resp_suspend_cnf_entry_s_type;

/* Struct to hold parameters for MBMS suspend cnf
*/
typedef struct 
{
  /* Number of services in the array */
  uint8 num_services;

  /* Services list */
  sys_gw_mbms_resp_suspend_cnf_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];      

}sys_gw_mbms_resp_suspend_cnf_s_type;

/* MBMS resume cnf */
typedef struct 
{
  /* TMGI of service */
  sys_gw_mbms_tmgi_uint_s_type        tmgi;

  /* Status of req - TRUE indicates success, FALSE indicates failure */
  boolean                          cnf_status;

  /* Service status after resumption */
  sys_gw_mbms_srv_status_e_type       srv_status;

  /* Generic parameter */
  uint32                           mbms_parm;

}sys_gw_mbms_resp_resume_cnf_entry_s_type;

/* Struct to hold parameters for MBMS resume cnf
*/
typedef struct 
{
  /* Number of services in the array */
  uint8                                num_services;

  /* Services list */
  sys_gw_mbms_resp_resume_cnf_entry_s_type services[SYS_GW_MBMS_NUM_MAX_SRVS_PER_REQ];      

}sys_gw_mbms_resp_resume_cnf_s_type;

/*
Struct to hold parameters for Available services list cnf
*/
typedef struct 
{
  /* Status of req - TRUE indicates success, FALSE indicates failure */
  boolean                          cnf_status;

  /* List of service ids that are available in the cell currently */
  uint32                           service_id[SYS_GW_MBMS_MAX_SERVICES];

  /* Generic parameter */
  uint32                           mbms_parm;

}sys_gw_mbms_resp_avail_srv_list_cnf_s_type;

typedef struct 
{
  /* Generic parameters */
  uint32 mbms_parm1;
  uint32 mbms_parm2;
  uint32 mbms_parm3;
  uint32 mbms_parm4;
  uint32 mbms_parm5;
  uint32 mbms_parm6;

}sys_gw_mbms_resp_set_attr_s_type;

/* Type to indicate the Lower Layer (RRC) is in a READY (IDLE) state to 
** service MBMS requests
*/
typedef struct 
{
  /* Generic parameters */
  uint32 mbms_parm1;

} sys_gw_mbms_resp_ll_ready_ind_s_type;

#else /* (defined(FEATURE_MODEM_MBMS) || defined(FEATURE_MM_SUPERSET)) */
#endif /* (defined(FEATURE_MODEM_MBMS) || defined(FEATURE_MM_SUPERSET)) */

/* --------------------------------------------------------------------------
 Enumeration that identifies the status of ps signal release. It has to be identical to
 struct ps_sig_rel_status_T in sm_cm.h because the values coming from NAS is mapped 
 to this by CM
** ------------------------------------------------------------------------*/
typedef enum
{
   PS_SIG_REL_SUCCESS,
   PS_SIG_REL_FAILURE
} cm_ps_sig_rel_status_T;

#endif /* #ifndef SYS_GW_H */
#ifndef NET_H
#define NET_H
/*===========================================================================

              NET  H E A D E R   F I L E

DESCRIPTION
  This header file contains definitions that are required for defining NETWORK
  SYSTEM and PROFILES in a NET FILE.

EXTERNALIZED FUNCTIONS

  net_get_sw_ver

  net_file_read
  net_file_write
  net_file_read2
  net_file_write2

  net_validate

  net_parser_make
  net_parser_init
  net_set_file_id

  net_get_max_allowed_file_size
  net_get_file_len

  net_extract_buf_ptr

  net_get_max_allowed_sys
  net_get_max_allowed_profile
  net_get_num_sys
  net_get_num_profile

  net_get_sys_rec
  net_get_profile
  net_get_wlan_sys_rec

  net_insert_sys_rec
  net_insert_profile
  net_insert_sys_rec_profile
  net_insert_wlan_sys_rec

  net_insert_wlan_sys_rec_profile

  net_del_sys_rec
  net_del_profile

  net_modify_sys_rec
  net_modify_profile
  net_modify_wlan_sys_rec

  net_pack_profile
  net_unpack_profile


Copyright (c) 2004 - 2006 by QUALCOMM INCORPORATED. All Rights Reserved.

Export of this technology or software is regulated by the U.S. Government.
Diversion contrary to U.S. law prohibited.

===========================================================================*/

#ifndef SYS_WLAN_H
#define SYS_WLAN_H

/*===========================================================================

              WLAN S Y S T E M   H E A D E R   F I L E

DESCRIPTION
  This header file contains definitions that are shared between Call Manager,
  Call Manager clients and the WLAN protocol stacks.

Copyright (c) 2004 - 2006 by QUALCOMM INCORPORATED. All Rights Reserved.

Export of this technology or software is regulated by the U.S. Government.
Diversion contrary to U.S. law prohibited.

===========================================================================*/


/*
** Enumeration of technology type mask.
** It converts bit position of sys_tech_e_type to a bit mask.
** To keep numbering scheme consistent,
** use sys_tech_e_type instead of numbers directly.
**
*/
/*
** Technology type bit mask data type. It is a combination of enumeration of
** system band class mask.
*/
typedef uint32                          sys_tech_mask_type;

/* Enumeration of WLAN Scan preference.
*/
typedef enum
{

  /* FOR INTERNAL USE OF CM ONLY!.
  */
  SYS_WLAN_SCAN_PREF_NONE               = -1,

  /* Active WLAN Scan.
  */
  SYS_WLAN_SCAN_PREF_ACTIVE              = 0,

  /* Passive WLAN Scan.
  */
  SYS_WLAN_SCAN_PREF_PASSIVE             = 1,

  /* WLAN Scanning to be decided automatically.
  */
  SYS_WLAN_SCAN_PREF_AUTO                = 2,

  /* FOR INTERNAL USE OF CM ONLY!.
  */
  SYS_WLAN_SCAN_PREF_MAX

} sys_wlan_scan_pref_e_type;

/* Enumeration of WLAN Rates.
*/
typedef enum {

  /* FOR INTERNAL USE ONLY!.
  */
  SYS_WLAN_RATE_NONE = -1,

  /* 1 Mbps.
  */
  SYS_WLAN_RATE_1_MBPS,

  /* 2 Mbps.
  */
  SYS_WLAN_RATE_2_MBPS,

  /* 5.5 Mbps.
  */
  SYS_WLAN_RATE_5_5_MBPS,

  /* 11 Mbps.
  */
  SYS_WLAN_RATE_11_MBPS,

  /* FOR INTERNAL USE ONLY!.
  */
  SYS_WLAN_RATE_MAX

} sys_wlan_rate_e_type;

typedef enum{
  /* For Internal Use Only! */
  SYS_WLAN_SEC_TYPE_NONE               = 0,
    
  SYS_WLAN_SEC_TYPE_LEGACY             = 1,

  SYS_WLAN_SEC_TYPE_WPA_OR_WPA2        = 2,

  SYS_WLAN_SEC_TYPE_WPA2_ONLY          = 3,

  SYS_WLAN_SEC_TYPE_MAX

} sys_wlan_sec_mode_e_type;

/** WPS methods.
*/
typedef enum {

  SYS_WLAN_WPS_MODE_NONE              = -1,
  /**< @internal None.
  */

  SYS_WLAN_WPS_MODE_MANUAL,
  /**< WPS procedure requiring user to select SSID.
  */

  SYS_WLAN_WPS_MODE_AUTO,
  /**< WPS procedure not requiring user to select SSID.
  */

  SYS_WLAN_WPS_MODE_MAX
  /**< @internal Maximum.
  */

} sys_wlan_wps_mode_e_type;

/** Various configuration methods for WPS.
*/ 
typedef enum {

  SYS_WLAN_WPS_CONFIG_METHOD_NONE                  = 0,
  /**< @internal None.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_USBA                  = 1,
  /**< USB flash drive.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_ETHERNET              = 2,
  /**< Ethernet.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_LABEL                 = 4,
  /**< Label on the hardware.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_DISPLAY               = 8,
  /**< Display on hardware.
  */
  
  SYS_WLAN_WPS_CONFIG_METHOD_EXT_NFC_TOKEN         = 16,
  /**< External NFC token.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_INT_NFC_TKN           = 32,
  /**< Internal NFC token.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_NFC_IFACE             = 64,
  /**< NFC interface.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_PUSHBUTTON            = 128,
  /**< Push button.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_KEYPAD                = 256,
  /**< Keypad.
  */

  SYS_WLAN_WPS_CONFIG_METHOD_MAX
  /**< @internal Maximum value.
  */

} sys_wlan_wps_config_method_e_type;

/** WPS devive password types.
*/
typedef enum {

  SYS_WLAN_WPS_DEV_PASSWD_ID_NONE                  = -1,
  /**< @internal None. */

  SYS_WLAN_WPS_DEV_PASSWD_ID_PIN                   =  0,
  /**< PIN. */

  SYS_WLAN_WPS_DEV_PASSWD_ID_USER_SPECIFIED        =  1,
  /**< User specified. */

  SYS_WLAN_WPS_DEV_PASSWD_ID_MACHINE_SPECIFIED     =  2,
  /**< Machine specified. */

  SYS_WLAN_WPS_DEV_PASSWD_ID_REKEY                 =  3,
  /**< 256 bit rekeying password. */

  SYS_WLAN_WPS_DEV_PASSWD_ID_PUSHBUTTON            =  4,
  /**< Push button. */

  SYS_WLAN_WPS_DEV_PASSWD_ID_REGISTRAR_SPECIFIED   =  5,
  /**< Registrar specified. */

  SYS_WLAN_WPS_DEV_PASSWD_ID_MAX
  /**< @internal Maximum. */

} sys_wlan_wps_dev_passwd_id_e_type;

/** WPS procedure end status.
*/
typedef enum {

  /** @internal None. */
  SYS_WLAN_WPS_STATUS_NONE             = -1,

  /** WPS procedure completed without any errors. */
  SYS_WLAN_WPS_STATUS_NO_ERROR         =  0,

  /*------------------------------------------------------*/
  /* Configuration Errors in registration protocol. */
  /*------------------------------------------------------*/

  /** Out of band interface read error. */
  SYS_WLAN_WPS_STATUS_OOB_IFACE_READ_ERROR,

  /** Decryption CRC failure. */
  SYS_WLAN_WPS_STATUS_DECRYPT_CRC_FAILURE,

  /** 2.4 channel not supported. */
  SYS_WLAN_WPS_STATUS_2_4_CHAN_NOT_SUPPORTED,

  /** 5.0 channel not supported. */
  SYS_WLAN_WPS_STATUS_5_0_CHAN_NOT_SUPPORTED,
  
  /** Signal too weak. */
  SYS_WLAN_WPS_STATUS_SIGNAL_TOO_WEAK,

  /** Network authentication failure. */
  SYS_WLAN_WPS_STATUS_NETWORK_AUTH_FAILURE,

  /** Network association failure. */
  SYS_WLAN_WPS_STATUS_NETWORK_ASSOC_FAILURE,
  
  /** No DHCP response. */
  SYS_WLAN_WPS_STATUS_NO_DHCP_RESP,

  /** Failed DHCP config. */
  SYS_WLAN_WPS_STATUS_FAILED_DHCP_CONFIG,

  /** IP address conflict. */
  SYS_WLAN_WPS_STATUS_IP_ADDR_CONFLICT,

  /** Couldn't connect to Registrar. */
  SYS_WLAN_WPS_STATUS_NO_REGISTRAR_CONNECT,

  /** Multiple PBC sessions detected. */
  SYS_WLAN_WPS_STATUS_PBC_SESSION_OVERLAP,

  /** Rogue activity suspected. */
  SYS_WLAN_WPS_STATUS_ROGUE_ACTIVITY_SUSPECTED,

  /** Device busy. */
  SYS_WLAN_WPS_STATUS_DEVICE_BUSY,

  /** Setup locked. */
  SYS_WLAN_WPS_STATUS_SETUP_LOCKED,

  /** Message timeout. */
  SYS_WLAN_WPS_STATUS_MSG_TIMEOUT,

  /** Registration session timeout. */
  SYS_WLAN_WPS_STATUS_REG_SESSION_TIMEOUT,

  /** Device password authentication failure. */
  SYS_WLAN_WPS_STATUS_DEV_PASSWD_AUTH_FAILURE,

  /*------------------------------------------------------*/
  /* Failures detected in WLAN CP */
  /*------------------------------------------------------*/

  /** WPS capable access points not found. */
  SYS_WLAN_WPS_STATUS_WPS_CAPABLE_APS_NOT_FOUND    = 100

} sys_wlan_wps_status_e_type;
 
/**
** Enumeration for WLAN link quality
*/
typedef enum sys_wlan_link_qual_e {

  SYS_WLAN_LINK_QUAL_NONE = -1,
  /**< @internal */

  SYS_WLAN_LINK_QUAL_POOR,
  /**< POOR WLAN link quality  */

  SYS_WLAN_LINK_QUAL_GOOD,
 /**< GOOD WLAN link quality  */

  SYS_WLAN_LINK_QUAL_VERY_GOOD,
 /**< VERY GOOD WLAN link quality  */

  SYS_WLAN_LINK_QUAL_EXCELLENT,
 /**< EXCELLENT WLAN link quality  */

  SYS_WLAN_LINK_QUAL_MAX
 /**< @internal */

} sys_wlan_link_qual_e_type;

/*==============================================================================

                     S Y S T E M   I D E N T I F I E R

==============================================================================*/

/** Maximum size of WPS device password.
*/
#define SYS_WLAN_WPS_DEV_PASSWD_LEN_MAX (uint16)(64)

/** Maximum number of credentials from a WPS procedure.
*/
#define SYS_WLAN_WPS_CREDENTIAL_COUNT_MAX (uint8)(5)

/* WLAN Statistics
*/

typedef struct sys_wlan_stats_s
{
  sys_wlan_rate_e_type    current_xmit_rate;
  /* Xmit rate of the last packet successfully transmitted */

  uint32                  total_tx_bytes;
  /* Number of bytes transmitted over the WLAN interface  */

  uint32                  total_rx_bytes;
  /* Number of bytes received over the WLAN interface     */
  
  sys_wlan_link_qual_e_type	wlan_link_quality;
  /**< Link quality reported by WLAN */

} sys_wlan_stats_s_type;

/* WLAN Record with all the fields which SD doesn't care about & are passed 
 * down by SD to WLAN as it is
 */

typedef struct {
  
  /* Whether Handoff is permitted on the current SSID */
  boolean                                          is_handoff_permitted;

  /* Whether the current SSID is hidden */
  boolean                                          is_hidden_ssid;

  /* WLAN security mode such as LEGACY, WPA, WPA2 */
  sys_wlan_sec_mode_e_type                         wlan_sec_mode;

} sys_wlan_misc_params_s_type;

/** WLAN system record using sys_* types.
*/
typedef struct sys_wlan_sys_rec_s {

  sys_tech_mask_type                               tech;
  /**< WLAN Technology */

  sys_band_mask_type                               band;
  /**< WLAN Bands */

  sys_chan_type                                    chan;
  /**< WLAN channels to acquire.
  ** Channel 0 means any channel.
  */

  word                                             groups;
  /**< Group this record belongs to. */

  sys_wlan_bss_e_type                              mode;
  /**< WLAN BSS type such as AD-HOC,INFRA, etc. */

  sys_profile_id_type                              profile_id;
  /**< Profile Id */

  sys_wlan_ssid_s_type                             ssid;
  /**< SSID */

  sys_wlan_misc_params_s_type                      wlan_misc_params;
  /**< Misc fields relevant for the WLAN stack. */

} sys_wlan_sys_rec_s_type;

/** WPS credentials.
*/
typedef struct sys_wlan_wps_credential_s {

  sys_wlan_sys_rec_s_type           sys_rec;
  /**< WLAN system record info.
  */

  sys_manual_sys_profile_s_type     profile;
  /**< WLAN security profile info.
  */

  boolean                           is_key_provided_auto;
  /**< Key provided automatically.
  */

  sys_wlan_bssid_type               bssid;
  /**< MAC address.
  */

} sys_wlan_wps_credential_s_type;

/** WPS credential list.
*/
typedef struct sys_wlan_wps_credential_list_s {

  uint8                             count;
  /**< Number of credentials.
  */

  sys_wlan_wps_credential_s_type    cred[SYS_WLAN_WPS_CREDENTIAL_COUNT_MAX];
  /**< WLAN credentials.
  */

} sys_wlan_wps_credential_list_s_type;

/** WPS result
*/
typedef struct sys_wlan_wps_result_s {

  sys_wlan_wps_status_e_type            status;
  /**< WPS procedure end status.
  ** @NOTE: If status is not SYS_WLAN_WPS_STATUS_NO_ERROR, then the cred_list
  ** has no meaning.
  */

  sys_wlan_wps_credential_list_s_type   cred_list;
  /**< WLAN credential list.
  */

} sys_wlan_wps_result_s_type;

/** WPS Device password info.
*/
typedef struct sys_wlan_wps_dev_passwd_s {

  sys_wlan_wps_dev_passwd_id_e_type  id;

  uint16                             len;

  byte                               passwd[SYS_WLAN_WPS_DEV_PASSWD_LEN_MAX];

} sys_wlan_wps_dev_passwd_s_type;

/** Parameters needed for initiating WPS procedure.
*/
typedef struct sys_wlan_wps_start_param_s {

  sys_wlan_wps_mode_e_type            wps_mode;
  /**< Automatic or Manual mode of WPS operation.
  */

  sys_wlan_wps_config_method_e_type   config_method;
  /**< WPS configuration method to use.
  */
  
  sys_wlan_wps_dev_passwd_s_type      dev_passwd;
  /**< WPS Device password info.
  */

} sys_wlan_wps_start_param_s_type;

#endif /* #ifndef SYS_WLAN_H */

/* WEP Key Sizes
*/

#define NET_40_BIT_WEP_KEY_SIZE        5

#define NET_104_BIT_WEP_KEY_SIZE       13

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* USER ID MAX Size
*/

#define NET_USER_ID_MAX_SIZE           72

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* User password MAX Size
*/

#define NET_USER_PASSWD_MAX_SIZE       63

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Server name MAX Size
*/

#define NET_SERVER_NAME_MAX_SIZE       72

/* Authenticaton Type associated with a particular profile.
*/

typedef enum{

  NET_AUTH_TYPE_NONE                   = -1,
    /* For Internal Use Only! */

  NET_AUTH_TYPE_NO_AUTH                = 0,
  NET_AUTH_TYPE_WEP                    = 1,
  NET_AUTH_TYPE_8021X_PASSWD           = 2,
  NET_AUTH_TYPE_8021X_TLS_RADIUS       = 3,
  NET_AUTH_TYPE_8021X_MD5_RADIUS       = 4,
  NET_AUTH_TYPE_8021X_TLS_RADIUS_WKEY  = 5,
  NET_AUTH_TYPE_8021X_TLS_CERT         = 6,
  NET_AUTH_TYPE_PAP                    = 7,
  NET_AUTH_TYPE_CHAP                   = 8,
  NET_AUTH_TYPE_MsCHAPv2               = 9,
  NET_AUTH_TYPE_PEAP                   = 10,
  NET_AUTH_TYPE_TTLS                   = 11,
  NET_AUTH_TYPE_SIM                    = 12,
  NET_AUTH_TYPE_AKA                    = 13,

  NET_AUTH_TYPE_MAX
    /* For Internal Use Only! */

} net_auth_e_type;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* Encryption type associated with a particular profile
*/
typedef enum{

  NET_ENCRY_TYPE_NONE            = -1,
   /* For Internal Use Only! */

  NET_ENCRY_TYPE_NO_ENCRY        = 0,
  NET_ENCRY_TYPE_WEP_40_BIT      = 1,
  NET_ENCRY_TYPE_WEP_104_BIT     = 2,
  NET_ENCRY_TYPE_TKIP            = 3,
  NET_ENCRY_TYPE_AES             = 4,

  NET_ENCRY_TYPE_MAX
   /* For Internal Use Only! */

} net_encry_e_type;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* Profile Type
*/

typedef enum{

  /* For internal Use only! */
  NET_PROFILE_TYPE_NONE          = 0,

  NET_PROFILE_TYPE_WLAN          = 1,

  /* For internal Use only! */
  NET_PROFILE_TYPE_MAX

} net_profile_e_type;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* 40 Bit (a.k.a. 64 bit) WEP Key Storage.
*/

typedef struct {

  /* Default WEP Key Id */
  byte                                        default_key;

  /* WEP Key 1 */
  byte                                        key1[NET_40_BIT_WEP_KEY_SIZE];

  /* WEP Key 2 */
  byte                                        key2[NET_40_BIT_WEP_KEY_SIZE];

  /* WEP Key 3 */
  byte                                        key3[NET_40_BIT_WEP_KEY_SIZE];

  /* WEP Key 4 */
  byte                                        key4[NET_40_BIT_WEP_KEY_SIZE];

} net_wlan_40_bit_wep_info_s_type;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* 104 Bit (a.k.a. 128 bit) WEP Key Storage.
*/

typedef struct {

  /* Default WEP Key Id */
  byte                                        default_key;

  /* WEP Key 1 */
  byte                                        key1[NET_104_BIT_WEP_KEY_SIZE];

  /* WEP Key 2 */
  byte                                        key2[NET_104_BIT_WEP_KEY_SIZE];

  /* WEP Key 3 */
  byte                                        key3[NET_104_BIT_WEP_KEY_SIZE];

  /* WEP Key 4 */
  byte                                        key4[NET_104_BIT_WEP_KEY_SIZE];

} net_wlan_104_bit_wep_info_s_type;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

typedef struct {

  /* ID Length */
  byte                                        id_len;

  /* ID */
  byte                                        id[NET_USER_ID_MAX_SIZE];

} net_profile_id_s_type;

typedef struct {

  /* Password Length */
  byte                                        pass_len;

  /* Password */
  byte                                        pass[NET_USER_PASSWD_MAX_SIZE];

} net_profile_pass_s_type;

typedef struct {

  /* ID Length */
  byte                                        id_len;

  /* ID */
  byte                                        id[NET_USER_ID_MAX_SIZE];

  /* Password/Shared Secret Length */
  byte                                        pass_len;

  /* Password/Shared Secret */
  byte                                        pass[NET_USER_PASSWD_MAX_SIZE];

} net_profile_id_pass_s_type;

typedef struct {

  /* Server name length */
  byte                                        server_name_len;

  /* Server name */
  byte                                        server_name[NET_SERVER_NAME_MAX_SIZE];

} net_profile_server_id_s_type;

typedef struct {

  /* ID Length */
  byte                                        id_len;

  /* ID */
  byte                                        id[NET_USER_ID_MAX_SIZE];

  /* TLS Certificate Id */
  byte                                        cert_id;

  /* server ID */
  net_profile_server_id_s_type                server_id;

} net_profile_id_cert_s_type;

/* WLAN Authentication profiles.
*/

typedef union {

  /* WLAN WEP Info */
  net_wlan_40_bit_wep_info_s_type                  wep_40_bit_info;

  net_wlan_104_bit_wep_info_s_type                 wep_104_bit_info;

  /* For 802 1X Password Based. Home Environment. */
  net_profile_pass_s_type                          x_info_passwd;

  /* For 802 1X TLS or TLS_WKEY Based. */
  net_profile_id_s_type                            x_info_tls;

  /* For 802 1X MD5 Based. */
  net_profile_id_pass_s_type                       x_info_md5;

  /* For 802 1X TLS with Certificate Based. */
  net_profile_id_cert_s_type                       x_info_tls_cert;

} net_wlan_auth_info_u_type;

typedef struct {

  /* The WLAN Encryption Type */
  byte                                             encryp_type;

  /* The WLAN Authentication Type */
  byte                                             auth_type;

  /* Mobile IP Profile Id */
  byte                                             mob_ip_profile_id;

  /* The WLAN Authentication Info */
  net_wlan_auth_info_u_type                        auth_info;

} net_wlan_profile_s_type;

/* Profile structure as required by NET.
*/

typedef union {

  net_wlan_profile_s_type                          wlan;

} net_profile_u_type;

typedef struct {

  /* Profile Length*/
  byte                                             len;

  /* Profile Id */
  byte                                             profile_id;

  /* Profile Type */
  byte                                             type;

  /* Profile */
  net_profile_u_type                               profile;

} net_profile_s_type;

#endif  /* NET_H */
#ifndef CMWMSG_H
#define CMWMSG_H

/*===========================================================================
            COPYRIGHT INFORMATION

Copyright (c) 2002 - 2006 QUALCOMM, Incorporated and its licensors.  All Rights
Reserved.  QUALCOMM Proprietary.  Export of this technology or software
is regulated by the U.S. Government. Diversion contrary to U.S. law prohibited.

            EDIT HISTORY FOR MODULE

This section contains comments describing changes made to the module.
Notice that changes are listed in reverse chronological order.

$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $

when       who     what, where, why
--------   ---     ----------------------------------------------------------
06/17/08   ak      Compilation error discovered on target rectified.
09/14/07   dm      Added support for FEATURE_MM_SUPERSET
06/27/07   cl      Add new CM API to expose cmwcall_get_user_data() to RPC
05/02/07   rp      Adding FEATURE_CM_LCS
04/15/07   rp      Removing FEATURE_MMGPS
07/04/06   ka      Changes to support call control on PS calls.
03/24/06   ka      Added VideoTelephony fallback to voice feature for UMTS.
06/24/05   ic      Adding CCBS feature (merged in P4 change list 204600)
11/23/04   ic      Put user-to-user signaling code under FEATURE_UUS
11/19/04   ka      Adding support for user to user signaling
08/26/04   sbs     Added externalAddress and nameString IEs to MOLR_Invoke /
                   LocationNotification SS messages
08/17/04   ic      Undoing P4 change list #121638
02/06/04   ws      Initial jaguar/mainline merge.
07/08/03   sbs/lt  Added support for Location Services related SS messages
04/29/03   sun     Added new typedef for cc_reject
01/21/03   ws      Updated copyright information for 2003
09/30/02   RI      Added ie_ss_notification_s_type declaration.
08/29/02   PRK     Added "dummy" typedefs for non UMTS targets.
08/15/02   RI      Modified the max. forwarded to number size to be
                   same as that in mn_cm_exp.h
08/12/02   RI      Modified forwarding feature list definition.
                   Added definitions for ECT.
07/29/02   RI      Added definitions for supporting cause of no CLI.
05/07/02   PRK     Renamed to cmwmsg.h.
02/04/02   RI      Initial release.
                   This is a temporary file used by UI, DS and CM only.
                   - translates the data structures defined by the lower
                   layers to the standard API formats at the CM interface.
===========================================================================*/
#if (defined(FEATURE_WCDMA) || defined(FEATURE_GSM) || defined(FEATURE_MM_SUPERSET))
#ifndef mn_cm_exp_h
#define mn_cm_exp_h

#ifndef sys_cnst_h
#define sys_cnst_h
/*===========================================================================
                        COPYRIGHT INFORMATION

Copyright (c) 2001 QUALCOMM, Incorporated and its licensors.  All Rights
Reserved.  QUALCOMM Proprietary.  Export of this technology or software
is regulated by the U.S. Government. Diversion contrary to U.S. law prohibited.

                        EDIT HISTORY FOR MODULE

This section contains comments describing changes made to the module.
Notice that changes are listed in reverse chronological order.

$PVCSPath:  L:/src/asw/MSM5200/nas/vcs/sys_cnst.h_v   1.18   07 May 2002 09:07:00   cdealy  $
$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $    $DateTime: 2009/01/08 04:43:34 $ $Author: cbothsa $

when       who     what, where, why
--------   ---     ----------------------------------------------------------
03/23/01   VT      Added MAX_RAB_ID & DEFAULT_RAB_ID
04/04/01   jca     Corrected Lint errors.
05/03/01   jca     Added PLMN_SIZE.
05/11/01   jca     Added more SIZE constants.
06/11/01   TS      Added GSM build support.
07/18/01   CD      Added MAXNO_INVOKE_IDS
08/14/01   AB      Renamed connection manager reference to CNM from CM.
08/15/01   AB      Renamed all MMI references to CM.
08/21/01   CD      Moved the following items to nas_exp.h
                    MAX_USER_USER_DATA_LENGTH
                    MAXNO_SMS_TRANSACTIONS
                    MAX_COMPONENTS_LENGTH
                    MAX_OCTETS_L3_MESSAGE
                    MAX_SS_PARAMETER_LENGTH
                    MAX_COMPONENTS
                    GSM_CAUSE_SIZE

                   Added nas_exp.h
08/23/01   TS      Moved several defines to nas_exp.h
                    LLC_NORMAL_UNSPECIFIED
                    LLC_CONNNECTION_RELEASE
                    LLC_RADIO_LINK_FAIL
                    LLC_T3230_EXPIRY
                    LLC_AUTHENTICATION_FAILURE
                    LLC_CALL_REJECTED_BY_MM
                    LLC_NETWORK_REJECT_MM_CONN
                    LLC_CNM_SERVICE_REJECT_NORMAL
                    MAX_LENGTH_SMS_DATA

01/25/02    CD     Moved the above definitions back in here
                   since CM/UI no longer needs them

04/19/02    CD     Added definitions for release types used in MMCNM_REL_REQ
                   and MMCNM_REL_IND

04/22/02    CD     Changed value of MAXNO_SMS_TRANSACTIONS form 4 to 7

05/07/02    CD     Changed definitions for CNM-MM release types due to
                   name collision with RR

09/19/02    CD     Added sync reasons to be included in the interface between
                   MM and MN/CNM
09/27/02    CD     Added reject_type_enum, and definitions for AS and MM internal
                   reject causes.
10/16/02    CD     Added reject cause for access class blocking
11/22/02    AB     Added the internal cause base value to the establish reject
                   cause value to differentiate the GSM cause value defined
                   in GSM 4.008 Table 10.86.
11/26/02    jca    Fixed LINT errors.
12/09/02    cd     Added to the sync reason enumeration list
12/10/02    ab     Increased the MAXNO_INVOKE_IDS to MAXNO_SS_TRANSACTIONS to 
                   accomodates SS call related SS transactions.
09/18/03    mks    Merged Kurt's changes to support silent redial feature -
                   Added new cause AS_REJ_LOW_LEVEL_FAIL_REDIAL_NOT_ALLOWED.
08/12/04    ab     Added new MN CNM internal cause value, CNM_MM_REL_PENDING,
                   CNM_MN_NO_RESOURCES.
05/24/05    vdr    Added new AS_REJ_LOW_LEVEL_IMMED_RETRY reject cause
11/02/05    ab     Added values that is used for NV_FORCE_UE_MSCR_R99_I.
01/18/06    up     Updated ue_force_rel_mode_type to move NV_FORCE_UE_REL5 at
                   the end and also NV_REL_MODE_MAX is defined.
03/05/06    NR     Adding changes for WB_AMR
===========================================================================*/

#ifndef nas_exp_h
#define nas_exp_h
/*===========================================================================
                        COPYRIGHT INFORMATION

Copyright (c) 2001 QUALCOMM, Incorporated and its licensors.  All Rights 
Reserved.  QUALCOMM Proprietary.  Export of this technology or software 
is regulated by the U.S. Government. Diversion contrary to U.S. law prohibited.

                        EDIT HISTORY FOR MODULE

This section contains comments describing changes made to the module.
Notice that changes are listed in reverse chronological order.

$PVCSPath:  L:/src/asw/MSM5200/nas/vcs/nas_exp.h_v   1.6   04 Feb 2002 11:55:02   cdealy  $   
$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $    $DateTime: 2009/01/08 04:43:34 $ $Author: cbothsa $

when       who     what, where, why
--------   ---     ----------------------------------------------------------
08/01/01   CD      Initial version
8/15/01    AB      Renamed all MMI references to CM.
08/21/01   CD      Moved the following from sys_type.h
                      cc_state_T
                      CNMServiceType_T
                      hold_auxiliary_state_T
                      mpty_auxiliary_state_T
                      channel_mode_T
                      lower_layer_cause_T
                      ss_state_T

08/21/01   CD      Moved the following items from sys_cnst.h
                    MAX_USER_USER_DATA_LENGTH
                    MAXNO_SMS_TRANSACTIONS
                    MAX_COMPONENTS_LENGTH
                    MAX_OCTETS_L3_MESSAGE
                    MAX_SS_PARAMETER_LENGTH
                    MAX_COMPONENTS
                    GSM_CAUSE_SIZE
08/23/01   TS      Moved the following items from sys_cnst.h
                    LLC_NORMAL_UNSPECIFIED
                    LLC_CONNNECTION_RELEASE
                    LLC_RADIO_LINK_FAIL
                    LLC_T3230_EXPIRY
                    LLC_AUTHENTICATION_FAILURE
                    LLC_CALL_REJECTED_BY_MM
                    LLC_NETWORK_REJECT_MM_CONN
                    LLC_CNM_SERVICE_REJECT_NORMAL
				   Moved the following items from sys_type.h
                    MAX_LENGTH_SMS_DATA

10/22/01   AB      Changed the ss_state_T data type to an enum type for 
                     data security and correctness.

11/01/01   AB      Moved cc_state_T and ss_state_T to cc_state.h.

01/25/02   CD      Moved LLC cause definitions back to sys_cnst.h
                   since CM/UI not longer needs them

===========================================================================*/

#define MAX_USER_USER_DATA_LENGTH             128  /* in TS22.087                */

#endif /* nas_exp_h */

/*
 * remove any pre-existing definition of NULL which is present in some
 * system header files
 */

#ifdef NULL
#undef NULL
#endif


#define NULL 0

/*
 * Definitions for BOOLEAN
 */

#ifndef FALSE
  #define FALSE                             0
#endif

#ifndef TRUE
  #define TRUE                              1
#endif

#define IMSI                              1

/* Connection Management establishment rejection type */
typedef enum
{
   INVALID_REJECT_CAUSE = 0x00,
   OTA_REJECT_CAUSE,
   AS_REJECT_CAUSE,
   MM_REJECT_CAUSE,
   CNM_MN_REJECT_CAUSE
}reject_type_enum_T;

#endif /* sys_cnst_h */
#ifndef sys_type_h
#define sys_type_h

/*===========================================================================
                        COPYRIGHT INFORMATION

Copyright (c) 2001 QUALCOMM, Incorporated and its licensors.  All Rights 
Reserved.  QUALCOMM Proprietary.  Export of this technology or software 
is regulated by the U.S. Government. Diversion contrary to U.S. law prohibited.

                        EDIT HISTORY FOR MODULE

This section contains comments describing changes made to the module.
Notice that changes are listed in reverse chronological order.

$PVCSPath:  L:/src/asw/MSM5200/nas/vcs/sys_type.h_v   1.10   05 Feb 2002 09:42:20   chatlani  $   
$Header: //release/linux-enablement/02.00.08.010.041/target/msm7625/main/api/libs/remote_apis/cm/inc/cm.h#3 $    $DateTime: 2009/01/08 04:43:34 $ $Author: cbothsa $

when       who     what, where, why
--------   ---     ----------------------------------------------------------
01/15/01   JC      Added dBx16_T.
04/04/01   jca     Fixed some Lint errors.
08/01/01   cd      Removed definition of connection_id_T and included nas_exp.h
08/14/01   AB      Renamed connection manager reference to CNM from CM.
08/21/01   CD      Moved the following to nas_exp.h
                      cc_state_T
                      CNMServiceType_T
                      hold_auxiliary_state_T
                      mpty_auxiliary_state_T
                      channel_mode_T
                      lower_layer_cause_T
                      ss_state_T
08/23/01   TS      Moved several types to nas_exp.h
11/21/01   TS      Added sword for GSM lower layer usage.                 
10/09/03   cd      Merged in GSM pref band support				   
09/20/04   ks      Added value INVALID_BAND in sys_band_T
09/22/04   ks      Fixed the missing ',' in sys_band_T enum.
===========================================================================*/

typedef byte                      reject_cause_T;


#endif
#define NULL_SS_OPERATION               0xff

/************************************************************************
*                                                                       *
*               Basic Service Codes                                     *
*                                                                       *
*************************************************************************
*/

#define telephony                         0x11

/* Forward Feature List params, bcd no, = 9 */
#define MAXNO_FORWARD_TO_NUMBER		    (1)

/* ss password values */

typedef enum
{
   enterPW,
   enterNewPW,
   enterNewPW_Again,
   badPW_TryAgain,
   badPW_FormatTryAgain
}ss_password_value;

/* Data length definitions */

#define CM_CALLED_PARTY_BCD_NO_LENGTH       41 
#define CM_CALLED_PARTY_SUBADDRESS_LENGTH   21
#define CM_CALLING_PARTY_BCD_NO_LENGTH      12 
#define CM_CALLING_PARTY_SUBADDRESS_LENGTH  21 
#define CM_CONNECTED_NO_LENGTH              20 
#define CM_CONNECTED_SUBADDRESS_LENGTH      21
#define CM_SUBS_VIOL_EXT_CONTAINER_LENGTH   50

/* SS Misc default setting */

#define MAX_DIAGNOSTICS_LENGTH          27

/* MN specific values for ss errors     */

#define MAX_PWD_CHAR                      4     /* Max num of char in password*/
#define MAX_USS_CHAR                    160     /* Max num of char is USS data*/
#define ACTIVE_CALLS_LIST_SIZE           14     
#define FWD_FEATURE_LIST_SIZE            13
#define CALL_BARRING_LIST_SIZE           13
#define BASIC_SERV_GROUP_LIST_SIZE       13
#define CUG_SUBSCRIPTION_LIST_SIZE       10
#define CUG_FEATURE_LIST_SIZE            13
#define CUG_INDICATOR_SIZE                2
#define CUG_INTERLOCK_SIZE                4
#define LL_COMPATIBILITY_DATA_SIZE       13
#if defined (FEATURE_CCBS) || defined(FEATURE_MM_SUPERSET)
#define MAX_CCBS_FEATURE_LIST_SIZE        5
#endif /* FEATURE_CCBS || FEATURE_MM_SUPERSET*/

/************************************************************************
*                                                                       *
*               Network SS Codes                                        *
*                                                                       *
*    Note:  Only aoci, aocc are used for now                            *
*************************************************************************
*/


typedef struct
{
   boolean                         present;
   byte                            repeat_indication;

} cm_repeat_indicator_T;

/* Ref: 24.008, Sec: 10.5.4.5  Octets 3a, etc., in  Bearer Capability IE */
/* For the definitions of other octets in Bearer Capability IE, see ds_cap.h */

/* Enum for GSM speech versions.  */
typedef enum gsm_speech_ver_e {
    GSM_FR_SPEECH_VER_1 = 0x00, 
    GSM_HR_SPEECH_VER_1 = 0x01,   /* aka HR  */
    GSM_FR_SPEECH_VER_2 = 0x02,   /* aka EFR  */
    GSM_FR_SPEECH_VER_3 = 0x04,   /* aka GSM AMR??  */
    GSM_HR_SPEECH_VER_3 = 0x05,   /* Not used??  */
    GSM_FR_SPEECH_VER_5 = 0x08,   /* FR AMR-WB */
    GSM_INVALID_SPEECH_VER = 0x0e   /* Not specified in 24.008 */
} gsm_speech_ver_e_type;

#if defined (FEATURE_TTY) || defined(FEATURE_MM_SUPERSET)
/* Enum for CTM text telephony indication */
typedef enum ctm_e {
    CTM_NOT_SUPPORTED = 0x00,
    CTM_SUPPORTED = 0x01
} ctm_e_type;
#endif /* FEATURE_TTY || FEATURE_MM_SUPERSET*/


/* bearer Capability */

typedef struct
{
   boolean                         present;

   /* octet 3 */
   byte                            radio_channel_requirement;
   byte                            coding_standard;
   byte                            transfer_mode;
   byte                            information_transfer_capability;

   /* We'll support only 3 speech versions: FR, EFR and AMR  */
   /* octet 3a */
#if defined(FEATURE_TTY) || defined(FEATURE_MM_SUPERSET)
   ctm_e_type                      ctm;
#endif /* FEATURE_TTY || || FEATURE_MM_SUPERSET */

#ifdef FEATURE_GSM_AMR_WB
   /* octet 3e */
   gsm_speech_ver_e_type           gsm_speech_ver_pref_0;
#endif

   gsm_speech_ver_e_type           gsm_speech_ver_pref_1;

   /* octet 3b */
   gsm_speech_ver_e_type           gsm_speech_ver_pref_2;

   /* octet 3c */
   gsm_speech_ver_e_type           gsm_speech_ver_pref_3;

#if defined(FEATURE_GSM_EXT_SPEECH_PREF_LIST) || defined(FEATURE_MM_SUPERSET)
   /* octet 3d */
   gsm_speech_ver_e_type           gsm_speech_ver_pref_4;

   /* octet 3e */
   gsm_speech_ver_e_type           gsm_speech_ver_pref_5;
#endif /* FEATURE_GSM_EXT_SPEECH_PREF_LIST || FEATURE_MM_SUPERSET */ 

   /* octet 4 */
   byte                            compression;
   byte                            structure;
   byte                            duplex_mode;
   byte                            configuration;
   byte                            NIRR;
   byte                            establishment;

   /* octet 5 */
   byte                            access_id;  /* 0 as per 24.008 V3.6.0 */
   byte                            rate_adaption;
   byte                            signalling_access_protocol;

   /* octet 5a */                    
   byte                            other_ITC;
   byte                            other_rate_adaption;

   /* octet 5b */
   byte                            rate_adaption_header;
   byte                            multiple_frame_establishment;
   byte                            mode_of_operation;
   byte                            logical_link_identifier_negotiation;
   byte                            assignor_assignee;
   byte                            inband_outband_negotiation;

   /* octet 6 */
   byte                            layer_1_id;  /* 1 as per 24.008 V3.6.0 */
   byte                            user_information_layer_1_protocol;
   byte                            sync_async;

   /* octet 6a */
   byte                            number_of_stop_bits;
   byte                            negotiation;
   byte                            number_of_data_bits;
   byte                            user_rate;

   /* octet 6b */
   byte                            intermediate_rate;
   byte                            NIC_on_Tx;
   byte                            NIC_on_Rx;
   byte                            parity;

   /* octet 6c */
   byte                            connection_element;
   byte                            modem_type;

   /* These are used for Phase2+ (i.e.14400bd) */
   /* octet 6d */
   byte                            other_modem_type;
   byte                            fixed_network_user_rate;

   /* octet 6e */
   byte                            acceptable_channel_codings;
   byte                            maximum_number_of_trafic_channels;

   /* octet 6f */
   byte                            user_initiated_modification_indication;
   byte                            wanted_air_interface_user_rate;

   /* octet 6g */
   byte                            acceptable_channel_coding_extended;
   byte                            asymmetry_indication; /* EDGE channel coding */

   /* octet 7 */
   byte                            layer_2_id;  /* 2 as per 24.008 V3.6.0 */
   byte                            user_information_layer_2_protocol;

   /* Used only for logging!! */
   byte                            mt_fall_back_rate;
   
} cm_bearer_capability_T;

/* Low Layer Compatibility */

typedef struct
{
   boolean                         present;
   byte                            length;
   byte                            data[LL_COMPATIBILITY_DATA_SIZE];

} cm_low_layer_compatibility_T;

/* High Layer Compatibility */

typedef struct
{
   boolean                         present;
   boolean                         not_applicable;
   byte                            coding_standard;
   byte                            interpretation;
   byte                            presentation_method;
   byte                            high_layer_characteristic_id;
   boolean                         ehlcid_present;
   byte                            extended_high_layer_characteristic_id;

} cm_high_layer_compatibility_T;

/* Called Party BCD Number */

typedef struct
{
   boolean                         present;
   byte                            length;
   byte                            data[CM_CALLED_PARTY_BCD_NO_LENGTH];

} cm_called_party_bcd_no_T;

/* Called Party Subaddress */

typedef struct
{
   boolean                         present;
   byte                            length;
   byte                            data[CM_CALLED_PARTY_SUBADDRESS_LENGTH];

} cm_called_party_subaddress_T;

/* Calling Party BCD Number */

typedef struct
{
   boolean                         present;
   byte                            length;
   byte                            data[CM_CALLING_PARTY_BCD_NO_LENGTH];

} cm_calling_party_bcd_no_T;

/* Calling Party Subaddress */

typedef struct
{
   boolean                         present;
   byte                            length;
   byte                            data[CM_CALLING_PARTY_SUBADDRESS_LENGTH];

} cm_calling_party_subaddress_T;

typedef struct
{
   boolean                         present;
   byte                            msb;
   byte                            lsb;

} ie_cug_index_T;

typedef struct
{
   boolean                         present;
   ie_cug_index_T                  cm_cug_index;
   boolean                         cm_suppress_pref_cug;
   boolean                         cm_suppress_outgoing_access;

} cm_forward_cug_info_T;

typedef enum
{
  NO_CODE = -1,
  BS_CODE,
  TS_CODE,
  MAX_CODE

} bsg_code_type;

typedef struct
{
  boolean         present;
  bsg_code_type   code_type;
  byte            bs_code;

} basic_service_T;

/* no reply condition timer */

typedef struct
{
   boolean                         present;
   byte                            timer_value;

} ie_no_reply_condition_timer_T;

/* ss password */

typedef struct
{
   boolean                       present;
   char                          ss_password[MAX_PWD_CHAR];

} ie_ss_password_T;

typedef struct
{
   boolean                       present;
   byte                          ss_code;

} ie_ss_code_T;

#if defined ( FEATURE_CM_MMGPS ) || defined ( FEATURE_CM_LCS ) || defined(FEATURE_MM_SUPERSET)
typedef enum
{
	PERMISSION_DENIED,
	PERMISSION_GRANTED
} location_notification_res_e_type;

/* LCS Location Notification Response SS data definitions */
typedef struct
{
   boolean                           present;
   location_notification_res_e_type  location_notification_res;
} ie_ss_location_notification_res_T;

/* LCS Location Notification SS data definitions */
typedef enum
{
   NOTIFY_LOCATION_ALLOWED,
   NOTIFY_AND_VERIFY_LCS_ALLOWED_IF_NO_RESPONSE,
   NOTIFY_AND_VERIFY_LCS_NOT_ALLOWED_IF_NO_RESPONSE,
   LOCATION_NOT_ALLOWED,
   NOTIFY_LOCATION_ABORTED
} notification_type_e_type;

typedef enum
{
   CURRENT_LOCATION,
   CURRENT_OR_LAST_KNOWN_LOCATION,
   INITIAL_LOCATION,
   ACTIVATION_DEFERRED_LOCATION,
   CANCEL_DEFERRED_LOCATION
} location_type_e_type;

typedef struct
{
   boolean  present;
   byte     unused_bits;
   byte     ms_available;  
} lcs_deferred_location_type;

typedef struct
{
  byte present;
  byte data[20];
  byte size;
} external_address_T;

typedef struct
{
  byte present;
  external_address_T external_address;
} lcs_client_external_id_T;

typedef struct
{
  byte present;
  byte size;
  byte data[63];
} namestring_T;

typedef struct
{
   byte         present;
   byte         data_coding_scheme;
   namestring_T namestring;
} lcs_client_name_T;

typedef struct 
{
   byte         present;
   byte         data_coding_scheme;
   namestring_T requestorIDString;  
} lcs_requestor_id_T;

typedef struct 
{
   byte         present;
   byte         data_coding_scheme;
   namestring_T lcsCodewordString; 
} lcs_codeword_string_T;

typedef struct
{
   byte         present;
   byte         lcsServiceTypeID;
} lcs_service_type_ID_T;

typedef struct
{
   byte         present;
   byte         mm_cause;
   byte         lower_layer_cause;
} lcs_abort_T;

typedef struct
{
   boolean                     present;
   notification_type_e_type    notification_type;
   location_type_e_type        location_type;
   lcs_deferred_location_type  deferred_location_type;
   lcs_client_external_id_T    external_id;
   lcs_client_name_T           client_name;
   lcs_requestor_id_T          requestor_id;
   lcs_codeword_string_T       codeword_string;
   lcs_service_type_ID_T       service_type;
   lcs_abort_T                 aborted;
} location_notification_T;

typedef enum
{
	LOCATION_ESTIMATE,
	ASSISTANCE_DATA,
	DECIPHERING_KEYS
} molr_type_e_type;

typedef enum
{
	MS_BASED_EOTD,
	MS_ASSISTED_EOTD,
	ASSISTED_GPS
} location_method_e_type;

typedef struct
{
   byte present;
   location_method_e_type data;
} location_method_T;

typedef enum
{
   DELAY_LOW,
   DELAY_TOLERANT
} response_time_category_e_type;

typedef struct
{
   byte present;
   response_time_category_e_type response_time_category;
} response_time_T;

typedef struct
{
   byte present;
   byte data;
} horiz_accuracy_T;

typedef struct
{
   byte present;
} vert_coord_req_T;

typedef struct
{
   byte present;
   byte data;
} vert_accuracy_T;

typedef struct
{
   byte present;
   horiz_accuracy_T horiz_accuracy;
   vert_coord_req_T vertical_coord_req;
   vert_accuracy_T  vertical_accuracy;
   response_time_T  response_time;
} lcs_qos_T;

typedef struct
{
   byte present;
   byte data[38];
   byte size;
} gps_assistance_data_T;

typedef struct
{
   byte present;
   byte data;
} supported_gad_shapes_T;

typedef struct
{
   byte present;
   byte size;
   byte data[9];
} mlc_number_T;

#endif

/* Unstructured ss data definitions */

/* for phase 2 uss messages */
typedef struct
{
   boolean                         present;
   byte                            uss_data_coding_scheme;
   byte                            size;
   byte                            ussData[MAX_USS_CHAR];

} uss_data_T;

typedef struct
{
   boolean                         present;
   byte                            call_barring_cause;

} ie_cm_called_barred_error;

typedef struct
{
   boolean                         present;
   boolean                         cm_ss_operative;
   boolean                         cm_ss_provisioned;
   boolean                         cm_ss_registered;
   boolean                         cm_ss_active;

} ie_ss_status_T;

typedef struct
{
   boolean                         present;
   byte                            option;

} cm_cli_restriction_option_T;

typedef struct
{
   boolean                         present;
   ie_ss_status_T                  cm_ss_status;
   cm_cli_restriction_option_T     cm_cli_restriction_option;

} cli_restriction_info_T;

typedef struct
{
   boolean                         present;
   byte                            value;

} ie_override_category_T;

typedef enum
{
  CLI_DEFAULT_OPTION,
  CLI_RESTRICT_OPTION,
  CLI_OVERRIDE_OPTION,
  CLI_UNKNOWN_OPTION
} cli_option_type;

typedef struct
{
  cli_option_type                  option_type;
  union
  {
    cm_cli_restriction_option_T     clir_restriction_option;
    ie_override_category_T          override_category;
  } option;

} ie_ss_subscription_option_T;

typedef struct 
{
   boolean                         present;
   byte                            size;
   byte                            data[CM_SUBS_VIOL_EXT_CONTAINER_LENGTH];
} ie_ss_subscription_violation_ext_cont_T;

typedef  struct
{
   boolean                         present;
   ie_ss_subscription_option_T     ss_subscription_option;
   ie_ss_subscription_violation_ext_cont_T extension_container;
} ie_cm_subscription_violation;

typedef struct
{
   boolean                         present;
   ie_ss_code_T                    ss_code;
   basic_service_T                 basic_service;
   ie_ss_status_T                  ss_status;

} ie_ss_incompatability_error;

typedef struct
{       
   boolean                         present;
   boolean                         mwd_set;

} ie_absent_subscriber_error;

typedef struct
{
   boolean                         present;
   byte                            network_resource;

} ie_system_failure_error;

typedef struct
{
   boolean                         present;
   byte                            pw_registration_failure_cause;

} ie_pw_registration_failure_error;

#if defined ( FEATURE_CM_MMGPS ) || defined ( FEATURE_CM_LCS ) || defined(FEATURE_MM_SUPERSET)
typedef struct
{
   boolean                         present;
   byte                            position_method_failure_diagnostic;
} ie_position_method_failure_error;
#endif

typedef enum
{
  NO_ERR,
  CALL_BARRED_ERR,
  SUBSCRIPTION_VIOLATION_ERR,
  SS_INCOMPATIBILITY_ERR,
  ABSENT_SUBSCRIBER_ERR,
  SYSTEM_FAILURE_ERR,
  PW_REG_FAILURE_ERR,
#if defined ( FEATURE_CM_MMGPS ) || defined ( FEATURE_CM_LCS ) || defined(FEATURE_MM_SUPERSET)
  POSITION_METHOD_FAILURE_ERR,
#endif
  UNKNOWN_ERR
} ss_error_type;

typedef struct
{
   boolean                             present;
   byte                                error_code_tag;
   byte                                error_code;
   ss_error_type                       error_type;
   union
   {
      ie_cm_called_barred_error        cm_called_barred_error;
      ie_cm_subscription_violation     cm_subscription_violation;
      ie_ss_incompatability_error      cm_ss_incompatability_error;
      ie_absent_subscriber_error       cm_absent_subscriber_error;
      ie_system_failure_error          cm_system_failure_error;
      ie_pw_registration_failure_error cm_pw_registration_failure_error;
#if defined ( FEATURE_CM_MMGPS ) || defined ( FEATURE_CM_LCS ) || defined(FEATURE_MM_SUPERSET)
      ie_position_method_failure_error cm_position_method_failure_error;
#endif
   } parameter;

} ie_cm_ss_error_T;

typedef struct
{
   boolean                         present;
   reject_type_enum_T              rej_type;
   reject_cause_T                  rej_value;
} ie_cm_cc_reject_T;

typedef struct
{
   boolean                         present;
   byte                            coding_standard;
   byte                            location;
   boolean                         recommendation_present;
   byte                            recommendation;
   byte                            cause_value;
   byte                            diagnostic_length;
   byte                            diagnostics[MAX_DIAGNOSTICS_LENGTH];

} ie_cm_cc_cause_T;

typedef enum
{
  FWD_INFO = 1,
  FWD_TO_NUM_INFO,
  FWD_FEATURE_LIST_INFO,
  CALL_BARRING_INFO,
  CLI_RESTRICTION_INFO,
  CALLED_PARTY_NUM_INFO,
  CUG_INFO,
  BSG_LIST_INFO,
  USS_DATA_INFO,
  USSD_DATA_INFO,
  NEW_PWD_INFO,
#if defined ( FEATURE_CM_MMGPS ) || defined ( FEATURE_CM_LCS ) || defined(FEATURE_MM_SUPERSET)
  LCS_MOLR_INFO,
#endif
  SS_DATA_INFO,
  SS_STATUS_INFO,
  SS_ERROR_INFO,
  CC_CAUSE_INFO,
  LL_CAUSE_INFO,
  UNKNOWN_CONF_INFO, 
#if defined (FEATURE_CCBS) || defined(FEATURE_MM_SUPERSET)
  CCBS_INFO,
#endif /* FEATURE_CCBS */
  NO_INFO
} cm_ss_conf_e_type;

/* To hold data for cm_unstructured_ss_res */

typedef struct
{
  cm_ss_conf_e_type                 data_type;
  union
  {
    uss_data_T                 uss_data;
    ie_cm_ss_error_T           cm_ss_error;
  } data;
} uss_res_data_T;

/* connected number  */

typedef  struct
{
   boolean                         present;
   byte                            length;
   byte                            data[CM_CONNECTED_NO_LENGTH];

} cm_connected_no_T;

/* connected subaddress  */

typedef  struct
{
   boolean                         present;
   byte                            length;
   byte                            data[CM_CONNECTED_SUBADDRESS_LENGTH];

} cm_connected_subaddress_T;

typedef struct
{
   boolean                        present;
#if defined (FEATURE_MULTIMEDIA_FALLBACK) || defined(FEATURE_MM_SUPERSET)
   cm_repeat_indicator_T          bc_repeat_indicator;
#endif
   cm_bearer_capability_T         bearer_capability_1;
   cm_bearer_capability_T         bearer_capability_2;

} ie_cm_mo_call_details_T;

typedef struct
{
   byte size;
   byte table[ACTIVE_CALLS_LIST_SIZE];

} active_calls_list_T;

typedef struct
{
   boolean                         present;
   byte                            forwarding_reason;
   boolean                         notification_to_fp;
   boolean                         notification_to_cp;

} ie_forwarding_options_T;

typedef struct
{
   basic_service_T                 basic_service;
   ie_ss_status_T                  ss_status;
   cm_called_party_bcd_no_T        forwarded_to_number[2*MAXNO_FORWARD_TO_NUMBER];  /* x2 = overload long forward number into same structure */ 
   ie_forwarding_options_T         forwarding_options;
   ie_no_reply_condition_timer_T   no_reply_condition_timer;
   cm_called_party_subaddress_T    forwarded_to_subaddress;
} forwarding_feature_T;

typedef struct
{
   boolean                         present;
   byte                            forwarding_feature_list_length;
   forwarding_feature_T            forwarding_feature[FWD_FEATURE_LIST_SIZE];

} ie_forwarding_feature_list_T;

typedef struct
{
   boolean                         present;
   ie_ss_code_T                    cm_ss_code;
   ie_forwarding_feature_list_T    forwarding_feature_list;

} ie_forwarding_info_T;

typedef struct
{
   basic_service_T                 basic_service;
   ie_ss_status_T                  cm_ss_status;

} call_barring_feature_T;

typedef struct
{
   boolean                         present;
   byte                            call_barring_info_length;
   ie_ss_code_T                    cm_ss_code;
   call_barring_feature_T          call_barring_feature_list[CALL_BARRING_LIST_SIZE];

} ie_call_barring_info_T;

/* forward CUG info */

typedef struct
{
   boolean                         present;
   byte                            restrictions;

} ie_inter_cug_restrictions_T;

typedef struct
{
   boolean                         present;
   byte                            cug_indicator[CUG_INDICATOR_SIZE];

} preferential_cug_indicator_T;

typedef struct
{
   boolean                         present;
   basic_service_T                 basic_service;
   preferential_cug_indicator_T    preferential_cug_indicator;
   ie_inter_cug_restrictions_T     inter_cug_restrictions;

} ie_cug_feature_T;

typedef byte    intra_cug_options_T;

typedef struct
{
   boolean                         present;
   byte                            list_length;
   basic_service_T                 list[BASIC_SERV_GROUP_LIST_SIZE];

} basic_service_group_list_T;

typedef struct
{
   boolean                         present;
   byte                            cug_index[CUG_INDICATOR_SIZE];
   byte                            cug_interlock[CUG_INTERLOCK_SIZE];
   intra_cug_options_T             intra_cug_options;
   basic_service_group_list_T      basic_service_group_list;

} ie_cug_subscription_T;

typedef struct
{
   boolean                         present;
   byte                            cug_subscription_list_length;
   ie_cug_subscription_T           cug_subscription_list[CUG_SUBSCRIPTION_LIST_SIZE];
   byte                            cug_feature_list_length;
   ie_cug_feature_T                cug_feature_list[CUG_FEATURE_LIST_SIZE];

} ie_cug_info_T;

typedef struct
{
   boolean                         present;
   byte                            length;
   ie_ss_code_T                    cm_ss_code;
   ie_ss_status_T                  cm_ss_status;
   ie_ss_subscription_option_T     ss_subscription_option;
   basic_service_group_list_T      basic_service_group_list;

} ie_cm_ss_data_T;

typedef struct
{
   boolean                         present;
   byte                            notification;

} ie_ss_notification_T;

typedef enum
{ 
    presentationAllowedAddress,
    presentationRestrictedECT,
    numberNotAvailable,
    presentationRestricteddAdress

}  routing_number_option_T;  /* routing dest number option */

typedef enum 
{
    alerting_ECT, 
    active_ECT 

} ect_call_state_T;

typedef struct
{
    boolean  present; 
    byte     ccbs_Index;

} ie_ccbs_index_T;

typedef struct 
{
    boolean  present;
    ie_ccbs_index_T              ccbsIndex;
#if defined (FEATURE_CCBS) || defined(FEATURE_MM_SUPERSET)
    cm_called_party_bcd_no_T     subscriberNumber[2*MAXNO_FORWARD_TO_NUMBER];
#else
    cm_called_party_bcd_no_T     subscriberNumber[MAXNO_FORWARD_TO_NUMBER];
#endif /* FEATURE_CCBS || FEATURE_MM_SUPERSET */
    cm_called_party_subaddress_T subscriberAddress;
    basic_service_T              basicService;     

} ie_ccbs_indicator_T;
 
#if defined (FEATURE_CCBS) || defined(FEATURE_MM_SUPERSET)
typedef struct
{
   boolean                         present;
   ie_ss_status_T                  cm_ss_status;
   byte                            ccbs_feature_list_length;
   ie_ccbs_indicator_T             ccbs_feature_list[MAX_CCBS_FEATURE_LIST_SIZE];
} ccbs_info_T;
#endif /* FEATURE_CCBS || FEATURE_MM_SUPERSET */


#if defined ( FEATURE_CM_MMGPS ) || defined ( FEATURE_CM_LCS ) || defined(FEATURE_MM_SUPERSET)
typedef struct
{
   byte present;
   byte size;
   byte data[20];
} location_estimate_T;

typedef struct
{
   byte present;
   byte data[15];
} deciphering_keys_T;

typedef struct
{
   byte present;
   byte size;
   byte data[91];
} add_location_estimate_T;

typedef struct
{
   location_estimate_T            location_estimate;
   deciphering_keys_T             deciphering_keys;
   add_location_estimate_T        add_location_estimate;
} lcs_molr_res_data_T;

typedef struct
{
  cm_ss_conf_e_type             data_type;
  union 
  {
    lcs_molr_res_data_T         molr_res_data;
    ie_cm_ss_error_T            cm_ss_error;
    ie_cm_cc_cause_T            cm_cc_cause;
  } data;
} lcs_molr_res_T;

#endif

typedef struct
{
    boolean                        present;
    byte                           cause_value;
} cm_cause_of_no_CLI_T;

/* User to User Signaling */
typedef enum
{
    UUS_DATA = 0,          

    /* Activation Type */
    UUS1_IMPLICIT,    
    UUS1_REQUIRED,    
    UUS1_NOT_REQUIRED,
    UUS2_REQUIRED,
    UUS2_NOT_REQUIRED,
    UUS3_REQUIRED,
    UUS3_NOT_REQUIRED,
    UUS_MAX /*This is a max value included to evade lint error. Do not assign this value*/
} uus_type_T;

typedef struct
{
    boolean        present; /* True or False */
    uus_type_T     user_user_type; /* Implicit or explicit */
    byte           user_user_data_length; /* length of data in user_user_data */
    byte           user_user_protocol_disc;  /* protocol discrimator = data encoded scheme */
    byte           user_user_data [MAX_USER_USER_DATA_LENGTH]; /* Actual user to user data to be sent */
    boolean        more_data_indicator; /* True if more data is going to follow */
} cm_user_data_T;

#endif

typedef cm_user_data_T                   cm_user_data_s_type;
typedef cm_repeat_indicator_T            cm_repeat_indicator_s_type;
typedef cm_bearer_capability_T           cm_bearer_capability_s_type;
typedef cm_low_layer_compatibility_T     cm_low_layer_compatibility_s_type;
typedef cm_high_layer_compatibility_T    cm_high_layer_compatibility_s_type;
typedef cm_called_party_bcd_no_T         cm_called_party_bcd_no_s_type;
typedef cm_called_party_subaddress_T     cm_called_party_subaddress_s_type;
typedef cm_calling_party_bcd_no_T        cm_calling_party_bcd_no_s_type;
typedef cm_calling_party_subaddress_T    cm_calling_party_subaddress_s_type;
typedef cm_forward_cug_info_T            cm_forward_cug_info_s_type;
typedef ie_cm_cc_cause_T                 ie_cm_cc_cause_s_type;
typedef ie_cm_mo_call_details_T          ie_cm_mo_call_details_s_type;
typedef ie_cm_ss_error_T                 ie_cm_ss_error_s_type;
typedef active_calls_list_T              active_calls_list_s_type;
typedef cm_connected_no_T                cm_connected_no_s_type;
typedef cm_connected_subaddress_T        cm_connected_subaddress_s_type;
typedef ie_forwarding_info_T             ie_forwarding_info_s_type;
typedef ie_call_barring_info_T           ie_call_barring_info_s_type;
typedef ie_cug_info_T                    ie_cug_info_s_type;
typedef ie_ss_status_T                   ie_ss_status_s_type;
typedef basic_service_group_list_T       basic_service_group_list_s_type;
typedef ie_forwarding_feature_list_T     ie_forwarding_feature_list_s_type;
typedef cli_restriction_info_T           cli_restriction_info_s_type;
typedef ie_ss_password_T                 ie_ss_password_s_type;
typedef uss_data_T                       uss_data_s_type;
typedef ie_cm_ss_data_T                  ie_cm_ss_data_s_type;
typedef basic_service_T                  basic_service_s_type;
typedef ie_no_reply_condition_timer_T    ie_no_reply_condition_timer_s_type;
typedef ie_ss_code_T                     ie_ss_code_s_type;
typedef uss_res_data_T                   uss_res_data_s_type;
typedef cm_cause_of_no_CLI_T             cm_cause_of_no_cli_s_type;
typedef routing_number_option_T          routing_number_option_s_type;
typedef ect_call_state_T                 ect_call_state_s_type;
typedef ie_ss_notification_T             ie_ss_notification_s_type;
typedef ie_cm_cc_reject_T                ie_cm_cc_reject_s_type;

#if (defined(FEATURE_CM_MMGPS) || defined(FEATURE_CM_LCS) || defined(FEATURE_MM_SUPERSET))
typedef location_method_T                location_method_s_type;
typedef lcs_qos_T                        lcs_qos_s_type;
typedef mlc_number_T                     mlc_number_s_type;
typedef lcs_client_external_id_T         lcs_client_external_id_s_type;
typedef gps_assistance_data_T            gps_assistance_data_s_type;
typedef supported_gad_shapes_T           supported_gad_shapes_s_type;
typedef location_notification_T          location_notification_s_type;
typedef ie_ss_location_notification_res_T ie_ss_location_notification_res_s_type;
typedef lcs_molr_res_T                   lcs_molr_res_s_type;
typedef molr_type_e_type                 cm_molr_type_e_type;

#else
#endif

#if defined(FEATURE_CCBS) || defined(FEATURE_MM_SUPERSET)
typedef ccbs_info_T                      ccbs_info_s_type;
#endif


#else /* #if (defined(FEATURE_WCDMA) || defined(FEATURE_GSM)) */
#endif /* #else (defined(FEATURE_WCDMA) || defined(FEATURE_GSM)) */

#endif /* CMWMSG_H */

/*---------------------------------------------------------------------------
** Defines
**---------------------------------------------------------------------------
*/
  /** CM signal for NV synchronous read by UI in CM thread context */
#define CM_UI_NV_SIG        0x0080
  /* CM signal for NV synchronous read by UI in CM thread context */

  /** Used in cm_sups_unparsed_l3_data_s_type to define the max size of the
  ** L3 message
  ** Clients need to check for CM_SUPS_UNPARSED_L3_DATA before
  ** using this macro.
  */
#define CM_MAX_SUPS_PARAMETER_LENGTH         260

   /**
  ** Alternate Line Service feature default settings (FEATURE_ALS)
  */
#define CM_ALS_DEFAULT_CPHS_SETTING           CM_CPHS_PROC_NOT_ALLOWED

   /**
  ** Alternate Line Service feature default settings (FEATURE_ALS)
  */
#define CM_ALS_DEFAULT_ALS_SETTING            CM_ALS_PROC_NOT_ALLOWED

   /**
  ** Alternate Line Service feature default settings (FEATURE_ALS)
  */
#define CM_ALS_DEFAULT_LINE_SWITCHING         CM_ALS_LINE_SWITCHING_ALLOWED

   /**
  ** Alternate Line Service feature default settings (FEATURE_ALS)
  */
#define CM_ALS_DEFAULT_LINE                   CM_ALS_LINE_01

   /**
  ** No change constant for ph cmd signal delta API
  */
#define CM_SIG_STRENGTH_DELTA_NO_CHANGE        ((uint8)-1)

/*---------------------------------------------------------------------------
** Enums
**---------------------------------------------------------------------------
*/

/** Enumeration of lines supported (FEATURE_ALS)
*/
typedef enum cm_als_line_e {

  CM_ALS_LINE_NONE = -1,
    /**< @internal */

  CM_ALS_LINE_01,
    /**< Line #1 */

  CM_ALS_LINE_02,
    /**< Line #2 */

  CM_ALS_LINE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_ALS_LINE_BIG=0x10000000,
    /**< To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_als_line_e_type;

/** Enumeration of line switching status (FEATURE_ALS)
*/
typedef enum cm_als_line_switching_e {

  CM_ALS_LINE_SWITCHING_NONE = -1,
    /**< @internal */

  CM_ALS_LINE_SWITCHING_NOT_ALLOWED,
    /**< User is not allowed to switch between lines */

  CM_ALS_LINE_SWITCHING_ALLOWED,
    /**< User is allowed to switch between lines */

  CM_ALS_LINE_SWITCHING_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_ALS_LINE_SWITCHING_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_als_line_switching_e_type;

/** Enumeration of CPHS procedures status (FEATURE_ALS)
*/
typedef enum cm_als_cphs_proc_e {

  CM_CPHS_PROC_NONE = -1,
    /**< @internal */

  CM_CPHS_PROC_NOT_ALLOWED,
    /**< CPHS procedures are not supported */

  CM_CPHS_PROC_ALLOWED,
    /**< CPHS procedures are supported */

  CM_ALS_CPHS_PROC_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_ALS_CPHS_PROC_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_cphs_proc_e_type;

/** Enumeration of ALS procedures status (FEATURE_ALS)
*/
typedef enum cm_als_proc_e {

  CM_ALS_PROC_NONE = -1,
    /**< @internal */

  CM_ALS_PROC_NOT_ALLOWED,
    /**< ALS procedures are not supported */

  CM_ALS_PROC_ALLOWED,
    /**< ALS procedures are supported */

  CM_ALS_PROC_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_ALS_PROC_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_als_proc_e_type;

/** This enum stores the various status codes that the MC can send to the
** CM regarding MO DBM messages.
*/
typedef enum cm_dbm_mo_status_e {

  CM_DBM_MO_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_DBM_MO_OK,
    /**< SMS msg has been completed successfully */

  CM_DBM_MO_HOLD_ORIG_RETRY_TIMEOUT,
    /**< HOLD ORIG retry timeout*/

  CM_DBM_MO_HOLD_ORIG,
    /**< MC can not process MO SMS because HOLD ORIG is TRUE*/

  CM_DBM_MO_NO_SRV,
    /**< can not send SMS msg  - no service */

  /* 4 */
  CM_DBM_MO_ABORT,
    /**< MC or CM aborts the SMS request */

  CM_DBM_MO_NOT_ALLOWED_IN_AMPS,
    /**< can not sent SMS msg in analog mode */

  CM_DBM_MO_NOT_ALLOWED_IN_HDR,
    /**< can not send data burst msg while HDR call is up */

  CM_DBM_MO_L2_ACK_FAILURE,
    /**< not receiving L2 ack from base station */

  /* 8 */
  CM_DBM_MO_L3_ACK_FAILURE,
    /**< not receiving L3 ack from base station */

  CM_DBM_MO_OUT_OF_RESOURCES,
    /**< e.g. out of memory buffer */

  CM_DBM_MO_ACCESS_TOO_LARGE,
    /**< message is too large to be sent over access */

  CM_DBM_MO_DTC_TOO_LARGE,
    /**< message is too large to be sent over DTC */

  /* 12 */
  CM_DBM_MO_OTHER,
  /**< any status response other than above */

  CM_DBM_MO_ACCT_BLOCK,
    /**< Access Control based on Call Type(service option)  is blocked */

  CM_DBM_MO_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_DBM_MO_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_dbm_mo_status_e_type;

/** Response to recall indication from network
** Enumeration can be used only if CM_API_CCBS is defined
*/
typedef enum cm_recall_rsp_e {

    CM_RECALL_RSP_CCBS_NONE = -1,

    CM_RECALL_RSP_CCBS_ACCEPT,       /**< Accept the recall */

    CM_RECALL_RSP_CCBS_REJECT,       /**< Reject the recall */

    CM_RECALL_RSP_CCBS_HOLD_ACCEPT,  /**< Hold active calls & accept recall */

    CM_RECALL_RSP_CCBS_REL_ACCEPT,   /**< Rel active calls & accept recall */

    CM_RECALL_RSP_CCBS_MAX

} cm_ccbs_recall_rsp_e_type;

/**  Responses that can be received in 5_send_cnf and recall indication
** Enumeration can be used only if CM_API_CCBS is defined
*/
typedef enum cm_ccbs_cnf_e {

    CM_CCBS_CNF_NONE       = -1,

    CM_CCBS_CNF_RET_RES,   /**< CCBS specific information present */

    CM_CCBS_CNF_RET_ERR,   /**< SS error */

    CM_CCBS_CNF_REJ,       /**< SS request rejected */

    CM_CCBS_CNF_RECALL_IND, /**< recall indicaton for CCBS call */

    CM_CCBS_CNF_MAX

} cm_ccbs_cnf_e_type;

/** Enums for the power collapse functionality
** enum to indicate which processor the clients are executing
*/

typedef enum cm_processor_e {

  CM_PROCESSOR_NONE   = -1,

  CM_PROCESSOR_MODEM,  /**< The client is executing on the modem processor */

  CM_PROCESSOR_APPS_1, /**< The client is executing on the APPS processor  */

  CM_PROCESSOR_MAX
} cm_processor_e_type;

/** Enum to indicate the event notification preferences while in power
** collapse
*/

typedef enum cm_pwr_collapse_notify_e {

  CM_PWR_COLLAPSE_NOTIFY_NULL = -1,

  CM_PWR_COLLAPSE_NOTIFY_NONE,   /**< Do not notify anything in powersave */

  CM_PWR_COLLAPSE_NOTIFY_NORMAL, /**< Notify all the events in power save */

  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT, /**< Notify the default "important
                                            ** events" as defined by CM
                                            */

  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM, /**< Notify the "important events"
                                           ** as defined by clients
                                           */
  CM_PWR_COLLAPSE_NOTIFY_MAX

} cm_pwr_collapse_notify_e_type;

/*---------------------------------------------------------------------------
** Datatypes
**---------------------------------------------------------------------------
*/

typedef int   cm_client_id_type;
  /**< Client ID type to differentiate CM client objects from one another */

typedef uint8 cm_call_id_type;
  /**< Data type for call id */

typedef uint8 cm_npi_type;
  /**<
  ** Data type for number presentation indicator.
  ** Values are defined by CM_PRESENTATION_XXX.
  */

typedef uint8 cm_si_type;
  /**<
  ** Data type for screening indicator.
  ** Values are defined by CM_USER_PROVIDED_XXX.
  */

typedef uint8 cm_ccbs_indx_type;
  /**<
  ** Data type for ccbs index
  ** Can be used only if CM_API_CCBS is defined
  */

typedef uint64 cm_call_type_mask_type;
  /**<
  ** Data type to carry bit masks of call types.
  ** CM_CALL_TYPE_x_MASK are the defines that
  ** go with this type.
  **
  ** Clients needs to check for CM_API_VIDEOSHARE
  ** before using this type
  */

typedef uint32 cm_emerg_srv_categ_type;
  /**< Data type for emergency service category */


/*---------------------------------------------------------------------------
** Defines
**---------------------------------------------------------------------------
*/

#define CM_CALL_CMD_PARAM_DEFAULT_VALUE      0
  /**< Init value for all call command parameter buffer */

#define CM_CALL_EVENT_DEFAULT_FIELD_VALUE    CM_CALL_CMD_PARAM_DEFAULT_VALUE
  /**< Initial init value for all call event fields */


/** Define number of simulteneous called allowed:
** - For CDMA only build, 8 for SVD, 1 otherwise
** - For GSM/WCDMA or Multimode, 8 always.
*/
#define CM_CALL_ID_MAX              ( 6 + SYS_MAX_PDP_CONTEXTS )
  /**< Maximum number of simulteneous calls allowed.
  ** CDMA: voice/test voice, data/test data, SMS, GPS, OTASP, OTAPA
  ** GW: 6 voice + N ps */

#define CM_CALL_ID_INVALID          ((cm_call_id_type) 0xFF)
  /**< Invalid call id */

#define CM_CALL_ID_UNASSIGNED       ((cm_call_id_type) 0xFE)
  /**< Call id unknown at this time */

#define CM_CALL_ID_ALL_CALLS        ((cm_call_id_type) 0xFD)
  /**< Applies to all calls. Call id is not necessary */

#define CM_CALL_ID_NONE             ((cm_call_id_type) 0xFC)
  /**< @internal No call id */

#define CM_MAX_DIALED_DIGITS  36
  /**<
  ** Max length of dialed digit string.
  ** This should be same as NV_MAX_DIAL_DIGITS
  ** This is hardcoded here to
  ** eliminate dependency on nv.h for remote processors.
  */

/*
** Subaddress values
*/

#define CM_MAX_SUBADDRESS_DIGITS   21
  /**< Max length of subaddress digit string */

#define CM_SUBADDRESS_TYPE_NSAP     0
  /**< Subaddress type - NSAP (CCITT X.213 / ISO 8348 AD2) */

#define CM_SUBADDRESS_TYPE_USER     1
  /**< Subaddress type - User specified */

#define CM_SUBADDRESS_EO_IND_EVEN   0
  /**< Even number of address signals */

#define CM_SUBADDRESS_EO_IND_ODD    1
  /**< Odd number of address signals  */


#define CM_MAX_CALLER_ID_CHARS      32
  /**< Max length of Caller ID string */

#if (defined(FEATURE_GSM) || defined(FEATURE_WCDMA))
#define CM_MAX_CALLED_INFO_CHARS    81
  /**< 3GPP spec 24.008 (Rel 5) section 10.5.4.7 specifices
  ** called party BCD number to 40 BCD digits  (80 bytes).
  ** UI can supply CM with "+" in the begining (1  byte).
  ** for international numbers
  ** CAUTION: x increase in value of INFO_CHARS increases
  ** call obj by close to 8x times.
  */
#else
#define CM_MAX_CALLED_INFO_CHARS    65
#endif

#define CM_MAX_CONNECTED_NUM_CHARS  64
  /**< Max length of Connected num string. CM_MAX_DATA_DIGITS */

#define CM_MAX_NUMBER_CHARS         CM_MAX_CALLED_INFO_CHARS
  /**< Max length of CM number string
  ** This is the Maximum of CM_MAX_DIALED_DIGITS, CM_MAX_CALLER_ID_CHARS
  ** CM_MAX_CALLED_INFO_CHARS and CM_MAX_CALLED_INFO_CHARS */

#define CM_MAX_ALPHA_LEN_FOR_CALL_ORIG      90
  /*< Max number of characters for alpha tag on call origination.
  ** Size being increased to support SIM related GCF test cases
  ** where a string upto size 90 can be required to be displayed
  ** on the UE.
  */

#define CM_MAX_ALPHA_LEN_FOR_DISPLAY_INFO   90
  /*< CM_MAX_DATA_DIGITS
  ** Same reason as for CM_MAX_ALPHA_LEN_FOR_CALL_ORIG. Call events
  ** deliver alpha string to UI and so they need to carry as much
  ** as origination can give.
  */

#define CM_MAX_ALPHA_TAG_CHARS      CM_MAX_ALPHA_LEN_FOR_DISPLAY_INFO
  /**< Max length of CM alpha tag string.
  ** This is the maximum of CM_MAX_ALPHA_LEN_FOR_CALL_ORIG and
  ** CM_MAX_ALPHA_LEN_FOR_DISPLAY_INFO */

#define CM_MAX_ALPHA_TAG_BYTES      (CM_MAX_ALPHA_TAG_CHARS)
  /*< Max length of CM alpha tag string in bytes.
  ** This is taken to be same as CM_MAX_ALPHA_TAG_CHARS
  ** assuming that it is such a coding scheme
  */

#define CM_ORIG_QOS_LEN_MAX         31
  /**< Max lenght of Quality of Service buffer.
  ** Should be same as CAI_ORIG_QOS_LEN_MAX */

/* The following constants are used for GSM/WCDMA.
*/

#define CM_EXTENSION_BIT           0x80
  /**< Indicates octet 3a of the BCD number IE
      (calling party/called party/redirecting party information element)
  */

/** Presentation Indicator */
#define CM_PRESENTATION_IND_MASK   0x60
  /**< Presentation indicator  (octet 3a) */

/** Bits 7-6 for presentation indicator */
#define CM_PRESENTATION_ALLOWED    0x00
  /**< Presentation allowed */

#define CM_PRESENTATION_RESTRICTED 0x01
  /**< Presentation restricted */

#define CM_NUMBER_NOT_AVAILABLE    0x02
  /**< Number not available due to interworking */

/** Screening Indicator */
#define CM_SCREENING_IND_MASK       0x03
  /**< Screening indicator (octet 3a) */

/** Bits 2-1 */
#define CM_USER_PROVIDED_NOT_SCRND  0
  /**< User-provided, not screened */

#define CM_USER_PROVIDED_VER_PASSED 0x01
  /**< User-provided, verified and passed */

#define CM_USER_PROVIDED_VER_FAILED 0x02
  /**< User-provided, verified and failed */

#define CM_NETWORK_PROVIDED         0x03
  /**< Network provided */

/* type of number
*/
#define CM_TON_MASK                 0x70
/**< type of number  (octet 3) */

/** Bits 7-5 */
#define CM_TON_UNKNOWN              (0x00 << 4)
  /**< Unknown */

#define CM_TON_INTERNATIONAL        (0x01 << 4)
  /**< International number */

#define CM_TON_NATIONAL             (0x02 << 4)
  /**< National number */

#define CM_TON_NETWORK_SPECIFIC     (0x03 << 4)
  /**< Network specific number */

#define CM_TON_DEDICATED_ACCESS     (0x04 << 4)
  /**< Dedicated access, short code */

#define CM_TON_RESERVED_5           (0x05 << 4)
  /**< Reserved */

#define CM_TON_RESERVED_6           (0x06 << 4)
  /**< Reserved */

#define CM_TON_RESERVED_EXTENSION   (0x07 << 4)
  /**< Reserved for extension */

/* Numbering Plan Identification
*/
#define CM_NUM_PLAN_MASK            0x0F
  /**< Numbering Plan Identification (octet 3) */

#define CM_NPI_UNKNOWN              0x00
  /**< Unknown */

#define CM_NPI_ISDN                 0x01
  /**< ISDN/telephony numbering plan */

#define CM_NPI_DATA                 0x03
  /**< Data numbering plan */

#define CM_NPI_TELEX                0x04
  /**< Telex numbering plan */

#define CM_NPI_NATIONAL             0x08
  /**< National numbering plan */

#define CM_NPI_PRIVATE              0x09
  /**< Private numbering plan */

#define CM_NPI_RESERVED_CTS         0x0b
  /**< Reserved for CTS */

#define CM_NPI_RESERVED_EXTENSION   0x0f
  /**< Reserved for extension */

#define CM_MAX_CCP_LEN              14

#define CM_MAX_SEARCH_LIST_LENGTH   10
  /**< Max length of search list */

#define CM_RP_USER_DATA_TPDU_LENGTH 232
  /**< Max lenght of RP user data */

#define CM_NAS_MN_TPDU_SIZE         164
  /**< Max size of MN TPDU size */

#define CM_NAS_CB_DATA_PAGE_SIZE    88

#define CM_SMS_ADDRESS_MAX          32

#define CM_SMS_MAX_LEN              255

#define CM_USSD_ALPHABET_MASK       0x0F
  /*< MASK used to decide on USSD Data coding scheme *
  ** Clients need to check for CM_API_USSD_DCS before
  ** using this macro
  */

#define CM_CCBS_INDX_INVALID       ((uint8) 0xFF)
  /**< Invalid ccbs indx
  ** can be used only if CM_API_CCBS is defined
  */


#define CM_MAX_CCBS_REQ            5  /* see 24.093 fig 4.5.3 NOTE */
  /**< Max total of CCBS indexes possible
  ** Should be the same as MAX_CCBS_FEATURE_LIST_SIZE in mn_cm_exp.h
  ** Not using "#define CM_MAX_CCBS_REQ MAX_CCBS_FEATURE_LIST_SIZE"
  ** because then it has to be featurized under GSM.
  ** can be used only if CM_API_CCBS is defined
  */

#if (defined(FEATURE_GSM) || defined(FEATURE_WCDMA))
#define CM_MAX_EMERGENCY_NUM_COUNT 16
#else
#define CM_MAX_EMERGENCY_NUM_COUNT 1
#endif

 /**< Clients need to check for CM_API_EMERGENCY_NUM_LIST before
 **   using
 **
 ** Should be the same as CM_MAX_EMERGENCY_NO_COUNT in reg_cm.h.
 **
 ** Emergency list IE is max of 50 bytes. One byte of IEI and one byte of
 ** List Length leaves with max of 48 bytes. Each individual emergency number
 ** will have one byte of length indicator, one byte of type indicator
 ** (if number is Hospital or Police etc.) and at least one byte of BCD
 ** digits for the emergency number. This means that each individual emergency
 ** number will take at least 3 bytes. Therefore, max number of emergency
 ** numbers that can be sent by network in this IE is 48/3 = 16.
 */


#define CM_CALLED_PARTY_BCD_WITH_BCD_LEN  CM_CALLED_PARTY_BCD_NO_LENGTH + 1
  /**< To be used when passing bcd buffer to
  **  cm_util_number_to_bcd() or cm_util_bcd_to_ascii(). Function
  **  puts BCD length in the same array and so need that extra
  **  byte.
  **
  ** Clients needs to check for CM_API_ECATEG_IN_NUM_STRUCT before
  ** using this field.
  */

/*-------------------------------------------------------------------------*/
/*
** Clients needs to check for CM_API_VIDEOSHARE
** before using following #defines
*/

#define CM_IPAPP_HOST_SIZE                  20
  /**< Size of host name generating ip warning
  **
  ** CAUTION: x increase in HOST_SIZE increases
  ** cm_cmd_s_type by CM_CALL_ID_MAX * x times.
  ** end_params field
  */

#define CM_IPAPP_TEXT_SIZE                  20
  /**< Size of warning text generatedn from ipapp
  **
  ** CAUTION: x increase in TEXT_SIZE increases
  ** cm_cmd_s_type by CM_CALL_ID_MAX * x times.
  ** end_params field
  */

#define CM_MAX_OCTETS_L3_MESSAGE           251  /**< max size of L3 message
                                                ** as defined in 04.06 sect
                                                ** 5.8.5
                                                */

/**< Bit masks of fundamental call types. Combination of these can be generated
** by using ADD_CALL_TYPE_MASK
*/

#define CM_CALL_TYPE_NONE_MASK    ((cm_call_type_mask_type)0)
  /* Bit mask for call type none */

#define CM_CALL_TYPE_VOICE_MASK   (cm_call_type_mask_type) SYS_BM_64BIT(CM_CALL_TYPE_VOICE)
  /**< Bit mask for voice call type */

#define CM_CALL_TYPE_VT_MASK      (cm_call_type_mask_type) SYS_BM_64BIT(CM_CALL_TYPE_VT)
  /**< Bit mask for VT call type */

#define CM_CALL_TYPE_VS_MASK      (cm_call_type_mask_type) SYS_BM_64BIT(CM_CALL_TYPE_VS)
  /**< Bit mask for VS call type */

#define CM_CALL_TYPE_SMS_MASK     (cm_call_type_mask_type) SYS_BM_64BIT(CM_CALL_TYPE_SMS)
  /**< Bit mask for SMS call type */

#define ADD_CALL_TYPE_MASK(CALL_TYPE1,CALL_TYPE2)  (cm_call_type_mask_type) (((uint64)CALL_TYPE1) | ((uint64)CALL_TYPE2))
  /**< Utility to create combination of call type capabilites */


/** Enumeration of call commands client are able to send to CM.
*/
typedef enum cm_call_cmd_e {

  CM_CALL_CMD_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_CALL_CMD_ORIG,
    /**< Originate a call */

  CM_CALL_CMD_ANSWER,
    /**< Answer an incoming call */

  CM_CALL_CMD_END,
    /**< End a call in orig, incom or conv state */

  CM_CALL_CMD_SUPS,
    /**< Send a call related supplementary service command
    ** eg: In CDMA, this is a FLASH command with information
    **     In WCDMA/GSM this may be a 1 SEND command to
    **     release the active call and accept the waiting call
    */

  /* 4 */
  CM_CALL_CMD_PRIVACY_PREF,
    /**< Change privacy pref for CDMA*/

  CM_CALL_CMD_INFO_GET,
    /**< Get a sanpshot of the call information in the CM */

  CM_CALL_CMD_INFO_LIST_GET,
    /**< Get a snapshot of call information for all calls in the CM */

  CM_CALL_CMD_SETUP_RES,
    /**< Response to a setup message for WCDMA/GSM/IP Voice App*/

  /* 8 */
  CM_CALL_CMD_PDP_ACT_RES,
    /**< Response to a PDP activation request for WCDMA/GSM PS*/

  CM_CALL_CMD_PDP_MODIFY,
    /**< cmd to modify a PDP for WCDMA/GSM PS */

  CM_CALL_CMD_RAB_REESTAB,
    /**< cmd to reetablish a RAB for WCDMA/GSM PS*/

  CM_CALL_CMD_PS_DATA_AVAILABLE,
    /**< cmd to inform protocol stack that data is available */
    /* for transmission                                    */

  /* 12 */
  CM_CALL_CMD_CC_COMPLETE_REORIG,
    /**< cmd to inform CM that call control is complete */
    /**< @internal */

  CM_CALL_CMD_UMTS_CDMA_HANDOVER_REQ,
    /**< Request to handoff UMTS call to 1x. */

  CM_CALL_CMD_UMTS_CDMA_HANDOVER_CNF,
    /**< Status confirmation for UMTS->1x handover. */

  CM_CALL_CMD_RECALL_RSP,
    /**<
    ** Client response to recall indication from network.
    */

  /* 16 */
  CM_CALL_CMD_MO_MODIFY_REQ,
    /**<
    ** Client request to modify call type
    */

  CM_CALL_CMD_MODIFY_RES,
    /**<
    ** Client response to modify request from network
    */

  CM_CALL_CMD_HANDOVER_REQ,
    /**<
     ** Generic handoff request
    */

  CM_CALL_CMD_PS_SIG_REL,
    /**<
    ** Command to request CM to release PS signaling
    */

  CM_CALL_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_cmd_e_type;

/** Enumeration of call command errors returned by call command
** callback functions.
*/
typedef enum cm_call_cmd_err_e {

  CM_CALL_CMD_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_CALL_CMD_ERR_NOERR,
    /**< No errors found */

  /* Error codes resulting from clients feeding a call command
  ** function with bad or inappropriate parameters.
  */

  CM_CALL_CMD_ERR_CLIENT_ID_P,
    /**< invalid client ID - null or not initialized*/

  CM_CALL_CMD_ERR_CALL_ID_P,
    /**< invalid call ID in the command */

  CM_CALL_CMD_ERR_NUM_CALL_IDS_P,
    /**< Number of call Ids specified exceeds the maximum
    ** number of call IDs allocated
    */

  /* 4 */
  CM_CALL_CMD_ERR_CALL_TYPE_P,
    /**< Bad call type parameter */

  CM_CALL_CMD_ERR_SRV_TYPE_P,
    /**< Bad service type parameter */

  CM_CALL_CMD_ERR_SRV_OPT_P,
    /**< Bad service option parameter. CDMA only */

  CM_CALL_CMD_ERR_MODE_PREF_P,
    /**< Requested call type cannot be made in current mode preference */

  /* 8 */
  CM_CALL_CMD_ERR_NO_NUM_P,
    /**< Expecting a number to be provided via the number parameter */

  CM_CALL_CMD_ERR_NULL_NUM_P,
    /**< Number length is > 0, but number buffer points to NULL */

  CM_CALL_CMD_ERR_NUM_P,
    /**< Invalid digits found in number buffer */

  CM_CALL_CMD_ERR_NUM_LEN_P,
    /**< Out of range value found in number length field */

  /* 12 */
  CM_CALL_CMD_ERR_NULL_ALPHA_P,
    /**< Alpha length is > 0, but alpha buffer points to NULL */

  CM_CALL_CMD_ERR_ALPHA_LEN_P,                                     /* 10 */
    /* Out of range value found in alpha length field */

  CM_CALL_CMD_ERR_MISMATCH_P,
    /**< Call type and parameter type do not match. GW only */

  CM_CALL_CMD_ERR_NULL_PARAM_P,
    /**< NULL pointer paramter in the API */

  /* 16 */
  CM_CALL_CMD_ERR_ACTIVATE_CODE_P,
    /**< Invalid OTASP activation code. CDMA only */

  CM_CALL_CMD_ERR_CALL_SUPS_P,
    /**< Invalid call related supplementary service parameter */

  CM_CALL_CMD_ERR_QOS_LEN_P,
    /**< Length of QOS parameters exceed maximum size */

  CM_CALL_CMD_ERR_LAST_ACT_DATA_NET_P,
    /**< Invalid last active data network */

  /* 20 */
  CM_CALL_CMD_ERR_INVALID_PRIMARY_CALL_ID_P,
  /**< OBSOLETE with definition of CM_API_SEC_PDP */
  /* The primary PDP context's call Id is invalid.
  ** Sent during a secondary PDP context origination and
  ** the specified primary PDP context is not valid
  */


  CM_CALL_CMD_ERR_INVALID_GROUP_ID_P,
    /**< Clients check CM_API_SEC_PDP for SEC PDP support.
    ** Sent during a secondary PDP context origination if
    ** the specified group id is not valid
    */

  CM_CALL_CMD_ERR_PROFILE_NUMBER_IN_USE_P,
    /**< The profile is already in use by another
    ** PDP context
    */

  CM_CALL_CMD_ERR_UMTS_CDMA_HANDOVER_REQ_P,
    /**< Error in parameter for UMTS ->1x handover cnf.
    */

  /* 24 */
  CM_CALL_CMD_ERR_UMTS_CDMA_HANDOVER_CNF_P,
    /**< Error in parameter for UMTS ->1x handover cnf.
    */

  /* Error codes resulting from clients trying to instruct
  ** CM to perform inappropriate actions relative to the current
  ** state of the call and/or phone.
  */

  CM_CALL_CMD_ERR_OFFLINE_S,
    /**< Phone is offline */

  CM_CALL_CMD_ERR_CDMA_LOCK_S,
    /**< Phone is CDMA locked */

  CM_CALL_CMD_ERR_FLASH_S,
    /**< Client tried to send a flash while a call that not supporting
    ** flashes is in progress. CDMA only */

  /* 28 */
  CM_CALL_CMD_ERR_ORIG_RES_S,
    /**< Dialed number is not allowed under the current origination
    ** restriction */

  CM_CALL_CMD_ERR_NO_FUNDS_S,
    /**< Dialed number is not allowed because phone is out of funds. GW only */

  CM_CALL_CMD_ERR_EMERGENCY_MODE_S,
    /**< Client tried to originate a NONE EMERGENCY call while EMERGENCY mode
    ** preference is in effect. CDMA only */

  CM_CALL_CMD_ERR_IN_USE_S,
    /**< Can't perform the command in question while phone is in-use */

  /* 32 */
  CM_CALL_CMD_ERR_SRV_TYPE_S,
    /**< Client originated with service type that is currently not
    ** supported by the phone/PRL */

  CM_CALL_CMD_ERR_CALL_TYPE_S,
    /**< The command in question is invalid for the call(s) in progress.
    ** e.g. Client answered with inappropriate call type relative to
    ** to the type of the incoming call, etc. */

  CM_CALL_CMD_ERR_CALL_STATE_S,
    /**< The command in question is invalid in the current call state -
    ** e.g. answering a call that was already answered,
    ** ending a call that was already ended, etc. */

  CM_CALL_CMD_ERR_SRV_STATE_S,
    /**< The command in question is invalid in the current Phone serving state-
    ** e.g answering a call but serving state is no service */

  /* 36 */
  CM_CALL_CMD_ERR_NO_SO_S,
    /**< no valid service found for origination with AUTOMATIC
    ** or CDMA_AUTOMATIC srv type. CDMA only  */

  CM_CALL_CMD_ERR_ALERT_ANS_BYPASS_S,
    /**< Client is not allowed to answer the incoming call. CDMA only
    ** Valid for FEATURE_IS95B_ALERT_ANS_BYPASS */

  CM_CALL_CMD_ERR_UIM_NOT_PRESENT_S,
    /**< UIM not present. Valid for FEATURE_UIM_RUIM */

  CM_CALL_CMD_ERR_BAD_PRIVACY_PREF_S,
    /**< Invalid privacy preference. CDMA only */

  /* 40 */
  CM_CALL_CMD_ERR_NO_CALL_ID_S,
    /**< No call IDs can be allocated */

  CM_CALL_CMD_ERR_CALL_ORIG_FAIL_S,
    /**< Call origination failed in the lower layer */

  CM_CALL_CMD_ERR_INVALID_MODE_S,
    /**< Recieved the command in a mode different from the phone's
    ** operational mode
    */

  CM_CALL_CMD_ERR_INVALID_SIM_STATE_S,
    /**< Call origination failed because the SIM was marked
    ** by the network as invalid for the circuit and/or
    ** packet service domain.
    */

  /* 44 */
  CM_CALL_CMD_ERR_MAX_PRIMARY_PDP_CONTEXTS_S,
    /**< The maximum number of primary PDP contexts have been activated */

  CM_CALL_CMD_ERR_MAX_SEC_PDP_CONTEXT_PER_PRI_S,
    /**< The maximum number of secondary PDP contexts
    ** has been reached for this primary PDP context
    */

  CM_CALL_CMD_ERR_NO_COLLOC_HDR,
    /**< There is no clocated HDR */

  /* Error codes resulting from operational limitation
  ** of CM.
  */

  CM_CALL_CMD_ERR_NO_BUF_L,
    /**< No available CM command buffers to queue the command */

  /* 48 */
  CM_CALL_CMD_ERR_MC_COM_L,
    /**< Communication problems with MC - e.g. MC buffer shortage */

  CM_CALL_CMD_ERR_OTHER,
    /**< A problem other than the above was found */

  CM_CALL_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  CM_CALL_CMD_ERR_CALL_CONTROL_REJECTED,
    /**< Call control has rejected the command. */

  /* 52 */
  CM_CALL_CMD_ERR_FAVORED_MODE_PREF_FOR_ORIGINATION,
    /**< CM was not able to determine favored mode preference for origination
       for given call type, service type and current mode preference */

  CM_CALL_CMD_ERR_CONNECTION_ID_OUT_L,
    /**< CM was not able to get a connection Id from MN or SM */

  CM_CALL_CMD_ERR_SUPS_SRV_ON_PROHIBITED_LINE_S,
    /**<
    ** FEATURE_ALS
    ** Supplementary services are not allowed
    ** for calls that are on prohibited line.
    ** Prohibited line is one that is different than currently
    ** selected line when line switching is not allowed.
    */

  CM_CALL_CMD_ERR_USER_DATA_LENGTH_P,
    /**<
    ** FEATURE_UUS
    ** Invalid user data length parameter
    */

  /* 56 */
  CM_CALL_CMD_ERR_NON_NEGOT_BEARER_P,
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE definition
    ** before using this enum
    **
    ** When call gets connected bearer capabilities that both parties
    ** can support are negotiatied and stored in call object. MO Call
    ** modification request gets rejected by CM if bearer for new type
    ** requested has not been neogitiated during call set up. GSM WCDMA only.
    */

  CM_CALL_CMD_ERR_INVALID_BC_P,
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE definition
    ** before using this enum
    **
    ** Set up response to MT call setup indication should carry a valid
    ** BC in BC1 if there is a valid BC in BC2. GSM WCDMA only.
    **
    */

  CM_CALL_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_cmd_err_e_type;

/** Enumeration of call events.
** Clients are able to register with CM to be notified of any subsets
** of these events.
*/
typedef enum cm_call_event_e {

  CM_CALL_EVENT_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_CALL_EVENT_ORIG,
    /**< phone originated a call */

  CM_CALL_EVENT_ANSWER,
    /**< Incoming call was answered */

  CM_CALL_EVENT_END_REQ,
    /**< Started call end process */

  CM_CALL_EVENT_END,
    /**< Originated/incoming call was ended */

  CM_CALL_EVENT_SUPS,
    /**< phone sent Flash / Flash with Info to BS */

  /* 5 */
  CM_CALL_EVENT_INCOM,
    /**< phone received an incoming call */

  CM_CALL_EVENT_CONNECT,
    /**< Originated/incoming call was connected */

  CM_CALL_EVENT_SRV_OPT,
    /**< Service option changed while in a call. CDMA only */

  CM_CALL_EVENT_PRIVACY,
    /**< Privacy mode changed while in a call. CDMA only */

  CM_CALL_EVENT_PRIVACY_PREF,
    /**< Privacy mode preference changed */

  /* 10 */
  CM_CALL_EVENT_CALLER_ID,
    /**< Caller ID info was received from BS. CDMA only */

  CM_CALL_EVENT_ABRV_ALERT,
    /**< CMDA/AMPS abbreviated alert. CDMA only */

  CM_CALL_EVENT_ABRV_REORDER,
    /**< AMPS abbreviated reorder. CDMA only */

  CM_CALL_EVENT_ABRV_INTERCEPT,
    /**< AMPS abbreviated intercept. CDMA only */

  CM_CALL_EVENT_SIGNAL,
    /**< signal info was received from BS */

  /* 15 */
  CM_CALL_EVENT_DISPLAY,
    /**< display info was received from BS. CDMA only */

  CM_CALL_EVENT_CALLED_PARTY,
    /**< called party info was received from BS. CDMA only */

  CM_CALL_EVENT_CONNECTED_NUM,
    /**< connected number info was received from BS */

  CM_CALL_EVENT_INFO,
    /**< call information, this event only sent to the client
    ** that request this information through cm_call_cmd_get_call_info */

  CM_CALL_EVENT_EXT_DISP,
    /**< extended display was received from BS. CDMA only */

  /* 20 */
  CM_CALL_EVENT_NDSS_START,
    /**< Start NDSS redirection. CDMA only */

  CM_CALL_EVENT_NDSS_CONNECT,
    /**< call was re-connected due to NDSS. CDMA only */

  /* The following are for FEATURE_JCDMA
  */

  CM_CALL_EVENT_EXT_BRST_INTL,
    /**< Extended Burst Type - International */

  CM_CALL_EVENT_NSS_CLIR_REC,
    /**< National Supplementary services - CLIR */

  CM_CALL_EVENT_NSS_REL_REC,
    /**< National Supplementary services - Release */

  /* 25 */
  CM_CALL_EVENT_NSS_AUD_CTRL,
    /**< National Supplementary services - Audio Control */

  CM_CALL_EVENT_L2ACK_CALL_HOLD,
    /**< Call Hold */

  /* The following are for WCDMA/GSM
  ** Except CM_CALL_EVENT_SETUP_RES which is also used by IP APP
  */

  CM_CALL_EVENT_SETUP_IND,
    /**< phone received a setup ind message from BS*/

  CM_CALL_EVENT_SETUP_RES,
    /**< A setup response was sent, used also for IP call */

  CM_CALL_EVENT_CALL_CONF,
    /**< The call origination has been accepted*/

  /* The following are for WCDMA/GSM  PS Data
  */

  /* 30 */
  CM_CALL_EVENT_PDP_ACTIVATE_IND,
    /**< phone received Incoming PDP call  */

  CM_CALL_EVENT_PDP_ACTIVATE_RES,
    /**< A response to incoming PDP was sent */

  CM_CALL_EVENT_PDP_MODIFY_REQ,
    /**< PDP modify request was sent */

  CM_CALL_EVENT_PDP_MODIFY_IND,
    /**< phone received a PDP modify indication from BS*/

  CM_CALL_EVENT_PDP_MODIFY_REJ,
    /**< phone received a PDP modify rejection from BS*/

  /* 35 */
  CM_CALL_EVENT_PDP_MODIFY_CONF,
    /**< phone received a PDP modify confirmation from BS*/

  CM_CALL_EVENT_RAB_REL_IND,
    /**< phone received a RAB release indication from BS*/

  CM_CALL_EVENT_RAB_REESTAB_IND,
    /**< phone received a RAB reestablish indication from BS*/

  CM_CALL_EVENT_RAB_REESTAB_REQ,
    /**< RAB reestablish request was sent */

  CM_CALL_EVENT_RAB_REESTAB_CONF,
    /**< phone received a RAB reestablish confirm from BS*/

  /* 40 */
  CM_CALL_EVENT_RAB_REESTAB_REJ,
    /**< phone received a RAB reestablish reject from BS*/

  CM_CALL_EVENT_RAB_REESTAB_FAIL,
    /**< RAB reestablishment failed */

  CM_CALL_EVENT_PS_DATA_AVAILABLE,
    /**< PS data available reqeust was sent */

  CM_CALL_EVENT_MNG_CALLS_CONF,
    /**< confirmation for mpty calls */

  CM_CALL_EVENT_CALL_BARRED,
    /**< call barred notification */

  /* 45 */
  CM_CALL_EVENT_CALL_IS_WAITING,
    /**< call is in waiting notification */

  CM_CALL_EVENT_CALL_ON_HOLD,
    /**< call on hold notification */

  CM_CALL_EVENT_CALL_RETRIEVED,
    /**< call retrieved notification */

  CM_CALL_EVENT_ORIG_FWD_STATUS,
    /**< Originated call may be forwarded notification to
       forwarding subscriber
    */
  CM_CALL_EVENT_CALL_FORWARDED,
    /**< call forwarded notification to forwarding subscriber*/

  /* 50 */
  CM_CALL_EVENT_CALL_BEING_FORWARDED,
    /**< call being forwarded notification to calling subsciber */

  CM_CALL_EVENT_INCOM_FWD_CALL,
    /**< Incoming forwarded call notification to
       forwarded-to-subscriber
    */
  CM_CALL_EVENT_CALL_RESTRICTED,
    /**< call restricted notification */

  CM_CALL_EVENT_CUG_INFO_RECEIVED,
    /**< call forward CUG notification */

  CM_CALL_EVENT_CNAP_INFO_RECEIVED,
    /**< caller name info notification */

  /* 55 */
  CM_CALL_EVENT_EMERGENCY_FLASHED,
    /**< A voice call was converted into emergency call */

  CM_CALL_EVENT_PROGRESS_INFO_IND,
    /**< call origination progress indication */

  CM_CALL_EVENT_CALL_DEFLECTION,
    /**< Call deflection notification */

  CM_CALL_EVENT_TRANSFERRED_CALL,
    /**< Call transfer notification */

  CM_CALL_EVENT_EXIT_TC,
    /**< A traffic channel has been torn down. CDMA only */

  /* 60 */
  CM_CALL_EVENT_REDIRECTING_NUMBER,
    /**< Redirecting Number Info Record Event. CDMA only */

  CM_CALL_EVENT_PDP_PROMOTE_IND,
    /**< OBSOLETE with definition of CM_API_SEC_PDP */
    /* Clients check CM_API_SEC_PDP for SEC PDP support
    ** Secondary context being promoted to primary
    */

  CM_CALL_EVENT_UMTS_CDMA_HANDOVER_START,
    /**< An event to initiate the UMTS to 1X handoff */

  CM_CALL_EVENT_UMTS_CDMA_HANDOVER_END,
    /**< An event to indicate the UMTS to 1X handoff is completed.*/

  CM_CALL_EVENT_SECONDARY_MSM,
    /**< Invoke event call back even if the event is from secondary MSM.
    ** CM will not generate any events with this, but is used by
    ** thin client CM layer to call client call backs for events from
    ** secondary msm.
    */

  /* 65 */
  CM_CALL_EVENT_ORIG_MOD_TO_SS,
    /**< An Origination command was modified to SS due to Call Control */

  CM_CALL_EVENT_USER_DATA_IND,
    /**< Clients need to check for CM_API_USER_USER_DATA before
    ** using this event. Indicates user data from remote side
    */

  CM_CALL_EVENT_USER_DATA_CONG_IND,
    /**< Clients need to check for CM_API_USER_USER_DATA before
    ** using this event. Indication from lower layers to stop
    ** sending user data
    */

  CM_CALL_EVENT_MODIFY_IND,
    /**< This event is applicable when CM_API_VT is defined.
    ** Network requested modification of VT to Voice and vice-versa.
    */

  CM_CALL_EVENT_MODIFY_REQ,
    /**< This event is applicable when CM_API_VT is defined.
    ** Request to do modification of VT to Voice and vice-versa is sent.
    */

  /* 70 */
  CM_CALL_EVENT_LINE_CTRL,
    /**< This event is sent when CM_LINE_CTRL_F report is received from
    ** the lower layers {1X only}.
    */

  CM_CALL_EVENT_CCBS_ALLOWED,
    /**< Clients need to check for CM_API_CCBS before
    ** using this event. Informs that CCBS is allowed
    ** on this call.
    */

  CM_CALL_EVENT_ACT_CCBS_CNF,
    /**< Clients need to check for CM_API_CCBS before
    ** using this event.
    ** Sent after CM_5_SEND_CNF is received from network
    */

  CM_CALL_EVENT_CCBS_RECALL_IND,
    /**< Clients need to check for CM_API_CCBS before
    ** using this event.
    ** Sent in response to CM_RECALL_IND from Network
    */

  CM_CALL_EVENT_CCBS_RECALL_RSP,
    /**< Clients need to check for CM_API_CCBS before
    ** using this event.
    ** Sent after receiving recall response from client
    */


  /* 75 */
  CM_CALL_EVENT_CALL_ORIG_THR,
    /**< Call origination throttled
    */

  CM_CALL_EVENT_VS_AVAIL,
    /**< Clients should check for CM_API_VIDEOSHARE before using
    ** this event.
    ** Videoshare call is possible for this voice call
    */

  CM_CALL_EVENT_VS_NOT_AVAIL,
    /**< Clients should check for CM_API_VIDEOSHARE before using
    ** this event.
    ** Videoshare call is not possible for this voice call
    */

  CM_CALL_EVENT_MODIFY_COMPLETE_CONF,
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE before
    ** using this event.
    ** Event sent after in-call modification confirmation has been
    ** received by CM.
    */

  CM_CALL_EVENT_MODIFY_RES,
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE before
    ** using this event.
    ** Event sent to indicate client's response to MT in-call modification
    ** indication.
    */

  /* 80 */
  CM_CALL_EVENT_CONNECT_ORDER_ACK,
    /**< Clients need to  check for CM_API_CONNECT_ORDER_ACK before
    ** using this event.
    ** Event sent to indicate client's response to user answered the call.
    */

  CM_CALL_EVENT_TUNNEL_MSG,
    /**< Got a tunneled message for the call
    */

  CM_CALL_EVENT_END_VOIP_CALL,
    /**< Event to end the voip call
    */

  CM_CALL_EVENT_VOIP_CALL_END_CNF,
    /**< Event to confirm voip call end
    */
  /* 84 */
  CM_CALL_EVENT_PS_SIG_REL_REQ,
   /**< Started PS Signaling release process
   */

  /* 85 */
  CM_CALL_EVENT_PS_SIG_REL_CNF,
   /**< Event to notify PS Signaling release confirmation
   */

  CM_CALL_EVENT_HANDOFF_CALL_ORIG,
    /**<  HOM originated call
    */

    /* 87 */
  CM_CALL_EVENT_HANDOFF_CALL_CONNECT,
    /**<  HOM originated / incoming call was connected
    */

  CM_CALL_EVENT_HANDOFF_CALL_END,
    /**<  HOM originated / incoming call was ended
    */

  CM_CALL_EVENT_HANDOFF_MANUAL_CALL_ORIG,
    /**<  Manually originated / incoming call.
    */

    /* 90 */
  CM_CALL_EVENT_MPTY_CALL_IND,
    /**<  multiparty call indication.
    */

    /* 91 */
  CM_CALL_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_event_e_type;

typedef enum cm_redirecting_reason_e {

  CM_REDIRECTING_REASON_NONE = -1,
    /**< @internal */

  CM_REDIRECTING_REASON_UNKNOWN = 0,
    /**< Unknown */

  CM_REDIRECTING_REASON_CALL_FORWARDING_BUSY = 1,
    /**< Call forwarding busy or called DTE busy */

  CM_REDIRECTING_REASON_CALL_FORWARDING_NO_REPLY = 2,
    /**< Call forwarding no reply (circuit-mode only) */

  CM_REDIRECTING_REASON_CALLED_DTE_OUT_OF_ORDER = 9,
    /**< Called DTE out of order (packet-mode only) */

  CM_REDIRECTING_REASON_CALL_FORWARDING_BY_THE_CALLED_DTE = 10,
    /**< Call forwarding by the called DTE (packet-mode only) */

  CM_REDIRECTING_REASON_CALL_FORWARDING_UNCONDITIONAL = 15,
    /**< Call forwarding unconditional or Systematic call redirection */

  CM_REDIRECTING_REASON_RESERVED,
    /**< Reserved */

  CM_REDIRECTING_REASON_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_REDIRECTING_REASON_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

}cm_redirecting_reason_e_type;

/* mapping the old band name to the new enumeration */
#define CM_ABAND      CM_ACTIVATE_CODE_BC0_ABAND
#define CM_BBAND      CM_ACTIVATE_CODE_BC0_BBAND
#define CM_ABLOCK     CM_ACTIVATE_CODE_BC1_ABLOCK
#define CM_BBLOCK     CM_ACTIVATE_CODE_BC1_BBLOCK
#define CM_CBLOCK     CM_ACTIVATE_CODE_BC1_CBLOCK
#define CM_DBLOCK     CM_ACTIVATE_CODE_BC1_DBLOCK
#define CM_EBLOCK     CM_ACTIVATE_CODE_BC1_EBLOCK
#define CM_FBLOCK     CM_ACTIVATE_CODE_BC1_FBLOCK

/**< OTASP activation code. For CDMA only.
*/
typedef enum cm_activate_code_e {
  CM_ACTIVATE_CODE_BC0_ABAND = 0,
  /**< Band Class 0, A band */

  CM_ACTIVATE_CODE_BC0_BBAND = 1,
  /**< Band Class 0, B band */

  CM_ACTIVATE_CODE_BC1_ABLOCK = 2,
  /**< Band Class 1, A block */

  CM_ACTIVATE_CODE_BC1_BBLOCK = 3,
  /**< Band Class 1, B block */

  CM_ACTIVATE_CODE_BC1_CBLOCK = 4,
  /**< Band Class 1, C block */

  CM_ACTIVATE_CODE_BC1_DBLOCK = 5,
  /**< Band Class 1, D block */

  CM_ACTIVATE_CODE_BC1_EBLOCK = 6,
  /**< Band Class 1, E block */

  CM_ACTIVATE_CODE_BC1_FBLOCK = 7,
  /**< Band Class 1, F block */

  /* Band Class 2 and 3 are not supportd */

  CM_ACTIVATE_CODE_BC4_ABAND = 12,
  /**< Band Class 4, A Band */

  CM_ACTIVATE_CODE_BC4_BBAND = 13,
  /**< Band Class 4, B Band */

  CM_ACTIVATE_CODE_BC4_CBAND = 14,
  /**< Band Class 4, C Band */

  CM_ACTIVATE_CODE_BC5_ABAND = 15,
  /**< Band Class 5, A Band */

  CM_ACTIVATE_CODE_BC5_BBAND = 16,
  /**< Band Class 5, B Band */

  CM_ACTIVATE_CODE_BC5_CBAND = 17,
  /**< Band Class 5, C Band */

  CM_ACTIVATE_CODE_BC5_DBAND = 18,
  /**< Band Class 5, D Band */

  CM_ACTIVATE_CODE_BC5_EBAND = 19,
  /**< Band Class 5, E Band */

  CM_ACTIVATE_CODE_BC5_FBAND = 20,
  /**< Band Class 5, F Band */

  CM_ACTIVATE_CODE_BC5_GBAND = 21,
  /**< Band Class 5, G Band */

  CM_ACTIVATE_CODE_BC5_HBAND = 22,
  /**< Band Class 5, H Band */

  CM_ACTIVATE_CODE_BC6 = 23,
  /**< Band Class 6 */

  /* Band Class 7, A Band and B Band are not supported */

  CM_ACTIVATE_CODE_BC7_CBAND = 26,
  /**< Band Class 7, C Band */

  CM_ACTIVATE_CODE_BC7_DBAND = 27,
  /**< Band Class 7, D Band */

  CM_ACTIVATE_CODE_BC8 = 28,
  /**< Band Class 8 */

  CM_ACTIVATE_CODE_BC9 = 29,
  /**< Band Class 9 */

  CM_ACTIVATE_CODE_BC10_ABAND = 30,
  /**< Band Class 10, A Band */

  CM_ACTIVATE_CODE_BC10_BBAND = 31,
  /**< Band Clas 10, B Band */

  CM_ACTIVATE_CODE_BC10_CBAND = 32,
  /**< Band Class 10, C Band */

  CM_ACTIVATE_CODE_BC10_DBAND = 33,
  /**< Band Class 10, D Band */

  CM_ACTIVATE_CODE_BC10_EBAND = 34,
  /**< Band Class 10, E Band */

  CM_ACTIVATE_CODE_BC11_ABAND = 35,
  /**< Band Class 11, A Band */

  CM_ACTIVATE_CODE_BC11_BBAND = 36,
  /**< Band Class 11, B Band */

  CM_ACTIVATE_CODE_BC11_CBAND = 37,
  /**< Band Class 11, C Band */

  CM_ACTIVATE_CODE_BC11_DBAND = 38,

  CM_ACTIVATE_CODE_BC11_EBAND = 39,

  CM_ACTIVATE_CODE_BC11_FBAND = 40,
  /**< Band Class 11, F Band */

  CM_ACTIVATE_CODE_BC12_ABAND = 41,
  /**< Band Class 12, A Band */

  CM_ACTIVATE_CODE_BC12_BBAND = 42,
  /**< Band Class 12, B Band */

  /* Band Class 14, A Block to F Block has the same activation code
  ** and the same frequency as Band Class 1.
  ** So we'll use Band Class 1 for it.
  */

  CM_ACTIVATE_CODE_BC14_GBLOCK = 57,
  /**< Band Class 14, G Block */

  CM_ACTIVATE_CODE_BC15_ABAND = 58,
  /**< Band Class 15, A Band */

  CM_ACTIVATE_CODE_BC15_BBAND = 59,
  /**< Band Class 15, B Band */

  CM_ACTIVATE_CODE_BC15_CBAND = 60,
  /**< Band Class 15, C Band */

  CM_ACTIVATE_CODE_BC15_DBAND = 61,
  /**< Band Class 15, D Band */

  CM_ACTIVATE_CODE_BC15_EBAND = 62,
  /**< Band Class 15, E Band */

  CM_ACTIVATE_CODE_BC15_FBAND = 63,
  /**< Band Class 15, F Band */

  CM_ACTIVATE_CODE_BC16_ABAND = 64,
  /**< Band Class 16, A Band */

  CM_ACTIVATE_CODE_BC16_BBAND = 65,
  /**< Band Class 16, B Band */

  CM_ACTIVATE_CODE_BC16_CBAND = 66,
  /**< Band Class 16, C Band */

  CM_ACTIVATE_CODE_BC16_DBAND = 67,
  /**< Band Class 16, D Band */

  /* Activation code 68 - 99 is reserved */

  CM_PREFERRED  = 100,
  /**< Used Internally
  ** PREFFERRED is currently mapped to BC1 A Block.
  ** This is only used for non-standard otasp call
  */

  CM_OTASP_ACT_CODE_NONE = 101
  /**< None */

  #ifdef FEATURE_RPC
  , CM_OTASP_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_activate_code_e_type;

/** Enumeration of call states. At all times a CM call must be in one
** of the states below.
*/
typedef enum cm_call_state_e {

  CM_CALL_STATE_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_CALL_STATE_IDLE,
    /**< Call is in idle state - i.e. no call */

  CM_CALL_STATE_ORIG,
    /**< Call is in origination state */

  CM_CALL_STATE_INCOM,
    /**< Call is in alerting state */

  CM_CALL_STATE_CONV,
    /**< Call is in conversation state */

  /* 4 */
  CM_CALL_STATE_CC_IN_PROGRESS,
    /**< Call is originating but waiting for call control to complete */

  CM_CALL_STATE_RECALL_RSP_PEND,
    /**< Call is waiting for recall response from client
    */

  CM_CALL_STATE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_STATE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_state_e_type;

/** Enumeration of CM call types.
** When originating or answering a call, clients need to specify
** one of these call types.
**
** For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_call_type_e {

  CM_CALL_TYPE_NONE=-1,
    /**< @internal */

  CM_CALL_TYPE_VOICE=0,
    /**< Voice call type.
    **
    ** NOTE! Answering with this type is only successful if the
    ** incoming call is of type VOICE */

  CM_CALL_TYPE_CS_DATA=1,
    /**< CS Data call type - (for modem, fax, etc. calls).
    **
    ** NOTE! Answering with this call is only successful if the
    ** incoming call is of type DATA or VOICE (with AMPS service) */

  CM_CALL_TYPE_PS_DATA=2,
    /**< Packet Switched Data call type */

  CM_CALL_TYPE_SMS=3,
    /**< SMS call type (SMS SO-6 and SO-14). CDMA only
    **
    ** NOTE! Answering with this call type is only successful
    ** if incoming call is of type SMS */

  CM_CALL_TYPE_PD=4,
    /**< Position Determination call type (SO-35 and 36). CDMA only
    ** This call type used to exchange IS-801 messages.
    */

  CM_CALL_TYPE_TEST=5,
    /**< Test call type (for Markov, Loopback, etc.). CDMA only
    **
    ** NOTE! Answering with this call type is only successful
    ** if incoming call is of type TEST */

  CM_CALL_TYPE_OTAPA=6,
    /**< OTAPA call type (OTAPA SO-18 and SO-19). CDMA only
    **
    ** NOTE! Answering with this call type is only successful
    ** if incoming call is of type OTAPA */

  /* Call types that are automatically assigned by call manager when
  ** detecting an origination dial-string that matches one of the
  ** special numbers that are stored in the phone-book.
  **
  ** NOTE! This call types should not be used to originate
  ** or answer calls.
  */

  CM_CALL_TYPE_STD_OTASP=7,
    /**< Standard OTASP call type. CDMA only
    **
    ** This call type is automatically assigned by call manager when
    ** detecting an origination dial-string that matches one of the
    ** standard OTASP numbers that are stored in the phone-book.
    **
    ** NOTE! This call type should not be used to originate
    ** or answer calls */

  CM_CALL_TYPE_NON_STD_OTASP=8,
    /**< None standard OTASP call type. CDMA only
    **
    ** This call type is automatically assigned by call manager when
    ** detecting an origination dial-string that matches one of the none
    ** standard OTASP numbers that are stored in the phone-book.
    **
    ** NOTE! This call type should not be used to originate
    ** or answer calls */

  CM_CALL_TYPE_EMERGENCY=9,
    /**< Emergency call type.
    **
    ** This call type is automatically assigned by call manager when
    ** detecting an origination dial-string that matches one of the
    ** EMERGENCY numbers that are stored in the phone-book.
    **
    ** This call type can be used by Clients also to originate calls.
    **
    ** NOTE! If call manager assigned this call type, the mode
    ** preference is forced to EMERGENCY before origination. If at the
    ** end of the call the phone is not in EMERGENCY callback mode,
    ** the mode is automatically restored to its original selection.
    ** Else the EMERGENCY mode stays in effect until changed by a client
    ** or power-cycle */

  CM_CALL_TYPE_SUPS=10,
    /**< A supplementary services command is in progress.
    ** The call type here is to facilatate call control where a sups
    ** command can be turned into a voce call or vice versa.
    */

  CM_CALL_TYPE_VT=11,
    /**< Video Telephony Call Type. Currently applicable for GSM/WCDMA only.
    */

  CM_CALL_TYPE_VT_LOOPBACK,
    /**< Video Telephony Loopback Call Type.
    ** Currently applicable for GSM/WCDMA only.
    */

  CM_CALL_TYPE_VS,
    /**< Clients should check for CM_API_VIDEOSHARE before using
    ** this call type
    **
    ** Used for Video Share calls. Differs from VT in the sense that voice
    ** does not have to be synced with video and generally it is transmitted
    ** only ine one direction from user A to B.
    */


  CM_CALL_TYPE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_TYPE_BIG=0x10000000 /* To force enum to 32 bit for windowsNT */
  #endif /* FEATURE_RPC */

} cm_call_type_e_type;

/**
** Call processing layer failure (1X)
** Call processing layer where the call failed during origination.
** CM_CALL_ORIG_ERR_LAYER_OTHER is lower layer failure than
** CM_CALL_ORIG_ERR_LAYER_L2 and CM_CALL_ORIG_ERR_LAYER_L2 is
** lower layer failure than CM_CALL_ORIG_ERR_LAYER_L3
*/
typedef enum {
  CM_CALL_ORIG_ERR_LAYER_NONE = -1,                      /**< CM internal  */
  CM_CALL_ORIG_ERR_LAYER_OTHER,    /**< Internal failure or rejected by BS */
  CM_CALL_ORIG_ERR_LAYER_L2,                             /**< L2 failure   */
  CM_CALL_ORIG_ERR_LAYER_L3,                             /**< L3 failure   */
  CM_CALL_ORIG_ERR_LAYER_MAX                             /**< CM internal  */
} cm_call_orig_fail_layer_e_type;

/** Enumeration of service types.
**
** When originating a call, clients need to specify
** one of these service types.
**
** For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_srv_type_e {

  CM_SRV_TYPE_NONE = -1,
    /**< @internal */

  CM_SRV_TYPE_AMPS=0,
    /**< Call is to be connected over analog service.
    **
    ** Note that the client does NOT need to specify service option when
    ** originating with this call type.
    **
    ** NOTE! When originating with this service type, the mode preference
    ** might be forced to ANALOG ONLY before origination and returned to
    ** its original setting at the end of the call */

  CM_SRV_TYPE_HDR=1,
    /**< Call is to be connected over HDR service.
    ** Valid for FEATURE_HDR */

  CM_SRV_TYPE_CDMA_SPECIFIC=2,
    /**< Call is to be connected over CDMA service with specific client
    ** designated CDMA service option.
    **
    ** Note that the client need to specify service option when
    ** originating with this call type.
    **
    ** NOTE! When originating with this service type, the mode preference
    ** might be forced to DIGITAL ONLY before origination and returned to
    ** its original setting at the end of the call */

  CM_SRV_TYPE_CDMA_AUTOMATIC=3,
    /**< Call is to be connected over CDMA service where CM automatically
    ** originate with the best available service option for the specified
    ** call type.
    **
    ** Note that the client does NOT need to specify service option when
    ** originating with this call type */

  CM_SRV_TYPE_AUTOMATIC=4,
    /**< Call is to be connected over available service - AMPS or CDMA,
    ** or GSM or WCDMA or HDR.
    **
    ** Note that the client does NOT need to specify service option when
    ** originating with this srv type except for the packet data call*/

  CM_SRV_TYPE_CDMA_HDR=5,
    /**< Call is to be connected over available service - CDMA or HDR.
    **
    ** Note that the client need to specify service option when
    ** originating with this srv type for CDMA. */

  CM_SRV_TYPE_GSM_WCDMA=6,
    /**< Call is to be connected over available service - GSM or WCDMA */

  CM_SRV_TYPE_WCDMA=7,
    /**< Call is to be connected over WCDMA service */

  CM_SRV_TYPE_GSM=8,
    /**< Call is to be connected over GSM service */

  CM_SRV_TYPE_WLAN=9,
    /**< Call is to be connected over WLAN service */

  CM_SRV_TYPE_NON_AUTOMATIC=10,
    /**< Service type is non automatic */
    /**< @internal */

  CM_SRV_TYPE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SRV_TYPE_BIG=0x10000000
      /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_srv_type_e_type;

/** Enumeration of call end statuses
** - i.e. the reason for ending a call.
**
** For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_call_end_e {

  CM_CALL_END_NONE                         = -1,
    /**< @internal */

  /* Common
  */
  CM_CALL_END_OFFLINE                      = 0,
    /**< phone is offline */

  /* CDMA
  */
  CM_CALL_END_CDMA_LOCK                    = 20,
    /**< phone is CDMA locked until power cycle. CDMA only */

  CM_CALL_END_NO_SRV                       = 21,
    /**< phone has no service. */
    /* Backwards compatibility -- NO_CDMA_SRV & NO_GW_SRV mapped to this */

  CM_CALL_END_FADE                         = 22,
    /**< Call has ended abnormally. CDMA only */

  CM_CALL_END_INTERCEPT                    = 23,
    /**< received intercept from BS - orig only. CDMA only */

  CM_CALL_END_REORDER                      = 24,
    /**< received reorder from BS - orig only. CDMA only */

  CM_CALL_END_REL_NORMAL                   = 25,
    /**< received release from BS - no reason given. */

  CM_CALL_END_REL_SO_REJ                   = 26,
    /**< received release from BS - SO reject. CDMA only */

  CM_CALL_END_INCOM_CALL                   = 27,
    /**< received incoming call from BS */

  CM_CALL_END_ALERT_STOP                   = 28,
    /**< received alert stop from BS - incom only. CDMA only */

  CM_CALL_END_CLIENT_END                   = 29,
    /**< client ended the call */

  CM_CALL_END_ACTIVATION                   = 30,
    /**< received end activation - OTASP call only. CDMA only */

  CM_CALL_END_MC_ABORT                     = 31,
    /**< MC aborts the origination/conversation. CDMA only */

  CM_CALL_END_MAX_ACCESS_PROBE             = 32,
    /**< Max access probes transmitted. CDMA only */

  CM_CALL_END_PSIST_NG                     = 33,
    /**< Persistence test failure. FEATURE_JCDMA only. CDMA only */

  CM_CALL_END_UIM_NOT_PRESENT              = 34,
    /**< RUIM is not present */

  CM_CALL_END_ACC_IN_PROG                  = 35,
    /**< Access attempt already in progress. */

  CM_CALL_END_ACC_FAIL                     = 36,
    /**< Access failure for reason other than the above */

  CM_CALL_END_RETRY_ORDER                  = 37,
    /**< Received retry order - orig only. IS-2000. CDMA only */

  CM_CALL_END_CCS_NOT_SUPPORTED_BY_BS      = 38,
    /**< Concurrent servive is not supported by base station */

  CM_CALL_END_NO_RESPONSE_FROM_BS          = 39,
    /**< No response recived from base station */

  CM_CALL_END_REJECTED_BY_BS               = 40,
    /**< Call rejected by the base station. CDMA only */

  CM_CALL_END_INCOMPATIBLE                 = 41,
    /**< Concurrent services requested were not compatible. CDMA only */

  CM_CALL_END_ACCESS_BLOCK                 = 42,
    /**< Access is blocked by base station. CDMA only */

  CM_CALL_END_ALREADY_IN_TC                = 43,
    /**< Corresponds to CM_CALL_ORIG_ERR_ALREADY_IN_TC */

  CM_CALL_END_EMERGENCY_FLASHED            = 44,
    /**< Call is ended due to Emergency call is flashed over this call. CDMA only */

  CM_CALL_END_USER_CALL_ORIG_DURING_GPS    = 45,
    /**< Used if CM is ending a GPS call in favor of a user call */

  CM_CALL_END_USER_CALL_ORIG_DURING_SMS    = 46,
    /**< Used if CM is ending a SMS call in favor of a user call */

  CM_CALL_END_USER_CALL_ORIG_DURING_DATA   = 47,
    /**< Used if CM is ending a DATA call in favor of an emergency call */

  CM_CALL_END_REDIR_OR_HANDOFF             = 48,
    /**< Call rejected because of redirection or handoff */

  CM_CALL_END_ACCESS_BLOCK_ALL             = 49,
    /**< Access is blocked by base station for all mobiles. KDDI specific. CDMA only */

  CM_CALL_END_OTASP_SPC_ERR                = 50,
    /**< To Support OTASP SPC Error indication */


  /* GSM/WCDMA
  */
  CM_CALL_END_LL_CAUSE                     = 100,
    /**< rxd a reason from lower layer,look in cc_cause. WCDMA/GSM only*/

  CM_CALL_END_CONF_FAILED,
    /**< call orig request failed. WCDMA/GSM only */

  CM_CALL_END_INCOM_REJ,
    /**< client rejected the incoming call. WCDMA/GSM only */

  CM_CALL_END_SETUP_REJ,
    /**< client rejected the setup_ind. WCDMA/GSM only */

  /* 104 */
  CM_CALL_END_NETWORK_END,
    /**< network ended the call,look in cc_cause. WCDMA/GSM only*/

  CM_CALL_END_NO_FUNDS,
    /**< GSM/WCDMA only */

  CM_CALL_END_NO_GW_SRV,
    /**< GWM/WCDMA only.  Phone has no service */

  CM_CALL_END_NO_CDMA_SRV,
    /**< 1x only.  Phone has no service */

  /* 108 */
  CM_CALL_END_NO_FULL_SRV,
    /**< Full srv unavailable. */

  CM_CALL_END_MAX_PS_CALLS,
    /**< Indicates resources not available to handle
    ** new MO/MT PS call
    */

  /* HDR
  */
  CM_CALL_END_CD_GEN_OR_BUSY               = 150,
    /**< abort connection setup due to the reception of a ConnectionDeny msg
    ** with deny code = general or network busy */

  CM_CALL_END_CD_BILL_OR_AUTH              = 151,
    /**< abort connection setup due to the reception of a ConnectionDeny msg
    ** with deny code = billing or authentication failure */

  CM_CALL_END_CHG_HDR                      = 152,
    /**< change HDR system due to redirection or PRL not preferred */

  CM_CALL_END_EXIT_HDR                     = 153,
    /**< exit HDR  due to redirection or PRL not preferred */

  CM_CALL_END_HDR_NO_SESSION               = 154,
    /**< no HDR session  */

  CM_CALL_END_CM_COLLOC_ACQ_FAIL           = 155,
    /**< only for internal CM use -Fail to acquire collocated HDR for
    ** origination*/

  CM_CALL_END_HDR_ORIG_DURING_GPS_FIX      = 156,
    /**< Used if CM is ending a HDR call orig in favor of GPS fix */

  CM_CALL_END_HDR_CS_TIMEOUT               = 157,
    /**< connection setup timeout*/

  CM_CALL_END_HDR_RELEASED_BY_CM,
    /**< CM released HDR call so 1X call can continue */

  CM_CALL_END_HOLD_DBM_IN_PROG,
    /**< CM will hold the HDR origination to allow 1X SMS to end */

  /* 160 */
  CM_CALL_END_OTASP_COMMIT_IN_PROG,

  CM_CALL_END_NO_HYBR_HDR_SRV,
    /**< Mobile has no Hybrid HDR service. */

  CM_CALL_END_HDR_NO_LOCK_GRANTED,
    /**< Call ended because HDR didn't get the RF Lock. */

  CM_CALL_END_HOLD_OTHER_IN_PROG,
    /**< CM will hold the the current call to allow other call to end */

  /* Following Call Release reason are specific to VideoTelephony Call.
  */

  CM_CALL_END_VIDEO_CONN_LOST              = 301,
    /**< modem released the call after the modem had been connected */

  CM_CALL_END_VIDEO_SETUP_FAILURE          = 302,
    /**< call setup failed while trying to setup the modem */

  CM_CALL_END_VIDEO_PROTOCOL_CLOSED        = 303,
    /**< video protocol closed after the video protocol setup was done */

  CM_CALL_END_VIDEO_PROTOCOL_SETUP_FAILURE = 304,
    /**< video protocol setup failed */

  CM_CALL_END_INTERNAL_ERROR,
    /**< CM internal error other than any of the above */

  /* WLAN
  */

  CM_CALL_END_NO_WLAN_SRV                  = 200,

  CM_CALL_END_VOIP_FAIL_WLAN               = 201,
    /**< VOIP failed on WLAN */

  CM_CALL_END_IP_FAIL                      = 202,
    /**< To be used only when CM_API_IP_CALL is defined
    ** Call origination on IP Failed
    */

  CM_CALL_END_IP_RETRY                     = 203,
    /**< To be used only when CM_API_IP_CALL is defined
    ** Call needs to be retried on IP
    */

  CM_IP_CALL_END_EMERG_ORIG                = 204,
    /**< To be used only when CM_API_IP_CALL is defined
    ** Call ended due to Emerg origination
    */

  CM_CALL_END_ORIG_THR                     = 401,
    /**< Origination throttled */

  CM_CALL_END_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_END_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_end_e_type;

/** Enumeration of call mode info types
*/
typedef enum cm_call_mode_info_e {

  CM_CALL_MODE_INFO_NONE,
    /**< @internal */

  CM_CALL_MODE_INFO_CDMA,
    /**< Call info is CDMA */

  CM_CALL_MODE_INFO_GW_CS,
    /**< Call info is GSM/WCDMA circuit switched */

  CM_CALL_MODE_INFO_GW_PS,
    /**< Call info is GSM/WCDMA packet switched */

  CM_CALL_MODE_INFO_IP,
    /**< To be used only if CM_API_IP_CALL is defined
    ** Call info is WLAN
    */

  CM_CALL_MODE_INFO_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_MODE_INFO_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_mode_info_e_type;

/** Enumeration of digit modes.
*/
typedef enum cm_digit_mode_e {

  CM_DIGIT_MODE_NONE=-1,
    /**< @internal */

  CM_DIGIT_MODE_4BIT_DTMF,
    /**< 4-bit DTMF */

  CM_DIGIT_MODE_8BIT_ASCII,
    /**< 8-bit ASCII */

  CM_DIGIT_MODE_SIP_URI,
    /**< Clients should check for CM_API_VIDEOSHARE before using
    ** this enum
    ** Indicates that buf in
    ** cm_num_s_type carries SIP URI.
    */

  CM_DIGIT_MODE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_DIGIT_MODE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_digit_mode_e_type;

/** Privacy mode during a call. CDMA only.
*/
typedef enum cm_privacy_pref_e {

  CM_PRIVACY_PREF_NONE = -1,
    /**< @internal */

  CM_PRIVACY_PREF_STANDARD,
    /**< Standard privacy */

  CM_PRIVACY_PREF_ENHANCED,
    /**< Enhanced privacy */

  CM_PRIVACY_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PRIVACY_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_privacy_pref_e_type;

/** Retry delay type ( FEATURE_IS2000 )
*/
typedef enum cm_retry_type_e {

  CM_RETRY_TYPE_NONE = -1,
    /**< No retry order */

  CM_RETRY_TYPE_CLEAR_ALL,
    /**< Clear all retry order */

  CM_RETRY_TYPE_ORIGINATION,
    /**< Origination retry order */

  CM_RETRY_TYPE_RESOURCE_REQ,
    /**< Resource request retry order */

  CM_RETRY_TYPE_SUPP_CH_REQ,
    /**< Supplemental channel request retry order */

  CM_RETRY_TYPE_RESERVED4,
    /**< Reserved */

  CM_RETRY_TYPE_RESERVED5,
    /**< Reserved */

  CM_RETRY_TYPE_RESERVED6,
    /**< Reserved */

  CM_RETRY_TYPE_RESERVED7,
    /**< Reserved */

  CM_RETRY_TYPE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_RETRY_TYPE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_retry_type_e_type;

/** Enumeration of supplementary system commands client are able to send to CM.
*/
typedef enum cm_sups_cmd_e {

  CM_SUPS_CMD_NONE = -1,
    /**< @internal */

  /* 0 */
  CM_SUPS_CMD_REGISTER,
    /**< Register Supplementary Service Request */

  CM_SUPS_CMD_ERASE,
    /**< Erase Supplementary Service Request */

  CM_SUPS_CMD_ACTIVATE,
    /**< Activate Supplementary Service Request */

  CM_SUPS_CMD_DEACTIVATE,
    /**< Deactivate Supplementary Service Request */

  /* 4 */
  CM_SUPS_CMD_INTERROGATE,
    /**< Interrogate Supplementary Service Request */

  CM_SUPS_CMD_PROCESS_USS,
    /**< Process Unstructured Supplementary Service */

  CM_SUPS_CMD_REG_PASSWORD,
    /**< Register Password Supplementary Service Request */

  CM_SUPS_CMD_ABORT,
    /**< Abort Supplementary Service Request */

  /* 8 */
  CM_SUPS_CMD_RELEASE,
    /**< Release Supplementary Service Request */

  CM_SUPS_CMD_GET_PASSWORD_RES,
    /**< Get Password Response */

  CM_SUPS_CMD_USS_NOTIFY_RES,
    /**< Unstructured Supplementary Service Notify Response */

  CM_SUPS_CMD_USS_RES,
    /**< Unstructured Supplementary Service Response */


  CM_SUPS_CMD_LCS_LOCATION_NOTIFICATION_RES,
    /**< Location Services Location Notification Supp Serv Response */

  CM_SUPS_CMD_LCS_MOLR,
    /**< Location Services LCS MOLR Request */

  CM_SUPS_CMD_LCS_MOLR_COMPLETED,
    /**< Location Services LCS MOLR Completed */



  CM_SUPS_CMD_ERASE_CC_ENTRY,
    /**< Request to deactivate one or all pending ccbs requests at
    ** the network. Does not have a CM API to call this directly.
    ** Gets mapped from cm_sups_cmd_deactivate ()
    */

  CM_SUPS_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SUPS_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sups_cmd_e_type;

/** Enumeration of call command supplementary service type
*/
typedef enum cm_call_sups_type_e {

  CM_CALL_SUPS_TYPE_NONE = -1,
    /**< @internal */

  CM_CALL_SUPS_TYPE_HELD_CALL_REL_OR_UDUB,
    /**< 0 SEND - Release all held calls or
    **          set User Determined User Busy (UDUB)
    **          for a waiting call. */

  CM_CALL_SUPS_TYPE_ACTIVE_CALL_REL,
    /**< 1 SEND - Release all active calls and
    **          accept other call (held or waiting) */

  CM_CALL_SUPS_TYPE_ACTIVE_CALL_X_REL,
    /**< 1 X SEND - Release a specific call X */

  CM_CALL_SUPS_TYPE_HOLD_CALL,
    /**< 2 SEND - Place all active calls on hold and
    **          accept another call (held or waiting) */

  CM_CALL_SUPS_TYPE_SELECT_CALL_X,
    /**< 2 X SEND - Place all active calls on hold except X
    **            with which communication is still established. */

  CM_CALL_SUPS_TYPE_MULTIPARTY_CALL,
    /**< 3 SEND - Add a held call to the conversation,
    **          Multiparty call */

  CM_CALL_SUPS_TYPE_CALL_DEFLECTION,
    /**< 4 * DN SEND - Deflect an incoming call */

  CM_CALL_SUPS_TYPE_EXPLICIT_CALL_TRANSFER,
    /**< 4 SEND - Explicit call transfer */

  CM_CALL_SUPS_TYPE_CALL_FORWARD,
    /**< Call forward */

  CM_CALL_SUPS_TYPE_EMERGENCY_CALL,
    /**< CDMA - indicates emergency call */

  CM_CALL_SUPS_TYPE_ACT_ANSWER_HOLD,
    /**< CDMA - Activate answer hold */

  CM_CALL_SUPS_TYPE_DEACT_ANSWER_HOLD,
    /**< CDMA - Deactivate answer hold */

  CM_CALL_SUPS_TYPE_SIMPLE_FLASH,
    /**< CDMA - Send it as regular flash */

  CM_CALL_SUPS_TYPE_ACT_CCBS_REQ,
    /**<
    ** 5 SEND - Activates the Completion of Calls to Busy Subscriber Request
    ** GW only. Response to CCBS_ALLOWED indication from network
    */

  CM_CALL_SUPS_TYPE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_SUPS_TYPE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_sups_type_e_type;

/** Enumeration of call direction.
*/
typedef enum cm_call_direction_e {
  CM_CALL_DIRECTION_NONE,
    /**< Undefined Direction */

  CM_CALL_DIRECTION_MO,
    /**< Mobile Originated Call */

  CM_CALL_DIRECTION_MT,
    /**< Mobile Terminated Call */

  CM_CALL_DIRECTION_MAX
  /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_DIRECTION_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_call_direction_e_type;

/** Enumeration of Call control result.
*/
typedef enum cm_cc_result_e {

  CM_CC_RESULT_NONE = -1,
    /**< @internal */

  /* 0 */
  CM_CC_RESULT_ALLOWED_NO_MODIFICATIONS,
    /**< Call Allowed, Call control did not make any modifications */

  CM_CC_RESULT_NOT_ALLOWED,
    /**< Call Not Allowed */

  CM_CC_RESULT_ALLOWED_BUT_MODIFIED,
    /**< Call Allowed, But there were modifications */

  CM_CC_RESULT_ALLOWED_BUT_MODIFIED_TO_VOICE,
    /**< Call Allowed, Call type was changed to voice */

  /* 4 */
  CM_CC_RESULT_ALLOWED_BUT_MODIFIED_TO_SS,
    /**< Call Allowed, Call type was chanegd to SS */

  CM_CC_RESULT_ALLOWED_BUT_MODIFIED_TO_USSD,
    /**< Call Allowed, Call type was changed to USSD */

  CM_CC_RESULT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CC_RESULT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif   /* FEATURE_RPC */

} cm_cc_result_e_type;

typedef enum cm_call_modify_e{

  CM_CALL_MODIFY_NONE  = -1,
    /**< @internal */

  CM_CALL_MODIFY_NO_CHANGE = 0,
    /**< No Modification for this call. */

  CM_CALL_MODIFY_VOCIE = 1,
    /**< Modify the call to Voice Only */

  CM_CALL_MODIFY_VT    = 2,
    /**< Modify the call to VT */

  CM_CALL_MODIFY_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CALL_MODIFY_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif   /* FEATURE_RPC */

}cm_call_modify_e_type;

/* Enumeration for values carried by handset based plus dial */
typedef enum cm_hs_based_plus_dial_e {

  CM_HS_BASED_PLUS_DIAL_NONE = -1,
    /* FOR INTERNAL USE OF CM ONLY! */

  CM_HS_BASED_PLUS_DIAL_DISABLED = 0,
  /* Plus dial disabled */

  CM_HS_BASED_PLUS_DIAL_ENABLED_ACCEPT_NETW_SOLN = 1,
  /* Plus dial enabled. If country table
  ** entry shows network based solution then
  ** network based will be used.
  */

  CM_HS_BASED_PLUS_DIAL_ENABLED_IGNORE_NETW_SOLN = 2,
  /* Plus dial enabled. Even if country table entry
  ** shows network based solution is avail, CM will
  ** still use handset based solution
  */

  CM_HS_BASED_PLUS_DIAL_MAX
    /* FOR INTERNAL USE OF CM ONLY! */

  #ifdef FEATURE_RPC
  ,  CM_HS_BASED_PLUS_DIAL_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif   /* FEATURE_RPC */

} cm_hs_based_plus_dial_e_type;

/** Progress states for
** CM_CALL_EVENT_PROGRESS_INFO_IND.
**
** Clients needs to check for CM_API_IPCALL_SS_INFO
** before using this type
*/
typedef enum cm_call_prog_info_e {

  CM_CALL_PROG_INFO_NONE = -1,
    /**< @internal */

  CM_CALL_PROG_INFO_REMOTE_ALERT,
    /**< Indicates that remote party is being alerted
    ** for MO call
    */

  CM_CALL_PROG_INFO_MAX
    /**< @internal */

} cm_call_prog_info_e_type;

/** Structure holds warning information
** sent by IP app during registration or ending
** of an ip call.
** Clients needs to check for CM_API_VIDEOSHARE
** before using this type.
*/
typedef struct cm_ipapp_warn_info_s {

  boolean   present;
    /**< TRUE   - Warning is present
    ** FALSE  - Warning is not present
    */

  int   cause;
    /**< Warning code - SIP RFC 3261, sect 20.43
    */

  char  hostname[CM_IPAPP_HOST_SIZE];
    /**< Null terminated host name that
    ** generates the warning
    */

  char  description[CM_IPAPP_TEXT_SIZE];
    /**< Null terminated Warning text.
    */

} cm_ipapp_warn_info_s_type;

/** Structure to store ccbs indexes
** Clients need to check for CM_API_CCBS before using
** this structure
*/
typedef struct {

    cm_ccbs_indx_type              ccbs_index;
      /**< ccbs index value stored
      */

    cm_called_party_bcd_no_s_type  called_party;
      /**< called party number for the corresp call
      */

} cm_ccbs_indx_store_s_type;

/* Type for ccbs information returned to clients
** Clients need to check for CM_API_CCBS before using
*/
typedef struct cm_ccbs_store_info_s {

    int                         cm_ccbs_store_info_len;
      /**< Total entries present in ccbs store
      */

    cm_ccbs_indx_store_s_type   ccbs_indx_store[CM_MAX_CCBS_REQ];
      /**< Carries ccbs index and called number
      */
} cm_ccbs_store_info_s_type;

/** Type for CM signal types.
*/
typedef struct cm_signal_s {

  boolean     is_signal_info_avail;
    /**< Indicate whether signal information is available.
    **
    ** NOTE! if this variable is FALSE, the values found in other
    ** fields of this structure as NO meaning */

  uint8       signal_type;
    /**< Signal type - Tone Signal, ISDN Alerting or IS-54B Alerting */

  uint8       alert_pitch;
    /**< Alert pitch - Medium, High or Low */

  uint8       signal;
    /**< Indicate which Tone signals, ISDN Alerting or IS_54B Alerting */

} cm_signal_s_type;

typedef struct cm_subaddress_s
{
  boolean   extension_bit;
    /**< The extension bit */

  uint8     subadd_type;
    /**< Type of subaddress - NSAP/USER */

  uint8     odd_even_ind;
    /**< The indicator of even/odd bits - EVEN/ODD */

  uint8     num_char;
    /**< Number of characters in subaddress array */

  uint8     chari[CM_MAX_SUBADDRESS_DIGITS];
    /**< Array of subaddress digits */

} cm_subaddress_s_type;

/** Type for CM number.
** Able to store a dialed number or a caller ID number.
**
** NOTE! In the case where the digit_mode parameter is set to
** CM_DIGIT_MODE_4BIT_DTMF the number buffer may only contain
** 0-9, "#", or "*" characters.
**
** In the case where the digit_mode parameter is set to
** CM_DIGIT_MODE_8BIT_ASCII the number buffer may contain any
** 8-bit ASCII characters.
**
** Digital calls include CDMA and GSM/WCDMA but not AMPS.
**
** number_type should be of type cm_num_type_e_type.
** number_plan should be of type cm_num_plan_e_type.
*/
typedef struct cm_num_s {

  uint8                    buf[CM_MAX_NUMBER_CHARS];
    /**< Number buffer */

  uint8                    len;
    /**< Length of number stored in num_buf */

  cm_digit_mode_e_type     digit_mode;
    /**< Origination digit mode */

  uint8                    number_type;
    /**< Number type */

  uint8                    number_plan;
    /**< Numbering Plan */

  cm_npi_type              pi;
    /**< Presentation Indicator */

  cm_si_type               si;
    /**< Screening Indicator */

  cm_subaddress_s_type     subaddr;
    /**< Subaddress */

  cm_emerg_srv_categ_type  emerg_srv_categ;
    /**< Clients needs to check for CM_API_ECATEG_IN_NUM_STRUCT before
    ** using this field.
    **
    ** Applies only when call type is EMERGENCY.
    ** Holds service category bits that are or'ed
    ** These bits come from CM_EMERG_NUM_TYPE_xx.
    ** Example - CM_EMERG_NUM_TYPE_POLICE_MASK
    */

} cm_num_s_type;

/** Type for Redirecting Numbers.
*/
typedef struct cm_redirecting_num_s {

  cm_num_s_type                num;
    /**< Number that is redirecting */

  cm_redirecting_reason_e_type redirecting_reason;
    /**< Optional param -- redirecting reason
    ** REDIRECTING_REASON_UNKNOWN if no included.
    */

}cm_redirecting_num_s_type;

/** Type for CM alpha.
** Able to store alpha tag text.
*/
typedef struct cm_alpha_s {

  uint8    buf[CM_MAX_ALPHA_TAG_CHARS];
    /**< Alpha buffer */

  uint8    len;
    /**< Length of alpha tag stored in alpha_buf */

} cm_alpha_s_type;

/* Type to hold the country code */
typedef uint16 cm_country_code_type;

/* Type to hold sid */
typedef uint16 cm_sid_type;

/* Type for CM alpha with coding scheme.
** Able to store
** - Encoded CNAP string
** - Number of characters in the decoded string
** - Number of bytes in the encoded data
** - Coding scheme used
*/
typedef struct cm_enc_alpha_s {

  byte     buf[CM_MAX_ALPHA_TAG_BYTES];
    /* Alpha buffer */

  uint8    num_characters;
    /* Length of alpha tag stored in alpha_buf */

  uint8    num_bytes;
    /* Length of alpha tag stored in alpha_buf */

  uint8    coding_scheme;
    /* Coding scheme of data */

} cm_enc_alpha_s_type;

/** Extended Burst Type International message - FEATURE_T53
*/
typedef struct cm_ext_brst_intl_s {

  uint16   mcc;
   /**< Mobile Country Code (fixed '0101010011')*/

  uint8    db_subtype;
   /**< Data Burst subtype (fixed '000001') */

  uint8    chg_ind;
   /**< Charge Indication */

  uint8    sub_unit;
   /**< Unit call time (1/10 second) */

  uint8    unit;
   /**< Unit call time (second) */

} cm_ext_brst_intl_s_type;

/** National Supplementary services - CLIR - FEATURE_T53
*/
typedef struct cm_nss_clir_rec_s {

  uint8   cause;
    /**< Reason code */

} cm_nss_clir_rec_s_type;

/** National Supplementary services - Audio Control - FEATURE_T53
*/
typedef struct cm_nss_aud_ctrl_s {

  uint8   up_link;
    /**< Audio path from the MS to the BS */

  uint8   down_link;
    /**< Audio path from the BS to the MS */

} cm_nss_aud_ctrl_s_type;

/** Retry order info
*/
typedef struct cm_retry_order_s {

  cm_retry_type_e_type retry_type;
    /**< Retry delay type */

  uint16               srv_opt;
    /**< Service option   */

  boolean              infinite_delay;
    /**< True if infinite delay, it should always be FALSE for origination */

  uint32               retry_delay_in_ms;
    /**< Only meaningful if infinite_delay is FALSE */

} cm_retry_order_s_type;

/** Type for holding optional supplementary service parameters
*/
typedef struct cm_call_sups_params_s {

  cm_call_id_type   call_id;
    /**< Optional call ID of the call */

  cm_num_s_type     sups_number;
    /**< Optional User supplied number */

  uint8             cause;
    /* Optional cause value for GSM/WCDMA N/Nx SEND command */

} cm_call_sups_params_s_type;

/** Redirected call information */
typedef struct cm_route_dest_number_s
{
  boolean                           present;
  routing_number_option_s_type      type;
  cm_called_party_bcd_no_s_type     number[MAXNO_FORWARD_TO_NUMBER];
  cm_called_party_subaddress_s_type address;

} cm_route_dest_number_s_type;

/** Explicit Call Tranfer indicator */
typedef struct cm_ect_indicator_s
{
  boolean                         present;
  ect_call_state_s_type           callState;
  cm_route_dest_number_s_type     routeDestNumber;

} cm_ect_indicator_s_type;

/** Call Complete on Busy Subscriber indication
** Clients need to check for CM_API_CCBS before using
*/
typedef struct cm_ccbs_indicator_s
{
  boolean            present;
    /**< TRUE if this structure is valid */

  cm_ccbs_cnf_e_type ccbs_cnf;
    /**< CM_CCBS_CNF_RET_RES - Check ccbs_indx_present flag and then ccbs_indx
    ** CM_CCBS_CNF_RET_ERR and CM_CCBS_CNF_REJ - Look inside ss_error within
    ** cm_gw_cs_call_info_s_type.
    */

  boolean            ccbs_indx_present;
    /**< TRUE if ccbs indx is present
    */

  cm_ccbs_indx_type  ccbs_indx;
    /**< Actual ccbs indx
    */

} cm_ccbs_ret_res_s_type;

typedef struct cm_call_ss_info_s
{
  ie_ss_status_s_type        ss_status;
  ie_ss_code_s_type          ss_code;
  ie_ss_notification_s_type  ss_notification;
}cm_call_ss_info_s_type;

/** Forward declaration of cm_mm_call_info_s_type for
** use by event_user_data function
*/
typedef struct cm_mm_call_info_s cm_mm_call_info_s_type;

/** Used by clients to query for user data
** signaling messages after receiving call
** event related to user data.
** Clients need to check for CM_API_USER_USER_DATA before
** using.
*/
typedef struct {
     cm_user_data_s_type      mt_user_data;
       /**< Data from remote user in case
       ** of CM_CALL_EVENT_USER_DATA_IND
       */

     boolean                     is_receiver_busy;
       /**< Used for CM_CALL_EVENT_USER_DATA_CONG_IND
       */

     ie_cm_cc_cause_s_type       cm_cc_cause;
       /**< Used for CM_CALL_EVENT_USER_DATA_CONG_IND
       */
} cm_call_event_user_data_s_type;

/** Type for function to be called by clients to retrieve
** information regarding user to user data.
** Clients need to check for CM_API_USER_USER_DATA before
** using.
*/
typedef void (cm_call_event_user_data_f_type) (

    cm_call_event_user_data_s_type  *call_event_user_data,
      /**< Structure holding user data corresponding to events */

    const cm_mm_call_info_s_type    *call_info_ptr
        /**< pointer to call info pointer sent to the clients */
);

/** Circuit switched Call information returned with each event
*/
typedef struct cm_gw_cs_call_info_s {

  uint8                               transaction_id;
    /**< Call transaction ID */

  boolean                             accept;
    /**< Accept the call */

  boolean                             success;
    /**< Confirmation message from the lower layer is successful */


  cm_repeat_indicator_s_type          bc_repeat_indicator;
    /**< Bearer capability repeat indicator - included only if
    ** bearer capability 1 and bearer capability 2 are included */

  cm_bearer_capability_s_type         bearer_capability_1;
    /**< Bearer Capability 1 */

  cm_bearer_capability_s_type         bearer_capability_2;
    /**< Bearer Capability 2*/

  cm_repeat_indicator_s_type          llc_repeat_indicator;
    /**< LLC repeat indicator - included only if BC repeat indicator
    ** and low layer compatibility 1 are included */

  cm_low_layer_compatibility_s_type   low_layer_compatibility_1;
    /**< Low Layer Compatibility 1 - included in the Network -> UE
    ** direction if the calling user specifies a  low layer
    ** compatibility */

  cm_low_layer_compatibility_s_type   low_layer_compatibility_2;
    /**< Low Layer Compatibility 2 - included only if LLC repeat indicator
    ** is included */

  cm_repeat_indicator_s_type          hlc_repeat_indicator;
    /**< HLC repeat indicator - included only if BC repeat indicator
    ** and high layer compatibility 1 are included */

  cm_high_layer_compatibility_s_type  high_layer_compatibility_1;
    /**< High Layer compatibility 1 - included in the Network -> UE
    ** direction if the calling user specifies a  high layer
    ** compatibility
    */

  cm_high_layer_compatibility_s_type  high_layer_compatibility_2;
    /**< High Layer compatibility 2 - included only if HLC repeat
    ** indicator is included */

  cm_called_party_bcd_no_s_type       called_party_bcd_number;
    /**< Called party BCD number */

  cm_called_party_subaddress_s_type   called_party_subaddress;
    /**< Called party subaddress */

  cm_calling_party_bcd_no_s_type      calling_party_bcd_number;
    /**< Calling party BCD number */

  cm_calling_party_subaddress_s_type  calling_party_subaddress;
    /**< Calling party subaddress */

  cm_num_s_type                       redirect_party_number;
    /**< Redirecting party number */

  cm_forward_cug_info_s_type          forward_cug_info;
    /**< Closed user Group information */

  uint32                              rab_id;
    /**< Radio Access Bearer ID
    ** Valid only if rab_id_present is TRUE
    **
    ** Clients need to check for CM_API_CS_RABID before
    ** using this field.
    */

  uint8                               cm_clir;
    /**< CLIR information - CLIR suppression / invocation etc. */

  ie_cm_cc_cause_s_type               cc_cause;
    /**< Call control cause information - eg: */

  ie_cm_cc_reject_s_type              cc_reject;

  ie_cm_mo_call_details_s_type        call_details;
    /**<  Bearer capability information for mobile originated
    **  calls */

  ie_cm_ss_error_s_type               ss_error;
    /**< Supplementary service error */

  boolean                             call_ss_success;
    /**< Flag to indicate whether multiple call management
    ** is successful or not */

  active_calls_list_s_type            active_calls_list;
    /**< Active call ID list from multiple calls management
    ** confirmation */

  cm_connected_no_s_type              connected_num;
    /**< Connected number */

  cm_connected_subaddress_s_type      connected_subaddress;
    /**< Connected subaddress */

  cm_call_sups_type_e_type            sups_type;
     /**< Supplementary services type */

  cm_call_sups_params_s_type          sups_params;
    /**< supplementary service specific data */

  uint8                               call_progress;
    /**< call origination progress information */

  cm_cause_of_no_cli_s_type           cause_of_no_cli;
    /**< cause for no CLI in mobile terminated call */

  cm_ect_indicator_s_type             ect_info;
    /**< explicit call transfer information */

  cm_call_ss_info_s_type              ss_info;
    /**< call related SS information */


  #if (defined(FEATURE_UMTS_1X_HANDOVER_UMTSMSM) || \
       defined(FEATURE_MM_SUPERSET))
  sys_is2000_msg_s_type               umts_cdma_ho_info;
    /**< UMTS to 1X handoff information.
    */
  #endif

 #if (defined(FEATURE_UUS) || defined(FEATURE_MM_SUPERSET))
  cm_call_event_user_data_f_type     *user_data_func;
  #endif

  boolean                             is_user_data_present;
    /**< Can be used by clients to check if user_data_func
    ** can be called to return valid values.
    */

  cm_ccbs_ret_res_s_type             ccbs_ret_res;
    /**< Clients need to check for CM_API_CCBS before
    ** using this structure. Carries CCBS specific
    ** parameters for the clients
    */

  cm_ccbs_recall_rsp_e_type          ccbs_recall_rsp;
    /**< Clients need to check for CM_API_CCBS before
    ** using this structure. Carries recall response
    ** sent by the client for Recall indication
    */

  cm_call_type_e_type                new_call_type_req;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    ** New call type that is requested by in-call modification api
    ** cm_mm_call_cmd_modify_req()
    */

  boolean                            incall_modif_err_status;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    ** Error status returned by MN as a result of in-call modification
    ** request
    ** TRUE  - Error in processing in-call modification req.
    ** FALSE - No error in processing in-call modification req.
    */

  boolean                             is_call_mod_possible;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    **
    ** Used by UI clients to display icon that can be chosen by user to
    ** perform call modifications.
    **
    ** TRUE   - Call can be modified. Voice to VT and VT to Voice.
    ** FALSE  - Call cannot be modified.
    */

  boolean                             gw_cs_modify_res;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    ** Client response to modification request
    ** TRUE   - Modification got accepted by client
    ** FALSE  - Modification got rejected by client
    */

  boolean                             rab_id_present;
    /**< TRUE   - rab_id carries valid value
    ** FALSE  - rab_id does not carry valid value
    **
    ** Clients need to check for CM_API_CS_RABID before
    ** using this field.
    */

  boolean                             is_network_initiated;
    /* Clients need to check for CM_API_VT_FALLBACK_TO_VOICE before
    ** using this field.
    **
    ** Used by UI clients to tailor messages/prompts indicating whether
    ** network or remote-user is responsible for this event.
    **
    ** TRUE   - Network initiated event
    ** FALSE  - Remote-user initiated event
    */

} cm_gw_cs_call_info_s_type;

/** Packet switched Call information returned with each event
*/
typedef struct cm_gw_ps_call_info_s {

  nsapi_T                         nsapi;
    /**< NSAPI information */

  qos_T                           qos;
    /**< Quality of Service information */

  qos_T                           minimum_qos;
    /**< The minimum quality of service allowed for the
    ** PDP context */

  pdp_address_T                   pdp_addr;
    /**< Packet data protocol address */

  protocol_cfg_options_T          config_options;
    /**< Protocol Configuration Options */

  apn_T                           apn_name;
    /**< Access point  name - a label or a full
    ** qualified domain name */

  sys_pdp_header_comp_e_type      h_comp;
    /**< IP Header Compression Required
    **
    ** Clients need to check for CM_API_PDP_COMPR before
    ** using this enum
    */

  sys_pdp_data_comp_e_type        d_comp;
    /**< Data Compression Required
    **
    ** Clients need to check for CM_API_PDP_COMPR before
    ** using this enum
    */

  ti_T                            tear_down_ind;
    /**< Tear down indicator - indicates whether
    ** only the PDP context associated with this specific
    ** TI or all active PDP contexts sharing the same PDP
    ** address associated with this specific TI shall be deactivated. */

  cause_enum_type_T               pdp_cause_type;
    /**< PDP cause type */

  pdp_cause_T                     cause;
    /**< PDP cause */

  rabm_rabid_T                    rabid;
    /**< RAB Id */

  rabmcm_cause_T                  rab_cause;
    /**< RAB cause */

  cm_call_id_type                 primary_call_id;
    /**< Call Id of the primary PDP context.
       This field is only used if this is
       a secondary PDP context origination
    */

  uint16                            profile_number;
    /**< The PDP profile number used for this
    ** PDP context
    */

  #if (defined(FEATURE_UMTS_1X_HANDOVER_UMTSMSM) || \
       defined(FEATURE_MM_SUPERSET))
  sys_is2000_msg_s_type               umts_cdma_ho_info;
    /**< UMTS to 1X handoff information.
    */
  #endif

  byte                            pdp_group_id;
   /**< Clients check CM_API_SEC_PDP for SEC PDP support
   ** Group id of the primary context
   ** that is associated with the
   ** secondary PDP context origination
   */

 uint16                            assoc_pri_profile_num;
   /**< Clients check CM_API_SEC_PDP for SEC PDP support
   ** For Primary context, holds own profile number.
   ** For Seconadry context, profile of associated
   ** primary.
   */

 boolean                         is_net_alloc_qos_diff_from_req;
   /**< Clients check CM_API_SEC_PDP for SEC PDP support
   ** Valid for only Sec PDP context
   ** Sec PDP origination's requested qos and
   ** minimum_qos decide this value
   ** FALSE - Nw has allocated qos in between requested and minimum_qos
   ** TRUE  - Nw has allocated different qos
   */

 cm_ps_sig_rel_status_T          ps_sig_rel_status;
   /* Status of PS Signaling release request that was
   ** initiated by client
   */

} cm_gw_ps_call_info_s_type;

/* GAN status information structure. 
*/
typedef struct cm_gw_gan_info_s{

    sys_gw_gan_state_e_type                       gan_state;
        /**< gan state - init or shutdown  */

    sys_gw_gan_conn_status_e_type                 gan_conn_status;
        /**< GAN connection status */

    sys_gw_gan_sig_chan_status_e_type             gan_sig_chan_status;
        /**< signal channel status */

    sys_gw_gan_mode_display_s_type                gan_mode_display;
         /**< mode display - indicates if 
         **   WLAN or GERAN is the active RAT
         */

    sys_gw_gan_error_s_type                       gan_error;
        /**< gan error information 
        **   category and codepoint
         */

}cm_gw_gan_info_s_type;

/** CDMA call information returned with each event
** Applicable for targets that support CDMA
*/
typedef struct cm_cdma_call_info_s {

  uint16                          srv_opt;
    /**< Service option as defined in CAI.H file
    **
    ** NOTE! The service option takes on the CM_SO_ANALOG
    ** value (defined in this file) when the call is connected
    ** (or to be connected) over analog service */

  cm_privacy_pref_e_type          privacy_pref;
    /**< NOTE: This is the user preference. It is different from is_privacy
    ** which indicates the actual status of privacy during the call. */

  boolean                         is_privacy;
    /**< Indicate whether privacy mode is on */

  boolean                         is_otasp_commit;
    /**< Indicate whether OTASP activation is successful */

  boolean                         is_last_cdma_info_rec;
    /**< this field indicates whether this is the last
    ** CDMA info record or not */

  cm_call_sups_type_e_type        sups_type;
      /**< Supplementary services (flash) type */

  cm_call_id_type                 emergency_flash_call_id;
      /**< The call used in sending emergency flash */

  boolean                         emergency_flash_over_incoming_call;
      /**< whether a previous emergency request was flashed on this
      incoming call or not */

  boolean                         qos_parms_incl;
    /**< Qos Parameters presense indicator. TRUE - Present; FALSE - Not */

  uint8                           qos_parms_len;
    /**< Length of QOS parameter list */

  uint8                           qos_parms[CM_ORIG_QOS_LEN_MAX];
    /**< QOS parameters list */

  uint8 end_reason;
    /**< the reason for ending a call, it's different from end_status to keep
    ** the old interface unchanged while adding more IS2000 specific reasons */

  cm_retry_order_s_type           retry_order;
    /**< retry order info */

  uint8                           ext_disp_type;
    /**< display type for extended disaply info record - FEATURE_IS95B_EXT_DISP */

  boolean                         alert_ans_bypass;
    /**< Indicate whether the incoming call need to be answered by the clients
    ** FEATURE_IS95B_ALERT_ANS_BYPASS */

  boolean                         ndss_in_progress;
    /**< MC is perfoming NDSS redirection - FEATURE_IS95B_NDSS */

  cm_ext_brst_intl_s_type         ext_brst_intl_msg;
    /**< Contains charge rate information - FEATURE_T53 */

  cm_nss_clir_rec_s_type          nss_clir_rec;
    /**< National Supplementary services - CLIR - FEATURE_T53 */

  cm_nss_aud_ctrl_s_type          nss_aud_ctrl_rec;
    /**< National Supplementary services - Audio Control - FEATURE_T53 */

  sys_umts_cdma_handover_e_type   umts_cdma_ho_status;

  sys_ho_status_e_type            ho_status;

  /**< Line control information
  */

  boolean                              line_ctrl_polarity_included;
    /**< TRUE if polarity info included
    */

  boolean                              line_ctrl_toggle;
    /**< TRUE = toggle polarity
    */

  boolean                              line_ctrl_reverse;
    /**< TRUE = reverse polarity
    ** FALSE = normal polarity
    */

  byte                                 line_ctrl_power_denial;
    /**< Power denial time
    */

  cm_call_orig_fail_layer_e_type       orig_fail_layer;
    /**< Highest layer where the call failed during origination
    ** This field is adjusted after every silent redial failure during
    ** origination.
    ** CM_CALL_ORIG_ERR_LAYER_OTHER is lower layer failure than
    ** CM_CALL_ORIG_ERR_LAYER_L2 and CM_CALL_ORIG_ERR_LAYER_L2 is
    ** lower layer failure than CM_CALL_ORIG_ERR_LAYER_L3
    */

} cm_cdma_call_info_s_type;

/** IP call information returned with IP call related
** events
**
** Clients needs to check for CM_API_IPCALL_SS_INFO
** before using this type
*/
typedef struct cm_ip_call_info_s {

  cm_call_sups_type_e_type      sups_type;
     /**< Indicates the supp service req for which
     ** call_ss_success is being generated.
     ** Relevant for CM_CALL_EVENT_MNG_CALLS_CONF
     */

  boolean                       call_ss_success;
    /**< Flag to indicate if sups service request on ip call
    ** succeded or not for CM_CALL_EVENT_MNG_CALLS_CONF.
    */

  cm_call_prog_info_e_type      call_prog_info;
    /**< Gives the specific progress states for
    ** CM_CALL_EVENT_PROGRESS_INFO_IND
    */
} cm_ip_call_info_s_type;

typedef union cm_call_mode_info_u {

  cm_gw_cs_call_info_s_type     gw_cs_call;
      /**< CS GSM or WCDMA specific info */

  cm_gw_ps_call_info_s_type     gw_ps_call;
      /**< PS GSM or WCDMA specific info */

  cm_cdma_call_info_s_type      cdma_call;
      /**< CDMA specific info */

  cm_ip_call_info_s_type        ip_call;
      /**< IP specific info
      **
      ** Clients needs to check for CM_API_IPCALL_SS_INFO
      ** before using this type
      */

} cm_call_mode_info_u_type;

typedef struct cm_call_mode_info_s {

  cm_call_mode_info_e_type  info_type;
    /**< Which mode information is present */

  cm_call_mode_info_u_type  info;
    /**< Mode information */

} cm_call_mode_info_s_type;

/** Origination parameters for GSM/WCDMA circuit switched call
   set by the clients.
*/
typedef struct cm_gw_cs_orig_params_s {

  cm_repeat_indicator_s_type          bc_repeat_indicator;
    /**< Bearer capability repeat indicator - included only if
       bearer capability 1 and bearer capability 2 are included
    */

  cm_bearer_capability_s_type         bearer_capability_1;
    /**< Bearer Capability 1 */

  cm_bearer_capability_s_type         bearer_capability_2;
    /**< Bearer Capability 2*/

  cm_repeat_indicator_s_type          llc_repeat_indicator;
    /**< LLC repeat indicator - included only if BC repeat indicator
       and low layer compatibility 1 are included
    */

  cm_low_layer_compatibility_s_type   low_layer_compatibility_1;
    /**< Low Layer Compatibility 1 - included in the Network -> UE
       direction if the calling user specifies a  low layer
       compatibility
    */

  cm_low_layer_compatibility_s_type   low_layer_compatibility_2;
    /**< Low Layer Compatibility 2 - included only if LLC repeat indicator
       is included
    */

  cm_repeat_indicator_s_type          hlc_repeat_indicator;
    /**< HLC repeat indicator - included only if BC repeat indicator
       and high layer compatibility 1 are included
    */

  cm_high_layer_compatibility_s_type  high_layer_compatibility_1;
    /**< High Layer compatibility 1 - included in the Network -> UE
       direction if the calling user specifies a  high layer
       compatibility
    */

  cm_high_layer_compatibility_s_type  high_layer_compatibility_2;
    /**< High Layer compatibility 2 - included only if HLC repeat
       indicator is included
    */

  cm_called_party_bcd_no_s_type       called_party_bcd_number;
    /**< Called party BCD number */

  cm_called_party_subaddress_s_type   called_party_subaddress;
    /**< Called party subaddress */

  cm_calling_party_subaddress_s_type  calling_party_subaddress;
    /**< Calling party subaddress */

  cm_forward_cug_info_s_type          forward_cug_info;
    /**< Closed user Group information */

  uint8                               cm_clir;
    /**< CLIR information - CLIR suppression / invocation etc. */

  boolean                             call_control_completed;
    /**< Calling task has applied call control aready */

  #if defined (FEATURE_UUS) || defined(FEATURE_MM_SUPERSET)
  cm_user_data_s_type                 mo_user_data;
    /**< Clients need to check for CM_API_USER_USER_DATA before
    ** using this field. user to user data request structure
    */
  #endif

} cm_gw_cs_orig_params_s_type;

/** Origination parameters for GSM/WCDMA packet switched call
*/
typedef struct cm_gw_ps_orig_params_s {

  boolean                accept;
  /**< Applicable for only MT calls
  ** True: MT call gets accepted
  ** False: MT call is rejected
  ** accept being made first parameter to align with other call answer
  ** structures
  */

  boolean                primary_pdp;
  /**< True: Primary
     False: Secondary
  */

  qos_T                  qos;
    /**< Quality of Service */

  qos_T                  minimum_qos;
    /**< The minimum quality of service allowed for the
       PDP context
    */

  pdp_address_T          pdp_addr;
    /**< Packet data protocol address */

  apn_T                  apn_name;
    /**< Access point  name - a label or a full
       qualified domain name
    */

  protocol_cfg_options_T config_options;
    /**< Protocol configuration options */

  sys_pdp_header_comp_e_type h_comp;
    /**< IP Header Compression Required
    **
    ** Clients need to check for CM_API_PDP_COMPR before
    ** using this enum
    */

  sys_pdp_data_comp_e_type   d_comp;
    /**< Data Compression Required
    **
    ** Clients need to check for CM_API_PDP_COMPR before
    ** using this enum
    */

  tft_type_T             tft;
    /**< Traffic flow template */

  nsapi_T                primary_nsapi;
    /**< Primary NSAPI */

  cm_call_id_type        primary_call_id;
    /**< Call Id of the primary PDP context.
       This field is only used if this is
       a secondary PDP context origination
    */

  uint16                   profile_number;
    /**< The PDP profile number used for this
    ** PDP context
    */

  byte                   pdp_group_id;
    /**< Clients check CM_API_SEC_PDP for SEC PDP support
    ** Group id of the primary context
    ** that is associated with the
    ** secondary PDP context origination
    */

  uint16                   assoc_pri_profile_num;
   /**< Clients check CM_API_SEC_PDP for SEC PDP support
   ** Valid for only Sec PDP context
   ** Sec PDP origination contains requested qos and
   ** minimum_qos.
   ** FALSE - Nw has allocated qos in between requested and minimum_qos
   ** TRUE  - Nw has allocated different qos
   */


} cm_gw_ps_orig_params_s_type;

/** Answer parameters for GSM/WCDMA circuit switched call
** set by the clients.
*/
typedef struct cm_gw_answer_params_s {

  boolean                         accept;
    /**< Flag indicating whether the call is accepted or not
    */

  cm_call_type_e_type             call_type;
    /**< Call type */

  cm_connected_subaddress_s_type  connected_subaddress;
    /**< Connected suaddress */

} cm_gw_answer_params_s_type;

/** To be used only if CM_API_IP_CALL is defined
** Answer parameters for WLAN voice call
** set by the clients.
*/
typedef struct cm_ip_answer_params_s {

  boolean                         accept;
    /**< Flag indicating whether the call is accepted or not
    */

  cm_call_type_e_type             call_type;
    /**< Call type */

} cm_ip_answer_params_s_type;

/** Call End parameters for GSM/WCDMA circuit switched call
** set by the clients.
*/
typedef struct cm_gw_cs_end_params_s {

  uint8                      reserved;
    /**< empty for now */

} cm_gw_cs_end_params_s_type;

/** Call End parameters for GSM/WCDMA packet switched call
** set by the clients.
*/
typedef struct cm_gw_ps_end_params_s {

  nsapi_T                    nsapi;
    /**< NSAPI */

  ti_T                       tear_down_ind;
    /**< Tear down indicator - indicates whether
       only the PDP context associated with this specific
       TI or all active PDP contexts sharing the same PDP
       address associated with this specific TI shall be deactivated.
    */

  sm_status_T                cause;
    /**< Cause for ending the call */

} cm_gw_ps_end_params_s_type;

/** Setup res parameters for GSM/WCDMA circuit switched call
** and VoIP calls set by the clients.
*/
typedef struct cm_setup_res_params_s {

  boolean                             accept;
    /**< Flag indicating whether the call is accepted or not */

  /**< Following fields only used for responding to GSM/WCDMA
  ** set up requests
  */
  ie_cm_cc_cause_s_type               cc_cause;
    /**< Call control cause information */

  cm_repeat_indicator_s_type          bc_repeat_indicator;
    /**< Bearer capability repeat indicator - included only if
       bearer capability 1 and bearer capability 2 are included
    */

  cm_bearer_capability_s_type         bearer_capability_1;
    /**< Bearer Capability 1 */

  cm_bearer_capability_s_type         bearer_capability_2;
    /**< Bearer Capability 2*/

  cm_repeat_indicator_s_type          llc_repeat_indicator;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    **
    ** LLC repeat indicator - included only if BC repeat indicator
    ** and low layer compatibility 1 are included */

  cm_low_layer_compatibility_s_type   low_layer_compatibility_1;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    **
    ** Low Layer Compatibility 1 - included in the Network -> UE
    ** direction if the calling user specifies a  low layer
    ** compatibility */

  cm_low_layer_compatibility_s_type   low_layer_compatibility_2;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    **
    ** Low Layer Compatibility 2 - included only if LLC repeat indicator
    ** is included */

  cm_repeat_indicator_s_type          hlc_repeat_indicator;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    **
    ** HLC repeat indicator - included only if BC repeat indicator
    ** and high layer compatibility 1 are included */

  cm_high_layer_compatibility_s_type  high_layer_compatibility_1;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    **
    ** High Layer compatibility 1 - included in the Network -> UE
    ** direction if the calling user specifies a  high layer
    ** compatibility
    */

  cm_high_layer_compatibility_s_type  high_layer_compatibility_2;
    /**< Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
    ** using this field.
    **
    ** High Layer compatibility 2 - included only if HLC repeat
    ** indicator is included */

} cm_setup_res_params_s_type;

/** PDP modify parameters for GSM/WCDMA packet switched call
*/
typedef struct cm_pdp_modify_params_s {

  nsapi_T                nsapi;
    /**< NSAPI */

  qos_T                  qos;
    /**< Quality of Service information */

  tft_type_T             tft;
    /**< Traffic flow template */

  qos_T                  minimum_qos;
    /**<  Clients need to check for CM_API_CHG_PDP_MOD before
    **  using this macro
    **  Minimum quality of service required for the
    **  PDP context
    */

} cm_pdp_modify_params_s_type;

/** RAB Reestablish request parameters for GSM/WCDMA packet
 *  switched call
*/
typedef struct cm_rab_reestab_params {

  rabm_rabid_T           rabid;
    /**< RAB Id */

} cm_rab_reestab_params_s_type;

/** CDMA call origination parameter structure
** Applicable for FEATURE_CDMA_800 or FEATURE_CDMA_1900.
*/
typedef struct cm_cdma_orig_params_s {

  uint16                    srv_opt;
    /**< Service options as defined in CAI.H file */

  cm_activate_code_e_type   activate_code;
    /**< OTASP activation code */

  boolean                   drs_bit;
    /**< Data ready set is ON/OFF */

  boolean                   sr_id_included;
    /**< Service Identifier is included or not */

  uint8                     sr_id;
    /**< Service Identifier */

  boolean                   qos_parms_incl;
    /**< Quality of Service parameters included or not */

  uint8                     qos_parms_len;
    /**< Length of Quality of Service parameter list */

  uint8                     qos_parms[CM_ORIG_QOS_LEN_MAX];
    /**< Quality of Service parameter list */

  sys_sys_mode_e_type       last_act_data_net;
    /**< last active data network - FEATURE_HDR_HANDOFF */

} cm_cdma_orig_params_s_type;

/** CDMA call answer parameter structure
** Applicable for FEATURE_CDMA_800 or FEATURE_CDMA_1900.
*/
typedef struct cm_cdma_answer_params_s {

  cm_call_type_e_type        call_type;
    /**< Call type */

} cm_cdma_answer_params_s_type;

/** CDMA call end parameter structure
** Applicable for FEATURE_CDMA_800 or FEATURE_CDMA_1900.
*/
typedef struct cm_cdma_end_params_s {

  boolean      end_reason_included;
    /**< End reason included or not */

  uint8        end_reason;
    /**< End reson */

} cm_cdma_end_params_s_type;

/** IP cause values for call hold/retrieve and call end
*/
typedef struct cm_ip_cause_s {

  uint32        cause;
    /**< ip cause */

} cm_ip_cause_s_type;

/** Type for CM alpha.
** Able to store alpha tag text.
*/
typedef struct cm_orig_alpha_s {

  uint8    buf[CM_MAX_ALPHA_LEN_FOR_CALL_ORIG];
    /**< Alpha buffer */

  uint8    len;
    /**< Length of alpha tag stored in alpha_buf */

} cm_orig_alpha_s_type;

/** Union for all mode answer parameters
*/
typedef union cm_ans_params_u {

  cm_gw_answer_params_s_type             gw_cs_ans;
    /**< GW CS answer parameters */

  cm_gw_ps_orig_params_s_type            gw_ps_ans;
    /**< GW PS answer parameters. Parameters required
    ** are exactly the same as reqd for ps call
    ** origination. So reusing call orig structure.
    */

  cm_ip_answer_params_s_type           ip_ans;
    /**< To be used only if CM_API_IP_CALL is defined
    ** Parameters to answer a MT IP voice
    */

  cm_cdma_answer_params_s_type           cdma_ans;
    /**< CDMA answer parameters */

} cm_ans_params_u_type;

/** Call answer parameters depending on the mode - CDMA, GSM,
 *  WCDMA etc.
*/
typedef struct cm_ans_params_s {

  cm_call_mode_info_e_type  info_type;
    /**< mode type */

  cm_ans_params_u_type      ans_params;
    /**< union - for mode specific parameters */

} cm_ans_params_s_type;

/** Union of all mode call end parameters
*/
typedef union cm_end_params_u {

  cm_gw_cs_end_params_s_type           gw_cs_end;
    /**< GSM/WCDMA circuit switched call end parameters */

  cm_gw_ps_end_params_s_type           gw_ps_end;
    /**< GSM/WCDMA packet switched call end parameters */

  cm_cdma_end_params_s_type            cdma_end;
    /**< CDMA call end parameters */

  cm_ip_cause_s_type                   ip_cause;
} cm_end_params_u_type;

/** Call end parameters depending on the mode - CDMA, GSM, WCDMA etc.
*/
typedef struct cm_end_params_s {

  cm_call_id_type           call_id;
    /**< Call ID to end */

  cm_call_mode_info_e_type  info_type;
    /**< Mode type */

  cm_end_params_u_type      end_params;
    /**< mode specific end parameters */

} cm_end_params_s_type;

/** Enumeration for call substates in idle state.
*/
typedef enum cm_call_idle_substate_e {

    CM_CALL_IDLE_SUBST_NONE = -1, /**< @internal */

    CM_CALL_IDLE_SUBST_ENDWAIT,   /* Waiting for END ACK */

    CM_CALL_IDLE_SUBST_MAX        /**< @internal */

} cm_call_idle_subst_e_type;

/** Enumeration for call substates in incoming state.
*/
typedef enum cm_call_incom_substate_e {

    CM_CALL_INCOM_SUBST_NONE = -1, /**< @internal */

    /* 0 */
    CM_CALL_INCOM_SUBST_REGULAR,   /**< All the other SO incoming calls */

    CM_CALL_INCOM_SUBST_OTAPA,     /**< OTAPA SO 18/19 incoming call */

    CM_CALL_INCOM_SUBST_SETUP,     /**< Processing Incoming Setup(GSM/WCDMA)
                                   ** Setup is pending for client to respond
                                   **
                                   ** Clients need to check for
                                   ** CM_API_ADD_INCOM_SUBST before using
                                   */

    CM_CALL_INCOM_SUBST_SETUP_PROCESSED, /**< Client response sent to
                                         ** protocol layer (GSM/WCDMA)
                                         ** Clients need to check for
                                         ** CM_API_ADD_INCOM_SUBST bef using
                                         */

    CM_CALL_INCOM_SUBST_ALERTING,   /**< Client being alerted on incoming call
                                    ** (GSM/WCDMA)
                                    ** Clients need to check for
                                    **  CM_API_ADD_INCOM_SUBST bef using
                                    */

    CM_CALL_INCOM_SUBST_ANSWERED,   /**< Answer from client sent to
                                    ** Protocol layer (GSM/WCDMA)
                                    ** Clients need to check for
                                    ** CM_API_ADD_INCOM_SUBST bef using
                                    */

    CM_CALL_INCOM_SUBST_DELAY_SETUPRES, /**< Used by FEATURE_CM_DELAY_SETUPRES.
                                        ** Setup response from CM client
                                        ** is made to wait in CM before
                                        ** being sent to NAS.
                                        ** Clients need to check for
                                        ** CM_API_DELAY_SETUPRES bef using
                                        */


    CM_CALL_INCOM_SUBST_MAX        /**< @internal */

} cm_call_incom_subst_e_type;

/** Enumeration for call substates in conversation state.
*/
typedef enum cm_call_conv_substate_e {

    CM_CALL_CONV_SUBST_NONE = -1,  /**< @internal */

    /** 0 */
    CM_CALL_CONV_SUBST_REGULAR,    /**< All the other calls */

    CM_CALL_CONV_SUBST_COMMIT,
                                   /**< OTASP or busy OTAPA call. */
           /**< Commit is in progress */

    CM_CALL_CONV_SUBST_PC_OTAPA_REGULAR,
                                   /**< SO 18/19 OTAPA call */
           /**< Without commit (either commit */
           /**< never happens or commit finishes */

    CM_CALL_CONV_SUBST_PC_OTAPA_COMMIT,
                                   /**< SO 18/19 OTAPA call */
           /**< Commit is in progress. */

    /* 4 */
    CM_CALL_CONV_CALL_ACTIVE,
          /**< the call is in conversation state and is active */

    CM_CALL_CONV_CALL_ON_HOLD,
          /**< the call is in conversation state, but is put on hold */

    CM_CALL_CONV_SUBST_MAX      /**< @internal */

} cm_call_conv_subst_e_type;

/** Type for call substate.
*/
typedef union cm_call_substate_u {


    cm_call_idle_subst_e_type idle;

    cm_call_incom_subst_e_type incom;

    cm_call_conv_subst_e_type  conv;

} cm_call_substate_type;

/** Defines the state information for a particular call object.
*/
typedef struct cm_call_state_info_s {

  cm_call_id_type                call_id;
    /**< Call ID */

  cm_call_type_e_type            call_type;
    /**< Call type - VOICE, DATA, OTASP, etc */

  cm_call_state_e_type           call_state;
    /**< Call state - idle, orig, incom, conv */

  sys_sys_mode_e_type            sys_mode;
    /**< The mode in which the call was originated */

  cm_call_direction_e_type       call_direction;
    /**< Indicates whether the call was mobile originated
    ** or mobile terminated
    */

  dword                          call_connect_time;
    /**< The time the call was connected.  The units is
    ** seconds since the phone has powered on (clock
    ** uptime).
    **/

  cm_alpha_s_type                alpha;
    /**< Alpha tag to be displayed along with dialed address
    ** of an originated call.
    */

  /*
  ** The following fields are only valid if
  ** call_type is CM_CALL_TYPE_PS_DATA.
  */
  boolean                        primary_pdp;
    /**< True  = Primary PDP context
       False = Secondary PDP context
    */

  uint16                           profile_number;
    /**< The number/Id of the PDP profile used
       for this PDP context
    */

  cm_call_id_type                primary_call_id;
    /**< Call ID of the primary PDP context */

  uint16                           assoc_pri_profile_num;
    /**< Clients check CM_API_SEC_PDP for SEC PDP support
    ** Valid for only Sec PDP context
    ** Sec PDP origination contains requested qos and
    ** minimum_qos.
    ** FALSE - Nw has allocated qos in between requested and minimum_qos
    ** TRUE  - Nw has allocated different qos
    */

  boolean                        is_net_alloc_qos_diff_from_req;
    /**< Clients check CM_API_SEC_PDP for SEC PDP support
    ** Valid for only Sec PDP context
    ** Sec PDP origination's requested qos and
    ** minimum_qos decide this value
    ** FALSE - Nw has allocated qos in between requested and minimum_qos
    ** TRUE  - Nw has allocated different qos
    */

  byte                           pdp_group_id;
     /**< Clients check CM_API_SEC_PDP for SEC PDP support
     ** Valid for only Sec context.
     ** Group id of primary context particular
     ** sec is associated with
     */

  cm_call_substate_type          call_subst;
     /**< Call substates - idle, conv, incom
     */
} cm_call_state_info_s_type;

/** The state information for all call objects
*/
typedef struct cm_call_state_info_list_s {

  byte                      number_of_active_calls;
  /**< The number of calls whose state is not idle */

  cm_call_state_info_s_type info[CM_CALL_ID_MAX];
  /**< The state info for all call objects */
} cm_call_state_info_list_s_type;

/** Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
** using this field.
** Structure for holding call compatibility
** and capability details.
*/
typedef struct cm_call_comp_cap_info_s {


  cm_bearer_capability_s_type         bearer_capability;
    /**< Bearer Capability */


  cm_low_layer_compatibility_s_type   low_layer_compatibility;
    /**< Low Layer Compatibility 1 - included in the Network -> UE
    ** direction if the calling user specifies a  low layer
    ** compatibility */


  cm_high_layer_compatibility_s_type  high_layer_compatibility;
    /**< High Layer compatibility 1 - included in the Network -> UE
    ** direction if the calling user specifies a  high layer
    ** compatibility
    */

} cm_call_comp_cap_info_s_type;

/**
** Structure to hold alpha and num returned by call control
** Check for CM_API_RESULT_FROM_CC flag before using cm_result_from_cc_s_type

*/
typedef struct cm_result_from_cc_s
{
  cm_cc_result_e_type                call_control_result;
    /**< Indicates whether there were modifications */

  cm_num_s_type                        num;
    /**< Number buffer:
    ** CM_CALL_EVENT_ORIG      - contains dialed digits string.
    ** CM_CALL_EVENT_FLASH     - contains dialed digits string.
    ** CM_CALL_EVENT_INCOM     - contains caller ID string.
    ** CM_CALL_EVENT_CALLER_ID - contains caller ID string.
    */
  cm_alpha_s_type                      alpha;
    /**< Alpha tag returned by call control
    */


} cm_result_from_cc_s_type;

/** Type to hold call state information.
** When notified of call events, clients are given
** a reference to such a structure.
*/
struct cm_mm_call_info_s {

  cm_client_id_type                    call_client_id;
    /**< Call client - originating/answering client */

  cm_call_id_type                      call_id;
    /**< call ID of the call */

  cm_call_state_e_type                 call_state;
    /**< Call state - idle, orig, incom, conv */

  cm_call_type_e_type                  call_type;
    /**< Call type - VOICE, DATA, OTASP, etc */

  cm_num_s_type                        num;
    /**< Number buffer:
    ** CM_CALL_EVENT_ORIG      - contains dialed digits string.
    ** CM_CALL_EVENT_FLASH     - contains dialed digits string.
    ** CM_CALL_EVENT_INCOM     - contains caller ID string.
    ** CM_CALL_EVENT_CALLER_ID - contains caller ID string.
    */

  #ifdef FEATURE_IP_CALL
  cm_num_s_type                        waiting_num;
  #endif /* FEATURE_IP_CALL */

  cm_redirecting_num_s_type            redirecting_number;
    /**< Number buffer:
    ** CM_CALL_EVENT_REDIRECTING_NUMBER           - contains redirecting num.
    */

  cm_alpha_s_type                      alpha;
    /**< Alpha tag to be displayed along with dialed address
    ** of an originated call.
    **
    ** NOTE! this is not a phone book name match, but rather
    ** an indication for the UI to display some text for an
    ** outgoing call
    **
    ** We probably need to change this one to a UI text component to
    ** support I18N
    **
    Alpha buffer:
    CM_CALL_EVENT_ORIG
    CM_CALL_EVENT_DISPLAY
    CM_CALL_EVENT_EXT_DISP
    */

  cm_enc_alpha_s_type                    enc_alpha;
    /* Alpha tag to be displayed along with dialed address
    ** of an originated call. This has coding information that
    ** may be later used by UI
    */

  cm_signal_s_type                     signal;
    /**< Alert signal information to be played for the incoming call
    */

  cm_call_end_e_type                   end_status;
    /**< Call end status (i.e. reason for ending a call in origination,
    **incoming or conversation state)
    */

  uint8                                num_call_ids_ended;
    /**< number of calls ended
    */

  cm_end_params_s_type                 end_params;
    /**< call end information
    */

  sys_sys_mode_e_type                  sys_mode;
    /**< Indicates the system on which the call is made
    */

  dword                                call_connect_time;
    /**< The time the call was connected.  The units is seconds since
    ** the phone has powered on (clock uptime).
    **/

  dword                                call_end_time;
    /**< The time the call was ended.  The units is seconds since
    ** the phone has powered on (clock uptime).
    **/

  uint32                               bytes_received;
    /**< The number of bytes received during the call (PS data call only).
    ** This field is populated after the call has ended.
    */

  uint32                               bytes_transmitted;
    /**< The number of bytes transmitted during the call (PS data call only).
    ** This field is populated after the call has ended.
    */
  cm_call_mode_info_s_type             mode_info;
    /**< System specific info - CDMA, GSM/WCDMA-CS, GSM/WCDMA-PS
    */

  cm_als_line_e_type                   line;
    /**< What line is being used for this call (FEATURE_ALS)
    */

  cm_client_id_type                    requesting_client_id;
    /**< Requesting client
    */

  #if (defined(FEATURE_UMTS_1X_HANDOVER_1XMSM) || \
       defined(FEATURE_UMTS_1X_HANDOVER_UMTSMSM) || \
       defined(FEATURE_MM_SUPERSET))
  sys_msm_id_e_type                    msm_id;
    /**< Identifies the MSM which generated this event.
    */
  #endif

  cm_call_direction_e_type             direction;
    /**< Holds direction of the current call.
    ** It can be Mobile originated or Mobile
    ** Terminated
    */

  cm_call_modify_e_type                modify;
    /**< Indicates the modified call type. It indiactes network's
    ** desired modify action when CM sends CM_CALL_EVENT_MODIFY.
    ** In all other cases, it will represent modified call type
    ** being used. Please note that CALL_TYPE is not changed as
    ** a result of MODIFY.
    */

  cm_result_from_cc_s_type             result_from_cc;
    /**< Holds alpha and num returned by call control
    ** Check for CM_API_RESULT_FROM_CC before using this field.
    */
};

/** Type for call compatibility and capability info callback function.
**
** Clients need to check for CM_API_VT_FALLBACK_TO_VOICE  before
** using this type definition.
**
** Function registered along with call type to retrieve compatibility
** capability.
*/
typedef void (cm_call_comp_cap_cb_f_type) (

  cm_call_comp_cap_info_s_type    *call_comp_cap_info_ptr
    /**< Pointer to call compatibility and capability info */

);

/** Macro to decide whether a given call type is an OTASP
** (standard or none standard ).
*/
#define CM_CALL_TYPE_IS_OTASP( call_type )  \
              ((call_type) == CM_CALL_TYPE_STD_OTASP    || \
                                (call_type) == CM_CALL_TYPE_NON_STD_OTASP   )

#define CM_CALL_TYPE_IS_OTAPA( call_type )  \
              ((call_type) == CM_CALL_TYPE_OTAPA)

/** Macro to return the length of a CM number.
*/
#define CM_NUM_LEN( num_ptr )  ( (num_ptr)->len )

/** Macro to return the Number type of a call manager number
*/
#define CM_NUM_NUMBER_TYPE( num_ptr )  ( (num_ptr)->number_type )

/** Macro to return the Numbering Plan of a CM number
*/
#define CM_NUM_NUMBER_PLAN( num_ptr )  ( (num_ptr)->number_plan )

/** Macro to return the Presentation Indicator of a CM number
*/
#define CM_NUM_PI( num_ptr )  ( (num_ptr)->pi )

/** Macro to return the Screening Indicator of a CM number
*/
#define CM_NUM_SI( num_ptr )  ( (num_ptr)->si )

/** Macro to return the Origination digit mode of a CM number
*/
#define CM_NUM_DIGIT_MODE( num_ptr )  ( (num_ptr)->digit_mode )

/** Type for call command callback functions.
**
** A client that wants to be notified of the result of a  call command
** needs to supply a pointer to a function of this type as the first
** parameter to a call-command-function.
**
** NOTE! Client's provided callback functions must be reentrant since they
** might be called from client, as well as, CM context simultaneously.
*/
typedef void (cm_call_cmd_cb_f_type) (

  void                      *data_block_ptr,
    /**< Pointer to client provided data block.
    **
    ** NOTE! Depending on the client implementation of this function
    ** the data block pointed by this pointer might be accessed from
    ** client, as well as, CM context simultaneously */

  cm_call_cmd_e_type        call_cmd,
    /**< Indicate which command is this error status for */

  cm_call_cmd_err_e_type    call_cmd_err
    /* Call command error code, indicating whether command
    ** is rejected and the reason */

);

/**==========================================================================

@FUNCTION cm_mm_call_cmd_orig

@DESCRIPTION
  Command CM to originate a call.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  - TRUE - request sent
  - FALSE - No buffer to send request
  Call_id will be returned in call_id_ptr.

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_orig(

  cm_call_cmd_cb_f_type       cmd_cb_func,
    /**< Client callback function */

  void                        *data_block_ptr,
    /**< Pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< Originating client */

  cm_call_type_e_type         call_type,
    /**< Call type - voice, data, etc. */

  cm_srv_type_e_type          srv_type,
    /**< Service type - automatic, etc. */

  const cm_num_s_type         *calling_number,
    /**< Number of mobile that is originating the call */

  const cm_num_s_type         *called_number,
    /**< Number dialed - phone that is being called */

  const cm_orig_alpha_s_type  *alpha_buf,
    /**< Alpha tag to be displayed for the origination */

  const cm_cdma_orig_params_s_type  *cdma_orig_params_ptr,
    /**< Pointer to cdma mode specific data */

  const cm_gw_cs_orig_params_s_type *gw_cs_orig_params_ptr,
    /**< Pointer to GW CS mode specific data */

  const cm_gw_ps_orig_params_s_type *gw_ps_orig_params_ptr,
    /**< Pointer to GW PS mode specific data */

  cm_call_id_type             *return_call_id_ptr
    /**< Call ID will be allocated and returned */

);

/**==========================================================================

@FUNCTION cm_mm_call_cmd_orig_exten

@DESCRIPTION
  Command CM to originate a handover call.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  - TRUE - request sent
  - FALSE - No buffer to send request
  Switch_in Call_id will be returned in switch_in_call_id_ptr.

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_orig_exten(

  cm_call_cmd_cb_f_type       cmd_cb_func,
    /**< Client callback function */

  void                        *data_block_ptr,
    /**< Pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< Originating client */

  cm_call_type_e_type         call_type,
    /**< Call type - voice, data, etc. */

  cm_srv_type_e_type          srv_type,
    /**< Service type - automatic, etc. */

  const cm_num_s_type         *calling_number,
    /**< Number of mobile that is originating the call */

  const cm_num_s_type         *called_number,
    /**< Number dialed - phone that is being called */

  const cm_orig_alpha_s_type  *alpha_buf,
    /**< Alpha tag to be displayed for the origination */

  const cm_cdma_orig_params_s_type  *cdma_orig_params_ptr,
    /**< Pointer to cdma mode specific data */

  const cm_gw_cs_orig_params_s_type *gw_cs_orig_params_ptr,
    /**< Pointer to GW CS mode specific data */

  const cm_gw_ps_orig_params_s_type *gw_ps_orig_params_ptr,
    /**< Pointer to GW PS mode specific data */

  cm_call_id_type             switch_out_call_id,
    /**< Switch out call id */

  cm_call_id_type             *return_call_id_ptr
    /**< Call ID will be allocated and returned */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_answer

@DESCRIPTION
  Command CM to answer an incoming call.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_answer(

  cm_call_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< answering client */

  cm_call_id_type        call_id,
    /**< call ID of the call */

  const cm_ans_params_s_type   *ans_params_ptr
    /**< pointer to mode specific data */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_end

@DESCRIPTION
  Command CM to end a call - in origination, incoming or conversation state.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_end(

  cm_call_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< ending client */

  uint8                  num_call_ids,
    /**< number of call IDs sent */

  const cm_end_params_s_type   *end_params_ptr
    /**< pointer to mode specific data */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_sups

@DESCRIPTION
  Command CM to send a supplementary service request to the BS.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_sups(

  cm_call_cmd_cb_f_type       cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< sending client */

  cm_call_sups_type_e_type    sups_type,
    /**< Type of supplementary service */

  const cm_call_sups_params_s_type  *sups_params_ptr
    /**< Pointer to supplementary service specific data */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_privacy_pref

@DESCRIPTION
  Command CM to change the privacy pref.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_CDMA_800 || FEATURE_CDMA_1900 must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
boolean cm_mm_call_cmd_privacy_pref(

  cm_call_cmd_cb_f_type   cmd_cb_func,
    /**< client callback function */

  void                    *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type       client_id,
    /**< ending client */

  cm_call_id_type         call_id,
    /**< call ID of the call */

  cm_privacy_pref_e_type  privacy_pref
    /**< privacy pref setting */
);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_get_call_info

@DESCRIPTION
  Get a sanpshot of the current call information in the CM

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_get_call_info(

  cm_call_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< requesting client ID */

  cm_call_id_type        call_id
    /**< call ID of the call */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_get_call_info_list

@DESCRIPTION
  Get a sanpshot of the state of all call objects maintained by CM.  This
  is a synchronous function.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_get_call_info_list(

  cm_call_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id
    /**< requesting client ID */
);
/**===========================================================================

@FUNCTION cm_mm_call_comp_cap_cb_reg

@DESCRIPTION
  Clients call this function to register call backs that can be used to
  receive capability and compatibility information for a call type.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

  CM_API_VT_FALLBACK_TO_VOICE should be defined

@RETURNS
  TRUE   - Callback could be registered succeddfully
  FALSE  - Callback could not be registered successfully.

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_mm_call_comp_cap_cb_reg(

  cm_call_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< requesting client ID */

  cm_call_type_e_type    call_type,
    /**< Call type for which call back has to be set */

  cm_call_comp_cap_cb_f_type *comp_cap
    /**< Callback that retrieves compatibility and capability for the
    ** call type.
    */
);

/**===========================================================================

@FUNCTION cm_mm_get_call_comp_cap

@DESCRIPTION
  Return the call compatibility and capability for given call type.


@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

  CM_API_VT_FALLBACK_TO_VOICE should be defined.

@RETURNS
  TRUE   - Call compatibiliy and capability being returned.
  FALSE  - Call compatibiliy and capability could not be returned.

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_get_call_comp_cap(

  cm_call_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< requesting client ID */

  cm_call_type_e_type    call_type,
    /**< Call type */

  cm_call_comp_cap_info_s_type   *call_comp_cap_info_ptr
    /**< Pointer used to return compatibility and capability for call type */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_setup_res

@DESCRIPTION
  Command CM to send a setup message response.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_setup_res(

  cm_call_cmd_cb_f_type         cmd_cb_func,
    /**< client callback function */

  void                          *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type             client_id,
    /**< answering client */

  cm_call_id_type               call_id,
    /**< call ID of the call */

  const cm_setup_res_params_s_type   *setup_params_ptr
    /**< pointer to mode specific data */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_pdp_modify

@DESCRIPTION
  Command CM to request a PDP modify command.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_pdp_modify(

  cm_call_cmd_cb_f_type         cmd_cb_func,
    /**< client callback function */

  void                          *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type             client_id,
    /**< answering client */

  cm_call_id_type               call_id,
    /**< call ID of the call */

  const cm_pdp_modify_params_s_type   *modify_params_ptr
    /**< pointer to command data */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_rab_reestablish

@DESCRIPTION
  Command CM to send a RAB reestablish request.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_rab_reestablish(

  cm_call_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type              client_id,
    /**< answering client */

  cm_call_id_type                call_id,
    /**< call ID of the call */

  const cm_rab_reestab_params_s_type   *reestab_params_ptr
    /**< pointer to mode specific data */

);

/*===========================================================================

@FUNCTION cm_mm_call_cmd_ps_data_available

@DESCRIPTION
  Inform CM that data is available for transmission.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_ps_data_available(

  cm_call_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type              client_id
    /**< requesting client ID */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_ps_sig_release

@DESCRIPTION
  Request CM to release PS signaling.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURN VALUE
  TRUE - request sent, FALSE - No buffer to send request

@SIDE EFFECTS
  If command is successful, CM clients will be notified of the
  corresponding CM event.

===========================================================================*/
extern boolean cm_mm_call_cmd_ps_sig_release(

  cm_call_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type              client_id
    /**< requesting client ID */

);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_handover_req

@DESCRIPTION
  Command CM to complete the handoff between different RAT.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURN VALUE
  TRUE - request sent, FALSE - No buffer to send request

@SIDE EFFECTS
  If command is successful, CM clients will be notified of the
  corresponding CM event.

===========================================================================*/
boolean cm_mm_call_cmd_handover_req
(

  cm_call_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< originating client */

  cm_call_type_e_type    call_type,
    /**< call type - voice, data, etc. */

  cm_call_state_e_type   call_state,
    /**< Call state - orig, incoming or conv */

  cm_call_id_type        *return_call_id_ptr
    /**< call ID will be allocated and returned */

);

/** @defgroup DSTF Data Session Types & Functions
**                DATA SESSION TYPES & FUNCTIONS
** This block group all the functionality that is associated with
** data session callback functions.
**
** When call manager ends a data call, it consults the data session callback
** functions for the following information:
**
*    1. Total number of bytes received and transmitted during the data call.
*
@{
*/

typedef enum cm_data_session_status_e {

  CM_DATA_SESSION_CB_ERR_NONE=-1,
    /**< @internal */

  CM_DATA_SESSION_CB_OK,
    /**< No error, request was completed successfully */

  CM_DATA_SESSION_ERR_NULL_DATA_SESSION_TOTAL_BYTE_CTRS_FUNC,
    /**< Null function provided for checking if a request is time-constraint */

  CM_DATA_SESSION_ERR_DATA_SESSION_TOTAL_BYTE_CTRS_FUNC_PREV_REG,
    /**< Get Daa Seesion Total Byte Ctr function already registered */

  CM_DATA_SESSION_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_DATA_SESSION_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_data_session_status_e_type;

/** Type for get data session byte counters callback functions.
**
** This callback function is provided to CM so CM can obtain the
** number of total number of bytes received and transmitted during
** a data call.
**
** NOTE! Client's provided callback functions must be reentrant since they
** might be called from client, as well as, CM context simultaneously.
*/
typedef boolean (cm_get_data_session_total_byte_ctrs_cb_f_type) (

    cm_call_id_type                call_id,
    /**< call ID of the call */

    uint32                        *bytes_received,
    /**< Number of bytes received during the call */

    uint32                        *bytes_transmitted
    /**< Number of bytes transmitted during the call */
);

/**===========================================================================

@FUNCTION cm_data_session_reg

@DESCRIPTION
  Register data session callback functions with CM

  When call manager ends a data call, it consults the data session callback
  functions for the following information:

     1. Total number of bytes received and transmitted during the data call.

@DEPENDENCIES
  CM must have already been initialized with cm_init_before_task_start().

@RETURNS
  Status of registration

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern cm_data_session_status_e_type cm_data_session_reg(

  cm_get_data_session_total_byte_ctrs_cb_f_type
                                *data_session_total_byte_ctrs_cb_func_ptr
    /**< Pointer to data session total byte counters callback function */

);

/** Register Supplementary Service Parameters.
*/
typedef struct cm_reg_ss_params_s {

  uint8                                ss_code;
    /**< SS code */

  uint8                                ss_ref;
    /**< SS reference */

  basic_service_s_type                 basic_service;
    /**< Basic service group information */

  cm_called_party_bcd_no_s_type        fwd_to_num;
    /**< Forwarded to number */

  cm_called_party_subaddress_s_type    fwd_to_subaddr;
    /**< Forwarded to subaddress */

  ie_no_reply_condition_timer_s_type   nr_timer;
    /**< No reply condition timer */

} cm_reg_ss_params_s_type;

/** Erase Supplementary Service Request
*/
typedef struct cm_erase_ss_params_s {

  uint8                     ss_ref;
    /**< SS reference */

  uint8                     ss_code;
    /**< SS code */

  basic_service_s_type      basic_service;
    /**< Basic service group information */

} cm_erase_ss_params_s_type;

/** Activate Supplementary Service Parameters
*/
typedef struct cm_act_ss_params_s {

  uint8                     ss_ref;
    /**< SS reference */

  uint8                     ss_code;
    /**< SS code */

  basic_service_s_type      basic_service;
    /**< Basic service group information */

} cm_act_ss_params_s_type;

/** Deactivate Supplementary Service Parameters
*/
typedef struct cm_deact_ss_params_s {

  uint8                     ss_ref;
    /**< SS reference */

  uint8                     ss_code;
    /**< SS code */

  basic_service_s_type      basic_service;
    /**< Basic service group information */


  cm_ccbs_indx_type         ccbs_indx;
    /**< Clients should check for CM_API_CCBS
    ** to use this field
    ** Field used only for ss_code == CCBS
    **
    ** ccbs_indx = CM_CCBS_INDX_INVALID, results
    **   deact of all pending ccbs requests.
    **
    ** ccbs_indx = valid, results in one particular
    **   ccbs getting deactivated.
  */

} cm_deact_ss_params_s_type;

/** Interrogate Supplementary Service Parameters
*/
typedef struct
{
  uint8                     ss_ref;
    /**< SS reference */

  uint8                     ss_code;
    /**< SS code */

  basic_service_s_type      basic_service;
    /**< Basic service group information */

  cm_ccbs_indx_type         ccbs_indx;
    /**< Clients should check for CM_API_CCBS
    ** to use this field
    ** Field used only for ss_code == CCBS
    **
    ** ccbs_indx = CM_CCBS_INDX_INVALID, results
    **   deact of all pending ccbs requests.
    **
    ** ccbs_indx = valid, results in one particular
    **   ccbs getting deactivated.
    */

} cm_interr_ss_params_s_type;

/** Register Password Parameters.
*/
typedef struct cm_reg_pwd_params_s {

  ie_ss_code_s_type       ss_code;
    /**< SS code */

  uint8                   ss_ref;
    /**< SS reference */

  ie_ss_password_s_type   ss_old_pwd;
    /**< Old password */

  ie_ss_password_s_type   ss_new_pwd;
    /**< New password */

  ie_ss_password_s_type   ss_new_pwd_again;
    /**< Confirmation of new password */

} cm_reg_pwd_params_s_type;

/** Process Unstructured SS Parameters
*/
typedef  struct cm_uss_params_s {

  uint8                  ss_ref;
    /**< SS reference */

  uss_data_s_type        uss_data;
    /**< Process unstructured SS request data */

} cm_uss_params_s_type;

/** Release Supplementary Service Parameters.
*/
typedef struct cm_release_ss_params_s {

  uint8                ss_ref;
    /**< SS reference */

  uint8                ss_oper;
    /**< SS operation to be released */

} cm_release_ss_params_s_type;

/* Invalid user zone id
*/
#define CM_INVALID_UZID         (-1)

/* Default avoid time for avoid system command from UI == 100 hours
*/
#define CM_DFLT_AVOID_SYS_TIME  (360000)

/** Enumeration of phone commands client are able to send to CM.
*/
typedef enum cm_ph_cmd_e {

  CM_PH_CMD_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_PH_CMD_OPRT_MODE,
    /**< Change the operating mode */

  CM_PH_CMD_SYS_SEL_PREF,
    /**< Change the system selection pref - SD20 */

  CM_PH_CMD_ANSWER_VOICE,
    /**< Change the answer-voice-as-data setting. CDMA Only */

  CM_PH_CMD_NAM_SEL,
    /**< Change the NAM selection. CDMA Only */

  /* 4 */
  CM_PH_CMD_CLIENT_ACT,
    /**< A CM client activated itself. Internal Command. No client
    ** can invoke this command */

  CM_PH_CMD_INFO_GET,
    /**< Get a sanpshot of the phone information in the CM */

  CM_PH_CMD_RSSI_DELTA,
    /**< Set RSSI change delta threshold for RSSI reporting */

  CM_PH_CMD_SUBSCRIPTION_AVAILABLE,
    /**< Subscription info available for use */

  /* 8 */
  CM_PH_CMD_SUBSCRIPTION_NOT_AVAILABLE,
    /**< Subscription info not available for use */

  CM_PH_CMD_SUBSCRIPTION_CHANGED,
    /**< Subscription info changed for use */

  CM_PH_CMD_GET_NETWORKS,
    /**< Get the preferred or available networks. GSM/WCDMA Only */

  CM_PH_CMD_TERMINATE_GET_NETWORKS,
    /**< Terminate the request to get the preferred
    ** or available networks. GSM/WCDMA Only */

  /* 12 */
  CM_PH_CMD_SET_PREFERRED_NETWORKS,
    /**< Client made a request to save
    ** the preferred network list to SIM/USIM. GSM/WCDMA Only. */

  CM_PH_CMD_PACKET_STATE,
    /**< Set Rm packet state. CDMA Only */

  CM_PH_CMD_VOC_ACTIVITY,
    /**< Voice activity. CDMA Only - FEATURE_JCDMA*/

  CM_PH_CMD_AVOID_SYS,
    /**< Command to avoid a particular system. CDMA Only */

  /* 16 */
  CM_PH_CMD_WAKEUP_FROM_STANDBY,
    /**< Command to wake up lower layers from deep sleep (standby) */

  CM_PH_CMD_CHANGE_RTRE_CONFIG,
    /**< Command to change RTRE configuration. CDMA Only */

  CM_PH_CMD_DDTM_PREF,
    /**< data dedicated transmission mode preference */

  CM_PH_CMD_RESET_ACM,
    /**< Reset the ACM to 0. This also resets the ability for CM to send
     * the FUNDS_LOW message.  */

  /* 20 */
  CM_PH_CMD_SET_ACMMAX,
    /**< Set the ACMmax to the value given. This command could cause
     * the FUNDS_LOW message to be resent if the new value would cause
     * calls to end within an estimated 30 seconds.  */

  CM_PH_CMD_LINE_SWITCHING,
    /**<
    ** Allow or prevent the user from switching lines
    ** (i.e changing selected line).
    ** Sent to CM by UI client
    ** FEATURE_ALS
    */

  CM_PH_CMD_SELECTED_LINE,
    /**<
    ** Set selected line,
    ** Sent to CM by UI client
    ** FEATURE_ALS
    */

  CM_PH_CMD_ALS_SIM_INFO_AVAIL,
    /**<
    ** All ALS info is available.
    ** Sent to CM by ALS custom when all ALS related items
    ** have been read from the SIM.
    ** FEATURE_ALS
    */

  /* 24 */
  CM_PH_CMD_LINE_SWITCHING_SAVED,
    /**<
    ** Sent to CM by ALS custom when line switching
    ** setting has been written to the SIM
    ** Update setting in CM and notify clients.
    ** FEATURE_ALS
    */

  CM_PH_CMD_SELECTED_LINE_SAVED,
    /**<
    ** Sent to CM by ALS custom when selected line
    ** has been written to the SIM
    ** Update setting in CM and notify clients.
    ** FEATURE_ALS
    */

  CM_PH_CMD_UPDATE_CDMA_CAPABILITY,
    /**< Update the CDMA capability information.
    */

  CM_PH_CMD_CLIENT_RELEASE,
    /**< @internal
    ** Release the client object associated
    ** with the deregistering client.
    */

  /* 28 */
  CM_PH_CMD_SIGNAL_STRENGTH_DELTA,
    /**<
    ** Set RSSI/ECIO/IO change delta threshold for Signal Strength reporting
    */

  /* 29 */
  CM_PH_CMD_WPS_START,
    /**< Command to get WLAN security credentials using WPS procedure.
    */

  /* 30 */
  CM_PH_CMD_WPS_ABORT,
    /**< Command to abort the WPS procedure.
    */

   CM_PH_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
   , CM_PH_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ph_cmd_e_type;

/** Enumeration of phone command errors returned by phone command
** callback functions.
*/
typedef enum cm_ph_cmd_err_e {

  CM_PH_CMD_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_PH_CMD_ERR_NOERR,
    /**< No errors found */

  CM_PH_CMD_ERR_ANSWER_VOICE_F,
    /**< Answer voice feature is not defined */

  /* Error codes resulting from clients feeding a phone command
  ** function with bad or inappropriate parameters.
  */

  CM_PH_CMD_ERR_CLIENT_ID_P,
    /**< Invalid client ID; null or not initialized */

  CM_PH_CMD_ERR_OPRT_MODE_P,
    /**< Bad operating mode parameter */

  /* 4 */
  CM_PH_CMD_ERR_MODE_PREF_P,
    /**< Bad mode preference parameter */

  CM_PH_CMD_ERR_PREF_TERM_P,
    /**< Bad mode term parameter */

  CM_PH_CMD_ERR_SYS_PREF_P,
    /**< Bad system preference parameter - obsolete in SD 2.0 */

  CM_PH_CMD_ERR_BAND_PREF_P,
    /**< Bad band preference parameter */

  /* 8 */
  CM_PH_CMD_ERR_ROAM_PREF_P,
    /**< Bad roam preference parameter */

  CM_PH_CMD_ERR_ANSWER_VOICE_P,
    /**< Bad answer voice parameter. CDMA Only */

  CM_PH_CMD_ERR_ANSWER_DURATION_P,
    /**< Bad answer duration parameter. When indicating a temp. setting,
    ** such as CM_ANSWER_VOICE_AS_FAX_ONCE or DB_VOICE_AS_MODEM_ONCE
    ** a non-zero duration must be indicated, as well. CDMA Only */

  CM_PH_CMD_ERR_NAM_P,
    /**< Bad NAM parameter. CDMA Only */

  /* 12 */
  CM_PH_CMD_ERR_PACKET_STATE_P,
    /**< Bad packet state parameter. CDMA Only */

  CM_PH_CMD_ERR_HYBR_PREF_P,
   /**< Hybrid preference */

  CM_PH_CMD_ERR_SERVICE_DOMAIN_P,
    /**< Invaild service domain parameter. GSM/WCDMA Only */

  CM_PH_CMD_ERR_ACQ_ORDER_PREF_P,
    /**< Invalid acquisition order preference parameter. GSM/WCDMA Only */

  /* 16 */
  CM_PH_CMD_ERR_NETWORK_LIST_TYPE_P,
    /**< Invalid network list type parameter. GSM/WCDMA Only */

  CM_PH_CMD_ERR_NETWORK_SEL_MODE_P,
    /**< Invalid network selection mode parameter. GSM/WCDMA Only */

  CM_PH_CMD_ERR_SYSTEM_MODE_P,
    /**< Invalid system mode parameter. GSM/WCDMA Only */

  CM_PH_CMD_ERR_PLMN_P,
    /**< Invalid PLMN identifier parameter. GSM/WCDMA Only */

  /* 20 */
  CM_PH_CMD_ERR_RTRE_CONFIG_P,
    /**< Invalid RTRE configuration parameter. CDMA Only */

  CM_PH_CMD_ERR_CDMA_CAPABILITY_P,
    /**< Invalid CDMA capability parameter error. */

  CM_PH_CMD_ERR_PRL_PREF_P,
    /**< Bad prl preference parameter */

  CM_PH_CMD_ERR_WLAN_PREF_P,
    /**< Bad WLAN preference parameter */
    /* Clients check CM_API_WLAN for WLAN support */

  /* Error codes resulting from clients trying to instruct
  ** CM to perform inappropriate actions relative to the current
  ** state of the phone.
  */

  /* 24 */
  CM_PH_CMD_ERR_IN_USE_S,
    /**< Phone is in-use (i.e. in a call) */

  CM_PH_CMD_ERR_ONLINE_S,
    /**< Phone is offline */

  CM_PH_CMD_ERR_OPRT_MODE_S,
    /**< Invalid command or operating mode switch relatively to the current
    ** operating mode - e.g. OFFLINE -> ONLINE */

  CM_PH_CMD_ERR_MODE_PREF_S,
    /**< Invalid mode preference selection relatively to what we
    ** currently have in the PRL - e.g. ANALOG_ONLY when there are no
    ** analog entries in the PRL */

  /* 28 */
  CM_PH_CMD_ERR_SYS_PREF_S,
    /**< Invalid system preference selection for this target
    ** - e.g. A_ONLY for a none 800 MHz target, etc. - obsolete in SD20*/

  CM_PH_CMD_ERR_SYS_SEL_PREF_S,
    /**< Invalid system selection preference for this target/PRL
    ** - e.g. band-class 1 for a PCS only target
    **
    ** Also returned when CM_NETWORK_SEL_MODE_PREF_HPLMN_SRCH is requested other
    ** than in Automatic mode */

  CM_PH_CMD_ERR_HYBR_PREF_S,
    /**< FEATURE_HDR - Invalid command or hybrid preference selection */

  CM_PH_CMD_ERR_SUBSCRIPTION_AVAILABLE_S,
    /**< Invalid command relative to the current value of subscription
    ** available - e.g. transitioning from subscription available to
    ** subscription available is invalid or issuing a command when
    ** the subscription information is not available. GSM/WCDMA Only. */

  /* 32 */
  CM_PH_CMD_ERR_GET_NETWORKS_S,
    /**< A terminate get networks request was made and
    ** a request for available network list was not previously made.
    **
    ** OR
    **
    ** A get network request was made while a previous get network
    ** request for different technology was still pending.
    **/

  /* Error codes resulting from operational limitation
  ** of CM.
  */

  CM_PH_CMD_ERR_NO_BUF_L,
    /**< No available CM command buffers to queue the command */

  CM_PH_CMD_ERR_MC_COM_L,
    /**< MC communication problems */

  /* Error codes related to "Avoid system" command.
  */

  CM_PH_CMD_ERR_AVOID_SYS_P,
      /**< Atleast one of the parameters in "Avoid system"
      ** command from phone client was invalid. CDMA Only
      */

  /* 36 */
  CM_PH_CMD_ERR_SYS_NOT_IN_UZ,
      /**< Indicates that the MS is not in user zone, when
      ** "Avoid system" on user zone was processed. CDMA Only
      */

  CM_PH_CMD_ERR_OTHER,
    /**< A problem other than the above was found */

  CM_PH_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  CM_PH_CMD_ERR_CURRENT_NAM_IS_NOT_RUIM_NAM_S,
    /**< Current NAM is not RUIM NAM. CDMA Only */

  /* 40 */
  CM_PH_CMD_ERR_USER_PREFERRED_NETWORK_LIST_ACCESS,
    /**< An error occurred accessing the user preferred network list.
    ** GSM/WCDMA Only. */

  CM_PH_CMD_ERR_DDTM_PREF_P,
    /**< Bad DDTM pref parameter
    */

  CM_PH_CMD_ERR_DDTM_NUM_SRV_OPTIONS_P,
    /**< Bad number of service options.
    */

  CM_PH_CMD_ERR_LINE_SWITCHING_P,
    /**<
    ** Invalid line switching parameter
    ** FEATURE_ALS
    */

  /* 44 */
  CM_PH_CMD_ERR_LINE_SWITCHING_S,
    /**<
    ** Client requested that selected line be changed
    ** but line switching is not allowed
    ** FEATURE_ALS
    */

  CM_PH_CMD_ERR_SELECTED_LINE_P,
    /**<
    ** Invalid selected line parameter
    ** FEATURE_ALS
    */

  CM_PH_CMD_ERR_ALS_NOT_SUPPORTED_S,
    /**<
    ** ALS is not supported and therefore ALS
    ** cmd cannot be processed
    ** FEATURE_ALS
    */

  CM_PH_CMD_ERR_ALS_SIM_WRITE_FAILED_S,
    /**<
    ** SIM write failed
    ** FEATURE_ALS
    */

  CM_PH_CMD_ERR_AOC_NOT_READY_S,
     /**< Values related to advice of charge cannot be
     ** read or written at this time.
     **
     ** Clients need to check for CM_API_AOC_INFO before
     ** using this enum.
     */

  /* 49 */
  CM_PH_CMD_ERR_NET_TYPE_P,
    /**< Invalid Network type requested in
    ** cm_ph_cmd_get_networks API.
    ** Clients check CM_API_WLAN for WLAN support */

  CM_PH_CMD_ERR_DDTM_SRV_OPTIONS_LIST_P,
    /**< Bad service options pointer
    */

  CM_PH_CMD_ERR_INVALID_HYBR_PREF_MODE_PREF,
    /**< Invalid Hybr pref and mode pref combination
    */

  CM_PH_CMD_ERR_MODE_PREF_CHANGE_NOT_ALLOWED_S,
    /**< mode pref change is not allowed 
    */

  CM_PH_CMD_ERR_INVALID_WPS_MODE,
    /**< Invalid WPS mode used in WPS start command.
    */

  CM_PH_CMD_ERR_INVALID_WPS_CONFIG_METHOD,
    /**< Invalid WPS config method used in WPS start command.
    */

  CM_PH_CMD_ERR_INVALID_WPS_DEV_PASSWD,
    /**< Invalid WPS device password used in WPS start command.
    */

  CM_PH_CMD_ERR_NO_WPS_IN_PROGRESS,
    /**< Client request to abort WPS even when it is not started.
    */

  CM_PH_CMD_ERR_WPS_ALREADY_IN_PROGRESS,
    /**< Client send another WPS Start request to abort WPS when 
    ** the previous request has not been completed yet.
    */

  CM_PH_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PH_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ph_cmd_err_e_type;

/** Enumeration of phone events.
** Clients are able to register with CM to be notified of any subsets
** of these phone events.
*/
typedef enum cm_ph_event_e {

  CM_PH_EVENT_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_PH_EVENT_OPRT_MODE,
    /**< Operating mode was changed */

  CM_PH_EVENT_TEST_CONTROL_TYPE,
    /**< Operating mode type needs to be updated*/

  CM_PH_EVENT_SYS_SEL_PREF,
    /**< System Selection pref was changed */

  CM_PH_EVENT_ANSWER_VOICE,
    /**< Answer voice as data was changed. CDMA Only. */

  /* 4 */
  CM_PH_EVENT_NAM_SEL,
    /**< NAM selection was changed. CDMA Only.  */

  CM_PH_EVENT_CURR_NAM,
    /**< Current NAM was changed. CDMA Only.  */

  CM_PH_EVENT_IN_USE_STATE,
    /**< In use state was changed */

  CM_PH_EVENT_CDMA_LOCK_MODE,
    /**< CDMA lock mode was changed. CDMA Only.  */

  /* 8 */
  CM_PH_EVENT_UZ_CHANGED,
    /**< User zone selection was changed. CDMA Only.  */

  CM_PH_EVENT_MAINTREQ,
    /**< CDMA maintenance required command. CDMA Only.  */

  CM_PH_EVENT_STANDBY_SLEEP,
    /**< Entering powerdown sleep mode */

  CM_PH_EVENT_STANDBY_WAKE,
    /**< Existing powerdown sleep mode */

  /* 12 */
  CM_PH_EVENT_INFO,
    /**< Phone information, this event only sent to the client
    ** that request this information through cm_ph_cmd_get_ph_info */

  CM_PH_EVENT_PACKET_STATE,
    /**< Packet state was changed. CDMA Only. */

  CM_PH_EVENT_INFO_AVAIL,
    /**< Phone information is now available. Automatically generated
    ** after a client does activation */

  CM_PH_EVENT_SUBSCRIPTION_AVAILABLE,
    /**< A client is informing CM that the subscription info is available */

  /* 16 */
  CM_PH_EVENT_SUBSCRIPTION_NOT_AVAILABLE,
    /**< A client is informing CM that the subscription info is not available */

  CM_PH_EVENT_SUBSCRIPTION_CHANGED,
    /**< A client is informing CM that the subscription info is changed */

  CM_PH_EVENT_AVAILABLE_NETWORKS_CONF,
    /**< The requested available networks are available. GSM/WCDMA/WLAN Only. */

  CM_PH_EVENT_PREFERRED_NETWORKS_CONF,
    /**< The requested preferred networks are available. GSM/WCDMA Only */

  /* 20 */
  CM_PH_EVENT_FUNDS_LOW,
    /**< Funds running low. GSM/WCDMA Only. */

  CM_PH_EVENT_WAKEUP_FROM_STANDBY,
    /**< Command is sent to lower layers to wake up from deep sleep(standby) */

  CM_PH_EVENT_NVRUIM_CONFIG_CHANGED,
    /**< RTRE configuration changed. CDMA Only */

  CM_PH_EVENT_PREFERRED_NETWORKS_SET,
    /**<
    ** The requested preferred networks were
    ** written to the (U)SIM. GSM/WCDMA Only
    */

  /* 24 */
  CM_PH_EVENT_DDTM_PREF,
    /**< DDTM pref change  */

  CM_PH_EVENT_PS_ATTACH_FAILED,
    /**<
    ** A client request for Packet Service attach failed.  Sent if the
    ** cm_ph_cmd_sys_sel_pref() API is called with the srv_domain_pref
    ** parameter set to CM_SRV_DOMAIN_PREF_PS_ATTACH and the PS attach
    ** fails.
    */
  CM_PH_EVENT_RESET_ACM_COMPLETED,
    /**< As requested the ACM has been reset on the (U)SIM. GSM/WCDMA Only */

  CM_PH_EVENT_SET_ACMMAX_COMPLETED,
    /**< The requested value was written to the (U)SIM. GSM/WCDMA Only */

  /* 28 */
  CM_PH_EVENT_CDMA_CAPABILITY_UPDATED,
    /**< A event to indicate that the CDMA capability was updated. */

  CM_PH_EVENT_LINE_SWITCHING,
    /**<
    ** Line switching setting has been updated in CM
    ** as per client's request
    ** FEATURE_ALS
    */

   CM_PH_EVENT_SELECTED_LINE,
    /**<
    ** Selected line setting has been updated in CM
    ** as per client's request
    ** FEATURE_ALS
    */

  CM_PH_EVENT_SECONDARY_MSM,
    /**< Invoke event call back even if the event is from secondary MSM.
    ** CM will not generate any events with this, but is used by
    ** thin client CM layer to call client call backs for events from
    ** secondary msm.
    */

  /* 32 */
  CM_PH_EVENT_TERMINATE_GET_NETWORKS,
    /**< Indicate that the current get network request is terminated.
    */

  CM_PH_EVENT_DDTM_STATUS,
    /**< update the DDTM status.
    ** DDTM status = ON if either
    **    (DDTM_PREF is ON)  AND (GPS fix is in progress)
    **         OR
    **    (DDTM_PREF is ON) AND ( In hybrid HDR call and no MO SMS and no MO DBM)
    ** Event triggered if the DDTM status changes
    */

  CM_PH_EVENT_CCBS_STORE_INFO_CHANGED,
    /**< Clients need to check for CM_API_CCBS before
    ** using this event.
    ** Event generated when an entry is added to or removed from
    ** ccbs_store_info of phone event structure
    */

  CM_PH_EVENT_WPS_COMPLETED,
    /**< Event generated when the WPS procedure has been completed.
    ** Completed does not necessarily mean any credential was obtained.
    ** Clients need to check for CM_API_WLAN_WPS.
    */

  CM_PH_EVENT_WPS_ABORTED,
    /**< Event generated when the WPS procedure is aborted by a client.
    ** Clients need to check for CM_API_WLAN_WPS.
    */

  CM_PH_EVENT_WPS_START,
    /**< Event generated when the WPS security credentials are requested by the clients
    ** Clients need to check for CM_API_WLAN_WPS.
    */

  CM_PH_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PH_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ph_event_e_type;

/** The current state of the phone.
*/
typedef enum cm_ph_state_e {

  CM_PH_STATE_NONE = -1,
    /**< @internal */

  CM_PH_STATE_NORMAL,
    /**< The phone is in Normal operation */

  CM_PH_STATE_EMERG_CB,
    /**< The phone is in Emergency call back mode */

  CM_PH_STATE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PH_STATE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */
} cm_ph_state_e_type;

/** Enumeration of mode preferences.
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_mode_pref_e {

  CM_MODE_PREF_NONE=-1,
    /**< @internal */

  CM_MODE_PREF_AMPS_ONLY=0,
    /**< = NV_MODE_ANALOG_ONLY, Service is limited to analog only */

  CM_MODE_PREF_DIGITAL_ONLY=1,
    /**< = NV_MODE_DIGITAL_ONLY, Service is limited to digital
    ** (CDMA, HDR, GW) only */

  CM_MODE_PREF_AUTOMATIC=2,
    /**< = NV_MODE_AUTOMATIC, Determine the mode automatically */

  CM_MODE_PREF_EMERGENCY=3,
    /**< = NV_MODE_EMERGENCY, Emergency mode
    **
    **  It's intended to be used internally by CM.
    **  Client is not allowed to use it as parameter to change system
    **  selection preference command.
    **
     */

  /* For compatibility with QPST, do not change values or
  ** order. We start with NV_MODE_CELL_CDMA_ONLY+1 (i.e. 9).
  */
  CM_MODE_PREF_CDMA_ONLY = 9,
    /**<
    ** Service is limited to CDMA only
    */

  CM_MODE_PREF_HDR_ONLY=10,
    /**<
    ** Service is limited to HDR only
    */

  CM_MODE_PREF_CDMA_AMPS_ONLY=11,
    /**<
    ** Service is limited to CDMA and AMPS only
    */

  CM_MODE_PREF_GPS_ONLY=12,
    /**<
    ** Service is limited to GPS only
    */

  /*
  ** The following enums are the radio access technologies for
  ** WCDMA and GSM.
  */
  CM_MODE_PREF_GSM_ONLY=13,
    /**<
    ** Service is limited to GSM only
    */

  CM_MODE_PREF_WCDMA_ONLY=14,
    /**<
    ** Service is limited to WCMDA only
    */

  /*
  ** Others
  */
  CM_MODE_PREF_PERSISTENT=15,
    /**<
    ** Return to persistent mode preference.
    ** Will be mapped to sth else by CM,
    ** ph_ptr->mode_pref is never set to this value
    */

  CM_MODE_PREF_NO_CHANGE=16,
    /**<
    ** Do not change the mode preference.
    ** Will be mapped to sth else by CM,
    ** ph_ptr->mode_pref is never set to this value
    */

  /*
  ** Even though logically the below belog with
  ** enums listed above, they were added at the end
  ** to not break compatibility with test tools
  */

  CM_MODE_PREF_ANY_BUT_HDR=17,
    /**<
    ** Use any service but HDR
    */

  CM_MODE_PREF_CURRENT_LESS_HDR=18,
    /**<
    ** Remove HDR component from current mode preference.
    ** Will be mapped to sth else by CM,
    ** ph_ptr->mode_pref is never set to this value
    */

  CM_MODE_PREF_GSM_WCDMA_ONLY=19,
    /**<
    ** Service is limited to GSM and WCDMA only
    */

  CM_MODE_PREF_DIGITAL_LESS_HDR_ONLY=20,
    /**< Acquire digital, non-HDR mode systems only
    ** (CDMA or GSM or WCDMA )
    */

  CM_MODE_PREF_CURRENT_LESS_HDR_AND_AMPS=21,
    /**<
    ** Remove HDR and AMPS component from current mode preference.
    ** Will be mapped to sth else by CM,
    ** ph_ptr->mode_pref is never set to this value
    */

  CM_MODE_PREF_CDMA_HDR_ONLY=22,
    /**<
    ** Acquire CDMA or HDR systems only
    */

  CM_MODE_PREF_CDMA_AMPS_HDR_ONLY=23,
    /**<
    ** Acquire CDMA or AMPS or HDR systems only
    */

  CM_MODE_PREF_CURRENT_LESS_AMPS=24,
    /**<
    ** Remove AMPS component from current mode preference.
    ** Will be mapped to sth else by CM,
    ** ph_ptr->mode_pref is never set to this value
    */
  /* Clients check CM_API_WLAN for WLAN support for following
  ** preferences.
  */
  CM_MODE_PREF_WLAN_ONLY=25,
    /**<
    ** Acquire WLAN systems only
    */

  CM_MODE_PREF_CDMA_WLAN=26,
    /**<
    ** Acquire CDMA and WLAN systems only
    */

  CM_MODE_PREF_HDR_WLAN=27,
    /**<
    ** Acquire HDR and WLAN systems only
    */

  CM_MODE_PREF_CDMA_HDR_WLAN=28,
    /**<
    ** Acquire CDMA, HDR and WLAN systems only
    */

  CM_MODE_PREF_GSM_WLAN=29,
    /**<
    ** Acquire GSM and WLAN systems only
    */

  CM_MODE_PREF_WCDMA_WLAN=30,
    /**<
    ** Acquire WCDMA and WLAN systems only
    */

  CM_MODE_PREF_GW_WLAN=31,
    /**<
    ** Acquire GSM/WCDMA and WLAN systems only
    */

  CM_MODE_PREF_CURRENT_PLUS_WLAN=32,
    /**<
    ** Acquire WLAN systems in addition to current system
    */

  CM_MODE_PREF_CURRENT_LESS_WLAN=33,
    /**<
    ** Remove WLAN systems from the current system
    */

  CM_MODE_PREF_CDMA_AMPS_HDR_WLAN_ONLY = 34,
    /**<
    ** Acquire CDMA, AMPS, HDR and WLAN systems.
    */

  CM_MODE_PREF_CDMA_AMPS_WLAN_ONLY = 35,
    /**<
    ** Acquire CDMA, AMPS and WLAN systems.
    */

  CM_MODE_PREF_INTERSECT_OR_FORCE = 36,
    /**< Acquire the mode that is common (intersection of) the current mode and
    ** the requested mode, if the intersection is NULL, then Force the
    ** requested preferences
    */

  CM_MODE_PREF_ANY_BUT_HDR_WLAN = 37,
    /**<
    ** Use any service except HDR and WLAN
    */

    /**< @internal */

  CM_MODE_PREF_MAX
    /* FOR INTERNAL USE OF CM ONLY!
    */

  #ifdef FEATURE_RPC
  , CM_MODE_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_mode_pref_e_type;

/** Enumeration of GSM/WCDMA acquisition order
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_gw_acq_order_pref_e {

  CM_GW_ACQ_ORDER_PREF_NONE = -1,
    /**< @internal */

  CM_GW_ACQ_ORDER_PREF_AUTOMATIC=0,
    /**< Determine mode automatically from the PRL order */

  CM_GW_ACQ_ORDER_PREF_GSM_WCDMA=1,
    /**< Acqisition order is first GSM followed by WCDMA */

  CM_GW_ACQ_ORDER_PREF_WCDMA_GSM=2,
    /**< Acqisition order is first WCDMA followed by GSM */

  CM_GW_ACQ_ORDER_PREF_NO_CHANGE=3,
    /**< Do not change GSM/WCDMA acquisition order */

  CM_GW_ACQ_ORDER_PREF_PERSISTENT=4,
    /**< Return to acq order preference given by NV.
    **
    ** Clients need to check for CM_API_PERSISTENT_PREF
    ** before using this
    */

  CM_GW_ACQ_ORDER_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_MODE_GW_ACQ_ORDER_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_gw_acq_order_pref_e_type;

/** Enumeration of mode terms - i.e designate the mode span.
*/
typedef enum cm_pref_term_e {

  CM_PREF_TERM_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_PREF_TERM_PERMANENT,
    /**< Permanent mode change */

  CM_PREF_TERM_PWR_CYCLE,
    /**< Until power cycle */

  CM_PREF_TERM_1_CALL,
    /**< Until end of next call or power-cycle */

  CM_PREF_TERM_1_CALL_OR_TIME,
    /**< Until end of next call, specified timeout or power-cycle */

  /* 4 */
  CM_PREF_TERM_CM_1_CALL,
  CM_PREF_TERM_CM_1_CALL_PLUS,
  CM_PREF_TERM_CM_MO_SMS,
    /**< Mode terms that are assigned automatically by call manager
    ** when mode is forced on the fly during a call origination or
    ** mobile originated SMS.
    **
    ** CM unforce the mode back to it original settings at end of
    ** call or some short time after end of call/message transmission.
    **
    ** NOTE! These mode term should NOT be used by clients
    ** when changing the mode preference */

  CM_PREF_TERM_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PREF_TERM_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_pref_term_e_type;

/** 64 Bit cm_band_pref is to be used if CM_API_BAND_PREF_64_BIT is defined.
*/

typedef uint64 cm_band_pref_e_type;

#define  CM_BAND_PREF_NONE   (cm_band_pref_e_type)0
    /**< @internal */

#define  CM_BAND_PREF_BC0_A  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC0_A))
    /**< Acquire band class 0, A-Side systems only */

#define  CM_BAND_PREF_BC0_B  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC0_B))
    /**< Acquire band class 0, B-Side systems only */

#define  CM_BAND_PREF_BC0    ((cm_band_pref_e_type)(SYS_BM_64BIT(SYS_SBAND_BC0_A)|SYS_BM_64BIT(SYS_SBAND_BC0_B)))
    /**< Acquire band class 0 systems only */

#define  CM_BAND_PREF_BC1    ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC1))
    /**< Acquire band class 1 systems only */

#define  CM_BAND_PREF_BC3    ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC3))
    /**< Acquire band class 3 systems only */

#define  CM_BAND_PREF_BC4    ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC4))
    /**< Acquire band class 4 systems only */

#define  CM_BAND_PREF_BC5    ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC5))
    /**< Acquire band class 5 systems only */

#define  CM_BAND_PREF_GSM_DCS_1800  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_GSM_DCS_1800))
    /**< Acquire GSM DCS systems only */

#define  CM_BAND_PREF_GSM_EGSM_900  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_GSM_EGSM_900))
    /**< Acquire GSM Extended GSM 900 systems only */

#define  CM_BAND_PREF_GSM_PGSM_900  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_GSM_PGSM_900))
    /**< Acquire GSM Primary GSM 900 systems only */

#define  CM_BAND_PREF_BC6  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC6))
    /**< Acquire band class 6 systems only */

#define  CM_BAND_PREF_BC7  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC7))
    /**< Acquire band class 7 systems only */

#define  CM_BAND_PREF_BC8 ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC8))
    /**< Acquire band class 8 systems only */

#define  CM_BAND_PREF_BC9  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC9))
    /**< Acquire band class 9 systems only */

#define  CM_BAND_PREF_BC10  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC10))
    /**< Acquire band class 10 systems only */

#define  CM_BAND_PREF_BC11  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC11))
    /**< Acquire band class 11 systems only */

/** Clients should check for CM_API_BAND_CLASS_12_14_15_16
** before using this macro
*/
#define  CM_BAND_PREF_BC12  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC12))
    /**< Acquire band class 12 systems only */

/** Clients should check for CM_API_BAND_CLASS_12_14_15_16
** before using this macro
*/
#define  CM_BAND_PREF_BC14  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC14))
    /**< Acquire band class 14 systems only */

/** Clients should check for CM_API_BAND_CLASS_12_14_15_16
** before using this macro
*/
#define  CM_BAND_PREF_BC15  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC15))
    /**< Acquire band class 15 systems only */

/** Clients should check for CM_API_BAND_CLASS_12_14_15_16
** before using this macro
*/
#define  CM_BAND_PREF_BC16  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_BC16))
    /**< Acquire band class 16 systems only */

#define  CM_BAND_PREF_GSM_450  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_GSM_450 ))
    /**< Acquire GSM 450 systems only */

#define  CM_BAND_PREF_GSM_480  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_GSM_480 ))
    /**< Acquire GSM 480 systems only */

#define  CM_BAND_PREF_GSM_750  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_GSM_750 ))
    /**< Acquire GSM 750 systems only */

#define  CM_BAND_PREF_GSM_850  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_GSM_850 ))
    /**< Acquire GSM 850 systems only */

#define  CM_BAND_PREF_GSM_RGSM_900  ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_GSM_RGSM_900))
    /**< Acquire GSM Railway GSM 900 systems only */

#define  CM_BAND_PREF_GSM_PCS_1900  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_GSM_PCS_1900 ))
    /**< Acquire GSM PCS systems only */

#define  CM_BAND_PREF_WCDMA_I_IMT_2000  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_I_IMT_2000 ))
    /**< Acquire WCDMA I IMT 2000 systems only */

#define  CM_BAND_PREF_WCDMA_II_PCS_1900  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_II_PCS_1900 ))
    /**< Acquire WCDMA II PCS systems only */

#define  CM_BAND_PREF_WCDMA_III_1700  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_III_1700 ))
    /**< Acquire WCDMA III 1700 systems only */

#define  CM_BAND_PREF_WCDMA_IV_1700  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_IV_1700 ))
    /**< Acquire WCDMA IV 1700 systems only */

#define  CM_BAND_PREF_WCDMA_V_850  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_V_850 ))
    /**< Acquire WCDMA V 850 systems only */

#define  CM_BAND_PREF_WCDMA_VI_800  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_VI_800 ))
    /**< Acquire WCDMA VI 800 systems only */

/** Clients need to check for CM_API_WCDMA900 for the following three band
** classes.
** - CM_BAND_PREF_WCDMA_VII_2600
** - CM_BAND_PREF_WCDMA_VIII_900
** - CM_BAND_PREF_WCDMA_IX_1700
*/
#define CM_BAND_PREF_WCDMA_VII_2600      ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_VII_2600 ))
    /**< Acquire WCDMA EUROPE 2600 systems only */

#define CM_BAND_PREF_WCDMA_VIII_900      ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_VIII_900 ))
    /**< Acquire WCDMA EUROPE & CHINA 900 systems only */

#define CM_BAND_PREF_WCDMA_IX_1700      ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WCDMA_IX_1700 ))
    /**< Acquire WCDMA JAPAN 1700 systems only */

  /**< Clients check CM_API_WLAN for WLAN support for WLAN bands.*/
#define  CM_BAND_PREF_WLAN_2400_US  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_US_2400))
    /**< Acqurie WLAN in US 2.4 GHz */

#define  CM_BAND_PREF_WLAN_2400_JP  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_JAPAN_2400))
    /**< Acqurie WLAN in JP 2.4 GHz */

#define  CM_BAND_PREF_WLAN_2400_ETSI ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_EUROPE_2400))
    /**< Acqurie WLAN in Europe 2.4 GHz */

#define CM_BAND_PREF_WLAN_2400_SP    ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_SPAIN_2400))
    /**< Acqurie WLAN in SPAIN 2.4 GHz */

#define CM_BAND_PREF_WLAN_2400_FR    ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_FRANCE_2400))
    /**< Acqurie WLAN in France 2.4 GHz */

#define  CM_BAND_PREF_WLAN_5000_US  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_US_5000))
    /**< Acqurie WLAN in US 5 GHz */

#define  CM_BAND_PREF_WLAN_5000_JP  ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_JAPAN_5000))
    /**< Acqurie WLAN in JP 5 GHz */

#define  CM_BAND_PREF_WLAN_5000_ETSI ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_EUROPE_5000))
    /**< Acqurie WLAN in Europe 5 GHz */

#define CM_BAND_PREF_WLAN_5000_SP    ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_SPAIN_5000))
    /**< Acqurie WLAN in SPAIN 5 GHz */

#define CM_BAND_PREF_WLAN_5000_FR    ((cm_band_pref_e_type)SYS_BM_64BIT( SYS_SBAND_WLAN_FRANCE_5000))
    /**< Acqurie WLAN in France 5 GHz */

/** When CM_API_BAND_PREF_NO_CHANGE_ANY_MAX_UPDATE  is defined, revise the
** CM_BAND_PREF_NO_CHANGE back to the value when band pref is still 32 bit
** for backward compatible purpose. The bit 30 is reserved for NO_CHANGE.
*/
#define  CM_BAND_PREF_NO_CHANGE   (cm_band_pref_e_type)(0x40000000)
    /**< Do not change the band preference */

/** When CM_API_BAND_PREF_NO_CHANGE_ANY_MAX_UPDATE is defined, updated the
** CM_BAND_PREF_ANY to align with CM_BAND_PREF_NO_CHANGE.
*/
#define  CM_BAND_PREF_ANY   (cm_band_pref_e_type)0xFFFFFFFFBFFFFFFFULL
    /**< Acquire any band class systems
    ** ULL designates it as "unsigned long long" to get rid of compiler warnings
    ** "literal treated as unsigned long long"
    */

/** When CM_API_BAND_PREF_NO_CHANGE_ANY_MAX_UPDATE is defined, updated the
** CM_BAND_PREF_MAX to align with CM_BAND_PREF_NO_CHANGE.
*/
#define  CM_BAND_PREF_MAX       (cm_band_pref_e_type)(CM_BAND_PREF_ANY + 1)
    /**< @internal */

  //#ifdef FEATURE_RPC
  //, CM_BAND_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  //#endif /* FEATURE_RPC */

#define  CM_BAND_PREF_PERSISTENT        ((cm_band_pref_e_type)SYS_BM_64BIT(SYS_SBAND_PERSISTENT))
    /**< Return to the value given by NV
    ** Clients need to check for CM_API_PERSISTENT_PREF
    ** before using this
    */

/* Cellular and PCS band preference to band-class preference mapping.
**
** Note that IS-683-A PRL only provide support for one cellular band and one
** PCS band. Therefore we define a Cellular and PCS band preferences and map
** them to different band-classes preferences depending on the market, as
** follows:
**
** Cellular band preference is mapped to band-class 3 preference for the
** Japanese market or band-class 0 preference for any other market.
**
** PCS band preference is mapped to band-class 4 preference for the Korean
** market, band-class 5 preference for Band Class 5 market or band-class 1
** preference for any other market.
*/

  #define CM_BAND_PREF_CELL_A  CM_BAND_PREF_BC0_A  /* US Cell A */
  #define CM_BAND_PREF_CELL_B  CM_BAND_PREF_BC0_B  /* US Cell B */
  #define CM_BAND_PREF_CELL    CM_BAND_PREF_BC0    /* US Cell A/B */

  #define CM_BAND_PREF_PCS   CM_BAND_PREF_BC1  /* US PCS */

/** Enumeration of system selection roam preferences.
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_roam_pref_e {

  CM_ROAM_PREF_NONE=0,
    /**< @internal */

  CM_ROAM_PREF_HOME=SYS_BM(SYS_ROAM_STATUS_OFF),
    /**< Acquire only systems for which the roaming indication is off
    ** SD_SS_ROAM_PREF_HOME */

  CM_ROAM_PREF_ROAM_ONLY=SYS_BM(SYS_ROAM_STATUS_ON),
    /**<Acquire a system as long as its roaming indication is not off*/

  CM_ROAM_PREF_AFFIL=SYS_BM(SYS_ROAM_STATUS_OFF)|SYS_BM(SYS_ROAM_STATUS_ON),
    /**< Acquire only systems for which the roaming indication is off or
    ** solid on - i.e. not flashing. CDMA Only
    ** SD_SS_ROAM_PREF_AFFIL */

  CM_ROAM_PREF_ANY=0xFF,
    /**< Acquire systems regardless of their roaming indication
    ** SD_SS_ROAM_PREF_ANY */

  CM_ROAM_PREF_NO_CHANGE,
    /**< Do not change the roam preference */

  CM_ROAM_PREF_PERSISTENT,
    /**< Return to roam preference as given by NV
    **
    ** Clients need to check for CM_API_PERSISTENT_PREF
    ** before using this
    */

  CM_ROAM_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_ROAM_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_roam_pref_e_type;

/** Enumeration of prl preferences.
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_prl_pref_e {

  CM_PRL_PREF_NONE=0,
    /**< @internal */

  CM_PRL_PREF_AVAIL_BC0_A=SYS_BM(SYS_PRL_AVAIL_BC0_A),
    /**< Acquire available system only on the B side.
    */

  CM_PRL_PREF_AVAIL_BC0_B=SYS_BM(SYS_PRL_AVAIL_BC0_B),
    /**< Acquire available system only on the B side.
    */

  CM_PRL_PREF_ANY=0x3FFF,
    /**< Acquire any available systems.
    */

  CM_PRL_PREF_NO_CHANGE,
    /**< Do not change the prl preference */

  CM_PRL_PREF_PERSISTENT,
    /**< Return to persistent preference setting */

  CM_PRL_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PRL_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_prl_pref_e_type;

/** Enumeration of system selection WLAN Technology  preferences.
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_wlan_tech_pref_e {

  CM_WLAN_TECH_PREF_NONE=0,
    /**< @internal */

  CM_WLAN_TECH_PREF_A       =          SYS_BM(SYS_TECH_WLAN_80211A),
    /**< Acquire 802.11a only systems */

  CM_WLAN_TECH_PREF_B       =          SYS_BM(SYS_TECH_WLAN_80211B),
    /**< Acquire 802.11b only systems */

  CM_WLAN_TECH_PREF_G_ONLY  =          SYS_BM(SYS_TECH_WLAN_80211G),
    /**< Acquire 802.11g only systems */

  CM_WLAN_TECH_PREF_G       =          SYS_BM(SYS_TECH_WLAN_80211B) | \
                                       SYS_BM(SYS_TECH_WLAN_80211G),
    /**< Acquire Any 802.11g systems */

  CM_WLAN_TECH_PREF_ANY     =          0x3FFFFFFF,
    /**< Acquire Any 802.11 systems */

  CM_WLAN_TECH_PREF_NO_CHANGE,
    /**< Do not change the WLAN Technology preference */

  CM_WLAN_TECH_PREF_MAX
    /**< @internal */

} cm_wlan_tech_pref_e_type;

/** Enumeration of system selection WLAN Technology  preferences.
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_wlan_bss_type_pref_e {

  CM_WLAN_BSS_TYPE_PREF_NONE=0,
    /**< @internal */

  CM_WLAN_BSS_TYPE_PREF_ADHOC,
    /**< Acquire Adhoc systems only */

  CM_WLAN_BSS_TYPE_PREF_INFRA,
    /**< Acquire Infra systems only */

  CM_WLAN_BSS_TYPE_PREF_ANY,
    /**< Acquire Any systems */

  CM_WLAN_BSS_TYPE_PREF_NO_CHANGE,
    /**< Do not change the WLAN BSS type preference */

  CM_WLAN_BSS_TYPE_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_WLAN_BSS_TYPE_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_wlan_bss_type_pref_e_type;

/** FEATURE_HDR - Enumeration of system selection hybrid
 *  preferences.
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_hybr_pref_e {

  CM_HYBR_PREF_NONE        = -1,
    /**< @internal */

  CM_HYBR_PREF_OFF=0,
    /**< hybrid operation is not allowed - SD_SS_HYBR_PREF_NONE */

  CM_HYBR_PREF_ON=1,
    /**< hybrid operation is allowed - SD_SS_HYBR_PREF_CDMA_HDR */

  CM_HYBR_PREF_CDMA__HDR = CM_HYBR_PREF_ON,
    /**< CDMA + HDR hybrid operation */

  CM_HYBR_PREF_NO_CHANGE=2,
    /**< Do not change the hybr preference */

  CM_HYBR_PREF_PERSISTENT=3,
    /**< Return to value given in NV
    **
    ** Clients need to check for CM_API_PERSISTENT_PREF
    ** before using this
    **
    ** Bumping  pref_presistent to 3 to preserve enum value
    ** from 02.00.47.00 branch. Diag clients depend on
    ** CM_HYBR_PREF_PERSISTENT to hold same value across
    ** targets.
    */

  CM_HYBR_PREF_CDMA__HDR_WCDMA,
    /**< CDMA and (HDR or WCDMA) whichever is available */

  CM_HYBR_PREF_CDMA__WCDMA,
    /**< CDMA and WCDMA hybrid operation */

  CM_HYBR_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_HYBR_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_hybr_pref_e_type;

/** FEATURE_DDTM_CNTL - Enumeration of DDTM preferences.
*/
typedef enum cm_ddtm_pref_e {

  CM_DDTM_PREF_NONE        = -1,
    /**< @internal */

  CM_DDTM_PREF_OFF,
    /**< disable data dedicated transmission mode */

  CM_DDTM_PREF_ON,
    /**< enable data dedicated transmission mode */

  CM_DDTM_PREF_NO_CHANGE,
    /**< Do not change the DDTM preference */

  CM_DDTM_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_DDTM_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ddtm_pref_e_type;

/** Enum of action types to Add, replace, delete etc the user specified SOs
** in the service option list maintained by CM for DDTM.
*/
typedef enum cm_ddtm_pref_act_e {

  CM_DDTM_SO_LIST_ACT_NONE        = -1,
    /**< @internal */

  CM_DDTM_SO_LIST_ACT_ADD,
    /**< Add the specified SOs to the current DDTM SO list
    ** maintained by CM.
    */

  CM_DDTM_SO_LIST_ACT_REPLACE,
     /**< Replace the current DDTM SO list maintained by CM with one
     ** specified.
     */

  CM_DDTM_SO_LIST_ACT_DELETE,
     /**< Delete the user specified SOs from the DDTM SO list maintained
     ** by CM.
     */

  CM_DDTM_SO_LIST_ACT_NO_CHANGE,
     /**< No change in the DDTM SO list.
     */

  CM_DDTM_SO_LIST_ACT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_DDTM_SO_LIST_ACT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */
} cm_ddtm_so_list_act_e_type;

/** Enumeration to indicate the type of system to be avoided
*/
typedef enum {

  CM_SS_AVOID_SYS_NONE        = -1,
    /**< @internal */

  CM_SS_AVOID_SYS_SRV_IF_UZ,
    /**< Avoid idle system only if MS has currently
    ** selected user zone.
    */

  CM_SS_AVOID_SYS_SRV,
    /**< Avoid Idle system.
    */

  CM_SS_AVOID_SYS_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SS_AVOID_SYS_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ss_avoid_sys_e_type;

/** Enumeration of answer voice as data settings. CDMA Only.
*/
typedef enum cm_answer_voice_e {

  CM_ANSWER_VOICE_NONE=-1,
    /**< @internal */

  CM_ANSWER_VOICE_AS_VOICE,
    /**< = DB_VOICE_AS_DATA_NEVER, Answer voice as voice */

  CM_ANSWER_VOICE_AS_FAX_ONCE,
    /**< = DB_VOICE_AS_FAX_ONCE, Answer voice as fax once (for the next
    ** 10 minutes) */

  CM_ANSWER_VOICE_AS_FAX_ALWAYS,
     /**< = DB_VOICE_AS_FAX_ALWAYS, Answer voice as fax always */

  CM_ANSWER_VOICE_AS_MODEM_ONCE,
    /**< = DB_VOICE_AS_MODEM_ONCE, Answer voice as modem once (for the
    ** next 10 minutes) */

  CM_ANSWER_VOICE_AS_MODEM_ALWAYS,
    /**< = DB_VOICE_AS_MODEM_ALWAYS, Answer voice as modem always */

  CM_ANSWER_VOICE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_ANSWER_VOICE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_answer_voice_e_type;

/** Enumeration of NAM selections
*/
typedef enum cm_nam_e {

  CM_NAM_NONE=-1,
    /**< @internal */

  CM_NAM_1,
    /**< NAM 1*/

  CM_NAM_2,
    /**< NAM 2 - for targets with more than 1 NAM */

  CM_NAM_3,
    /**< NAM 3 - for targets with more than 2 NAM's */

  CM_NAM_4,
    /**< NAM 4 - for targets with more than 3 NAM's */

  CM_NAM_AUTO,
    /**< Auto NAM - for targets with more than 1 NAM */

  CM_NAM_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_NAM_MAX_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_nam_e_type;

/** Enumeration of phone CDMA lock modes.
*/
typedef enum cm_cdma_lock_mode_e {

  CM_CDMA_LOCK_MODE_NONE=-1,
    /**< @internal */

  CM_CDMA_LOCK_MODE_OFF,
    /**< phone is NOT CDMA locked */

  CM_CDMA_LOCK_MODE_ON,
    /**< phone is CDMA locked until power-cycle */

  CM_CDMA_LOCK_MODE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CDMA_LOCK_MODE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_cdma_lock_mode_e_type;

/** Enumeration of phone service states
*/
typedef enum cm_packet_state_e {

  CM_PACKET_STATE_NONE=-1,
    /**< @internal */

  CM_PACKET_STATE_NULL,
    /**< packet state is null */

  CM_PACKET_STATE_CONNECT,
    /**< packet state is connect */

  CM_PACKET_STATE_DORMANT,
    /**< packet state is dormant */

  CM_PACKET_STATE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PACKET_STATE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_packet_state_e_type;

/**
** Enumeration that defines the service domain being requested by
** the client (the preferred service domain).
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_srv_domain_pref_e {

  CM_SRV_DOMAIN_PREF_NONE=-1,
    /**< No service domain is requested. */

  CM_SRV_DOMAIN_PREF_CS_ONLY=0,
    /**< Prefer Circuit Switched Only */

  CM_SRV_DOMAIN_PREF_PS_ONLY=1,
    /**< Prefer Packet Switched Only */

  CM_SRV_DOMAIN_PREF_CS_PS=2,
    /**< Prefer Circuit and Packet Switched */

  CM_SRV_DOMAIN_PREF_ANY=3,
    /**< Any domain will do. No preference */

  CM_SRV_DOMAIN_PREF_NO_CHANGE=4,
    /**< To be used by clients who do not want to change the service domain */

  CM_SRV_DOMAIN_PREF_PS_ATTACH=5,
    /**<  PS attach on demand.
        Note: This value of service domain preference is not saved in NV  */

  CM_SRV_DOMAIN_PREF_PS_DETACH=6,
    /**< PS detach on demand
       Note: This value of service domain preference is not saved in NV   */


  CM_SRV_DOMAIN_PREF_PERSISTENT=7,
    /**< Return to value stored in NV
    **
    ** Clients need to check for CM_API_PERSISTENT_PREF
    ** before using this
    */

  CM_SRV_DOMAIN_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SRV_DOMAIN_PREF_BIG=0x10000000
   /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_srv_domain_pref_e_type;

/**
** Enumeration that defines whether the network should be selected
** automatically, manually or for limited service. GSM/WCDMA or WLAN
** Only.
*/
/* For compatibility with QXDM database, please do not change the following
** fix assigned values. If new values are added please also update the QXDM
** database
*/
typedef enum cm_network_sel_mode_pref_e {

  CM_NETWORK_SEL_MODE_PREF_NONE=-1,
    /**< @internal */

  CM_NETWORK_SEL_MODE_PREF_AUTOMATIC=0,
    /**< Automatic network selection */

  CM_NETWORK_SEL_MODE_PREF_MANUAL=1,
    /**< Manual network selection */

  CM_NETWORK_SEL_MODE_PREF_LIMITED_SRV=2,
    /**< Select a network for limited service
    ** Not applicable for WLAN!!
    */

  CM_NETWORK_SEL_MODE_PREF_NO_CHANGE=3,
    /**< No change */

  CM_NETWORK_SEL_MODE_PREF_PERSISTENT=4,
   /**< Return to persistent preference.
   ** Not applicable for WLAN!!
   */

  CM_NETWORK_SEL_MODE_PREF_HPLMN_SRCH=5,
   /**< Clients need to check for define CM_API_INITIATE_HPLMN_SRCH before
   ** using this enum.
   **
   **
   ** Search and Camp on HPLMN .
   ** When requested using cm_ph_cmd_sys_sel_pref()
   ** pref_duration and plmn_ptr are ignored
   ** term_pref = CM_PREF_TERM_PWR_CYCLE
   ** other parameters should carry NO_CHANGE
   */


  CM_NETWORK_SEL_MODE_PREF_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_NETWORK_SEL_MODE_PREF_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_network_sel_mode_pref_e_type;

/**
** Enumeration that defines the type of network list to be requested.  The
** requested list will either contain the preferred networks or all available
** networks.
*/
typedef enum cm_network_list_type_e {

  CM_NETWORK_LIST_NONE=-1,
    /**< @internal */

  CM_NETWORK_LIST_AVAILABLE,
    /**< The available network list. */

  CM_NETWORK_LIST_USER_PREFERRED,
    /**< The preferred network list from SIM/USIM
    ** This request returnes the list of PLMNs that
    ** are valid only. List does not contain any
    ** holes even if there are holes in SIM/USIM file.
    */

  CM_NETWORK_LIST_USER_PREFERRED_UNPACKED,
    /**< The preferred network list from SIM/USIM. This would
    ** return the list the way it is stored in the SIM/USIM.
    ** If there are holes between 2 records, it would be there
    ** too.
    */

  CM_NETWORK_LIST_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_NETWORK_LIST_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_network_list_type_e_type;

typedef enum cm_subscription_status_e {

  CM_SUBSCRIPTION_STATUS_NONE=-1,
    /**< @internal */

  CM_SUBSCRIPTION_STATUS_CHANGE,
    /**< Subscription for the specified mode changed */

  CM_SUBSCRIPTION_STATUS_NO_CHANGE,
    /**< Subscription for the specified mode has not changed */

  CM_SUBSCRIPTION_STATUS_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SUBSCRIPTION_STATUS_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_subscription_status_e_type;

typedef enum cm_rtre_config_e {

  CM_RTRE_CONFIG_NONE,
    /**< @internal */

  CM_RTRE_CONFIG_RUIM_ONLY,
    /**< RTRE configuration: use R-UIM only */

  CM_RTRE_CONFIG_NV_ONLY,
    /**< RTRE configuration: use NV only    */

  CM_RTRE_CONFIG_RUIM_OR_DROP_BACK,
    /**< RTRE use R-UIM if available or NV  */

  CM_RTRE_CONFIG_SIM_ACCESS,
    /**< RTRE use SIM */

  CM_RTRE_CONFIG__MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_RTRE_CONFIG_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_rtre_config_e_type;

typedef enum cm_rtre_control_e {

  CM_RTRE_CONTROL_NONE,
    /**< @internal */

  CM_RTRE_CONTROL_RUIM,
    /**< RTRE control: use R-UIM */

  CM_RTRE_CONTROL_NV,
    /**< RTRE control: use NV */

  CM_RTRE_CONTROL_SIM
    /**< RTRE control: use SIM */

  #ifdef FEATURE_RPC
  , CM_RTRE_CONTROL_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_rtre_control_e_type;

typedef enum cm_test_control_type_e {

  CM_TEST_CONTROL_TYPE_NONE=-1,
    /**< @internal */

  CM_TEST_CONTROL_TYPE_NO_TEST,
    /**< Init value when no testing is going on */

  CM_TEST_CONTROL_TYPE_LB_MODE1,
    /**< LOOPBACK MODE1 */

  CM_TEST_CONTROL_TYPE_LB_MODE2,
    /**< LOOPBACK MODE2 */

  CM_TEST_CONTROL_TYPE_LB_MODE1_WITH_DUMMY_SIGNALLING,
    /**< LOOPBACK MODE1 with dummy signalling */

  CM_TEST_CONTROL_TYPE_LB_MODE2_WITH_DUMMY_SIGNALLING,
    /**< LOOPBACK MODE2 with dummy signalling */

  CM_TEST_CONTROL_TYPE_MAX
    /**< @internal */

} cm_test_control_type_e_type;

/** Gives clients advice of charge information.
**
** Clients need to check for CM_API_AOC_INFO before
** using this field.
*/

typedef struct cm_ph_aoc_info_s {

  boolean  aoc_ready;
    /**< Tells if the AOC subsystem ready */

  unsigned long ACM;
    /**< Accumulated Call Meter.
    ** aoc_ready should be TRUE for this to be valid
    */

  unsigned long ACMmax;
    /**< Max allowed Accumulated Call Meter.
    ** aoc_ready should be TRUE for this to be valid
    */

} cm_ph_aoc_info_s_type;

/** Clients check CM_API_WLAN for WLAN support for following
*/

/*
** Enumeration that defines the type of Wakeup Action required.
*/
typedef enum cm_wakeup_e {

  CM_WAKEUP_NONE=-1,
    /**< @internal */

  CM_WAKEUP_MAIN   = SYS_BM(0),
    /**< Wakeup Main service. It could be CDMA, HDR, GSM, WCDMA or GW
    ** depending on the mode_pref and hybr_pref.
    */

  CM_WAKEUP_HDR    = SYS_BM(1),
    /**< Wakeup HDR service. It is valid only if hybr_pref is on */

  CM_WAKEUP_WLAN   = SYS_BM(2),
    /**< Wakeup WLAN Service */

  CM_WAKEUP_ALL    =  CM_WAKEUP_MAIN | \
                      CM_WAKEUP_HDR  | \
                      CM_WAKEUP_WLAN,
    /**< Wakeup All services */

  CM_WAKEUP_MAX
  /**< @internal */

  #ifdef FEATURE_RPC
  , CM_WAKEUP_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_wakeup_e_type;

/**
** Enumeration that defines the WLAN scan preference
*/
typedef enum cm_wlan_scan_pref_e {

  CM_WLAN_SCAN_PREF_NONE =-1,
    /**< @internal */

  CM_WLAN_SCAN_PREF_ACTIVE   = SYS_WLAN_SCAN_PREF_ACTIVE,
    /**< ACTIVE WLAN scan.
    */

  CM_WLAN_SCAN_PREF_PASSIVE  = SYS_WLAN_SCAN_PREF_PASSIVE,
    /**< Passive WLAN Scan.
    */

  CM_WLAN_SCAN_PREF_AUTO     = SYS_WLAN_SCAN_PREF_AUTO,
    /**< CM to decide Active/Passive scan automatically.
    */

  CM_WLAN_SCAN_PREF_NO_CHANGE,

  CM_WLAN_SCAN_PREF_MAX

  #ifdef FEATURE_RPC
  , CM_SERVICE_WAKEUP_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_wlan_scan_pref_e_type;

/**---------------------------------------------------------------------------
** Datatypes
**---------------------------------------------------------------------------
*/

/** Type to hold net lists phone information.
** When notified of phone events about network lists, clients are given
** a reference to such a structure.
*/
typedef struct cm_ph_net_lists_info_s {

  sys_user_pref_plmn_list_s_type   gw_user_pref_networks;
    /**< The user preferred network list. GSM/WCDMA only */

  sys_detailed_plmn_list_s_type    gw_available_networks;
    /**< Available networks. GSM/WCDMA only */

  sys_wlan_bss_info_list_s_type    wlan_bss_list;
    /**< Available WLAN BSS List */

} cm_ph_net_lists_info_s_type;

typedef struct cm_wlan_pref_s {

  cm_network_sel_mode_pref_e_type   network_sel_mode_pref;
    /**< WLAN selection is automatic or manual */

  cm_wlan_scan_pref_e_type          scan_mode;
  /**< Active/Passive scan mode */

  cm_wlan_tech_pref_e_type          tech_pref;
   /**< Specify 802.11 a/b/g etc. here. */

  cm_wlan_bss_type_pref_e_type      bss_type_pref;
   /**< Specify Adhoc/Infra/Any for Automatic mode. */

  /* Following information is required for MANUAL mode of WLAN
  ** selection.
  */

  sys_wlan_bss_e_type               bss_type;
   /**< BSS TYpe : AD-HOC, ADHOC_START or INFRA for Manual mode */

  sys_wlan_bssid_type               bss_id;
    /**< If WLAN network selection is set to manual, this specifies BSS */
    /**< if BSS Id is unknown, then set bss_id to 0 */

  sys_wlan_ssid_s_type              ssid;
    /**< If WLAN network selection is set to manual, this specifies SSID */
    /**< if SSId is unknown, then set ssid length to 0 */

  sys_chan_type                     chan;

   /**< Channel is specified as a bit mask. Please see definition in net.h
   ** for BIT Pattern of Channel as defined in
   ** net_chan_wlan_2400_e_type  or
   ** net_chan_wlan_5000_e_type
   */

   /**< If WLAN network selection is set to manual, this specifies Channel */
   /**< If WLAN channel is unkown, then set channel to 0*/

  sys_band_mask_type                band;
   /**< If WLAN network selection is set to manual, this specifies WLAN Band */
   /**< If WLAN channel is unkown, then set channel to SYS_BAND_MASK_WLAN_ANY*/

  sys_profile_id_type               profile_id;
   /**< Profile ID to be used with this manual system. */

  net_profile_s_type                profile;
  /**< Profile to be used with this manual system */


}cm_wlan_pref_s_type;

/** Type to hold phone information.
** When notified of phone events, clients are given
** a reference to such a structure.
*/
typedef struct cm_ph_info_s {

  boolean                           is_in_use;
    /**< Indicate whether phone is currently in use */

  sys_oprt_mode_e_type              oprt_mode;
    /**< Indicate current operating mode */

  cm_test_control_type_e_type       test_control_type;
    /**< Indicate current test control type */

  cm_cdma_lock_mode_e_type          cdma_lock_mode;
    /**< Indicate whether phone is CDMA locked until power cycle */

  cm_answer_voice_e_type            answer_voice;
    /**< Indicate whether phone should answer incoming
    ** voice calls as voice, fax or modem. CDMA only */

  cm_mode_pref_e_type               mode_pref;
    /**< Indicate current mode preference */

  cm_pref_term_e_type               pref_term;
    /**< Indicate the current preference term - one-call, power-cycle, etc.*/

  cm_gw_acq_order_pref_e_type       acq_order_pref;
    /**< The acquisition order preferred by the client. GSM/WCDMA only. */

  cm_srv_domain_pref_e_type         srv_domain_pref;
    /**< The service domain preferred by the client.
    ** This field is set after a call to cm_ph_cmd_sys_sel_pref.
    ** GSM/WCDMA only. */

  cm_band_pref_e_type               band_pref;
    /**< Indicate current band preference */

  cm_roam_pref_e_type               roam_pref;
    /**< Indicate current roam preference */

  cm_nam_e_type                     nam_sel;
    /**< Indicate the NAM selection. CDMA only */

  cm_nam_e_type                     curr_nam;
    /**< Indicate the current NAM -
    ** needed when NAM selection is set to AUTO-NAM. CDMA only */

  cm_packet_state_e_type            packet_state;
    /**< Indicate current packet state. CDMA only */

  cm_hybr_pref_e_type               hybr_pref;
    /**< Indicate hybrid preference */

  cm_network_sel_mode_pref_e_type   network_sel_mode_pref;
    /**< The network selection mode selected by the client. GSM/WCDMA only */

  sys_plmn_id_s_type                plmn;
    /**< The identifier of the PLMN to be selected manually. GSM/WCDMA only */

  sys_wlan_bss_info_s_type          wlan_bss_info;
    /**< The identifier of the BSS to be selected manually. WLAN only */

  sys_user_pref_plmn_list_s_type    user_pref_networks;
    /**< The user preferred network list. GSM/WCDMA only */

  sys_detailed_plmn_list_s_type     available_networks;
    /**< Available networks. GSM/WCDMA only */

  sys_wlan_bss_info_list_s_type     wlan_bss_list;
    /**< Available WLAN BSS List */
    /**< Clients check CM_API_WLAN for WLAN support*/


  boolean                           is_cdma_subscription_available;
    /**< Indicate whether the cdma subscription/provisioning information
    ** is available for consumption.                              */

  boolean                           is_gw_subscription_available;
    /**< Indicate whether the GSM/WCDMA subscription/provisioning information
    ** is available for consumption.                              */

  boolean                           is_wlan_subscription_available;
    /**< Indicate whether the WLAN subscription/provisioning information
    ** is available for consumption.                              */
    /**< Clients check CM_API_WLAN for WLAN support*/

  cm_rtre_config_e_type             rtre_config;
    /**< Current RTRE configuration - RUIM, NV, RUIM fallback NV. CDMA only */

  cm_rtre_control_e_type            rtre_control;
    /**< Current RTRE control - RUIM or NV. CDMA only */

  cm_srv_domain_pref_e_type         orig_srv_domain_pref;
    /**< service domain preference for PS attach/detach commands.
       This is different from the phone service domain preference
    */

  cm_ddtm_pref_e_type               ddtm_pref;
    /**< Data Dedicated Tranmission mode (DDTM) preference.
    */

  boolean                           cur_ddtm_status;
    /**< ddtm status */

  sys_ddtm_act_mask_e_type          ddtm_act_mask;
    /**< DDTM action mask settings.
    */

  sys_ddtm_act_mask_e_type          orig_ddtm_act_mask;
    /**< DDTM action mask settings.
    */

  uint16                            ddtm_num_srv_opt;
    /**< Number of service options specified in below list.
    */

  sys_srv_opt_type             ddtm_srv_opt_list[SYS_DDTM_MAX_SO_LIST_SIZE];
    /**< List of service options whose pages have to be ignored provided
    ** ddtm_pref & ddtm_act_mask allows it.
    */

  cm_cphs_proc_e_type               cphs_allowed;
    /**<
    ** Whether Common PCN Handset Specifications procedures are allowed
    ** FEATURE_ALS
    */

  cm_als_proc_e_type                als_allowed;
    /**<
    ** Whether ALS procedures are allowed.
    ** FEATURE_ALS
    */

  cm_als_line_e_type                line;
    /**<
    ** Currently selected line (all MO voice calls will use it)
    ** FEATURE_ALS
    */

  cm_als_line_switching_e_type      line_switching;
    /**<
    ** Whether the user is allowed to switch between lines
    ** FEATURE_ALS
    */

  cm_client_id_type                 requesting_client_id;
    /**< Requesting client */


  #if (defined(FEATURE_UMTS_1X_HANDOVER_1XMSM) || \
       defined(FEATURE_UMTS_1X_HANDOVER_UMTSMSM) || \
       defined(FEATURE_MM_SUPERSET)) 
  sys_is2000_msg_s_type             cdma_capability;
    /**< CDMA capability in the form of IS2000 Status Message.
    */

  sys_msm_id_e_type                 msm_id;
    /**< Identifies the MSM which generated this event.
    */
  #endif

  boolean                           is_net_lists_present;
    /**< This flag indicates if network lists info is available
    ** for clients.
    */

  cm_wlan_pref_s_type               wlan_pref;
    /**< WLAN preferences
    */

  cm_ccbs_store_info_s_type         ccbs_store_info;
    /**< Clients need to check for CM_API_CCBS before
    ** using this event.
    ** Holds ccbs information for clients
    */

  cm_ph_state_e_type                ph_state;
    /**< Indicates the current operating mode of the phone
    ** Used to indicate that the phone is in emergency call back mode
    */

  cm_ph_aoc_info_s_type             aoc_info;
    /**< Gives clients advice of charge information.
    **
    ** Clients need to check for CM_API_AOC_INFO before
    ** using this field.
    */

  sys_plmn_list_status_e_type       available_networks_list_cnf;
    /**< Clients need to check for CM_API_AVAIL_NET_LIST_CNF
    ** before using this field
    **
    ** Gives the status of plmn list request (success/abort).
    */

  sys_wlan_wps_result_s_type        wlan_wps_result;
    /** WPS procedure result.
    **
    ** Clients need to check for CM_API_WLAN_WPS before using this field.
    */

} cm_ph_info_s_type;

/** Type for phone command callback functions.
**
** A client that wants to be notified of the result of a
** phone-command-function needs to supply a pointer to a function
** of this type as the first parameter to a phone-command-function.
*/
typedef void (cm_ph_cmd_cb_f_type) (

  void                    *data_block_ptr,
    /**< Pointer to client provided data block */

  cm_ph_cmd_e_type        ph_cmd,
    /**< Indicate which phone command is this error status for */

  cm_ph_cmd_err_e_type    ph_cmd_err
    /**< Phone command error code, indicating whether command
    ** is rejected and the reason */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_oprt_mode

@DESCRIPTION
  Command CM to put phone in a specified operating mode, such as offline,
  online, LPM, etc.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_oprt_mode(

  cm_ph_cmd_cb_f_type    cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< Requesting client */

  sys_oprt_mode_e_type   oprt_mode
    /**< Switch to this operating mode */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_sys_sel_pref

@DESCRIPTION
  Command CM to change the phone's system selection preference (i.e., the
  mode, band and roam preference).

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_sys_sel_pref(

  cm_ph_cmd_cb_f_type               cmd_cb_func,
    /**< Client callback function */

  void                              *data_block_ptr,
    /**< Pointer to client callback data block */

  cm_client_id_type                 client_id,
    /**< Requesting client */

  cm_mode_pref_e_type               mode_pref,
    /**< Switch to this mode preference */

  cm_pref_term_e_type               pref_term,
    /**< Switch the preference for this term */

  dword                             pref_duration,
    /**< Specify the duration in seconds for temporary term */

  cm_gw_acq_order_pref_e_type       acq_order_pref,
    /**< gw acquisition order preference */

  cm_band_pref_e_type               band_pref,
    /**< Switch to this band preference */

  cm_prl_pref_e_type                prl_pref,
    /**< Switch to this prl preference */

  cm_roam_pref_e_type               roam_pref,
    /**< Switch to this roam preference */

  cm_hybr_pref_e_type               hybr_pref,
    /**< Switch to this hybrid preference */

  cm_srv_domain_pref_e_type         srv_domain_pref,
    /**< Switch to this service domain (e.g. Circuit Switch)
    ** Set to CM_SRV_DOMAIN_PREF_NO_CHANGE if a service
    ** domain is not being changed. */

  cm_network_sel_mode_pref_e_type   network_sel_mode_pref,
    /**< Defines whether the network should be selected automatically
    ** or manually */

  const sys_plmn_id_s_type                *plmn_ptr,
    /**< If network selection is set to manual, this specifies plmn id */

  const cm_wlan_pref_s_type               *wlan_pref_ptr
    /**< WLAN Prefereces.
    ** Clients check CM_API_WLAN for WLAN support */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_ddtm_pref

@DESCRIPTION
  Command CM to change the phone's data dedicated transmission mode (DDTM)
  preference to a specified selection, such as ON or OFF etc.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
boolean cm_ph_cmd_ddtm_pref(

  cm_ph_cmd_cb_f_type        cmd_cb_func,
    /**< client callback function.
    */

  void                       *data_block_ptr,
    /**< pointer to client callback data block.
    */

  cm_client_id_type          client_id,
    /**< Requesting client.
    */

  cm_ddtm_pref_e_type        ddtm_pref,
    /**< Switch to this DDTM preference.
    */

  sys_ddtm_act_mask_e_type   ddtm_act,
    /**< When DDTM is enabled, this field specifies what combined
    ** DDTM actions should takes place to enhance HDR data thru'put.
    ** This is bit-mapped enum, with each bit specifying action.
    */

  cm_ddtm_so_list_act_e_type so_list_act,
    /**< Specifies what to do ( add, replace, delete ) with the user
    ** specified SO list in the following parameters.
    */

  uint16                     num_srv_opt,
    /**< Number of SOs specified in list,
    ** MAX = SYS_DDTM_MAX_SO_LIST_SIZE
    */

  const sys_srv_opt_type           srv_opt_list[]
    /** List of SOs for which 1x pages have to ignored while in
    ** HDR connected state. if srv_opt_list[] contains CAI_SO_NULL
    ** & ddtm_pref is ON, ignore all pages.
    */


);

/**===========================================================================

@FUNCTION cm_ph_cmd_avoid_sys

@DESCRIPTION
  Command CM to avoid the system defined in "avoid_type" for avoid_time seconds

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

  CDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_avoid_sys(

  cm_ph_cmd_cb_f_type     cmd_cb_func,
    /**< client callback function */

  void                    *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type       client_id,
    /**< Requesting client */

  cm_ss_avoid_sys_e_type  avoid_type,
    /**< type of the system to avoid */

  dword                   avoid_time
    /**< avoid time in seconds */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_answer_voice

@DESCRIPTION
  Command CM to change the phone's answer-voice-as setting to a specified
  selection, such as answer-voice-as-data, answer-voice-as-voice, etc.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

  CDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_CDMA_800 || FEATURE_CDMA_1900 must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_answer_voice(

  cm_ph_cmd_cb_f_type        cmd_cb_func,
    /**< client callback function */

  void                       *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type          client_id,
    /**< Requesting client */

  cm_answer_voice_e_type     answer_voice,
    /**< Indicate whether phone should answer incoming
    ** voice calls as voice, fax or modem */

  dword                      answer_duration
    /**< Indicate seconds duration for temp. setting, such as
    ** CM_ANSWER_VOICE_AS_FAX_ONCE or DB_VOICE_AS_MODEM_ONCE */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_nam_sel

@DESCRIPTION
  Command CM to change the phone's NAM selection to NAM-1, NAM-2, etc.

  NOTE! This command fails when trying to change the NAM to illegal
  selection. E.g. changing to NAM-2 for a 1 NAM target.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

  CDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_CDMA_800 || FEATURE_CDMA_1900 must be defined.

@RETURNS
  none

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_nam_sel(

  cm_ph_cmd_cb_f_type        cmd_cb_func,
    /**< client callback function */

  void                       *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type          client_id,
    /**< Requesting client */

  cm_nam_e_type              nam_sel
    /**< Change NAM selection to this NAM */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_get_ph_info

@DESCRIPTION
  Get a sanpshot of the current phone information in the CM

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_ph_cmd_get_ph_info(

  cm_ph_cmd_cb_f_type    cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id
    /**< requesting client ID */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_rssi_delta_threshold

@DESCRIPTION
  This function commands CM to set the RSSI delta threshold to the
  specified value.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_ph_cmd_rssi_delta_threshold(

  cm_ph_cmd_cb_f_type    cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< requesting client ID */

  uint8                  delta
    /**< RSSI change delta threshold for RSSI reporting */

);

/*===========================================================================

@FUNCTION cm_ph_cmd_signal_strength_delta

@DESCRIPTION
  This function commands CM to set the RSSI/ECIO/IO delta threshold to the
  specified value.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_ph_cmd_signal_strength_delta(

  cm_ph_cmd_cb_f_type    cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client,
    /**< requesting client ID */

  uint8                  rssi_delta,
    /**< RSSI change delta threshold for Signal Strength reporting */

  uint8                  ecio_delta,
    /**< ECIO change delta threshold for Signal Strength  reporting */

  uint8                  io_delta
    /**< IO change delta threshold for Signal Strength  reporting */
);

/**===========================================================================

@FUNCTION cm_ph_cmd_subscription_available

@DESCRIPTION
  This function informs CM that the subscription/provisioning information
  has been verified and available for consumption.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If the subscription is currently available, the request will be
  ignored and a CM_PH_CMD_ERR_SUBSCRIPTION_AVAILABLE_S is returned.

  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_subscription_available(

  cm_ph_cmd_cb_f_type             cmd_cb_func,
    /**< client callback function */

  void                            *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type               client_id,
    /**< Requesting client */

  cm_subscription_status_e_type   cdma_status,
    /**< Subscription status of CDMA system */

  cm_subscription_status_e_type   gw_status,
    /**< Subscription status of GSM/WCDMA system */

  cm_subscription_status_e_type   wlan_status
    /**< Subscription status of WLAN system.
    ** Clients check CM_API_WLAN for WLAN support */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_subscription_not_available

@DESCRIPTION
  This function informs CM that the subscription/provisioning information
  is not available for consumption.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT

  If the subscription is currently not available, the request will be
  ignored and a CM_PH_CMD_ERR_SUBSCRIPTION_AVAILABLE_S is returned.

  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_subscription_not_available(

  cm_ph_cmd_cb_f_type             cmd_cb_func,
    /**< client callback function */

  void                            *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type               client_id,
    /**< Requesting client */

  cm_subscription_status_e_type   cdma_status,
    /**< Subscription status of CDMA system */

  cm_subscription_status_e_type   gw_status,
    /**< Subscription status of GSM/WCDMA system */

  cm_subscription_status_e_type   wlan_status
    /**< Subscription status of WLAN system.
    ** Clients check CM_API_WLAN for WLAN support */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_subscription_changed

@DESCRIPTION
  This function informs CM that the subscription/provisioning information
  is changed.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT

  If the subscription is currently not available, the request will be
  ignored and a CM_PH_CMD_ERR_SUBSCRIPTION_AVAILABLE_S is returned.

  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_subscription_changed(

  cm_ph_cmd_cb_f_type             cmd_cb_func,
    /**< client callback function */

  void                            *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type               client_id,
    /**< Requesting client */

  cm_subscription_status_e_type   cdma_status,
    /**< Subscription status of CDMA system */

  cm_subscription_status_e_type   gw_status,
    /**< Subscription status of GSM/WCDMA system */

  cm_subscription_status_e_type   wlan_status
    /**< Subscription status of WLAN system.
    ** Clients check CM_API_WLAN for WLAN support */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_get_networks

@DESCRIPTION
  Command CM to retrieve either a list of preferred networks or a list of
  all available networks.

  Note that the client supplied callback function, cmd_cb_func, will be
  called to notify the client of the command status.

  GSM/WCDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE  = command was successfully sent to CM
  FALSE = command was not successfully sent to CM

@SIDE_EFFECT
  If command is successful, CM clients will receive the list of networks
  via the CM_PH_EVENT_AVAILABLE_NETWORKS_CONF or CM_PH_EVENT_PREFERRED_-
  NETWORKS_CONF event.
@x
===========================================================================*/
extern boolean cm_ph_cmd_get_networks(

  cm_ph_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type            client_id,
    /**< Requesting client */

  cm_network_list_type_e_type  list_type,
    /**< Indicates whether to retrieve the preferred or available networks */

  cm_mode_pref_e_type          network_type

    /**< Clients check CM_API_WLAN for WLAN support */

    /**< Indicates the desired system such as WLAN or GW.
    ** Only WLAN or GW is supported, one at a time can be
    ** requested only.
    */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_terminate_get_networks

@DESCRIPTION
  Command CM to terminate retrieval operation of list of all available
  networks.

  Note that the client supplied callback function, cmd_cb_func, will be
  called to notify the client of the command status.

  GSM/WCDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE  = command was successfully sent to CM
  FALSE = command was not successfully sent to CM

@SIDE_EFFECT
  If command is successful, the previous command to retrieve the list will be
  terminated.

@x
===========================================================================*/
extern boolean cm_ph_cmd_terminate_get_networks(

  cm_ph_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type            client_id
    /**< Requesting client */
);

/*===========================================================================

@FUNCTION cm_ph_cmd_wps_start

@DESCRIPTION
  Command CM to get WLAN security credentials using WPS.

  Note that the client supplied callback function, cmd_cb_func, will be
  called to notify the client of the command status.

  WLAN only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  - TRUE  - command was successfully sent to CM
  - FALSE - command was not successfully sent to CM

@SIDE_EFFECT
  If command is successful, CM clients will receive a list of WLAN
  credentials via the CM_PH_EVENT_WPS_COMPLETED event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_wps_start(

        cm_ph_cmd_cb_f_type              cmd_cb_func,
          /**< Client callback function.
          */

        void                            *data_block_ptr,
          /**< Pointer to client callback data block.
          */

        cm_client_id_type                client_id,
          /**< Requesting client.
          */

        sys_wlan_wps_start_param_s_type  const *wps_start_param
          /**< Info required to start WPS procedure.
          */
);

/*===========================================================================

@FUNCTION cm_ph_cmd_wps_abort

@DESCRIPTION
  Command CM to terminate WPS procedure.

  Note that the client supplied callback function, cmd_cb_func, will be
  called to notify the client of the command status.

  WLAN Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE  = command was successfully sent to CM
  FALSE = command was not successfully sent to CM

@SIDE_EFFECT
  If command is successful, the previous command to retrieve the WLAN
  credentials using WPS will be aborted.

@x
===========================================================================*/
extern boolean cm_ph_cmd_wps_abort(

  cm_ph_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type            client_id
    /**< Requesting client */
);

/*===========================================================================

@FUNCTION cm_ph_cmd_set_preferred_networks

@DESCRIPTION
  Command CM to save the preferred networks to the SIM/USIM.

  Note that the client supplied callback function, cmd_cb_func, will be
  called to notify the client of the command status.

  GSM/WCDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE  = command was successfully sent to CM
  FALSE = command was not successfully sent to CM

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_ph_cmd_set_preferred_networks(

  cm_ph_cmd_cb_f_type              cmd_cb_func,
    /**< client callback function */

  void                            *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type                client_id,
    /**< Requesting client */

  const sys_user_pref_plmn_list_s_type  *preferred_networks_ptr
    /**< The preferred networks to be saved */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_packet_state

@DESCRIPTION
  Command CM to change Rm packet state in packet mode.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

  CDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
boolean cm_ph_cmd_packet_state(

  cm_ph_cmd_cb_f_type         cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< Requesting client */

  cm_packet_state_e_type      packet_state
    /**< Change Rm packet state to this state */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_wakeup_from_standby

@DESCRIPTION
  Command CM to inform lower layers to wake up from deep sleep (standby mode)

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_wakeup_from_standby(

  cm_ph_cmd_cb_f_type        cmd_cb_func,
    /**< client callback function */

  void                      *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type          client_id
    /**< Requesting client */
);

/**===========================================================================

@FUNCTION cm_ph_cmd_wakeup_from_standby2

@DESCRIPTION

  Clients check CM_API_WLAN for WLAN support

  Command CM to inform lower layers to wake up from deep sleep (standby mode)

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_wakeup_from_standby2(

  cm_ph_cmd_cb_f_type        cmd_cb_func,
    /**< client callback function */

  void                      *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type          client_id,
    /**< Requesting client */

  cm_wakeup_e_type           service
    /**< Service to be waken up */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_change_rtre_config

@DESCRIPTION
  Command CM to change RTRE configuration

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

  CDMA Only.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_UIM_RUN_TIME_ENABLE must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_change_rtre_config(

  cm_ph_cmd_cb_f_type    cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< Requesting client */

  cm_rtre_config_e_type  rtre_config
    /**< new RTRE configuration */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_aoc_reset_acm

@DESCRIPTION
  This command will reset the ACM to 0 on a system supporting ACM/ACMAX.

@DEPENDENCIES
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, The ACM value will be set to 0.

@x
===========================================================================*/
extern boolean cm_ph_cmd_aoc_reset_acm(

  cm_ph_cmd_cb_f_type    cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id
    /**< Requesting client */
);

/**===========================================================================

@FUNCTION cm_ph_cmd_aoc_set_acmmax

@DESCRIPTION
  This command will set the ACMMax value in the SIM to the requested value.

@DEPENDENCIES
  FEATURE_GSM || FEATURE_WCDMA must be defined.


@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  None.

@x
===========================================================================*/
extern boolean cm_ph_cmd_aoc_set_acmmax(

  cm_ph_cmd_cb_f_type    cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< Requesting client */

  uint32                 new_max
    /**< new max value for ACMMAX. */
);

/**===========================================================================

@FUNCTION cm_ph_cmd_aoc_get_ccm

@DESCRIPTION
  This function returns the current value of the Current Call Meter.

@DEPENDENCIES
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  None.

@SIDE_EFFECT
  None
@x
===========================================================================*/
extern unsigned long cm_ph_cmd_aoc_get_ccm(void);

/**===========================================================================

@FUNCTION cm_ph_cmd_aoc_get_acm

@DESCRIPTION
  This function returns the current value of the Accumulated Call Meter.

@DEPENDENCIES
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  None.

@SIDE_EFFECT
  None
@x
===========================================================================*/
extern unsigned long cm_ph_cmd_aoc_get_acm(void);

/**===========================================================================

@FUNCTION cm_ph_cmd_aoc_get_acmmax

@DESCRIPTION
  This function returns the current value of the Accumulated Call Meter Max.

@DEPENDENCIES
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  None.

@SIDE_EFFECT
  None
@x
===========================================================================*/
extern unsigned long cm_ph_cmd_aoc_get_acmmax(void);

/**===========================================================================

@FUNCTION cm_ph_cmd_aoc_get_puct

@DESCRIPTION
  This function returns the current value of the AOC Price Unit Conversion value.

@DEPENDENCIES
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  None.

@SIDE_EFFECT
  None
@x
===========================================================================*/
extern unsigned long cm_ph_cmd_aoc_get_puct(void);

/**===========================================================================
@FUNCTION cm_ph_cmd_line_switching

@DESCRIPTION

  Queue CM_PH_CMD_LINE_SWITCHING command to CM.

@DEPENDENCIES
  FEATURE_ALS and FEATURE_GSM have to be defined.

@RETURNS

  TRUE
  Command was queued successfully to CM

  FALSE
  No CM buffer available to queue the command

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_ph_cmd_line_switching(

  cm_ph_cmd_cb_f_type                 cmd_cb_func,
    /**< client cmd callback function */

  void                                *data_block_ptr,
    /**< pointer to client cmd callback data block */

  cm_client_id_type                    client_id,
    /**< commanding client's id */

  cm_als_line_switching_e_type         status
    /**< whether the user is allowed to switch between lines */

);

/**===========================================================================
@FUNCTION cm_ph_cmd_selected_line

@DESCRIPTION

  Queue CM_PH_CMD_SELECTED_LINE command to CM.

@DEPENDENCIES
  FEATURE_ALS and FEATURE_GSM have to be defined.

@RETURNS

  TRUE
  Command was queued succesfully to CM

  FALSE
  No CM buffer available to queue the command or incorrect parameters
  passed into the function

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_ph_cmd_selected_line(

  cm_ph_cmd_cb_f_type                 cmd_cb_func,
    /**< client cmd callback function */

  void                                *data_block_ptr,
    /**< pointer to client cmd callback data block */

  cm_client_id_type                    client_id,
    /**< commanding client's id */

  cm_als_line_e_type                   selected_line
    /**< selected line */

);

/**===========================================================================

@FUNCTION cm_ph_cmd_update_cdma_capability

@DESCRIPTION
  Command CM to update the CDMA2000 capability information in form of
  IS2000 Status message.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_ph_cmd_update_cdma_capability(

  cm_ph_cmd_cb_f_type               cmd_cb_func,
    /**< Client callback function */

  void                              *data_block_ptr,
    /**< Pointer to client callback data block */

  cm_client_id_type                 client_id,
    /**< Requesting client */

  const sys_is2000_msg_s_type             *is2000_msg_ptr
    /**< Pointer to the IS2000 message */

);

/* Default values for serving system stored information.
** For CDMA only.
*/
#define CM_SS_SID_NONE                         ( (uint16) 0 )
  /**< Indicates an undefined SID */

#define CM_SS_NID_NONE                         ( (uint16) 0 )
  /**< Indicates an undefined NID */

#define CM_SS_REG_ZONE_NONE                    ( (uint16) 0xFFFF )
  /**< Indicates an undefined registration zone */

#define CM_SS_PACKET_ZONE_NONE                 ( (uint8) 0 )
  /**< Indicates an undefined packet zone */

#define CM_SS_BS_P_REV_NONE                    ( (uint8) 0 )
  /**< Indicates an undefined base station p rev */

#define CM_SS_P_REV_IN_USE_NONE                ( (uint8) 0 )
  /**< Indicates an undefined p rev */

/**< Bit masks indicating which fields are changed
** in cm_mm_ss_info_s_type structure.
*/
#define CM_SS_SID_MASK                          ( SYS_BM_64BIT(0) )
  /**< SID */

#define CM_SS_NID_MASK                          ( SYS_BM_64BIT(1)  )
  /**< NID */

#define CM_SS_REG_ZONE_MASK                     ( SYS_BM_64BIT(2)  )
  /**< Registration Zone */

#define CM_SS_PACKET_ZONE_MASK                  ( SYS_BM_64BIT(3)  )
  /**< Packet Zone */

#define CM_SS_BS_P_REV_MASK                     ( SYS_BM_64BIT(4)  )
  /**< Basestation P-Rev */

#define CM_SS_P_REV_IN_USE_MASK                 ( SYS_BM_64BIT(5)  )
  /**< P-Rev in use */

#define CM_SS_CCS_SUPPORTED_MASK                ( SYS_BM_64BIT(6)  )
  /**< Concurrent services supported? */

#define CM_SS_SRV_STATUS_MASK                   ( SYS_BM_64BIT(7)  )
  /**< Serving Status - No, limited, full */

#define CM_SS_CDMA_SRV_STATUS_MASK              CM_SS_SRV_STATUS_MASK

#define CM_SS_SRV_DOMAIN_MASK                   ( SYS_BM_64BIT(8)  )
  /**< Service Domain */

#define CM_SS_CDMA_SRV_DOMAIN_MASK              CM_SS_SRV_DOMAIN_MASK

#define CM_SS_SRV_CAPABILITY_MASK               ( SYS_BM_64BIT(9)  )
  /**< System/s service capability */

#define CM_SS_CDMA_SRV_CAPABILITY_MASK          CM_SS_SRV_CAPABILITY_MASK

#define CM_SS_SYS_MODE_MASK                     ( SYS_BM_64BIT(10) )
  /**< System mode */

#define CM_SS_ROAM_STATUS_MASK                  ( SYS_BM_64BIT(11) )
  /**< Roaming status */

#define CM_SS_CDMA_ROAM_STATUS_MASK             CM_SS_ROAM_STATUS_MASK

#define CM_SS_SYS_ID_MASK                       ( SYS_BM_64BIT(12) )
  /**< System ID */

#define CM_SS_CDMA_SYS_ID_MASK                  CM_SS_SYS_ID_MASK

#define CM_SS_SRV_IND_MASK                      ( SYS_BM_64BIT(13) )
  /**< Service indicators: This mask indicates a change of service occurred.
  ** It is set even if the service is the same as the previous service. */

#define CM_SS_MOBILITY_MGMT_MASK                ( SYS_BM_64BIT(14) )
  /**< Mobility Management */

#define CM_SS_IDLE_DIGITAL_MODE_MASK            ( SYS_BM_64BIT(15) )
  /**< HDR: Idle digital mode */

#define CM_SS_SIM_STATE_MASK                    ( SYS_BM_64BIT(16) )
  /**< SIM card status */

#define CM_SS_PLMN_FORBIDDEN_MASK               ( SYS_BM_64BIT(17) )
#define CM_SS_SYS_FORBIDDEN_MASK                CM_SS_PLMN_FORBIDDEN_MASK
  /**< Forbidden PLMN/System */

#define CM_SS_PS_DATA_SUSPEND_MASK              ( SYS_BM_64BIT(18) )
  /**< PS Data Suspend MASK */

#define CM_SS_UZ_CHANGED_MASK                   ( SYS_BM_64BIT(19) )
  /**< UZ values changed */

#define CM_SS_HDR_SRV_STATUS_MASK               ( SYS_BM_64BIT(20) )
  /**< HDR Serving Status - No, limited, full */

#define CM_SS_HDR_ROAM_STATUS_MASK              ( SYS_BM_64BIT(21) )
  /**< HDR Roaming status */

#define CM_SS_MAIN_BCMCS_SRV_SUPPORTED_MASK     ( SYS_BM_64BIT(22) )
  /**< Whether 1X supports BCMCS service */

#define CM_SS_MAIN_BCMCS_SRV_STATUS_MASK        ( SYS_BM_64BIT(23) )
  /**< BCMCS service status on 1X */

#define CM_SS_HYBR_HDR_BCMCS_SRV_SUPPORTED_MASK ( SYS_BM_64BIT(24) )
  /**< Whether HDR supports BCMCS service */

#define CM_SS_HYBR_HDR_BCMCS_SRV_STATUS_MASK    ( SYS_BM_64BIT(25) )
  /**< BCMCS service status on HDR */

#define CM_SS_BASE_STATION_PARMS_CHGD_MASK      ( SYS_BM_64BIT(26) )
  /**< Base station Parameters changed */

/**< Clients check CM_API_WLAN for WLAN support for following*/
#define CM_SS_WLAN_SRV_STATUS_MASK              ( SYS_BM_64BIT(27) )
  /**< WLAN Serving Status - No, full */

#define CM_SS_WLAN_BSS_INFO_MASK                ( SYS_BM_64BIT(28) )
  /**< WLAN BSS Info is change is indicated */

#define CM_SS_ORIG_THR_STATUS_MASK              ( SYS_BM_64BIT(29) )
  /**< Origination throttle status changed */

#define CM_SS_HDR_SYS_ID_MASK                   ( SYS_BM_64BIT(30) )
  /**< HDR System ID */

#define CM_SS_MCC_MASK                          ( SYS_BM_64BIT(31) )
  /**< MCC changed */

#define CM_SS_IMSI_11_12_MASK                   ( SYS_BM_64BIT(32) )
  /**< IMSI changed */

#define CM_SS_PSIST_CHGD_MASK                   ( SYS_BM_64BIT(33) )
  /**< Psist information changed */

#define CM_SS_ACTIVE_BAND_MASK                  ( SYS_BM_64BIT(34) )
  /**< Clients needs to check for CM_API_ECATEG_IN_NUM_STRUCT before
  ** using this field.
  **
  ** Active band information
  */

#define CM_SS_GW_SRV_STATUS_MASK                ( SYS_BM_64BIT(35) )
  /**< GW Serving Status - No, limited, full */

#define CM_SS_GW_ROAM_STATUS_MASK               ( SYS_BM_64BIT(36) )
  /**< GW Roaming status */

#define CM_SS_GW_SRV_DOMAIN_MASK                ( SYS_BM_64BIT(37) )
  /**< Srv domain on GW changed */

#define CM_SS_GW_SRV_CAPABILITY_MASK            ( SYS_BM_64BIT(38) )
  /**< Srv capability on GW changed */

#define CM_SS_GW_SYS_MODE_MASK                  ( SYS_BM_64BIT(39) )
  /**< Sys mode on GW changed */

#define CM_SS_GW_ACTIVE_BAND_MASK               ( SYS_BM_64BIT(40) )
  /**< Clients needs to check for CM_API_ECATEG_IN_NUM_STRUCT before
  ** using this field.
  **
  ** Active band information
  */

#define CM_SS_GW_SYS_ID_MASK                    ( SYS_BM_64BIT(41) )
  /**< System ID */

#define CM_SS_GW_SYS_FORBIDDEN_MASK             ( SYS_BM_64BIT(42) )


#define CM_SS_SIMULTANEOUS_MODE_MASK            ( SYS_BM_64BIT(43) )
  /**< Sumultaneous mode changed */

#define CM_SS_HDR_ACTIVE_PROT_MASK              ( SYS_BM_64BIT(44) )
  /**< HDR active protocol is changed.
  ** Need to define CM_API_HDR_ACTIVE_PROT to use this field.
  */
#define CM_SS_WLAN_LINK_QUAL_MASK               ( SYS_BM_64BIT(45) )
  /**< WLAN LINK QUALITY has changed in the WLAN_STATS ss event.
  */

#define CM_SS_WLAN_TX_RX_STATS_MASK             ( SYS_BM_64BIT(46) )
  /**< WLAN TX RX stats have changed in the WLAN STATS ss event.
  */

#define CM_SS_TRUE_SRV_STATUS_MASK              ( SYS_BM_64BIT(47)  )
  /* True Serving Status - No, limited, limited_regional */

#define CM_SS_TRUE_GW_SRV_STATUS_MASK           ( SYS_BM_64BIT(48) )
  /* GW Serving Status - No, limited, limited_regional */

#define CM_SS_CELL_INFO_MASK                    ( SYS_BM_64BIT(49) )
  /**< CELL_INFO: change in cell_id and neighbor cell_id
  */

#define CM_SS_GAN_STATE_MASK                    ( SYS_BM_64BIT(50) )
  /**< UMA GAN client state
  **  init and shutdown indication
  */

#define CM_SS_GAN_CONN_STATUS_MASK              ( SYS_BM_64BIT(51) )
  /**< UMA GAN connection status
  */

#define CM_SS_GAN_SIG_CHAN_STATUS_MASK          ( SYS_BM_64BIT(52) )
  /**< UMA GAN signal channel status
  */

#define CM_SS_GAN_MODE_DISPLAY_MASK             ( SYS_BM_64BIT(53) )
  /**< UMA GAN indication whether WLAN 
  **  or GERAN becomes the active RAT 
  */

#define CM_SS_GAN_ERROR_PROMPT_MASK             ( SYS_BM_64BIT(54) )
  /**< UMA GAN error category
  */

#define CM_SS_ACTIVE_CHANNEL_MASK               ( SYS_BM_64BIT(55) )
  /**< Active channel information
  */

#define CM_SS_HYBRID_ACTIVE_BAND_MASK              ( SYS_BM_64BIT(56) )
  /**< Active HYBRID channel information
  */

#define CM_SS_HYBRID_ACTIVE_CHANNEL_MASK           ( SYS_BM_64BIT(57) )
  /**< Active HYBRID channel information
  */


/**< Clients need to check for CM_API_EMERGENCY_NUM_LIST before using.
** Masks for Emergency number types
*/
#define CM_EMERG_NUM_TYPE_NONE                        ( (uint32) 0 )
   /**< Clients need to use this type when no
   ** category is defined for emergency call
   */

#define CM_EMERG_NUM_TYPE_POLICE_MASK                 ( BM(0) )
   /**< Police */

#define CM_EMERG_NUM_TYPE_AMBULANCE_MASK              ( BM(1) )
   /**< Ambulance */

#define CM_EMERG_NUM_TYPE_FIRE_BRIGADE_MASK           ( BM(2) )
   /**< Fire Brigade */

#define CM_EMERG_NUM_TYPE_MARINE_GUARD_MASK           ( BM(3) )
   /**< Marine Guard */

#define CM_EMERG_NUM_TYPE_MOUNTAIN_RESCUE_MASK        ( BM(4) )
   /**< Mountain Rescue */

#define CM_EMERG_NUM_TYPE_MAX                         ( BM(5) )
   /**< For bounds checking, CM INTERNAL USE ONLY */


#define CM_COUNTRY_CODE_LIST_SIZE                      5
   /* List of countries presented for conflict resolution */

#define CM_INVALID_MOBILE_COUNTRY_CODE                (cm_country_code_type)(-1)
   /* Country code not pointing to any country
   ** Mirrors SD_MCC_NONE value
   **
   **
   */

#define CM_MAX_MOBILE_COUNTRY_CODE_VAL                1000
   /* Mobile country code cannot exceed this value.
   ** Mirrors SD_MCC_MAX value
   */


/** Enumeration of serving system commands client are able to send to CM.
*/
typedef enum cm_ss_cmd_e {

  CM_SS_CMD_NONE=-1,
    /**< @internal */

  CM_SS_CMD_INFO_GET,
    /**< Get serving system info */

  CM_SS_CMD_PS_DATA_AVAIL,
    /**< Get PS data available request from DS */

  CM_SS_CMD_ORIG_THR_UPDATE_TBL,
    /**< Update the throttle table */

  CM_SS_CMD_COUNTRY_SELECTED,
    /* Update current country as sel by user */

  CM_SS_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SS_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ss_cmd_e_type;

/** Enumeration of serving system command errors returned by call command
** callback functions.
*/
typedef enum cm_ss_cmd_err_e {

  CM_SS_CMD_ERR_NONE=-1,
    /**< @internal */

  CM_SS_CMD_ERR_NOERR,
    /**< No errors found */

  /* Error codes resulting from clients feeding a serving system command
  ** function with bad or inappropriate parameters.
  */

  CM_SS_CMD_ERR_CLIENT_ID_P,
    /**< Bad client parameter */

  /* Error codes resulting from operational limitation
  ** of CM.
  */

  CM_SS_CMD_ERR_NO_BUF_L,
    /**< No available CM command buffers to queue the command */

  CM_SS_CMD_ERR_OTHER,
    /**< any other errors not listed above */

  /* Error codes resulting from clients trying to instruct
  ** CM to perform inappropriate actions relative to the current
  ** state of the call and/or phone.
  */

  CM_SS_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  #if (defined(FEATURE_PS_DORMANT_PWR_SAVE) || \
       defined(FEATURE_MM_SUPERSET))
  CM_SS_CMD_ERR_OFFLINE_S,
    /**< Phone is offline */

  CM_SS_CMD_ERR_SRV_STATE_S,
    /**< Serving status is wrong */

  CM_SS_CMD_ERR_PS_DATA_SUSPEND_S,
    /**< PS data suspend state is not correct. */
  #endif /* FEATURE_PS_DORMANT_PWR_SAVE */

  CM_SS_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SS_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ss_cmd_err_e_type;

/** Enumeration of call origination throttling reasons.
*/

typedef enum cm_ss_orig_thr_reasons_e {

  CM_SS_ORIG_THR_REASON_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_SS_ORIG_THR_DS_MIP_UP_SUCCESS,
    /**< MIP Success */

  CM_SS_ORIG_THR_DS_MIP_PDSN_FAILURE,
    /**< PDSN, PPP setup  failure */

  CM_SS_ORIG_THR_DS_MIP_SOL_TIMEOUT,
    /**< MIP Solicitation Timeout */

  CM_SS_ORIG_THR_DS_MIP_RRQ_TIMEOUT,
    /**< MIP RRQ Timeout */

  /* 4 */
  CM_SS_ORIG_THR_DS_MIP_FA_FAILURE,
    /**< MIP FA Failure */

  CM_SS_ORIG_THR_DS_MIP_HA_FAILURE,
    /**< MIP HA Failure */

  CM_SS_ORIG_THR_DS_MIP_FAILURE,
    /**< MIP fail due to any other network reason */

  CM_SS_ORIG_THR_DS_PPP_UP_SUCCESS,
    /**< PPP Success */

  /* 8 */
  CM_SS_ORIG_THR_DS_PPP_AUTH_FAILURE,
    /**< PPP Authorization failure */

  CM_SS_ORIG_THR_DS_PPP_LCP_TIMEOUT,
    /**< PPP LCP Timeout */

  CM_SS_ORIG_THR_DS_PPP_NCP_TIMEOUT,
    /**< PPP IPCP Timeout */

  CM_SS_ORIG_THR_DS_PPP_FAILURE,
    /**< PPP fail due to any other network reason */

  /* 12 */
  CM_SS_ORIG_THR_CM_INTERCEPT,
    /**< Received Intercept from BS */

  CM_SS_ORIG_THR_CM_REL_SO_REJ,
    /**< SO Reject */

  CM_SS_ORIG_THR_CM_CD_GEN_OR_BUSY,
    /**< Connection Deny with deny code busy or general */

  CM_SS_ORIG_THR_CM_CD_BILL_OR_AUTH,
    /**< Billing or auth failure */

  /* 16 */
  CM_SS_ORIG_THR_DS_SIP_FAILURE,
    /**< SIP Failure */

  CM_SS_ORIG_THR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SS_ORIG_THRE_BIG=0x10000000
      /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */
} cm_ss_orig_thr_reasons_e_type;

/** Enumeration of ipapp registration states
** Clients needs to check for CM_API_VIDEOSHARE
** before using this type
*/
typedef enum {

  CM_IPAPP_REG_STATUS_NONE=-1,
    /**< @internal */

  CM_IPAPP_REG_STATUS_REGISTERED,
    /**< IP app has successfully registered with network.
    */

  CM_IPAPP_REG_STATUS_DEREGISTERED,
    /**< IP app has deregistered from network.
    */

  CM_IPAPP_REG_STATUS_FAILURE,
    /**< IP app has failed to register
    */

  CM_IPAPP_REG_STATUS_MAX
    /**< @internal */

} cm_ipapp_reg_status_e_type;

/** Enumeration of serving system events.
** Clients are able to register with CM to be notified of any subsets
** of these serving system events.
*/
typedef enum cm_ss_event_e {

  CM_SS_EVENT_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_SS_EVENT_SRV_CHANGED,
    /**< Serving system information changed */

  CM_SS_EVENT_RSSI,
    /**< RSSI changed */

  CM_SS_EVENT_INFO,
    /**< Serving system information, this event only sent to the client
    ** that request this information through cm_ss_cmd_get_ss_info() */

  /* Registration results - FEATURE_JCDMA only
  */
  CM_SS_EVENT_REG_SUCCESS,
    /**< Registration Success */

  CM_SS_EVENT_REG_FAILURE,
    /**< Registration Failure */

  /* 5 */
  CM_SS_EVENT_HDR_RSSI,
    /**< RSSI changed */

  CM_SS_EVENT_WLAN_RSSI,
    /**< WLAN RSSI */
    /* Clients check CM_API_WLAN for WLAN support*/

  CM_SS_EVENT_SRV_NEW,
    /**< Serving system information changed */

  CM_SS_EVENT_SECONDARY_MSM,
    /**< Invoke event call back even if the event is from secondary MSM.
    ** CM will not generate any events with this, but is used by
    ** thin client CM layer to call client call backs for events from
    ** secondary msm.
    */

  CM_SS_EVENT_PS_DATA_AVAIL,
    /**< Received PS data available request */

  /* 10 */
  CM_SS_EVENT_PS_DATA_FAIL,
    /**< Indicate fail to resume PS data */

  CM_SS_EVENT_PS_DATA_SUCCESS,
    /**< Indicate success in resuming PS data */

  CM_SS_EVENT_WLAN_STATS,
    /**< Indicate updates in WLAN Stats.*/

  CM_SS_EVENT_ORIG_THR_TBL_UPDATE,
    /**< Indicates updates to the Call origination throttle table */


  CM_SS_EVENT_EMERG_NUM_LIST,
    /**< CM_API_EMERGENCY_NUM_LIST needs to be checked before using
    ** this enum
    **
    ** Indicates that list of emergency numbers are available from the
    ** network. emerg_num_list in cm_mm_ss_info_s_type carries the numbers
    */

  CM_SS_EVENT_IPAPP_REG_STATUS,
    /**< Clients should check for CM_API_VIDEOSHARE before using
    ** this field.
    ** Indicates registration status of an IP app
    */

  CM_SS_EVENT_GW_RSSI,
    /**< RSSI for GW systems
    */

  CM_SS_EVENT_HDR_LN_STATUS,
    /* Location notification status event */

  CM_SS_EVENT_SELECT_COUNTRY,
    /* CM_API_PLUS_DIALING needs to be checked before using
    ** this enum.
    **
    ** Event sent to prompt user to select a country among given
    ** list. country_list field in cm_mm_ss_info_s_type will carry
    ** the list of countries.
    **
    ** UI should also present an option called "OTHER COUNTRY" to the user,
    ** which can be selected if user does not find any of the listed
    ** countries applicable. country_code can be set to CM_INVALID_MOBILE_COUNTRY_CODE
    ** when cm_ss_cmd_country_selected() is called.
    */


  CM_SS_EVENT_COUNTRY_SELECTED,
    /* CM_API_PLUS_DIALING needs to be checked before using
    ** this enum.
    **
    ** Event sent to inform clients of user selected country.
    ** current_country_code in cm_mm_ss_info_s_type will carry
    ** the current country.
    */

  CM_SS_EVENT_REG_REJECT,
    /* Event to sent to indicate Registration failure.
    ** Feature GSM or WCDMA only
    **
    */

  CM_SS_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SS_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_ss_event_e_type;

/** Enumeration of serving system origination throttle action
*/
typedef enum cm_ss_orig_thr_act_e{

  CM_SS_ORIG_THR_ACT_NONE = -1,
    /**< No action should be taken */

  CM_SS_ORIG_THR_RESET_TBL,
    /**< Reset the orig throttle table */

  CM_SS_ORIG_THR_UPDATE_SS,
    /**< Update a particular orig throttle entry */

  CM_SS_ORIG_THR_UPDATE_CURR_SS,
    /**< Update the current orig throttle entry */

  CM_SS_ORIG_THR_ACT_MAX
    /**< @internal */

} cm_ss_orig_thr_act_e_type;

typedef enum cm_psist_e{

  CM_PSIST_NONE = -1,
    /**< @internal */

  CM_PSIST_LOW,
    /**< Low psist */

  CM_PSIST_HIGH,
    /**< HIgh Psist */

  CM_PSIST_UNKNOWN,
    /**< Unknown psist */

  CM_PSIST_MAX
    /**< @internal */
} cm_psist_e_type;

/** CM_API_EMERGENCY_NUM_LIST needs to be checked before using this struct.
**
** Structure to hold emergency number and type
*/
typedef struct cm_emerg_num_s {

  uint32                    num_type;
    /**< Type of emergency number. Carries Bits with
    ** positions that are defined by CM_EMERG_NUM_TYPE_*
    */

  cm_num_s_type             num;
    /**< Digits in the number */

} cm_emerg_num_s_type;

/** CM_API_EMERGENCY_NUM_LIST needs to be checked before using this struct.
**
** Structure to hold list of emergency numbers
*/
typedef struct cm_emerg_num_list_s {

  int                       num_list_len;
    /**< Count of emergency numbers present */

  cm_emerg_num_s_type       num_list [CM_MAX_EMERGENCY_NUM_COUNT];
    /**< Emergency number type and digits */

} cm_emerg_num_list_s_type;

/** CM_API_CELL_SUPP_SERVICES needs to be checked before using this struct.
**
** Structure to hold information about services in current cell
*/
typedef struct cm_cell_srv_ind_s {

  sys_hs_ind_e_type         hs_ind;
    /**< High speed service indication (Over WCDMA) */

  sys_dtm_support_e_type    dtm_supp;
    /**< Dual Transfer mode indication (Over GSM) */

  sys_egprs_support_e_type  egprs_supp;
    /**< EGPRS indication  */

  sys_hs_ind_e_type         hs_call_status;
    /**< Clients need to check for CM_API_CELL_SUPP_SERVICES
  ** and CM_API_CELL_SUPP_SERVICES_HS_CALL  before
    ** using this structure.
  */

    /**< Reusing HS enums to indicate call status
  ** on HS.
  **
  ** SYS_HS_IND_HSDPA_HSUPA_UNSUPP_CELL - No calls in progress on HS.
  **
  ** SYS_HS_IND_HSDPA_SUPP_CELL  - Call in progress on HSDPA.
  **
  ** SYS_HS_IND_HSUPA_SUPP_CELL  - Call in progress on HSUPA
  */

} cm_cell_srv_ind_s_type;

/** Structure for registration reject information
*/
typedef struct cm_reg_reject_info_s {

  sys_srv_domain_e_type        reject_srv_domain;
    /**<   Srv domain on which registration is rejected */

  byte                         reject_cause;
    /**<  Registration Reject Cause */

} cm_reg_reject_info_s_type;

/**
** Type to hold serving system information for GSM or WCDMA modes.
*/
typedef struct cm_ss_gw_info_s {

  uint8                                   bit_err_rate;
    /**< Bit Error Rate / RX QUAL in GSM */

  sys_sim_state_e_type                    sim_state;
    /**< Current state of the SIM.
    ** Mask used is CM_SS_SIM_STATE_MASK.
    */

  boolean                                 plmn_forbidden;
    /**< Indicates whether the PLMN is forbidden.
    ** Mask used is CM_SS_PLMN_FORBIDDEN_MASK.
    */

  sys_mm_information_s_type                mm_information;
    /**< Mobility management information, i.e. network name, date,
    ** time and time zone of registered network */

} cm_ss_gw_info_s_type;

/**
** Type to hold serving system information for CDMA modes.
** Applicable for FEATURE_CDMA_800 or FEATURE_CDMA_1900.
*/
typedef struct cm_ss_cdma_info_s {

  sys_band_class_e_type        band_class;
    /**< cellular or PCS */

  sys_blksys_e_type            block_or_system;
    /**< PCS frequency block: A to F Cellular System A or B*/

  uint16                       reg_zone;
    /**< 12 bit registration zone */

  uint16                       packet_zone;
    /**< 8  bit packet zone, 0xffff means PACKET ZONE NONE.
    ** Mask used is CM_SS_PACKET_ZONE_MASK.
    */

  uint8                        bs_p_rev;
    /**< 8  bit base station p_rev.
    ** Mask used is CM_SS_BS_P_REV_MASK.
    */

  uint8                        p_rev_in_use;
    /**< 8  bit p_rev in use the lessor of BS p_rev and mobile p_rev.
    ** Mask used is CM_SS_P_REV_IN_USE_MASK.
    */

  boolean                      is_registered;
    /**< is mobile registered on the current system */

  boolean                      ccs_supported;
    /**< is concurrent services supported.
    */

  int32                        uz_id;
     /**< User zone Identification of the selected user zone,
     ** == CM_INVALID_UZID, if no user zone selected. FEATURE_USERZONE.
     ** Mask used is CM_SS_UZ_CHANGED_MASK.
     */

  sys_puzl_uz_name_s_type      uz_name;
     /**< User zone name of the selected user zone.
     ** Valid only if uz_id != CM_INVALID_UZID. FEATURE_USERZONE.
     ** Mask used is CM_SS_UZ_CHANGED_MASK.
     */

  sys_srch_win_type            srch_win_n;
    /**< Neighbour set window search size.
    ** Mask used is CM_SS_BASE_STATION_PARMS_CHGD_MASK.
    */

  sys_base_lat_type            base_lat;
    /**< Base station latitude[0.25sec and already sign extended].
    ** Mask used is CM_SS_BASE_STATION_PARMS_CHGD_MASK.
    */

  sys_base_long_type           base_long;
    /**< Base station latitude[0.25sec and already sign extended].
    ** Mask used is CM_SS_BASE_STATION_PARMS_CHGD_MASK.
    */

  sys_base_id_type             base_id;
    /**< Base station Identification number.
    ** Mask used is CM_SS_BASE_STATION_PARMS_CHGD_MASK.
    */

} cm_ss_cdma_info_s_type;

/** SS information
*/
typedef union cm_ss_info_u {

  cm_ss_gw_info_s_type     gw_info;
    /**< GSM/WCDMA SS information */

  cm_ss_cdma_info_s_type   cdma_info;
    /**< CDMA SS information */

} cm_ss_info_u_type;

typedef struct cm_ss_orig_thr_info_type {

  boolean                       ss_thr_status;
    /**< The throttle status of the current ss
    */

  dword                         thr_uptime;
    /**< The throttling time period
    */

  unsigned int                  idx;
    /**< The index in the throttle_time table
    ** Used internally by CM to keep track of the next throttle time
    ** increment
    */

  cm_ss_orig_thr_reasons_e_type call_status;
    /**< The call end reason
    */

} cm_ss_orig_thr_info_s_type;

/* Structure to hold list of country
** codes for user to be prompted with
*/
typedef struct cm_ss_country_list_s {

  boolean                present; /* !!!! CHECK USAGE !!!! */
    /* present flag if this structure
    ** is populated
    */

  cm_sid_type            sid;
    /* Sid that is in conflict with
    ** countries
    */

  uint8                  country_code_len;
    /* Length of country_code_list[]
    */

  cm_country_code_type   country_code_list [CM_COUNTRY_CODE_LIST_SIZE];
    /* Array of mobile country codes that conflict
    ** with given sid
    */

} cm_ss_country_list_s_type;

/** Information returned by ipapp on regis/deregis.
** Clients needs to check for CM_API_VIDEOSHARE
** before using this type
*/
typedef struct cm_ipapp_info_s {

  cm_ipapp_reg_status_e_type reg_status;
    /**< IP app registration status
    */

  int                        cause;
    /**< Cause given when app registration fails or deregisters
    */

  cm_ipapp_warn_info_s_type  warn_info;
    /**< Warning information given by ipapp
    */

  cm_call_type_mask_type     call_type_mask;
    /**< Call tpyes that ipapp can service
    */

  sys_sys_mode_mask_e_type   sys_mode;
    /**< System modes app can support for calls
    ** Can be used only if CM_API_SMS_OVER_IP is defined.
    */

} cm_ipapp_info_s_type;

/**
** Type to hold serving system information.
** When notified of serving system events, clients are given
** a reference to such a structure.
*/
typedef struct cm_mm_ss_info_s {

  uint64                     changed_fields;
    /**< Bit mask indicating which of the following serving system fields
    ** were changed since last notification.  Refer to the #defines
    ** (CM_SS_*_MASK) above. */

  sys_srv_status_e_type      srv_status;
    /**< The service status (SERVICE/NO SERVICE) of the system.
    ** Mask used is CM_SS_SRV_STATUS_MASK.
    */

  sys_srv_status_e_type      true_srv_status;
    /* The true service status (LIMITED/LIMITED_REGIONAL) of the system.
    ** Mask used is CM_SS_TRUE_SRV_STATUS_MASK.
    */

  sys_srv_domain_e_type      srv_domain;
    /**< The service domain registered on the system. /
    ** Mask used is CM_SS_SRV_DOMAIN_MASK.
    */

  sys_srv_domain_e_type      srv_capability;
    /**< The system's service capability.
    ** Mask used is CM_SS_SRV_CAPABILITY_MASK.
    */

  sys_sys_mode_e_type        sys_mode;
    /**< The system's mode.
    ** Mask used is CM_SS_SYS_MODE_MASK.
    */

  sys_roam_status_e_type     roam_status;
    /**< Indicate current roaming status.
    ** Mask used is CM_SS_ROAM_STATUS_MASK.
    */

  sys_sys_id_s_type          sys_id;
    /**< The ID of the selected system.
    ** Mask used is CM_SS_SYS_ID_MASK.
    */

  boolean                    is_sys_forbidden;
    /**< Indicates whether the System is forbidden.
    ** Mask used is CM_SS_SYS_FORBIDDEN_MASK.
    */

  boolean                   is_colloc;
    /**< Indicates whether the system is collocated.
    ** Mask used is CM_SS_SYS_ID_MASK.
    */

  uint16                     rssi;
    /**< RSSI in positive dBm i.e. 75 means -75dBm. The range for
    ** AMPS:      -110 to -89 dBm
    ** 800 CDMA:  -105 to -90 dBm
    ** 1900 CDMA: -108 to -93 dBm
    ** GSM/WCDMA: -105 to -60 dBm
    */

  int16                      ecio;
  int                        io;
  byte                       sinr;
    /**< ECIO in negative 0.5 dBm i.e. 63 means -31.5dBm.
    ** Io field is valid only when in HDR mode only operation
    ** SINR range: from 0 to 8, Level 8 represents highest SINR
    ** SINR applicable only when sys_mode = HDR.
    */

  int16                      pathloss;
    /**< Pathloss is applicable only in Connected mode (otherwise 0xFF)
    */

  int16                      sir;
    /**< SIR applicable and valid (otherwise 0xFF) only in WCDMA
    ** connected mode when DPCCH is active.
    */

  int16                      rssi2;
    /**< The -ve RSSI value, coming from RRC layer
    */

  int16                      rscp;
    /**< The range of RSCP would be from -28 to -121 dBm
    */

  boolean                    ecio_for_display;
    /**< TRUE if UE is in Data call
    */

  cm_psist_e_type            psist;
    /**< The psist of the system
    */

  boolean                    ps_data_suspend;
    /**< Indicates that the current PS data service has been suspended.
    ** Mask used is CM_SS_PS_DATA_SUSPEND_MASK.
    */

  boolean                    hdr_hybrid;
    /**< system is hybrid or not. FEATURE_HDR_HYBRID */

  sys_srv_status_e_type      hdr_srv_status;
     /**< Indicate current service state - FEATURE_HDR_HYBRID.
     ** Mask used is CM_SS_HDR_SRV_STATUS_MASK.
     */

  sys_roam_status_e_type     hdr_roam_status;
     /**< Indicate current hybrid hdr roaming status - FEATURE_HDR_HYBRID.
     ** Mask used is CM_SS_HDR_ROAM_STATUS_MASK.
     */

  uint16                     hdr_rssi;
    /**< HDR RSSI in positive dBm i.e. 75 means -75dBm - FEATURE_HDR_HYBRID
    ** The range is -105 to -90 dBm
    */

  int16                      hdr_ecio;
  int                        hdr_io;
  byte                       hdr_sinr;
    /**<
    ** HDR Ec/Io and Io values (used when mobile is in
    ** hybrid operation).
    ** Ec/Io range: from 5 ( -31.5 dB ) to 512 ( 0 dB )
    ** Io    range: from -106 dBm to -21 dBm
    ** SINR range: from 0 to 8, Level 8 represents highest SINR
    ** ( FEATURE_HDR )
    */

  sys_active_prot_e_type     hdr_active_prot;
    /**< The HDR active protocol revision information.
    ** Mask used is CM_SS_HDR_ACTIVE_PROT_MASK
    ** Need to define CM_API_HDR_ACTIVE_PROT before access this field.
    */
  sys_sys_mode_e_type        prev_idle_digital_mode;
    /**< previous idle digital mode. FEATURE_HDR_HANDOFF.
    ** Mask used is CM_SS_IDLE_DIGITAL_MODE_MASK.
    */

  sys_sys_mode_e_type        cur_idle_digital_mode;
    /**< current idle digital mode. FEATURE_HDR_HANDOFF.
    ** Mask used is CM_SS_IDLE_DIGITAL_MODE_MASK.
    */

  cm_ss_info_u_type          mode_info;
    /**< Mode specific serving system information */

  /* FEATURE_BCMCS
  ** These fields specify whether lower layer
  ** supports broadcast/multicast as per
  ** High Rate Broadcast-Multicast Packet data Air
  ** Interface Specification C.S0054 and
  ** BCMCS Framework Draft Document 0.1.3 XP0019
  */

  boolean                    hybr_hdr_bcmcs_srv_supported;
    /**< Specify whether HDR is configured to support BCMCS service.
    ** Mask used is CM_SS_HYBR_HDR_BCMCS_SRV_SUPPORTED_MASK.
    */

  sys_bcmcs_srv_status_e_type hybr_hdr_bcmcs_srv_status;
    /**< Specify whether BCMCS service is available on HDR.
    ** Mask used is CM_SS_HYBR_HDR_BCMCS_SRV_STATUS_MASK.
    */

  boolean                    ss_main_bcmcs_srv_supported;
    /**< Specify whether MAIN is configured to support BCMCS service.
    ** Mask used is CM_SS_MAIN_BCMCS_SRV_SUPPORTED_MASK.
    */

  sys_bcmcs_srv_status_e_type ss_main_bcmcs_srv_status;
    /**< Specify whether BCMCS service is available on MAIN.
    ** Mask used is CM_SS_MAIN_BCMCS_SRV_STATUS_MASK.
    */

  cm_client_id_type          requesting_client_id;
    /**< Requesting client */

  #if (defined(FEATURE_UMTS_1X_HANDOVER_1XMSM) || \
       defined(FEATURE_UMTS_1X_HANDOVER_UMTSMSM) || \
       defined(FEATURE_MM_SUPERSET))
  sys_msm_id_e_type          msm_id;
     /**< Identifies the MSM which generated this event.
     */
  #endif

  /** Clients check CM_API_WLAN for WLAN support for following
  **
  ** wlan_rssi, wlan_srv_status, wlan_bss_info, wlan_stats
  */
  uint16                     wlan_rssi;

  sys_srv_status_e_type      wlan_srv_status;
     /**< Indicate current WLAN service state
     ** Mask used is CM_SS_WLAN_SRV_STATUS_MASK.
     */

  sys_wlan_bss_info_s_type   wlan_bss_info;
    /**< 802.11 (WLAN) System Information
    */

  sys_wlan_stats_s_type      wlan_stats;
    /**< WLAN stats such as Current Transmit Rate, TX/RX bytes.
    */

  sys_srv_domain_e_type      cipher_domain;
    /**< Can be used only if CM_CIPHERING_IND_SUPP is defined.
    ** Ciphering on CS or PS domain or both.
    */

  cm_ss_orig_thr_info_s_type main_thr_status;
    /**< The DCTM status, indicates the current throttle status of the MAIN
    ** system
    */

  cm_ss_orig_thr_info_s_type hdr_thr_status;
    /**< The DCTM status, indicates the current throttle status of the HDR
    ** system
    */

  sys_sys_id_s_type          hdr_sys_id;
    /**< The ID of the HDR sub system.
    ** Mask used is CM_SS_HDR_SYS_ID_MASK.
    */

  dword                      curr_uptime;
    /**< The current uptime
    */

  cm_emerg_num_list_s_type   emerg_num_list;
    /**< Clients need to check for CM_API_EMERGENCY_NUM_LIST before
    ** using this structure.
    **
    ** Emergency number list returned from the network
    */


  cm_ipapp_info_s_type       ipapp_info;
    /**< Clients should check for CM_API_VIDEOSHARE before using
    ** this structure type
    **
    ** Registration information of the app
    */

  sys_band_class_e_type       active_band;
    /**< Clients need to check for CM_API_EMERGENCY_NUM_LIST before
    ** using this structure.
    **
    */

  sys_channel_num_type        active_channel;
    /**< Report active channel of the current serving system.
    */

  sys_band_class_e_type       hybrid_active_band;
    /**< Report active band of hybrid system 
    */

  sys_channel_num_type        hybrid_active_channel;
    /**< Report active channel of the current serving system.
    */

  cm_cell_srv_ind_s_type      cell_srv_ind;
    /**< Clients need to check for CM_API_CELL_SUPP_SERVICES before
    ** using this structure.
    **
    ** Structure to hold information about services in current cell.
    ** Information tied to CM_SS_SRV_IND_MASK.
    */

  #if (defined(FEATURE_CM_TECH_SPEC_SRV_IND) || \
       defined(FEATURE_MM_SUPERSET))

  sys_band_class_e_type      gw_active_band;
    /**< Clients need to check for CM_API_EMERGENCY_NUM_LIST before
    ** using this structure.
    **
    */

  sys_srv_status_e_type      gw_srv_status;
    /* The service status (SERVICE/NO SERVICE) of the system.
    ** Mask used is CM_SS_GW_SRV_STATUS_MASK.
    */

  sys_srv_status_e_type      true_gw_srv_status;
    /* The true service status (LIMITED/LIMITED_REGIONAL) of the system.
    ** Mask used is CM_SS_TRUE_GW_SRV_STATUS_MASK.
    */

  sys_srv_domain_e_type      gw_srv_domain;
    /**< The service domain registered on the system. /
    ** Mask used is CM_SS_SRV_DOMAIN_MASK.
    */

  sys_srv_domain_e_type      gw_srv_capability;
    /**< The system's service capability.
    ** Mask used is CM_SS_SRV_CAPABILITY_MASK.
    */

  sys_sys_mode_e_type        gw_sys_mode;
    /**< The system's mode.
    ** Mask used is CM_SS_SYS_MODE_MASK.
    */

  sys_roam_status_e_type     gw_roam_status;
    /**< Indicate current roaming status.
    ** Mask used is CM_SS_ROAM_STATUS_MASK.
    */

  sys_sys_id_s_type          gw_sys_id;
    /**< The ID of the selected system.
    ** Mask used is CM_SS_SYS_ID_MASK.
    */

  boolean                    gw_is_sys_forbidden;
    /**< Indicates whether the System is forbidden.
    ** Mask used is CM_SS_SYS_FORBIDDEN_MASK.
    */


  uint16                     gw_rssi;
    /**< RSSI in positive dBm i.e. 75 means -75dBm. The range for
    ** AMPS:      -110 to -89 dBm
    ** 800 CDMA:  -105 to -90 dBm
    ** 1900 CDMA: -108 to -93 dBm
    ** GSM/WCDMA: -105 to -60 dBm
    */


  int                        gw_io;
  byte                       gw_sinr;
    /**< ECIO in negative 0.5 dBm i.e. 63 means -31.5dBm.
    ** Io field is valid only when in HDR mode only operation
    ** SINR range: from 0 to 8, Level 8 represents highest SINR
    ** SINR applicable only when sys_mode = HDR.
    */

  int16                      gw_pathloss;
    /**< Pathloss is applicable only in Connected mode (otherwise 0xFF)
    */

  int16                      gw_sir;
    /**< SIR applicable and valid (otherwise 0xFF) only in WCDMA
    ** connected mode when DPCCH is active.
    */

  int16                      gw_rssi2;
    /**< The -ve RSSI value, coming from RRC layer
    */

  int16                      gw_rscp;
    /**< Signal strength in RSSI, change for WCDMA only  (otherwise 0xFF)
    */

  boolean                    gw_ecio_for_display;
    /**< TRUE if UE is in a data call, else FALSE
    */

  sys_cell_info_s_type       gw_cell_info;
    /**< The CELL_INFO of the selected system.
    **  Mask used is CM_SS_CELL_INFO_MASK
    */

  #endif

  #if (defined(FEATURE_HYBR_GW) || \
       defined(FEATURE_MM_SUPERSET))
  sys_simultaneous_mode_e_type simultaneous_mode;
    /**< Simultaneous, used to differentiate between WX and non-WX modes
    ** CM_SS_SRV_IND_MASK?
    */
  #endif

  int16                      gw_ecio;
    /**< ECIO for WCDMA only
    ** Ec/Io is measured in -0.5 dB.
    ** What WCDMA L1 sends to RRC is in 0.5dB (positive value)
    ** For GSM it is defaulted to CMSS_ECIO_VALUE_INVALID_SIGNAL
    ** Clients should check for CM_API_GW_ECIO to use this field
    */


  sys_cell_info_s_type      cell_info;
    /**< The CELL_INFO of the selected system.
    **  Mask used is CM_SS_CELL_INFO_MASK
    */


  sys_hdr_location_notification_status_e_type hdr_ln_status;
    /**< HDR LN status
    */

  cm_ss_country_list_s_type   country_list;
    /* Clients need to check for CM_API_PLUS_DIALING before
    ** using this structure.
    **
    ** Structure populated when sending CM_SS_EVENT_SELECT_COUNTRY
    */

  /* cm_plus_code*/

  cm_country_code_type        current_mcc;
    /* Clients need to check for CM_API_PLUS_DIALING before
    ** using this structure. Associated with CM_SS_SRV_STATUS_MASK
    **
    ** Carries country code of current serving country.
    */


  cm_country_code_type        home_mcc;
    /* Clients need to check for CM_API_PLUS_DIALING before
    ** using this structure. Associated with CM_SS_SRV_STATUS_MASK
    **
    ** Carries home country code.
    */


  cm_hs_based_plus_dial_e_type  plus_dial_setting;
    /* Clients need to check for CM_API_PLUS_DIALING before
    ** using this structure. Associated with CM_SS_SRV_STATUS_MASK
    **
    ** Carries NV setting corresp to plus dial
    */


  cm_reg_reject_info_s_type reg_reject_info;
    /**< Registration reject information
    */

  cm_gw_gan_info_s_type gan_info;
   /**< GAN controller information  
   */

} cm_mm_ss_info_s_type;

/** Type for serving system command callback functions.
**
** A client that wants to be notified of the result of a
** serving system-command-function needs to supply a pointer to a function
** of this type as the first parameter to a serving system-command-function.
*/
typedef void (cm_ss_cmd_cb_f_type) (

  void                    *data_block_ptr,
    /**< Pointer to client provided data block */

  cm_ss_cmd_e_type        ss_cmd,
    /**< Indicate which serving system command is this error status for */

  cm_ss_cmd_err_e_type    ss_cmd_err
    /**< Serving system command error code, indicating whether command
    ** is rejected and the reason */

);

/**===========================================================================

@FUNCTION cm_ss_cmd_get_ss_info

@DESCRIPTION
  Get a sanpshot of the current serving system information in the CM

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request


@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_ss_cmd_get_ss_info(

  cm_ss_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                 *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type    client_id
    /**< requesting client ID */

);

/**===========================================================================

@FUNCTION cm_mm_ss_cmd_ps_data_available

@DESCRIPTION
  Inform CM that data is available for transmission.

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_ss_cmd_ps_data_available(

  cm_ss_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type              client_id
    /**< requesting client ID */

);

/*===========================================================================

@FUNCTION cm_ss_cmd_orig_thr_update_tbl

@DESCRIPTION
  This API queues a command to CM to update the origination throttle table

@DEPENDENCIES
  cmss_init() should have been called previously.

@RETURNS
  True if a command was queued
  False otherwise

@SIDE_EFFECT
  None.
@x
===========================================================================*/

boolean cm_ss_cmd_orig_thr_update_tbl
(
  cm_ss_cmd_cb_f_type               *ss_cmd_cb_func,
    /**< Pointer to the call back function
    */

  void                              *data_block_ptr,
    /**< Pointer to user data
    */

  cm_client_id_type                  client,
    /**< requesting client ID
    */

  cm_ss_orig_thr_act_e_type          orig_thr_act,
    /**< The action to be taken
    */

  cm_ss_orig_thr_reasons_e_type      call_status,
    /**< The call end reason
    */

  cm_call_type_e_type                call_type,
    /**< Type of the call, e.g PS_DATA
    */

  sys_sys_mode_e_type                mode,
    /**< The mode on which the call was connected
    */

  const sys_sys_id_s_type           *sys_id,
    /**< The sys id of the system, SID,NID
    ** This field is only used if
    ** orig_thr_act = CM_SS_ORIG_THR_UPDATE_TBL_ENTRY
    */

  sys_band_class_e_type              band_class,
    /**< cellular or PCS
    ** This field is only used if
    ** orig_thr_act = CM_SS_ORIG_THR_UPDATE_TBL_ENTRY
    */

  uint16                             packet_zone
    /**< The packet zone ID
    ** This field is only used if
    ** orig_thr_act = CM_SS_ORIG_THR_UPDATE_SS
    */


);

/*===========================================================================

FUNCTION cm_ss_cmd_country_selected

DESCRIPTION
  Carries the country code selected by user in response to
  CM_SS_EVENT_SELECT_COUNTRY.

DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_GSM || FEATURE_WCDMA must be defined.

RETURN VALUE
  TRUE - request sent, FALSE - No buffer to send request

SIDE EFFECTS
  If command is successful, CM clients will be notified of the
  corresponding CM event.

===========================================================================*/
extern boolean cm_ss_cmd_country_selected (

  cm_ss_cmd_cb_f_type          cmd_cb_func,
    /* client callback function */

  cm_client_id_type            client_id,
    /* requesting client ID */

  cm_sid_type                  sid,
    /* sid for which country is being resolved */

  cm_country_code_type         country_code
    /* code of country that has been selected */
);

/*---------------------------------------------------------------------------
** Defines
**---------------------------------------------------------------------------
*/


#define CM_INBAND_MAX_FWD_DIALED_DIGITS 64
  /* Max length of forward DTMF digit string */

#ifdef FEATURE_JCDMA
  #define CM_INBAND_MAX_REV_DIALED_DIGITS 255  /* value of CAI_SBDTMF_MAX */
  #define CM_INBAND_MAX_DIALED_DIGITS CM_INBAND_MAX_REV_DIALED_DIGITS
#else /* FEATURE_JCDMA */
  #define CM_INBAND_MAX_REV_DIALED_DIGITS 32
  #define CM_INBAND_MAX_DIALED_DIGITS CM_INBAND_MAX_FWD_DIALED_DIGITS
#endif /* #else FEATURE_JCDMA */
  /* Max length of reverse DTMF digit string */


/** Enumeration of inband commands client are able to send to CM.
*/
typedef enum cm_inband_cmd_e {

  CM_INBAND_CMD_NONE=-1,
    /**< @internal */

  CM_INBAND_CMD_BURST_DTMF,
    /**< request to send  a burst DTMF */

  CM_INBAND_CMD_START_CONT_DTMF,
    /**< request to start a continuous DTMF tone */

  CM_INBAND_CMD_STOP_CONT_DTMF,
    /**< request to stop  a continuous DTMF tone */

  CM_INBAND_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_INBAND_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_inband_cmd_e_type;

/** Enumeration of inband command errors returned by call command
** callback functions.
*/
typedef enum cm_inband_cmd_err_e {

  CM_INBAND_CMD_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_INBAND_CMD_ERR_NOERR,
    /**< No errors found */

  /* parameter related error
  */

  CM_INBAND_CMD_ERR_CLIENT_ID_P,
    /**< invalid client ID */

  CM_INBAND_CMD_ERR_ON_LEN_P,
    /**< invalid DTMF pulse width */

  CM_INBAND_CMD_ERR_OFF_LEN_P,
    /**< invalid DTMF inter-digit interval */

  /* 4 */
  CM_INBAND_CMD_ERR_NULL_BUF_P,
    /**< null digit buffer */

  CM_INBAND_CMD_ERR_DIGIT_P,
    /**< invalid digits */

  CM_INBAND_CMD_ERR_CNT_P,
    /**< the value of cnt exceeds the maximum allowed value */

  CM_INBAND_CMD_ERR_CALL_ID_P,
    /**< invalid call ID */

  /* Error codes resulting from clients trying to instruct
  ** CM to perform inappropriate actions relative to the current
  ** state of the phone.
  */

  /* 8 */
  CM_INBAND_CMD_ERR_BAD_STATE_S,
    /**< invalid state for inband request */

  CM_INBAND_CMD_ERR_OFFLINE_S,
    /**< Phone is offline */

  /* Error codes resulting from operational limitation
  ** of CM.
  */

  CM_INBAND_CMD_ERR_NO_BUF_L,
    /**< No available CM command buffers to queue the command */

  /* other error
  */

  CM_INBAND_CMD_ERR_OTHER,
    /**< A problem other than the above was found */

  /* 12 */
  CM_INBAND_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  CM_INBAND_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_INBAND_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_inband_cmd_err_e_type;

/** Enumeration of inband events.
** Clients are able to register with CM to be notified of any subsets
** of these inband events.
*/
typedef enum cm_inband_event_e {

  CM_INBAND_EVENT_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_INBAND_EVENT_REV_BURST_DTMF,
    /**< send a CDMA-burst DTMF */

  CM_INBAND_EVENT_REV_START_CONT_DTMF,
    /**< start a continuous DTMF tone */

  CM_INBAND_EVENT_REV_START_CONT_DTMF_CONF,
    /**< WCDMA/GSM only: confirm whether a continuous DTMF tone is played */

  CM_INBAND_EVENT_REV_STOP_CONT_DTMF,
    /**< stop a continuous DTMF tone */

  /* 4 */
  CM_INBAND_EVENT_REV_STOP_CONT_DTMF_CONF,
    /**< WCDMA/GSM only: confirm a continuous DTMF tone is stopped */

  CM_INBAND_EVENT_FWD_BURST_DTMF,
    /**< received a CDMA-burst DTMF message */

  CM_INBAND_EVENT_FWD_START_CONT_DTMF,
    /**< received a start-continuous DTMF tone order */

  CM_INBAND_EVENT_FWD_STOP_CONT_DTMF,
    /**< received a stop-continuous DTMF tone order */

  /* 8 */
  CM_INBAND_EVENT_REV_BURST_DTMF_ACK,
    /**< FEATURE_T53 - received L2 Ack for a CDMA-burst DTMF message */

  CM_INBAND_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_INBAND_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_inband_event_e_type;

/** Type to hold inband information.
** When notified of inband events, clients are given
** a reference to such a structure.
*/
typedef struct cm_inband_info_s {

  cm_client_id_type       client_id;
    /**< request client ID for reverse DTMF requests */

  cm_call_id_type         call_id;
    /**< call ID */

  boolean                 success;
  /**< whether a continuous DTMF is played (GSM/WCDMA)*/

  uint8                   on_length;
    /**< DTMF pulse width */

  uint8                   off_length;
    /**< DTMF inter-digit interval */

  uint8                   cnt;
    /**< digit count */

  uint8                   digits[CM_INBAND_MAX_DIALED_DIGITS];
    /**< DTMF digit buffer */

  uint16                  duration;
    /**< duration for continuous DTMF; in milliseconds
    ** for reverse stop continuous DTMF event only */

  cm_client_id_type       requesting_client_id;
    /**< Requesting client */

} cm_inband_info_s_type;

/** Type for inband command callback functions.
**
** A client that wants to be notified of the result of a
** inband-command-function needs to supply a pointer to a function
** of this type as the first parameter to a inband-command-function.
*/
typedef void (cm_inband_cmd_cb_f_type) (

  void                        *data_block_ptr,
    /**< Pointer to client provided data block */

  cm_inband_cmd_e_type        inband_cmd,
    /**< Indicate which inband command is this error status for */

  cm_inband_cmd_err_e_type    inband_cmd_err
    /* Inband command error code, indicating whether command
    ** is rejected and the reason */

);

/**===========================================================================

@FUNCTION cm_mm_inband_cmd_burst_dtmf

@DESCRIPTION
  Command CM to send a burst DTMF

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  FEATURE_CDMA_800 || FEATURE_CDMA_1900 must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_inband_cmd_burst_dtmf(

  cm_inband_cmd_cb_f_type     cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< Requesting client */

  cm_call_id_type             call_id,
    /**< call ID of the call */

  uint8                       on_length,
    /**< DTMF pulse width */

  uint8                       off_length,
    /**< DTMF inter-digit interval */

  uint8                       cnt,
    /**< DTMF digit count */

  const uint8                 *dtmf_digit_ptr
    /**< Pointer to the DTMF digit buffer */

);

/**===========================================================================

@FUNCTION cm_mm_inband_cmd_start_cont_dtmf

@DESCRIPTION
  Command CM to start a continuous DTMF

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  CM must have already been initialized with

  cm_init_before_task_start() and cm_init_after_task_start()
@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_inband_cmd_start_cont_dtmf(

  cm_inband_cmd_cb_f_type     cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< Requesting client */

  cm_call_id_type             call_id,
    /**< call ID of the call */

  uint8                       digit
    /**< DTMF digit */

);

/**===========================================================================

@FUNCTION cm_mm_inband_cmd_stop_cont_dtmf

@DESCRIPTION
  Command CM to stop a continuous DTMF

  Note that the client supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_mm_inband_cmd_stop_cont_dtmf(

  cm_inband_cmd_cb_f_type     cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< Requesting client */

  cm_call_id_type             call_id,
    /**< call ID of the call */

  uint16                      duration
    /**< DTMF duration */

);

/*---------------------------------------------------------------------------
** Defines
**---------------------------------------------------------------------------
*/
#define CM_RP_USER_DATA_TPDU_LENGTH       232

#define CM_NAS_MN_TPDU_SIZE               164

/*---------------------------------------------------------------------------
** Enums
**---------------------------------------------------------------------------
*/

typedef enum cm_sms_cmd_e {

  CM_SMS_CMD_NONE=-1,
    /**< @internal */

  CM_SMS_CMD_MO_MSG,
    /**< FEATURE_CDSMS - MO SMS */

  CM_SMS_CMD_AWI_ACK,
    /**< FEATURE_CDSMS - Analog Alert with info ack */

  CM_SMS_CMD_BC_ENABLE,
    /**< FEATURE_BROADCAST_SMS */

  CM_SMS_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SMS_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sms_cmd_e_type;

/** Enumeration of SMS command errors returned by SMS command
** callback functions.
*/
typedef enum cm_sms_cmd_err_e {

  CM_SMS_CMD_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_SMS_CMD_ERR_NOERR,
    /**< FEATURE_CDSMS - No errors found */

  /* Error codes resulting from clients feeding a serving system command
  ** function with bad or inappropriate parameters.
  */

  CM_SMS_CMD_ERR_CLIENT_ID_P,
    /**< FEATURE_CDSMS - Bad client parameter */

  CM_SMS_CMD_ERR_NOT_IDLE_S,
    /**< FEATURE_CDSMS - Can not accept SMS origination while SMS state
    ** is not IDLE */

  CM_SMS_CMD_ERR_OFFLINE_S,
    /**< FEATURE_CDSMS - Phone is offline */

  /* 4 */
  CM_SMS_CMD_ERR_CDMA_LOCK_S,
    /**< FEATURE_CDSMS - Phone is CDMA locked */

  CM_SMS_CMD_ERR_CALL_ORIG_S,
    /**< FEATURE_CDSMS - Call origination is in progress */

  CM_SMS_CMD_ERR_EMERGENCY_MODE_S,
    /**< FEATURE_CDSMS - phone is in EMERGENCY callback mode only EMERGENCY
    ** call is allowed  */

  CM_SMS_CMD_ERR_NO_SRV_S,
    /**< FEATURE_CDSMS - Client tried to send MO SMS but there is no service */

  /* 8 */
  CM_SMS_CMD_ERR_NOT_ALLOWED_IN_AMPS_S,
    /**< FEATURE_CDSMS - Client tried to send MO SMS but the srv state
    ** is analog */

  CM_SMS_CMD_ERR_NOT_ANALOG_S,
    /**< FEATURE_CDSMS - Client tried to send AWI ACK but the srv state
    ** is not analog */

  /* Error codes resulting from operational limitation of CM.
  */

  CM_SMS_CMD_ERR_NO_BUF_L,
    /**< FEATURE_CDSMS - No available CM command buffers to queue the
    ** command */

  CM_SMS_CMD_ERR_OTHER,
    /**< FEATURE_CDSMS - any other errors not listed above */

  /* 12 */
  CM_SMS_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  CM_SMS_CMD_ERR_DDTM,
    /**< SMS blocked due to high psist on 1X and DO call in progress */

  CM_SMS_CMD_ERR_MODE_PREF,
    /**< Wrong mode preference over which SMS is sent
    ** Can be used only if CM_API_SMS_OVER_IP is defined
    */

  CM_SMS_CMD_ERR_SIP,
    /**< Wrong SIP status when SMS is sent over SIP.
    ** Can be used only if CM_API_SMS_OVER_IP is defined
    */

  CM_SMS_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SMS_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sms_cmd_err_e_type;

/** Enumeration of SMS events.
** Clients are able to register with CM to be notified of any subsets
** of these events.
*/
typedef enum cm_sms_event_e {

  CM_SMS_EVENT_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_SMS_EVENT_MO_MSG,
    /**< FEATURE_CDSMS */

  CM_SMS_EVENT_AWI_ACK,
    /**< FEATURE_CDSMS */

  CM_SMS_EVENT_MO_STATUS,
    /**< FEATURE_CDSMS */

  CM_SMS_EVENT_MT_MSG,
    /**< FEATURE_CDSMS */

  /* 4 */
  CM_SMS_EVENT_BC_ENABLED,
    /**< FEATURE_BROADCAST_SMS */

  CM_SMS_EVENT_MSG_WAITING,
    /**< FEATURE_CDSMS */

  CM_SMS_EVENT_N_VOICE,
    /**< FEATURE_CDSMS */

  CM_SMS_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SMS_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sms_event_e_type;

/** Now the possible statuses, as returned by MC. Since SMS uses
**  DBMs, these must map to the DBM enum, defined above. FEATURE_CDSMS only.
*/
typedef enum cm_sms_mo_status_e {

  CM_SMS_MO_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_SMS_MO_OK=CM_DBM_MO_OK,
    /**< SMS msg has been completed successfully */

  CM_SMS_MO_HOLD_ORIG_RETRY_TIMEOUT=CM_DBM_MO_HOLD_ORIG_RETRY_TIMEOUT,
    /**< HOLD ORIG retry timeout*/

  CM_SMS_MO_HOLD_ORIG=CM_DBM_MO_HOLD_ORIG,
    /**< MC can not process MO SMS because HOLD ORIG is TRUE*/

  CM_SMS_MO_NO_SRV=CM_DBM_MO_NO_SRV,
    /**< can not send SMS msg  - no service */

  /* 4 */
  CM_SMS_MO_ABORT=CM_DBM_MO_ABORT,
    /**< MC or CM aborts the SMS request */

  CM_SMS_MO_NOT_ALLOWED_IN_AMPS=CM_DBM_MO_NOT_ALLOWED_IN_AMPS,
    /**< can not sent SMS msg in analog mode */

  CM_SMS_MO_NOT_ALLOWED_IN_HDR=CM_DBM_MO_NOT_ALLOWED_IN_HDR,
    /**< can not sent SMS msg while a HDR call is up*/

  CM_SMS_MO_L2_ACK_FAILURE=CM_DBM_MO_L2_ACK_FAILURE,
    /**< not receiving L2 ack from base station */

  /* 8 */
  CM_SMS_MO_OUT_OF_RESOURCES=CM_DBM_MO_OUT_OF_RESOURCES,
    /**< e.g. out of memory buffer */

  CM_SMS_MO_ACCESS_TOO_LARGE=CM_DBM_MO_ACCESS_TOO_LARGE,
    /**< message is too large to be sent over access */

  CM_SMS_MO_DTC_TOO_LARGE=CM_DBM_MO_DTC_TOO_LARGE,
    /**< message is too large to be sent over DTC */

  CM_SMS_MO_ACCT_BLOCK = CM_DBM_MO_ACCT_BLOCK,
    /**< Access Control based on Call Type(service option)  is blocked */

  /* 12 */
  CM_SMS_MO_SIP_PERMANENT_FAILURE,
    /* The permanent SIP transport failure for MO SMS.
    ** i.e. refer to 4xx 5xx 6xx SIP error codes.
    ** Can be used only if CM_API_SMS_OVER_IP is defined
    */

  CM_SMS_MO_SIP_TEMPORARY_FAILURE,
    /* The temporary SIP transport failure for MO SMS.
    ** i.e. SIP layer time out.
    ** Can be used only if CM_API_SMS_OVER_IP is defined
    */

  CM_SMS_MO_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SMS_MO_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sms_mo_status_e_type;

/** Enumeration of SMS states. At all times a CM SMS must be in one
** of the states below.
*/
typedef enum cm_sms_state_e {

  CM_SMS_STATE_NONE=-1,
    /**< @internal */

  CM_SMS_STATE_IDLE,
    /**< SMS is in idle state */

  CM_SMS_STATE_HOLD_ORIG_RETRY,
    /**< SMS is checking Hold Orig status periodically to determine
    ** whether MO SMS can be sent to MC */

  CM_SMS_STATE_WAIT_FOR_STATUS,
    /**< SMS is waiting for MO SMS status from MC */

  CM_SMS_STATE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SMS_STATE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sms_state_e_type;

/** Analog alert with info ack message
*/
typedef struct cm_sms_awi_ack_s {

  boolean                 bf;
    /**< begin/final flag */

  uint8                   seq_no;
    /**< sequence number */

  uint8                   status;
    /**< status */

  uint8                   error_class;
    /**< error class */

} cm_sms_awi_ack_s_type;

/** Type to hold sms information.
** When notified of sms events, clients are given
** a reference to such a structure.
** FEATURE_CDSMS is removed in the data structure
** when CM_API_SMS_OVER_IP is defined.
*/
typedef struct cm_sms_info_s {

  cm_client_id_type       sms_client_id;
    /**< requesting client - MO_SMS/AWI_ACK */

  cm_sms_state_e_type     sms_state;
    /**< SMS state for MO SMS */

  cm_sms_awi_ack_s_type   awi_ack;
    /**< field for awi ack */

  uint8                   mt_sms_format;
    /**< message format for MT SMS */

  uint16                  length;
    /**< length for SMS buffer - used by MT SMS only*/

  uint8                   *data;
    /**< pointer to MT SMS buffer */

  sys_sys_mode_e_type     sys_mode;
    /**< system mode over which SMS is received.
    ** can not used when CM_API_SMS_OVER_IP is defined.
    */

  boolean                 l2_ack_requested;
    /**< l2 ack required or not - used by MO SMS*/

  cm_sms_mo_status_e_type mo_status;
    /**< status for MO SMS */

  boolean                 bc_enable;
    /**< Enable broadcast SMS - FEATURE_BROADCAST_SMS */

  cm_client_id_type       requesting_client_id;
    /**< Requesting client */

} cm_sms_info_s_type;
// TODO - callbacks must copy data array instead of pointer

/** Type for SMS command callback functions.
**
** A client that wants to be notified of the result of a
** sms-command-function needs to supply a pointer to a function
** of this type as the first parameter to a inband-command-function.
*/
typedef void (cm_sms_cmd_cb_f_type) (

  void                        *data_block_ptr,
    /**< Pointer to client provided data block */

  cm_sms_cmd_e_type           sms_cmd,
    /**< Indicate which sms command is this error status for */

  cm_sms_cmd_err_e_type       sms_cmd_err
    /* SMS command error code, indicating whether command
    ** is rejected and the reason */

);

/**===========================================================================

@FUNCTION cm_sms_cmd_awi_ack

@DESCRIPTION

  Send analog alert with info ack message to base station

  Applicable for FEATURE_UASMS

@DEPENDENCIES

  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()
  FEATURE_CDSMS || FEATURE_UASMS must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request


@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_sms_cmd_awi_ack(

  cm_sms_cmd_cb_f_type   cmd_cb_func,
    /**< client callback function */

  void                   *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type      client_id,
    /**< requesting client ID */

  uint8                  seq_no,
    /**< sequence number */

  boolean                bf,
    /**< begin/final flag */

  uint8                  error_class,
    /**< error class */

  uint8                  status
    /**< ack status */

);

/**===========================================================================

@FUNCTION cm_sms_cmd_bc_enable

@DESCRIPTION

  Enable/disable broadcast SMS

  Applicable for FEATURE_BROADCAST_SMS

@DEPENDENCIES

  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()
  FEATURE_BROADCAST_SMS && FEATURE_CDSMS must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request


@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_sms_cmd_bc_enable(

  cm_sms_cmd_cb_f_type  cmd_cb_func,
    /**< client callback function */

  void                  *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type     client_id,
    /**< requesting client ID */

  boolean               bc_enable
    /**< enable broadcast message */

);

/** Possible PD commands
*/
typedef enum cm_pd_cmd_e {

  CM_PD_CMD_NONE = -1,
    /**< @internal */

  /* 0 */
  CM_PD_CMD_SEND_MSG,
    /**< Send data burst message */

  CM_PD_CMD_SESSION_START,
    /**< Start Session Command */

  CM_PD_CMD_SESSION_END,
    /**< End Session Command */

  CM_PD_CMD_FIX_START,
    /**< Block HDR data call origination to start GPS search */

  /* 4 */
  CM_PD_CMD_FIX_END,
    /**< Unblock HDR data call origination */

  CM_PD_CMD_SEND_REVA,
    /**< This command to be used to send Release A message */

  CM_PD_CMD_SESSION_DORMANT,
    /**< The dormancy status of the session changed */

  CM_PD_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PD_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_pd_cmd_e_type;

/** Possible PD errors
*/
typedef enum cm_pd_cmd_err_e {

  CM_PD_CMD_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_PD_CMD_ERR_NOERR,
    /**< No errors found */

  /* Error codes resulting from clients feeding a serving system command
  ** function with bad or inappropriate parameters.
  */

  CM_PD_CMD_ERR_CLIENT_ID_P,
    /**< Bad client parameter */

  CM_PD_CMD_ERR_NOT_IDLE_S,
    /**< Can not accept SMS origination while SMS state is not IDLE */

  CM_PD_CMD_ERR_OFFLINE_S,
    /**< Phone is offline */

  /* 4 */
  CM_PD_CMD_ERR_CDMA_LOCK_S,
    /**< Phone is CDMA locked */

  CM_PD_CMD_ERR_CALL_ORIG_S,
    /**< Call origination is in progress */

  CM_PD_CMD_ERR_EMERGENCY_MODE_S,
    /**<  phone is in EMERGENCY callback mode only EMERGENCY call is allowed  */

  CM_PD_CMD_ERR_NO_SRV_S,
    /**< Client tried to send MO SMS but there is no service */

  /* 8 */
  CM_PD_CMD_ERR_NOT_ALLOWED_IN_AMPS_S,
    /**< Client tried to send but the srv state is analog */

  CM_PD_CMD_ERR_NOT_ALLOWED_IN_HDR_S,
    /**< Client tried to send but an HDR call is up */

  /* Error codes resulting from operational limitation
  ** of CM.
  */

  CM_PD_CMD_ERR_NO_BUF_L,
    /**< No available CM command buffers to queue the command */

  CM_PD_CMD_ERR_PHONE_BUSY,
    /**< Phone is already in use */

  /* 12 */
  CM_PD_CMD_ERR_SESSION_TYPE_INVALID,
    /**< Session type is invalid */

  CM_PD_CMD_ERR_OTHER,
    /**< any other errors not listed above */

  CM_PD_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  CM_PD_CMD_ERR_PAYLOAD_SIZE_P,
    /**< Invalid size of message payload */

  CM_PD_CMD_ERR_PAYLOAD_NULL_PTR_P,
    /**< NULL pointer passed as message payload */

  CM_PD_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_PD_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_pd_cmd_err_e_type;

/*---------------------------------------------------------------------------
** Datatypes
**---------------------------------------------------------------------------
*/

#define CM_BSSR_MAX_PILOTS          0xF /* 0xF pilots per Rec*/

/** Type for PD command callback functions.
**
** A client that wants to be notified of the result of a
** pd-command-function needs to supply a pointer to a function
** of this type.
*/
typedef void (cm_pd_cmd_cb_f_type) (

  void                       *data_block_ptr,
    /**< Pointer to client provided data block */

  cm_pd_cmd_e_type           pd_cmd,
    /**< Indicate which pd command is this error status for */

  cm_pd_cmd_err_e_type       pd_cmd_err
    /**< Reason for rejection */

);

/**
** Client should check for CM_API_SUPS_DEFAULT_VALUES before using this macro
*/
#define CM_SS_REF_UNASSIGNED  ((byte) 0x00)
  /* Default value of ss_ref in cm_sups_info_s */

/**
** Client should check for CM_API_SUPS_DEFAULT_VALUES before using this macro
*/
#define CM_SS_CODE_UNASSIGNED  ((byte) 0x00)
  /**< Default value of ss_code in cm_sups_info_s */

/**
** Client should check for CM_API_SUPS_DEFAULT_VALUES before using this macro
*/
#define CM_SS_OPERATION_UNASSIGNED  ((byte) 0x00)
  /**< Default value of ss_operation in cm_sups_info_s
  ** Set equal to NULL_SS_OPERATION in MN
  */

/**
** Client should check for CM_API_SUPS_DEFAULT_VALUES before using this macro
*/
#define CM_SS_INVOKE_ID_UNASSIGNED  ((byte) 0x00)
  /**< Default value of invoke_id in cm_sups_info_s */

#define CM_USS_DATA_MAX CM_USS_PHASE2_TYPE_MAX
  /**< Enum cm_uss_data_e */

/** Enumeration of sups command errors returned by command
** callback functions.
*/
typedef enum cm_sups_cmd_err_e {

  CM_SUPS_CMD_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_SUPS_CMD_ERR_NOERR,
    /**< No errors found */

  /* Error codes resulting from clients providing a sups command
  ** function with bad or invalid parameters.
  */

  CM_SUPS_CMD_ERR_CLIENT_ID_P,
    /**< invalid client ID - null or not initialized*/

  CM_SUPS_CMD_ERR_NULL_PARAM_P,
    /**< Null pointer parameter */

  /* Error codes resulting from clients trying to instruct
  ** CM to perform inappropriate actions relative to the current
  ** state of the call and/or phone.
  */

  CM_SUPS_CMD_ERR_OFFLINE_S,
    /**< Phone is offline */

  /* 4 */
  CM_SUPS_CMD_ERR_SRV_STATE_S,
    /**< The command in question is invalid in the current Phone serving state -
    ** e.g answering a call but serving state is no service */

  /* Error codes resulting from operational limitation
  ** of CM.
  */

  CM_SUPS_CMD_ERR_NO_BUF_L,
    /**< No available CM command buffers to queue the command */

  CM_SUPS_CMD_ERR_OTHER,
    /**< A problem other than the above was found */

  CM_SUPS_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  /* 8 */
  CM_SUPS_CMD_ERR_CALL_CONTROL_FAILURE,
    /**< Unable to complete call control */

  CM_SUPS_CMD_ERR_CALL_CONTROL_REJECTED,
    /**< Call control rejected sups request */

  CM_SUPS_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SUPS_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sups_cmd_err_e_type;

/** Enumeration of supplementary services events.
** Clients are able to register with CM to be notified of any subsets
** of these supplementary services events.
*/
typedef enum cm_sups_event_e {

  CM_SUPS_EVENT_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_SUPS_EVENT_REGISTER,
    /**< Register Supplementary Service */

  CM_SUPS_EVENT_REGISTER_CONF,
    /**< Register Supplementary Service Confirmation */

  CM_SUPS_EVENT_ERASE,
    /**< Erase Supplementary Service Request */

  CM_SUPS_EVENT_ERASE_CONF,
    /**< Erase Supplementary Service Confirmation */

  /* 4 */
  CM_SUPS_EVENT_ACTIVATE,
    /**< Activate Supplementary Service Request */

  CM_SUPS_EVENT_ACTIVATE_CONF,
    /**< Activate Supplementary Service Confirmation */

  CM_SUPS_EVENT_DEACTIVATE,
    /**< Deactivate Supplementary Service Request */

  CM_SUPS_EVENT_DEACTIVATE_CONF,
    /**< Deactivate Supplementary Service Confirmation */

  /* 8 */
  CM_SUPS_EVENT_INTERROGATE,
    /**< Interrogate Supplementary Service Request */

  CM_SUPS_EVENT_INTERROGATE_CONF,
    /**< Interrogate Supplementary Service Confirmation */

  CM_SUPS_EVENT_REG_PASSWORD,
    /**< Register Password Supplementary Service Request*/

  CM_SUPS_EVENT_REG_PASSWORD_CONF,
    /**< Register Password Supplementary Service Confirmation */

  /* 12 */
  CM_SUPS_EVENT_PROCESS_USS,
    /**< Process Unstructured Supplementary Service Request */

  CM_SUPS_EVENT_PROCESS_USS_CONF,
    /**< Process Unstructured Supplementary Service Confirmation */

  CM_SUPS_EVENT_RELEASE,
    /**< Release Supplementary Service Request */

  CM_SUPS_EVENT_ABORT,
    /**< Abort Supplementary Service Request */

  /* 16 */
  CM_SUPS_EVENT_FWD_CHECK_IND,
    /**< Forward Check Supplementary Service Indication */

  CM_SUPS_EVENT_USS_NOTIFY_IND,
    /**< Unstructured Supplementary Service Notify Indication */

  CM_SUPS_EVENT_USS_NOTIFY_RES,
    /**< Unstructured Supplementary Service Notify Response */

  CM_SUPS_EVENT_USS_IND,
    /**< Unstructured Supplementary Service Indication */

  /* 20 */
  CM_SUPS_EVENT_USS_RES,
    /**< Unstructured Supplementary Service Response */

  CM_SUPS_EVENT_RELEASE_USS_IND,
    /**< Release Unstructured Supplementary Service Indication */

  CM_SUPS_EVENT_GET_PASSWORD_IND,
    /**< Get Password Supplementary Service Indication */

  CM_SUPS_EVENT_GET_PASSWORD_RES,
    /**< Get Password Supplementary Service Response */


  /* 24 */
  CM_SUPS_EVENT_LCS_LOCATION_NOTIFICATION_IND,
    /**< LCS Location Notification Indication */

  CM_SUPS_EVENT_LCS_LOCATION_NOTIFICATION_RES,
    /**< LCS Location Notification Response */

  CM_SUPS_EVENT_LCS_MOLR,
    /**< LCS MOLR Request */

  CM_SUPS_EVENT_LCS_MOLR_COMPLETED,
    /**< LCS MOLR Completed */

  /* 28 */
  CM_SUPS_EVENT_LCS_MOLR_CONF,
    /**< LCS MOLR Confirmation */


  CM_SUPS_EVENT_SS_MOD_TO_ORIG,
    /**< Sups command was modified to origination due to call control */

  CM_SUPS_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_SUPS_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_sups_event_e_type;

/* Response to Unstructured SS Indication from the
   network.
*/
typedef enum cm_uss_res_e {

  CM_USS_RES_SS_NONE=-1,
    /**< @internal */

  CM_USS_RES_SS_DATA,
    /**< USS response with data */

  CM_USS_RES_SS_ERROR,
    /**< USS response indicating SS error */

  CM_USS_RES_SS_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_USS_RES_SS_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_uss_res_e_type;

typedef enum cm_uss_data_e
{

  CM_USS_UNKNOWN_TYPE = -1,
    /**< @internal */

  CM_USS_PHASE1_TYPE,
    /**< Phase 1 USS data */

  CM_USS_PHASE2_TYPE,
    /**< Phase 2 USS data */

  CM_USS_DATA_NONE,
    /**< USS data with no type */

  CM_USS_PHASE2_TYPE_MAX
  /**< @internal */

  #ifdef FEATURE_RPC
  , CM_USS_DATA_SS_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */


} cm_uss_data_e_type;

/**
** Unparsed SUPS L3 message passed from MN.
** Clients need to check for CM_SUPS_UNPARSED_L3_DATA before
** using this field.
*/
typedef struct cm_sups_unparsed_l3_data_s
{
   boolean                         present;
     /**< To check if size and data are valid */

   uint16                            size;
     /**< Actual size of the array data */

   byte                            data[CM_MAX_SUPS_PARAMETER_LENGTH];
     /**< array to hold the L3 raw data from MN */

} cm_sups_unparsed_l3_data_s_type;

/** Type to hold supplementary services information.
** When notified of supplementary services events, clients are given
** a reference to such a structure.
*/
typedef struct cm_sups_info_s {
  cm_client_id_type                   sups_client_id;
    /**< client */

  boolean                             ss_success;

  uint8                               ss_ref;
    /**< SS reference */

  uint8                               ss_code;
    /**< SS code */

  uint8                               ss_operation;
    /**< SS operation */

  uint8                               invoke_id;
    /**< Invocation Id */

  basic_service_s_type                basic_service;
    /**< Basic Service Group information */

  cm_called_party_bcd_no_s_type       forwarded_to_number;
    /**< Forwarded to number */

  cm_called_party_subaddress_s_type   forwarded_to_subaddress;
    /**< Forwarded to subaddress */

  ie_no_reply_condition_timer_s_type  nr_timer;
    /**< No reply condition timer */

  ie_ss_password_s_type               ss_password;
    /**< SS password */

  ie_ss_password_s_type               ss_new_password;
    /**< New password */

  ie_ss_password_s_type               ss_new_password_again;
    /**< Confirmation of new password */

  ie_ss_code_s_type                   code;
    /**< SS code */

  ss_password_value                   guidance_info;
    /**< Password guidance information */

  cm_ss_conf_e_type                   conf_type;
    /**< SS confirmation type */

  ie_cm_ss_error_s_type               ss_error;
    /**< SS error */

  ie_forwarding_info_s_type           forwarding_info;
    /**< Call forwarding Information */

  ie_call_barring_info_s_type         call_barring_info;
    /**< Call barring information */

  ie_cug_info_s_type                  cug_info;
    /**< Closed User Group information */

  ie_cm_cc_cause_s_type               cc_cause;
    /**< Call control cause */

  ie_ss_status_s_type                 ss_status;
    /**< SS status */

  basic_service_group_list_s_type     bsg_list;
    /**< Basic Service Group list information */

  ie_forwarding_feature_list_s_type   fwd_feature_list;
    /**< Forwarding Feature list information */

  cli_restriction_info_s_type         cli_restriction;
    /**< CLI restriction information */

  cm_uss_data_e_type                  uss_data_type;
    /**< Type of USS message - phase1, phase2 */

  uss_data_s_type                     uss_data;
    /**< Unstructured SS data */

  ie_cm_ss_data_s_type                ss_data;
    /**< SS data */


  location_notification_s_type    location_notification;
    /**< LCS Location Notification Data */

  lcs_molr_res_s_type                     lcs_molr_res;
    /**< LCS MOLR Response */



  cm_client_id_type                   requesting_client_id;
    /**< Requesting client */


  cm_ccbs_indx_type                   ccbs_indx;
    /**< Clients should check for CM_API_CCBS
    ** to use this field
    **
    ** ccbs_indx = CM_CCBS_INDX_INVALID results
    **   deact of all pending ccbs requests.
    **
    ** ccbs_indx = valid value results in one particular
    **   ccbs getting deactivated.
    */

  #if defined(FEATURE_CCBS) || defined(FEATURE_MM_SUPERSET)
  ccbs_info_s_type                    ccbs_info;
    /**< Clients should check for CM_API_CCBS
    ** to use this field.
    ** Carries list of ccbs indices returned as a result of
    ** interrogation. Note that ccbs_Index will contain call
    ** ids.
    */
  #endif

  cm_sups_unparsed_l3_data_s_type      sups_unparsed_l3_data;
    /**<
    **  Unparsed L3 message from MN.
    ** Clients need to check for CM_SUPS_UNPARSED_L3_DATA before
    ** using this field.
    */

} cm_sups_info_s_type;

/** Get Password Response Parameters
*/
typedef struct cm_get_pwd_res_params_s {

  uint8                      invoke_id;
    /**< Invocation Id */

  ie_ss_password_s_type      ss_pwd;
    /**< SS password - one of old, new or confirmation of
                     new password as requested by the
                     network
    */

} cm_get_pwd_res_params_s_type;

/** LCS Location Notification Response Parameters
*/
typedef struct cm_lcs_location_notification_res_params_s {

  uint8                        invoke_id;
    /**< Invocation ID */

  ie_ss_location_notification_res_s_type  location_notification_res;
    /**< Enumerated Response */

} cm_lcs_location_notification_res_params_s_type;

/** LCS MOLR SS Parameters
*/
typedef  struct cm_lcs_molr_ss_params_s {

  uint8                  ss_ref;
    /**< SS reference */

  cm_molr_type_e_type             molr_type;
    /**< MOLR Type */

  location_method_s_type       location_method;
    /**< Location Method */

  lcs_qos_s_type               lcs_qos;
    /**< QOS Type */

  lcs_client_external_id_s_type external_id;
    /**< LCS Client External ID */

  mlc_number_s_type            mlc_number;
    /**< MLC Number */

  gps_assistance_data_s_type   gps_assistance_data;
    /**< GPS Assistance Data */

  supported_gad_shapes_s_type  supported_gad_shapes;
    /**< Supported GAD Shapes */

} cm_lcs_molr_params_s_type;

/** LCS MOLR Completed SS Parameters
*/
typedef struct cm_lcs_molr_completed_params_s {

  uint8  ss_ref;
    /**< SS Reference */

} cm_lcs_molr_completed_params_s_type;

/** Unstructured SS Notify Response Parameters
*/
typedef struct cm_uss_notify_res_params_s {

  ie_cm_ss_error_s_type        ss_error;
    /**< USS Notify response SS error */

  uint8                        invoke_id;
    /**< Invocation Id */

} cm_uss_notify_res_params_s_type;

/** Unstructured SS Response Parameters
*/
typedef struct cm_uss_res_params_s {

  uint8                           invoke_id;
    /**< Invocation Id */

  uss_res_data_s_type             uss_res_data;
    /**< USS response data */

} cm_uss_res_params_s_type;

/** Type for SUPS command callback functions.
**
** A client that wants to be notified of the result of a
** sups-command-function needs to supply a pointer to a function
** of this type as the first parameter to a sups-command-function.
*/
typedef void (cm_sups_cmd_cb_f_type) (

  void                        *data_block_ptr,
    /**< Pointer to client provided data block */

  cm_sups_cmd_e_type           sups_cmd,
    /**< Indicate which sups command is this error status for */

  cm_sups_cmd_err_e_type       sups_cmd_err
    /**< SUPS command error code, indicating whether command
    ** is rejected and the reason */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_register

@DESCRIPTION
  Register SS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_register(

  cm_sups_cmd_cb_f_type     sups_cmd_cb_func,
    /**< client callback function */

  void                      *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type         client_id,
    /**< originating client */

  const cm_reg_ss_params_s_type   *reg_cmd_params
    /**< pointer to register SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_erase

@DESCRIPTION
  EraseSS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_erase(

  cm_sups_cmd_cb_f_type       sups_cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< originating client */

  const cm_erase_ss_params_s_type   *erase_cmd_params
    /**< pointer to erase SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_activate

@DESCRIPTION
  EraseSS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_activate(

  cm_sups_cmd_cb_f_type    sups_cmd_cb_func,
    /**< client callback function */

  void                     *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type        client_id,
    /**< originating client */

  const cm_act_ss_params_s_type  *act_cmd_params
    /**< pointer to activate SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_deactivate

@DESCRIPTION
  DeactivateSS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_deactivate(

  cm_sups_cmd_cb_f_type       sups_cmd_cb_func,
    /**< client callback function */

  void                        *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type           client_id,
    /**< originating client */

  const cm_deact_ss_params_s_type   *deact_cmd_params
    /**< pointer to erase SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_interrogate

@DESCRIPTION
  InterrogateSS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_interrogate(

  cm_sups_cmd_cb_f_type        sups_cmd_cb_func,
    /**< client callback function */

  void                         *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type            client_id,
    /**< originating client */

  const cm_interr_ss_params_s_type   *interr_cmd_params
    /**< pointer to interrogate SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_process_uss

@DESCRIPTION
  Process Unstructured SS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_process_uss(

  cm_sups_cmd_cb_f_type    sups_cmd_cb_func,
    /**< client callback function */

  void                     *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type        client_id,
    /**< originating client */

  const cm_uss_params_s_type     *process_uss_cmd_params
    /**< pointer to Process Unstructured SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_reg_password

@DESCRIPTION
  Register Password SS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_reg_password(

  cm_sups_cmd_cb_f_type      sups_cmd_cb_func,
    /**< client callback function */

  void                       *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type          client_id,
    /**< originating client */

  const cm_reg_pwd_params_s_type   *reg_pwd_cmd_params
    /**< pointer to register password SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_release

@DESCRIPTION
  Release SS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_release(

  cm_sups_cmd_cb_f_type          sups_cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type              client_id,
    /**< originating client */

  const cm_release_ss_params_s_type    *release_cmd_params
    /**< pointer to release SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_get_password_res

@DESCRIPTION
  Get Password response command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_get_password_res(

  cm_sups_cmd_cb_f_type             sups_cmd_cb_func,
    /**< client callback function */

  void                              *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type                 client_id,
    /**< originating client */

  const cm_get_pwd_res_params_s_type      *get_pwd_res_params
    /**< pointer to Get Password response data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_lcs_molr

@DESCRIPTION
  LCS MOLR SS command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
boolean cm_sups_cmd_lcs_molr
(

        cm_sups_cmd_cb_f_type            sups_cmd_cb_func,
            /**< client callback function */

        void                            *data_block_ptr,
            /**< pointer to client callback data block */

        cm_client_id_type                client,
            /**< originating client */

        const cm_lcs_molr_params_s_type *lcs_molr_cmd_params
            /**< pointer to lcs-MOLR SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_lcs_location_notification_res

@DESCRIPTION
  Send an LCS location notification response to the network.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
boolean cm_sups_cmd_lcs_location_notification_res(

        cm_sups_cmd_cb_f_type             sups_cmd_cb_func,
            /**< client callback function */

        void                               *data_block_ptr,
            /**< pointer to client callback data block */

        cm_client_id_type                  client,
            /**< originating client */

  const cm_lcs_location_notification_res_params_s_type       *lcs_location_notification_res_params
            /**< pointer to location notification response data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_lcs_molr_completed

@DESCRIPTION
  LCS MOLR SS Completed command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
boolean cm_sups_cmd_lcs_molr_completed(

        cm_sups_cmd_cb_f_type      sups_cmd_cb_func,
            /**< client callback function */

        void                       *data_block_ptr,
            /**< pointer to client callback data block */

        cm_client_id_type           client,
            /**< originating client */

 const cm_lcs_molr_completed_params_s_type    *lcs_molr_completed_cmd_params
            /**< pointer to lcs-MOLR Completed SS command data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_uss_notify_res

@DESCRIPTION
  Unstructured SS Notify response command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_uss_notify_res(

  cm_sups_cmd_cb_f_type               sups_cmd_cb_func,
    /**< client callback function */

  void                                *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type                   client_id,
    /**< originating client */

  const cm_uss_notify_res_params_s_type     *uss_notify_res_params
    /**< pointer to Unstructured SS Notify response data */

);

/**===========================================================================

@FUNCTION cm_sups_cmd_uss_res

@DESCRIPTION
  Unstructured SS response command to CM.

  Note that the client's supplied callback function, cmd_cb_func,
  will be called to notify the client of the command status.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  If command is successful, CM clients will be notified of the
  corresponding CM event.

@x
===========================================================================*/
extern boolean cm_sups_cmd_uss_res(

  cm_sups_cmd_cb_f_type         sups_cmd_cb_func,
    /**< client callback function */

  void                          *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type             client_id,
    /**< originating client */

  const cm_uss_res_params_s_type      *uss_res_params
    /**< pointer to Unstructured SS response data */

);

/*---------------------------------------------------------------------------
** Defines
**---------------------------------------------------------------------------
*/

#define CM_DBM_MAX_PAYLOAD_SIZE 255 /* Data Burst Message max payload size */

/*---------------------------------------------------------------------------
** Enums
**---------------------------------------------------------------------------
*/

typedef enum
{
  CM_DBM_NONE = -1,

  /**< CM will try to send the DBM on either access or enhanced access channel
   *  or traffic (if traffic channel is available). If it fails to successfully
   *  do that, then it will originate a call and send the DBM on traffic.
  */
  CM_DBM_TRANSMIT_AUTOMATIC,


  /**< CM will try to send the DBM on enhanced access channel or traffic (if
   *  traffic channel is available). If it fails to successfully do that or
   *  enhanced access channel is not available, then it will notify back a
   *  failure event to the interested clients.
  */
  CM_DBM_TRANSMIT_ENH_ACCESS_OR_TRAFFIC,


  /**< CM will try to send the DBM on access channel or traffic (if traffic
   *  channel is available). If it fails to successfully do that, then it
   *  will notify back a failure event to the interested clients.
  */
  CM_DBM_TRANSMIT_IN_CURR_PROTOCOL_STATE,


  CM_DBM_MAX

} cm_dbm_trans_pref_e_type;

/*---------------------------------
  Possible DBM events
 *------------------------------ */

typedef enum cm_dbm_event_e {
    CM_DBM_EVENT_NONE = -1,    /**< @internal */

    CM_DBM_EVENT_MO_STATUS,
    CM_DBM_EVENT_MT_MSG,

    CM_DBM_EVENT_MAX         /**< @internal */
} cm_dbm_event_e_type;

/*---------------------------------
  Possible DBM classes
 *------------------------------ */

typedef enum cm_dbm_class_e {
    CM_DBM_CLASS_NONE=-1,    /**< @internal */

    CM_DBM_CLASS_PD,         /* Class for Position Determination */
    CM_DBM_CLASS_SDB,        /* Class for Short Data Burst */

    CM_DBM_CLASS_MAX         /**< @internal */
} cm_dbm_class_e_type;

/*---------------------------------
  Possible DBM commands
 *------------------------------ */

typedef enum cm_dbm_cmd_e {
    CM_DBM_CMD_NONE = -1,

    CM_DBM_CMD_SEND_MSG,

    CM_DBM_CMD_MAX
} cm_dbm_cmd_e_type;

/*---------------------------------
  Possible DBM errors
 *------------------------------ */

typedef enum cm_dbm_cmd_err_e {

    CM_DBM_CMD_ERR_NONE=-1,
        /**< @internal */

    /* 0 */
    CM_DBM_CMD_ERR_NOERR,
        /**< No errors found */

    /*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

    /* Error codes resulting from clients feeding a serving system command
    ** function with bad or inappropriate parameters.
    */

    CM_DBM_CMD_ERR_CLIENT_ID_P,
        /**< Bad client parameter */

    /*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/


    CM_DBM_CMD_ERR_NOT_IDLE_S,
     /**< Can not accept SMS origination while SMS state is not IDLE */

    CM_DBM_CMD_ERR_OFFLINE_S,
        /**< Phone is offline */

    /* 4 */
    CM_DBM_CMD_ERR_CDMA_LOCK_S,
        /**< Phone is CDMA locked */

    CM_DBM_CMD_ERR_CALL_ORIG_S,
        /**< Call origination is in progress */

    CM_DBM_CMD_ERR_E911_MODE_S,
        /**<  phone is in E911 callback mode only E911 call is allowed  */

    CM_DBM_CMD_ERR_NO_SRV_S,
        /**< Client tried to send MO SMS but there is no service */

    /* 8 */
    CM_DBM_CMD_ERR_NOT_ALLOWED_IN_AMPS_S,
        /**< Client tried to send but the srv state is analog */

    /* Error codes resulting from operational limitation
    ** of CM.
    */

    CM_DBM_CMD_ERR_NO_BUF_L,
        /**< No available CM command buffers to queue the command */


    CM_DBM_CMD_ERR_OTHER,
        /**< any other errors not listed above */

    CM_DBM_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
      /**< The function is unavailable due to relavent feature being undefined */

    /* 12 */
    CM_DBM_CMD_ERR_PAYLOAD_NULL_PTR_P,
      /**< Bad payload pointer */

    CM_DBM_CMD_ERR_PAYLOAD_SIZE_P,
    /**< Bad payload size parameter */

    CM_DBM_CMD_ERR_DDTM,
      /**< 1X in high psist and DO call in progress */

    CM_DBM_CMD_ERR_MAX
        /**< @internal */

} cm_dbm_cmd_err_e_type;

typedef enum cm_dbm_source_e
{

  CM_DBM_FROM_1X,
  CM_DBM_FROM_HDR

} cm_dbm_source_e_type;

/*---------------------------------------------------------------------------
** Datatypes
**---------------------------------------------------------------------------
*/

typedef struct cm_dbm_cmd_info_s {

  uint8                    payload[CM_DBM_MAX_PAYLOAD_SIZE];
  uint16                   num_bytes;

  cm_dbm_trans_pref_e_type trans_pref;
      /**< Transmission preference whether to send on
         EACH, ACH or set up a call etc..
      */

  uint8                    rlp_flow;
      /**< RLP Flow only used in HDR DOS msgs to identify RLP
      */

  uint8                    route;
      /**< Route indication.
      */

} cm_dbm_cmd_info_s_type;

 typedef struct
{

  uint8                   burst_type;
    /**< Burst type whether a PD or SDB e.g. CAI_POSITION_DET etc. */

  cm_dbm_source_e_type    burst_source;
    /**< Whether the DBM came over 1X or HDR. */

  /**<---------------------------------
    Following 2 fields used for MO
    message status event.
   *------------------------------ */

  void                   *user_data;
    /**< The user data tag associated with a MO message */

  cm_dbm_mo_status_e_type mo_status;
    /**< The status of a MO message */

  word                    burst_overflow_size;
    /**< Number of bytes the message exceeds its maximum allowed limit */

  /**<---------------------------------
    Following 2 fields used for receiving
    messages over CDMA
   *------------------------------ */

  uint8                  *payload;
    /**< Pointer to data for received message */

  uint8                   num_bytes;
    /**< Number of bytes in the payload */

  /**<---------------------------------
    Following 2 fields used for receiving
    MT DOS messages over HDR
   *------------------------------ */

  void                   *dos_payload;
    /**< Pointer to DOS payload from HDR passed as a DISM item
    */

  uint32                 dos_num_bytes;
    /**< Number of bytes in the dos payload
    */

  cm_client_id_type      requesting_client_id;
    /**< Requesting client
    */

  uint8                  rlp_flow;
    /**< Corresponding Link Flow number for the DoS packet
    ** (FEATURE_HDR_EMPA)
    */

  byte                   route;
    /**< Route on which the DoS packet should go
    ** (FEATURE_HDR_EMPA)
    */


} cm_dbm_info_s_type;

/*---------------------------------------------------------------------------
** Functions
**---------------------------------------------------------------------------
*/

typedef void (cm_dbm_cmd_cb_f_type) (

    void                        * data_block_ptr,
        /**< Pointer to client provided data block */

    cm_dbm_cmd_e_type           dbm_cmd,
        /**< Indicate which DBM command is this error status for */

    cm_dbm_cmd_err_e_type       dbm_cmd_err
        /**< Reason for rejection */
);

/** This callback function is used for copying the payload from
 *  Client's space to CM's space. Not all client are required to
 *  provide an implementation for this. If this is NULL CM does
 *  a memcopy itself. If this not NULL, this function is called
 *  to copy the payload into CM's space. This was provided for
 *  DS to avoid multiple copying of long payload.
*/
typedef int8 (cm_dbm_payload_copy_cb_f_type) (

    void                        * payload,
        /**<  Pointer to client provided payload
         *  <input parameter>
        */

    byte                        * dbm_payload,
        /**<  Pointer to memory buffer to store the payload data
         *  <output parameter>
        */
    int                         * num_bytes
        /**<  Number of bytes to copy
        */
);

/*===========================================================================

@FUNCTION cm_dbm_cmd_mo_msg

@DESCRIPTION
  Send a data burst message. Places a request on the CM queue.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_dbm_cmd_mo_msg(
  uint8                              burst_type,
      /**< Burst type whether a PD ro SDB e.g. CAI_POSITION_DET etc */

  cm_dbm_cmd_cb_f_type               cmd_cb_func,
      /**< client callback function */

  void                               *data_block_ptr,
      /**< pointer to client callback data block */

  cm_client_id_type                  client_id,
      /**< requesting client ID */

  void *                             payload_ptr,
      /**< pointer to start of message */

  uint16                             num_bytes,
      /**< Number of bytes in message */

  cm_dbm_payload_copy_cb_f_type      *payload_copy_func,
      /**< Pointer to callback function to copy payload from client's
       * memory space to CM's memory space
      */

    uint8                   l2_ack_wait_time,
        /**< Maximum number of seconds to wait for receiving L2 ack */

    uint8                   l3_ack_wait_time,
        /**< Maximum number of seconds to wait for receiving L3 ack
         * before sending the pref sys change command
        */

    cm_dbm_trans_pref_e_type  trans_pref
        /* Transmission preference like REACH, ACH etc.. */
);

/**===========================================================================

@FUNCTION cm_dbm_cmd_mo_msg2

@DESCRIPTION
  Send a data burst message. Places a request on the CM queue.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURN VALUE
  TRUE - request sent, FALSE - No buffer to send request

@SIDE EFFECTS
  none

===========================================================================*/
extern boolean cm_dbm_cmd_mo_msg2 (
  uint8                              burst_type,
      /**< Burst type whether a PD ro SDB e.g. CAI_POSITION_DET etc */

  cm_dbm_cmd_cb_f_type               cmd_cb_func,
      /**< client callback function */

  void                               *data_block_ptr,
      /**< pointer to client callback data block */

  cm_client_id_type                  client_id,
      /**< requesting client ID */

  const cm_dbm_cmd_info_s_type       *dbm_cmd_info_ptr,
      /**< DBM information pointer */

  uint8                              l2_ack_wait_time,
      /**< Maximum number of seconds to wait for receiving L2 ack */

  uint8                              l3_ack_wait_time
      /**< Maximum number of seconds to wait for receiving L3 ack
       * before sending the pref sys change command
      */
);

/** Enumeration of BCMCS commands that clients are able to send to CM.
*/
typedef enum cm_bcmcs_cmd_e {

  CM_BCMCS_CMD_NONE = -1,
    /**< @internal */

  CM_BCMCS_CMD_FLOW_REQUEST_F,
    /**< Request for flow registration */

  CM_BCMCS_CMD_REG_REQUEST_F,
    /**< BCMCS Registration Request */

  CM_BCMCS_CMD_BOM_CACHING_SETUP_F,
    /**< BCMCS strict caching setup */

  CM_BCMCS_CMD_REG_HANDOFF_F,
    /**< Enable event driven registrations on handoff */
  
  CM_BCMCS_CMD_FLOW_DEACT_REQUEST_F,
    /* Request for flow deactivation */

  CM_BCMCS_CMD_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_BCMCS_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_bcmcs_cmd_e_type;

/** Enumeration of BCMCS command errors returned by
** BCMCS command callback functions.
*/
typedef enum cm_bcmcs_cmd_err_e {

  CM_BCMCS_CMD_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_BCMCS_CMD_ERR_NOERR,
    /**< No errors found */

  /*
  ** Error codes resulting from clients feeding a command
  ** function with bad or inappropriate parameters.
  */

  CM_BCMCS_CMD_ERR_INVALID_NUMBER_OF_FLOW_IDS_P,
    /**< Number of flow ids is < 0 or > SYS_BCMCS_MAX_FLOWS or
       number of flow ids is 0 while pointer to flow id list is not NULL.
       Returned the moment client tries to queue a BCMCS command to CM */

  CM_BCMCS_CMD_ERR_FLOW_IDS_NULL_PTR_P,
     /**< Null pointer given as parameter instead of a pointer
        to a list of flow ids when number of flow ids is not 0.
        Returned the moment client tries to queue a BCMCS command to CM */

  /**<- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  /* Error codes resulting from CM being in wrong state
     for the command to be processed */

  CM_BCMCS_CMD_ERR_BCMCS_SRV_NOT_AVAILABLE_S,
    /**< Returned in response to CM_BCMCS_CMD_FLOW_REQUEST_F
       when no BCMCS service is available at any of
       the acquired systems
       NOTE: Client will be returned this error only after
             CM_BCMCS_CMD_FLOW_REQUEST_F was processed by CM.
             This is because BCMCS service may have became
             available / not available between when
             CM_BCMCS_CMD_FLOW_REQUEST_F is queued and processed by CM */

  /* Error codes resulting from operational limitation
  ** of CM.
  */

  /* 4 */
  CM_BCMCS_CMD_ERR_NO_BUF_L,
    /**< No available CM command buffers to queue the command */

  CM_BCMCS_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to FEATURE_BCMCS being undefined */

  CM_BCMCS_CMD_ERR_OTHER,
    /**< Error other than any of the above */

  CM_BCMCS_CMD_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_BCMCS_CMD_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_bcmcs_cmd_err_e_type;

/** Enumeration of BCMCS events.
** Clients are able to register with CM to be notified of any subsets
** of these events.
*/
typedef enum cm_bcmcs_event_e {

  CM_BCMCS_EVENT_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_BCMCS_EVENT_FLOW_REQUEST_SUCCESS,
    /**< CM_BCMCS_CMD_FLOW_REQUEST_F succeeded
       Sent to client when CM received CM_HDR_BCMCS_UPDATE_FLOW_REQ_SUCCESS_F
       or CM_HDR_BCMCS_BROADCAST_DISCONTINUED_F report from HDR protocol.
       Event payload will indicate flow status for each flow that
       got registered / deregistered. */

  CM_BCMCS_EVENT_FLOW_REQUEST_FAILURE,
    /**< CM_BCMCS_CMD_FLOW_REQUEST_F failed
       Sent to client when CM failed to deliver flow registration
       request to HDR (currently it only happens when BCMCS service is
       permanently lost).
       Event payload will indicate flow status for each flow. */

  CM_BCMCS_EVENT_FLOW_STATUS_CHANGE,
    /**< HDR flow status change
       Sent to client when CM received CM_HDR_BCMCS_FLOW_STATUS_F
       report from HDR protocol.
       Event payload will indicate flow status for each flow */

  CM_BCMCS_EVENT_BROADCAST_RESET,
    /**< Broadcast reset
       Sent to client when CM received CM_HDR_BCMCS_BROADCAST_RESET_F report
       from HDR protocol.
       Event payload will indicate flow status for each flow */

  /* 4 */
  CM_BCMCS_EVENT_REGISTRATION_STATUS,
    /**<
    ** HDR registration status update Sent to client when CM
    ** received a CM_HDR_BCMCS_REG_STATUS_F report from the HDR
    ** protocol. Event payload will indicate flow registration
    ** status for each flow that was registered
    */

  CM_BCMCS_EVENT_FLOW_DEACT_REQUEST_SUCCESS,
     /* Sent to client when MBMS deact cnf is received 
     */

  CM_BCMCS_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_BCMCS_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_bcmcs_event_e_type;

/** Type to hold BCMCS information.
** When notified of BCMCS events, clients are given
** a reference to such a structure.
*/
typedef struct cm_bcmcs_info_s {

  sys_sys_mode_e_type             protocol;
    /**< Indicate what protocol this event comes from */

  uint8                           num_of_flows;
    /**< Number of entries in flow_status array below */

  sys_bcmcs_flow_status_element_s_type  flow_status_array[ SYS_BCMCS_MAX_FLOWS ];
    /**< Array of <IP>:<port number> addresses for which flows should be requested */

  cm_client_id_type               requesting_client_id;
    /**< Requesting client */

  sys_bcmcs_reg_status_element_s_type reg_status_array[ SYS_BCMCS_MAX_FLOWS ];
  /**< List of all the flows and registration statuses */

} cm_bcmcs_info_s_type;

/* Type for BCMCS command callback functions.
**
** A client that wants to be notified of the result of a BCMCS command
** needs to supply a pointer to a function of this type as the first
** parameter to a BCMCS command function.
**
** NOTE! Client's provided callback functions must be reentrant since they
** might be called from client, as well as, CM context simultaneously.
*/
typedef void (cm_bcmcs_cmd_cb_f_type) (

  void                      *data_block_ptr,
    /**< Pointer to client provided data block.
    **
    ** NOTE! Depending on the client implementation of this function
    ** the data block pointed by this pointer might be accessed from
    ** client, as well as, CM context simultaneously */

  cm_bcmcs_cmd_e_type        bcmcs_cmd,
    /**< Indicate which command is this error status for */

  cm_bcmcs_cmd_err_e_type    bcmcs_cmd_err
    /* Call command error code, indicating whether command
    ** is rejected and the reason */

);

/**===========================================================================
@FUNCTION cm_bcmcs_cmd_flow_request

@DESCRIPTION

  Queue CM_BCMCS_CMD_FLOW_REQUEST_F command to CM.
  This command is used to register BCMCS data flows with
  lower layer.

  If num_of_flows > 0 and flow_ids_array_ptr is not NULL,
  queueing CM_BCMCS_CMD_FLOW_REQUEST_F will result in
  "update flow registration" command sent to the lower layer.

  If num_of_flows = 0 and flow_ids_array_ptr is NULL,
  queueing CM_BCMCS_CMD_FLOW_REQUEST_F will result in
  "discontinue broadcast" command sent to the lower layer.


@DEPENDENCIES
  None

@RETURNS

  TRUE
  Command was queued succesfully to CM

  FALSE
  No CM buffer available to queue the command

@SIDE_EFFECT
  None

@x
===========================================================================*/
boolean cm_bcmcs_cmd_flow_request(

  cm_bcmcs_cmd_cb_f_type   cmd_cb_func,
    /**< client callback function */

  void                 *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type     client_id,
    /**< originating client */

  uint8                 num_of_flows,
    /**< Number of entries in the array below */

  const sys_bcmcs_flow_addr_s_type* flow_ids_array_ptr
    /**< Array of <IP>:<port number> addresses for which flows should be requested */

);

boolean cm_bcmcs_cmd_flow_request2(

  cm_bcmcs_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type               client_id,
    /**< originating client */

  uint8                           num_of_flows,
    /**< number of entries in the array below */

  const sys_bcmcs_flow_addr_s_type *flow_ids_array_ptr,
    /**< array of IP:port number addresses for which flows should be requested */

  const sys_bcmcs_reg_setup_e_type *flow_reg_setup_array_ptr
    /**< whether non-required registration should be allowed for each flow */

);

boolean cm_bcmcs_cmd_registration_request(

  cm_bcmcs_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type               client_id,
    /**< originating client */

  uint8                           num_of_flows,
    /**< number of entries in the array below */

  const sys_bcmcs_flow_addr_s_type *flow_ids_array_ptr
    /**< array of IP:port number addresses for which flows should be registered */
);

boolean cm_bcmcs_cmd_registration_handoff(

  cm_bcmcs_cmd_cb_f_type          cmd_cb_func,
    /**< client callback function */

  void                           *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type               client_id,
    /**< originating client */

  uint8                           num_of_flows,
    /**< number of entries in the array below */

  const sys_bcmcs_flow_addr_s_type *flow_ids_array_ptr
    /**< array of IP:port number addresses for which flows should be registered */
);

/*===========================================================================
FUNCTION cm_mbms_cmd_flow_deact_request

DESCRIPTION
  This command is used to deact MBMS data flow requests with
  lower layers.

  
DEPENDENCIES
  None

RETURN VALUE

  TRUE
  Command was queued succesfully to CM

  FALSE
  No CM buffer available to queue the command

SIDE EFFECTS
  None
                     !!!!!!!!!!!!!!!METACOMMENTS !!!!!!!!!!!!!!!!!!!!!!!!
===========================================================================*/
boolean cm_mbms_cmd_flow_deact_request(

  cm_bcmcs_cmd_cb_f_type          cmd_cb_func,
    /* client callback function */

  void                           *data_block_ptr,
    /* pointer to client callback data block */

  cm_client_id_type               client_id,
    /* originating client */

  uint8                           num_of_flows,
    /* number of entries in the array below */

  const sys_bcmcs_flow_addr_s_type *flow_ids_array_ptr
    /* array of IP:port number addresses for which flows should be requested */

);

/**--------------------------------------------------------------------------
** Enums
** --------------------------------------------------------------------------
*/
/* Enumeration of MBMS commands that clients are able to send to CM.
*/
typedef enum cm_mbms_cmd_e {

  CM_MBMS_CMD_NONE = -1,
    /* FOR INTERNAL USE OF CM ONLY! */

  CM_MBMS_CMD_GENERIC,
    /* Generic MBMS command */


  CM_MBMS_CMD_MAX
    /* FOR INTERNAL USE OF CM ONLY! */

  #ifdef FEATURE_RPC
  , CM_MBMS_CMD_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_mbms_cmd_e_type;

/* Enumeration for MBMS command errors to be sent to clients when
** command errors are detected by CM.
** Clients should check for CM_API_MBMS before using this enum
*/
typedef enum cm_mbms_cmd_err_e {

  CM_MBMS_CMD_ERR_NONE=-1,
    /* FOR INTERNAL USE OF CM ONLY! */

  /* 0 */
  CM_MBMS_CMD_ERR_NOERR,
    /* No errors found */

  CM_MBMS_CMD_ERR_INVALID_COMMAND,
    /* Command requested by client in mbms_generic_cmd is invalid */

  CM_MBMS_CMD_ERR_NO_BUF_L,
    /* No available CM command buffers to queue the command */

  CM_MBMS_CMD_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /* The function is unavailable due to FEATURE_MODEM_MBMS being undefined */

  CM_MBMS_CMD_ERR_MBMS_SRV_UNAVAILABLE,
    /* MBMS service unavailable */

  /* 5 */ 
  CM_MBMS_CMD_ERR_OTHER,
    /* Error other than any of the above */

  CM_MBMS_CMD_ERR_MAX
    /* FOR INTERNAL USE OF CM ONLY! */


} cm_mbms_cmd_err_e_type;

/* Enumeration of MBMS events.
** Clients are able to register with CM to be notified of any subsets
** of these events.
** Clients should check for CM_API_MBMS before using this enum
*/
typedef enum cm_mbms_event_e {

  CM_MBMS_EVENT_NONE=-1,
    /* FOR INTERNAL USE OF CM ONLY! */

  /* 0 */
  CM_MBMS_EVENT_GENERIC_CMD,
    /* CM_MBMS_EVENT_GENERIC_CMD will be sent to registered clients
    ** whenever a MBMS command is issued to CM
    */

  CM_MBMS_EVENT_GENERIC_RPT,
    /* CM_MBMS_EVENT_GENERIC_RPT will be sent to registered clients
    ** whenever lower layers send a MBMS report to CM.
    */


  CM_MBMS_EVENT_MAX
    /* FOR INTERNAL USE OF CM ONLY! */


  #ifdef FEATURE_RPC
  , CM_MBMS_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_mbms_event_e_type;

/**--------------------------------------------------------------------------
** Datatypes
** --------------------------------------------------------------------------
*/

/* Struct to hold MBMS commands sent to the lower layers
*/
typedef struct cm_mbms_generic_cmd_s
{
   /* MBMS command being sent by the client 
   */
   sys_gw_mbms_req_e_type                          cmd_type;
   union {
     sys_gw_mbms_activate_req_s_type               activate_req;
     sys_gw_mbms_deactivate_req_s_type             deactivate_req;
     sys_gw_mbms_session_complete_ind_s_type       session_complete_ind;
     sys_gw_mbms_abort_req_s_type                  abort_req;
     sys_gw_mbms_suspend_req_s_type                suspend_req;
     sys_gw_mbms_resume_req_s_type                 resume_req;
     sys_gw_mbms_avail_srv_list_req_s_type         avail_srv_list_req;
     sys_gw_mbms_capability_req_s_type             capability_req;
     sys_gw_mbms_set_attr_req_s_type               set_attr;                    
    
   }cmd;   
} cm_mbms_generic_cmd_s_type ;

/* Struct to hold MBMS report parameters sent by lower layers
*/
typedef struct cm_mbms_generic_rpt_s
{
  /* MBMS report type */
  sys_gw_mbms_resp_e_type   rpt_type;
  union{
    sys_gw_mbms_resp_activate_cnf_s_type            activate_cnf;
    sys_gw_mbms_resp_deactivate_cnf_s_type          deactivate_cnf;
    sys_gw_mbms_resp_service_ind_s_type             service_ind;
    sys_gw_mbms_resp_capability_ind_s_type          capability_ind;
    sys_gw_mbms_resp_context_activated_ind_s_type   context_activated_ind;
    sys_gw_mbms_resp_context_deactivated_ind_s_type context_deactivated_ind;
    sys_gw_mbms_resp_abort_cnf_s_type               abort_cnf;
    sys_gw_mbms_resp_suspend_cnf_s_type             suspend_cnf;
    sys_gw_mbms_resp_resume_cnf_s_type              resume_cnf;
    sys_gw_mbms_resp_avail_srv_list_cnf_s_type      avail_srv_list_cnf;
    sys_gw_mbms_resp_ll_ready_ind_s_type            ll_ready_ind;
    sys_gw_mbms_resp_set_attr_s_type                set_attr;                    

  }rpt;
} cm_mbms_generic_rpt_s_type;

typedef struct cm_mbms_info_s {

  cm_mbms_generic_rpt_s_type     mbms_generic_rpt;
    /* MBMS generic report structure */

    cm_mbms_generic_cmd_s_type     mbms_generic_cmd;
    /* MBMS generic command structure */

    cm_client_id_type               requesting_client_id;
    /* Requesting client */

} cm_mbms_info_s_type;

/**--------------------------------------------------------------------------
** Macros
** ------------------------------------------------------------------------*/

/* Type for  MBMS command callback functions 
**
** A client that wants to be notified of the result of a MBMS command
** needs to supply a pointer to a function of this type as the first
** parameter to a MBMS command function.
**
** NOTE! Client's provided callback functions must be reentrant since they
** might be called from client, as well as, CM context simultaneously.
** Clients should check for CM_API_MBMS before using this function
*/

typedef void (cm_mbms_cmd_cb_f_type) (

  void                      *data_block_ptr,
    /* Pointer to client provided data block.
    **
    ** NOTE! Depending on the client implementation of this function
    ** the data block pointed by this pointer might be accessed from
    ** client, as well as, CM context simultaneously */

  cm_mbms_cmd_e_type        mbms_cmd,
    /* Indicate which MBMS request is this error status for */

  cm_mbms_cmd_err_e_type     mbms_cmd_err
    /* Call command error code, indicating whether command
    ** is rejected and the reason */

);

/*===========================================================================

FUNCTION cm_mbms_cmd_generic

DESCRIPTION
  API to be used by MBMS Apps to send commands to MBMS Service Manager
  Clients should fill in the appropriate MBMS request type and also
  provide the corresponding parameters in the mbms_generic_req struct.
  Clients should check for CM_API_MBMS before using this function

DEPENDENCIES
  cm_init_before_task_start() must have already been called.


RETURN VALUE
  TRUE   - Cmd has been queued to CM
  FALSE  - Cmd did not get queued to CM

SIDE EFFECTS
  None

===========================================================================*/
boolean cm_mbms_cmd_generic (

  cm_mbms_cmd_cb_f_type                cmd_cb_func,
    /* client callback function */

  void                                 *data_block_ptr,
    /* pointer to client callback data block */

  const cm_client_id_type              client_id,
    /* originating client */

  const cm_mbms_generic_cmd_s_type    *mbms_generic_cmd
    /* Structure to hold MBMS commands and their parameters */
);

/* Anonymous client ID to be used by clients that are not interested
** in being notified of CM events and therefore do not allocate a
** an object of type cm_client_s_type in their own program space.
*/
#define CM_CLIENT_ID_ANONYMOUS  (cm_client_id_type) (-1)

/*
** Clients are pre-defined. Also, floating types are provided for clients that
** use and release CM as needed.
*/

typedef enum cm_client_type_e {

  CM_CLIENT_TYPE_NONE = -1,
    /**< @internal */

  /* 0 */
  CM_CLIENT_TYPE_UI,
    /**< Reserved for UI running on the same processor  */

  CM_CLIENT_TYPE_SMS,
    /**< Reserved for SMS running on the same processor  */

  CM_CLIENT_TYPE_DS,
    /**< Reserved for DATA SERVICES running on the same processor  */

  CM_CLIENT_TYPE_PD,
    /**< Reserved for position determination client on the same uP */

  /* 4 */
  CM_CLIENT_TYPE_ATCOP,
    /**< Reserved for DS ATCOP client on the same procesor */

  CM_CLIENT_TYPE_CAT_APP,
    /**< Reserved for USAT/CAT APP client on the same procesor */

  CM_CLIENT_TYPE_GSTK,
    /**< Reserved for GSTK client on the same procesor */

  CM_CLIENT_TYPE_FLOATING1,
    /**< Floating client 1 running on same/remote processor. */

  /* 8 */
  CM_CLIENT_TYPE_FLOATING2,
    /**< Floating client 2 running on same/remote processor. */

  CM_CLIENT_TYPE_FLOATING3,
    /**< Floating client 3 running on same/remote processor. */

  CM_CLIENT_TYPE_FLOATING4,
    /**< Floating client 4 running on same/remote processor. */

  CM_CLIENT_TYPE_DIAG,
    /**< Client used for diagnostic logging running on the same processor. */

  /* 12 */
  CM_CLIENT_TYPE_BREW,
    /**< Reserved for ICM */

  CM_CLIENT_TYPE_BLUETOOTH,
    /**< Reserved for bluetooth application */

  CM_CLIENT_TYPE_HDR_AN,
    /**< Reserved for HDR AN Authentication client on the same procesor */

  CM_CLIENT_TYPE_CAMERA,
    /**< Reserved for Camera */

  /* 16 */
  CM_CLIENT_TYPE_CMHM,
    /**< Reserved for Handover Manager */

  CM_CLIENT_TYPE_RM_NETWORK_INTERFACE,
    /**< Reserved for RM Interface Object*/

  CM_CLIENT_TYPE_DS_BCMCS,
    /**< Reserved for DS BCMCS client */

  CM_CLIENT_TYPE_MFLO,
    /**< Reserved for MediaFLO */

  /* 20 */
  CM_CLIENT_TYPE_OEMTELEPHONE,
    /**< Reserved for OEMTelephone */

  /* 21 */
  CM_CLIENT_TYPE_PBM,
    /**< Phone Book Manager, Check for CM_API_EMERGENCY_NUM_LIST before using
    ** this enum
    */

  /* 22 */
  CM_CLIENT_TYPE_END_LEGACY,
    /**< FOR INTERNAL USE OF CM ONLY!
    ** All new client types should be added AFTER this.
    */

  CM_CLIENT_TYPE_GSDI,
  /**< Reserved for GSDI */

  CM_CLIENT_TYPE_BREW_APPS,
  /**< Reserved for GSDI */

  CM_CLIENT_TYPE_OEMNET,
    /**< Reserved for OEMNet */

  CM_CLIENT_TYPE_HOMER,
   /**< Reserved for WLAN homer */

  CM_CLIENT_TYPE_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CLIENT_TYPE_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_client_type_e_type;

/** Enumeration of client API return status
*/
typedef enum cm_client_status_e {

  CM_CLIENT_ERR_NONE=-1,
    /**< @internal */

  /* 0 */
  CM_CLIENT_OK,
    /**< No error, request was completed successfully */

  CM_CLIENT_ERR_CLIENT_ID_PTR,
    /**< Invalid client ID pointer*/

  CM_CLIENT_ERR_CLIENT_ID,
    /**< Invalid client ID */

  CM_CLIENT_ERR_EVENT_REG_TYPE,
    /**< Invalid event registration type */

  /* 4 */
  CM_CLIENT_ERR_FROM_EVENT,
    /**< Invalid from event */

  CM_CLIENT_ERR_TO_EVENT,
    /**< Invalid to event */

  CM_CLIENT_ERR_CLIENT_INIT_FAIL,
    /**< Unable to initialize the client */

  CM_CLIENT_ERR_FUNCTION_UNAVAILABLE_DUE_TO_UNDEFINED_FEATURE,
    /**< The function is unavailable due to relavent feature being undefined */

  /* 8 */
  CM_CLIENT_ERR_PWR_COLLAPSE_TYPE,
    /**< Invalid power collapse type */

  CM_CLIENT_ERR_PROC_ID,
    /**< Invalid processor id */

  CM_CLIENT_ERR_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CLIENT_ERR_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_client_status_e_type;

/** Enumeration of client event registration type
*/
typedef enum cm_client_event_reg_e {

  CM_CLIENT_EVENT_NONE=-1,
    /**< @internal */

  CM_CLIENT_EVENT_REG,
    /**< event registration */

  CM_CLIENT_EVENT_DEREG,
    /**< event de-registration */

  CM_CLIENT_EVENT_MAX
    /**< @internal */

  #ifdef FEATURE_RPC
  , CM_CLIENT_EVENT_BIG=0x10000000
    /* To force enum to 32 bit for windows NT */
  #endif /* FEATURE_RPC */

} cm_client_event_reg_e_type;

/** Type for call event callback function.
**
** A client that want to be notified of call events needs to register
** with such a function with CM.
*/
typedef void (cm_mm_call_event_f_type) (

  cm_call_event_e_type         call_event,
    /***< Indicate call event */

  const cm_mm_call_info_s_type *call_info_ptr
    /***< A pointer to a call state information structure */

);

/** Type for phone event callback function.
**
** A client that want to be notified of phone events needs to register
** with such a function with CM.
*/
typedef void (cm_ph_event_f_type) (

  cm_ph_event_e_type           ph_event,
    /**< Indicate phone event */

  const cm_ph_info_s_type      *ph_info_ptr
    /**< A pointer to a phone state information structure */

);

/** Type for BCMCS data event callback function.
**
** A client that wants to be notified of BCMCS data events needs to register
** such a function with CM.
*/
typedef void (cm_bcmcs_event_f_type) (

  cm_bcmcs_event_e_type            bcmcs_event,
    /**< Indicate BCMCS data event
    */

  const cm_bcmcs_info_s_type      *bcmcs_info_ptr
    /**< A pointer to a BCMCS data information structure
    */

);

/* Type for MBMS event callback function.
**
** A client that wants to be notified of MBMS data events needs to register
** such a function with CM.
** Clients should check for CM_API_MBMS before using this function
*/
typedef void (cm_mbms_event_f_type) (

  cm_mbms_event_e_type            mbms_event,
    /* Indicate MBMS data event
    */

  const cm_mbms_info_s_type      *mbms_info_ptr
    /* A pointer to a BCMCS data information structure
    */

);

/** Type for serving system event callback function.
**
** A client that want to be notified of serving system events needs to
** register with such a function with CM.
*/
typedef void (cm_mm_ss_event_f_type) (

  cm_ss_event_e_type           ss_event,
    /**< Indicate serving system event */

  const cm_mm_ss_info_s_type   *ss_info_ptr
    /**< A pointer to a serving system information structure */

);

/** Type for inband event callback function.
**
** A client that want to be notified of inband events needs to
** register with such a function with CM.
*/
typedef void (cm_inband_event_f_type) (

  cm_inband_event_e_type           inband_event,
    /**< Indicate inband event */

  const cm_inband_info_s_type      *inband_info_ptr
    /**< A pointer to a inband information structure */

);

/** Type for SMS event callback function.
**
** A client that want to be notified of inband events needs to
** register with such a function with CM.
*/
typedef void (cm_sms_event_f_type) (

  cm_sms_event_e_type           sms_event,
    /**< Indicate sms event */

  const cm_sms_info_s_type      *sms_info_ptr
    /**< A pointer to a sms information structure */

);

/** Type for DBM event callback function.
**
** A client that want to be notified of DBM events needs to
** register with such a function with CM.
*/
typedef void (cm_dbm_event_f_type) (

    cm_dbm_event_e_type           dbm_event,
        /**< Indicate pd event */

    const cm_dbm_info_s_type      *dbm_info_ptr
        /**< A pointer to a pd information structure */

);

/** Type for SUPS event callback function.
**
** A client that want to be notified of SUPS events needs to
** register with such a function with CM.
*/
typedef void (cm_sups_event_f_type) (

  cm_sups_event_e_type                 sups_event,
    /**< Indicate sups event */

  const cm_sups_info_s_type            *sups_info_ptr
    /**< A pointer to a sups information struct */

);

/** Type for call info list callback function.
**
** A client that wants to be called with call information list needs to
** register such a function with CM.
*/
typedef void (cm_call_info_list_f_type) (

  const cm_call_state_info_list_s_type    *cm_call_info_list_ptr
    /**< Pointer to call info list struct */

);

/** Type for call command error callback function.
**
** A client that want to be notified of OTHER clients call command errors
** needs to register with such a function with CM.
*/
typedef void (cm_mm_call_cmd_err_f_type) (

  cm_call_id_type              call_id,
    /**< call ID */

  cm_client_id_type            client_id,
    /**< Indicate which client caused the error */

  cm_call_cmd_e_type           cmd,
    /**< Indicate for which call command this error is reported */

  cm_call_cmd_err_e_type       cmd_err
    /**< Indicate nature of error */

);

/** Type for phone command error callback function.
**
** A client that want to be notified of OTHER clients phone command errors
** needs to register with such a function with CM.
*/
typedef void (cm_ph_cmd_err_f_type) (

  cm_client_id_type       client_id,
    /**< Indicate which client caused the error */

  cm_ph_cmd_e_type        cmd,
    /**< Indicate for which phone command this error is reported */

  cm_ph_cmd_err_e_type    cmd_err
    /**< Indicate nature of error */

);

/** Type for BCMCS data command error callback function.
**
** A client that want to be notified of OTHER clients'
** BCMCS data command errors needs to register
** such a function with CM.
*/
typedef void (cm_bcmcs_cmd_err_f_type) (

  cm_client_id_type          client_id,
    /**< Indicate which client caused the error
    */

  cm_bcmcs_cmd_e_type        cmd,
    /**< Indicate for which BCMCS data command this error is reported
    */

  cm_bcmcs_cmd_err_e_type    cmd_err
    /**< Indicate nature of error
    */

);

/* Type for MBMS data command error callback function.
**
** A client that wants to be notified of OTHER clients'
** MBMS data command errors needs to register
** such a function with CM.
** Clients should check for CM_API_MBMS before using this function
*/
typedef void (cm_mbms_cmd_err_f_type) (

  cm_client_id_type          client_id,
    /* Indicate which client caused the error
    */

  cm_mbms_cmd_e_type        cmd,
    /* Indicate for which MBMS command this error is reported
    */

  cm_mbms_cmd_err_e_type    cmd_err
    /* Indicate nature of error
    */

);

/** Type for serving system command error callback function.
**
** A client that want to be notified of OTHER clients serving system command errors
** needs to register with such a function with CM.
*/
typedef void (cm_ss_cmd_err_f_type) (

  cm_client_id_type       client_id,
    /**< Indicate which client caused the error */

  cm_ss_cmd_e_type        cmd,
    /**< Indicate for which serving system command this error is reported */

  cm_ss_cmd_err_e_type    cmd_err
    /**< Indicate nature of error */

);

/** Type for inband command error callback function.
**
** A client that want to be notified of OTHER clients inband command errors
** needs to register with such a function with CM.
*/
typedef void (cm_mm_inband_cmd_err_f_type) (

  cm_call_id_type             call_id,
    /**< call ID */

  cm_client_id_type           client_id,
    /**< Indicate which client caused the error */

  cm_inband_cmd_e_type        cmd,
    /**< Indicate for which inband command this error is reported */

  cm_inband_cmd_err_e_type    cmd_err
    /**< Indicate nature of error */

);

/** Type for SMS command error callback function.
**
** A client that want to be notified of OTHER clients sms command errors
** needs to register with such a function with CM.
*/
typedef void (cm_sms_cmd_err_f_type) (

  cm_client_id_type           client_id,
    /**< Indicate which client caused the error */

  cm_sms_cmd_e_type           cmd,
    /**< Indicate for which sms command this error is reported */

  cm_sms_cmd_err_e_type       cmd_err
    /**< Indicate nature of error */

);

/** Type for DBM command error callback function.
**
** A client that want to be notified of OTHER clients dbm command errors
** needs to register with such a function with CM.
*/
typedef void (cm_dbm_cmd_err_f_type) (

    cm_client_id_type           client,
        /**< Indicate which client caused the error */

    cm_dbm_cmd_e_type           cmd,
        /**< Indicate for which sms command this error is reported */

    cm_dbm_cmd_err_e_type       cmd_err
        /**< Indicate nature of error */

);

/** Type for SUPS command error callback function.
**
** A client that want to be notified of OTHER clients SUPS command errors
** needs to register with such a function with CM.
*/

typedef void (cm_sups_cmd_err_f_type) (

  cm_client_id_type            client_id,
    /**< Indicate which client caused the error */

  cm_sups_cmd_e_type           cmd,
    /**< Indicate for which sups command this error is reported */

  cm_sups_cmd_err_e_type       cmd_err
    /**< Indicate nature of error */

);

/** Type for NAS command error callback function.
**
** A client that want to be notified of OTHER clients NAS command errors
** needs to register with such a function with CM.
*/

/**===========================================================================

@FUNCTION cm_client_init

@DESCRIPTION
  Initializing a client object.

  This function must be called exactly once on a client object before
  it is being used, in any way, place, or form.

  Note that in order to get notified of CM events a client still needs
  to do the following:
  1. Register its callback functions and specific events with each functional group
  2. Activate its client object with cm_client_act()

@DEPENDENCIES
  none

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern cm_client_status_e_type cm_client_init(

  cm_client_type_e_type           client_type,
    /**< Type of client */
  cm_client_id_type               *client_id_ptr
    /**< Client ID pointer*/

);

/**===========================================================================

@FUNCTION cm_client_release

@DESCRIPTION
  Release a client object.

  This function should be called if a client doesn't need CM anymore.
  This call will release the client object. That object can be reused for
  another client. If the client needs to use CM again, it should call
  cm_client_init function to establish connection.

@DEPENDENCIES
  none

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern cm_client_status_e_type cm_client_release(

  cm_client_id_type               client_id
    /**< Client ID pointer*/

);

/**===========================================================================

@FUNCTION cm_mm_client_call_reg

@DESCRIPTION
  This function allows a client to register the following call-related
  callbacks and events with CM:

   1. Callback function to receive registered call events
   2. Register and de-register call events
   3. Callback function to receive other clients' call-command errors.

   If a client registers a callback function to receive call event
   notification, it also needs to register one or more call events it is
   interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of call events, a client needs to call on this API twice- once for each
   range of call events.

  If a client registers a callback function to receive other clients'
  call-command errors, it will receive notifications on all possible
  call-command errors caused by other clients. A client cannot register to
  receive only a subset of call-command errors. The NULL function pointer can
  also be used for the callback function if a client is not interested in
  receiving that callback. For example, if a client is not interested in
  receiving other clients' call-command errors, it can set
  call_cmd_err_func = NULL. However, if the call_event_func is set to NULL,
  all registered call events are also de-registered and the event_reg_type,
  from_call_event, and to_call_event parameters are ignored.

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_call_reg(

  cm_client_id_type           client_id,
    /**< Requesting client */

  cm_mm_call_event_f_type     *call_event_func,
    /**< Pointer to a callback function to notify the client of call
    ** events */

  cm_client_event_reg_e_type  event_reg_type,
    /**< register or deregister */

  cm_call_event_e_type        from_call_event,
    /**< register from this event (including) */

  cm_call_event_e_type        to_call_event,
    /**< to this event (including) */

  cm_mm_call_cmd_err_f_type   *call_cmd_err_func
    /**< pointer to a callback function to notify the client of call
    ** command errors of OTHER clients */

);

/**===========================================================================

@FUNCTION cm_mm_client_call_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_call_event and to_call_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of call events, a client needs to call on this API twice- once for each
  range of call events. In case of conflicting pwr_collapse_type, the last
  one will be honored


@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_call_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_mm_call_event_f_type      *call_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Normal, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Registration type */

    cm_call_event_e_type          from_call_event,
        /**< register from this event (including) */

    cm_call_event_e_type          to_call_event
        /* to this event (including) */
);

/*===========================================================================

@FUNCTION cm_client_ph_reg

@DESCRIPTION
  This function allows a client to register the following phone-related
  callbacks and events with CM:

   1. Callback function to receive registered phone events
   2. Register and de-register phone events
   3. Callback function to receive other clients' phone-command errors.

   If a client registers a callback function to receive phone event
   notification, it also needs to register one or more phone events it is
   interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of call events, a client needs to call on this API twice- once for each
   range of call events.

  If a client registers a callback function to receive other clients'
  phone-command errors, it will receive notifications on all possible
  phone-command errors caused by other clients. A client cannot register to
  receive only a subset of phone-command errors. The NULL function pointer can
  also be used for the callback function if a client is not interested in
  receiving that callback. For example, if a client is not interested in
  receiving other clients' phone-command errors, it can set
  ph_cmd_err_func = NULL. However, if the ph_event_func is set to NULL,
  all registered phone events are also de-registered and the event_reg_type,
  from_ph_event, and to_ph_event parameters are ignored.

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_client_ph_reg(

  cm_client_id_type               client_id,
    /**< Requesting client */

  cm_ph_event_f_type             *ph_event_func,
    /**< Pointer to a callback function to notify the client of phone
    ** events */

  cm_client_event_reg_e_type      event_reg_type,
    /**< register or deregister */

  cm_ph_event_e_type              from_ph_event,
    /**< register from this event (including) */

  cm_ph_event_e_type              to_ph_event,
    /**< to this event (including) */

  cm_ph_cmd_err_f_type           *ph_cmd_err_func
    /**< pointer to a callback function to notify the client of phone
    ** command errors of OTHER clients */

);

/**===========================================================================

@FUNCTION cm_mm_client_ph_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_ph_event and to_ph_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of ph events, a client needs to call on this API twice- once for each
  range of ph events. In case of conflicting pwr_collapse_type, the last
  one will be honored


@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_ph_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_ph_event_f_type           *ph_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Normal, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Registration type */

    cm_ph_event_e_type            from_ph_event,
        /**< register from this event (including) */

    cm_ph_event_e_type            to_ph_event
        /* to this event (including) */
);

/**===========================================================================

@FUNCTION cm_mm_client_ss_reg

@DESCRIPTION
  This function allows a client to register the following serving system-related
  callbacks and events with CM:

   1. Callback function to receive registered serving system events
   2. Register and de-register serving system events
   3. Callback function to receive other clients' serving system-command errors.

   If a client registers a callback function to receive serving system event
   notification, it also needs to register one or more serving system events it is
   interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of call events, a client needs to call on this API twice- once for each
   range of call events.

  If a client registers a callback function to receive other clients'
  serving system-command errors, it will receive notifications on all possible
  serving system-command errors caused by other clients. A client cannot register to
  receive only a subset of serving system-command errors. The NULL function pointer can
  also be used for the callback function if a client is not interested in
  receiving that callback. For example, if a client is not interested in
  receiving other clients' serving system-command errors, it can set
  ss_cmd_err_func = NULL. However, if the ss_event_func is set to NULL,
  all registered serving system events are also de-registered and the event_reg_type,
  from_ss_event, and to_ss_event parameters are ignored.

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_ss_reg(

  cm_client_id_type               client_id,
    /**< Requesting client */

  cm_mm_ss_event_f_type          *ss_event_func,
    /**< Pointer to a callback function to notify the client of serving system
    ** events */

  cm_client_event_reg_e_type      event_reg_type,
    /**< register or deregister */

  cm_ss_event_e_type              from_ss_event,
    /**< register from this event (including) */

  cm_ss_event_e_type              to_ss_event,
    /**< to this event (including) */

  cm_ss_cmd_err_f_type           *ss_cmd_err_func
    /**< pointer to a callback function to notify the client of serving system
    ** command errors of OTHER clients */

);

/**===========================================================================

@FUNCTION cm_mm_client_ss_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_ss_event and to_ss_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of ss events, a client needs to call on this API twice- once for each
  range of ph events. In case of conflicting pwr_collapse_type, the last
  one will be honored


@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_ss_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_mm_ss_event_f_type        *ss_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Normal, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Registration type */

    cm_ss_event_e_type            from_ss_event,
        /**< register from this event (including) */

    cm_ss_event_e_type            to_ss_event
        /* to this event (including) */
);

/**===========================================================================

@FUNCTION cm_client_inband_reg

@DESCRIPTION
  This function allows a client to register the following inband-related
  callbacks and events with CM:

   1. Callback function to receive registered inband events
   2. Register and de-register inband events
   3. Callback function to receive other clients' inband-command errors.

   If a client registers a callback function to receive inband event
   notification, it also needs to register one or more inband events it is
   interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of inband events, a client needs to call on this API twice- once for each
   range of inband events.

  If a client registers a callback function to receive other clients'
  inband-command errors, it will receive notifications on all possible
  inband-command errors caused by other clients. A client cannot register to
  receive only a subset of inband-command errors. The NULL function pointer can
  also be used for the callback function if a client is not interested in
  receiving that callback. For example, if a client is not interested in
  receiving other clients' inband-command errors, it can set
  inband_cmd_err_func = NULL. However, if the inband_event_func is set to NULL,
  all registered inband events are also de-registered and the event_reg_type,
  from_inbnad_event, and to_inband_event parameters are ignored.

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_inband_reg(

  cm_client_id_type               client_id,
    /**< Requesting client */

  cm_inband_event_f_type          *inband_event_func,
    /**< Pointer to a callback function to notify the client of inband
    ** events */

  cm_client_event_reg_e_type      event_reg_type,
    /**< register or deregister */

  cm_inband_event_e_type          from_inband_event,
    /**< register from this event (including) */

  cm_inband_event_e_type          to_inband_event,
    /**< to this event (including) */

  cm_mm_inband_cmd_err_f_type     *inband_cmd_err_func
    /**< pointer to a callback function to notify the client of inband
    ** command errors of OTHER clients */

);

/**===========================================================================

@FUNCTION cm_mm_client_inband_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_inband_event and to_inband_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of inband events, a client needs to call on this API twice- once for each
  range of ph events. In case of conflicting pwr_collapse_type, the last
  one will be honored


@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_inband_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_inband_event_f_type       *inband_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Normal, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Registration type */

    cm_inband_event_e_type        from_inband_event,
        /**< register from this event (including) */

    cm_inband_event_e_type        to_inband_event
        /* to this event (including) */
);

/**===========================================================================

@FUNCTION cm_client_sms_reg

@DESCRIPTION
  This function allows a client to register the following sms-related
  callbacks and events with CM:

   1. Callback function to receive registered sms events
   2. Register and de-register sms events
   3. Callback function to receive other clients' sms-command errors.

   If a client registers a callback function to receive inband event
   notification, it also needs to register one or more inband events it is
   interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of sms events, a client needs to call on this API twice- once for each
   range of sms events.

  If a client registers a callback function to receive other clients'
  sms-command errors, it will receive notifications on all possible
  sms-command errors caused by other clients. A client cannot register to
  receive only a subset of sms-command errors. The NULL function pointer can
  also be used for the callback function if a client is not interested in
  receiving that callback. For example, if a client is not interested in
  receiving other clients' sms-command errors, it can set
  sms_cmd_err_func = NULL. However, if the sms_event_func is set to NULL,
  all registered sms events are also de-registered and the event_reg_type,
  from_sms_event, and to_sms_event parameters are ignored.

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().
  FEATURE_CDSMS must be defined.

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_client_sms_reg(

  cm_client_id_type               client_id,
    /**< Requesting client */

  cm_sms_event_f_type            *sms_event_func,
    /**< Pointer to a callback function to notify the client of sms
    ** events */

  cm_client_event_reg_e_type      event_reg_type,
    /**< register or deregister */

  cm_sms_event_e_type             from_sms_event,
    /**< register from this event (including) */

  cm_sms_event_e_type             to_sms_event,
    /**< to this event (including) */

  cm_sms_cmd_err_f_type          *sms_cmd_err_func
    /**< pointer to a callback function to notify the client of sms
    ** command errors of OTHER clients */

);

/**===========================================================================

@FUNCTION cm_mm_client_sms_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_sms_event and to_sms_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of sms events, a client needs to call on this API twice- once for each
  range of ph events. In case of conflicting pwr_collapse_type, the last
  one will be honored


@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_sms_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_sms_event_f_type          *sms_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Normal, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Registration type */

    cm_sms_event_e_type           from_sms_event,
        /**< register from this event (including) */

    cm_sms_event_e_type           to_sms_event
        /* to this event (including) */
);

/**===========================================================================

@FUNCTION cm_mm_client_call_info_list_reg

@DESCRIPTION
  clients call this function to register a callback for
  receiving call information list from CM. CM api has to be
  seperately called to receive the information through callback.

@DEPENDENCIES
  cm_client_init must have been called previously.

@RETURNS
  results of the registration.

@SIDE_EFFECT
  None

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_call_info_list_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_call_info_list_f_type     *call_info_list_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_client_event_reg_e_type    event_reg_type,

    cm_mm_call_cmd_err_f_type    *call_info_list_cmd_err_func
      /**< pointer to a callback function to notify the client of call
      ** command errors of OTHER clients */
);

/**===========================================================================

@FUNCTION cm_client_dbm_event_reg

@DESCRIPTION
  This function is to be used by CM clients interested in registering for
  DBM call manager events.

@DEPENDENCIES
  cm_client_init must have been called previously.

@RETURNS
  results of the registration.

@SIDE_EFFECT
  None

@x
===========================================================================*/

cm_client_status_e_type cm_client_dbm_event_reg(

    cm_client_id_type               client,
        /**< Requesting client */

    cm_dbm_event_f_type             *dbm_event_func,
        /**< Pointer to a callback function to notify the client of dbm
        ** events */

    cm_client_event_reg_e_type      event_reg_type,
        /**< Is this a registration or de-reg */

    cm_dbm_event_e_type             from_dbm_event,
        /**< register from this event (including) */

    cm_dbm_event_e_type             to_dbm_event,
        /**< to this event (including) */


    cm_dbm_cmd_err_f_type           *dbm_cmd_err_func
      /**< pointer to a callback function to notify the client of dbm
      ** command errors of OTHER clients */

);

/**===========================================================================

@FUNCTION cm_client_dbm_class_reg

@DESCRIPTION
  This function is to be used by CM clients interested in registering for
  DBM classes like PD, SDB etc..

@DEPENDENCIES
  cm_client_init must have been called previously.

@RETURNS
  results of the registration.

@SIDE_EFFECT
  None

@x
===========================================================================*/

cm_client_status_e_type cm_client_dbm_class_reg(

    cm_client_id_type               client,
        /**< Requesting client */

    cm_client_event_reg_e_type      event_reg_type,
        /**< Is this a registration or de-reg */

    cm_dbm_class_e_type             from_dbm_class,
        /**< register from this class (including) */

    cm_dbm_class_e_type             to_dbm_class
        /**< to this class (including) */

);

/**===========================================================================

@FUNCTION cm_mm_client_dbm_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_dbm_event and to_dbm_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of dbm events, a client needs to call on this API twice- once for each
  range of dbm events. In case of conflicting pwr_collapse_type, the last
  one will be honored

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_dbm_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_dbm_event_f_type          *dbm_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Full, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Is this a registration or de-reg */

    cm_dbm_event_e_type           from_dbm_event,
        /**< register from this event (including) */

    cm_dbm_event_e_type           to_dbm_event
          /** to this event (including) */
);

/**===========================================================================

@FUNCTION cm_client_sups_reg

@DESCRIPTION
  This function allows a client to register the following serving system-related
  callbacks and events with CM:

   1. Callback function to receive registered sups events
   2. Register and de-register sups events
   3. Callback function to receive other clients' sups command errors.

   If a client registers a callback function to receive sups event
   notification, it also needs to register one or more sups events it is
   interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of sups events, a client needs to call this API twice- once for each
   range of sups events.

  If a client registers a callback function to receive other clients'
  sup command errors, it will receive notifications on all possible
  sups command errors caused by other clients. A client cannot register to
  receive only a subset of sups command errors. The NULL function pointer can
  also be used for the callback function if a client is not interested in
  receiving that callback. For example, if a client is not interested in
  receiving other clients' sups command errors, it can set
  sups_cmd_err_func = NULL. However, if the sups_event_func is set to NULL,
  all registered sups events are also de-registered and the event_reg_type,
  from_event, and to_event parameters are ignored.

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().
  (FEATURE_WCDMA || FEATURE_GSM) must be defined.

@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_client_sups_reg(

  cm_client_id_type             client_id,
    /**< Requesting client */

  cm_sups_event_f_type          *sups_event_func,
    /**< Pointer to a callback function to notify the client of sups
    ** events */

  cm_client_event_reg_e_type    event_reg_type,
    /**< register or deregister */

  cm_sups_event_e_type          from_event,
    /**< register from this event (including) */

  cm_sups_event_e_type          to_event,
    /**< to this event (including) */

  cm_sups_cmd_err_f_type        *sups_cmd_err_func
    /**< pointer to a callback function to notify the client of sups
    ** command errors of OTHER clients */

);

/**===========================================================================

@FUNCTION cm_mm_client_sups_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_sups_event and to_sups_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of sups events, a client needs to call on this API twice- once for each
  range of sups events. In case of conflicting pwr_collapse_type, the last
  one will be honored

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_sups_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_sups_event_f_type         *sups_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Full, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Is this a registration or de-reg */

    cm_sups_event_e_type          from_sups_event,
        /**< register from this event (including) */

    cm_sups_event_e_type          to_sups_event
          /* to this event (including) */
);

/**===========================================================================
@FUNCTION cm_client_bcmcs_reg

@DESCRIPTION

  This function allows a client to register the following BCMCS
  callbacks and events with CM:

   1. Callback function to receive registered BCMCS events
   2. Register for and de-register from receiving BCMCS events
   3. Callback function to receive other clients' BCMCS command errors.

   If a client registers a callback function to receive BCMCS event
   notification, it also needs to register one or more BCMCS events
   it is interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of BCMCS events, a client needs to call on this API twice -
   once for each range of BCMCS events.

   If a client registers a callback function to receive other clients'
   BCMCS command errors, it will receive notifications on all possible
   BCMCS command errors caused by other clients. A client cannot
   register to receive only a subset of BCMCS command errors.
   The NULL function pointer can also be used for the callback function
   if a client is not interested in receiving that callback.
   For example, if a client is not interested in
   receiving other clients' BCMCS command errors, it can set
   bcmcs_cmd_err_func = NULL. However, if the bcmcs_event_func is set to NULL,
   all registered BCMCS events are also de-registered and the
   event_reg_type, from_bcmcs_event, and to_bcmcs_event parameters are ignored.

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().

@RETURNS
  Request status

@SIDE_EFFECT
  None

@x
===========================================================================*/
cm_client_status_e_type cm_client_bcmcs_reg(

    cm_client_id_type              client,
        /**< client id
        */

    cm_bcmcs_event_f_type         *bcmcs_event_func,
        /**< Pointer to a callback function to notify the client
        ** of BCMCS events
        */

    cm_client_event_reg_e_type     event_reg_type,
        /**< Registering or deregistering?
        */

    cm_bcmcs_event_e_type          from_bcmcs_event,
        /**< register from this event (including)
        */

    cm_bcmcs_event_e_type          to_bcmcs_event,
          /**< to this event (including)
          */

    cm_bcmcs_cmd_err_f_type        *bcmcs_cmd_err_func
      /**< pointer to a callback function to notify the client of BCMCS
      ** command errors of OTHER clients
      */
);

/**===========================================================================

@FUNCTION cm_mm_client_bcmcs_pwr_collapse_reg

@DESCRIPTION
  This function allows a client to register/de-register the events it should
  be notified during power collapse. If the client wants to be notified of
  all the events that it is registered for in the normal (power restored
  state), it should use CM_PWR_COLLAPSE_NOTIFY_NORMAL as the
  pwr_collapse_type. If the client wants CM to decide on "important events"
  to wake up the processor from the power collapse state, it should use
  CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_DEFAULT. If the client wants to override
  CM's default, it should use CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM.

  The from_bcmcs_event and to_bcmcs_event, and event_reg_type are used only
  if the pwr_collapse_type is CM_PWR_COLLAPSE_NOTIFY_SELECTIVE_CUSTOM. If
  event_reg_type is CM_CLIENT_EVENT_REG, the event will be notified while in
  power collapse. If the event_reg_type is CM_CLIENT_EVENT_DEREG, the event
  will not be reported while in power collapse.

  This API has a cumulative effect for event registration.
  For example, in order to regieter/de-register for two different ranges
  of bcmcs events, a client needs to call on this API twice- once for each
  range of bcmcs events. In case of conflicting pwr_collapse_type, the last
  one will be honored

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().


@RETURNS
  request status

@SIDE_EFFECT
  none

@x
===========================================================================*/
cm_client_status_e_type cm_mm_client_bcmcs_pwr_collapse_reg(

    cm_client_id_type             client,
        /**< client id */

    cm_bcmcs_event_f_type        *bcmcs_event_func,
        /**< Pointer to a callback function to notify the client of call
        ** events */

    cm_processor_e_type           proc_id,
        /**< The processor on which the client is executing */

    cm_pwr_collapse_notify_e_type pwr_collapse_type,
        /**< The power collapse type, None, Full, default, custom */

    cm_client_event_reg_e_type    event_reg_type,
        /**< Is this a registration or de-reg */

    cm_bcmcs_event_e_type         from_bcmcs_event,
        /**< register from this event (including) */

    cm_bcmcs_event_e_type         to_bcmcs_event
        /* to this event (including) */
);

/*===========================================================================
FUNCTION cm_client_mbms_reg

DESCRIPTION

  This function allows a client to register the following MBMS
  callbacks and events with CM:

   1. Callback function to receive registered MBMS events
   2. Register for and de-register from receiving MBMS events
   3. Callback function to receive other clients' MBMS command errors.

   If a client registers a callback function to receive MBMS event
   notification, it also needs to register one or more MBMS events
   it is interested in receiving. This API has a cumulative effect for event
   registration. For example, in order to register for two different ranges
   of BCMCS events, a client needs to call on this API twice -
   once for each range of MBMS events.

   If a client registers a callback function to receive other clients'
   MBMS command errors, it will receive notifications on all possible
   MBMS command errors caused by other clients. A client cannot
   register to receive only a subset of MBMS command errors.
   The NULL function pointer can also be used for the callback function
   if a client is not interested in receiving that callback.
   For example, if a client is not interested in
   receiving other clients' MBMS command errors, it can set
   mbms_cmd_err_func = NULL. However, if the mbms_event_func is set to NULL,
   all registered MBMS events are also de-registered and the
   event_reg_type, from_mbms_event, and to_mbms_event parameters are ignored.

DEPENDENCIES
  Client must have already been initialized with cm_client_init().

RETURN VALUE
  Request status

SIDE EFFECTS
  None

===========================================================================*/
cm_client_status_e_type cm_client_mbms_reg(

    cm_client_id_type              client,
        /* client id
        */
    
    cm_mbms_event_f_type         *mbms_event_func,
        /* Pointer to a callback function to notify the client
        ** of MBMS events
        */
    
    cm_client_event_reg_e_type    event_reg_type,
        /* Registering or deregistering?
        */

    cm_mbms_event_e_type          from_mbms_event,
        /* register from this event (including)
        */

    cm_mbms_event_e_type          to_mbms_event,
          /* to this event (including)
          */

    cm_mbms_cmd_err_f_type        *mbms_cmd_err_func
      /* pointer to a callback function to notify the client of MBMS
      ** command errors of OTHER clients
      */
);

/**===========================================================================

@FUNCTION cm_client_act

@DESCRIPTION
  Activate the client object, so that the client will be notified
  of call manager events (for which it is registered).

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().

@RETURNS
   request status

@SIDE_EFFECT
  Add the client object to the client list.

@x
===========================================================================*/
extern cm_client_status_e_type cm_client_act(

  cm_client_id_type               client_id
    /**< Requesting client */

);

/**===========================================================================

@FUNCTION cm_client_deact

@DESCRIPTION
  Deactivate a client object, so that the client will NOT be notified
  of call manager events (for which it is registered).

@DEPENDENCIES
  Client must have already been initialized with cm_client_init().

@RETURNS
  request status

@SIDE_EFFECT
  Remove the client object from the client list.

@x
===========================================================================*/
extern cm_client_status_e_type cm_client_deact(

  cm_client_id_type               client_id
    /**< Requesting client */

);

/*---------------------------------------------------------------------------
** Defines
**---------------------------------------------------------------------------
*/

#define CM_EXTDISP_MAX_SUBREC_LEN  20
  /* from ANSI T1.610 Annex D */

/* Types for M51 mode change functions.
*/
typedef boolean ( cm_m511_mode_settings_f_type ) (

  sys_jcdma_m511_e_type      new_mode

);

typedef boolean ( cm_m512_mode_settings_f_type ) (

  sys_jcdma_m512_e_type      new_mode

);

typedef boolean ( cm_m513_mode_settings_f_type ) (

  sys_jcdma_m513_e_type      new_mode

);

/**===========================================================================

@FUNCTION cm_change_m511_mode

@DESCRIPTION
  Request DS to change M511 mode via calling appropriate handler function
  in M51 mode object.
  Return TRUE if mode change succeeded and FALSE otherwise.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start().

@RETURNS
  TRUE/FALSE depending on whether mode change suceeded

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_change_m511_mode(sys_jcdma_m511_e_type new_mode);

/**===========================================================================

@FUNCTION cm_change_m512_mode

@DESCRIPTION
  Request DS to change M512 mode via calling appropriate handler function
  in M51 mode object.
  Return TRUE if mode change succeeded and FALSE otherwise.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start().

@RETURNS
  TRUE/FALSE depending on whether mode change suceeded

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_change_m512_mode(sys_jcdma_m512_e_type new_mode);

/**===========================================================================

@FUNCTION cm_change_m513_mode

@DESCRIPTION
  Request DS to change M513 mode via calling appropriate handler function
  in M51 mode object.
  Return TRUE if mode change succeeded and FALSE otherwise.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start().

@RETURNS
  TRUE/FALSE depending on whether mode change suceeded

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_change_m513_mode(sys_jcdma_m513_e_type new_mode);

/**===========================================================================
@FUNCTION cm_m51_mode_reg

@DESCRIPTION
  Register M51 mode change callback functions with CM.
  When cm_change_m511/512/513_mode() functions are called by UI, CM looks at
  M51 mode object and calls appropriate handler that had been registered
  for required mode change.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start().

@RETURNS
  TRUE

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_m51_mode_reg
(

  cm_m511_mode_settings_f_type     *change_m511_mode_func,
      /**< pointer to a DS function that changes M511 mode */

  cm_m512_mode_settings_f_type     *change_m512_mode_func,
      /**< pointer to a DS function that changes M512 mode */

  cm_m513_mode_settings_f_type     *change_m513_mode_func
      /**< pointer to a DS function that changes M513 mode */
);

/**===========================================================================

@FUNCTION cm_is_valid_mode_band_pref

@DESCRIPTION
  Check whether a specified combination of mode and band preference is
  supported by the current target and the PRL that is associated with the
  currently selected NAM.

@DEPENDENCIES
  None

@RETURNS
  TRUE if the specified combination of mode and band preference is supported.
  FALSE otherwise.

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_is_valid_mode_band_pref(

  cm_mode_pref_e_type    mode_pref,
    /**< Mode preference to check */

  cm_band_pref_e_type    band_pref
    /**< Band preference to check */

);

/**===========================================================================

@FUNCTION cm_get_mode_band_capability

@DESCRIPTION
  Request for all the available modes and bands supported by the current 
  target.

@DEPENDENCIES
  None

@RETURNS
  

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern void cm_get_mode_band_capability(

  cm_mode_pref_e_type *    mode_pref,
  /**< Mode preference supported by the current target */  

  cm_band_pref_e_type *    band_pref
  /**< Band preference supported by the current target */


);

/**===========================================================================

@FUNCTION cm_is_valid_mode_pref

@DESCRIPTION
  Check whether a given mode preference is valid.

@DEPENDENCIES
  none

@RETURNS
  TRUE if mode preference is valid, FALSE otherwise.

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_is_valid_mode_pref(

  cm_mode_pref_e_type    mode_pref
    /**< mode preference to check */

);

/**===========================================================================

@FUNCTION cm_is_sys_mode_digital

@DESCRIPTION
  This function determines whether the given system mode is a digital\
  mode.

@DEPENDENCIES
  none

@RETURNS
  TRUE if the system mode is digital, FALSE otherwise.

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_is_sys_mode_digital(

  sys_sys_mode_e_type    sys_mode
    /**< system mode to check */

);

/**===========================================================================

@FUNCTION cm_get_pref_srv_type_for_packet_orig

@DESCRIPTION
  This function returns service type on which the next packet data call is
  likely to be originated on.

@DEPENDENCIES
  none

@RETURNS
  system mode.

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern sys_sys_mode_e_type cm_get_pref_srv_type_for_packet_orig(

  void

);

/**===========================================================================

@FUNCTION CM_GET_CUR_HYBR_STATUS

@DESCRIPTION
  This function get the current  hybrid status

  Applicable for FEATURE_HDR_HYBRID.

@DEPENDENCIES
  Phone object must have already been initialized with
  cmph_init().

@RETURNS
  TRUE- hybrid operation is enabled

@SIDE_EFFECT
  none

@x
===========================================================================*/
boolean cm_get_cur_hybr_status(void);

/**===========================================================================

@FUNCTION cm_num_init

@DESCRIPTION
  Initialize a CM number object.

  This function must be called on a CM number object before it being used,
  in any way, place, or form.

@DEPENDENCIES

@RETURNS
  None

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern void cm_num_init(

  cm_num_s_type *num_ptr
    /**< The number to be initialized */

);

/**===========================================================================

@FUNCTION cm_num_fill

@DESCRIPTION
  Initialize a CM number object and fill it with a number.

@DEPENDENCIES

@RETURNS
  none

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern void cm_num_fill(

    cm_num_s_type          *num_ptr,
        /**< Pointer to a CM number to be initialized */
    const uint8            *num_buf,
        /**< Dialed address buffer.
        **
        ** NOTE! In the case where the digit_mode parameter is set to
        ** CM_DIGIT_MODE_4BIT_DTMF the number buffer may only contain
        ** 0-9, "#", or "*" characters.
        **
        ** In the case where the digit_mode parameter is set to
        ** CM_DIGIT_MODE_8BIT_ASCII the number buffer may contain any
        ** 8-bit ASCII characters */

    uint8                  num_len,
        /**< dialed address length */

    cm_digit_mode_e_type   digit_mode
        /**< digit mode */
);

/**===========================================================================

@FUNCTION cm_get_current_acq_sys_mode

@DESCRIPTION
  This function returns the current system mode that is acquired.

@DEPENDENCIES
  none

@RETURNS
  system mode.

@SIDE_EFFECT
  none

@x
===========================================================================*/
sys_sys_mode_e_type cm_get_current_acq_sys_mode( void );

/**=========================================================================*/

#define cm_flash_type_e_type     cm_call_sups_type_e_type
#define CM_FLASH_TYPE_EMERGENCY  CM_CALL_SUPS_TYPE_EMERGENCY_CALL
#define CM_CALL_TYPE_DATA        CM_CALL_TYPE_PS_DATA
#define CM_CALL_TYPE_PKT_DATA    CM_CALL_TYPE_PS_DATA

/**=========================================================================*/

#if ((defined(FEATURE_HDR_HYBRID) && defined(FEATURE_GPSONE)) || \
      defined(FEATURE_MM_SUPERSET))
/**===========================================================================

@FUNCTION cm_pd_cmd_fix_start

@DESCRIPTION
  Send a start fix command to CM. Places a request on the CM queue.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_pd_cmd_fix_start(

    cm_pd_cmd_cb_f_type   cmd_cb_func,
        /**< client callback function */

    void                  *data_block_ptr,
        /**< pointer to client callback data block */

    cm_client_id_type     client
        /**< requesting client ID */

);

/**===========================================================================

@FUNCTION cm_pd_cmd_fix_end

@DESCRIPTION
  Send a end fix command to CM. Places a request on the CM queue.

@DEPENDENCIES
  CM must have already been initialized with
  cm_init_before_task_start() and cm_init_after_task_start()

@RETURNS
  TRUE - request sent, FALSE - No buffer to send request

@SIDE_EFFECT
  none

@x
===========================================================================*/
extern boolean cm_pd_cmd_fix_end(

    cm_pd_cmd_cb_f_type   cmd_cb_func,
        /**< client callback function */

    void                  *data_block_ptr,
        /**< pointer to client callback data block */

    cm_client_id_type     client
        /**< requesting client ID */

    );
#endif /* FEATURE_HDR_HYBRID && FEATURE_GPSONE */

/**===========================================================================

@FUNCTION cm_init_wlan_pref

@DESCRIPTION
  Initialize WLAN preferences.

@DEPENDENCIES
  Clients check CM_API_WLAN for WLAN support.
  cm_num_init()

@RETURNS
  none

@SIDE_EFFECT
  none

@x
===========================================================================*/
void cm_wlan_pref_init(

    cm_wlan_pref_s_type  *wlan_pref
        /**< Pointer to a WLAN preference structure */
);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_recall_rsp

@DESCRIPTION
  This function carries response from client for a recall indication from
  network.

@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  ((FEATURE_WCDMA || FEATURE_GSM) && FEATURE_CCBS) must be defined.

@RETURNS
  None

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern boolean cm_mm_call_cmd_recall_rsp (

  cm_call_cmd_cb_f_type         cmd_cb_func,
    /**< client callback function */

  void                          *data_block_ptr,
    /**< pointer to client callback data block */

  cm_call_id_type               call_id,
    /**< call ID of the call */

  cm_client_id_type             client_id,
    /**< commanding client's id */

  cm_ccbs_recall_rsp_e_type     ccbs_recall_rsp
    /**< client response to recall indication */
);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_modify_req

@DESCRIPTION
  Api used to request in-call (connected state) modification of call type.
  Call needs to be connected for this request to be processed.


@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  ((FEATURE_WCDMA || FEATURE_GSM) && CM_API_VT_FALLBACK_TO_VOICE) must be
  defined.

@RETURNS
  TRUE   - Cmd has been queued to CM
  FALSE  - Cmd did not get queued to CM

@SIDE_EFFECT
  None

@x
===========================================================================*/
boolean cm_mm_call_cmd_modify_req (

  cm_call_cmd_cb_f_type         cmd_cb_func,
    /**< client callback function */

  void                          *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type             client_id,
    /**< commanding client's id */

  cm_call_id_type               call_id,
    /**< call ID of the call */

  cm_call_type_e_type           new_call_type_req
    /**< New call type requested for call modification */
);

/**===========================================================================

@FUNCTION cm_mm_call_cmd_modify_res

@DESCRIPTION
  Response to network initiated in-call modification request.
  Call needs to be connected for this request to be processed.


@DEPENDENCIES
  cm_init_before_task_start() must have already been called.
  ((FEATURE_WCDMA || FEATURE_GSM) && CM_API_VT_FALLBACK_TO_VOICE) must be
  defined.

@RETURNS
  TRUE   - Cmd got queued to CM
  FALSE  - Cmd did not get queued to CM

@SIDE_EFFECT
  None

@x
===========================================================================*/
boolean cm_mm_call_cmd_modify_res (

  cm_call_cmd_cb_f_type         cmd_cb_func,
    /**< client callback function */

  void                          *data_block_ptr,
    /**< pointer to client callback data block */

  cm_client_id_type             client_id,
    /**< commanding client's id */

  cm_call_id_type               call_id,
    /**< call ID of the call */

  boolean                       gw_cs_modify_res,
    /**< Client response to modification request
    ** TRUE   - Modification is accepted by client
    ** FALSE  - Modification gets rejected by client
    */

  ie_cm_cc_cause_s_type         *cc_cause_ptr
    /**< Specific cause value when gw_cs_modify_res is FALSE
    ** Ignored when gw_cs_modify_res is TRUE.
    */

);

/**===========================================================================

@FUNCTION cm_get_user_data

@DESCRIPTION
  Call back client uses to get details regarding user data.

@DEPENDENCIES
  Call object must have already been initialized with
  cmcall_init().

@RETURN VALUE
  none

@SIDE EFFECTS
  none

===========================================================================*/
extern void cm_get_user_data
(
  const cm_mm_call_info_s_type      *call_info_ptr,
    /**< pointer to call info pointer sent to the clients */

  cm_call_event_user_data_s_type    *call_event_user_data
    /**< pointer to a client before for user data details */
);

/**===========================================================================

@FUNCTION cm_ph_net_list_copy

@DESCRIPTION
  This function copies networks lists from PH event info to the client when
  requested bv client.

@DEPENDENCIES
  None

@RETURNS

@SIDE_EFFECT
  None

@x
===========================================================================*/
extern void cm_ph_net_list_copy
(
  cm_ph_net_lists_info_s_type   *info_ptr
);

#endif /* CM_H */

/** @}
*  endgroup Utilities Functions
*/

#endif /* ! CM_H_trimmed */
